      CIVL: The Concurrency Intermediate Verification Language
                               v1.22

------------------------------ Overview -------------------------------

CIVL is a framework encompassing... 

 * a programming language, CIVL-C, which adds to C a number of
   concurrency primitives, as well as the ability to define
   functions in any scope.  Together, these features make for
   a very expressive concurrent language that can faithfully
   represent programs using various APIs and parallel languages,
   such as MPI, OpenMP, Pthread, CUDA, and Chapel. CIVL-C also 
   provides a number of primitives supporting verification.
 * a model checker which uses symbolic execution to verify a
   number of safety properties of CIVL-C programs.   The model
   checker can also be used to verify that two CIVL-C programs
   are functionally equivalent.
 * a number of translators from various commonly-used languages
   and APIs to CIVL-C. (This part is still a work in progress.)

CIVL is developed by the Verified Software Laboratory at the
University of Delaware Department of Computer Science.
For more information, visit http://vsl.cis.udel.edu/civl

Active Developers:
Stephen F. Siegel
Wenhao Wu
Alexander Wilton

Inactive Developers:
John Edenhofner
Andre Marianiello
Michael Rogers
Timothy K. Zirkel
Manchun Zheng
Yihao Yan
Matthew B. Dwyer
Mitchell Gerrard
Ziqing Luo

------------------------------- License -------------------------------

CIVL is open source software distributed under the GNU
General Public License.  However, the libraries used by CIVL
(and incorporated into the complete distribution) use various
licenses.  See directory licenses for the license of each component.

-------------------------- Updates from v1.21 -------------------------

-- 1. Upgraded to Java 17
-- 2. Overhauled repository structure by moving ABC, SARL, and GMC
      repositories into this one.
-- 3. Core language changes
     3.1 Only the first statement in an $atomic block is allowed to block.
     3.2 $yield can be used to release the lock of the atomic block
     3.3 Removed $atom
-- 4. Total overhaul to OpenMP transformations. Now includes a robust data
      race detection feature as described in CAV 2023 paper 'Model Checking
      Race-freedom When “Sequential Consistency for Data-race-free Programs”
      is Guaranteed'
-- 5. A large number of bug fixes and small improvements.

-------------------------- Updates from v1.20 -------------------------
-- 1. refine the Fortran extension for paper submitted to TACAS 2022
     1.1 Complete Fortran Array Descriptor for tracking changes made on 
         index ranges by array section and reshape operations. 
         Any declared array type is transformed into a Fortran array 
         descriptor by Fortran to CIVL-C AST transformer.
     1.2 Introduce four basic CIVL verification primitives Fortran bindings
       1.2.1 Type qualifiers:
         - !$CVL $input:  indicates that all variables declared immediately
                          in the next line are symbolic and read-only.
         - !$CVL $output: indicates that all variables declared immediately
                          in the next line are write-only and used for 
                          verifying functional output equivalence.
         A type declaration statement is required to be used immediately 
         after any CIVL type qualifier and variables qualified shall follow
         read/write constraints mentioned above.
         CIVL assumption primitives can be used for limiting the value range 
         of variables qualified by '!$CVL $input'.
         e.g., 
         !$CVL $input
         integer :: n, a(n) 
         !! both 'n' and elements of 'a' are symbolic and read-only
         !$CVL $output
         integer :: sum
         !! sum is write-only and can be used for comparing with another
         !! program, which also has 'sum' with a same type and qualified 
         !! by '!$CVL $output'
         
       1.2.2 Verification
         - !$CVL $assume(logic_expr); 
             Make CIVL only explores paths, whose path conditions shall 
             make 'logic_expr' to be true.
             Set the value range for varialbes qualified by '!$CVL $input'
         - !$CVL $assert(logic_expr); 
             Checks predicates representing specific correctness properties 
             that users expect to verify.
             If any CIVL assertion primitive is evaluated as false, then 
             CIVL shall report an assertion violation. 
     1.3 Add supports for additional Fortran features include:
       1.3.1 'inout' and 'out' attributes declared by 'intent' statement
       1.3.2 compound types with fields having scalar types.
       1.3.3 pointer types to scalar types.
       1.3.4 logic expression evaluation without short-circuits
       1.3.5 line truncation for fixed and free forms 
       1.3.6 other features are shown here:
             https://vsl.cis.udel.edu/trac/civl/wiki/FortranTransformations
     1.4 Add test cases imported from SMACK verification suite 
             https://github.com/soarlab/gandalv/
   2. CUDA Support Improvement
     2.1 Fixed CUDA bug in which CUDA kernel declarations were not being 
         transformed properly
     2.2 Fixed source info bug (completeSources wasn’t being called 
         everywhere that it should)
     2.3 Fixed short circuit bug described in ticket #943
     2.4 Added small optimization to short circuit transformer to allow 
         for finer granularity of its transformation
   3. Other Improvement and Fixed Bugs
     3.1 MPI_Comm types can be compared by equality operator ('==').
     3.2 Java-Doc improvements


-------------------------- Updates from v1.19 -------------------------
-- 1. added new language primitives:
     1.1 $local_start() and $local_end()
       An execution of the statements in between of this pair, including this pair themselves,
       is NOT ONLY uninterruptable BUT ALSO purely local to the view of the verifier.
     1.2 $read_set_push() and $read_set_pop() (the correspondence for write set has already been supported)
       This pair of primitives can be used to turn on/off the capturing of read set during execution.
-- 2. added Fortran support for translating basic Fortran features into CIVL-AST
  (see: https://vsl.cis.udel.edu/trac/civl/wiki/FortranTransformations)
-- 3. added simple Fortran verification examples (edited)

   
------------------------- Binary Installation -------------------------

For most users, this will be the easiest way to install and
use CIVL.  Developers should instead follow the instructions for
"Source Installation" below.

1. Install at least one of the theorem provers below.
The more provers you install, the more precise CIVL analysis will
be.  Note that CIVL only requires the binary executable
version of each prover; you can ignore the libraries, various
API bindings, etc.   You just need to ensure that
each binary executable is in your PATH when you run
"civl config".   The currently supported provers are:
     
   - CVC4,  http://cvc4.cs.nyu.edu/downloads/
   
   - Z3, http://z3.codeplex.com/SourceControl/latest

2. Install a Java 17 SDK if you have not already.  Go to

  http://www.oracle.com/technetwork/java/javase/downloads/

for the latest from Oracle.  On linux, you can instead use
the package manager:

  sudo apt install openjdk-17-jdk

3. Download the CIVL distribution from http://vsl.cis.udel.edu/civl.

4. Unzip and untar the CIVL distribution file if this
does not happen automatically.  This should result in a
folder named CIVL-TAG, where TAG is some version ID string.
This folder contains the following:

 - README   : this file
 - bin      : containing one executable sh script called "civl"
 - lib      : containing civl-TAG.jar
 - doc      : containing the manual and the tutorial of CIVL
 - emacs    : CIVL-C emacs mode and its installation instructions
 - licenses : licenses for CIVL and included libraries
 - examples : some example CIVL programs

5.  You can move the CIVL folder wherever you want.
The JAR file in the lib directory is all you need to run CIVL.
You may also move this jar file wherever you want.   You 
run CIVL by typing a command that begins
"java -jar /path/to/civl-TAG.jar ...".  For convenience
you may instead use the shell script "civl" in bin,
which allows you to replace "java -jar /path/to/civl-TAG.jar"
with just "civl" on the command line.   Simply edit the civl script
to reflect the path to civl-TAG.jar and place the script 
somewhere in your PATH.   Alternatively, you can just define
an alias in your .profile, .bash_profile, or equivalent, such as

alias civl='java -jar /path/to/civl-TAG.jar'

In the following, we will assume that you have defined
a command "civl" in one these ways.

6. Type "civl config".  This should report that it found
the theorem provers you installed (and are in your PATH).
It should create a file called ".sarl" in your home directory
which you can also edit by hand.


------------------------- Source Installation -------------------------

Instructions found here:
https://vsl.cis.udel.edu/trac/civl/wiki/Be%20a%20CIVL%20developer
   

This folder contains conjugate gradient (CG) examples, 2x2 cases and 3x3 cases.
refer: https://repo.anl-external.org/repos/provesa/codes/qmul/hilbert/
Running "make" will execute all 2x2 cases in this folder, 3x3 cases is under developing.

# Nek5000

| **`Short Tests`** | **`Examples`** |
|-----------------|---------------------|
| [![Build](https://travis-ci.org/Nek5000/Nek5000.svg?branch=master)](https://travis-ci.org/Nek5000/Nek5000) | [![Build Status](https://jenkins-ci.cels.anl.gov/buildStatus/icon?job=Nek5000)](https://jenkins-ci.cels.anl.gov/job/Nek5000/) |

Nek5000 is a fast and scalable open source CFD solver.

## Release Notes
Make sure to read the [release notes](https://github.com/Nek5000/Nek5000/blob/master/RELEASE.md) before using the code.

## Getting Started

See [here](http://nek5000.github.io/NekDoc/quickstart.html). 

## Troubleshooting

If you run into problems compiling, installing, or running Nek5000, please send a message to the User's Group [mailing list](https://groups.google.com/forum/#!forum/nek5000).

## Reporting Bugs
Nek5000 is hosted on GitHub and all bugs are reported and tracked through the [Issues](https://github.com/Nek5000/Nek5000/issues) feature on GitHub. However, GitHub Issues should not be used for common troubleshooting purposes. If you are having trouble installing the code or getting your model to run properly, you should first send a message to the User's Group mailing list. If it turns out your issue really is a bug in the code, an issue will then be created on GitHub. If you want to request that a feature be added to the code, you may create an Issue on GitHub.

## Contributing

Our project is hosted on [GitHub](https://github.com/Nek5000). If you are planning a large contribution, we encourage you to discuss the concept here on GitHub and interact with us frequently to ensure that your effort is well-directed.

This example is to demonstrates that two programs writing to the same file
with same data will result in an equivalent file system.
(CIVL assumes that the file system is never shared by two seperated programs
when doing functional equivalence checking.)

Usage: profile tapenade.prof output.csv

This program parse the tapenade.prof file and generate and ouput.csv file
that you can load in any spreadsheet to explore, sort, compute other datas.

There is an example output.csv from a run of ifremer-opa.

Columns meanings: 

name : name of the function
call_count: number of call to this function
snap_count: number of snap before calling this function
taping: summation of all the memory used in the fwd part of a function (only positive for jointly differentiated function)
snapshoting: summation of all the memory consumed in snapshots
fwdtime: summation of all the time spend in the fwd part of a function (same remark than for taping) 
         less the time spend in subcalls.
totaltime: summations of all the time spend in a function less the time spend in subcalls
totalsize: summation of all the memory used in this function
snapshottime: summation of all the time used by snapshots for this function

Units:
	size units are bytes, and times unit are cpu cycles on x86, 
        and not implemented on other platforms.

/home/local/UFAD/jason.hackl/Work/cmt-nek2/nek5/trunk/cmt
Mon Aug 31 15:53:39 EDT 2015
/home/local/UFAD/jason.hackl/Work/cmt-nek2/nek5/trunk/cmt
Thu Sep  3 15:57:05 EDT 2015
/home/hackl/cmt-nek2/nek5/trunk/cmt
Tue Sep  8 17:30:45 EDT 2015
/home/local/UFAD/jason.hackl/Work/cmt-nek2/nek5/trunk/cmt
Wed Sep  9 17:59:58 EDT 2015
/home/local/UFAD/jason.hackl/Work/cmt-nek2/nek5/trunk/cmt
Thu Sep 10 13:08:04 EDT 2015
/home/local/UFAD/jason.hackl/Work/cmt-nek2/nek5/trunk/cmt
Fri Sep 25 15:35:55 EDT 2015

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Addition of mutexinoutset dependence type on c, will ensure that line d@36:9 assignment will depend
!on task at Line 29 and line 32. They might execute in any order but not at the same time.
!There is no data race.

program DRB135_taskdep_mutexinoutset_orig_no_omp50
    use omp_lib
    implicit none

    integer :: a, b, c, d

    !$omp parallel
    !$omp single
        !$omp task depend(out: c)
        c = 1      ! Task T1
        !$omp end task
        !$omp task depend(out: a)
        a = 2      ! Task T2
        !$omp end task
        !$omp task depend(out: b)
        b = 3      ! Task T3
        !$omp end task
        !$omp task depend(in: a) depend(mutexinoutset: c)
        c = c + a  ! Task T4
        !$omp end task
        !$omp task depend(in: b) depend(mutexinoutset: c)
        c = c + b  ! Task T5
        !$omp end task
        !$omp task depend(in: c)
        d = c      ! Task T6
        !$omp end task
    !$omp end single
    !$omp end parallel

    print *, d
end program

! @expect verified

program main
  implicit none
  type Location
    integer x
    integer y
  end type Location

  type(Location) :: p
  p = Location(2,3)
  !print *, p%x == 3
  !$CVL $assert(p%x == 2)
  !$CVL $assert(p%y == 3)
end program main

Program Driver

implicit none

#include "Eos.h"
#include "Eos_map.h"
#include "constants.h"
#include "Flash.h"

  integer, dimension(LOW:HIGH,MDIM) :: range
  integer :: vecLen, n, dataStruct
  real, dimension(EOS_NUM,NZB,NYB,NXB) :: solnData
  real, dimension(EOS_NUM*NZB*NYB*NXB) :: eosData
  
  range(LOW, IAXIS) = GRID_ILO
  range(LOW, JAXIS) = GRID_JLO
  range(LOW, KAXIS) = GRID_KLO
  range(HIGH, IAXIS) = GRID_IHI
  range(HIGH, JAXIS) = GRID_JHI
  range(HIGH, KAXIS) = GRID_KHI
  
  dataStruct = 1
  
  n = 1
  
  do l = 1, EOS_NUM
    do k = GRID_KLO,GRID_KHI
      do j = GRID_JLO,GRID_JHI
        do i = GRID_ILO,GRID_IHI
          solnData(l,k,j,i) = 1.0
          eosData(n) = 0.0
          n = n+1
        end do
      end do
    end do
  end do
  
  call Eos_getData(range,vecLen,solnData,dataStruct,eosData)

End Program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Arrays passed as function parameters. No data race pairs.


module DRB050
    use omp_lib
    implicit none
    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:), allocatable :: o1, c
contains
    subroutine foo1(o1,c,len)
        integer, parameter :: dp = kind(1.0d0)
        real(dp), dimension(:), allocatable :: o1, c
        real(dp) :: volnew_o8
        integer :: len, i

        !$omp parallel do private(volnew_o8)
        do i = 1, len
            volnew_o8 = 0.5*c(i)
            o1(i) = volnew_o8
        end do
        !$omp end parallel do
!        print*,o1(50)
    end subroutine
end module

program DRB050_functionparameter_orig_no
    use omp_lib
    use DRB050
    implicit none

    allocate (o1(100))
    allocate (c(100))

    call foo1(o1, c, 100)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This one has race condition due to true dependence.
!But data races happen at instruction level, not thread level.
!Data race pair: a[i+1]@55:18 vs. a[i]@55:9

program DRB025_simdtruedep_var_yes
    use omp_lib
    implicit none

    integer :: i, len, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    integer, dimension(:), allocatable :: a
    integer, dimension(:), allocatable :: b

    len = 100

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (a(len))
    allocate (b(len))

    do i = 1, len
        a(i) = i
        b(i) = i+1
    end do

    !$omp simd
    do i = 1, len-1
        a(i+1) = a(i) + b(i)
    end do

    do i = 1, len
        write(6,*) 'Values for i and a(i) are:', i, a(i)
    end do

    deallocate(args,a,b)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!For the case of a variable which is referenced within a construct:
!static data member should be shared, unless it is within a threadprivate directive.
!
!Dependence pair: counter@37:5 vs. counter@37:15


module DRB087
    implicit none
    public :: A

    integer, save :: counter
    integer, save :: pcounter

    type A
        integer :: counter = 0
        integer :: pcounter = 0
    end type
    !$omp threadprivate(pcounter)
end module

program DRB087_static_data_member2_orig_yes
    use omp_lib
    use DRB087
    implicit none

    type(A) :: c
    c = A(0,0)

    !$omp parallel
    counter = counter+1
    pcounter = pcounter+1
    !$omp end parallel

    print *,counter,pcounter
end program

      subroutine byte_sync_mpi(mpi_fh)

      include 'mpif.h'
#ifndef NOMPIIO
      call MPI_file_sync(mpi_fh,ierr)
#else
      call exitti('MPI_file_sync unsupported!$',0)
#endif
      return
      end
C--------------------------------------------------------------------------
      subroutine byte_open_mpi(fnamei,mpi_fh,ifro,ierr)

      include 'mpif.h'

      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal

      character fnamei*(*)
      logical ifro
 
      character*132 fname
      character*1   fname1(132)
      equivalence  (fname1,fname)

      l = ltrunc(fnamei,len(fnamei))
      if(l+1.gt.len(fname))
     $ call exitti('invalid string length$',l)
 
      call chcopy(fname1     ,fnamei ,l) 
      call chcopy(fname1(l+1),char(0),1)

      imode = MPI_MODE_WRONLY+MPI_MODE_CREATE
      if(ifro) then
        imode = MPI_MODE_RDONLY 
      endif

#ifndef NOMPIIO
      call MPI_file_open(nekcomm,fname,imode,
     &                   MPI_INFO_NULL,mpi_fh,ierr)
#else
      call exitti('MPI_file_open unsupported!$',0)
#endif

      return
      end
C--------------------------------------------------------------------------
      subroutine byte_read_mpi(buf,icount,iorank,mpi_fh,ierr)

      include 'mpif.h'

      real*4 buf(1)          ! buffer

      iout = icount ! icount is in 4-byte words
#ifndef NOMPIIO
      call MPI_file_read_all(mpi_fh,buf,iout,MPI_REAL,
     &                       MPI_STATUS_IGNORE,ierr)
#else
      call exitti('MPI_file_read_all unsupported!$',0)
#endif

      return
      end
C--------------------------------------------------------------------------
      subroutine byte_write_mpi(buf,icount,iorank,mpi_fh,ierr)

      include 'mpif.h'
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal

      real*4 buf(1)          ! buffer

      iout = icount ! icount is in 4-byte words
      if(iorank.ge.0 .and. nid.ne.iorank) iout = 0
#ifndef NOMPIIO
      call MPI_file_write_all(mpi_fh,buf,iout,MPI_REAL,
     &                        MPI_STATUS_IGNORE,ierr)
#else
      call exitti('MPI_file_write_all unsupported!$',0)
#endif

      return
      end
C--------------------------------------------------------------------------
      subroutine byte_close_mpi(mpi_fh,ierr)

      include 'mpif.h'

#ifndef NOMPIIO
      call MPI_file_close(mpi_fh,ierr)
#else
      call exitti('MPI_file_close unsupported!$',0)
#endif

      return
      end
C--------------------------------------------------------------------------
      subroutine byte_set_view(ioff_in,mpi_fh)

      include 'mpif.h'
      integer*8 ioff_in
    
      if(ioff_in.lt.0) 
     & call exitti('Invalid index in MPI_file_set_view!$',ioff_in)
#ifndef NOMPIIO
      call MPI_file_set_view(mpi_fh,ioff_in,MPI_BYTE,MPI_BYTE,
     &                       'native',MPI_INFO_NULL,ierr)
#endif

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!By utilizing the ordered construct @23 the execution will be sequentially consistent.
!No Data Race Pair.

program DRB155_missingordered_orig_gpu_no
    use omp_lib
    implicit none

    integer :: var(100)
    integer :: i

    do i = 1, 100
        var(i) = 1
    end do

    !$omp target map(tofrom:var) device(0)
    !$omp parallel do ordered
    do i = 2, 100
        !$omp ordered
        var(i) = var(i-1)+1
        !$omp end ordered
    end do
    !$omp end parallel do
    !$omp end target

    do i = 1, 100
        if (var(i)/=i) then
            print*,"Data Race Present"
        end if
    end do

end program

      SUBROUTINE ZWGL (Z,W,NP)
C--------------------------------------------------------------------
C
C     Generate NP Gauss Legendre points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha=0,beta=0).
C     The polynomial degree N=NP-1.
C     Z and W are in single precision, but all the arithmetic
C     operations are done in double precision.
C
C--------------------------------------------------------------------
      REAL Z(1),W(1)
      ALPHA = 0.
      BETA  = 0.
      CALL ZWGJ (Z,W,NP,ALPHA,BETA)
      RETURN
      END
C
      SUBROUTINE ZWGLL (Z,W,NP)
C--------------------------------------------------------------------
C
C     Generate NP Gauss-Lobatto Legendre points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha=0,beta=0).
C     The polynomial degree N=NP-1.
C     Z and W are in single precision, but all the arithmetic
C     operations are done in double precision.
C
C--------------------------------------------------------------------
      REAL Z(1),W(1)
      ALPHA = 0.
      BETA  = 0.
      CALL ZWGLJ (Z,W,NP,ALPHA,BETA)
      RETURN
      END
C
      SUBROUTINE ZWGJ (Z,W,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Generate NP GAUSS JACOBI points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha>-1,beta>-1).
C     The polynomial degree N=NP-1.
C     Single precision version.
C
C--------------------------------------------------------------------
      PARAMETER (NMAX=84)
      PARAMETER (lzd = NMAX)
      REAL*8  ZD(lzd),WD(lzd),ALPHAD,BETAD
      REAL Z(1),W(1),ALPHA,BETA
C
      NPMAX = lzd
      IF (NP.GT.NPMAX) THEN
         WRITE (6,*) 'Too large polynomial degree in ZWGJ'
         WRITE (6,*) 'Maximum polynomial degree is',NMAX
         WRITE (6,*) 'Here NP=',NP
         call exitt
      ENDIF
      ALPHAD = ALPHA
      BETAD  = BETA
      CALL ZWGJD (ZD,WD,NP,ALPHAD,BETAD)
      DO 100 I=1,NP
         Z(I) = ZD(I)
         W(I) = WD(I)
 100  CONTINUE
      RETURN
      END
C
      SUBROUTINE ZWGJD (Z,W,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Generate NP GAUSS JACOBI points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha>-1,beta>-1).
C     The polynomial degree N=NP-1.
C     Double precision version.
C
C--------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  Z(1),W(1),ALPHA,BETA
C
      N     = NP-1
      DN    = ((N))
      ONE   = 1.
      TWO   = 2.
      APB   = ALPHA+BETA
C
      IF (NP.LE.0) THEN
         WRITE (6,*) 'ZWGJD: Minimum number of Gauss points is 1',np
         call exitt
      ENDIF
      IF ((ALPHA.LE.-ONE).OR.(BETA.LE.-ONE)) THEN
         WRITE (6,*) 'ZWGJD: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
C
      IF (NP.EQ.1) THEN
         Z(1) = (BETA-ALPHA)/(APB+TWO)
         W(1) = GAMMAF(ALPHA+ONE)*GAMMAF(BETA+ONE)/GAMMAF(APB+TWO)
     $          * TWO**(APB+ONE)
         RETURN
      ENDIF
C
      CALL JACG (Z,NP,ALPHA,BETA)
C
      NP1   = N+1
      NP2   = N+2
      DNP1  = ((NP1))
      DNP2  = ((NP2))
      FAC1  = DNP1+ALPHA+BETA+ONE
      FAC2  = FAC1+DNP1
      FAC3  = FAC2+ONE
      FNORM = PNORMJ(NP1,ALPHA,BETA)
      RCOEF = (FNORM*FAC2*FAC3)/(TWO*FAC1*DNP2)
      DO 100 I=1,NP
         CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,NP2,ALPHA,BETA,Z(I))
         W(I) = -RCOEF/(P*PDM1)
 100  CONTINUE
      RETURN
      END
C
      SUBROUTINE ZWGLJ (Z,W,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Generate NP GAUSS LOBATTO JACOBI points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha>-1,beta>-1).
C     The polynomial degree N=NP-1.
C     Single precision version.
C
C--------------------------------------------------------------------
      PARAMETER (NMAX=84)
      PARAMETER (lzd = NMAX)
      REAL*8  ZD(lzd),WD(lzd),ALPHAD,BETAD
      REAL Z(1),W(1),ALPHA,BETA
C
      NPMAX = lzd
      IF (NP.GT.NPMAX) THEN
         WRITE (6,*) 'Too large polynomial degree in ZWGLJ'
         WRITE (6,*) 'Maximum polynomial degree is',NMAX
         WRITE (6,*) 'Here NP=',NP
         call exitt
      ENDIF
      ALPHAD = ALPHA
      BETAD  = BETA
      CALL ZWGLJD (ZD,WD,NP,ALPHAD,BETAD)
      DO 100 I=1,NP
         Z(I) = ZD(I)
         W(I) = WD(I)
 100  CONTINUE
      RETURN
      END
C
      SUBROUTINE ZWGLJD (Z,W,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Generate NP GAUSS LOBATTO JACOBI points (Z) and weights (W)
C     associated with Jacobi polynomial P(N)(alpha>-1,beta>-1).
C     The polynomial degree N=NP-1.
C     Double precision version.
C
C--------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  Z(NP),W(NP),ALPHA,BETA
C
      N     = NP-1
      NM1   = N-1
      ONE   = 1.
      TWO   = 2.
C
      IF (NP.LE.1) THEN
       WRITE (6,*) 'ZWGLJD: Minimum number of Gauss-Lobatto points is 2'
       WRITE (6,*) 'ZWGLJD: alpha,beta:',alpha,beta,np
       call exitt
      ENDIF
      IF ((ALPHA.LE.-ONE).OR.(BETA.LE.-ONE)) THEN
         WRITE (6,*) 'ZWGLJD: Alpha and Beta must be greater than -1'
         call exitt
      ENDIF
C
      IF (NM1.GT.0) THEN
         ALPG  = ALPHA+ONE
         BETG  = BETA+ONE
         CALL ZWGJD (Z(2:NP),W(2:NP	),NM1,ALPG,BETG)
      ENDIF
      Z(1)  = -ONE
      Z(NP) =  ONE
      DO 100  I=2,NP-1
         W(I) = W(I)/(ONE-Z(I)**2)
 100  CONTINUE
      CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,N,ALPHA,BETA,Z(1))
      W(1)  = ENDW1 (N,ALPHA,BETA)/(TWO*PD)
      CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,N,ALPHA,BETA,Z(NP))
      W(NP) = ENDW2 (N,ALPHA,BETA)/(TWO*PD)
C
      RETURN
      END
C
      REAL*8  FUNCTION ENDW1 (N,ALPHA,BETA)
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  ALPHA,BETA
      ZERO  = 0.
      ONE   = 1.
      TWO   = 2.
      THREE = 3.
      FOUR  = 4.
      APB   = ALPHA+BETA
      IF (N.EQ.0) THEN
         ENDW1 = ZERO
         RETURN
      ENDIF
      F1   = GAMMAF(ALPHA+TWO)*GAMMAF(BETA+ONE)/GAMMAF(APB+THREE)
      F1   = F1*(APB+TWO)*TWO**(APB+TWO)/TWO
      IF (N.EQ.1) THEN
         ENDW1 = F1
         RETURN
      ENDIF
      FINT1 = GAMMAF(ALPHA+TWO)*GAMMAF(BETA+ONE)/GAMMAF(APB+THREE)
      FINT1 = FINT1*TWO**(APB+TWO)
      FINT2 = GAMMAF(ALPHA+TWO)*GAMMAF(BETA+TWO)/GAMMAF(APB+FOUR)
      FINT2 = FINT2*TWO**(APB+THREE)
      F2    = (-TWO*(BETA+TWO)*FINT1 + (APB+FOUR)*FINT2)
     $        * (APB+THREE)/FOUR
      IF (N.EQ.2) THEN
         ENDW1 = F2
         RETURN
      ENDIF
      DO 100 I=3,N
         DI   = ((I-1))
         ABN  = ALPHA+BETA+DI
         ABNN = ABN+DI
         A1   = -(TWO*(DI+ALPHA)*(DI+BETA))/(ABN*ABNN*(ABNN+ONE))
         A2   =  (TWO*(ALPHA-BETA))/(ABNN*(ABNN+TWO))
         A3   =  (TWO*(ABN+ONE))/((ABNN+TWO)*(ABNN+ONE))
         F3   =  -(A2*F2+A1*F1)/A3
         F1   = F2
         F2   = F3
 100  CONTINUE
      ENDW1  = F3
      RETURN
      END
C
      REAL*8  FUNCTION ENDW2 (N,ALPHA,BETA)
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  ALPHA,BETA
      ZERO  = 0.
      ONE   = 1.
      TWO   = 2.
      THREE = 3.
      FOUR  = 4.
      APB   = ALPHA+BETA
      IF (N.EQ.0) THEN
         ENDW2 = ZERO
         RETURN
      ENDIF
      F1   = GAMMAF(ALPHA+ONE)*GAMMAF(BETA+TWO)/GAMMAF(APB+THREE)
      F1   = F1*(APB+TWO)*TWO**(APB+TWO)/TWO
      IF (N.EQ.1) THEN
         ENDW2 = F1
         RETURN
      ENDIF
      FINT1 = GAMMAF(ALPHA+ONE)*GAMMAF(BETA+TWO)/GAMMAF(APB+THREE)
      FINT1 = FINT1*TWO**(APB+TWO)
      FINT2 = GAMMAF(ALPHA+TWO)*GAMMAF(BETA+TWO)/GAMMAF(APB+FOUR)
      FINT2 = FINT2*TWO**(APB+THREE)
      F2    = (TWO*(ALPHA+TWO)*FINT1 - (APB+FOUR)*FINT2)
     $        * (APB+THREE)/FOUR
      IF (N.EQ.2) THEN
         ENDW2 = F2
         RETURN
      ENDIF
      DO 100 I=3,N
         DI   = ((I-1))
         ABN  = ALPHA+BETA+DI
         ABNN = ABN+DI
         A1   =  -(TWO*(DI+ALPHA)*(DI+BETA))/(ABN*ABNN*(ABNN+ONE))
         A2   =  (TWO*(ALPHA-BETA))/(ABNN*(ABNN+TWO))
         A3   =  (TWO*(ABN+ONE))/((ABNN+TWO)*(ABNN+ONE))
         F3   =  -(A2*F2+A1*F1)/A3
         F1   = F2
         F2   = F3
 100  CONTINUE
      ENDW2  = F3
      RETURN
      END
C
      REAL*8 FUNCTION GAMMAF (X)
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  X
      ZERO = 0.0
      HALF = 0.5
      ONE  = 1.0
      TWO  = 2.0
      FOUR = 4.0
      PI   = FOUR*ATAN(ONE)
      GAMMAF = ONE
      IF (X.EQ.-HALF) GAMMAF = -TWO*SQRT(PI)
      IF (X.EQ. HALF) GAMMAF =  SQRT(PI)
      IF (X.EQ. ONE ) GAMMAF =  ONE
      IF (X.EQ. TWO ) GAMMAF =  ONE
      IF (X.EQ. 1.5  ) GAMMAF =  SQRT(PI)/2.
      IF (X.EQ. 2.5) GAMMAF =  1.5*SQRT(PI)/2.
      IF (X.EQ. 3.5) GAMMAF =  0.5*(2.5*(1.5*SQRT(PI)))
      IF (X.EQ. 3. ) GAMMAF =  2.
      IF (X.EQ. 4. ) GAMMAF = 6.
      IF (X.EQ. 5. ) GAMMAF = 24.
      IF (X.EQ. 6. ) GAMMAF = 120.
      RETURN
      END
C
      REAL*8  FUNCTION PNORMJ (N,ALPHA,BETA)
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  ALPHA,BETA
      ONE   = 1.
      TWO   = 2.
      DN    = ((N))
      CONST = ALPHA+BETA+ONE
      IF (N.LE.1) THEN
         PROD   = GAMMAF(DN+ALPHA)*GAMMAF(DN+BETA)
         PROD   = PROD/(GAMMAF(DN)*GAMMAF(DN+ALPHA+BETA))
         PNORMJ = PROD * TWO**CONST/(TWO*DN+CONST)
         RETURN
      ENDIF
      PROD  = GAMMAF(ALPHA+ONE)*GAMMAF(BETA+ONE)
      PROD  = PROD/(TWO*(ONE+CONST)*GAMMAF(CONST+ONE))
      PROD  = PROD*(ONE+ALPHA)*(TWO+ALPHA)
      PROD  = PROD*(ONE+BETA)*(TWO+BETA)
      DO 100 I=3,N
         DINDX = ((I))
         FRAC  = (DINDX+ALPHA)*(DINDX+BETA)/(DINDX*(DINDX+ALPHA+BETA))
         PROD  = PROD*FRAC
 100  CONTINUE
      PNORMJ = PROD * TWO**CONST/(TWO*DN+CONST)
      RETURN
      END
C
      SUBROUTINE JACG (XJAC,NP,ALPHA,BETA)
C--------------------------------------------------------------------
C
C     Compute NP Gauss points XJAC, which are the zeros of the
C     Jacobi polynomial J(NP) with parameters ALPHA and BETA.
C     ALPHA and BETA determines the specific type of Gauss points.
C     Examples:
C     ALPHA = BETA =  0.0  ->  Legendre points
C     ALPHA = BETA = -0.5  ->  Chebyshev points
C
C--------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      REAL*8  XJAC(1)
      DATA KSTOP /10/
      DATA EPS/1.0e-12/
      N   = NP-1
      one = 1.
      DTH = 4.*ATAN(one)/(2.*((N))+2.)
      DO 40 J=1,NP
         IF (J.EQ.1) THEN
            X = COS((2.*(((J))-1.)+1.)*DTH)
         ELSE
            X1 = COS((2.*(((J))-1.)+1.)*DTH)
            X2 = XLAST
            X  = (X1+X2)/2.
         ENDIF
         DO 30 K=1,KSTOP
            CALL JACOBF (P,PD,PM1,PDM1,PM2,PDM2,NP,ALPHA,BETA,X)
            RECSUM = 0.
            JM = J-1
            DO 29 I=1,JM
               RECSUM = RECSUM+1./(X-XJAC(NP-I+1))
 29         CONTINUE
            DELX = -P/(PD-RECSUM*P)
            X    = X+DELX
            IF (ABS(DELX) .LT. EPS) GOTO 31
 30      CONTINUE
 31      CONTINUE
         XJAC(NP-J+1) = X
         XLAST        = X
 40   CONTINUE
      DO 200 I=1,NP
         XMIN = 2.
         DO 100 J=I,NP
            IF (XJAC(J).LT.XMIN) THEN
               XMIN = XJAC(J)
               JMIN = J
            ENDIF
 100     CONTINUE
         IF (JMIN.NE.I) THEN
            SWAP = XJAC(I)
            XJAC(I) = XJAC(JMIN)
            XJAC(JMIN) = SWAP
         ENDIF
 200  CONTINUE
      RETURN
      END
C
      SUBROUTINE JACOBF (POLY,PDER,POLYM1,PDERM1,POLYM2,PDERM2,
     $                   N,ALP,BET,X)
C--------------------------------------------------------------------
C
C     Computes the Jacobi polynomial (POLY) and its derivative (PDER)
C     of degree N at X.
C
C--------------------------------------------------------------------
      IMPLICIT REAL*8  (A-H,O-Z)
      APB  = ALP+BET
      POLY = 1.
      PDER = 0.
      IF (N .EQ. 0) RETURN
      POLYL = POLY
      PDERL = PDER
      POLY  = (ALP-BET+(APB+2.)*X)/2.
      PDER  = (APB+2.)/2.
      IF (N .EQ. 1) RETURN
      DO 20 K=2,N
         DK = ((K))
         A1 = 2.*DK*(DK+APB)*(2.*DK+APB-2.)
         A2 = (2.*DK+APB-1.)*(ALP**2-BET**2)
         B3 = (2.*DK+APB-2.)
         A3 = B3*(B3+1.)*(B3+2.)
         A4 = 2.*(DK+ALP-1.)*(DK+BET-1.)*(2.*DK+APB)
         POLYN  = ((A2+A3*X)*POLY-A4*POLYL)/A1
         PDERN  = ((A2+A3*X)*PDER-A4*PDERL+A3*POLY)/A1
         PSAVE  = POLYL
         PDSAVE = PDERL
         POLYL  = POLY
         POLY   = POLYN
         PDERL  = PDER
         PDER   = PDERN
 20   CONTINUE
      POLYM1 = POLYL
      PDERM1 = PDERL
      POLYM2 = PSAVE
      PDERM2 = PDSAVE
      RETURN
      END
      

c-----------------------------------------------------------------------
      subroutine gen_fast(df,sr,ss,st,x,y,z)
c
c     Generate fast diagonalization matrices for each element
c
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'SOLN'
      include 'WZ'
c
      parameter(lxx=lx1*lx1)
      real df(lx1*ly1*lz1,1),sr(lxx*2,1),ss(lxx*2,1),st(lxx*2,1)
c
      common /ctmpf/  lr(2*lx1+4),ls(2*lx1+4),lt(2*lx1+4)
     $              , llr(lelt),lls(lelt),llt(lelt)
     $              , lmr(lelt),lms(lelt),lmt(lelt)
     $              , lrr(lelt),lrs(lelt),lrt(lelt)
      real lr ,ls ,lt 
      real llr,lls,llt
      real lmr,lms,lmt
      real lrr,lrs,lrt
c
      integer lbr,rbr,lbs,rbs,lbt,rbt,e
c
      real x(lx1,ly1,lz1,nelv)
      real y(lx1,ly1,lz1,nelv)
      real z(lx1,ly1,lz1,nelv)
      real axwt(lx2)

      ierr = 0

      do e=1,nelv
c
         if (param(44).eq.1) then
           call get_fast_bc(lbr,rbr,lbs,rbs,lbt,rbt,e,2,ierr)
         else
           call get_fast_bc(lbr,rbr,lbs,rbs,lbt,rbt,e,3,ierr)
         endif
c
c        Set up matrices for each element.
c
         if (param(44).eq.1) then
           call set_up_fast_1D_fem( sr(1,e),lr,nr ,lbr,rbr
     $                      ,llr(e),lmr(e),lrr(e),zgm2(1,1),lx2,e)
         else
           call set_up_fast_1D_sem( sr(1,e),lr,nr ,lbr,rbr
     $                      ,llr(e),lmr(e),lrr(e),e)
         endif
         if (ifaxis) then
            xsum = vlsum(wxm2,lx2)
            do i=1,ly2
               yavg = vlsc2(y(1,i,1,e),wxm2,lx2)/xsum
               axwt(i) = yavg
            enddo
            call set_up_fast_1D_fem_ax( ss(1,e),ls,ns ,lbs,rbs
     $                 ,lls(e),lms(e),lrs(e),zgm2(1,2),axwt,ly2,e)
         else
            if (param(44).eq.1) then
               call set_up_fast_1D_fem( ss(1,e),ls,ns ,lbs,rbs
     $                      ,lls(e),lms(e),lrs(e),zgm2(1,2),ly2,e)
            else
               call set_up_fast_1D_sem( ss(1,e),ls,ns ,lbs,rbs
     $                      ,lls(e),lms(e),lrs(e),e)
            endif
         endif
         if (if3d) then
            if (param(44).eq.1) then
               call set_up_fast_1D_fem( st(1,e),lt,nt ,lbt,rbt
     $                      ,llt(e),lmt(e),lrt(e),zgm2(1,3),lz2,e)
            else
               call set_up_fast_1D_sem( st(1,e),lt,nt ,lbt,rbt
     $                      ,llt(e),lmt(e),lrt(e),e)
            endif
         endif
c
c        DIAGNOSTICS
c
c        n12 = min(9,nr)
c        write(6,1) e,'1D lr',llr(e),lmr(e),lrr(e),(lr(k),k=1,n12)
c        write(6,1) e,'1D ls',lls(e),lms(e),lrs(e),(ls(k),k=1,n12)
c        if (if3d) 
c    $   write(6,1) e,'1D lt',llt(e),lmt(e),lrt(e),(lt(k),k=1,n12)
c   1    format(i6,1x,a5,1p12e12.4)
c
c
c        Set up diagonal inverse
c
         if (if3d) then
            eps = 1.e-5 * (vlmax(lr(2),nr-2)
     $                  +  vlmax(ls(2),ns-2) + vlmax(lt(2),nt-2))
            l   = 1
            do k=1,nt
            do j=1,ns
            do i=1,nr
               diag = lr(i) + ls(j) + lt(k)
               if (diag.gt.eps) then
                  df(l,e) = 1.0/diag
               else
c                 write(6,3) e,'Reset Eig in gen fast:',i,j,k,l
c    $                         ,eps,diag,lr(i),ls(j),lt(k)
c   3             format(i6,1x,a21,4i5,1p5e12.4)
                  df(l,e) = 0.0
               endif
               l = l+1
            enddo
            enddo
            enddo
         else
            eps = 1.e-5*(vlmax(lr(2),nr-2) + vlmax(ls(2),ns-2))
            l   = 1
            do j=1,ns
            do i=1,nr
               diag = lr(i) + ls(j)
               if (diag.gt.eps) then
                  df(l,e) = 1.0/diag
               else
c                 write(6,2) e,'Reset Eig in gen fast:',i,j,l
c    $                         ,eps,diag,lr(i),ls(j)
c   2             format(i6,1x,a21,3i5,1p4e12.4)
                  df(l,e) = 0.0
               endif
               l = l+1
            enddo
            enddo
         endif
c
c        Next element ....
c
      enddo

      ierrmx = iglmax(ierr,1)
      if (ierrmx.gt.0) then
         if (ierr.gt.0) write(6,*) nid,ierr,' BC FAIL'
         call exitti('E INVALID BC FOUND in genfast$',ierrmx)
      endif


      return
      end
c-----------------------------------------------------------------------
      subroutine gen_fast_spacing(x,y,z)
c
c     Generate fast diagonalization matrices for each element
c
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'SOLN'
      include 'WZ'
c
      parameter(lxx=lx1*lx1)
c
      common /ctmpf/  lr(2*lx1+4),ls(2*lx1+4),lt(2*lx1+4)
     $              , llr(lelt),lls(lelt),llt(lelt)
     $              , lmr(lelt),lms(lelt),lmt(lelt)
     $              , lrr(lelt),lrs(lelt),lrt(lelt)
      real lr ,ls ,lt 
      real llr,lls,llt
      real lmr,lms,lmt
      real lrr,lrs,lrt
c
      integer lbr,rbr,lbs,rbs,lbt,rbt,e
c
      real x(lx1,ly1,lz1,nelv)
      real y(lx1,ly1,lz1,nelv)
      real z(lx1,ly1,lz1,nelv)
      real axwt(lx2)

      ierr = 0

      if (param(44).eq.1) then
c                                    __ __ __
c        Now, for each element, compute lr,ls,lt between specified planes
c
         n1 = lx2
         n2 = lx2+1
         nz0 = 1
         nzn = 1
         if (if3d) then
            nz0= 0
            nzn=n2
         endif
         eps = 1.e-7
         if (wdsize.eq.8)  eps = 1.e-14
c
c        Find mean spacing between "left-most" planes
         call plane_space2(llr,lls,llt, 0,wxm2,x,y,z,n1,n2,nz0,nzn)
c
c        Find mean spacing between "middle" planes
         call plane_space (lmr,lms,lmt, 1,n1,wxm2,x,y,z,n1,n2,nz0,nzn)
c
c        Find mean spacing between "right-most" planes
         call plane_space2(lrr,lrs,lrt,n2,wxm2,x,y,z,n1,n2,nz0,nzn)
c
      else
         call load_semhat_weighted    !   Fills the SEMHAT arrays
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine plane_space_std(lr,ls,lt,i1,i2,w,x,y,z,nx,nxn,nz0,nzn)
c
c     This routine now replaced by "plane_space()"
c
c     Here, spacing is based on arithmetic mean. 
c     New verision uses harmonic mean.  pff 2/10/07
c
      include 'SIZE'
      include 'INPUT'
c
      real w(1),lr(1),ls(1),lt(1)
      real x(0:nxn,0:nxn,nz0:nzn,1)
      real y(0:nxn,0:nxn,nz0:nzn,1)
      real z(0:nxn,0:nxn,nz0:nzn,1)
      real lr2,ls2,lt2
c                                    __ __ __
c     Now, for each element, compute lr,ls,lt between specified planes
c
      ny = nx
      nz = nx
      j1 = i1
      k1 = i1
      j2 = i2
      k2 = i2
c
      do ie=1,nelv
c
         if (if3d) then
            lr2  = 0.
            wsum = 0.
            do k=1,nz
            do j=1,ny
               weight = w(j)*w(k)
               lr2  = lr2  + ( (x(i2,j,k,ie)-x(i1,j,k,ie))**2
     $                     +   (y(i2,j,k,ie)-y(i1,j,k,ie))**2
     $                     +   (z(i2,j,k,ie)-z(i1,j,k,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            enddo
            lr2     = lr2/wsum
            lr(ie)  = sqrt(lr2)
c
            ls2 = 0.
            wsum = 0.
            do k=1,nz
            do i=1,nx
               weight = w(i)*w(k)
               ls2  = ls2  + ( (x(i,j2,k,ie)-x(i,j1,k,ie))**2
     $                     +   (y(i,j2,k,ie)-y(i,j1,k,ie))**2
     $                     +   (z(i,j2,k,ie)-z(i,j1,k,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            enddo
            ls2     = ls2/wsum
            ls(ie)  = sqrt(ls2)
c
            lt2 = 0.
            wsum = 0.
            do j=1,ny
            do i=1,nx
               weight = w(i)*w(j)
               lt2  = lt2  + ( (x(i,j,k2,ie)-x(i,j,k1,ie))**2
     $                     +   (y(i,j,k2,ie)-y(i,j,k1,ie))**2
     $                     +   (z(i,j,k2,ie)-z(i,j,k1,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            enddo
            lt2     = lt2/wsum
            lt(ie)  = sqrt(lt2)
c
         else
            lr2 = 0.
            wsum = 0.
            do j=1,ny
               weight = w(j)
               lr2  = lr2  + ( (x(i2,j,1,ie)-x(i1,j,1,ie))**2
     $                     +   (y(i2,j,1,ie)-y(i1,j,1,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            lr2     = lr2/wsum
            lr(ie)  = sqrt(lr2)
c
            ls2 = 0.
            wsum = 0.
            do i=1,nx
               weight = w(i)
               ls2  = ls2  + ( (x(i,j2,1,ie)-x(i,j1,1,ie))**2
     $                     +   (y(i,j2,1,ie)-y(i,j1,1,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            ls2     = ls2/wsum
            ls(ie)  = sqrt(ls2)
c           write(6,*) 'lrls',ie,lr(ie),ls(ie)
         endif
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine plane_space(lr,ls,lt,i1,i2,w,x,y,z,nx,nxn,nz0,nzn)
c
c     Here, spacing is based on harmonic mean.  pff 2/10/07
c
c
      include 'SIZE'
      include 'INPUT'
c
      real w(1),lr(1),ls(1),lt(1)
      real x(0:nxn,0:nxn,nz0:nzn,1)
      real y(0:nxn,0:nxn,nz0:nzn,1)
      real z(0:nxn,0:nxn,nz0:nzn,1)
      real lr2,ls2,lt2
c                                    __ __ __
c     Now, for each element, compute lr,ls,lt between specified planes
c
      ny = nx
      nz = nx
      j1 = i1
      k1 = i1
      j2 = i2
      k2 = i2
c
      do ie=1,nelv
c
         if (if3d) then
            lr2  = 0.
            wsum = 0.
            do k=1,nz
            do j=1,ny
               weight = w(j)*w(k)
c              lr2  = lr2  + ( (x(i2,j,k,ie)-x(i1,j,k,ie))**2
c    $                     +   (y(i2,j,k,ie)-y(i1,j,k,ie))**2
c    $                     +   (z(i2,j,k,ie)-z(i1,j,k,ie))**2 )
c    $                     *   weight
               lr2  = lr2  +   weight /
     $                       ( (x(i2,j,k,ie)-x(i1,j,k,ie))**2
     $                     +   (y(i2,j,k,ie)-y(i1,j,k,ie))**2
     $                     +   (z(i2,j,k,ie)-z(i1,j,k,ie))**2 )
               wsum = wsum + weight
            enddo
            enddo
            lr2     = lr2/wsum
            lr(ie)  = 1./sqrt(lr2)
c
            ls2 = 0.
            wsum = 0.
            do k=1,nz
            do i=1,nx
               weight = w(i)*w(k)
c              ls2  = ls2  + ( (x(i,j2,k,ie)-x(i,j1,k,ie))**2
c    $                     +   (y(i,j2,k,ie)-y(i,j1,k,ie))**2
c    $                     +   (z(i,j2,k,ie)-z(i,j1,k,ie))**2 )
c    $                     *   weight
               ls2  = ls2  +   weight /
     $                       ( (x(i,j2,k,ie)-x(i,j1,k,ie))**2
     $                     +   (y(i,j2,k,ie)-y(i,j1,k,ie))**2
     $                     +   (z(i,j2,k,ie)-z(i,j1,k,ie))**2 )
               wsum = wsum + weight
            enddo
            enddo
            ls2     = ls2/wsum
            ls(ie)  = 1./sqrt(ls2)
c
            lt2 = 0.
            wsum = 0.
            do j=1,ny
            do i=1,nx
               weight = w(i)*w(j)
c              lt2  = lt2  + ( (x(i,j,k2,ie)-x(i,j,k1,ie))**2
c    $                     +   (y(i,j,k2,ie)-y(i,j,k1,ie))**2
c    $                     +   (z(i,j,k2,ie)-z(i,j,k1,ie))**2 )
c    $                     *   weight
               lt2  = lt2  +   weight /
     $                       ( (x(i,j,k2,ie)-x(i,j,k1,ie))**2
     $                     +   (y(i,j,k2,ie)-y(i,j,k1,ie))**2
     $                     +   (z(i,j,k2,ie)-z(i,j,k1,ie))**2 )
               wsum = wsum + weight
            enddo
            enddo
            lt2     = lt2/wsum
            lt(ie)  = 1./sqrt(lt2)
c
         else              ! 2D
            lr2 = 0.
            wsum = 0.
            do j=1,ny
               weight = w(j)
c              lr2  = lr2  + ( (x(i2,j,1,ie)-x(i1,j,1,ie))**2
c    $                     +   (y(i2,j,1,ie)-y(i1,j,1,ie))**2 )
c    $                     *   weight
               lr2  = lr2  + weight /
     $                       ( (x(i2,j,1,ie)-x(i1,j,1,ie))**2
     $                       + (y(i2,j,1,ie)-y(i1,j,1,ie))**2 )
               wsum = wsum + weight
            enddo
            lr2     = lr2/wsum
            lr(ie)  = 1./sqrt(lr2)
c
            ls2 = 0.
            wsum = 0.
            do i=1,nx
               weight = w(i)
c              ls2  = ls2  + ( (x(i,j2,1,ie)-x(i,j1,1,ie))**2
c    $                     +   (y(i,j2,1,ie)-y(i,j1,1,ie))**2 )
c    $                     *   weight
               ls2  = ls2  + weight /
     $                       ( (x(i,j2,1,ie)-x(i,j1,1,ie))**2
     $                     +   (y(i,j2,1,ie)-y(i,j1,1,ie))**2 )
               wsum = wsum + weight
            enddo
            ls2     = ls2/wsum
            ls(ie)  = 1./sqrt(ls2)
c           write(6,*) 'lrls',ie,lr(ie),ls(ie)
         endif
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine plane_space2(lr,ls,lt,i1,w,x,y,z,nx,nxn,nz0,nzn)
c
c     Here, the local spacing is already given in the surface term.
c     This addition made to simplify the periodic bdry treatment.
c
c
      include 'SIZE'
      include 'INPUT'
c
      real w(1),lr(1),ls(1),lt(1)
      real x(0:nxn,0:nxn,nz0:nzn,1)
      real y(0:nxn,0:nxn,nz0:nzn,1)
      real z(0:nxn,0:nxn,nz0:nzn,1)
      real lr2,ls2,lt2
c                                    __ __ __
c     Now, for each element, compute lr,ls,lt between specified planes
c
      ny = nx
      nz = nx
      j1 = i1
      k1 = i1
c
      do ie=1,nelv
c
         if (if3d) then
            lr2  = 0.
            wsum = 0.
            do k=1,nz
            do j=1,ny
               weight = w(j)*w(k)
               lr2  = lr2  + ( (x(i1,j,k,ie))**2
     $                     +   (y(i1,j,k,ie))**2
     $                     +   (z(i1,j,k,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            enddo
            lr2     = lr2/wsum
            lr(ie)  = sqrt(lr2)
c
            ls2 = 0.
            wsum = 0.
            do k=1,nz
            do i=1,nx
               weight = w(i)*w(k)
               ls2  = ls2  + ( (x(i,j1,k,ie))**2
     $                     +   (y(i,j1,k,ie))**2
     $                     +   (z(i,j1,k,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            enddo
            ls2     = ls2/wsum
            ls(ie)  = sqrt(ls2)
c
            lt2 = 0.
            wsum = 0.
            do j=1,ny
            do i=1,nx
               weight = w(i)*w(j)
               lt2  = lt2  + ( (x(i,j,k1,ie))**2
     $                     +   (y(i,j,k1,ie))**2
     $                     +   (z(i,j,k1,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            enddo
            lt2     = lt2/wsum
            lt(ie)  = sqrt(lt2)
c           write(6,1) 'lrlslt',ie,lr(ie),ls(ie),lt(ie)
    1       format(a6,i5,1p3e12.4)
c
         else
            lr2 = 0.
            wsum = 0.
            do j=1,ny
               weight = w(j)
               lr2  = lr2  + ( (x(i1,j,1,ie))**2
     $                     +   (y(i1,j,1,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            lr2     = lr2/wsum
            lr(ie)  = sqrt(lr2)
c
            ls2 = 0.
            wsum = 0.
            do i=1,nx
               weight = w(i)
               ls2  = ls2  + ( (x(i,j1,1,ie))**2
     $                     +   (y(i,j1,1,ie))**2 )
     $                     *   weight
               wsum = wsum + weight
            enddo
            ls2     = ls2/wsum
            ls(ie)  = sqrt(ls2)
c           write(6,*) 'lrls',ie,lr(ie),ls(ie),lt(ie)
         endif
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_fast_1D_fem(s,lam,n,lbc,rbc,ll,lm,lr,z,nz,e)
      real s(1),lam(1),ll,lm,lr,z(1)
      integer lbc,rbc,e
c
      parameter (m=100)
      real dx(0:m)
      integer icalld
      save    icalld
      data    icalld/0/
c
      icalld=icalld+1
c
      if (nz.gt.m-3) then
         write(6,*) 'ABORT. Error in set_up_fast_1D_fem. Increase m to'
     $             , nz
         call exitt
      endif
c
c     In the present scheme, each element is viewed as a d-fold
c     tensor of (1+nz+1) arrays, even if funky bc's are applied 
c     on either end of the 1D array.
c
      n = nz+2
c
c     Compute spacing, dx()
c
      call set_up_1D_geom(dx,lbc,rbc,ll,lm,lr,z,nz)
c
      nn1 = n*n + 1
      call gen_eigs_A_fem(s,s(nn1),lam,n,dx,lbc,rbc)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_1D_geom(dx,lbc,rbc,ll,lm,lr,z,nz)
c
      real dx(0:1),ll,lm,lr,z(2)
      integer lbc,rbc
c
c
c     Set up the 1D geometry for the tensor-product based overlapping Schwarz
c
c     Upon return: 
c
c       dx() contains the spacing required to set up the stiffness matrix.  
c
c
c     Input:
c
c       lbc (rbc) is 0 if the left (right) BC is Dirichlet, 1 if Neumann. 
c
c       ll is the space between the left-most Gauss point of the middle
c          element and the right-most Gauss point of the LEFT element
c
c       lm is the space between the left-most Gauss point of the middle
c          element and the right-most Gauss point of the MIDDLE element
c
c       lr is the space between the right-most Gauss point of the middle
c          element and the left-most Gauss point of the RIGHT element
c
c       --- if ll (lr) is very small (0), it indicates that there is no
c           left (right) spacing, and that the left (right) BC is Neumann.
c
c
c       z() is the array of nz Gauss points on the interval ]-1,1[.
c
c     Boundary conditions:
c
c     bc = 0  -- std. Dirichlet bc applied 2 points away from interior
c     bc = 1  -- Dirichlet bc applied 1 point away from interior (outflow)
c     bc = 2  -- Neumann bc applied on interior point (W,v,V,SYM,...)
c
c
c
c     Geometry:
c
c
c        dx0       dx1   dx2    dx3   dx5    dx5        dx6
c
c    bl        |<--ll-->|<------lm------>|<---lr--->|           br
c     0--------x-----|--x---x--------x---x--|-------x-----------0
c
c       left elem.         middle elem.         right elem.
c                   -1                     +1
c
c
c    "bl" = (extrapolated) location of Gauss point lx2-1 in left elem.
c
c    "br" = (extrapolated) location of Gauss point 2 in right elem.
c
c    Overlapping Schwarz applied with homogeneous Dirichlet boundary
c    conditions at "bl" and "br", and with a single d.o.f. extending
c    in to each adjacent domain.
c
      eps = 1.e-5
      call rone(dx,nz+3)
c
c     Middle
      scale = lm/(z(nz)-z(1))
      do i=1,nz-1
         dx(i+1) = (z(i+1)-z(i))*scale
      enddo

c     Left end
      if (lbc.eq.0) then
         dzm0   = z(1) + 1.
         dxm0   = scale*dzm0
         dxln   = ll - dxm0
         scalel = dxln/dzm0
         dx(0)  = scalel*(z(2)-z(1))
         dx(1)  = ll
      elseif (lbc.eq.1) then
         dx(1)  = ll
      endif
c
c     Right end
      if (rbc.eq.0) then
         dzm0      = z(1) + 1.
         dxm0      = scale*dzm0
         dxr0      = lr - dxm0
         scaler    = dxr0/dzm0
         dx(nz+1)  = lr
         dx(nz+2)  = scaler*(z(2)-z(1))
      elseif (rbc.eq.1) then
         dx(nz+1)  = lr
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine gen_eigs_A_fem(sf,sft,atd,n,l,lbc,rbc)
c
c     Set up Fast diagonalization solver for FEM on mesh 2
c
      real sf(n,n),sft(n,n),atd(1),l(0:1)
      integer lbc,rbc
c
      parameter (m=100)
      real atu(m),ad(m),au(m),c(m),bh(m),li(0:m)
c
      if (n.gt.m) then
         write(6,*) 'ABORT. Error in gen_eigs_A_fem. Increase m to',n
         call exitt
      endif
c
c     Get delta x's
c
      do i=0,n
         li(i) = 1.0/l(i)
      enddo
c                          ^   ^
c     Fill initial arrays, A & B:
c
      call rzero(ad,n)
      call rzero(au,n-1)
      call rzero(bh,n)
c
      ie1 = lbc
      ien = n-rbc
      do ie=ie1,ien
c
c        il,ir are the left and right endpts of element ie.
         il = ie
         ir = ie+1
c
         if (ie.gt.0) ad(il) = ad(il) +       li(ie)
         if (ie.lt.n) ad(ir) = ad(ir) +       li(ie)
         if (ie.gt.0) au(il) =        -       li(ie)
         if (ie.gt.0) bh(il) = bh(il) + 0.5 * l(ie)
         if (ie.lt.n) bh(ir) = bh(ir) + 0.5 * l(ie)
      enddo
c
c     Take care of bc's (using blasting)
      bhm = vlmax(bh(2),n-2)/(n-2)
      ahm = vlmax(ad(2),n-2)/(n-2)
c
      if (lbc.gt.0) then
         au(1) = 0.
         ad(1) = ahm
         bh(1) = bhm
      endif
c
      if (rbc.gt.0) then
         au(n-1) = 0.
         ad(n  ) = ahm
         bh(n  ) = bhm
      endif
c
c
      do i=1,n
         c(i) = sqrt(1.0/bh(i))
      enddo
c                                        ~
c     Scale rows and columns of A by C:  A = CAC
c
      do i=1,n
         atd(i) = c(i)*ad(i)*c(i)
      enddo
c
c     Scale upper diagonal
c
      atu(1) = 0.
      do i=1,n-1
         atu(i) = c(i)*au(i)*c(i+1)
      enddo
c                                             ~
c     Compute eigenvalues and eigenvectors of A
c
      call calcz(atd,atu,n,dmax,dmin,sf,ierr)
      if (ierr.eq.1) then
         nid = mynode()
         write(6,6) nid,' czfail:',(l(k),k=0,n)
    6    format(i5,a8,1p16e10.2)
         call exitt
      endif
c
c     Sort eigenvalues and vectors
c
      call sort(atd,atu,n)
      call transpose(sft,n,sf,n)
      do j=1,n
         call swap(sft(1,j),atu,n,au)
      enddo
      call transpose(sf,n,sft,n)
c
c     Make "like" eigenvectors of same sign (for ease of diagnostics)
c
      do j=1,n
         avg = vlsum(sf(1,j),n)
         if (avg.lt.0) call chsign(sf(1,j),n)
      enddo
c
c     Clean up zero eigenvalue
c
      eps = 1.0e-6*dmax
      do i=1,n
c        if (atd(i).lt.eps) 
c    $      write(6,*) 'Reset Eig in gen_Afem:',i,n,atd(i)
         if (atd(i).lt.eps) atd(i) = 0.0
      enddo
c
c     scale eigenvectors by C:
c
      do i=1,n
         do j=1,n
            sf(i,j) = sf(i,j)*c(i)
         enddo
      enddo
c                                        ^
c     Orthonormalize eigenvectors w.r.t. B inner-product
c
      do j=1,n
         alpha = vlsc3(bh,sf(1,j),sf(1,j),n)
         alpha = 1.0/sqrt(alpha)
         call cmult(sf(1,j),alpha,n)
      enddo
c
c     Diagnostics
c
c     do j=1,n
c        do i=1,n
c           sft(i,j) = vlsc3(bh,sf(1,i),sf(1,j),n)
c        enddo
c     enddo
c
c     n8 = min(n,8)
c     do i=1,n
c        write(6,2) (sft(i,j),j=1,n8)
c     enddo
c   2 format('Id:',1p8e12.4)
c 
      call transpose(sft,n,sf,n)
      return
      end
c-----------------------------------------------------------------------
      subroutine get_fast_bc(lbr,rbr,lbs,rbs,lbt,rbt,e,bsym,ierr)
      integer                lbr,rbr,lbs,rbs,lbt,rbt,e,bsym
c
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'TOPOL'
      include 'TSTEP'
c
      integer fbc(6)
c
c     ibc = 0  <==>  Dirichlet
c     ibc = 1  <==>  Dirichlet, outflow (no extension)
c     ibc = 2  <==>  Neumann,   


      do iface=1,2*ldim
         ied = eface(iface)
         ibc = -1

         if (ifmhd) call mhd_bc_dn(ibc,iface,e) ! can be overwritten by 'mvn'

         if (cbc(ied,e,ifield).eq.'   ') ibc = 0
         if (cbc(ied,e,ifield).eq.'E  ') ibc = 0
         if (cbc(ied,e,ifield).eq.'msi') ibc = 0
         if (cbc(ied,e,ifield).eq.'MSI') ibc = 0
         if (cbc(ied,e,ifield).eq.'P  ') ibc = 0
         if (cbc(ied,e,ifield).eq.'p  ') ibc = 0
         if (cbc(ied,e,ifield).eq.'O  ') ibc = 1
         if (cbc(ied,e,ifield).eq.'ON ') ibc = 1
         if (cbc(ied,e,ifield).eq.'o  ') ibc = 1
         if (cbc(ied,e,ifield).eq.'on ') ibc = 1
         if (cbc(ied,e,ifield).eq.'MS ') ibc = 1
         if (cbc(ied,e,ifield).eq.'ms ') ibc = 1
         if (cbc(ied,e,ifield).eq.'MM ') ibc = 1
         if (cbc(ied,e,ifield).eq.'mm ') ibc = 1
         if (cbc(ied,e,ifield).eq.'mv ') ibc = 2
         if (cbc(ied,e,ifield).eq.'mvn') ibc = 2
         if (cbc(ied,e,ifield).eq.'v  ') ibc = 2
         if (cbc(ied,e,ifield).eq.'V  ') ibc = 2
         if (cbc(ied,e,ifield).eq.'W  ') ibc = 2
         if (cbc(ied,e,ifield).eq.'SYM') ibc = bsym
         if (cbc(ied,e,ifield).eq.'SL ') ibc = 2
         if (cbc(ied,e,ifield).eq.'sl ') ibc = 2
         if (cbc(ied,e,ifield).eq.'SHL') ibc = 2
         if (cbc(ied,e,ifield).eq.'shl') ibc = 2
         if (cbc(ied,e,ifield).eq.'A  ') ibc = 2
         if (cbc(ied,e,ifield).eq.'S  ') ibc = 2
         if (cbc(ied,e,ifield).eq.'s  ') ibc = 2
         if (cbc(ied,e,ifield).eq.'J  ') ibc = 0
         if (cbc(ied,e,ifield).eq.'SP ') ibc = 0

         fbc(iface) = ibc

         if (ierr.eq.-1) write(6,1) ibc,ied,e,ifield,cbc(ied,e,ifield)
  1      format(2i3,i8,i3,2x,a3,'  get_fast_bc_error')

      enddo

      if (ierr.eq.-1) call exitti('Error A get_fast_bc$',e)

      lbr = fbc(1)
      rbr = fbc(2)
      lbs = fbc(3)
      rbs = fbc(4)
      lbt = fbc(5)
      rbt = fbc(6)

      ierr = 0 
      if (ibc.lt.0) ierr = lglel(e)

c     write(6,6) e,lbr,rbr,lbs,rbs,(cbc(k,e,ifield),k=1,4)
c   6 format(i5,2x,4i3,3x,4(1x,a3),'  get_fast_bc')

      return
      end
c-----------------------------------------------------------------------
      subroutine outv(x,n,name3)
      character*3 name3
      real x(1)
c
      nn = min (n,10)
      write(6,6) name3,(x(i),i=1,nn)
    6 format(a3,10f12.6)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine outmat(a,m,n,name6,ie)
      real a(m,n)
      character*6 name6
c
      write(6,*) 
      write(6,*) ie,' matrix: ',name6,m,n
      n12 = min(n,12)
      do i=1,m
         write(6,6) ie,name6,(a(i,j),j=1,n12)
      enddo
    6 format(i3,1x,a6,12f9.5)
      write(6,*) 
      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_fast_1D_fem_ax
     $   (s,lam,n,lbc,rbc,ll,lm,lr,z,y,nz,ie)
      real s(1),lam(1),ll,lm,lr,z(1),y(1)
      integer lbc,rbc
c
      parameter (m=100)
      real dx(0:m)
      integer icalld
      save    icalld
      data    icalld/0/
c
      icalld=icalld+1
c
      if (nz.gt.m-3) then
         write(6,*) 'ABORT. Error in set_up_fast_1D_fem. Increase m to'
     $             , nz
         call exitt
      endif
c
c     In the present scheme, each element is viewed as a d-fold
c     tensor of (1+nz+1) arrays, even if funky bc's are applied 
c     on either end of the 1D array.
c
      n = nz+2
c
c     Compute spacing, dx()
c
      call set_up_1D_geom_ax(dx,lbc,rbc,ll,lm,lr,z,y,nz)
c
      nn1 = n*n + 1
      call gen_eigs_A_fem_ax(s,s(nn1),lam,n,dx,y,lbc,rbc)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_1D_geom_ax(dx,lbc,rbc,ll,lm,lr,z,y,nz)
c
      real dx(0:1),ll,lm,lr,z(2),y(1)
      integer lbc,rbc
c
c
c     Set up the 1D geometry for the tensor-product based overlapping Schwarz
c
c     Upon return: 
c
c       dx() contains the spacing required to set up the stiffness matrix.  
c
c
c     Input:
c
c       lbc (rbc) is 0 if the left (right) BC is Dirichlet, 1 if Neumann. 
c
c       ll is the space between the left-most Gauss point of the middle
c          element and the right-most Gauss point of the LEFT element
c
c       lm is the space between the left-most Gauss point of the middle
c          element and the right-most Gauss point of the MIDDLE element
c
c       lr is the space between the right-most Gauss point of the middle
c          element and the left-most Gauss point of the RIGHT element
c
c       --- if ll (lr) is very small (0), it indicates that there is no
c           left (right) spacing, and that the left (right) BC is Neumann.
c
c
c       z() is the array of nz Gauss points on the interval ]-1,1[.
c
c     Boundary conditions:
c
c     bc = 0  -- std. Dirichlet bc applied 2 points away from interior
c     bc = 1  -- Dirichlet bc applied 1 point away from interior (outflow)
c     bc = 2  -- Neumann bc applied on interior point (W,v,V,SYM,...)
c
c
c
c     Geometry:
c
c
c        dx0       dx1   dx2    dx3   dx5    dx5        dx6
c
c    bl        |<--ll-->|<------lm------>|<---lr--->|           br
c     0--------x-----|--x---x--------x---x--|-------x-----------0
c
c       left elem.         middle elem.         right elem.
c                   -1                     +1
c
c
c    "bl" = (extrapolated) location of Gauss point lx2-1 in left elem.
c
c    "br" = (extrapolated) location of Gauss point 2 in right elem.
c
c    Overlapping Schwarz applied with homogeneous Dirichlet boundary
c    conditions at "bl" and "br", and with a single d.o.f. extending
c    in to each adjacent domain.
c
      eps = 1.e-5
      call rone(dx,nz+3)
c
c     Middle
      scale = lm/(z(nz)-z(1))
      do i=1,nz-1
         dx(i+1) = (z(i+1)-z(i))*scale
      enddo

c     Left end
      if (lbc.eq.0) then
         dzm0   = z(1) + 1.
         dxm0   = scale*dzm0
         dxln   = ll - dxm0
         scalel = dxln/dzm0
         dx(0)  = scalel*(z(2)-z(1))
         dx(1)  = ll
      elseif (lbc.eq.1) then
         dx(1)  = ll
      endif
c
c     Right end
      if (rbc.eq.0) then
         dzm0      = z(1) + 1.
         dxm0      = scale*dzm0
         dxr0      = lr - dxm0
         scaler    = dxr0/dzm0
         dx(nz+1)  = lr
         dx(nz+2)  = scaler*(z(2)-z(1))
      elseif (rbc.eq.1) then
         dx(nz+1)  = lr
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine gen_eigs_A_fem_ax(sf,sft,atd,n,l,y,lbc,rbc)
c
c     Set up Fast diagonalization solver for FEM on mesh 2
c
      real sf(n,n),sft(n,n),atd(1),l(0:1),y(1)
      integer lbc,rbc
c
      parameter (m=100)
      real atu(m),ad(m),au(m),c(m),bh(m),li(0:m)
c
      if (n.gt.m) then
         write(6,*) 'ABORT. Error in gen_eigs_A_fem. Increase m to',n
         call exitt
      endif
c
c     Get delta x's
c
      do i=0,n
         li(i) = 1.0/l(i)
      enddo
c                          ^   ^
c     Fill initial arrays, A & B:
c
      call rzero(ad,n)
      call rzero(au,n-1)
      call rzero(bh,n)
c
      ie1 = lbc
      ien = n-rbc
      do ie=ie1,ien
c
c        il,ir are the left and right endpts of element ie.
         il = ie
         ir = ie+1
c
         if (ie.gt.0) ad(il) = ad(il) +       li(ie)
         if (ie.lt.n) ad(ir) = ad(ir) +       li(ie)
         if (ie.gt.0) au(il) =        -       li(ie)
         if (ie.gt.0) bh(il) = bh(il) + 0.5 * l(ie)
         if (ie.lt.n) bh(ir) = bh(ir) + 0.5 * l(ie)
      enddo
c
c     Take care of bc's (using blasting)
      bhm = vlmax(bh(2),n-2)/(n-2)
      ahm = vlmax(ad(2),n-2)/(n-2)
c
      if (lbc.gt.0) then
         au(1) = 0.
         ad(1) = ahm
         bh(1) = bhm
      endif
c
      if (rbc.gt.0) then
         au(n-1) = 0.
         ad(n  ) = ahm
         bh(n  ) = bhm
      endif
c
c
      do i=1,n
         c(i) = sqrt(1.0/bh(i))
      enddo
c                                        ~
c     Scale rows and columns of A by C:  A = CAC
c
      do i=1,n
         atd(i) = c(i)*ad(i)*c(i)
      enddo
c
c     Scale upper diagonal
c
      atu(1) = 0.
      do i=1,n-1
         atu(i) = c(i)*au(i)*c(i+1)
      enddo
c                                             ~
c     Compute eigenvalues and eigenvectors of A
c
      call calcz(atd,atu,n,dmax,dmin,sf,ierr)
      if (ierr.eq.1) then
         nid = mynode()
         write(6,6) nid,' czfail2:',(l(k),k=0,n)
    6    format(i5,a8,1p16e10.2)
         call exitt
      endif
c
c     Sort eigenvalues and vectors
c
      call sort(atd,atu,n)
      call transpose(sft,n,sf,n)
      do j=1,n
         call swap(sft(1,j),atu,n,au)
      enddo
      call transpose(sf,n,sft,n)
c
c     Make "like" eigenvectors of same sign (for ease of diagnostics)
c
      do j=1,n
         avg = vlsum(sf(1,j),n)
         if (avg.lt.0) call chsign(sf(1,j),n)
      enddo
c
c     Clean up zero eigenvalue
c
      eps = 1.0e-6*dmax
      do i=1,n
c        if (atd(i).lt.eps) 
c    $      write(6,*) 'Reset Eig in gen_Afm_ax:',i,n,atd(i)
         if (atd(i).lt.eps) atd(i) = 0.0
      enddo
c
c     scale eigenvectors by C:
c
      do i=1,n
         do j=1,n
            sf(i,j) = sf(i,j)*c(i)
         enddo
      enddo
c                                        ^
c     Orthonormalize eigenvectors w.r.t. B inner-product
c
      do j=1,n
         alpha = vlsc3(bh,sf(1,j),sf(1,j),n)
         alpha = 1.0/sqrt(alpha)
         call cmult(sf(1,j),alpha,n)
      enddo
c
c     Diagnostics
c
c     do j=1,n
c        do i=1,n
c           sft(i,j) = vlsc3(bh,sf(1,i),sf(1,j),n)
c        enddo
c     enddo
c
c     n8 = min(n,8)
c     do i=1,n
c        write(6,2) (sft(i,j),j=1,n8)
c     enddo
c   2 format('Id:',1p8e12.4)
c 
      call transpose(sft,n,sf,n)
      return
      end
c-----------------------------------------------------------------------
      subroutine load_semhat_weighted    !   Fills the SEMHAT arrays
c
c     Note that this routine performs the following matrix multiplies
c     after getting the matrices back from semhat:
c
c     dgl = bgl dgl
c     jgl = bgl jgl
c
      include 'SIZE'
      include 'SEMHAT'
c
      nr = lx1-1
      call semhat(ah,bh,ch,dh,zh,dph,jph,bgl,zglhat,dgl,jgl,nr,wh)
      call do_semhat_weight(jgl,dgl,bgl,nr)
c
      return
      end
c----------------------------------------------------------------------
      subroutine do_semhat_weight(jgl,dgl,bgl,n)
      real bgl(1:n-1),jgl(1:n-1,0:n),dgl(1:n-1,0:n)

      do j=0,n
         do i=1,n-1
            jgl(i,j)=bgl(i)*jgl(i,j)
         enddo
      enddo
      do j=0,n
         do i=1,n-1
            dgl(i,j)=bgl(i)*dgl(i,j)
         enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine semhat(a,b,c,d,z,dgll,jgll,bgl,zgl,dgl,jgl,n,w)
c
c     Generate matrices for single element, 1D operators:
c
c        a    = Laplacian
c        b    = diagonal mass matrix
c        c    = convection operator b*d
c        d    = derivative matrix
c        dgll = derivative matrix,    mapping from pressure nodes to velocity
c        jgll = interpolation matrix, mapping from pressure nodes to velocity
c        z    = GLL points
c
c        zgl  = GL points
c        bgl  = diagonal mass matrix on GL
c        dgl  = derivative matrix,    mapping from velocity nodes to pressure
c        jgl  = interpolation matrix, mapping from velocity nodes to pressure
c
c        n    = polynomial degree (velocity space)
c        w    = work array of size 2*n+2
c
c     Currently, this is set up for pressure nodes on the interior GLL pts.
c
c
      real a(0:n,0:n),b(0:n),c(0:n,0:n),d(0:n,0:n),z(0:n)
      real dgll(0:n,1:n-1),jgll(0:n,1:n-1)
c
      real bgl(1:n-1),zgl(1:n-1)
      real dgl(1:n-1,0:n),jgl(1:n-1,0:n)
c
      real w(0:2*n+1)
c
      np = n+1
      nm = n-1
      n2 = n-2
c
      call zwgll (z,b,np)
c
      do i=0,n
         call fd_weights_full(z(i),z,n,1,w)
         do j=0,n
            d(i,j) = w(j+np)                   !  Derivative matrix
         enddo
      enddo

      if (n.eq.1) return                       !  No interpolation for n=1

      do i=0,n
         call fd_weights_full(z(i),z(1),n2,1,w(1))
         do j=1,nm
            jgll(i,j) = w(j   )                  !  Interpolation matrix
            dgll(i,j) = w(j+nm)                  !  Derivative    matrix
         enddo
      enddo
c
      call rzero(a,np*np)
      do j=0,n
      do i=0,n
         do k=0,n
            a(i,j) = a(i,j) + d(k,i)*b(k)*d(k,j)
         enddo
         c(i,j) = b(i)*d(i,j)
      enddo
      enddo
c
      call zwgl (zgl,bgl,nm)
c
      do i=1,n-1
         call fd_weights_full(zgl(i),z,n,1,w)
         do j=0,n
            jgl(i,j) = w(j   )                  !  Interpolation matrix
            dgl(i,j) = w(j+np)                  !  Derivative    matrix
         enddo
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine fd_weights_full(xx,x,n,m,c)
c
c     This routine evaluates the derivative based on all points
c     in the stencils.  It is more memory efficient than "fd_weights"
c
c     This set of routines comes from the appendix of 
c     A Practical Guide to Pseudospectral Methods, B. Fornberg
c     Cambridge Univ. Press, 1996.   (pff)
c
c     Input parameters:
c       xx -- point at wich the approximations are to be accurate
c       x  -- array of x-ordinates:   x(0:n)
c       n  -- polynomial degree of interpolant (# of points := n+1)
c       m  -- highest order of derivative to be approxxmated at xi
c
c     Output:
c       c  -- set of coefficients c(0:n,0:m).
c             c(j,k) is to be applied at x(j) when
c             the kth derivative is approxxmated by a 
c             stencil extending over x(0),x(1),...x(n).
c
c
      real x(0:n),c(0:n,0:m)
c
      c1       = 1.
      c4       = x(0) - xx
c
      do k=0,m
      do j=0,n
         c(j,k) = 0.
      enddo
      enddo
      c(0,0) = 1.
c
      do i=1,n
         mn = min(i,m)
         c2 = 1.
         c5 = c4
         c4 = x(i)-xx
         do j=0,i-1
            c3 = x(i)-x(j)
            c2 = c2*c3
            do k=mn,1,-1
               c(i,k) = c1*(k*c(i-1,k-1)-c5*c(i-1,k))/c2
            enddo
            c(i,0) = -c1*c5*c(i-1,0)/c2
            do k=mn,1,-1
               c(j,k) = (c4*c(j,k)-k*c(j,k-1))/c3
            enddo
            c(j,0) = c4*c(j,0)/c3
         enddo
         c1 = c2
      enddo
c     call outmat(c,n+1,m+1,'fdw',n)
      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_fast_1D_sem(s,lam,n,lbc,rbc,ll,lm,lr,ie)
      include 'SIZE'
      include 'SEMHAT'
c
      common /fast1dsem/ g(lr2),w(lr2)
c
      real g,w
      real s(1),lam(1),ll,lm,lr
      integer lbc,rbc
      
      integer bb0,bb1,eb0,eb1,n,n1
      logical l,r
      
      n=lx1-1
      !bcs on E are from normal vel component
      if(lbc.eq.2 .or. lbc.eq.3) then !wall,sym - dirichlet velocity
         eb0=1
      else !outflow,element - neumann velocity
         eb0=0
      endif
      if(rbc.eq.2 .or. rbc.eq.3) then !wall,sym - dirichlet velocity
         eb1=n-1
      else !outflow,element - neumann velocity
         eb1=n
      endif
      !bcs on B are from tangent vel component
      if(lbc.eq.2) then !wall - dirichlet velocity
         bb0=1
      else !outflow,element,sym - neumann velocity
         bb0=0
      endif
      if(rbc.eq.2) then !wall - dirichlet velocity
         bb1=n-1
      else !outflow,element,sym - neumann velocity
         bb1=n
      endif
c
      l = (lbc.eq.0)
      r = (rbc.eq.0)
c
c     calculate E tilde operator
      call set_up_fast_1D_sem_op(s,eb0,eb1,l,r,ll,lm,lr,bh,dgl,0)
c     call outmat(s,n+1,n+1,'  Et  ',ie)
c     calculate B tilde operator
      call set_up_fast_1D_sem_op(g,bb0,bb1,l,r,ll,lm,lr,bh,jgl,1)
c     call outmat(g,n+1,n+1,'  Bt  ',ie)
      
      n=n+1
      call generalev(s,g,lam,n,w)
      if(.not.l) call row_zero(s,n,n,1)
      if(.not.r) call row_zero(s,n,n,n)
      call transpose(s(n*n+1),n,s,n) ! compute the transpose of s

c     call outmat   (s,n,n,'  S   ',ie)
c     call outmat   (s(n*n+1),n,n,'  St  ',1)
c     call exitt
      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_fast_1D_sem_op(g,b0,b1,l,r,ll,lm,lr,bh,jgl,jscl)
c            -1 T
c     G = J B  J
c
c     gives the inexact restriction of this matrix to
c     an element plus one node on either side
c
c     g - the output matrix
c     b0, b1 - the range for Bhat indices for the element
c              (enforces boundary conditions)
c     l, r - whether there is a left or right neighbor
c     ll,lm,lr - lengths of left, middle, and right elements
c     bh - hat matrix for B
c     jgl - hat matrix for J (should map vel to pressure)
c     jscl - how J scales
c            0: J = Jh
c            1: J = (L/2) Jh
c
c     result is inexact because:
c        neighbor's boundary condition at far end unknown
c        length of neighbor's neighbor unknown
c        (these contribs should be small for large N and
c         elements of nearly equal size)
c
      include 'SIZE'
      real g(0:lx1-1,0:lx1-1)
      real bh(0:lx1-1),jgl(1:lx2,0:lx1-1)
      real ll,lm,lr
      integer b0,b1
      logical l,r
      integer jscl
c
      real bl(0:lx1-1),bm(0:lx1-1),br(0:lx1-1)
      real gl,gm,gr,gll,glm,gmm,gmr,grr
      real fac
      integer n
      n=lx1-1
c
c
c     compute the scale factors for J      
      if (jscl.eq.0) then
         gl=1.
         gm=1.
         gr=1.
      elseif (jscl.eq.1) then
         gl=0.5*ll
         gm=0.5*lm
         gr=0.5*lr
      endif
      gll = gl*gl
      glm = gl*gm
      gmm = gm*gm
      gmr = gm*gr
      grr = gr*gr
c
c     compute the summed inverse mass matrices for
c     the middle, left, and right elements
      do i=1,n-1
         bm(i)=2. /(lm*bh(i))
      enddo
      if (b0.eq.0) then
         bm(0)=0.5*lm*bh(0)
         if(l) bm(0)=bm(0)+0.5*ll*bh(n)
         bm(0)=1. /bm(0)
      endif
      if (b1.eq.n) then
         bm(n)=0.5*lm*bh(n)
         if(r) bm(n)=bm(n)+0.5*lr*bh(0)
         bm(n)=1. /bm(n)
      endif
c     note that in computing bl for the left element,
c     bl(0) is missing the contribution from its left neighbor
      if (l) then
         do i=0,n-1
            bl(i)=2. /(ll*bh(i))
         enddo
         bl(n)=bm(0)
      endif
c     note that in computing br for the right element,
c     br(n) is missing the contribution from its right neighbor
      if (r) then
         do i=1,n
            br(i)=2. /(lr*bh(i))
         enddo
         br(0)=bm(n)
      endif
c      
      call rzero(g,(n+1)*(n+1))
      do j=1,n-1
         do i=1,n-1
            do k=b0,b1
               g(i,j) = g(i,j) + gmm*jgl(i,k)*bm(k)*jgl(j,k)
            enddo
         enddo
      enddo
c      
      if (l) then
         do i=1,n-1
            g(i,0) = glm*jgl(i,0)*bm(0)*jgl(n-1,n)
            g(0,i) = g(i,0)
         enddo
c        the following is inexact
c        the neighbors bc's are ignored, and the contribution
c        from the neighbor's neighbor is left out
c        that is, bl(0) could be off as noted above
c        or maybe i should go from 1 to n
         do i=0,n
            g(0,0) = g(0,0) + gll*jgl(n-1,i)*bl(i)*jgl(n-1,i)
         enddo
      else
         g(0,0)=1.
      endif
c      
      if (r) then
         do i=1,n-1
            g(i,n) = gmr*jgl(i,n)*bm(n)*jgl(1,0)
            g(n,i) = g(i,n)
         enddo
c        the following is inexact
c        the neighbors bc's are ignored, and the contribution
c        from the neighbor's neighbor is left out
c        that is, br(n) could be off as noted above
c        or maybe i should go from 0 to n-1
         do i=0,n
            g(n,n) = g(n,n) + grr*jgl(1,i)*br(i)*jgl(1,i)
         enddo
      else
         g(n,n)=1.
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine swap_lengths

      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'WZ'
      common /swaplengths/ l(lx1,ly1,lz1,lelv)
      common /ctmpf/  lr(2*lx1+4),ls(2*lx1+4),lt(2*lx1+4)
     $              , llr(lelt),lls(lelt),llt(lelt)
     $              , lmr(lelt),lms(lelt),lmt(lelt)
     $              , lrr(lelt),lrs(lelt),lrt(lelt)
      real lr ,ls ,lt
      real llr,lls,llt
      real lmr,lms,lmt
      real lrr,lrs,lrt

      real l,l2d
      integer e

      n2 = lx1-1
      nz0 = 1
      nzn = 1
      nx  = lx1-2
      if (if3d) then
         nz0 = 0
         nzn = n2
      endif
      call plane_space(lmr,lms,lmt,0,n2,wxm1,xm1,ym1,zm1,nx,n2,nz0,nzn)

      n=n2+1
      if (if3d) then
         do e=1,nelv
         do j=2,n2
         do k=2,n2
            l(1,k,j,e) = lmr(e)
            l(n,k,j,e) = lmr(e)
            l(k,1,j,e) = lms(e)
            l(k,n,j,e) = lms(e)
            l(k,j,1,e) = lmt(e)
            l(k,j,n,e) = lmt(e)
         enddo
         enddo
         enddo
         call dssum(l,n,n,n)
         do e=1,nelv
            llr(e) = l(1,2,2,e)-lmr(e)
            lrr(e) = l(n,2,2,e)-lmr(e)
            lls(e) = l(2,1,2,e)-lms(e)
            lrs(e) = l(2,n,2,e)-lms(e)
            llt(e) = l(2,2,1,e)-lmt(e)
            lrt(e) = l(2,2,n,e)-lmt(e)
         enddo
      else
         do e=1,nelv
         do j=2,n2
            l(1,j,1,e) = lmr(e)
            l(n,j,1,e) = lmr(e)
            l(j,1,1,e) = lms(e)
            l(j,n,1,e) = lms(e)
c           call outmat(l(1,1,1,e),n,n,' L    ',e)
         enddo
         enddo
c        call outmat(l(1,1,1,25),n,n,' L    ',25)
         call dssum(l,n,n,1)
c        call outmat(l(1,1,1,25),n,n,' L    ',25)
         do e=1,nelv
c           call outmat(l(1,1,1,e),n,n,' L    ',e)
            llr(e) = l(1,2,1,e)-lmr(e)
            lrr(e) = l(n,2,1,e)-lmr(e)
            lls(e) = l(2,1,1,e)-lms(e)
            lrs(e) = l(2,n,1,e)-lms(e)
         enddo
      endif
      return
      end
c----------------------------------------------------------------------
      subroutine row_zero(a,m,n,e)
      integer m,n,e
      real a(m,n)
      do j=1,n
         a(e,j)=0.
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine mhd_bc_dn(ibc,face,e)
      integer                  face,e
c
c     sets Neumann BC on pressure (ibc=2) for face and e(lement) except
c     when ifield normal component has (homogeneous) Neumann
c     boundary condition setting ibc=1 (i.e. Direchlet BC on pressure)
c
c     Note: 'SYM' on a plane with r,s,t-normal is 'dnn','ndn','nnd'? bsym?
c
      include 'SIZE'
      include 'TOPOL'
      include 'INPUT'
      include 'TSTEP'

      ied = eface(face)	! symmetric -> preprocessor notation
      nfc = face+1
      nfc = nfc/2	! = 1,2,3 for face 1 & 2,3 & 4,5 & 6

      if (indx1(cbc(ied,e,ifield),'d',1).gt.0)   ibc=2

      if (indx1(cbc(ied,e,ifield),'n',1).gt.nfc) ibc=1 ! 'n' for V_n

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A nested lock can be locked several times. It doesn't unlock until you have unset
!it as many times as the number of calls to omp_set_nest_lock.
!incr_b is called at line 53 and line 58. So, it needs a nest_lock enclosing line 35
!Missing nest_lock will lead to race condition at line:35.
!Data Race Pairs, p%b@35:5 and p%b@35:5.

module DRB118
    use OMP_LIB, ONLY: OMP_NEST_LOCK_KIND
    type pair
        integer a
        integer b
        integer (OMP_NEST_LOCK_KIND) lck
    end type
end module

subroutine incr_a(p, a)
    use DRB118
    type(pair) :: p
    integer a
    p%a = p%a + 1
end subroutine

subroutine incr_b(p, b)
    use omp_lib
    use DRB118
    type(pair) :: p
    integer b
    p%b = p%b + 1
end subroutine

program DRB118_nestlock_orig_no
    use omp_lib
    use DRB118
    implicit none

    integer :: a, b

    type(pair) :: p
    p%a = 0
    p%b = 0
    call omp_init_nest_lock(p%lck);

    !$omp parallel sections
    !$omp section
        call omp_set_nest_lock(p%lck)
        call incr_b(p, a)
        call incr_a(p, b)
        call omp_unset_nest_lock(p%lck)

    !$omp section
        call incr_b(p, b);

    !$omp end parallel sections

    call omp_destroy_nest_lock(p%lck)

    print*,p%b

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!When if() evalutes to true, this program has data races due to true dependence within the loop at 31.
!Data race pair: a[i+1]@32:9 vs. a[i]@32:18

program DRB114_if_orig_yes
    use omp_lib
    implicit none

    integer i, len, rem, j
    real :: u
    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:), allocatable :: a

    len = 100
    allocate (a(len))

    do i = 1, len
        a(i) = i
    end do

    call random_number(u)
    j = FLOOR(100*u)

    !$omp parallel do if (MOD(j,2)==0)
    do i = 1, len-1
        a(i+1) = a(i)+1
    end do
    !$omp end parallel do

    print*,'a(50) =',a(50)

    deallocate(a)
end program

c-----------------------------------------------------------------------
      SUBROUTINE SETLOG(ifecho)
C                                                                     
C     Subroutine to initialize logical flags
C                                                                     
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      INCLUDE 'CTIMER'
      INCLUDE 'ADJOINT'

      logical ifecho

      COMMON  /CPRINT/ IFPRINT
C
      common  /nekcb/ cb
      CHARACTER CB*3
      LOGICAL IFALGN,IFNORX,IFNORY,IFNORZ,IFPRINT
C
      NFACE  = 2*ldim
C
      IFPRINT = .TRUE.
      IFVCOR  = .TRUE.
      IFGEOM  = .FALSE.
      IFINTQ  = .FALSE.
      IFSURT  = .FALSE.
      IFWCNO  = .FALSE.
      DO 10 IFIELD=1,NFIELD
         IFNONL(IFIELD) = .FALSE.
 10   CONTINUE
C
      CALL LFALSE (IFEPPM,NFACE*NELV)
      CALL LFALSE (IFQINP,NFACE*NELV)
C
      IF (IFMVBD) THEN
         IFGEOM = .TRUE.
         IF ( IFFLOW .AND. .NOT.IFNAV )       IFWCNO          = .TRUE.
         IF ( IFMELT .AND. .NOT.IFFLOW )      IFWCNO          = .TRUE.
      ENDIF
C
      IF (IFFLOW) THEN
         IERR = 0
         IFIELD = 1
         DO 100 IEL=1,NELV
         DO 100 IFC=1,NFACE
            CB = CBC(IFC,IEL,IFIELD)
            CALL CHKNORD (IFALGN,IFNORX,IFNORY,IFNORZ,IFC,IEL)
            CALL CHKCBC  (CB,IEL,IFC,IFALGN,IERR)
            IF  (CB.EQ.'O  ' .OR. CB.EQ.'o  ' .OR.
     $           CB.EQ.'ON ' .OR. CB.EQ.'on ' .OR.
     $           CB.EQ.'S  ' .OR. CB.EQ.'s  ' .OR.
     $           CB.EQ.'SL ' .OR. CB.EQ.'sl ' .OR.
     $           CB.EQ.'MM ' .OR. CB.EQ.'mm ' .OR.
     $           CB.EQ.'MS ' .OR. CB.EQ.'ms ')  THEN
                                              IFVCOR          = .FALSE.
                                              IFEPPM(IFC,IEL) = .TRUE.
            ENDIF
            IF  (CB.EQ.'VL ' .OR. CB.EQ.'vl ' .OR.
     $           CB.EQ.'WSL' .OR. CB.EQ.'wsl' .OR.
     $           CB.EQ.'SL ' .OR. CB.EQ.'sl ' .OR.
     $           CB.EQ.'SHL' .OR. CB.EQ.'shl' .OR.
     $           CB.EQ.'MM ' .OR. CB.EQ.'mm ' .OR.
     $           CB.EQ.'MS ' .OR. CB.EQ.'ms ' .OR.
     $           CB.EQ.'O  ' .OR. CB.EQ.'o  ' .OR.
     $           CB.EQ.'ON ' .OR. CB.EQ.'on ')  THEN
                                              IFQINP(IFC,IEL) = .TRUE.
            ENDIF
            IF  (CB.EQ.'MS ' .OR. CB.EQ.'ms ' .OR.
     $           CB.EQ.'MM ' .OR. CB.EQ.'mm ' .OR.
     $           CB.EQ.'MSI' .OR. CB.EQ.'msi' ) THEN
                                              IFSURT          = .TRUE.
            ENDIF
  100    CONTINUE

         ierr = iglsum(ierr,1)
         if (ierr.gt.0) call exitt 
      ENDIF
C
      IF (IFHEAT) THEN
C
         DO 250 IFIELD=2,NFIELD
         DO 250 IEL=1,NELFLD(IFIELD)
         DO 250 IFC=1,NFACE
            CB=CBC(IFC,IEL,IFIELD)
            IF  (CB.EQ.'r  ' .OR. CB.EQ.'R  ') THEN
                                              IFNONL(IFIELD)  = .TRUE.
            ENDIF
  250    CONTINUE
C
      ENDIF

      if (ifmhd) call set_ifbcor
C
C     Establish global consistency of LOGICALS amongst all processors.
C
      CALL GLLOG(IFVCOR , .FALSE.)
      CALL GLLOG(IFSURT , .TRUE. )
      CALL GLLOG(IFWCNO , .TRUE. )
      DO 400 IFIELD=2,NFIELD
         CALL GLLOG(IFNONL(IFIELD),.TRUE.)
  400 CONTINUE
C
      IF (NIO.EQ.0 .AND. ifecho) THEN
         WRITE (6,*) 'IFTRAN    =',IFTRAN
         WRITE (6,*) 'IFFLOW    =',IFFLOW
         WRITE (6,*) 'IFHEAT    =',IFHEAT
         WRITE (6,*) 'IFSPLIT   =',IFSPLIT
         WRITE (6,*) 'IFLOMACH  =',IFLOMACH
         WRITE (6,*) 'IFUSERVP  =',IFUSERVP
         WRITE (6,*) 'IFUSERMV  =',IFUSERMV
         WRITE (6,*) 'IFPERT    =',IFPERT
         WRITE (6,*) 'IFADJ     =',IFADJ
         WRITE (6,*) 'IFSTRS    =',IFSTRS
         WRITE (6,*) 'IFCHAR    =',IFCHAR
         WRITE (6,*) 'IFCYCLIC  =',IFCYCLIC
         WRITE (6,*) 'IFAXIS    =',IFAXIS
         WRITE (6,*) 'IFMVBD    =',IFMVBD
         WRITE (6,*) 'IFMELT    =',IFMELT
         WRITE (6,*) 'IFNEKNEK  =',IFNEKNEK
         WRITE (6,*) 'IFNEKNEKC =',IFNEKNEKC
         WRITE (6,*) 'IFSYNC    =',IFSYNC
         WRITE (6,*) '  '
         WRITE (6,*) 'IFVCOR    =',IFVCOR
         WRITE (6,*) 'IFINTQ    =',IFINTQ
         WRITE (6,*) 'IFGEOM    =',IFGEOM
         WRITE (6,*) 'IFSURT    =',IFSURT
         WRITE (6,*) 'IFWCNO    =',IFWCNO

         DO 500 IFIELD=1,NFIELD
            WRITE (6,*) '  '
            WRITE (6,*) 'IFTMSH for field',IFIELD,'   = ',IFTMSH(IFIELD)
            WRITE (6,*) 'IFADVC for field',IFIELD,'   = ',IFADVC(IFIELD)
            WRITE (6,*) 'IFNONL for field',IFIELD,'   = ',IFNONL(IFIELD)
 500     CONTINUE
         WRITE (6,*) '  '
         if (param(99).gt.0) write(6,*) 'Dealiasing enabled, nxd=', nxd
      ENDIF
C
      RETURN
      END
C
c-----------------------------------------------------------------------
      SUBROUTINE SETRZER
C-------------------------------------------------------------------
C
C     Check for axisymmetric case.
C     Are some of the elements close to the axis?
C
C-------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
C
C     Single or double precision???
C
      DELTA = 1.E-9
      X     = 1.+DELTA
      Y     = 1.
      DIFF  = ABS(X-Y)
      IF (DIFF.EQ.0.) EPS = 1.E-7
      IF (DIFF.GT.0.) EPS = 1.E-14
      eps1 = 1.e-6 ! for prenek mesh in real*4
C
      DO 100 IEL=1,NELT
         IFRZER(IEL) = .FALSE.
         IF (IFAXIS) THEN
            NVERT = 0
            DO 10 IC=1,4
               IF(ABS(YC(IC,IEL)).LT.EPS1) THEN
                  NVERT = NVERT+1
                  YC(IC,IEL) = 0.0  ! exactly on the axis
               ENDIF
 10         CONTINUE
         ENDIF
         IEDGE = 1
         IF ((NVERT.EQ.2).AND.(CCURVE(IEDGE,IEL).EQ.' '))
     $       IFRZER(IEL) = .TRUE.
 100  CONTINUE
      RETURN
      END
C
c-----------------------------------------------------------------------
      SUBROUTINE CHKNORD (IFALGN,IFNORX,IFNORY,IFNORZ,IFC,IEL)
C
C      Check direction of normal of an element face for
C      alignment with the X, Y, or Z axis.
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
C
      LOGICAL IFALGN,IFNORX,IFNORY,IFNORZ
C
      SUMX    = 0.0
      SUMY    = 0.0
      SUMZ    = 0.0
      TOLNOR  = 1.0e-3
      IFALGN  = .FALSE.
      IFNORX  = .FALSE.
      IFNORY  = .FALSE.
      IFNORZ  = .FALSE.
C
      IF (ldim.EQ.2) THEN
C
         NCPF = lx1
         DO 100 IX=1,lx1
            SUMX = SUMX + ABS( ABS(UNX(IX,1,IFC,IEL)) - 1.0 )
            SUMY = SUMY + ABS( ABS(UNY(IX,1,IFC,IEL)) - 1.0 )
  100    CONTINUE
         SUMX = SUMX / NCPF
         SUMY = SUMY / NCPF
         IF ( SUMX.LT.TOLNOR ) THEN
            IFNORX  = .TRUE.
            IFALGN = .TRUE.
         ENDIF
         IF ( SUMY.LT.TOLNOR ) THEN
            IFNORY  = .TRUE.
            IFALGN = .TRUE.
         ENDIF
C
      ELSE
C
         NCPF = lx1*lx1
         DO 200 IX=1,lx1
         DO 200 IY=1,ly1
            SUMX = SUMX + ABS( ABS(UNX(IX,IY,IFC,IEL)) - 1.0 )
            SUMY = SUMY + ABS( ABS(UNY(IX,IY,IFC,IEL)) - 1.0 )
            SUMZ = SUMZ + ABS( ABS(UNZ(IX,IY,IFC,IEL)) - 1.0 )
  200    CONTINUE
         SUMX = SUMX / NCPF
         SUMY = SUMY / NCPF
         SUMZ = SUMZ / NCPF
         IF ( SUMX.LT.TOLNOR ) THEN
            IFNORX  = .TRUE.
            IFALGN = .TRUE.
         ENDIF
         IF ( SUMY.LT.TOLNOR ) THEN
            IFNORY  = .TRUE.
            IFALGN = .TRUE.
         ENDIF
         IF ( SUMZ.LT.TOLNOR ) THEN
            IFNORZ  = .TRUE.
            IFALGN = .TRUE.
         ENDIF
C
      ENDIF
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE CHKAXCB
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      CHARACTER CB*3
C
      IFLD  = 1
      NFACE = 2*ldim
C
      DO 100 IEL=1,NELV
      DO 100 IFC=1,NFACE
         CB = CBC(IFC,IEL,IFLD)
         IF  (CB.EQ.'A  ' .AND. IFC.NE.1)  GOTO 9000
  100 CONTINUE
C
      RETURN
C
 9000 WRITE (6,*) ' Element face on the axis of symmetry must be FACE 1'
      WRITE (6,*) ' Element',IEL,'   face',IFC,'  is on the axis.'
      call exitt
C
      END
c-----------------------------------------------------------------------
      SUBROUTINE CHKCBC (CB,IEL,IFC,IFALGN,IERR)
      include 'SIZE' 
      include 'PARALLEL' 
      include 'INPUT' 
C
C     Check for illegal boundary conditions
C
      CHARACTER CB*3
      LOGICAL IFALGN

      if (ifstrs) return 

      ieg  = lglel(iel)

C     Laplacian formulation only
      IF  (CB.EQ.'SH ' .OR.  CB.EQ.'sh ' .OR.
     $     CB.EQ.'SHL' .OR.  CB.EQ.'shl' .OR.
     $     CB.EQ.'S  ' .OR.  CB.EQ.'s  ' .OR.
     $     CB.EQ.'SL ' .OR.  CB.EQ.'sl ' .OR.
     $     CB.EQ.'MM ' .OR.  CB.EQ.'mm ' .OR.
     $     CB.EQ.'MS ' .OR.  CB.EQ.'ms ' .OR.
     $     CB.EQ.'MSI' .OR.  CB.EQ.'msi'    )                GOTO 9001

       IF ( .NOT.IFALGN .AND.
     $    (CB.EQ.'ON ' .OR.  CB.EQ.'on ' .OR. CB.EQ.'SYM') ) GOTO 9010

      RETURN

 9001 WRITE (6,*) ' Illegal traction boundary conditions detected for'
      GOTO 9999

 9010 WRITE (6,*) ' Mixed B.C. on a side nonaligned with either the X,Y,
     $ or Z axis detected for'

 9999 WRITE (6,*) ' Element',ieg,'   side',IFC
      WRITE (6,*) ' Requires PN/PN-2 STRESS FORMULATION'

      ierr = err + 1

      END
c-----------------------------------------------------------------------
      SUBROUTINE BCMASK
C
C     Zero out masks corresponding to Dirichlet boundary points.
C
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      INCLUDE 'INPUT'
      INCLUDE 'MVGEOM'
      INCLUDE 'SOLN'
      INCLUDE 'TOPOL'

      common  /nekcb/ cb
      character*3 cb
      character*1 cb1(3)
      equivalence (cb1,cb)

      logical ifalgn,ifnorx,ifnory,ifnorz
      integer e,f

      NFACES=2*ldim
      NXYZ  =lx1*ly1*lz1

C
C     Masks for moving mesh
C
      IF (IFMVBD) THEN
         IFIELD = 0
         CALL STSMASK (W1MASK,W2MASK,W3MASK)
         do e=1,nelv
         do f=1,nfaces
            if (cbc(f,e,1).eq.'msi'.or.cbc(f,e,1).eq.'msi') then
               call facev(w1mask,e,f,0.0,lx1,ly1,lz1)
               call facev(w2mask,e,f,0.0,lx1,ly1,lz1)
               call facev(w3mask,e,f,0.0,lx1,ly1,lz1)
            endif
         enddo
         enddo
      ENDIF
C
C     Masks for flow variables
C
      IF (IFFLOW) THEN
         IFIELD = 1
         NEL    = NELFLD(IFIELD)
         NTOT   = NXYZ*NEL
C
C        Pressure mask
C
         call rone(pmask,ntot)
         do 50 iel=1,nelt
         do 50 iface=1,nfaces
            cb=cbc(iface,iel,ifield)
            if (cb.eq.'O  ' .or. cb.eq.'ON ' .or.
     $          cb.eq.'o  ' .or. cb.eq.'on ')
     $         call facev(pmask,iel,iface,0.0,lx1,ly1,lz1)
   50    continue
         if (nelt.gt.nelv) then
            nn=lx1*ly1*lz1*(nelt-nelv)
            call rzero(pmask(1,1,1,nelv+1),nn)
         endif
C
C        Zero out mask at Neumann-Dirichlet interfaces
C
         CALL DSOP(PMASK,'MUL',lx1,ly1,lz1)
C
C        Velocity masks
C
         IF (IFSTRS) THEN
           CALL STSMASK (V1MASK,V2MASK,V3MASK)
         ELSE
C
           CALL RONE(V1MASK,NTOT)
           CALL RONE(V2MASK,NTOT)
           CALL RONE(V3MASK,NTOT)
C
           DO 100 IEL=1,NELV
           DO 100 IFACE=1,NFACES
              CB =CBC(IFACE,IEL,IFIELD)
              CALL CHKNORD (IFALGN,IFNORX,IFNORY,IFNORZ,IFACE,IEL)
C
C            All-Dirichlet boundary conditions
C
           IF (CB.EQ.'v  ' .OR. CB.EQ.'V  ' .OR. CB.EQ.'vl ' .OR.
     $         cb.eq.'MV ' .or. cb.eq.'mv '                  .or.
     $         CB.EQ.'VL ' .OR. CB.EQ.'W  ') THEN
             CALL FACEV (V1MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             CALL FACEV (V2MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             CALL FACEV (V3MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             GOTO 100
           ENDIF
C
C        Mixed-Dirichlet-Neumann boundary conditions
C
         IF (CB.EQ.'SYM') THEN
             IF ( .NOT.IFALGN .OR. IFNORX )
     $            CALL FACEV (V1MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             IF ( IFNORY )
     $            CALL FACEV (V2MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             IF ( IFNORZ )
     $            CALL FACEV (V3MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             GOTO 100
         ENDIF

         IF (CB.EQ.'ON ' .OR. CB.EQ.'on ') THEN
             IF ( IFNORY .OR. IFNORZ )
     $            CALL FACEV (V1MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             IF ( .NOT.IFALGN .OR. IFNORX .OR. IFNORZ )
     $            CALL FACEV (V2MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             IF ( .NOT.IFALGN .OR. IFNORX .OR. IFNORY )
     $            CALL FACEV (V3MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
             GOTO 100
         ENDIF
         IF (CB.EQ.'A  ') THEN
             CALL FACEV (V2MASK,IEL,IFACE,0.0,lx1,ly1,lz1)
         ENDIF
  100    CONTINUE

         call opdsop(v1mask,v2mask,v3mask,'MUL') ! no rotation for mul

       ENDIF

       CALL RONE(OMASK,NTOT)
       DO 200 IEL=1,NELV
       DO 200 IFACE=1,NFACES
          CB =CBC(IFACE,IEL,IFIELD)
          IF (CB.EQ.'A  ') THEN
              CALL FACEV (OMASK,IEL,IFACE,0.0,lx1,ly1,lz1)
          ENDIF
 200   CONTINUE
       CALL DSOP(OMASK,'MUL',lx1,ly1,lz1)
C
      ENDIF
C
C     Masks for passive scalars
C
      IF (IFHEAT) THEN
C
         DO 1200 IFIELD=2,NFIELD
            IPSCAL = IFIELD-1
            NEL    = NELFLD(IFIELD)
            NTOT   = NXYZ*NEL
            CALL RONE (TMASK(1,1,1,1,IPSCAL),NTOT)
         DO 1100 IEL=1,NEL
         DO 1100 IFACE=1,NFACES
            CB =CBC(IFACE,IEL,IFIELD)
C
C           Assign mask values.
C
            IF  (CB.EQ.'T  ' .OR. CB.EQ.'t  ' .OR. 
     $          (CB.EQ.'A  ' .AND. IFAZIV)    .OR.
     $           CB.EQ.'MCI' .OR. CB.EQ.'MLI' .OR.
     $           CB.EQ.'KD ' .OR. CB.EQ.'kd ' .OR.
     $           CB.EQ.'ED ' .OR. CB.EQ.'ed ' .OR.
     $           CB.EQ.'KW ' .OR. CB.EQ.'KWS' .OR. CB.EQ.'EWS')
     $           CALL FACEV (TMASK(1,1,1,1,IPSCAL),
     $                       IEL,IFACE,0.0,lx1,ly1,lz1)
 1100       CONTINUE
         CALL DSOP (TMASK(1,1,1,1,IPSCAL),'MUL',lx1,ly1,lz1)
 1200    CONTINUE
C
      ENDIF
C
C     Masks for B-field
C
      if (ifmhd) then
         ifield = ifldmhd
         nel    = nelfld(ifield)
         ntot   = nxyz*nel
C
C        B-field pressure mask
C
         call rone(bpmask,ntot)
         do iel=1,nelv
         do iface=1,nfaces
            cb=cbc(iface,iel,ifield)
            if (cb.eq.'O  ' .or. cb.eq.'ON ')
     $         call facev(bpmask,iel,iface,0.0,lx1,ly1,lz1)
         enddo
         enddo
C
C        Zero out mask at Neumann-Dirichlet interfaces
C
         call dsop(bpmask,'MUL',lx1,ly1,lz1)
C
C        B-field masks
C
         if (ifstrs) then
           call stsmask (b1mask,b2mask,b3mask)
         else
C
           call rone(b1mask,ntot)
           call rone(b2mask,ntot)
           call rone(b3mask,ntot)
C
           do iel=1,nelv
           do iface=1,nfaces
              cb =cbc(iface,iel,ifield)
              call chknord (ifalgn,ifnorx,ifnory,ifnorz,iface,iel)
c
              if (cb.eq.'v  ' .or. cb.eq.'V  ' .or. cb.eq.'vl ' .or.
     $           cb.eq.'VL ' .or. cb.eq.'W  ') then
c
c               All-Dirichlet boundary conditions
c
                call facev (b1mask,iel,iface,0.0,lx1,ly1,lz1)
                call facev (b2mask,iel,iface,0.0,lx1,ly1,lz1)
                call facev (b3mask,iel,iface,0.0,lx1,ly1,lz1)
c
              elseif (cb.eq.'SYM') then
c
c               Mixed-Dirichlet-Neumann boundary conditions
c
                if ( .not.ifalgn .or. ifnorx )
     $            call facev (b1mask,iel,iface,0.0,lx1,ly1,lz1)
                if ( ifnory )
     $            call facev (b2mask,iel,iface,0.0,lx1,ly1,lz1)
                if ( ifnorz )
     $            call facev (b3mask,iel,iface,0.0,lx1,ly1,lz1)
c
              elseif (cb.eq.'ON ') then
c
c               Mixed-Dirichlet-Neumann boundary conditions
c
                if ( ifnory .or. ifnorz )
     $            call facev (b1mask,iel,iface,0.0,lx1,ly1,lz1)
                if ( .not.ifalgn .or. ifnorx .or. ifnorz )
     $            call facev (b2mask,iel,iface,0.0,lx1,ly1,lz1)
                if ( .not.ifalgn .or. ifnorx .or. ifnory )
     $            call facev (b3mask,iel,iface,0.0,lx1,ly1,lz1)
c
              elseif (cb.eq.'A  ') then
c
c               axisymmetric centerline
c
                call facev (b2mask,iel,iface,0.0,lx1,ly1,lz1)
c
              else
c
                if ( cb1(1).eq.'d' ) 
     $            call facev (b1mask,iel,iface,0.0,lx1,ly1,lz1)
                if ( cb1(2).eq.'d' ) 
     $            call facev (b2mask,iel,iface,0.0,lx1,ly1,lz1)
                if ( cb1(3).eq.'d' .and. if3d ) 
     $            call facev (b3mask,iel,iface,0.0,lx1,ly1,lz1)
c
              endif
           enddo
           enddo
c
           call dsop(b1mask,'MUL',lx1,ly1,lz1)
           call dsop(b2mask,'MUL',lx1,ly1,lz1)
           if (ldim.eq.3) call dsop(b3mask,'MUL',lx1,ly1,lz1)
         endif
      endif
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE BCDIRVC(V1,V2,V3,mask1,mask2,mask3)
C
C     Apply Dirichlet boundary conditions to surface of vector (V1,V2,V3).
C     Use IFIELD as a guide to which boundary conditions are to be applied.
C
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      INCLUDE 'INPUT'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      INCLUDE 'TOPOL'
      INCLUDE 'CTIMER'
      COMMON /SCRUZ/ TMP1(LX1,LY1,LZ1,LELV)
     $             , TMP2(LX1,LY1,LZ1,LELV)
     $             , TMP3(LX1,LY1,LZ1,LELV)
      COMMON /SCRMG/ TMQ1(LX1,LY1,LZ1,LELV)
     $             , TMQ2(LX1,LY1,LZ1,LELV)
     $             , TMQ3(LX1,LY1,LZ1,LELV)
C
      REAL V1(lx1,ly1,lz1,LELV),V2(lx1,ly1,lz1,LELV)
     $    ,V3(lx1,ly1,lz1,LELV)
      real mask1(lx1,ly1,lz1,lelv),mask2(lx1,ly1,lz1,lelv)
     $    ,mask3(lx1,ly1,lz1,lelv)
c
      common  /nekcb/ cb
      character cb*3
      character*1 cb1(3)
      equivalence (cb1,cb)
c
      logical ifonbc
c
      ifonbc = .false.
c
      if (icalld.eq.0) then
         tusbc=0.0
         nusbc=0
         icalld=icalld+1
      endif
      nusbc=nusbc+1
      etime1=dnekclock()
C
C
      NFACES=2*ldim
      NXYZ  =lx1*ly1*lz1
      NEL   =NELFLD(IFIELD)
      NTOT  =NXYZ*NEL
C
      CALL RZERO(TMP1,NTOT)
      CALL RZERO(TMP2,NTOT)
      IF (IF3D) CALL RZERO(TMP3,NTOT)
C
C     Velocity boundary conditions
C
c     write(6,*) 'BCDIRV: ifield',ifield
      DO 2100 ISWEEP=1,2
         DO 2000 IE=1,NEL
         DO 2000 IFACE=1,NFACES
            CB  = CBC(IFACE,IE,IFIELD)
            BC1 = BC(1,IFACE,IE,IFIELD)
            BC2 = BC(2,IFACE,IE,IFIELD)
            BC3 = BC(3,IFACE,IE,IFIELD)

            IF (CB.EQ.'V  ' .OR. CB.EQ.'VL '  .OR.
     $          CB.EQ.'WS ' .OR. CB.EQ.'WSL') THEN
               CALL FACEV (TMP1,IE,IFACE,BC1,lx1,ly1,lz1)
               CALL FACEV (TMP2,IE,IFACE,BC2,lx1,ly1,lz1)
               IF (IF3D) CALL FACEV (TMP3,IE,IFACE,BC3,lx1,ly1,lz1)
               IF ( IFQINP(IFACE,IE) )
     $         CALL GLOBROT (TMP1(1,1,1,IE),TMP2(1,1,1,IE),
     $                       TMP3(1,1,1,IE),IE,IFACE)
            ENDIF

            IF (CB.EQ.'v  ' .OR. CB.EQ.'vl ' .OR. 
     $          CB.EQ.'ws ' .OR. CB.EQ.'wsl' .OR.
     $          CB.EQ.'mv ' .OR. CB.EQ.'mvn' .OR.
     $          cb1(1).eq.'d'.or.cb1(2).eq.'d'.or.cb1(3).eq.'d') then

                call faceiv (cb,tmp1(1,1,1,ie),tmp2(1,1,1,ie),
     $                       tmp3(1,1,1,ie),ie,iface,lx1,ly1,lz1)

                IF ( IFQINP(IFACE,IE) )
     $          CALL GLOBROT (TMP1(1,1,1,IE),TMP2(1,1,1,IE),
     $                        TMP3(1,1,1,IE),IE,IFACE)
            ENDIF

            IF (CB.EQ.'ON ' .OR. CB.EQ.'on ') then   ! 5/21/01 pff
                ifonbc =.true.
                CALL FACEIV ('v  ',TMP1(1,1,1,IE),TMP2(1,1,1,IE),
     $                       TMP3(1,1,1,IE),IE,IFACE,lx1,ly1,lz1)
            ENDIF

 2000    CONTINUE
         DO 2010 IE=1,NEL
         DO 2010 IFACE=1,NFACES
            IF (CBC(IFACE,IE,IFIELD).EQ.'W  ') THEN
               CALL FACEV (TMP1,IE,IFACE,0.0,lx1,ly1,lz1)
               CALL FACEV (TMP2,IE,IFACE,0.0,lx1,ly1,lz1)
               IF (IF3D) CALL FACEV (TMP3,IE,IFACE,0.0,lx1,ly1,lz1)
            ENDIF
 2010    CONTINUE
C
C        Take care of Neumann-Dirichlet shared edges...
C
         if (isweep.eq.1) then
            call opdsop(tmp1,tmp2,tmp3,'MXA')
         else
            call opdsop(tmp1,tmp2,tmp3,'MNA')
         endif
 2100 CONTINUE
C
C     Copy temporary array to velocity arrays.
C
      IF ( .NOT.IFSTRS ) THEN
         CALL COL2(V1,mask1,NTOT)
         CALL COL2(V2,mask2,NTOT)
         IF (IF3D) CALL COL2(V3,mask3,NTOT)
         if (ifonbc) then
            call antimsk1(tmp1,mask1,ntot)
            call antimsk1(tmp2,mask2,ntot)
            if (if3d) call antimsk1(tmp3,mask3,ntot)
         endif
      ELSE
         CALL RMASK (V1,V2,V3,NELV)
      ENDIF

      CALL ADD2(V1,TMP1,NTOT)
      CALL ADD2(V2,TMP2,NTOT)
      IF (IF3D) CALL ADD2(V3,TMP3,NTOT)

      if (ifneknekc) call fix_surface_flux

      tusbc=tusbc+(dnekclock()-etime1)

      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE BCDIRSC(S)
C
C     Apply Dirichlet boundary conditions to surface of scalar, S.
C     Use IFIELD as a guide to which boundary conditions are to be applied.
C
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
      INCLUDE 'TOPOL'
      INCLUDE 'CTIMER'
C
      DIMENSION S(LX1,LY1,LZ1,LELT)
      COMMON /SCRSF/ TMP(LX1,LY1,LZ1,LELT)
     $             , TMA(LX1,LY1,LZ1,LELT)
     $             , SMU(LX1,LY1,LZ1,LELT)
      common  /nekcb/ cb
      CHARACTER CB*3

      if (icalld.eq.0) then
         tusbc=0.0
         nusbc=0
         icalld=icalld+1
      endif
      nusbc=nusbc+1
      etime1=dnekclock()
C
      IFLD   = 1
      NFACES = 2*ldim
      NXYZ   = lx1*ly1*lz1
      NEL    = NELFLD(IFIELD)
      NTOT   = NXYZ*NEL
      NFLDT  = NFIELD - 1
C
      CALL RZERO(TMP,NTOT)
C
C     Temperature boundary condition
C
      DO 2100 ISWEEP=1,2
C
         DO 2010 IE=1,NEL
         DO 2010 IFACE=1,NFACES
            CB=CBC(IFACE,IE,IFIELD)
            BC1=BC(1,IFACE,IE,IFIELD)
            BC2=BC(2,IFACE,IE,IFIELD)
            BC3=BC(3,IFACE,IE,IFIELD)
            BC4=BC(4,IFACE,IE,IFIELD)
            BCK=BC(4,IFACE,IE,IFLD)
            BCE=BC(5,IFACE,IE,IFLD)
            IF (CB.EQ.'T  ') CALL FACEV (TMP,IE,IFACE,BC1,lx1,ly1,lz1)
            IF (CB.EQ.'MCI') CALL FACEV (TMP,IE,IFACE,BC4,lx1,ly1,lz1)
            IF (CB.EQ.'MLI') CALL FACEV (TMP,IE,IFACE,BC4,lx1,ly1,lz1)
            IF (CB.EQ.'KD ') CALL FACEV (TMP,IE,IFACE,BCK,lx1,ly1,lz1)
            IF (CB.EQ.'ED ') CALL FACEV (TMP,IE,IFACE,BCE,lx1,ly1,lz1)
            IF (CB.EQ.'t  ' .OR. CB.EQ.'kd ' .or.
     $          CB.EQ.'ed ' .or. cb.eq.'o  ' .or. cb.eq.'on ') 
     $          CALL FACEIS (CB,TMP(1,1,1,IE),IE,IFACE,lx1,ly1,lz1)
 2010    CONTINUE
C
C        Take care of Neumann-Dirichlet shared edges...
C
         IF (ISWEEP.EQ.1) CALL DSOP(TMP,'MXA',lx1,ly1,lz1)
         IF (ISWEEP.EQ.2) CALL DSOP(TMP,'MNA',lx1,ly1,lz1)
 2100 CONTINUE
C
C     Copy temporary array to temperature array.
C
      CALL COL2(S,TMASK(1,1,1,1,IFIELD-1),NTOT)
      CALL ADD2(S,TMP,NTOT)

      tusbc=tusbc+(dnekclock()-etime1)

      RETURN
      END
C
c-----------------------------------------------------------------------
      SUBROUTINE BCNEUSC(S,ITYPE)
C
C     Apply Neumann boundary conditions to surface of scalar, S.
C     Use IFIELD as a guide to which boundary conditions are to be applied.
C
C     If ITYPE = 1, then S is returned as the rhs contribution to the 
C                   volumetric flux.
C
C     If ITYPE =-1, then S is returned as the lhs contribution to the 
C                   diagonal of A.
C
C
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
      INCLUDE 'CTIMER'
      INCLUDE 'NEKUSE'
C
      DIMENSION S(LX1,LY1,LZ1,LELT)
      common  /nekcb/ cb
      CHARACTER CB*3
C
      if (icalld.eq.0) then
         tusbc=0.0
         nusbc=0
         icalld=icalld+1
      endif
      nusbc=nusbc+1
      etime1=dnekclock()
C
      NFACES=2*ldim
      NXYZ  =lx1*ly1*lz1
      NEL   =NELFLD(IFIELD)
      NTOT  =NXYZ*NEL
      CALL RZERO(S,NTOT)
C
      IF (ITYPE.EQ.-1) THEN
C
C        Compute diagonal contributions to accomodate Robin boundary conditions
C
         DO 1000 IE=1,NEL
         DO 1000 IFACE=1,NFACES
            ieg=lglel(ie)
            CB =CBC(IFACE,IE,IFIELD)
            IF (CB.EQ.'C  ' .OR. CB.EQ.'c  ' .OR.
     $          CB.EQ.'R  ' .OR. CB.EQ.'r  ') THEN
C
               IF (CB.EQ.'C  ') HC   = BC(2,IFACE,IE,IFIELD)
               IF (CB.EQ.'R  ') THEN
                                TINF = BC(1,IFACE,IE,IFIELD)
                                HRAD = BC(2,IFACE,IE,IFIELD)
               ENDIF
               IA=0
C
C IA is areal counter, assumes advancing fastest index first. (IX...IY...IZ)
C
               CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,lx1,ly1,lz1,IFACE)
               DO 100 IZ=KZ1,KZ2
               DO 100 IY=KY1,KY2
               DO 100 IX=KX1,KX2
                  IA = IA + 1
                  TS = T(IX,IY,IZ,IE,IFIELD-1)
                  IF (CB.EQ.'c  ' .OR. CB.EQ.'r  ') THEN
                     if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IE)
                     CALL USERBC  (IX,IY,IZ,IFACE,IEG)
                  ENDIF
                  IF (CB.EQ.'r  ' .OR. CB.EQ.'R  ') 
     $               HC = HRAD * (TINF**2 + TS**2) * (TINF + TS)
                  S(IX,IY,IZ,IE) = S(IX,IY,IZ,IE) +
     $               HC*AREA(IA,1,IFACE,IE)/BM1(IX,IY,IZ,IE)
  100          CONTINUE
            ENDIF
 1000    CONTINUE
      ENDIF
      IF (ITYPE.EQ.1) THEN
C
C        Add passive scalar fluxes to rhs
C
         DO 2000 IE=1,NEL
         DO 2000 IFACE=1,NFACES
            ieg=lglel(ie)
            CB =CBC(IFACE,IE,IFIELD)
            IF (CB.EQ.'F  ' .OR. CB.EQ.'f  ' .OR.
     $          CB.EQ.'C  ' .OR. CB.EQ.'c  ' .OR. 
     $          CB.EQ.'R  ' .OR. CB.EQ.'r  ' ) THEN
C
                IF (CB.EQ.'F  ') FLUX=BC(1,IFACE,IE,IFIELD)
                IF (CB.EQ.'C  ') FLUX=BC(1,IFACE,IE,IFIELD)
     $                               *BC(2,IFACE,IE,IFIELD)
                IF (CB.EQ.'R  ') THEN
                                 TINF=BC(1,IFACE,IE,IFIELD)
                                 HRAD=BC(2,IFACE,IE,IFIELD)
                ENDIF
C
C              Add local weighted flux values to rhs, S.
C
C IA is areal counter, assumes advancing fastest index first. (IX...IY...IZ)
               IA=0
               CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,lx1,ly1,lz1,IFACE)
               DO 200 IZ=KZ1,KZ2
               DO 200 IY=KY1,KY2
               DO 200 IX=KX1,KX2
                  IA = IA + 1
                  TS = T(IX,IY,IZ,IE,IFIELD-1)
                  IF (CB.EQ.'f  ') THEN
                     if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IE)
                     CALL USERBC  (IX,IY,IZ,IFACE,IEG)
                  ENDIF
                  IF (CB.EQ.'c  ') THEN
                     if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IE)
                     CALL USERBC  (IX,IY,IZ,IFACE,IEG)
                     FLUX = TINF*HC
                  ENDIF
                  IF (CB.EQ.'r  ') THEN
                     if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IE)
                     CALL USERBC  (IX,IY,IZ,IFACE,IEG)
                  ENDIF
                  IF (CB.EQ.'R  ' .OR. CB.EQ.'r  ') 
     $               FLUX = HRAD*(TINF**2 + TS**2)*(TINF + TS) * TINF
C
C                 Add computed fluxes to boundary surfaces:
C
                  S(IX,IY,IZ,IE) = S(IX,IY,IZ,IE)
     $                           + FLUX*AREA(IA,1,IFACE,IE)
  200          CONTINUE
            ENDIF
 2000    CONTINUE
      ENDIF
C
      tusbc=tusbc+(dnekclock()-etime1)
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE FACEIS (CB,S,IEL,IFACE,NX,NY,NZ)
C
C     Assign inflow boundary conditions to face(IE,IFACE)
C     for scalar S.
C
      INCLUDE 'SIZE'
      INCLUDE 'PARALLEL'
      INCLUDE 'NEKUSE'
      INCLUDE 'TSTEP'     ! ifield    11/19/2010
      INCLUDE 'SOLN'      ! tmask()   11/19/2010
C
      DIMENSION S(LX1,LY1,LZ1)
      CHARACTER CB*3
c
      common  /nekcb/ cb3
      character*3 cb3
      cb3 = cb

      ifld1 = ifield-1


C     Passive scalar term

      ieg = lglel(iel)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)

      if (cb.eq.'t  ') then
         DO 100 IZ=KZ1,KZ2                           !  11/19/2010: The tmask() screen
         DO 100 IY=KY1,KY2                           !  added here so users can leave
         DO 100 IX=KX1,KX2                           !  certain points to be Neumann,
            if (tmask(ix,iy,iz,iel,ifld1).eq.0) then !  if desired.
               if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
               CALL USERBC  (IX,IY,IZ,IFACE,IEG)
               S(IX,IY,IZ) = TEMP
            endif
  100    CONTINUE
         RETURN

      elseif (cb.eq.'o  ' .or. cb.eq.'on ') then
         DO 101 IZ=KZ1,KZ2                           !  11/19/2010: The tmask() screen
         DO 101 IY=KY1,KY2                           !  added here so users can leave
         DO 101 IX=KX1,KX2                           !  certain points to be Neumann,
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            S(IX,IY,IZ) = PA
  101    CONTINUE
         RETURN

      ELSEIF (CB.EQ.'ms ' .OR. CB.EQ.'msi') THEN

         DO 200 IZ=KZ1,KZ2
         DO 200 IY=KY1,KY2
         DO 200 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            S(IX,IY,IZ) = SIGMA
  200    CONTINUE
C
      ELSEIF (CB.EQ.'kd ') THEN
C
         DO 300 IZ=KZ1,KZ2
         DO 300 IY=KY1,KY2
         DO 300 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            S(IX,IY,IZ) = TURBK
  300    CONTINUE
C
      ELSEIF (CB.EQ.'ed ') THEN
C
         DO 400 IZ=KZ1,KZ2
         DO 400 IY=KY1,KY2
         DO 400 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            S(IX,IY,IZ) = TURBE
  400    CONTINUE
C
      ENDIF
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE FACEIV (CB,V1,V2,V3,IEL,IFACE,NX,NY,NZ)
C
C     Assign fortran function boundary conditions to 
C     face IFACE of element IEL for vector (V1,V2,V3).
C
      INCLUDE 'SIZE'
      INCLUDE 'NEKUSE'
      INCLUDE 'PARALLEL'
C
      dimension v1(nx,ny,nz),v2(nx,ny,nz),v3(nx,ny,nz)
      character cb*3
c
      character*1 cb1(3)
c
      common  /nekcb/ cb3
      character*3 cb3
      cb3 = cb
c
      call chcopy(cb1,cb,3)
c
      ieg = lglel(iel)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
C
      IF (CB.EQ.'v  ' .OR. CB.EQ.'ws ' .OR. CB.EQ.'mv '.OR. 
     $    CB.EQ.'mvn') THEN
C
         DO 100 IZ=KZ1,KZ2
         DO 100 IY=KY1,KY2
         DO 100 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            V1(IX,IY,IZ) = UX
            V2(IX,IY,IZ) = UY
            V3(IX,IY,IZ) = UZ
  100    CONTINUE
         RETURN
C
      elseif (cb1(1).eq.'d'.or.cb1(2).eq.'d'.or.cb1(3).eq.'d') then
C
         do iz=kz1,kz2
         do iy=ky1,ky2
         do ix=kx1,kx2
            if (optlevel.le.2) call nekasgn (ix,iy,iz,iel)
            call userbc  (ix,iy,iz,iface,ieg)
            if (cb1(1).eq.'d') v1(ix,iy,iz) = ux
            if (cb1(2).eq.'d') v2(ix,iy,iz) = uy
            if (cb1(3).eq.'d') v3(ix,iy,iz) = uz
         enddo
         enddo
         enddo
         return
C
      ELSEIF (CB.EQ.'vl ' .OR. CB.EQ.'wsl') THEN
C
         DO 120 IZ=KZ1,KZ2
         DO 120 IY=KY1,KY2
         DO 120 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            V1(IX,IY,IZ) = UN
            V2(IX,IY,IZ) = U1
            V3(IX,IY,IZ) = U2
  120    CONTINUE
         RETURN
C
      ELSEIF (CB.EQ.'s  ' .OR. CB.EQ.'sh ') THEN
C
         DO 200 IZ=KZ1,KZ2
         DO 200 IY=KY1,KY2
         DO 200 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            V1(IX,IY,IZ) = TRX
            V2(IX,IY,IZ) = TRY
            V3(IX,IY,IZ) = TRZ
  200    CONTINUE
         RETURN
C
      ELSEIF (CB.EQ.'sl ' .OR. CB.EQ.'shl') THEN
C
         DO 220 IZ=KZ1,KZ2
         DO 220 IY=KY1,KY2
         DO 220 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            V1(IX,IY,IZ) = TRN
            V2(IX,IY,IZ) = TR1
            V3(IX,IY,IZ) = TR2
  220    CONTINUE
C
      ELSEIF (CB.EQ.'ms ') THEN
C
         DO 240 IZ=KZ1,KZ2
         DO 240 IY=KY1,KY2
         DO 240 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            V1(IX,IY,IZ) = -PA
            V2(IX,IY,IZ) = TR1
            V3(IX,IY,IZ) = TR2
  240    CONTINUE
C
      ELSEIF (CB.EQ.'on ' .OR. CB.EQ.'o  ') THEN
C
         DO 270 IZ=KZ1,KZ2
         DO 270 IY=KY1,KY2
         DO 270 IX=KX1,KX2
            if (optlevel.le.2) CALL NEKASGN (IX,IY,IZ,IEL)
            CALL USERBC  (IX,IY,IZ,IFACE,IEG)
            V1(IX,IY,IZ) = -PA
            V2(IX,IY,IZ) = 0.0
            V3(IX,IY,IZ) = 0.0
  270    CONTINUE
C
      ENDIF
C
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine nekasgn (ix,iy,iz,e)
C
C     Assign NEKTON variables for definition (by user) of
C     boundary conditions at collocation point (IX,IY,IZ)
C     of element IEL.
C
C       X             X-coordinate
C       Y             Y-coordinate
C       Z             Z-coordinate
C       UX            X-velocity
C       UY            Y-velocity
C       UZ            Z-velocity
C       TEMP          Temperature
C       PS1           Passive scalar No. 1
C       PS2           Passive scalar No. 2
C        .             .
C        .             .
C       PS9           Passive scalar No. 9
C       SI2           Strainrate invariant II
C       SI3           Strainrate invariant III
C
C     Variables to be defined by user for imposition of
C     boundary conditions :
C
C       SH1           Shear component No. 1
C       SH2           Shear component No. 2
C       TRX           X-traction
C       TRY           Y-traction
C       TRZ           Z-traction
C       SIGMA         Surface-tension coefficient
C       FLUX          Flux
C       HC            Convection heat transfer coefficient
C       HRAD          Radiation  heat transfer coefficient
C       TINF          Temperature at infinity
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      INCLUDE 'NEKUSE'

      integer e

      common  /nekcb/ cb
      character cb*3

      COMMON /SCREV / SII (LX1,LY1,LZ1,LELT)
     $              , SIII(LX1,LY1,LZ1,LELT)

      x     = xm1(ix,iy,iz,e)
      y     = ym1(ix,iy,iz,e)
      z     = zm1(ix,iy,iz,e)

      r     = x**2+y**2
      if (r.gt.0.0) r=sqrt(r)
      if (x.ne.0.0 .or. y.ne.0.0) theta = atan2(y,x)

      ux    = vx(ix,iy,iz,e)
      uy    = vy(ix,iy,iz,e)
      uz    = vz(ix,iy,iz,e)
      temp  = t(ix,iy,iz,e,1)
      do ips=1,npscal
         ps(ips) = t(ix,iy,iz,e,ips+1)
      enddo

      pa = pr(ix,iy,iz,e)
      p0 = p0th

      si2   = sii (ix,iy,iz,e)
      si3   = siii(ix,iy,iz,e)
      udiff = vdiff (ix,iy,iz,e,ifield)
      utrans= vtrans(ix,iy,iz,e,ifield)

      cbu   = cb

      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE BCNEUTR
C
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      COMMON /SCRSF/ TRX(LX1,LY1,LZ1)
     $             , TRY(LX1,LY1,LZ1)
     $             , TRZ(LX1,LY1,LZ1)
      COMMON /CTMP0/ STC(LX1,LY1,LZ1)
      REAL SIGST(LX1,LY1)
C
      LOGICAL IFALGN,IFNORX,IFNORY,IFNORZ
      common  /nekcb/ cb
      CHARACTER CB*3
C
      IFLD  = 1
      NFACE = 2*ldim
      NXY1  = lx1*ly1
      NXYZ1 = lx1*ly1*lz1
C
      DO 100 IEL=1,NELV
      DO 100 IFC=1,NFACE
C
         CB  = CBC (IFC,IEL,IFLD)
         BC1 = BC(1,IFC,IEL,IFLD)
         BC2 = BC(2,IFC,IEL,IFLD)
         BC3 = BC(3,IFC,IEL,IFLD)
         BC4 = BC(4,IFC,IEL,IFLD)
         CALL RZERO3 (TRX,TRY,TRZ,NXYZ1)
C
C        Prescribed tractions and shear tractions
C
         IF (CB.EQ.'S  ' .OR. CB.EQ.'SL ' .OR.
     $       CB.EQ.'SH ' .OR. CB.EQ.'SHL' ) THEN
             CALL TRCON (TRX,TRY,TRZ,BC1,BC2,BC3,IEL,IFC)
             IF (IFQINP(IFC,IEL)) CALL GLOBROT (TRX,TRY,TRZ,IEL,IFC)
             GOTO 120
         ENDIF
         IF (CB.EQ.'s  ' .OR. CB.EQ.'sl ' .OR.
     $       CB.EQ.'sh ' .OR. CB.EQ.'shl' ) THEN
             CALL FACEIV (CB,TRX,TRY,TRZ,IEL,IFC,lx1,ly1,lz1)
             CALL FACCVS (TRX,TRY,TRZ,AREA(1,1,IFC,IEL),IFC)
             IF (IFQINP(IFC,IEL)) CALL GLOBROT (TRX,TRY,TRZ,IEL,IFC)
             GOTO 120
         ENDIF
C
C        Prescribed outflow ambient pressure
C
         IF (CB.EQ.'ON ' .OR. CB.EQ.'O  ') THEN
             BCN = -BC1
             BC2 =  0.0
             BC3 =  0.0
             CALL TRCON   (TRX,TRY,TRZ,BCN,BC2,BC3,IEL,IFC)
             CALL GLOBROT (TRX,TRY,TRZ,IEL,IFC)
             GOTO 120
         ENDIF
         IF (CB.EQ.'on ' .OR. CB.EQ.'o  ') THEN
             CALL FACEIV  (CB,TRX,TRY,TRZ,IEL,IFC,lx1,ly1,lz1)
             CALL FACCVS  (TRX,TRY,TRZ,AREA(1,1,IFC,IEL),IFC)
             CALL GLOBROT (TRX,TRY,TRZ,IEL,IFC)
             GOTO 120
         ENDIF
C
C     Surface-tension
C
         IF (CB.EQ.'MS ' .OR. CB.EQ.'MSI' .OR.
     $       CB.EQ.'MM ' .OR. CB.EQ.'mm ' .OR.
     $       CB.EQ.'ms ' .OR. CB.EQ.'msi') THEN
             IF (CB.EQ.'MS '.or.cb.eq.'MM ') THEN
                BCN = -BC1
                CALL TRCON   (TRX,TRY,TRZ,BCN,BC2,BC3,IEL,IFC)
                CALL GLOBROT (TRX,TRY,TRZ,IEL,IFC)
             ENDIF
c            IF (CB.EQ.'ms '.or.cb.eq.'mm ') THEN
             IF (CB.EQ.'ms '.or.cb.eq.'msi') THEN
                CALL FACEIV  (CB,TRX,TRY,TRZ,IEL,IFC,lx1,ly1,lz1)
                CALL FACCVS  (TRX,TRY,TRZ,AREA(1,1,IFC,IEL),IFC)
                CALL GLOBROT (TRX,TRY,TRZ,IEL,IFC)
             ENDIF
             IF (CB(1:1).EQ.'M') THEN
                CALL CFILL  (SIGST,BC4,NXY1)
             ELSE
                CALL FACEIS (CB,STC,IEL,IFC,lx1,ly1,lz1)
                CALL FACEXS (SIGST,STC,IFC,0)
             ENDIF
             IF (IFAXIS) THEN
                CALL TRSTAX (TRX,TRY,SIGST,IEL,IFC)
             ELSEIF (ldim.EQ.2) THEN
                CALL TRST2D (TRX,TRY,SIGST,IEL,IFC)
             ELSE
                CALL TRST3D (TRX,TRY,TRZ,SIGST,IEL,IFC)
             ENDIF
         ENDIF
C
  120    CALL ADD2 (BFX(1,1,1,IEL),TRX,NXYZ1)
         CALL ADD2 (BFY(1,1,1,IEL),TRY,NXYZ1)
         IF (ldim.EQ.3) CALL ADD2 (BFZ(1,1,1,IEL),TRZ,NXYZ1)
C
  100 CONTINUE
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE TRCON (TRX,TRY,TRZ,TR1,TR2,TR3,IEL,IFC)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TOPOL'
C
      DIMENSION TRX(LX1,LY1,LZ1)
     $        , TRY(LX1,LY1,LZ1)
     $        , TRZ(LX1,LY1,LZ1)
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFC)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
      I = 0
C
      IF (ldim.EQ.2) THEN
         DO 100 J2=JS2,JF2,JSKIP2
         DO 100 J1=JS1,JF1,JSKIP1
            I = I + 1
            TRX(J1,J2,1) = TR1*AREA(I,1,IFC,IEL)
            TRY(J1,J2,1) = TR2*AREA(I,1,IFC,IEL)
  100    CONTINUE
      ELSE
         DO 200 J2=JS2,JF2,JSKIP2
         DO 200 J1=JS1,JF1,JSKIP1
            I = I + 1
            TRX(J1,J2,1) = TR1*AREA(I,1,IFC,IEL)
            TRY(J1,J2,1) = TR2*AREA(I,1,IFC,IEL)
            TRZ(J1,J2,1) = TR3*AREA(I,1,IFC,IEL)
  200    CONTINUE
      ENDIF
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE TRST2D (TRX,TRY,SIGST,IEL,IFC)
C
C     Compute taction due to surface tension (2D)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'DXYZ'
      INCLUDE 'TOPOL'
      INCLUDE 'WZ'
      COMMON /CTMP1/ A1X(LX1),A1Y(LX1),STX(LX1),STY(LX1)
C
      DIMENSION TRX(LX1,LY1,LZ1),TRY(LX1,LY1,LZ1),SIGST(LX1,1)
      DIMENSION CANG(2),SANG(2)
      DIMENSION IXN(2),IYN(2),IAN(2)
C
      DO 100 IX=1,lx1
         AA = SIGST(IX,1) * WXM1(IX)
         STX(IX) = T1X(IX,1,IFC,IEL) * AA
         STY(IX) = T1Y(IX,1,IFC,IEL) * AA
  100 CONTINUE
C 
      IF (IFC.EQ.3 .OR. IFC.EQ.4) THEN
         CALL CHSIGN (STX,lx1)
         CALL CHSIGN (STY,lx1)
      ENDIF
C
      IF (IFC.EQ.1 .OR. IFC.EQ.3) THEN
         CALL MXM (DXTM1,lx1,STX,lx1,A1X,1)
         CALL MXM (DXTM1,lx1,STY,lx1,A1Y,1)
      ELSE
         CALL MXM (DYTM1,ly1,STX,ly1,A1X,1)
         CALL MXM (DYTM1,ly1,STY,ly1,A1Y,1)
      ENDIF
C
      CALL DSSET (lx1,ly1,lz1)
      IFACE  = EFACE1(IFC)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
      I = 0
C
      DO 200 J2=JS2,JF2,JSKIP2
      DO 200 J1=JS1,JF1,JSKIP1
         I = I + 1
         TRX(J1,J2,1) = TRX(J1,J2,1) - A1X(I)
         TRY(J1,J2,1) = TRY(J1,J2,1) - A1Y(I)
  200 CONTINUE
C
C     Contact angle corrections
C
      CALL CTANG2D (CANG,SANG,IXN,IYN,IAN,IFC,IEL)
      DO 500 I=1,2
         IX = IXN(I)
         IY = IYN(I)
         IA = IAN(I)
         TRX(IX,IY,1)=TRX(IX,IY,1) + SIGST(IA,1)*CANG(I)
         TRY(IX,IY,1)=TRY(IX,IY,1) + SIGST(IA,1)*SANG(I)
  500 CONTINUE
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE TRSTAX (TRX,TRY,SIGST,IEL,IFC)
C
C     Compute taction due to surface tension (axisymmetric)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'DXYZ'
      INCLUDE 'TOPOL'
      INCLUDE 'WZ'
      COMMON /CTMP1/ A1X(LX1),A1Y(LX1),A2X(LX1),A2Y(LX1)
     $             , STX(LX1),STY(LX1),XJM1(LX1)
      COMMON /CTMP0/ XFM1(LX1),YFM1(LX1),T1XF(LX1),T1YF(LX1)
C
      DIMENSION TRX(LX1,LY1,LZ1),TRY(LX1,LY1,LZ1),SIGST(LX1,LY1)
      DIMENSION CANG(2),SANG(2)
      DIMENSION IXN(2),IYN(2),IAN(2)
      LOGICAL IFGLJ
C
      IFGLJ = .FALSE.
      IF ( IFRZER(IEL) .AND. (IFC.EQ.2 .OR. IFC.EQ.4) ) IFGLJ = .TRUE.
      CALL FACEC2 (XFM1,YFM1,XM1(1,1,1,IEL),YM1(1,1,1,IEL),IFC)
C
      IF (IFGLJ) THEN
         CALL MXM (DAM1,ly1,XFM1,ly1,T1XF,1)
         CALL MXM (DAM1,ly1,YFM1,ly1,T1YF,1)
         YS0 = T1YF(1)
      ELSE
         CALL MXM (DXM1,lx1,XFM1,lx1,T1XF,1)
         CALL MXM (DXM1,lx1,YFM1,lx1,T1YF,1)
      ENDIF
C
      DO 10 IX=1,lx1
         XJM1(IX)=SQRT( T1XF(IX)**2 + T1YF(IX)**2 )
         T1XF(IX)=T1XF(IX) / XJM1(IX)
         T1YF(IX)=T1YF(IX) / XJM1(IX)
   10 CONTINUE
C
      IF ( IFGLJ ) THEN
         CALL MXM (DAM1,1,T1XF,ly1,T1XS0,1)
         CALL MXM (DAM1,1,UNY(1,1,IFC,IEL),ly1,UNYS0,1)
         DDX    = WAM1(1)*SIGST(1,1)*T1XS0*YS0
         DDY    = WAM1(1)*SIGST(1,1)*T1YF(1)*YS0*2.0
         A2X(1) = WAM1(1)*SIGST(1,1)*XJM1(1)*UNX(1,1,IFC,IEL)*UNYS0
         A2Y(1) = 0.0
         STX(1) = 0.0
         STY(1) = 0.0
         DO 100 IY=2,ly1
            AA = WAM1(IY) * SIGST(IY,1) / (1.0 + ZAM1(IY))
            STX(IY) = T1XF(IY) * AA
            STY(IY) = T1YF(IY) * AA
            AA = AA * XJM1(IY) * UNY(IY,1,IFC,IEL)
            A2X(IY) = UNX(IY,1,IFC,IEL) * AA
            A2Y(IY) = UNY(IY,1,IFC,IEL) * AA
  100    CONTINUE
      ELSE
         DO 200 IX=1,lx1
            AA = SIGST(IX,1) * WXM1(IX)
            STX(IX) = T1XF(IX) * AA
            STY(IX) = T1YF(IX) * AA
            AA = AA * XJM1(IX) * UNY(IX,1,IFC,IEL)
            A2X(IX) = UNX(IX,1,IFC,IEL) * AA
            A2Y(IX) = UNY(IX,1,IFC,IEL) * AA
  200    CONTINUE
      ENDIF
C
      IF (IFGLJ) THEN
         DO 220 IY=1,ly1
            YSIY = T1YF(IY)*XJM1(IY)
            DTX1 = 0.0
            DTY1 = DATM1(IY,1)*DDY
            DTX2 = YSIY*STX(IY)
            DTY2 = YSIY*STY(IY)
            DTY3 = 0.0
            DO 240 J=2,ly1
               DTYS = DATM1(IY,J)*YFM1(J)
               DTX1 = DTX1 + DTYS*STX(J)
               DTY3 = DTY3 + DTYS*STY(J)
  240       CONTINUE
            A1X(IY) = DTX1 + DTX2
            A1Y(IY) = DTY1 + DTY2 + DTY3
  220    CONTINUE
            A1X(1)  = A1X(1) + DDX
      ELSE
         CALL MXM  (DXTM1,lx1,STX,lx1,A1X,1)
         CALL MXM  (DXTM1,lx1,STY,lx1,A1Y,1)
         CALL COL2 (A1X,YFM1,lx1)
         CALL COL2 (A1Y,YFM1,lx1)
      ENDIF
C
      CALL DSSET (lx1,ly1,lz1)
      IFACE  = EFACE1(IFC)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
      I = 0
C
      DO 300 J2=JS2,JF2,JSKIP2
      DO 300 J1=JS1,JF1,JSKIP1
         I  = I + 1
         TRX(J1,J2,1) = TRX(J1,J2,1) - A2X(I) - A1X(I)
         TRY(J1,J2,1) = TRY(J1,J2,1) - A2Y(I) - A1Y(I)
  300 CONTINUE
C
C     Contact angle corrections
C
      CALL CTANG2D (CANG,SANG,IXN,IYN,IAN,IFC,IEL)
      DO 500 I=1,2
         IX = IXN(I)
         IY = IYN(I)
         IA = IAN(I)
         AA = SIGST(IA,1)*YM1(IX,IY,1,IEL)
         TRX(IX,IY,1)=TRX(IX,IY,1) + AA*CANG(I)
         TRY(IX,IY,1)=TRY(IX,IY,1) + AA*SANG(I)
  500 CONTINUE
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE CTANG2D (CANG,SANG,IXN,IYN,IAN,IFC,IEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      INCLUDE 'INPUT'
C
      DIMENSION CANG(2),SANG(2)
      DIMENSION IXN(2),IYN(2),IAN(2),ISN(2),NEBPT(4,2)
      CHARACTER CBN*3
C
      DATA NEBPT /4,1,2,3, 2,3,4,1/
      IFLD = 1
      EPS  = 1.e-6
C
      DO 100 I=1,2
         IFCN    = NEBPT(IFC,I)
         CBN     = CBC(IFCN,IEL,IFLD)
         IXN(I)  = 1
         IYN(I)  = 1
         IAN(I)  = 1
         ISN(I)  = 1
         CANG(I) = 0.0
         SANG(I) = 0.0
         IF (CBN.EQ.'E  '.OR.CBN.EQ.'P  '.OR.cbn.eq.'p  '.or.
     $       CBN(1:1).EQ.'M' .OR. CBN(1:1).EQ.'m') GOTO 100
         NC = IFC
         IF (I.EQ.2) NC=IFCN
         IF (NC  .EQ.2 .OR. NC  .EQ.3) IXN(I) = lx1
         IF (NC  .EQ.3 .OR. NC  .EQ.4) IYN(I) = ly1
         IF (IFC .EQ.2 .OR. IFC .EQ.3) ISN(I) = lx1
         IF (IFCN.EQ.2 .OR. IFCN.EQ.3) IAN(I) = lx1
         IX = IXN(I)
         IY = IYN(I)
         IA = IAN(I)
         IS = ISN(I)
         IF (CBN(1:1).EQ.'V'   .OR. CBN(1:1).EQ.'v'   .OR. 
     $       CBN     .EQ.'S  ' .OR. CBN     .EQ.'s  ' .OR. 
     $       CBN     .EQ.'SL ' .OR. CBN     .EQ.'sl ' .OR. 
     $       CBN(1:1).EQ.'O'   .OR. CBN(1:1).EQ.'o' ) THEN
             UX=VX(IX,IY,1,IEL)
             UY=VY(IX,IY,1,IEL)
             UM=UX**2 + UY**2
             IF (UM.GT.EPS) THEN
                 UNLX=UNX(IS,1,IFCN,IEL)
                 UNLY=UNY(IS,1,IFCN,IEL)
                 UM=SQRT(UM)
                 DOT =UX*UNLX + UY*UNLY
                 IF (DOT.LT.0.0) UM=-UM
                 CANG(I)=UX/UM
                 SANG(I)=UY/UM
                 GOTO 100
             ENDIF
         ENDIF
         CANG(I)=UNX(IS,1,IFCN,IEL)
         SANG(I)=UNY(IS,1,IFCN,IEL)
  100 CONTINUE
C
      RETURN      
      END
c-----------------------------------------------------------------------
      SUBROUTINE TRST3D (TRX,TRY,TRZ,SIGST,IEL,IFC)
C
C     Compute taction due to surface tension (3D)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'WZ'
      COMMON /CTMP0/  XFM1(LX1,LY1),YFM1(LX1,LY1),ZFM1(LX1,LY1)
      COMMON /CTMP1/  DRM1(LX1,LX1),DRTM1(LX1,LY1)
     $             ,  DSM1(LX1,LX1),DSTM1(LX1,LY1)
     $             ,  WGS(LX1,LY1)
      COMMON /SCRMG/  XRM1(LX1,LY1),YRM1(LX1,LY1),ZRM1(LX1,LY1)
     $             ,  XSM1(LX1,LY1),YSM1(LX1,LY1),ZSM1(LX1,LY1)
      COMMON /SCRUZ/  S1X(LX1,LY1),S1Y(LX1,LY1),S1Z(LX1,LY1)
     $             ,  S2X(LX1,LY1),S2Y(LX1,LY1),S2Z(LX1,LY1)
      COMMON /SCRNS/  G1X(LX1,LY1),G1Y(LX1,LY1),G1Z(LX1,LY1)
     $             ,  G2X(LX1,LY1),G2Y(LX1,LY1),G2Z(LX1,LY1)
     $             ,  GBS(LX1,LY1),GB1L(LX1,LY1),GB2L(LX1,LY1)
C
      DIMENSION TRX(LX1,LY1,LZ1),TRY(LX1,LY1,LZ1),TRZ(LX1,LY1,LZ1)
      DIMENSION SIGST(LX1,LY1)
C
      NXY1 = lx1*ly1
C
      CALL RZERO3 (S1X,S1Y,S1Z,NXY1)
      CALL RZERO3 (S2X,S2Y,S2Z,NXY1)
      CALL FACEXV (XFM1,YFM1,ZFM1,XM1(1,1,1,IEL),YM1(1,1,1,IEL),
     $             ZM1(1,1,1,IEL),IFC,0)
      CALL SETDRS (DRM1,DRTM1,DSM1,DSTM1,IFC)
C
      CALL MXM (DRM1,lx1, XFM1,lx1,XRM1,ly1)
      CALL MXM (DRM1,lx1, YFM1,lx1,YRM1,ly1)
      CALL MXM (DRM1,lx1, ZFM1,lx1,ZRM1,ly1)
      CALL MXM (XFM1,lx1,DSTM1,ly1,XSM1,ly1)
      CALL MXM (YFM1,lx1,DSTM1,ly1,YSM1,ly1)
      CALL MXM (ZFM1,lx1,DSTM1,ly1,ZSM1,ly1)
C
      DO 100 IX=1,lx1
      DO 100 IY=1,ly1
         GB1X=XRM1(IX,IY)
         GB1Y=YRM1(IX,IY)
         GB1Z=ZRM1(IX,IY)
         GB2X=XSM1(IX,IY)
         GB2Y=YSM1(IX,IY)
         GB2Z=ZSM1(IX,IY)
         GB11=GB1X*GB1X + GB1Y*GB1Y + GB1Z*GB1Z
         GB12=GB1X*GB2X + GB1Y*GB2Y + GB1Z*GB2Z
         GB22=GB2X*GB2X + GB2Y*GB2Y + GB2Z*GB2Z
         GDET=GB11*GB22 - GB12*GB12
         IF (GDET .LT. 1.E-20) GO TO 9001
         GT11= GB22/GDET
         GT12=-GB12/GDET
         GT22= GB11/GDET
         GB1L(IX,IY)=SQRT(GB11)
         GB2L(IX,IY)=SQRT(GB22)
         GBS (IX,IY)=SQRT(GDET)
         WGS (IX,IY)=WXM1(IX)*WYM1(IY)*SIGST(IX,IY)
         BB = GBS(IX,IY) * WGS(IX,IY)
         G1X(IX,IY) = BB * ( GT11*GB1X + GT12*GB2X )
         G1Y(IX,IY) = BB * ( GT11*GB1Y + GT12*GB2Y )
         G1Z(IX,IY) = BB * ( GT11*GB1Z + GT12*GB2Z )
         G2X(IX,IY) = BB * ( GT12*GB1X + GT22*GB2X )
         G2Y(IX,IY) = BB * ( GT12*GB1Y + GT22*GB2Y )
         G2Z(IX,IY) = BB * ( GT12*GB1Z + GT22*GB2Z )
  100    CONTINUE
C
      CALL MXM (DRTM1,lx1,G1X,lx1,S1X,ly1)
      CALL MXM (DRTM1,lx1,G1Y,lx1,S1Y,ly1)
      CALL MXM (DRTM1,lx1,G1Z,lx1,S1Z,ly1)
C
      CALL MXM (G2X,lx1,DSM1,ly1,S2X,ly1)
      CALL MXM (G2Y,lx1,DSM1,ly1,S2Y,ly1)
      CALL MXM (G2Z,lx1,DSM1,ly1,S2Z,ly1)
C
      CALL ADD2 (S1X,S2X,NXY1)
      CALL ADD2 (S1Y,S2Y,NXY1)
      CALL ADD2 (S1Z,S2Z,NXY1)
C
C     Contact angle option on hold
C
C      ICONTAC=INT(BC2)
C      IF (ICONTAC.NE.0) THEN
C         IX=1
C         IY=1
C         IF (ICONTAC.GE.3) IY=ly1
C         IF (ICONTAC.EQ.2 .OR. ICONTAC.EQ.3) IX=lx1
C         ANG = BC3 * PI / 180.00
C         RR  = YM1(IX,IY,IZ,IEL)
C         TRX(IX,IY,IZ)=TRX(IX,IY,IZ) + RR*SIGST*COS( ANG )
C         TRY(IX,IY,IZ)=TRY(IX,IY,IZ) + RR*SIGST*SIN( ANG )
C      ENDIF
C
      CALL FACSUB2 (TRX,TRY,TRZ,S1X,S1Y,S1Z,IFC)
C
      RETURN
C
 9001 WRITE ( 6,*) 'Zero area for Element=',IEL,'    Face=',IFC
      call exitt
C
      END
c-----------------------------------------------------------------------
      SUBROUTINE SETDRS (DRM1,DRTM1,DSM1,DSTM1,IFC)
C
      INCLUDE 'SIZE'
      INCLUDE 'DXYZ'
C
      DIMENSION DRM1(LX1,LX1),DRTM1(LX1,LX1)
     $        , DSM1(LY1,LY1),DSTM1(LY1,LY1)
C
      NXY1=lx1*ly1
C
      IF (IFC.EQ.5 .OR. IFC.EQ.6) THEN
         CALL COPY (DRM1 ,DXM1 ,NXY1)
         CALL COPY (DSM1 ,DYM1 ,NXY1)
         CALL COPY (DRTM1,DXTM1,NXY1)
         CALL COPY (DSTM1,DYTM1,NXY1)
      ELSEIF (IFC.EQ.2 .OR. IFC.EQ.4) THEN
         CALL COPY (DRM1 ,DYM1 ,NXY1)
         CALL COPY (DSM1 ,DZM1 ,NXY1)
         CALL COPY (DRTM1,DYTM1,NXY1)
         CALL COPY (DSTM1,DZTM1 ,NXY1)
      ELSE     
         CALL COPY (DRM1 ,DZM1 ,NXY1)
         CALL COPY (DSM1 ,DXM1 ,NXY1)
         CALL COPY (DRTM1,DZTM1,NXY1)
         CALL COPY (DSTM1,DXTM1,NXY1)
      ENDIF
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE GLOBROT (R1,R2,R3,IEL,IFC)
C
C     Rotate vector components R1,R2,R3 at face IFC 
C     of element IEL from local to global system.
C
C     R1, R2, R3 have the (NX,NY,NZ) data structure
C     IFACE1 is in the preprocessor notation 
C     IFACE  is the dssum notation.
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TOPOL'
C
      DIMENSION R1(LX1,LY1,LZ1)
     $        , R2(LX1,LY1,LZ1)
     $        , R3(LX1,LY1,LZ1)
C
      CALL DSSET (lx1,ly1,lz1)
      IFACE  = EFACE1(IFC)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
      I = 0
C
      IF (ldim.EQ.2) THEN
         DO 200 J2=JS2,JF2,JSKIP2
         DO 200 J1=JS1,JF1,JSKIP1
            I = I+1
            RNORL = R1(J1,J2,1)
            RTAN1 = R2(J1,J2,1)
            R1(J1,J2,1) = RNORL*UNX(I,1,IFC,IEL) +
     $                    RTAN1*T1X(I,1,IFC,IEL)
            R2(J1,J2,1) = RNORL*UNY(I,1,IFC,IEL) +
     $                    RTAN1*T1Y(I,1,IFC,IEL)
  200    CONTINUE
      ELSE
         DO 300 J2=JS2,JF2,JSKIP2
         DO 300 J1=JS1,JF1,JSKIP1
            I = I+1
            RNORL = R1(J1,J2,1)    
            RTAN1 = R2(J1,J2,1)    
            RTAN2 = R3(J1,J2,1)    
            R1(J1,J2,1) = RNORL*UNX(I,1,IFC,IEL) +
     $                    RTAN1*T1X(I,1,IFC,IEL) +
     $                    RTAN2*T2X(I,1,IFC,IEL)
            R2(J1,J2,1) = RNORL*UNY(I,1,IFC,IEL) +
     $                    RTAN1*T1Y(I,1,IFC,IEL) +
     $                    RTAN2*T2Y(I,1,IFC,IEL)
            R3(J1,J2,1) = RNORL*UNZ(I,1,IFC,IEL) +
     $                    RTAN1*T1Z(I,1,IFC,IEL) +
     $                    RTAN2*T2Z(I,1,IFC,IEL)
  300       CONTINUE
         ENDIF
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE FACEC2 (A1,A2,B1,B2,IFC)
C
C     2-D Geometry only
C     Extract A1,A2 from B1,B2 on surface IFC.
C
C     A1, A2 have the (lx1,  1,NFACE) data structure
C     B1, B2 have the (lx1,ly1,    1) data structure
C
      INCLUDE 'SIZE'
C
      DIMENSION A1(LX1),A2(LX1),B1(LX1,LY1),B2(LX1,LY1)
C
      IX=1
      IY=1
      IF (IFC.EQ.1 .OR. IFC.EQ.3) THEN
         IF (IFC.EQ.3) IY = ly1
         DO 10 IX=1,lx1
            A1(IX)=B1(IX,IY)
            A2(IX)=B2(IX,IY)
   10    CONTINUE
      ELSE
         IF (IFC.EQ.2) IX = lx1
         DO 20 IY=1,ly1
            A1(IY)=B1(IX,IY)
            A2(IY)=B2(IX,IY)
   20   CONTINUE
      ENDIF
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE LFALSE (IFA,N)
      LOGICAL IFA(1)
      DO 100 I=1,N
      IFA(I)=.FALSE.
  100 CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE RZERO3 (A,B,C,N)
      DIMENSION A(1),B(1),C(1)
      DO 100 I=1,N
         A(I)=0.0
         B(I)=0.0
         C(I)=0.0
  100 CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE UNITVEC (X,Y,Z,N)
      DIMENSION X(1),Y(1),Z(1)
      DO 100 I=1,N
      XLNGTH = SQRT( X(I)**2 + Y(I)**2 + Z(I)**2 )
      IF (XLNGTH.NE.0.0) THEN
         X(I) = X(I)/XLNGTH
         Y(I) = Y(I)/XLNGTH
         Z(I) = Z(I)/XLNGTH
      ENDIF
  100 CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE CHKZVN (VMAX,IEL,IFC,IVNORL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      COMMON /SCRMG/ V1(LX1,LY1,LZ1,LELV)
     $             , V2(LX1,LY1,LZ1,LELV)
     $             , V3(LX1,LY1,LZ1,LELV)
     $             , VV(LX1,LY1,LZ1,LELV)
C
      NXZ1  = lx1*lz1
      TOLV  = 0.01*VMAX
C
      VNOR1 = FACDOT(V1(1,1,1,IEL),UNX(1,1,IFC,IEL),IFC)
      VNOR2 = FACDOT(V2(1,1,1,IEL),UNY(1,1,IFC,IEL),IFC)
      VNOR  = VNOR1 + VNOR2
      IF (ldim.EQ.3) THEN
          VNOR3 = FACDOT(V3(1,1,1,IEL),UNZ(1,1,IFC,IEL),IFC)
          VNOR  = VNOR + VNOR3
      ENDIF
      VNOR = ABS(VNOR) / NXZ1
C
      IVNORL = 1
      IF (VNOR .LT. TOLV) IVNORL = 0
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE BCTWALL (TMP1,TMP2,TMP3)
C
C     Apply Dirichlet boundary conditions to surface of vector (V1,V2,V3)
C     (No antimask operation is applied).
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
C
      DIMENSION TMP1(lx1,ly1,lz1,1)
     $        , TMP2(lx1,ly1,lz1,1)
     $        , TMP3(lx1,ly1,lz1,1)
      common  /nekcb/ cb
      CHARACTER CB*3
C
      NFACE = 2*ldim
      NTOT1 = lx1*ly1*lz1*NELV
C
      CALL RZERO (TMP1,NTOT1)
      CALL RZERO (TMP2,NTOT1)
      IF (IF3D) CALL RZERO (TMP3,NTOT1)
C
      DO 2000 IEL=1,NELV
      DO 2000 IFC=1,NFACE
         CB  = CBC (IFC,IEL,IFIELD)
         BC1 = BC(1,IFC,IEL,IFIELD)
         BC2 = BC(2,IFC,IEL,IFIELD)
         BC3 = BC(3,IFC,IEL,IFIELD)
         IF (CB.EQ.'V  ' .OR. CB.EQ.'VL '  .OR.
     $       CB.EQ.'WS ' .OR. CB.EQ.'WSL') THEN
             CALL FACEV (TMP1,IEL,IFC,BC1,lx1,ly1,lz1)
             CALL FACEV (TMP2,IEL,IFC,BC2,lx1,ly1,lz1)
             IF (ldim.EQ.3) CALL FACEV (TMP3,IEL,IFC,BC3,lx1,ly1,lz1)
             IF (CB.EQ.'VL ' .OR. CB.EQ.'WSL')
     $       CALL GLOBROT (TMP1(1,1,1,IEL),TMP2(1,1,1,IEL),
     $                     TMP3(1,1,1,IEL),IEL,IFC)
         ENDIF
         IF (CB.EQ.'v  ' .OR. CB.EQ.'vl ' .OR. 
     $       CB.EQ.'ws ' .OR. CB.EQ.'wsl' .OR.
     $       CB.EQ.'mv ' .OR. CB.EQ.'mvn') THEN
             CALL FACEIV (CB,TMP1(1,1,1,IEL),TMP2(1,1,1,IEL),
     $                    TMP3(1,1,1,IEL),IEL,IFC,lx1,ly1,lz1)
             IF (CB.EQ.'vl ' .OR. CB.EQ.'wsl')
     $       CALL GLOBROT (TMP1(1,1,1,IEL),TMP2(1,1,1,IEL),
     $                     TMP3(1,1,1,IEL),IEL,IFC)
         ENDIF
 2000 CONTINUE
C
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE ANTIMSK1(X,XMASK,N)
C------------------------------------------------------------------
C
C     Return only Dirichlet boundary values of X
C
C-------------------------------------------------------------------
      REAL  X(1),XMASK(1)
      include 'OPCTR'
C
      DO 100 I=1,N
         X(I) = X(I)*(1.-XMASK(I))
 100  CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine check_cyclic  ! check for cyclic bcs
      include 'SIZE'
      include 'TOTAL'

      common /scrmg/ v1(lx1,ly1,lz1,lelt)
     $             , v2(lx1,ly1,lz1,lelt)
     $             , v3(lx1,ly1,lz1,lelt)

      integer e,f

      nface = 2*ldim

      n = lx1*ly1*lz1*nelt
      call rzero(v1,n)
      call rzero(v2,n)
      call rzero(v3,n)

      ifield = 1
      do e=1,nelt   ! possibly U or B field
      do f=1,nface

         if (cbc(f,e,ifield).eq.'P  '.or.cbc(f,e,ifield).eq.'p  ') then
            call facind2 (js1,jf1,jskip1,js2,jf2,jskip2,f)
            k = 0
            do j2=js2,jf2,jskip2
            do j1=js1,jf1,jskip1
               k = k+1
               v1(j1,j2,1,e) = unx(j1,j2,1,e)
               v2(j1,j2,1,e) = uny(j1,j2,1,e)
               v3(j1,j2,1,e) = unz(j1,j2,1,e)
            enddo
            enddo
         endif

      enddo
      enddo

      ifcyclic = .false.
      call opdssum(v1,v2,v3)

      eps = 1.e-4
      if (ldim.eq.2) call rzero(v3,n)

      do e=1,nelt   ! Check for turning angle
      do f=1,nface

         if (cbc(f,e,ifield).eq.'P  '.or.cbc(f,e,ifield).eq.'p  ') then

            call facindr(i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f) ! restricted indx
            snorm = 0.
            dnorm = 0.
            do k=k0,k1
            do j=j0,j1
            do i=i0,i1
               snorm = abs(v1(i,j,k,e))
     $               + abs(v2(i,j,k,e))
     $               + abs(v3(i,j,k,e))
            enddo
            enddo
            enddo
            if (snorm.gt.eps) ifcyclic = .true.

         endif

      enddo
      enddo

      itest = 0
      if (ifcyclic) itest = 1
      itest = iglmax(itest,1)

      if (itest.gt.0) ifcyclic = .true.

      return
      end
c-----------------------------------------------------------------------
      real function glcflux(tx,ty,tz)
c
      include 'SIZE'
      include 'TOTAL'

      real tx(lx1,ly1,lz1,lelv)
      real ty(lx1,ly1,lz1,lelv)
      real tz(lx1,ly1,lz1,lelv)

      character cb*3

      nxyz1= lx1*ly1*lz1
      ntot1= nxyz1*nelv
      nfaces = 2*ldim

      termA = 0.0
      termVL= 0.0

      do 100 iel=1,nelv
      do 100 iface=1,nfaces
         cb = cbc(iface,iel,1)
         if (cb.eq.'v  ' .or. cb.eq.'V  ' .or. cb.eq.'mv ') then
            call facind(kx1,kx2,ky1,ky2,kz1,kz2,lx1,ly1,lz1,iface)
            ia = 0
            do 10 iz=kz1,kz2
            do 10 iy=ky1,ky2
            do 10 ix=kx1,kx2
               ia =ia + 1
               termxyz = tx(ix,iy,iz,iel)*unx(ia,1,iface,iel)
     $                 + ty(ix,iy,iz,iel)*uny(ia,1,iface,iel)
     $                 + tz(ix,iy,iz,iel)*unz(ia,1,iface,iel)
               termA  = termA + area(ia,1,iface,iel)
               termVL = termVL+ termxyz * area(ia,1,iface,iel)
 10         continue
         endif
 100  continue

      glcflux = glsum(termVL,1)  ! sum across processors

      return
      end
c-----------------------------------------------------------------------
      subroutine local_bflux(flux,tx,ty,tz,ifld)
c
      include 'SIZE'
      include 'TOTAL'

      real   tx(lx1,ly1,lz1,1),
     $       ty(lx1,ly1,lz1,1),
     $       tz(lx1,ly1,lz1,1),
     $     flux(lx1,ly1,lz1,1)

      character cb*3

      nel    = nelfld(ifld)
      nxyz   = lx1*ly1*lz1
      ntot   = nxyz*nel
      nfaces = 2*ldim

      call rzero(flux,ntot)

      do 100 iel=1,nel
      do 100 iface=1,nfaces
         cb = cbc(iface,iel,ifld)
         if (cb.ne.'E  ') then
            call facind(kx1,kx2,ky1,ky2,kz1,kz2,lx1,ly1,lz1,iface)
            ia = 0
            do 10 iz=kz1,kz2
            do 10 iy=ky1,ky2
            do 10 ix=kx1,kx2
               ia =ia + 1
               dtmp =   tx(ix,iy,iz,iel)*unx(ia,1,iface,iel)
     $                + ty(ix,iy,iz,iel)*uny(ia,1,iface,iel)
     $                + tz(ix,iy,iz,iel)*unz(ia,1,iface,iel)
               flux(ix,iy,iz,iel) = flux(ix,iy,iz,iel)
     $                              + dtmp*area(ia,1,iface,iel)
 10         continue
         endif
 100  continue

      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
C
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
C
      CALL DSSET (lx1,ly1,lz1)
      IFACE  = EFACE1(IFC)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine create_obj(iobjo,sid_list,n)
c
c     defines an object for a given list of surface ids
c
      include 'SIZE'
      include 'TOTAL'

      integer sid_list(n)

      integer e,f

      nobj = nobj + 1
      iobj = nobj

      if (maxobj.lt.nobj)
     $   call exitti('maxobj too small, increate in SIZE.$',ierr)

      do e=1,nelv
      do f=1,2*ndim
      do i=1,n
         if (boundaryID(f,e) .eq. sid_list(i)) then
            nmember(iobj) = nmember(iobj) + 1
            mem = nmember(iobj)
            ieg = lglel(e)
            object(iobj,mem,1) = ieg
            object(iobj,mem,2) = f
c            write(6,1) iobj,mem,f,ieg,e,nid,' OBJ'
    1       format(6i9,a4)
         endif
      enddo
      enddo
      enddo

      iobjo  = iobj

      return
      end
c-----------------------------------------------------------------------
      subroutine setbc(bid,ifld,cbci)
c
c     sets boundary condition for a given surface id and field
c
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'

      character*3 cbci
      integer bid

      if (bid.lt.1 .or. bid.gt.lbid)
     $  call exitti('invalid boundary id!$',bid)

      cbc_bmap(bid,ifld) = cbci
 
      if (iftmsh(ifld)) then
        do iel = 1,nelt
        do ifc = 1,2*ndim
           if (boundaryIDt(ifc,iel).eq.bid)
     $       cbc(ifc,iel,ifld) = cbc_bmap(bid,ifld)
        enddo
        enddo
      else
        do iel = 1,nelv
        do ifc = 1,2*ndim
           if (boundaryID(ifc,iel).eq.bid)
     $       cbc(ifc,iel,ifld) = cbc_bmap(bid,ifld)
        enddo
        enddo
      endif

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A file-scope variable used within a function called by a parallel region.
!No threadprivate is used to avoid data races.
!
!Data race pairs  sum0@39:13 vs. sum0@39:19
!                 sum0@39:13 vs. sum0@39:13

module DRB084
    implicit none
    integer (kind=8) :: sum0, sum1
contains
    subroutine foo(i)
        integer (kind=8) :: i
        sum0=sum0+i
    end subroutine
end module

program DRB084_threadprivatemissing_orig_yes
    use omp_lib
    use DRB084
    implicit none

    integer (kind=8) :: i, sum
    sum = 0

    !$omp parallel
        !$omp do
            do i = 1, 1001
                call foo(i)
            end do
        !$omp end do
        !$omp critical
            sum = sum + sum0
        !$omp end critical
    !$omp end parallel

    do i = 1, 1001
        sum1 = sum1+i
    end do

    print*,'sum = ',sum,'sum1 =',sum1
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This one has data races due to true dependence.
!But data races happen at both instruction and thread level.
!Data race pair: a[i+1]@31:9 vs. a[i]@31:16

program DRB115_forsimd_orig_yes
    use omp_lib
    implicit none

    integer i, len
    integer, dimension(:), allocatable :: a,b

    len = 100
    allocate (a(len))
    allocate (b(len))

    do i = 1, len
        a(i) = i
        b(i) = i+1
    end do

    !$omp simd
    do i = 1, len-1
        a(i+1)=a(i)+b(i)
    end do

    print*,'a(50) =',a(50)

    deallocate(a,b)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!For a variable declared in a scope inside an OpenMP construct:
!* private if the variable has an automatic storage duration
!* shared if the variable has a static storage duration.
!
!Dependence pairs:
!   tmp@38:13 vs. tmp@38:13
!   tmp@38:13 vs. tmp@39:20


program DRB090_static_local_orig_yes
    use omp_lib
    implicit none

    integer :: i, len
    integer, dimension(:), allocatable :: a, b
    integer, save :: tmp
    integer :: tmp2

    len = 100
    allocate (a(len))
    allocate (b(len))

    do i = 1, len
        a(i) = i
        b(i) = i
    end do

    !$omp parallel
        !$omp do
        do i = 1, len
            tmp = a(i)+i
            a(i) = tmp
        end do
        !$omp end do
    !$omp end parallel

    !$omp parallel
        !$omp do
        do i = 1, len
            tmp2 = b(i)+i
            b(i) = tmp2
        end do
        !$omp end do
    !$omp end parallel

    print 100, a(50), b(50)
    100 format (i3,3x,i3)

    deallocate(a,b)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The assignment to a@21:9 is  not synchronized with the update of a@29:11 as a result of the
!reduction computation in the for loop.
!Data Race pair: a@21:9 and a@24:30


program DRB140_reduction_barrier_orig_yes
    use omp_lib
    implicit none

    integer :: a, i

    !$omp parallel shared(a) private(i)
        !$omp master
        a = 0
        !$omp end master

        !$omp do reduction(+:a)
        do i = 1, 10
            a = a+i
        end do
        !$omp end do

        !$omp single
        print*, "Sum is ", A
        !$omp end single

    !$omp end parallel
end program

! @expect verified

subroutine addfive(x)
  implicit none
  integer, intent(inout) :: x
  x = x + 5
end subroutine addfive

program main
  implicit none
  integer :: x = 2
  call addfive(x)
  !print *, x == 7
  !$CVL $assert(x /= 7)
end program main

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!use of omp target + map + array sections derived from pointers. No data race pairs.


module DRB099
    implicit none
    contains
REAL FUNCTION foo(a,b,N)
    use omp_lib
    implicit none
  INTEGER :: N, i
  integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:), allocatable :: a,b

    !$omp target map(to:a(1:N)) map(from:b(1:N))
    !$omp parallel do
    do i = 1, N
        b(i) = a(i)*real(i,dp)
    end do
    !$omp end parallel do
    !$omp end target

  RETURN
END FUNCTION foo
end module

program DRB099_targetparallelfor2_orig_no
    use omp_lib
    use DRB099
    implicit none

    integer :: i, len
  integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:), allocatable :: a,b
    real :: x

    len = 1000

    allocate(a(len))
    allocate(b(len))

    do i = 1, len
        a(i) = (real(i,dp))/2.0
        b(i) = 0.0
    end do

    x=foo(a,b,len)
    print*,'b(50) =',b(50)
  
    deallocate(a,b)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two parallel for loops within one single parallel region,
!combined with private() and reduction().

!3.7969326424804763E-007 vs 3.7969326424804758E-007. There is no race condition. The minute
!difference at 22nd point after decimal is due to the precision in fortran95

module DRB058
    use omp_lib
    implicit none

    integer :: MSIZE
    integer :: n,m,mits
    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:,:), pointer :: u,f,uold
    real(dp) :: dx,dy,tol,relax,alpha

contains
    subroutine initialize()
        integer :: i,j,xx,yy

        MSIZE = 200
        mits = 1000
        tol=0.0000000001
        relax = 1.0
        alpha = 0.0543
        n = MSIZE
        m = MSIZE
        allocate(u(MSIZE,MSIZE))
        allocate(f(MSIZE,MSIZE))
        allocate(uold(MSIZE,MSIZE))

        dx = 2.0D0 / DBLE(n-1)
        dy = 2.0D0 / DBLE(m-1)

        do i = 1, n
            do j = 1, m
                xx = int(-1.0 + dx * (i-1))
                yy = int(-1.0 + dy * (i-1))
                u(i,j) = 0.0
                f(i,j) = -1.0 * alpha * (1.0-xx*xx) * (1.0-yy*yy) - 2.0* (1.0-xx*xx) -2.0 * (1.0-yy*yy)
            end do
        end do

    end subroutine

    subroutine jacobi()
        integer, parameter :: dp = kind(1.0d0)
        real(dp) :: omega
        integer :: i, j, k
        real(dp) :: error, resid,  ax, ay, b

        MSIZE = 200
        mits = 1000
        tol=0.0000000001
        relax = 1.0
        alpha = 0.0543
        n = MSIZE
        m = MSIZE

        omega = relax
        dx = 2.0D0 / DBLE(n-1)
        dy = 2.0D0 / DBLE(m-1)

        ax = 1.0D0 / (dx * dx);         !/* X-direction coef */
        ay = 1.0D0 / (dy * dy);         !/* Y-direction coef */
        b = -2.0D0 / (dx * dx) - 2.0D0 / (dy * dy) - alpha;

        error = 10.0 * tol
        k = 1

        do k = 1, mits
            error = 0.0

            !Copy new solution into old
            !$omp parallel
                !$omp do private(i,j)
                    do i = 1, n
                        do j = 1, m
                            uold(i,j) = u(i,j)
                        end do
                    end do
                !$omp end do
                !$omp do private(i,j,resid) reduction(+:error)
                    do i = 2, (n-1)
                        do j = 2, (m-1)
                            resid = (ax * (uold(i - 1,j) + uold(i + 1,j)) + ay * (uold(i,j - 1) + uold(i,j + 1)) + b * uold(i,j) - f(i,j)) / b
                            u(i,j) = uold(i,j) - omega * resid
                            error = error + resid * resid
                        end do
                    end do
                !$omp end do nowait
            !$omp end parallel

            !Error check
            error = sqrt(error)/(n*m)
        end do

        print*,"Total number of iterations: ",k
        print*,"Residual: ",error

    end subroutine
end module

program DRB058_jacobikernel_orig_no
    use omp_lib
    use DRB058
    implicit none

    call initialize()
    call jacobi()
end program

c-----------------------------------------------------------------------
      subroutine out_acsr(acsr,ia,ja,n)
      real acsr(1)
      integer ia(2),ja(1)
      character*1 adum
c
      open (unit=40,file='q0')
      open (unit=41,file='q1')
      open (unit=42,file='q2')
c
      write(6,*) 'this is ia:',ia(1),ia(2),n
      do i=1,n
         nc = ia(i+1)-ia(i)
         j0 = ia(i)-1
         do jc=1,nc
            j = ja  (jc+j0)
            a = acsr(jc+j0)
            write(40,40) a
            write(41,41) i
            write(42,41) j
            write(6,*) i,j,a
         enddo
      enddo
   40 format(1pe20.12)
   41 format(i9)
c
      close (unit=40)
      close (unit=41)
      close (unit=42)
c
c     write(6,*) 'Output in q0,q1,q2. Continue? <cr> '
c     read (5,*,end=1,err=1) adum
    1 continue
c
      return
      end
c-----------------------------------------------------------------------
      subroutine compress_acsr(acsr,ia,ja,n)
c
c     Compress csr formatted a matrix based on drop tolerance, eps.
c
      real acsr(1)
      integer ia(1),ja(1)
c
      eps = 1.e-10
c
      k0 = ia(1)-1
      do i=1,n
         nc = ia(i+1)-ia(i)
         j0 = ia(i)-1

C        row sum as metric
         aa = 0.0
         do jc=1,nc
            aa = aa+abs(acsr(jc+j0))
         enddo
         if (aa.lt.eps) then
            write(6,*) 'inf-norm of row is small',aa
            aa=1.0
         endif
C
         kc = 0
         do jc=1,nc
            ae = abs(acsr(jc+j0)/aa)
            if (ae.gt.eps) then
c              bump column pointer
               kc = kc+1
               acsr(kc+k0) = acsr(jc+j0)
               ja  (kc+k0) = ja  (jc+j0)
            endif
         enddo
         ia (i) = k0+1
         k0     = k0+kc
      enddo
      ia(i) = k0+1
c
      return
      end
c-----------------------------------------------------------------------
      subroutine outbox(xmax,xmin,ymax,ymin,io)
c
      dx = xmax-xmin
      dy = ymax-ymin
      dd = max(dx,dy)/2.
c
      xh = (xmax+xmin)/2.
      yh = (ymax+ymin)/2.
      xmn = xh - dd
      xmx = xh + dd
      ymn = yh - dd
      ymx = yh + dd
c
      write(io,*) 
      write(io,*) ymn,xmn
      write(io,*) ymx,xmn
      write(io,*) ymx,xmx
      write(io,*) ymn,xmx
      write(io,*) ymn,xmn
      write(io,*) 
c
      return
      end
c-----------------------------------------------------------------------
      subroutine imout(x,m,n,name)
      integer x(m,1)
      character*9 name
c
      n15 = min(n,30)
      do i=1,m
         write(6,6) n,name,(x(i,k),k=1,n15)
      enddo
    6 format(i4,1x,a9,':',2x,30i3)
      return
      end
c-----------------------------------------------------------------------
      subroutine out_abd(abd,lda,n,m)
      real    abd(lda,1)
c
      write(6,*) 'abd:',lda,m,n
      do j=1,n
          write(6,6) (abd(i,j),i=lda,1,-1)
      enddo
   6  format(12f8.3)
c.
c.
      open(unit=40,file='b0')
      open(unit=41,file='b1')
      open(unit=42,file='b2')
      mm = lda-1
      do 20 j = 1, n
         i1 = max0(1, j-mm)
         do 10 i = i1, j
            k = i-j+mm+1
            a = abd(k,j)
            write(40,*) a
            write(41,*) i
            write(42,*) j
   10    continue
   20 continue
c
      close(unit=40)
      close(unit=41)
      close(unit=42)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine rarr_out(x,name13)
      include 'SIZE'
      include 'INPUT'
c
      real x(lx1,ly1,lz1,lelt)
      character*13 name13
c
      if (nelv.gt.20) return
      write(6,*) 
      write(6,1) name13
    1 format('rarr ',3x,a13)
c
c     3 D
c
      if (if3d) then
         do iz=1,lz1
            write(6,*) 
            do j=ly1,1,-1
               write(6,3) (x(k,j,iz,1),k=1,lx1),(x(k,j,iz,2),k=1,lx1)
            enddo
         enddo
         write(6,*)
         write(6,*)
         return
      endif
c
c     2 D
c
      if (nelv.gt.2) then
         write(6,*) 
         do j=ly1,1,-1
            write(6,6) (x(k,j,1,3),k=1,lx1),(x(k,j,1,4),k=1,lx1)
         enddo
         write(6,*)
         write(6,*)
      endif
c
      do j=ly1,1,-1
         write(6,6) (x(k,j,1,1),k=1,lx1),(x(k,j,1,2),k=1,lx1)
      enddo
      write(6,*)
    3 format(4f6.2,5x,4f6.2)
    6 format(6f8.4,5x,6f8.4)
      return
      end
c-----------------------------------------------------------------------
      subroutine iarr_out(x,name)
      include 'SIZE'
      include 'INPUT'
c
      integer x(lx1,ly1,lz1,lelt)
      character*13 name
c
      if (nelv.gt.20) return
      write(6,*) 
      write(6,1) name
    1 format(a13)
c
c     3 D
c
      if (if3d) then
         do iz=1,lz1
            write(6,*) 
            do j=ly1,1,-1
               write(6,3) (x(k,j,iz,1),k=1,lx1),(x(k,j,iz,2),k=1,lx1)
            enddo
         enddo
         write(6,*)
         write(6,*)
         return
      endif
c
c     2 D
c
      if (nelv.gt.2) then
         write(6,*) 
         do j=ly1,1,-1
            write(6,6) (x(k,j,1,3),k=1,lx1),(x(k,j,1,4),k=1,lx1)
         enddo
         write(6,*)
         write(6,*)
      endif
c
      do j=ly1,1,-1
         write(6,6) (x(k,j,1,1),k=1,lx1),(x(k,j,1,2),k=1,lx1)
      enddo
      write(6,*)
    3 format(4i5,5x,4i5)
    6 format(5i5,5x,5i5)
      return
      end
c-----------------------------------------------------------------------
      subroutine iar2_out(x,name)
      include 'SIZE'
c
      integer x(lx2,ly2,lz2,lelt)
      character*13 name
c
      if (nelv.gt.20) return
      write(6,*) 
      write(6,1) name
    1 format(a13)
      if (nelv.gt.2) then
         write(6,*) 
         do j=ly2,1,-1
            write(6,6) (x(k,j,1,3),k=1,lx2),(x(k,j,1,4),k=1,lx2)
         enddo
         write(6,*)
         write(6,*)
      endif
c
      do j=ly2,1,-1
         write(6,6) (x(k,j,1,1),k=1,lx2),(x(k,j,1,2),k=1,lx2)
      enddo
      write(6,*)
    6 format(3i5,5x,3i5)
      return
      end
c-----------------------------------------------------------------------
      subroutine scsr_permute(bcsr,ib,jb,acsr,ia,ja,n
     $                                  ,icperm,inverse,nonzero,nzero)
c
c     Permutes a Symmetric Compressed Sparse Row formatted matrix
c     to minimize bandwidth
c
c     Reqired space:  NONZERO is an array of size 2*nnz+2,  where nnz
c                     is the number of nonzeros.  NONZERO and jb may
c                     occupy the same space.
c
c     NOTE!!:   "inverse" is used as a scratch array for reals
c               in the swap call below... Therefore, inverse must
c               be aligned on even byte boundaries when running
c               in 64 bit precision.
c
c
      real bcsr(1)
      integer ib(1),jb(1)
c
      real acsr(1)
      integer ia(1),ja(1)
c
      integer icperm(n),nonzero(2,0:1)
      integer inverse(n),nzero(n)
C     HMT HACK ... if we're actualy using smbwr.c then we need to 
C     uncomment the following line!!!
C      integer sm_bandwidth_reduction
c
      integer icalld,max_n 
      save    icalld,max_n 
      data    icalld,max_n /0,0/
C
C     HMT HACK ... if we're actualy using smbwr.c then we need to 
C     delete the following line!!!
      write(6,*) 'HMT HACK in subroutine scsr_permute() ... pls fix!'
      call exitt
C
      icalld=icalld+1
c
      write(6,*) 'scsr_permute',n,acsr(1)
      mnz    = 0
      mbw_in = 0
      do i=1,n
         n1 = ia(i)  +1
         n2 = ia(i+1)-1
         do jj=n1,n2
            mnz = mnz+1
            j   = ja(jj)
            nonzero(1,mnz) = i
            nonzero(2,mnz) = j
C            write (6,*) i,j
            mbw_in = max(mbw_in,abs(i-j))
         enddo
      enddo
      nonzero(1,0) = n
      nonzero(2,0) = mnz
C
      itype = -1
C      itype = -2
      if (n.le.200) itype = -2
      write(6,*) 'this is mnz:',mnz
C      write(6,*)  nonzero(1,0), nonzero(2,0)
c
C     HMT HACK ... if we're actualy using smbwr.c then we need to 
C     uncomment the following line!!!
C      ierr  = sm_bandwidth_reduction(nonzero(1,0),icperm(1),itype)
      ierr = 1
      if (ierr.eq.0) then
         write(6,*) 'scsr_permute :: sm_bandwidth_reduction failed',ierr
         call exitt
      elseif (ierr.lt.0) then
         write(6,*) 'scsr_permute :: graph disconnected?',ierr
         call exitt
      endif
c
c     Setup inverse map
c
      do i=1,n
         inverse(icperm(i))=i
      enddo
c
C      n20 = min(50,n)
C      write(6,20) (icperm (k),k=1,n20)
C      write(6,21) (inverse(k),k=1,n20)
C 20   format('icp:',20i4)
C 21   format('inv:',20i4)
c
c
c     Count *number* of nonzeros on each row in the new row pointer
c
      call izero(nzero,2*mnz)
      do i=1,n
         n1 = ia(i)
         n2 = ia(i+1)-1
         ii = inverse(i)
         do jc=n1,n2
            j=ja(jc)
            jj = inverse(j)
            if (jj.ge.ii) then
               nzero(ii) = nzero(ii)+1
            else
               nzero(jj) = nzero(jj)+1
            endif
         enddo
      enddo
c
c     Convert to pointers
c
      ib(1) = 1
      do i=1,n
         ib(i+1) = ib(i)+nzero(i)
      enddo
c
c     Fill permuted array
c
      call icopy(nzero,ib,n)
      do i=1,n
         n1 = ia(i)
         n2 = ia(i+1)-1
         ii = inverse(i)
         do jc=n1,n2
            j=ja(jc)
            jj = inverse(j)
            if (jj.ge.ii) then
               jb  (nzero(ii)) = jj
               bcsr(nzero(ii)) = acsr(jc)
               nzero(ii) = nzero(ii)+1
            else
               jb  (nzero(jj)) = ii
               bcsr(nzero(jj)) = acsr(jc)
               nzero(jj) = nzero(jj)+1
            endif
         enddo
      enddo
c
c     Sort each row of b in ascending column order -- 
c                             just for subsequent access efficiency
c
      m2 = mod(n2,2)+2
      do i=1,n
         n1 = ib(i)
         n2 = ib(i+1)-ib(i)
         call isort(jb  (n1),nzero,n2)
c        write(6,*) 'call swap:',n,i,m2,n1,n2
         call swap (bcsr(n1),nzero,n2,inverse)
      enddo
c
      if (icalld.le.10.or.mod(icalld,50).eq.0.or.n.gt.max_n) then
         mbw = mbw_csr(ib,jb,n)
         write(6,*) ierr,mbw,mbw_in,n,mnz,'   New bandwidth'
         if (n.gt.max_n) max_n = n
      endif
c
      return
      end
c=======================================================================
      subroutine scsr_to_spb(abd,lda,acsr,ia,ja,n)
c
c     This, and the companion routines map a *symmetrically*
c     stored (upper 1/2 only) Compressed Sparse Row formatted
c     matrix to the linpack banded format.
c
c
      real abd(1),acsr(1)
      integer m,n,ia(1),ja(1)
c
      lda = mbw_csr(ia,ja,n) + 1
      call scsr_to_spbm(abd,lda,acsr,ia,ja,n)
c
      return
      end
c=======================================================================
      subroutine scsr_to_spbm(abd,lda,acsr,ia,ja,n)
c
      real abd(lda,1),acsr(1)
      integer n,ia(1),ja(1)
c
      call rzero(abd,lda*n)
      do i=1,n
         n1 = ia(i)
         n2 = ia(i+1)-1
         do jc=n1,n2
            j=ja(jc)
            klin = lda + (i-j)
            jlin = j
            abd(klin,jlin) = acsr(jc)
         enddo
      enddo
      return
      end
      function mbw_csr(ia,ja,n) 
c
c     Determine the maximum bandwidth for a csr formatted matrix
c
      integer ia(1),ja(1)
c
      m = 0
      do i=1,n
         n1 = ia(i)
         n2 = ia(i+1)-1
         do jc=n1,n2
            j=ja(jc)
            m = max(m,abs(i-j))
         enddo
      enddo
      mbw_csr = m
      return
      end
c=======================================================================
      subroutine out_spbmat(abd,n,lda,name)
      real    abd(lda,1)
c
      character*9 name
      character*6 s(22)
c
      m = lda-1
      write(6,1) name,n,m
    1 format(/,'SPB Mat:',a9,3x,'n =',i3,' m =',i3,/)
c
      n22 = min(n,22)
      do i=1,n
         call blank(s,132)
         ii = lda*i
         do k=0,m
            j = i+k
            a = abd(ii+k*m,1)
            if (a.ne.0..and.j.le.n22) write(s(j),6) a
         enddo
         write(6,22) (s(k),k=1,n22)
      enddo
    6 format(f6.3)
   22 format(22a6)
c
      return
      end
c=======================================================================
      subroutine swap(b,ind,n,temp)
      real B(1),TEMP(1)
      integer IND(1)
C***
C***  SORT ASSOCIATED ELEMENTS BY PUTTING ITEM(JJ)
C***  INTO ITEM(I), WHERE JJ=IND(I).
C***
      DO 20 I=1,N
         JJ=IND(I)
         TEMP(I)=B(JJ)
   20 CONTINUE
      DO 30 I=1,N
   30 B(I)=TEMP(I)
      RETURN
      END
c=======================================================================
      subroutine ipermute(a,icperm,n,b)
      integer a(1),b(1)
      integer icperm(1)
c
      call icopy(b,a,n)
      do i=1,n
         a(i) = b(icperm(i))
      enddo
      return
      end
c=======================================================================
      subroutine out_csrmat(acsr,ia,ja,n,name9)
      real    acsr(1)
      integer ia(1),ja(1)
c
      character*9 name9
      character*6 s(22)
c
      nnz = ia(n+1)-ia(1)
c
      write(6,1) name9,n,nnz
    1 format(/,'CSR Mat:',a9,3x,'n =',i3,3x,'nnz =',i5,/)
c
      n22 = min(n,22)
      n29 = min(n,29)
      do i=1,n29
         call blank(s,132)
         n1 = ia(i)
         n2 = ia(i+1)-1
         do jj=n1,n2
            j = ja  (jj)
            a = acsr(jj)
            if (a.ne.0..and.j.le.n22) write(s(j),6) a
         enddo
         write(6,22) (s(k),k=1,n22)
      enddo
    6 format(f6.2)
   22 format(22a6)
c
      return
      end
c=======================================================================

      SUBROUTINE LU(A,N,ldim,IR,IC)
C  IT IS THE FIRST SUBROUTINE TO COMPUTE THE MX. INV.
      DIMENSION A(ldim,1),IR(1),IC(1)
      DO 10I=1,N
      IR(I)=I
      IC(I)=I
10      CONTINUE
      K=1
      L=K
      M=K
      XMAX=ABS(A(K,K))
      DO 100I=K,N
      DO 100J=K,N
      Y=ABS(A(I,J))
      IF(XMAX.GE.Y) GOTO 100
      XMAX=Y
      L=I
      M=J
100     CONTINUE
      DO 1000K=1,N
      IRL=IR(L)
      IR(L)=IR(K)
      IR(K)=IRL
      ICM=IC(M)
      IC(M)=IC(K)
      IC(K)=ICM
      IF(L.EQ.K) GOTO 300
      DO 200J=1,N
      B=A(K,J)
      A(K,J)=A(L,J)
      A(L,J)=B
200     CONTINUE
300     IF(M.EQ.K) GOTO 500
      DO 400I=1,N
      B=A(I,K)
      A(I,K)=A(I,M)
       A(I,M)=B
400    CONTINUE
500     C=1./A(K,K)
      A(K,K)=C
      IF(K.EQ.N) GOTO 1000
      K1=K+1
      XMAX=ABS(A(K1,K1))
      L=K1
      M=K1
      DO 600I=K1,N
       A(I,K)=C*A(I,K)
600     CONTINUE
      DO 800I=K1,N
      B=A(I,K)
      DO 800J=K1,N
      A(I,J)=A(I,J)-B*A(K,J)
      Y=ABS(A(I,J))
      IF(XMAX.GE.Y) GOTO 800
      XMAX=Y
      L=I
      M=J
800    CONTINUE
1000  CONTINUE
      RETURN
      END
      SUBROUTINE SOLVE(F,A,K,N,ldim,IR,IC)
C   IT IS THE SECOND PART OF THE MATRIX INVERSION
      DIMENSION A(ldim,1),F(ldim,1),IR(1),IC(1)
      COMMON /CTMPG/ G(2000)
C
C
      IF (N.GT.2000) THEN
         write(6,*) 'Abort IN Subrtouine SOLVE: N>2000, N=',N
         call exitt
      ENDIF
C
      N1=N+1
      DO 1000KK=1,K
      DO 100I=1,N
      IRI=IR(I)
        G(I)=F(IRI,KK)
100     CONTINUE
      DO 400I=2,N
      I1=I-1
      B=G(I)
      DO 300J=1,I1
        B=B-A(I,J)*G(J)
300     CONTINUE
        G(I)=B
400     CONTINUE
      DO 700IT=1,N
      I=N1-IT
      I1=I+1
      B=G(I)
      IF(I.EQ.N) GOTO 701
      DO 600J=I1,N
        B=B-A(I,J)*G(J)
600     CONTINUE
701     G(I)=B*A(I,I)
700     CONTINUE
      DO 900I=1,N
      ICI=IC(I)
        F(ICI,KK)=G(I)
900     CONTINUE
1000    CONTINUE
      RETURN
      END

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Loop carried true dep between tmp =..  and ..= tmp.
!Data race pair: tmp@24:9 vs. tmp@25:15

program DRB035_truedepscalar_orig_yes
    use omp_lib
    implicit none

    integer i, tmp, len
    integer, dimension(:), allocatable :: a

    len = 100
    tmp = 10
    allocate (a(len))

    !$omp parallel do
    do i = 1, len
        a(i) = tmp
        tmp = a(i) + i
    end do
    !$omp end parallel do

    print 100, a(50)
    100 format ('a(50) =',i3)

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Number of threads is empirical: We need enough threads so that
!the reduction is really performed hierarchically in the barrier!
!There is no data race.

program DRB121_reduction_orig_no
    use omp_lib
    implicit none

    integer :: var, i, sum1, sum2

    var = 0
    sum1 = 0
    sum2 = 0

    !$omp parallel reduction(+: var)
        !$omp do schedule(static) reduction(+: sum1)
        do i = 1, 5
            sum1 = sum1+i
        end do
        !$omp end do

        !$omp do schedule(static) reduction(+: sum2)
        do i = 1, 5
            sum2 = sum2+i
        end do
        !$omp end do

        var = sum1 + sum2
    !$omp end parallel

    print 100, var
    100 format ('var =',3i8)
end program

      PROGRAM TRUNCATE
        INTEGER extremelylongvariablename, extremelylongvariablename1
        INTEGER sum
        extremelylongvariablename = 0
        extremelylongvariablename1 = 1
        sum = 10 + extremelylongvariablename + extremelylongvariablename1
        !$CVL $assert(sum .EQ. 10);
      END PROGRAM TRUNCATE

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Using lastprivate() to resolve an output dependence.
!
!Semantics of lastprivate (x):
!causes the corresponding original list item to be updated after the end of the region.
!The compiler/runtime copies the local value back to the shared one within the last iteration.


program DRB059_lastprivate_orig_no
    use omp_lib
    implicit none
    !$omp parallel
    call foo()
    !$omp end parallel
contains
    subroutine foo()
        integer :: i, x
        !$omp parallel do private(i) lastprivate(x)
        do i = 1, 100
            x = i
        end do
        !$omp end parallel do
        print 100, x
        100 format ("x =",i3)
    end subroutine foo
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Concurrent accessing var@25:9 may cause atomicity violation and inter region data race.
!Lock and reduction clause at line 22, avoids this. No Data Race Pair.

program DRB154_missinglock3_orig_gpu_no
    use omp_lib
    implicit none

    integer (kind=omp_lock_kind) :: lck
    integer :: var, i
    var = 0

    call omp_init_lock (lck)

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute reduction(+:var)
    do i = 1, 100
        call omp_set_lock(lck)
        var = var+1
        call omp_unset_lock(lck)
    end do
    !$omp end teams distribute
    !$omp end target

    call omp_destroy_lock(lck)

    print*, var
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Concurrent access of var@23 in an intra region. Lock ensures that there is no data race.

program DRB152_missinglock2_orig_gpu_no
    use omp_lib
    implicit none

    integer (kind=omp_lock_kind) :: lck
    integer :: var, i
    var = 0

    !$omp target map(tofrom:var) device(0)
    !$omp teams num_teams(1)
    !$omp distribute parallel do
    do i = 1, 100
        call omp_set_lock(lck)
        var = var+1
        call omp_unset_lock(lck)
    end do
    !$omp end distribute parallel do
    !$omp end teams
    !$omp end target
end program

c-----------------------------------------------------------------------
c
c Some relevant parameters
c
c param(41):
c     0 - use additive SEMG
c     1 - use hybrid SEMG (not yet working... but coming soon!)
c
c param(42):   navier0.f, fasts.f
c     0 - use GMRES for iterative solver, use non-symmetric weighting
c     1 - use PCG for iterative solver, do not use weighting
c
c param(43):   uzawa_gmres.f, navier6.f
c     0 - use additive multilevel scheme (requires param(42).eq.0)
c     1 - use original 2 level scheme
c
c param(44):   fast3d.f, navier6.f
c     0 - base top-level additive Schwarz on restrictions of E
c     1 - base top-level additive Schwarz on restrictions of A
c
c----------------------------------------------------------------------
      subroutine hsmg_setup()
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'HSMG'
      include 'SEMHAT'
      include 'TSTEP'

      integer nf,nc,nr
      integer nx,ny,nz

      mg_fld = 1
      if (ifield.gt.1) mg_fld = 2
      if (ifield.eq.1) call hsmg_index_0 ! initialize index sets

      call hsmg_setup_mg_nx  ! set nx values for each level of multigrid
      call hsmg_setup_semhat ! set spectral element hat matrices
      call hsmg_setup_intp
      call hsmg_setup_dssum  ! set direct stiffness summation handles
      call hsmg_setup_wtmask ! set restriction weight matrices and bc masks
      call hsmg_setup_fdm    ! set up fast diagonalization method
      call hsmg_setup_schwarz_wt(.false.)
      call hsmg_setup_solve  ! set up the solver
c     call hsmg_setup_dbg

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_semhat
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      include 'SEMHAT'
      integer n,l
c     generate the SEM hat matrices for each level
c     top level
      n = mg_nx(mg_lmax)
      call semhat(ah,bh,ch,dh,zh,dph,jph,bgl,zglhat,dgl,jgl,n,wh)
      call copy(mg_zh(1,mg_lmax),zglhat,n-1) !top level based on gl points
      mg_nh(mg_lmax)=n-1
      mg_nhz(mg_lmax)=n-1
      if(.not.if3d) mg_nhz(mg_lmax)=1
c     lower levels
      do l=1,mg_lmax-1
         n = mg_nx(l)
         if(n.gt.1) then
            call semhat(ah,bh,ch,dh,zh,dph,jph,bgl,zglhat,dgl,jgl,n,wh)
            call copy(mg_ah(1,l),ah,(n+1)*(n+1))
            call copy(mg_bh(1,l),bh,n+1)
            call copy(mg_dh(1,l),dh,(n+1)*(n+1))
            call transpose(mg_dht(1,l),n+1,dh,n+1)
            call copy(mg_zh(1,l),zh,n+1)
         else
            mg_zh(1,l) = -1.
            mg_zh(2,l) =  1.
         endif
         mg_nh(l)=n+1
         mg_nhz(l)=mg_nz(l)+1
      enddo
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_intp
      include 'SIZE'
      include 'HSMG'
      include 'SEMHAT'
      integer l,nf,nc

      do l=1,mg_lmax-1

         nf=mg_nh(l+1)
         nc=mg_nh(l)

!        Standard multigrid coarse-to-fine interpolation
         call hsmg_setup_intpm(
     $           mg_jh(1,l),mg_zh(1,l+1),mg_zh(1,l),nf,nc)
         call transpose(mg_jht(1,l),nc,mg_jh(1,l),nf)

!        Fine-to-coarse interpolation for variable-coefficient operators
         call hsmg_setup_intpm(
     $           mg_jhfc(1,l),mg_zh(1,l),mg_zh(1,l+1),nc,nf)
         call transpose(mg_jhfct(1,l),nf,mg_jhfc(1,l),nc)
c        call outmat(mg_jhfc(1,l),nc,nf,'MG_JHFC',l)

      enddo
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_intpm(jh,zf,zc,nf,nc)
      integer nf,nc
      real jh(nf,nc),zf(1),zc(1)
      include 'SIZE'
      real w(2*lx1+2)
      do i=1,nf
         call fd_weights_full(zf(i),zc,nc-1,1,w)
         do j=1,nc
            jh(i,j)=w(j)
         enddo
      enddo
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_dssum
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'HSMG'
      parameter (lxyz=(lx1+2)*(ly1+2)*(lz1+2))
      common /c_is1/ glo_num(lxyz*lelv)
      common /ivrtx/ vertex ((2**ldim)*lelt)

      integer*8 glo_num
      integer vertex
      integer nx,ny,nz
      integer l
      
c     set up direct stiffness summation for each level
      ncrnr = 2**ldim
      call get_vert

c++   write(6,*) mg_fld,' mgfld in hsmg_setup_dssum'

      do l=1,mg_lmax-1
         nx=mg_nh(l)
         ny=mg_nh(l)
         nz=mg_nhz(l)
         call setupds(mg_gsh_handle(l,mg_fld),nx,ny,nz
     $                ,nelv,nelgv,vertex,glo_num)
         nx=nx+2
         ny=ny+2
         nz=nz+2
         if(.not.if3d) nz=1
         call setupds(mg_gsh_schwarz_handle(l,mg_fld),nx,ny,nz
     $                ,nelv,nelgv,vertex,glo_num)
      enddo
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_wtmask
      include 'SIZE'
      include 'HSMG'
      integer i,l
      i = mg_mask_index(mg_lmax,mg_fld-1)
      do l=1,mg_lmax
         mg_rstr_wt_index(l,mg_fld)=i
         mg_mask_index   (l,mg_fld)=i
         i=i+mg_nh(l)*mg_nhz(l)*2*ldim*nelv
         if(i .gt. lmgs*lmg_rwt*2*ldim*lelv) then
            itmp = i/(2*ldim*lelv)
            write(6,*) 'parameter lmg_rwt too small',i,itmp,lmg_rwt
            call exitt
         endif
         call hsmg_setup_rstr_wt(
     $           mg_rstr_wt(mg_rstr_wt_index(l,mg_fld))
     $          ,mg_nh(l),mg_nh(l),mg_nhz(l),l,mg_work)
         call hsmg_setup_mask(
     $           mg_mask(mg_mask_index(l,mg_fld))
     $          ,mg_nh(l),mg_nh(l),mg_nhz(l),l,mg_work)
      enddo
      mg_mask_index(l,mg_fld)=i
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_wtmask
      include 'SIZE'
      include 'HSMG'
      integer i,l
      i = mg_mask_index(mg_lmax,mg_fld-1)
      do l=1,mg_lmax-1
         mg_rstr_wt_index(l,mg_fld)=i
         mg_mask_index   (l,mg_fld)=i
         i=i+mg_nh(l)*mg_nhz(l)*2*ldim*nelv
         if(i .gt. lmgs*lmg_rwt*2*ldim*lelv) then
            itmp = i/(2*ldim*lelv)
            write(6,*) 'parameter lmg_rwt too small',i,itmp,lmg_rwt
            call exitt
         endif
         call hsmg_setup_rstr_wt(
     $           mg_rstr_wt(mg_rstr_wt_index(l,mg_fld))
     $          ,mg_nh(l),mg_nh(l),mg_nhz(l),l,mg_work)
         call hsmg_setup_mask(
     $           mg_mask(mg_mask_index(l,mg_fld))
     $          ,mg_nh(l),mg_nh(l),mg_nhz(l),l,mg_work)
      enddo
      mg_mask_index(l,mg_fld)=i
      end
c----------------------------------------------------------------------
      subroutine hsmg_intp(uf,uc,l) ! l is coarse level
      real uf(1),uc(1)
      integer l
      include 'SIZE'
      include 'HSMG'
      call hsmg_tnsr(uf,mg_nh(l+1),uc,mg_nh(l),mg_jh(1,l),mg_jht(1,l))
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_rstr(uc,uf,l) ! l is coarse level
      real uf(1),uc(1)
      integer l
      include 'SIZE'
      include 'HSMG'
      if(l.ne.mg_lmax-1)
     $   call hsmg_do_wt(uf,mg_rstr_wt(mg_rstr_wt_index(l+1,mg_fld))
     $                     ,mg_nh(l+1),mg_nh(l+1),mg_nhz(l+1))
      call hsmg_tnsr(uc,mg_nh(l),uf,mg_nh(l+1),mg_jht(1,l),mg_jh(1,l))
      call hsmg_dssum(uc,l)
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_rstr_no_dssum(uc,uf,l) ! l is coarse level
      real uf(1),uc(1)
      integer l
      include 'SIZE'
      include 'HSMG'
      if(l.ne.mg_lmax-1)
     $   call hsmg_do_wt(uf,mg_rstr_wt(mg_rstr_wt_index(l+1,mg_fld))
     $                     ,mg_nh(l+1),mg_nh(l+1),mg_nhz(l+1))
      call hsmg_tnsr(uc,mg_nh(l),uf,mg_nh(l+1),mg_jht(1,l),mg_jh(1,l))
      return
      end
c----------------------------------------------------------------------
c     computes
c     v = [A (x) A] u      or
c     v = [A (x) A (x) A] u 
      subroutine hsmg_tnsr(v,nv,u,nu,A,At)
      integer nv,nu
      real v(1),u(1),A(1),At(1)
      include 'SIZE'
      include 'INPUT'
      if (.not. if3d) then
         call hsmg_tnsr2d(v,nv,u,nu,A,At)
      else
         call hsmg_tnsr3d(v,nv,u,nu,A,At,At)
      endif
      return
      end
c----------------------------------------------------------------------
c     computes
c              T
c     v = A u B
      subroutine hsmg_tnsr2d(v,nv,u,nu,A,Bt)
      integer nv,nu
      real v(nv*nv,nelv),u(nu*nu,nelv),A(1),Bt(1)
      include 'SIZE'
      common /hsmgw/ work((lx1+2)*(lx1+2))
      integer ie
      do ie=1,nelv
         call mxm(A,nv,u(1,ie),nu,work,nu)
         call mxm(work,nv,Bt,nu,v(1,ie),nv)
      enddo
      return
      end
c----------------------------------------------------------------------
c     computes
c              
c     v = [C (x) B (x) A] u
      subroutine hsmg_tnsr3d(v,nv,u,nu,A,Bt,Ct)
      integer nv,nu
      real v(nv*nv*nv,nelv),u(nu*nu*nu,nelv),A(1),Bt(1),Ct(1)
      include 'SIZE'
      parameter (lwk=(lx1+2)*(ly1+2)*(lz1+2))
      common /hsmgw/ work(0:lwk-1),work2(0:lwk-1)
      integer ie, i
      do ie=1,nelv
         call mxm(A,nv,u(1,ie),nu,work,nu*nu)
         do i=0,nu-1
            call mxm(work(nv*nu*i),nv,Bt,nu,work2(nv*nv*i),nv)
         enddo
         call mxm(work2,nv*nv,Ct,nu,v(1,ie),nv)
      enddo
      return
      end
c----------------------------------------------------------------------
c     computes
c              T
c     v = A u B
      subroutine hsmg_tnsr2d_el(v,nv,u,nu,A,Bt)
      integer nv,nu
      real v(nv*nv),u(nu*nu),A(1),Bt(1)
      include 'SIZE'
      common /hsmgw/ work((lx1+2)*(lx1+2))
c
      call mxm(A,nv,u,nu,work,nu)
      call mxm(work,nv,Bt,nu,v,nv)
c
      return
      end
c----------------------------------------------------------------------
c     computes
c              
c     v = [C (x) B (x) A] u
      subroutine hsmg_tnsr3d_el(v,nv,u,nu,A,Bt,Ct)
      integer nv,nu
      real v(nv*nv*nv),u(nu*nu*nu),A(1),Bt(1),Ct(1)
      include 'SIZE'
      parameter (lwk=(lx1+2)*(ly1+2)*(lz1+2))
      common /hsmgw/ work(0:lwk-1),work2(0:lwk-1)
      integer i
c
      call mxm(A,nv,u,nu,work,nu*nu)
      do i=0,nu-1
         call mxm(work(nv*nu*i),nv,Bt,nu,work2(nv*nv*i),nv)
      enddo
      call mxm(work2,nv*nv,Ct,nu,v,nv)
c
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_dssum(u,l)
      include 'SIZE'
      include 'HSMG'
      include 'CTIMER'
      real u(1)

      if (ifsync) call nekgsync()
      etime1=dnekclock()

      call fgslib_gs_op(mg_gsh_handle(l,mg_fld),u,1,1,0)
      tdadd =tdadd + dnekclock()-etime1


      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_dsprod(u,l)
      include 'SIZE'
      include 'HSMG'
      include 'CTIMER'
      real u(1)

      if (ifsync) call nekgsync()

      call fgslib_gs_op(mg_gsh_handle(l,mg_fld),u,1,2,0)
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz_dssum(u,l)
      include 'SIZE'
      include 'HSMG'
      include 'CTIMER'

      if (ifsync) call nekgsync()
      etime1=dnekclock()

      call fgslib_gs_op(mg_gsh_schwarz_handle(l,mg_fld),u,1,1,0)
      tdadd =tdadd + dnekclock()-etime1

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_extrude(arr1,l1,f1,arr2,l2,f2,nx,ny,nz)
      include 'SIZE'
      include 'INPUT'
      integer l1,l2,nx,ny,nz
      real arr1(nx,ny,nz,nelv),arr2(nx,ny,nz,nelv)
      real f1,f2
      
      integer i,j,k,ie,i0,i1
      i0=2
      i1=nx-1
      
      if(.not.if3d) then
         do ie=1,nelv
            do j=i0,i1
               arr1(l1+1 ,j,1,ie) = f1*arr1(l1+1 ,j,1,ie)
     $                             +f2*arr2(l2+1 ,j,1,ie)
               arr1(nx-l1,j,1,ie) = f1*arr1(nx-l1,j,1,ie)
     $                             +f2*arr2(nx-l2,j,1,ie)
            enddo
            do i=i0,i1
               arr1(i,l1+1 ,1,ie) = f1*arr1(i,l1+1 ,1,ie)
     $                             +f2*arr2(i,l2+1 ,1,ie)
               arr1(i,ny-l1,1,ie) = f1*arr1(i,ny-l1,1,ie)
     $                             +f2*arr2(i,nx-l2,1,ie)
            enddo
         enddo
      else
         do ie=1,nelv
            do k=i0,i1
            do j=i0,i1
               arr1(l1+1 ,j,k,ie) = f1*arr1(l1+1 ,j,k,ie)
     $                             +f2*arr2(l2+1 ,j,k,ie)
               arr1(nx-l1,j,k,ie) = f1*arr1(nx-l1,j,k,ie)
     $                             +f2*arr2(nx-l2,j,k,ie)
            enddo
            enddo
            do k=i0,i1
            do i=i0,i1
               arr1(i,l1+1 ,k,ie) = f1*arr1(i,l1+1 ,k,ie)
     $                             +f2*arr2(i,l2+1 ,k,ie)
               arr1(i,nx-l1,k,ie) = f1*arr1(i,nx-l1,k,ie)
     $                             +f2*arr2(i,nx-l2,k,ie)
            enddo
            enddo
            do j=i0,i1
            do i=i0,i1
               arr1(i,j,l1+1 ,ie) = f1*arr1(i,j,l1+1 ,ie)
     $                             +f2*arr2(i,j,l2+1 ,ie)
               arr1(i,j,nx-l1,ie) = f1*arr1(i,j,nx-l1,ie)
     $                             +f2*arr2(i,j,nx-l2,ie)
            enddo
            enddo
         enddo
      endif
      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_schwarz(e,r,sigma,l)
      include 'SIZE'
      include 'HSMG'

      real e(1),r(1)

      n = mg_h1_n(l,mg_fld)

      call h1mg_schwarz_part1 (e,r,l)
      call hsmg_schwarz_wt    (e,l)          ! e  := W e
      call cmult              (e,sigma,n)    !  l       l

      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_schwarz_part1 (e,r,l)
      include 'SIZE'
      include 'INPUT'  ! if3d
      include 'TSTEP'  ! ifield
      include 'HSMG'

      real e(1),r(1)

      integer enx,eny,enz,pm

      zero =  0
      one  =  1
      onem = -1

      n  = mg_h1_n (l,mg_fld)
      pm = p_mg_msk(l,mg_fld)

      call h1mg_mask  (r,mg_imask(pm),nelfld(ifield))  ! Zero Dirichlet nodes

      if (if3d) then ! extended array 
         call hsmg_schwarz_toext3d(mg_work,r,mg_nh(l))
      else
         call hsmg_schwarz_toext2d(mg_work,r,mg_nh(l))
      endif

      enx=mg_nh(l)+2
      eny=mg_nh(l)+2
      enz=mg_nh(l)+2
      if(.not.if3d) enz=1
      i = enx*eny*enz*nelv+1
 
c     exchange interior nodes
      call hsmg_extrude(mg_work,0,zero,mg_work,2,one,enx,eny,enz)
      call hsmg_schwarz_dssum(mg_work,l)
      call hsmg_extrude(mg_work,0,one ,mg_work,2,onem,enx,eny,enz)

      call hsmg_fdm(mg_work(i),mg_work,l) ! Do the local solves

c     Sum overlap region (border excluded)
      call hsmg_extrude(mg_work,0,zero,mg_work(i),0,one ,enx,eny,enz)
      call hsmg_schwarz_dssum(mg_work(i),l)
      call hsmg_extrude(mg_work(i),0,one ,mg_work,0,onem,enx,eny,enz)
      call hsmg_extrude(mg_work(i),2,one,mg_work(i),0,one,enx,eny,enz)

      if(.not.if3d) then ! Go back to regular size array
         call hsmg_schwarz_toreg2d(e,mg_work(i),mg_nh(l))
      else
         call hsmg_schwarz_toreg3d(e,mg_work(i),mg_nh(l))
      endif

      call hsmg_dssum(e,l)                           ! sum border nodes
      call h1mg_mask (e,mg_imask(pm),nelfld(ifield)) ! apply mask 

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz(e,r,l)
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      real e(1),r(1)
      integer l
      integer enx,eny,enz
      integer i

      real zero,one,onem
      zero =  0
      one  =  1
      onem = -1

c     apply mask (zeros Dirichlet nodes)
      !!!!! uncommenting
      call hsmg_do_wt(r,mg_mask(mg_mask_index(l,mg_fld)),
     $                mg_nh(l),mg_nh(l),mg_nhz(l))
      
c     go to extended size array (room for overlap)      
      if (if3d) then
         call hsmg_schwarz_toext3d(mg_work,r,mg_nh(l))
      else
         call hsmg_schwarz_toext2d(mg_work,r,mg_nh(l))
      endif
      
      enx=mg_nh(l)+2
      eny=mg_nh(l)+2
      enz=mg_nh(l)+2
      if(.not.if3d) enz=1
      i = enx*eny*enz*nelv+1

c     exchange interior nodes
      call hsmg_extrude(mg_work,0,zero,mg_work,2,one,enx,eny,enz)
      call hsmg_schwarz_dssum(mg_work,l)
      call hsmg_extrude(mg_work,0,one ,mg_work,2,onem,enx,eny,enz)

c     do the local solves
      call hsmg_fdm(mg_work(i),mg_work,l)
c     sum overlap region (border excluded)
      call hsmg_extrude(mg_work,0,zero,mg_work(i),0,one ,enx,eny,enz)
      call hsmg_schwarz_dssum(mg_work(i),l)
      call hsmg_extrude(mg_work(i),0,one ,mg_work,0,onem,enx,eny,enz)
      call hsmg_extrude(mg_work(i),2,one,mg_work(i),0,one,enx,eny,enz)
c     go back to regular size array
      if(.not.if3d) then
         call hsmg_schwarz_toreg2d(e,mg_work(i),mg_nh(l))
      else
         call hsmg_schwarz_toreg3d(e,mg_work(i),mg_nh(l))
      endif
c     sum border nodes
      call hsmg_dssum(e,l)
c     apply mask (zeros Dirichlet nodes)
      !!!!!! changing r to e
      call hsmg_do_wt(e,mg_mask(mg_mask_index(l,mg_fld)),
     $                mg_nh(l),mg_nh(l),mg_nhz(l))
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz_toext2d(a,b,n)
      include 'SIZE'
      integer n
      real a(0:n+1,0:n+1,nelv),b(n,n,nelv)
      
      integer i,j,ie
c      call rzero(a,(n+2)*(n+2)*nelv)
      do ie=1,nelv
         do i=0,n+1
            a(i,0,ie)=0.
         enddo
         do j=1,n
            a(0  ,j,ie)=0.
            do i=1,n
               a(i,j,ie)=b(i,j,ie)
            enddo
            a(n+1,j,ie)=0.
         enddo
         do i=0,n+1
            a(i,n+1,ie)=0.
         enddo
      enddo
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz_toext3d(a,b,n)
      include 'SIZE'
      integer n
      real a(0:n+1,0:n+1,0:n+1,nelv),b(n,n,n,nelv)
      
      integer i,j,k,ie
      call rzero(a,(n+2)*(n+2)*(n+2)*nelv)
      do ie=1,nelv
      do k=1,n
      do j=1,n
      do i=1,n
         a(i,j,k,ie)=b(i,j,k,ie)
      enddo
      enddo
      enddo
      enddo
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz_toreg2d(b,a,n)
      include 'SIZE'
      integer n
      real a(0:n+1,0:n+1,nelv),b(n,n,nelv)
      
      integer i,j,ie
      do ie=1,nelv
      do j=1,n
      do i=1,n
         b(i,j,ie)=a(i,j,ie)
      enddo
      enddo
      enddo
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz_toreg3d(b,a,n)
      include 'SIZE'
      integer n
      real a(0:n+1,0:n+1,0:n+1,nelv),b(n,n,n,nelv)
      
      integer i,j,k,ie
      do ie=1,nelv
      do k=1,n
      do j=1,n
      do i=1,n
         b(i,j,k,ie)=a(i,j,k,ie)
      enddo
      enddo
      enddo
      enddo
      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_fdm()
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      
      integer l,i,j,nl
      i = mg_fast_s_index(mg_lmax,mg_fld-1)
      j = mg_fast_d_index(mg_lmax,mg_fld-1)
      do l=2,mg_lmax
         mg_fast_s_index(l,mg_fld)=i
         nl = mg_nh(l)+2
         i=i+nl*nl*2*ldim*nelv
         if(i .gt. lmg_fasts*2*ldim*lelv) then
            itmp = i/(2*ldim*lelv)
            write(6,*) 'lmg_fasts too small',i,itmp,lmg_fasts,l
            call exitt
         endif
         mg_fast_d_index(l,mg_fld)=j
         j=j+(nl**ldim)*nelv
         if(j .gt. lmg_fastd*lelv) then
            itmp = i/(2*ldim*lelv)
            write(6,*) 'lmg_fastd too small',i,itmp,lmg_fastd,l
            call exitt
         endif
         call hsmg_setup_fast(
     $             mg_fast_s(mg_fast_s_index(l,mg_fld))
     $            ,mg_fast_d(mg_fast_d_index(l,mg_fld))
     $            ,mg_nh(l)+2,mg_ah(1,l),mg_bh(1,l),mg_nx(l))
      enddo
      mg_fast_s_index(l,mg_fld)=i
      mg_fast_d_index(l,mg_fld)=j
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_fdm()
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      
      integer l,i,j,nl
      i = mg_fast_s_index(mg_lmax,mg_fld-1)
      j = mg_fast_d_index(mg_lmax,mg_fld-1)
      do l=2,mg_lmax-1
         mg_fast_s_index(l,mg_fld)=i
         nl = mg_nh(l)+2
         i=i+nl*nl*2*ldim*nelv
         if(i .gt. lmg_fasts*2*ldim*lelv) then
            itmp = i/(2*ldim*lelv)
            write(6,*) 'lmg_fasts too small',i,itmp,lmg_fasts,l
            call exitt
         endif
         mg_fast_d_index(l,mg_fld)=j
         j=j+(nl**ldim)*nelv
         if(j .gt. lmg_fastd*lelv) then
            itmp = i/(2*ldim*lelv)
            write(6,*) 'lmg_fastd too small',i,itmp,lmg_fastd,l
            call exitt
         endif
         call hsmg_setup_fast(
     $             mg_fast_s(mg_fast_s_index(l,mg_fld))
     $            ,mg_fast_d(mg_fast_d_index(l,mg_fld))
     $            ,mg_nh(l)+2,mg_ah(1,l),mg_bh(1,l),mg_nx(l))
      enddo
      mg_fast_s_index(l,mg_fld)=i
      mg_fast_d_index(l,mg_fld)=j
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_fast(s,d,nl,ah,bh,n)
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      real s(nl*nl,2,ldim,nelv)
      real d(nl**ldim,nelv)
      real ah(1),bh(1)
      common /ctmpf/  lr(2*lx1+4),ls(2*lx1+4),lt(2*lx1+4)
     $              , llr(lelt),lls(lelt),llt(lelt)
     $              , lmr(lelt),lms(lelt),lmt(lelt)
     $              , lrr(lelt),lrs(lelt),lrt(lelt)
      real lr ,ls ,lt
      real llr,lls,llt
      real lmr,lms,lmt
      real lrr,lrs,lrt
      
      integer i,j,k
      integer ie,il,nr,ns,nt
      integer lbr,rbr,lbs,rbs,lbt,rbt,two
      real eps,diag
      
      two  = 2
      ierr = 0
      do ie=1,nelv
         call get_fast_bc(lbr,rbr,lbs,rbs,lbt,rbt,ie,two,ierr)
         nr=nl
         ns=nl
         nt=nl
         call hsmg_setup_fast1d(s(1,1,1,ie),lr,nr,lbr,rbr
     $            ,llr(ie),lmr(ie),lrr(ie),ah,bh,n,ie)
         call hsmg_setup_fast1d(s(1,1,2,ie),ls,ns,lbs,rbs
     $            ,lls(ie),lms(ie),lrs(ie),ah,bh,n,ie)
         if(if3d) call hsmg_setup_fast1d(s(1,1,3,ie),lt,nt,lbt,rbt
     $                     ,llt(ie),lmt(ie),lrt(ie),ah,bh,n,ie)
         il=1
         if(.not.if3d) then
            eps = 1.e-5*(vlmax(lr(2),nr-2) + vlmax(ls(2),ns-2))
            do j=1,ns
            do i=1,nr
               diag = lr(i)+ls(j)
               if (diag.gt.eps) then
                  d(il,ie) = 1.0/diag
               else
c                 write(6,2) ie,'Reset Eig in hsmg setup fast:',i,j,l
c    $                         ,eps,diag,lr(i),ls(j)
    2             format(i6,1x,a21,3i5,1p4e12.4)
                  d(il,ie) = 0.0
               endif
               il=il+1
            enddo
            enddo
         else
            eps = 1.e-5 * (vlmax(lr(2),nr-2)
     $                  + vlmax(ls(2),ns-2) + vlmax(lt(2),nt-2))
            do k=1,nt
            do j=1,ns
            do i=1,nr
               diag = lr(i)+ls(j)+lt(k)
               if (diag.gt.eps) then
                  d(il,ie) = 1.0/diag
               else
c                 write(6,3) ie,'Reset Eig in hsmg setup fast:',i,j,k,l
c    $                         ,eps,diag,lr(i),ls(j),lt(k)
    3             format(i6,1x,a21,4i5,1p5e12.4)
                  d(il,ie) = 0.0
               endif
               il=il+1
            enddo
            enddo
            enddo
         endif
      enddo

      ierrmx = iglmax(ierr,1)
      if (ierrmx.gt.0) then
         if (ierr.gt.0) write(6,*) nid,ierr,' BC FAIL'
         call exitti('A INVALID BC FOUND in genfast$',ierrmx)
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_fast1d(s,lam,nl,lbc,rbc,ll,lm,lr,ah,bh,n,ie)
      integer nl,lbc,rbc,n
      real s(nl,nl,2),lam(nl),ll,lm,lr
      real ah(0:n,0:n),bh(0:n)
      
      include 'SIZE'
      parameter(lxm=lx1+2)
      common /ctmp0/ b(2*lxm*lxm),w(2*lxm*lxm)
      
      call hsmg_setup_fast1d_a(s,lbc,rbc,ll,lm,lr,ah,n)
      call hsmg_setup_fast1d_b(b,lbc,rbc,ll,lm,lr,bh,n)
      
c     if (nid.eq.0) write(6,*) 'THIS is generalev call',nl,lbc
      call generalev(s,b,lam,nl,w)
      if(lbc.gt.0) call row_zero(s,nl,nl,1)
      if(lbc.eq.1) call row_zero(s,nl,nl,2)
      if(rbc.gt.0) call row_zero(s,nl,nl,nl)
      if(rbc.eq.1) call row_zero(s,nl,nl,nl-1)
      
      call transpose(s(1,1,2),nl,s,nl)
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_fast1d_a(a,lbc,rbc,ll,lm,lr,ah,n)
      integer lbc,rbc,n
      real a(0:n+2,0:n+2),ll,lm,lr
      real ah(0:n,0:n)
      
      real fac
      integer i,j,i0,i1
      i0=0
      if(lbc.eq.1) i0=1
      i1=n
      if(rbc.eq.1) i1=n-1
      
      call rzero(a,(n+3)*(n+3))
      fac = 2.0/lm
      a(1,1)=1.0
      a(n+1,n+1)=1.0
      do j=i0,i1
         do i=i0,i1
            a(i+1,j+1)=fac*ah(i,j)
         enddo
      enddo
      if(lbc.eq.0) then
         fac = 2.0/ll
         a(0,0)=fac*ah(n-1,n-1)
         a(1,0)=fac*ah(n  ,n-1)
         a(0,1)=fac*ah(n-1,n  )
         a(1,1)=a(1,1)+fac*ah(n  ,n  )
      else
         a(0,0)=1.0
      endif
      if(rbc.eq.0) then
         fac = 2.0/lr
         a(n+1,n+1)=a(n+1,n+1)+fac*ah(0,0)
         a(n+2,n+1)=fac*ah(1,0)
         a(n+1,n+2)=fac*ah(0,1)
         a(n+2,n+2)=fac*ah(1,1)
      else
         a(n+2,n+2)=1.0
      endif
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_fast1d_b(b,lbc,rbc,ll,lm,lr,bh,n)
      integer lbc,rbc,n
      real b(0:n+2,0:n+2),ll,lm,lr
      real bh(0:n)
      
      real fac
      integer i,j,i0,i1
      i0=0
      if(lbc.eq.1) i0=1
      i1=n
      if(rbc.eq.1) i1=n-1
      
      call rzero(b,(n+3)*(n+3))
      fac = 0.5*lm
      b(1,1)=1.0
      b(n+1,n+1)=1.0
      do i=i0,i1
         b(i+1,i+1)=fac*bh(i)
      enddo
      if(lbc.eq.0) then
         fac = 0.5*ll
         b(0,0)=fac*bh(n-1)
         b(1,1)=b(1,1)+fac*bh(n  )
      else
         b(0,0)=1.0
      endif
      if(rbc.eq.0) then
         fac = 0.5*lr
         b(n+1,n+1)=b(n+1,n+1)+fac*bh(0)
         b(n+2,n+2)=fac*bh(1)
      else
         b(n+2,n+2)=1.0
      endif
      return
      end
c----------------------------------------------------------------------
c     clobbers r
      subroutine hsmg_fdm(e,r,l)
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      call hsmg_do_fast(e,r,
     $      mg_fast_s(mg_fast_s_index(l,mg_fld)),
     $      mg_fast_d(mg_fast_d_index(l,mg_fld)),
     $      mg_nh(l)+2)
      return
      end
c----------------------------------------------------------------------
c     clobbers r
      subroutine hsmg_do_fast(e,r,s,d,nl)
      include 'SIZE'
      include 'INPUT'
      real e(nl**ldim,nelv)
      real r(nl**ldim,nelv)
      real s(nl*nl,2,ldim,nelv)
      real d(nl**ldim,nelv)
      
      integer ie,nn,i
      nn=nl**ldim
      if(.not.if3d) then
         do ie=1,nelv
            call hsmg_tnsr2d_el(e(1,ie),nl,r(1,ie),nl
     $                         ,s(1,2,1,ie),s(1,1,2,ie))
            do i=1,nn
               r(i,ie)=d(i,ie)*e(i,ie)
            enddo
            call hsmg_tnsr2d_el(e(1,ie),nl,r(1,ie),nl
     $                         ,s(1,1,1,ie),s(1,2,2,ie))
         enddo
      else
         do ie=1,nelv
            call hsmg_tnsr3d_el(e(1,ie),nl,r(1,ie),nl
     $                         ,s(1,2,1,ie),s(1,1,2,ie),s(1,1,3,ie))
            do i=1,nn
               r(i,ie)=d(i,ie)*e(i,ie)
            enddo
            call hsmg_tnsr3d_el(e(1,ie),nl,r(1,ie),nl
     $                         ,s(1,1,1,ie),s(1,2,2,ie),s(1,2,3,ie))
         enddo
      endif
      return
      end
c----------------------------------------------------------------------
c     u = wt .* u
      subroutine hsmg_do_wt(u,wt,nx,ny,nz)
      include 'SIZE'
      include 'INPUT'
      integer nx,ny,nz
      real u(nx,ny,nz,nelv)
      real wt(nx,nz,2,ldim,nelv)
      
      integer e

c     if (nx.eq.2) then
c        do e=1,nelv
c           call outmat(wt(1,1,1,1,e),nx,nz,'wt 1-1',e)
c           call outmat(wt(1,1,2,1,e),nx,nz,'wt 2-1',e)
c           call outmat(wt(1,1,1,2,e),nx,nz,'wt 1-2',e)
c           call outmat(wt(1,1,2,2,e),nx,nz,'wt 2-2',e)
c        enddo
c        call exitti('hsmg_do_wt quit$',nelv)
c     endif

      if (.not. if3d) then
         do ie=1,nelv
            do j=1,ny
               u( 1,j,1,ie)=u( 1,j,1,ie)*wt(j,1,1,1,ie)
               u(nx,j,1,ie)=u(nx,j,1,ie)*wt(j,1,2,1,ie)
            enddo
            do i=2,nx-1
               u(i, 1,1,ie)=u(i, 1,1,ie)*wt(i,1,1,2,ie)
               u(i,ny,1,ie)=u(i,ny,1,ie)*wt(i,1,2,2,ie)
            enddo
         enddo
      else
         do ie=1,nelv
            do k=1,nz
            do j=1,ny
               u( 1,j,k,ie)=u( 1,j,k,ie)*wt(j,k,1,1,ie)
               u(nx,j,k,ie)=u(nx,j,k,ie)*wt(j,k,2,1,ie)
            enddo
            enddo
            do k=1,nz
            do i=2,nx-1
               u(i, 1,k,ie)=u(i, 1,k,ie)*wt(i,k,1,2,ie)
               u(i,ny,k,ie)=u(i,ny,k,ie)*wt(i,k,2,2,ie)
            enddo
            enddo
            do j=2,ny-1
            do i=2,nx-1
               u(i,j, 1,ie)=u(i,j, 1,ie)*wt(i,j,1,3,ie)
               u(i,j,nz,ie)=u(i,j,nz,ie)*wt(i,j,2,3,ie)
            enddo
            enddo
         enddo
      endif
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_rstr_wt(wt,nx,ny,nz,l,w)
      include 'SIZE'
      include 'INPUT'
      integer nx,ny,nz,l
      real w(nx,ny,nz,nelv)
      real wt(nx,nz,2,ldim,nelv)
      
      integer ie
      !init border nodes to 1
      call rzero(w,nx*ny*nz*nelv)
c     print *, 'Setup rstr wt: ',nx,ny,nz,nelv
      if (.not.if3d) then
         do ie=1,nelv
            do i=1,nx
               w(i,1,1,ie)=1.0
               w(i,ny,1,ie)=1.0
            enddo
            do j=1,ny
               w(1,j,1,ie)=1.0
               w(nx,j,1,ie)=1.0
            enddo
         enddo
      else
         do ie=1,nelv
            do j=1,ny
            do i=1,nx
               w(i,j,1,ie)=1.0
               w(i,j,nz,ie)=1.0
            enddo
            enddo
            do k=1,nz
            do i=1,nx
               w(i,1,k,ie)=1.0
               w(i,ny,k,ie)=1.0
            enddo
            enddo
            do k=1,nz
            do j=1,ny
               w(1,j,k,ie)=1.0
               w(nx,j,k,ie)=1.0
            enddo
            enddo
         enddo
      endif
      call hsmg_dssum(w,l)
      !invert the count w to get the weight wt
      if (.not. if3d) then
         do ie=1,nelv
            do j=1,ny
               wt(j,1,1,1,ie)=1.0/w(1,j,1,ie)
               wt(j,1,2,1,ie)=1.0/w(nx,j,1,ie)
            enddo
            do i=1,nx
               wt(i,1,1,2,ie)=1.0/w(i,1,1,ie)
               wt(i,1,2,2,ie)=1.0/w(i,ny,1,ie)
            enddo
         enddo
      else
         do ie=1,nelv
            do k=1,nz
            do j=1,ny
               wt(j,k,1,1,ie)=1.0/w(1,j,k,ie)
               wt(j,k,2,1,ie)=1.0/w(nx,j,k,ie)
            enddo
            enddo
            do k=1,nz
            do i=1,nx
               wt(i,k,1,2,ie)=1.0/w(i,1,k,ie)
               wt(i,k,2,2,ie)=1.0/w(i,ny,k,ie)
            enddo
            enddo
            do j=1,ny
            do i=1,nx
               wt(i,j,1,3,ie)=1.0/w(i,j,1,ie)
               wt(i,j,2,3,ie)=1.0/w(i,j,nz,ie)
            enddo
            enddo
         enddo
      endif
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_mask(wt,nx,ny,nz,l,w)
      include 'SIZE'
      include 'INPUT'
      integer nx,ny,nz,l
      real w(nx,ny,nz,nelv)
      real wt(nx,nz,2,ldim,nelv)
      
      integer ie
      integer lbr,rbr,lbs,rbs,lbt,rbt,two
c     init everything to 1

      n = nx*ny*nz*nelv
      call rone(w,n)

c     set dirichlet nodes to zero
      ierr = 0
      two  = 2
      do ie=1,nelv
         call get_fast_bc(lbr,rbr,lbs,rbs,lbt,rbt,ie,two,ierr)
         if (ierr.ne.0) then
            ierr = -1
            call get_fast_bc(lbr,rbr,lbs,rbs,lbt,rbt,ie,two,ierr)
         endif

         if(lbr.eq.1) then
            do k=1,nz
            do j=1,ny
               w(1,j,k,ie)=0.0
            enddo
            enddo
         endif
         if(rbr.eq.1) then
            do k=1,nz
            do j=1,ny
               w(nx,j,k,ie)=0.0
            enddo
            enddo
         endif
         if(lbs.eq.1) then
            do k=1,nz
            do i=1,nx
               w(i,1,k,ie)=0.0
            enddo
            enddo
         endif
         if(rbs.eq.1) then
            do k=1,nz
            do i=1,nx
               w(i,ny,k,ie)=0.0
            enddo
            enddo
         endif
         if(if3d) then
            if(lbt.eq.1) then
               do j=1,ny
               do i=1,nx
                  w(i,j,1,ie)=0.0
               enddo
               enddo
            endif
            if(rbt.eq.1) then
               do j=1,ny
               do i=1,nx
                  w(i,j,nz,ie)=0.0
               enddo
               enddo
            endif
         endif
      enddo
c     do direct stiffness multiply

      call hsmg_dsprod(w,l)


c     store weight
      if (.not. if3d) then
         do ie=1,nelv
            do j=1,ny
               wt(j,1,1,1,ie)=w(1,j,1,ie)
               wt(j,1,2,1,ie)=w(nx,j,1,ie)
            enddo
            do i=1,nx
               wt(i,1,1,2,ie)=w(i,1,1,ie)
               wt(i,1,2,2,ie)=w(i,ny,1,ie)
            enddo
         enddo
      else
         do ie=1,nelv
            do k=1,nz
            do j=1,ny
               wt(j,k,1,1,ie)=w(1,j,k,ie)
               wt(j,k,2,1,ie)=w(nx,j,k,ie)
            enddo
            enddo
            do k=1,nz
            do i=1,nx
               wt(i,k,1,2,ie)=w(i,1,k,ie)
               wt(i,k,2,2,ie)=w(i,ny,k,ie)
            enddo
            enddo
            do k=1,nz
            do j=1,ny
               wt(j,k,1,3,ie)=w(i,j,1,ie)
               wt(j,k,2,3,ie)=w(i,j,nz,ie)
            enddo
            enddo
         enddo
      endif

      ierrmx = iglmax(ierr,1)
      if (ierrmx.gt.0) then
         if (ierr.gt.0) write(6,*) nid,ierr,' BC FAIL'
         call exitti('B INVALID BC FOUND in genfast$',ierrmx)
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_schwarz_wt(ifsqrt)
      logical ifsqrt
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      
      integer l,i,nl,nlz

      i = mg_schwarz_wt_index(mg_lmax,mg_fld-1)
      do l=2,mg_lmax-1
         mg_schwarz_wt_index(l,mg_fld)=i
         nl = mg_nh(l)
         nlz = mg_nh(l)
         if(.not.if3d) nlz=1
         i=i+nl*nlz*4*ldim*nelv
         if(i .gt. lmg_swt*4*ldim*lelv) then
            itmp = i/(4*ldim*lelv)
            write(6,*) 'lmg_swt too small',i,itmp,lmg_swt,l
            call exitt
         endif

         call h1mg_setup_schwarz_wt_1(
     $      mg_schwarz_wt(mg_schwarz_wt_index(l,mg_fld)),l,ifsqrt)

      enddo
      mg_schwarz_wt_index(l,mg_fld)=i

      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_schwarz_wt(ifsqrt)
      logical ifsqrt
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      
      integer l,i,nl,nlz

      i = mg_schwarz_wt_index(mg_lmax,mg_fld-1)
      do l=2,mg_lmax

         mg_schwarz_wt_index(l,mg_fld)=i
         nl  = mg_nh(l)
         nlz = mg_nhz(l)
         i   = i+nl*nlz*4*ldim*nelv

         if (i .gt. lmg_swt*4*ldim*lelv) then
            itmp = i/(4*ldim*lelv)
            write(6,*) 'lmg_swt too small',i,itmp,lmg_swt,l
            call exitt
         endif

         call h1mg_setup_schwarz_wt_1(
     $      mg_schwarz_wt(mg_schwarz_wt_index(l,mg_fld)),l,ifsqrt)

      enddo

      mg_schwarz_wt_index(l,mg_fld)=i

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz_wt(e,l)
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      
      if(.not.if3d) call hsmg_schwarz_wt2d(
     $    e,mg_schwarz_wt(mg_schwarz_wt_index(l,mg_fld)),mg_nh(l))
      if(if3d) call hsmg_schwarz_wt3d(
     $    e,mg_schwarz_wt(mg_schwarz_wt_index(l,mg_fld)),mg_nh(l))
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz_wt2d(e,wt,n)
      include 'SIZE'
      integer n
      real e(n,n,nelv)
      real wt(n,4,2,nelv)
      
      integer ie,i,j
      do ie=1,nelv
         do j=1,n
            e(1  ,j,ie)=e(1  ,j,ie)*wt(j,1,1,ie)
            e(2  ,j,ie)=e(2  ,j,ie)*wt(j,2,1,ie)
            e(n-1,j,ie)=e(n-1,j,ie)*wt(j,3,1,ie)
            e(n  ,j,ie)=e(n  ,j,ie)*wt(j,4,1,ie)
         enddo
         do i=3,n-2
            e(i,1  ,ie)=e(i,1  ,ie)*wt(i,1,2,ie)
            e(i,2  ,ie)=e(i,2  ,ie)*wt(i,2,2,ie)
            e(i,n-1,ie)=e(i,n-1,ie)*wt(i,3,2,ie)
            e(i,n  ,ie)=e(i,n  ,ie)*wt(i,4,2,ie)
         enddo
      enddo
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_schwarz_wt3d(e,wt,n)
      include 'SIZE'
      integer n
      real e(n,n,n,nelv)
      real wt(n,n,4,3,nelv)
      
      integer ie,i,j,k
      do ie=1,nelv
         do k=1,n
         do j=1,n
            e(1  ,j,k,ie)=e(1  ,j,k,ie)*wt(j,k,1,1,ie)
            e(2  ,j,k,ie)=e(2  ,j,k,ie)*wt(j,k,2,1,ie)
            e(n-1,j,k,ie)=e(n-1,j,k,ie)*wt(j,k,3,1,ie)
            e(n  ,j,k,ie)=e(n  ,j,k,ie)*wt(j,k,4,1,ie)
         enddo
         enddo
         do k=1,n
         do i=3,n-2
            e(i,1  ,k,ie)=e(i,1  ,k,ie)*wt(i,k,1,2,ie)
            e(i,2  ,k,ie)=e(i,2  ,k,ie)*wt(i,k,2,2,ie)
            e(i,n-1,k,ie)=e(i,n-1,k,ie)*wt(i,k,3,2,ie)
            e(i,n  ,k,ie)=e(i,n  ,k,ie)*wt(i,k,4,2,ie)
         enddo
         enddo
         do j=3,n-2
         do i=3,n-2
            e(i,j,1  ,ie)=e(i,j,1  ,ie)*wt(i,j,1,3,ie)
            e(i,j,2  ,ie)=e(i,j,2  ,ie)*wt(i,j,2,3,ie)
            e(i,j,n-1,ie)=e(i,j,n-1,ie)*wt(i,j,3,3,ie)
            e(i,j,n  ,ie)=e(i,j,n  ,ie)*wt(i,j,4,3,ie)
         enddo
         enddo
      enddo
      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_coarse_solve(e,r)
      include 'SIZE'
      include 'DOMAIN'
      include 'ESOLV'
      include 'GEOM'
      include 'SOLN'
      include 'PARALLEL'
      include 'HSMG'
      include 'CTIMER'
      include 'INPUT'
      include 'TSTEP'
      real e(1),r(1)
c
      integer n_crs_tot
      save    n_crs_tot
      data    n_crs_tot /0/
c
      if (icalld.eq.0) then ! timer info
         ncrsl=0
         tcrsl=0.0
      endif
      icalld = 1

      if (ifsync) call nekgsync()

      ncrsl  = ncrsl  + 1
      etime1=dnekclock()

      call fgslib_crs_solve(xxth(ifield),e,r)

      tcrsl=tcrsl+dnekclock()-etime1

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_solve
      include 'SIZE'
      include 'HSMG'
      
      integer l,i,nl,nlz
      i = mg_solve_index(mg_lmax+1,mg_fld-1)
      do l=1,mg_lmax
         mg_solve_index(l,mg_fld)=i
         i=i+mg_nh(l)*mg_nh(l)*mg_nhz(l)*nelv
         if(i .gt. lmg_solve*lelv) then
            itmp = i/lelv
            write(6,*) 'lmg_solve too small',i,itmp,lmg_solve,l
            call exitt
         endif
      enddo
      mg_solve_index(l,mg_fld)=i

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_solve(e,r)
      real e(1),r(1)
      include 'SIZE'
      include 'HSMG'
      include 'GEOM'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'
      include 'CTIMER'
      include 'PARALLEL'
      
      common /quick/ ecrs  (2)  ! quick work array
     $             , ecrs2 (2)  ! quick work array
c     common /quick/ ecrs  (lx2*ly2*lz2*lelv)  ! quick work array
c    $             , ecrs2 (lx2*ly2*lz2*lelv)  ! quick work array

      common /scrhi/ h2inv (lx1,ly1,lz1,lelv)
      common /scrvh/ h1    (lx1,ly1,lz1,lelv),
     $               h2    (lx1,ly1,lz1,lelv)
      
      integer ilstep,iter
      save    ilstep,iter
      data    ilstep,iter /0,0/

      real    rhoavg,copt(2),copw(2)
      save    rhoavg,copt1,copt2
      data    rhoavg,copt1,copt2 /3*1./  ! Default copt = 1 for additive

      integer l,nt
      integer*8 ntotg,nxyz2

      logical if_hybrid

      mg_fld = 1
      if (ifield.gt.1) mg_fld = 2

      if (istep.ne.ilstep) then
         ilstep = istep
         ntot1  = lx1*ly1*lz1*nelv
         rhoavg = glsc2(vtrans,bm1,ntot1)/volvm1
      endif

      n = lx2*ly2*lz2*nelv
c     call copy(e,r,n)
c     return
 
      if (icalld.eq.0) then

         tddsl=0.0
         nddsl=0

         icalld = 1
         taaaa = 0
         tbbbb = 0
         tcccc = 0
         tdddd = 0
         teeee = 0
      endif

      nddsl  = nddsl  + 1
      etime1 = dnekclock()

      
c     n = lx2*ly2*lz2*nelv
c     rmax = glmax(r,n)
c     if (nid.eq.0) write(6,*) istep,n,rmax,' rmax1'
       
      iter = iter + 1      

      l = mg_lmax
      nt = mg_nh(l)*mg_nh(l)*mg_nhz(l)*nelv
      ! e := W M        r
      !         Schwarz
      time_0 = dnekclock()
      call local_solves_fdm(e,r)

      time_1 = dnekclock()

c     if (param(41).eq.1) if_hybrid = .true.
      if_hybrid = .false.

      if (if_hybrid) then
         ! w := E e
         rbd1dt = rhoavg*bd(1)/dt ! Assumes constant density!!!
         call cdabdtp(mg_work2,e,h1,h2,h2inv,1)
         call cmult  (mg_work2,rbd1dt,nt)
         time_2 = dnekclock()
         if (istep.eq.1) then
            copt(1)  = vlsc2(r       ,mg_work2,nt)
            copt(2)  = vlsc2(mg_work2,mg_work2,nt)
            call gop(copt,copw,'+  ', 2)
            copt(1)  = copt(1)/copt(2)
            avg2     = 1./iter
            avg1     = 1.-avg2
            copt1    = avg1*copt1 + avg2*copt(1)
            if(nio.eq.0)write(6,1)istep,iter,rbd1dt,copt(1),copt1,'cpt1'
    1       format(2i6,1p3e14.5,2x,a4)
         endif
         ! w := r - w
         do i = 1,nt
            mg_work2(i) = r(i) - copt1*mg_work2(i)
            e       (i) = copt1*e(i)
            ecrs2   (i) = mg_work2(i)
         enddo

      else   ! Additive
         ! w := r - w
         do i = 1,nt
            mg_work2(i) = r(i)
         enddo
         time_2 = dnekclock()
      endif
 
      do l = mg_lmax-1,2,-1

c        rmax = glmax(mg_work2,nt)
c        if (nid.eq.0) write(6,*) l,nt,rmax,' rmax2'

         nt = mg_nh(l)*mg_nh(l)*mg_nhz(l)*nelv
         !          T
         ! r   :=  J w
         !  l         
         call hsmg_rstr(mg_solve_r(mg_solve_index(l,mg_fld)),mg_work2,l)

         ! w  := r
         !        l
         call copy(mg_work2,mg_solve_r(mg_solve_index(l,mg_fld)),nt)
         ! e  := M        w
         !  l     Schwarz  
         call hsmg_schwarz(
     $          mg_solve_e(mg_solve_index(l,mg_fld)),mg_work2,l)

         ! e  := W e
         !  l       l
         call hsmg_schwarz_wt(mg_solve_e(mg_solve_index(l,mg_fld)),l)

c        call exitti('quit in mg$',l)

         ! w  := r  - w
         !        l
         do i = 0,nt-1
            mg_work2(i+1) = mg_solve_r(mg_solve_index(l,mg_fld)+i)
     $         !-alpha*mg_work2(i+1)
         enddo
      enddo

      call hsmg_rstr_no_dssum(
     $   mg_solve_r(mg_solve_index(1,mg_fld)),mg_work2,1)

      nzw = ldim-1

      call hsmg_do_wt(mg_solve_r(mg_solve_index(1,mg_fld)),
     $                mg_mask(mg_mask_index(1,mg_fld)),2,2,nzw)

      !        -1
      ! e  := A   r
      !  1         1
      call hsmg_coarse_solve(mg_solve_e(mg_solve_index(1,mg_fld)),
     $                       mg_solve_r(mg_solve_index(1,mg_fld)))

      call hsmg_do_wt(mg_solve_e(mg_solve_index(1,mg_fld)),
     $                mg_mask(mg_mask_index(1,mg_fld)),2,2,nzw)
      time_3 = dnekclock()
      do l = 2,mg_lmax-1
         nt = mg_nh(l)*mg_nh(l)*mg_nhz(l)*nelv
         ! w   :=  J e
         !            l-1
         call hsmg_intp
     $      (mg_work2,mg_solve_e(mg_solve_index(l-1,mg_fld)),l-1)

         ! e   :=  e  + w
         !  l       l
         do i = 0,nt-1
            mg_solve_e(mg_solve_index(l,mg_fld)+i) =
     $        + mg_solve_e(mg_solve_index(l,mg_fld)+i) + mg_work2(i+1)
         enddo
      enddo
      l = mg_lmax
      nt = mg_nh(l)*mg_nh(l)*mg_nhz(l)*nelv
      ! w   :=  J e
      !            m-1

      call hsmg_intp(mg_work2,
     $   mg_solve_e(mg_solve_index(l-1,mg_fld)),l-1)

      if (if_hybrid.and.istep.eq.1) then
         ! ecrs := E e_c
         call cdabdtp(ecrs,mg_work2,h1,h2,h2inv,1)
         call cmult  (ecrs,rbd1dt,nt)
         copt(1)  = vlsc2(ecrs2,ecrs,nt)
         copt(2)  = vlsc2(ecrs ,ecrs,nt)
         call gop(copt,copw,'+  ', 2)
         copt(1)  = copt(1)/copt(2)
         avg2     = 1./iter
         avg1     = 1.-avg2
         copt2    = avg1*copt2 + avg2*copt(1)
         if(nio.eq.0)write(6,1)istep,iter,rbd1dt,copt(1),copt2,'cpt2'
      endif
      ! e := e + w

      do i = 1,nt
         e(i) = e(i) + copt2*mg_work2(i)
      enddo
      time_4 = dnekclock()
c     print *, 'Did an MG iteration'
c
      taaaa = taaaa + (time_1 - time_0)
      tbbbb = tbbbb + (time_2 - time_1)
      tcccc = tcccc + (time_3 - time_2)
      tdddd = tdddd + (time_4 - time_3)
      teeee = teeee + (time_4 - time_0)
c
c     A typical time breakdown:
c
c  1.3540E+01  5.4390E+01  1.1440E+01  1.2199E+00  8.0590E+01 HSMG time
c
c  ==>  54/80 = 67 % of preconditioner time is in residual evaluation!
c
      call ortho (e)

      tddsl  = tddsl + ( dnekclock()-etime1 )



      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_setup_mg_nx()
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'HSMG'
      include 'SEMHAT'
      real w(lx1+2)
      integer nf,nc,nr
      integer nx,ny,nz

      integer mgn2(10)
      save    mgn2
      data    mgn2 / 1, 2, 2, 2, 2, 3, 3, 5, 5, 5/
c     data    mgn2 / 1, 2, 3, 4, 5, 6, 7, 8, 9, 0

c     if (param(82).eq.0) param(82)=2  ! nek default
c     if (np.eq.1)        param(82)=2  ! single proc. too slow
      p82 = 2                          ! potentially variable nxc
      mg_lmax = 3
c     mg_lmax = 4
      if (lx1.eq.4) mg_lmax = 2
c     if (param(79).ne.0) mg_lmax = param(79)
      mglx1    = p82-1 !1
      mg_nx(1) = mglx1
      mg_ny(1) = mglx1
      mg_nz(1) = mglx1
      if (.not.if3d) mg_nz(1) = 0 

      mglx2 = 2*(lx2/4) + 1
      if (lx1.eq.5)  mglx2 = 3
c     if (lx1.eq.6)  mglx2 = 3
      if (lx1.le.10) mglx2 = mgn2(lx1)
      if (lx1.eq.8)  mglx2 = 4
      if (lx1.eq.8)  mglx2 = 3

c     mglx2 = min(3,mglx2)  
      

      mg_nx(2) = mglx2
      mg_ny(2) = mglx2
      mg_nz(2) = mglx2
      if (.not.if3d) mg_nz(2) = 0 

      mg_nx(3) = mglx2+1
      mg_ny(3) = mglx2+1
      mg_nz(3) = mglx2+1
      if (.not.if3d) mg_nz(3) = 0 

      mg_nx(mg_lmax) = lx1-1
      mg_ny(mg_lmax) = ly1-1
      mg_nz(mg_lmax) = lz1-1

      if (nio.eq.0) write(*,*) 'mg_nx:',(mg_nx(i),i=1,mg_lmax)
      if (nio.eq.0) write(*,*) 'mg_ny:',(mg_ny(i),i=1,mg_lmax)
      if (nio.eq.0) write(*,*) 'mg_nz:',(mg_nz(i),i=1,mg_lmax)

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_index_0 ! initialize index sets
      include 'SIZE'
      include 'HSMG'

      n = lmgn*(lmgs+1)

      call izero( mg_rstr_wt_index      , n )
      call izero( mg_mask_index         , n )
      call izero( mg_solve_index        , n )
      call izero( mg_fast_s_index       , n )
      call izero( mg_fast_d_index       , n )
      call izero( mg_schwarz_wt_index   , n )
      
      return
      end
c----------------------------------------------------------------------
      subroutine outfldn (x,n,txt10,ichk) ! writes into unit=40+ifiled
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      real x(n,n,1,lelt)
      character*10 txt10
c
      integer idum,e
      save    idum
      data    idum /3/
      if (idum.lt.0)   return
      m = 40 + ifield                 ! unit #
c
C
      mtot = n*n*nelv
      if (n.gt.7.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)
c
      rnel = nelv
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nelv-ne+1
      do ie=ne1,1,-ne
         l=ie-1
         do k=1,1
            if (ie.eq.ne1) write(m,116) txt10,k,ie,xmin,xmax,ichk,time
            write(m,117) 
            do j=n,1,-1
              if (n.eq.2) write(m,102) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.3) write(m,103) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.4) write(m,104) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.5) write(m,105) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.6) write(m,106) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.7) write(m,107) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.8) write(m,108) ((x(i,j,k,e+l),i=1,n),e=1,ne)
            enddo
         enddo
      enddo

C
  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f9.5,5x,6f9.5)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
c
  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5)
  117 FORMAT(' ')
c
c     if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldn0 (x,n,txt10,ichk)
      INCLUDE 'SIZE'
      INCLUDE 'TSTEP'
      real x(n,n,1,lelt)
      character*10 txt10
c
      integer idum,e
      save idum
      data idum /3/
      if (idum.lt.0) return
c
C
      mtot = n*n*nelv
      if (n.gt.7.or.nelv.gt.16) return
      xmin = glmin(x,mtot)
      xmax = glmax(x,mtot)
c
      rnel = nelv
      snel = sqrt(rnel)+.1
      ne   = snel
      ne1  = nelv-ne+1
      do ie=ne1,1,-ne
         l=ie-1
         do k=1,1
            if (ie.eq.ne1) write(6,116) txt10,k,ie,xmin,xmax,ichk,time
            write(6,117) 
            do j=n,1,-1
              if (n.eq.2) write(6,102) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.3) write(6,103) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.4) write(6,104) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.5) write(6,105) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.6) write(6,106) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.7) write(6,107) ((x(i,j,k,e+l),i=1,n),e=1,ne)
              if (n.eq.8) write(6,108) ((x(i,j,k,e+l),i=1,n),e=1,ne)
            enddo
         enddo
      enddo

C
  102 FORMAT(4(2f9.5,2x))
  103 FORMAT(4(3f9.5,2x))
  104 FORMAT(4(4f7.3,2x))
  105 FORMAT(5f9.5,10x,5f9.5)
  106 FORMAT(6f9.5,5x,6f9.5)
  107 FORMAT(7f8.4,5x,7f8.4)
  108 FORMAT(8f8.4,4x,8f8.4)
c
  116 FORMAT(  /,5X,'     ^              ',/,
     $    5X,'   Y |              ',/,
     $    5X,'     |              ',A10,/,
     $    5X,'     +---->         ','Plane = ',I2,'/',I2,2x,2e12.4,/,
     $    5X,'       X            ','Step  =',I9,f15.5)
  117 FORMAT(' ')
c
c     if (ichk.eq.1.and.idum.gt.0) call checkit(idum)
      return
      end
c-----------------------------------------------------------------------
      subroutine outflda (x,n,txt10,ichk) ! writes into unit=p130+ifiled
      INCLUDE 'SIZE'                      ! or into std. output for p130<9
      INCLUDE 'TSTEP'                     ! truncated below eps=p131
      INCLUDE 'INPUT'                     ! param(130)
      real x(1)
      character*10 txt10                  ! note: n is not used
c     parameter (eps=1.e-7)
C
      p130 = param(130)
      eps  = param(131)
      if (p130.le.0)    return
      m    = 6
      if (p130.gt.9)  m = p130 + ifield

      ntot = lx1*ly1*lz1*nelfld(ifield)

      xmin = glmin(x,ntot)
      xmax = glmax(x,ntot)
      xavg = glsum(x,ntot)/ntot

      if (abs(xavg).lt.eps) xavg = 0.     ! truncation

      if (nid.eq.0) write(m,10) txt10,ichk,ntot,xavg,xmin,xmax

   10 format(3X,a10,2i8,' pts, avg,min,max = ',1p3g14.6)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine outfldan(x,n,txt10,ichk) ! writes x(1:n) into unit=p130+ifiled
      INCLUDE 'SIZE'                      ! or into std. output for 0<p130<9
      INCLUDE 'TSTEP'                     ! truncated below eps=p131
      INCLUDE 'INPUT'
      real x(1)
      character*10 txt10
c     parameter (eps=1.e-7)
C
      p130 = param(130)
      eps  = param(131)
      if (p130.le.0)    return
      m    = 6
      if (p130.gt.9)  m = p130 + ifield

      ntot = n

      xmin = glmin(x,ntot)
      xmax = glmax(x,ntot)
      xavg = glsum(x,ntot)/ntot

      if (abs(xavg).lt.eps) xavg = 0.     ! truncation

      if (nid.eq.0) write(m,10) txt10,ichk,ntot,xavg,xmin,xmax

   10 format(3X,a10,2i8,' pts, avg,min,max = ',1p3g11.3)
c  10 format(3X,a10,2i8,' pts, avg,min,max = ',1p3g14.6)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine h1mg_solve(z,rhs,if_hybrid)  !  Solve preconditioner: Mz=rhs
      real z(1),rhs(1)

c     Assumes that preprocessing has been completed via h1mg_setup()


      include 'SIZE'
      include 'HSMG'       ! Same array space as HSMG
      include 'GEOM'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'
      include 'CTIMER'
      include 'PARALLEL'
      
      common /scrhi/ h2inv (lx1,ly1,lz1,lelv)
      common /scrvh/ h1    (lx1,ly1,lz1,lelv),
     $               h2    (lx1,ly1,lz1,lelv)
      parameter (lt=lx1*ly1*lz1*lelt)
      common /scrmg/ e(2*lt),w(lt),r(lt)
      integer p_msk,p_b
      logical if_hybrid

c     if_hybrid = .true.    ! Control this from gmres, according
c     if_hybrid = .false.   ! to convergence efficiency

      nel   = nelfld(ifield)

      op    =  1.                                     ! Coefficients for h1mg_ax
      om    = -1.
      sigma =  1.
      if (if_hybrid) sigma = 2./3.

      l     = mg_h1_lmax
      n     = mg_h1_n(l,mg_fld)
      is    = 1                                       ! solve index

      call h1mg_schwarz(z,rhs,sigma,l)                ! z := sigma W M       rhs
                                                      !               Schwarz
      call copy(r,rhs,n)                              ! r  := rhs
      if (if_hybrid) call h1mg_axm(r,z,op,om,l,w)     ! r  := rhs - A z
                                                      !  l

      do l = mg_h1_lmax-1,2,-1                        ! DOWNWARD Leg of V-cycle
         is = is + n
         n  = mg_h1_n(l,mg_fld)
                                                      !          T
         call h1mg_rstr(r,l,.true.)                   ! r   :=  J r
                                                      !  l         l+1
!        OVERLAPPING Schwarz exchange and solve:
         call h1mg_schwarz(e(is),r,sigma,l)           ! e := sigma W M       r
                                                      !  l            Schwarz l

         if(if_hybrid)call h1mg_axm(r,e(is),op,om,l,w)! r  := r - A e
                                                      !  l           l
      enddo
      is = is+n
                                                      !         T
      call h1mg_rstr(r,1,.false.)                     ! r  :=  J  r
                                                      !  l         l+1
      p_msk = p_mg_msk(l,mg_fld)
      call h1mg_mask(r,mg_imask(p_msk),nel)           !        -1
      call hsmg_coarse_solve ( e(is) , r )            ! e  := A   r
      call h1mg_mask(e(is),mg_imask(p_msk),nel)       !  1     1   1

c     nx = mg_nh(1)
c     call outnxfld (e(is),nx,nelv,'ecrsb4',is)
c     call h1mg_mask(e(is),mg_imask(p_msk),nel)       !  1     1   1
c     call outnxfld (e(is),nx,nelv,'ecrsaf',is)
c     call exitt

      do l = 2,mg_h1_lmax-1                           ! UNWIND.  No smoothing.
         im = is
         is = is - n
         n  = mg_h1_n(l,mg_fld)
         call hsmg_intp (w,e(im),l-1)                 ! w   :=  J e
         i1=is-1                                      !            l-1
         do i=1,n
            e(i1+i) = e(i1+i) + w(i)                  ! e   :=  e  + w
         enddo                                        !  l       l
      enddo

      l  = mg_h1_lmax
      n  = mg_h1_n(l,mg_fld)
      im = is  ! solve index
      call hsmg_intp(w,e(im),l-1)                     ! w   :=  J e
      do i = 1,n                                      !            l-1
         z(i) = z(i) + w(i)                           ! z := z + w
      enddo

      call dsavg(z) ! Emergency hack --- to ensure continuous z!

      return
      end
c-----------------------------------------------------------------------
      subroutine h1mg_axm(w,p,aw,ap,l,wk)
c
c     w  := aw*w + ap*H*p, level l, with mask and dssum
c
c     Hu := div. h1 grad u + h2 u
c
c        ~= h1 A u + h2 B u
c
c     Here, we assume that pointers into g() and h1() and h2() have
c     been established
c
      include 'SIZE'
      include 'HSMG'
      include 'TSTEP'  ! nelfld

      real w(1),p(1),wk(1)

      integer p_h1,p_h2,p_g,p_b,p_msk
      logical ifh2

      p_h1  = p_mg_h1  (l,mg_fld)
      p_h2  = p_mg_h2  (l,mg_fld)
      p_g   = p_mg_g   (l,mg_fld)
      p_b   = p_mg_b   (l,mg_fld)
      p_msk = p_mg_msk (l,mg_fld)

      if (p_h1 .eq.0) call mg_set_h1  (p_h1 ,l)
      if (p_h2 .eq.0) call mg_set_h2  (p_h2 ,l)
      if (p_g  .eq.0) call mg_set_gb  (p_g,p_b,l)
      if (p_msk.eq.0) call mg_set_msk (p_msk,l)

      ifh2 = .true.
      if (p_h2.eq.0) ifh2 = .false.  ! Need a much better mech.
      ifh2 = .false.

      nx = mg_nh(l)
      ny = mg_nh(l)
      nz = mg_nhz(l)
      ng = 3*ldim-3


      call h1mg_axml (wk,p
     $               ,mg_h1(p_h1),mg_h2(p_h2),nx,ny,nz,nelfld(ifield)
     $               ,mg_g (p_g) , ng ,mg_b(p_b), mg_imask(p_msk),ifh2)


      call hsmg_dssum (wk,l)

      n = nx*ny*nz*nelfld(ifield)
      call add2sxy    (w,aw,wk,ap,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine h1mg_axml
     $  (w,p,h1,h2,nx,ny,nz,nel,g,ng,b,mask,ifh2)
c
c     w  := aw*w + ap*H*p, level l, with mask and dssum
c
c     Hu := div. h1 grad u + h2 u
c
c        ~= h1 A u + h2 B u
c

      include 'SIZE'
      include 'TOTAL'
      include 'HSMG'

      real w (nx*ny*nz,nel), p (nx*ny*nz,nel)
     $   , h1(nx*ny*nz,nel), h2(nx*ny*nz,nel)
     $   , b (nx*ny*nz,nel), g (ng*nx*ny*nz,nel)
      integer mask(1)

      logical ifh2

      parameter (lxyz=lx1*ly1*lz1)
      common /ctmp0/ ur(lxyz),us(lxyz),ut(lxyz)

      integer e

      do e=1,nel

         call axe(w(1,e),p(1,e),h1(1,e),h2(1,e),g(1,e),ng,b(1,e)
     $            ,nx,ny,nz,ur,us,ut,ifh2,ifrzer(e),e)
   
         im = mask(e)
         call mg_mask_e(w,mask(im)) ! Zero out Dirichlet conditions

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine h1mg_mask(w,mask,nel)
      include 'SIZE'

      real    w   (1)
      integer mask(1)        ! Pointer to Dirichlet BCs
      integer e
      
      do e=1,nel
         im = mask(e)
         call mg_mask_e(w,mask(im)) ! Zero out Dirichlet conditions
      enddo

      return
      end
c----------------------------------------------------------------------
      subroutine mg_mask_e(w,mask) ! Zero out Dirichlet conditions
      include 'SIZE'
      real w(1)
      integer mask(0:1)

      n=mask(0)
      do i=1,n
c        write(6,*) i,mask(i),n,' MG_MASK'
         w(mask(i)) = 0.
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine axe
     $     (w,p,h1,h2,g,ng,b,nx,ny,nz,ur,us,ut,ifh2,ifrz,e)

      include 'SIZE'
      include 'INPUT'   ! if3d
      logical ifh2,ifrz

      real w (nx*ny*nz), p (nx*ny*nz)
     $   , h1(nx*ny*nz), h2(nx*ny*nz)
     $   , b (nx*ny*nz), g (ng,nx*ny*nz)
     $   , ur(nx*ny*nz), us(nx*ny*nz), ut(nx*ny*nz)
      integer e

      nxyz = nx*ny*nz

      call gradl_rst(ur,us,ut,p,nx,if3d)
c     if (e.eq.1) then
c        call outmat(p ,nx,ny,'ur A p',e)
c        call outmat(ur,nx,ny,'ur A r',e)
c        call outmat(us,nx,ny,'ur A s',e)
c     endif

      if (if3d) then
         do i=1,nxyz
            wr = g(1,i)*ur(i) + g(4,i)*us(i) + g(5,i)*ut(i)
            ws = g(4,i)*ur(i) + g(2,i)*us(i) + g(6,i)*ut(i)
            wt = g(5,i)*ur(i) + g(6,i)*us(i) + g(3,i)*ut(i)
            ur(i) = wr*h1(i)
            us(i) = ws*h1(i)
            ut(i) = wt*h1(i)
         enddo
      elseif (ifaxis) then
         call exitti('Blame Paul for no gradl_rst support yet$',nx)
      else
         do i=1,nxyz
            wr = g(1,i)*ur(i) + g(3,i)*us(i)
            ws = g(3,i)*ur(i) + g(2,i)*us(i)
c           write(6,3) i,ur(i),wr,g(1,i)/b(i),b(i)
c 3         format(i5,1p4e12.4,' wrws')
            ur(i) = wr*h1(i)
            us(i) = ws*h1(i)
         enddo
      endif

      call gradl_rst_t(w,ur,us,ut,nx,if3d)

c     if (e.eq.1) then
c        call outmat(w ,nx,ny,'ur B w',e)
c        call outmat(ur,nx,ny,'ur B r',e)
c        call outmat(us,nx,ny,'ur B s',e)
c     endif

      if (ifh2) then
        do i=1,nxyz
          w(i)=w(i)+h2(i)*b(i)*p(i)
        enddo
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_tnsr1(v,nv,nu,A,At)
c
c     v = [A (x) A] u      or
c     v = [A (x) A (x) A] u 
c
      integer nv,nu
      real v(1),A(1),At(1)
      include 'SIZE'
      include 'INPUT'
      if (.not. if3d) then
         call hsmg_tnsr1_2d(v,nv,nu,A,At)
      else
         call hsmg_tnsr1_3d(v,nv,nu,A,At,At)
      endif
      return
      end
c-------------------------------------------------------T--------------
      subroutine hsmg_tnsr1_2d(v,nv,nu,A,Bt) ! u = A u B
      integer nv,nu
      real v(1),A(1),Bt(1)
      include 'SIZE'
      common /hsmgw/ work(lx1*lx1)
      integer e

      nv2 = nv*nv
      nu2 = nu*nu

      if (nv.le.nu) then
         iv=1
         iu=1
         do e=1,nelv
            call mxm(A,nv,v(iu),nu,work,nu)
            call mxm(work,nv,Bt,nu,v(iv),nv)
            iv = iv + nv2
            iu = iu + nu2
         enddo
      else
         do e=nelv,1,-1
            iu=1+nu2*(e-1)
            iv=1+nv2*(e-1)
            call mxm(A,nv,v(iu),nu,work,nu)
            call mxm(work,nv,Bt,nu,v(iv),nv)
         enddo
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine hsmg_tnsr1_3d(v,nv,nu,A,Bt,Ct) ! v = [C (x) B (x) A] u
      integer nv,nu
      real v(1),A(1),Bt(1),Ct(1)
      include 'SIZE'
      parameter (lwk=(lx1+2)*(ly1+2)*(lz1+2))
      common /hsmgw/ work(0:lwk-1),work2(0:lwk-1)
      integer e,e0,ee,es

      e0=1
      es=1
      ee=nelv

      if (nv.gt.nu) then
         e0=nelv
         es=-1
         ee=1
      endif

      nu3 = nu**3
      nv3 = nv**3

      do e=e0,ee,es
         iu = 1 + (e-1)*nu3
         iv = 1 + (e-1)*nv3
         call mxm(A,nv,v(iu),nu,work,nu*nu)
         do i=0,nu-1
            call mxm(work(nv*nu*i),nv,Bt,nu,work2(nv*nv*i),nv)
         enddo
         call mxm(work2,nv*nv,Ct,nu,v(iv),nv)
      enddo

      return
      end
c------------------------------------------   T  -----------------------
      subroutine h1mg_rstr(r,l,ifdssum) ! r =J r,   l is coarse level
      include 'SIZE'
      include 'HSMG'
      logical ifdssum

      real r(1)
      integer l

      call hsmg_do_wt(r,mg_rstr_wt(mg_rstr_wt_index(l+1,mg_fld))
     $                     ,mg_nh(l+1),mg_nh(l+1),mg_nhz(l+1))

      call hsmg_tnsr1(r,mg_nh(l),mg_nh(l+1),mg_jht(1,l),mg_jh(1,l))

      if (ifdssum) call hsmg_dssum(r,l)

      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup()
      include 'SIZE'
      include 'TOTAL'
      include 'HSMG'

      common /scrhi/ h2inv (lx1,ly1,lz1,lelt)
      common /scrvh/ h1    (lx1,ly1,lz1,lelt),
     $               h2    (lx1,ly1,lz1,lelt)

      integer p_h1,p_h2,p_g,p_b,p_msk


      param(59) = 1
      call geom_reset(1)  ! Recompute g1m1 etc. with deformed only

      n = lx1*ly1*lz1*nelt
      call rone (h1   ,n)
      call rzero(h2   ,n)
      call rzero(h2inv,n)

      call h1mg_setup_mg_nx
      call h1mg_setup_semhat ! SEM hat matrices for each level
      call hsmg_setup_intp   ! Interpolation operators
      call h1mg_setup_dssum  ! set direct stiffness summation handles
      call h1mg_setup_wtmask ! set restriction weight matrices and bc masks
      call h1mg_setup_fdm    ! set up fast diagonalization method
      call h1mg_setup_schwarz_wt(.false.)
      call hsmg_setup_solve  ! set up the solver

      l=mg_h1_lmax
      call mg_set_h1  (p_h1 ,l)
      call mg_set_h2  (p_h2 ,l)
      call mg_set_gb  (p_g,p_b,l)
      call mg_set_msk (p_msk,l)

      return
      end
c-----------------------------------------------------------------------
      subroutine h1mg_setup_mg_nx()
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'HSMG'
      include 'SEMHAT'
      include 'TSTEP'   ! nelfld
      real w(lx1+2)
      integer nf,nc,nr
      integer nx,ny,nz

      integer mgn2(10)
      save    mgn2
      data    mgn2 / 1, 2, 2, 2, 2, 3, 3, 5, 5, 5/
c     data    mgn2 / 1, 2, 3, 4, 5, 6, 7, 8, 9, 0

c     if (param(82).eq.0) param(82)=2  ! nek default
c     if (np.eq.1)        param(82)=2  ! single proc. too slow
      p82 = 2                          ! potentially variable nxc
      mg_h1_lmax = 3
c     mg_h1_lmax = 4
      if (lx1.eq.4) mg_h1_lmax = 2
c     if (param(79).ne.0) mg_h1_lmax = param(79)
      mg_lmax = mg_h1_lmax
      mglx1    = p82-1 !1
      mg_nx(1) = mglx1
      mg_ny(1) = mglx1
      mg_nz(1) = mglx1
      if (.not.if3d) mg_nz(1) = 0 

      mglx2 = 2*(lx2/4) + 1
      if (lx1.eq.5)  mglx2 = 3
c     if (lx1.eq.6)  mglx2 = 3
      if (lx1.le.10) mglx2 = mgn2(lx1)
      if (lx1.eq.8)  mglx2 = 4
      if (lx1.eq.8)  mglx2 = 3

      mglx2 = min(3,mglx2)  ! This choice seems best (9/24/12)

      mg_nx(2) = mglx2
      mg_ny(2) = mglx2
      mg_nz(2) = mglx2
      if (.not.if3d) mg_nz(2) = 0 

      mg_nx(3) = mglx2+1
      mg_ny(3) = mglx2+1
      mg_nz(3) = mglx2+1
      if (.not.if3d) mg_nz(3) = 0 

      mg_nx(mg_h1_lmax) = lx1-1
      mg_ny(mg_h1_lmax) = ly1-1
      mg_nz(mg_h1_lmax) = lz1-1

      if (nio.eq.0) write(*,*) 'h1_mg_nx:',(mg_nx(i),i=1,mg_h1_lmax)
      if (nio.eq.0) write(*,*) 'h1_mg_ny:',(mg_ny(i),i=1,mg_h1_lmax)
      if (nio.eq.0) write(*,*) 'h1_mg_nz:',(mg_nz(i),i=1,mg_h1_lmax)

      do ifld=1,ldimt1
      do l=1,mg_lmax
         mg_h1_n(l,ifld)=(mg_nx(l)+1)
     $                  *(mg_ny(l)+1)
     $                  *(mg_nz(l)+1)*nelfld(ifld)
      enddo
      enddo
      
      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_semhat ! SEM hat matrices for each level
      include 'SIZE'
      include 'INPUT'
      include 'HSMG'
      include 'SEMHAT'

      do l=1,mg_h1_lmax
         n = mg_nx(l)     ! polynomial order
         call semhat(ah,bh,ch,dh,zh,dph,jph,bgl,zglhat,dgl,jgl,n,wh)
         call copy(mg_ah(1,l),ah,(n+1)*(n+1))
         call copy(mg_bh(1,l),bh,n+1)
         call copy(mg_dh(1,l),dh,(n+1)*(n+1))
         call transpose(mg_dht(1,l),n+1,dh,n+1)
         call copy(mg_zh(1,l),zh,n+1)

         mg_nh(l)=n+1
         mg_nhz(l)=mg_nz(l)+1

      enddo
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_dssum
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'HSMG'
      parameter (lxyz=(lx1+2)*(ly1+2)*(lz1+2))
      common /c_is1/ glo_num(lxyz*lelt)
      common /ivrtx/ vertex ((2**ldim)*lelt)

      integer*8 glo_num
      integer vertex
      integer nx,ny,nz
      integer l
      
      ncrnr = 2**ldim
      call get_vert


      do l=1,mg_lmax  ! set up direct stiffness summation for each level
         nx=mg_nh(l)
         ny=mg_nh(l)
         nz=mg_nhz(l)
         call setupds(mg_gsh_handle(l,mg_fld),nx,ny,nz
     $                ,nelv,nelgv,vertex,glo_num)
         nx=nx+2
         ny=ny+2
         nz=nz+2
         if(.not.if3d) nz=1
         call setupds(mg_gsh_schwarz_handle(l,mg_fld),nx,ny,nz
     $                ,nelv,nelgv,vertex,glo_num)
      enddo

      return
      end
c----------------------------------------------------------------------
      subroutine mg_set_msk(p_msk ,l0)
      include 'SIZE'
      include 'HSMG'
      include 'TSTEP'
      integer p_msk

      l                  = mg_h1_lmax
      p_mg_msk(l,mg_fld) = 0
      n                  = mg_h1_n(l,mg_fld)


      do l=mg_h1_lmax,1,-1
         nx = mg_nh  (l)
         ny = mg_nh  (l)
         nz = mg_nhz (l)

         p_msk = p_mg_msk(l,mg_fld)

         call h1mg_setup_mask
     $     (mg_imask(p_msk),nm,nx,ny,nz,nelfld(ifield),l,mg_work)

         if (l.gt.1) p_mg_msk(l-1,mg_fld)=p_mg_msk(l,mg_fld)+nm

      enddo

      p_msk = p_mg_msk(l0,mg_fld)

      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_mask(mask,nm,nx,ny,nz,nel,l,w)
      include 'SIZE'
      include 'INPUT'        ! if3d

      integer mask(1)        ! Pointer to Dirichlet BCs
      integer nx,ny,nz,l
      real w(nx,ny,nz,nel)
      
      integer e,count,ptr
      integer lbr,rbr,lbs,rbs,lbt,rbt,two

      zero = 0
      nxyz = nx*ny*nz
      n    = nx*ny*nz*nel

      call rone(w,n)   ! Init everything to 1

      ierrmx = 0       ! BC verification
      two    = 2
      do e=1,nel       ! Set dirichlet nodes to zero

         call get_fast_bc(lbr,rbr,lbs,rbs,lbt,rbt,e,two,ierr)
c        write(6,6) e,lbr,rbr,lbs,rbs,ierr,nx
c   6    format(i5,2x,4i3,2x,i2,3x,i5,'  lbr,rbr,lbs')

         if (lbr.eq.1) call facev(w,e,4,zero,nx,ny,nz)
         if (rbr.eq.1) call facev(w,e,2,zero,nx,ny,nz)
         if (lbs.eq.1) call facev(w,e,1,zero,nx,ny,nz)
         if (rbs.eq.1) call facev(w,e,3,zero,nx,ny,nz)
         if (if3d) then
            if (lbt.eq.1) call facev(w,e,5,zero,nx,ny,nz)
            if (rbt.eq.1) call facev(w,e,6,zero,nx,ny,nz)
         endif
         ierrmx = max(ierrmx,ierr)
      enddo

      call hsmg_dsprod(w,l)    ! direct stiffness multiply

c
c     Prototypical mask layout, nel=5:
c
c    e=1 ...             10
c      1  2  3  4  5 ... 10 | 11 12 13 14 | 15 | 16 |
c     11 15 16 ...          |  3 p1 p2 p3 |  0 |  0 | ...
c                              ^
c                              |
c                              |_count for e=1
c

      nm  = 1                  ! store mask
      do e=1,nel

         mask(e) = nel+nm
         count   = 0          ! # Dirchlet points on element e
         ptr     = mask(e)

         do i=1,nxyz
            if (w(i,1,1,e).eq.0) then
               nm    = nm   +1
               count = count+1
               ptr   = ptr  +1
               mask(ptr) = i + nxyz*(e-1)   ! where I mask on element e 
            endif
         enddo


         ptr       = mask(e)
         mask(ptr) = count

         nm        = nm+1     ! bump pointer to hold next count

      enddo

      nm = nel + nm-1 ! Return total number of mask pointers/counters

      ierrmx = iglmax(ierrmx,1)
      if (ierrmx.gt.0) then
         if (ierr.gt.0) write(6,*) nid,ierr,' BC FAIL h1'
         call exitti('D INVALID BC FOUND in h1mg_setup_mask$',ierrmx)
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine mg_set_h1  (p_h1 ,l0)
      include 'SIZE'
      include 'HSMG'
      integer pf,pc

c     As a first pass, rely on the cheesy common-block interface to get h1

      common /scrvh/ h1    (lx1,ly1,lz1,lelv)
     $             , h2    (lx1,ly1,lz1,lelv)
     $             , h2inv (lx1,ly1,lz1,lelv)

      integer p_h1

      l                 = mg_h1_lmax
      p_mg_h1(l,mg_fld) = 0
      n                 = mg_h1_n(l,mg_fld)

      call copy (mg_h1,h1,n)   ! Fine grid is just original h1

      nx = mg_nh(l)
      ny = mg_nh(l)
      nz = mg_nhz(l)

      do l=mg_h1_lmax-1,1,-1

         p_mg_h1(l,mg_fld) = p_mg_h1(l+1,mg_fld) + n
         n                 = mg_h1_n(l  ,mg_fld)

         pf                = p_mg_h1(l+1,mg_fld)
         pc                = p_mg_h1(l  ,mg_fld)

         call hsmg_intp_fc (mg_h1(pc),mg_h1(pf),l)

      enddo

      p_h1 = p_mg_h1(l0,mg_fld)

      return
      end
c-----------------------------------------------------------------------
      subroutine mg_set_h2  (p_h2 ,l0)
      include 'SIZE'
      include 'HSMG'

c     As a first pass, rely on the cheesy common-block interface to get h2

      common /scrvh/ h1    (lx1,ly1,lz1,lelv)
     $             , h2    (lx1,ly1,lz1,lelv)
     $             , h2inv (lx1,ly1,lz1,lelv)

      integer p_h2,pf,pc

      l                 = mg_h1_lmax
      p_mg_h2(l,mg_fld) = 0
      n                 = mg_h1_n(l,mg_fld)

      call copy (mg_h2,h2,n)   ! Fine grid is just original h2

      nx = mg_nh(l)
      ny = mg_nh(l)
      nz = mg_nhz(l)

      do l=mg_h1_lmax-1,1,-1

         p_mg_h2(l,mg_fld) = p_mg_h2(l+1,mg_fld) + n
         n                 = mg_h1_n(l  ,mg_fld)

         pf                = p_mg_h2(l+1,mg_fld)
         pc                = p_mg_h2(l  ,mg_fld)

         call hsmg_intp_fc (mg_h2(pc),mg_h2(pf),l)

      enddo

      p_h2 = p_mg_h2(l0,mg_fld)

      return
      end
c-----------------------------------------------------------------------
      subroutine hsmg_intp_fc(uc,uf,l) ! l is coarse level

      include 'SIZE'
      include 'HSMG'

      real uc(1),uf(1)


      nc = mg_nh(l)
      nf = mg_nh(l+1)
      call hsmg_tnsr(uc,nc,uf,nf,mg_jhfc(1,l),mg_jhfct(1,l))

      return
      end
c-----------------------------------------------------------------------
      subroutine mg_intp_fc_e(uc,uf,nxc,nyc,nzc,nxf,nyf,nzf,e,l,w)
      include 'SIZE'
      include 'INPUT'      ! if3d
      include 'HSMG'

      real uf(nxf,nyf,nzf),uc(nxc,nyc,nzc),w(1)
      integer e

      if (if3d) then

         n1=nxf*nyf
         n2=nzf
         n3=nzc
         call mxm(uf,n1,mg_jhfct(1,l),n2,w,n3)

         lf=1           ! pointers into work array w()
         lc=1 + n1*n3
         lc0=lc

         n1=nxf
         n2=nyf
         n3=nyc

         do k=1,nzc
            call mxm(w(lf),n1,mg_jhfct(1,l),n2,w(lc),n3)
            lf = lf + n1*n2
            lc = lc + n1*n3
         enddo

         lf=lc0  ! Rewind fine pointer to start of coarse data
         n1=nxc
         n2=nxf
         n3=nyc*nzc
         call mxm(mg_jhfc(1,l),n1,w(lf),n2,uc,n3)

      else ! 2D

         n1=nxf
         n2=nyf
         n3=nyc
         call mxm(uf,n1,mg_jhfct(1,l),n2,w,n3)

         n1=nxc
         n2=nxf
         n3=nyc
         call mxm(mg_jhfc(1,l),n1,w,n2,uc,n3)

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine mg_intp_gfc_e(gc,gf,ng,nxc,nyc,nzc,nxf,nyf,nzf,e,l,w)
      include 'SIZE'
      include 'INPUT'      ! if3d
      include 'HSMG'

      real gf(ng,nxf,nyf,nzf),gc(ng,nxc,nyc,nzc),w(1)
      integer e


      if (if3d) then

         n1=ng*nxf*nyf
         n2=nzf
         n3=nzc
         call mxm(gf,n1,mg_jhfct(1,l),n2,w,n3)

         lf=1           ! pointers into work array w()
         lc=1 + n1*n3
         lc0=lc

         n1=ng*nxf
         n2=nyf
         n3=nyc

         do k=1,nzc
            call mxm(w(lf),n1,mg_jhfct(1,l),n2,w(lc),n3)
            lf = lf + n1*n2
            lc = lc + n1*n3
         enddo

         lf=lc0  ! Rewind fine pointer to start of coarse data
         n1=ng
         n2=nxf
         n3=nxc

         do k=1,nyc*nzc
            call mxm(w(lf),n1,mg_jhfct(1,l),n2,gc(1,1,k,1),n3)
            lf = lf + n1*n2
         enddo

      else ! 2D

         n1=ng*nxf
         n2=nyf
         n3=nyc
         call mxm(gf,n1,mg_jhfct(1,l),n2,w,n3)

         lf=1           ! pointers into work array w()

         n1=ng
         n2=nxf
         n3=nxc

         do k=1,nyc
            call mxm(w(lf),n1,mg_jhfct(1,l),n2,gc(1,1,k,1),n3)
            lf = lf + n1*n2
         enddo

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine mg_scale_mass (b,g,wt,ng,nx,ny,nz,wk,ifinv)
      include 'SIZE'
      include 'INPUT'  ! if3d
      include 'HSMG'

      real b(1),g(ng,1),wt(1),wk(1)
      logical ifinv

      common /ctmp0/ wi(2*lx1+4)

      n = nx*ny*nz

      if (nx.le.2*lx1) then
         if (ifinv) then
            call invers2(wi,wt,nx)
         else
            call copy(wi,wt,nx)
         endif
      else
         call exitti('mg_scale_mass: wi too small$',nx)
      endif

      if (if3d) then
         l=0
         do k=1,nz
         do j=1,ny
            wjk=wi(j)*wi(k)
            do i=1,nx
               l=l+1
               wk(l) = wjk*wi(i)
            enddo
         enddo
         enddo

         do k=1,n
            b(k)   = wk(k)*b(k)
            g(1,k) = wk(k)*g(1,k)
            g(2,k) = wk(k)*g(2,k)
            g(3,k) = wk(k)*g(3,k)
            g(4,k) = wk(k)*g(4,k)
            g(5,k) = wk(k)*g(5,k)
            g(6,k) = wk(k)*g(6,k)
         enddo

      else      ! 2D
         l=0
         do j=1,ny
         do i=1,nx
            l=l+1
            wk(l) = wi(i)*wi(j)
         enddo
         enddo

         do k=1,n
            b(k)   = wk(k)*b(k)
            g(1,k) = wk(k)*g(1,k)
            g(2,k) = wk(k)*g(2,k)
            g(3,k) = wk(k)*g(3,k)
         enddo

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine mg_set_gb  (p_g,p_b,l0)
      include 'SIZE'
      include 'HSMG'
      include 'MASS'   ! bm1
      include 'TSTEP'  ! nelfld

      integer p_g,p_b,e
      common /ctmp1/ w(lx1*ly1*lz1*lelt*2)

      l                 = mg_h1_lmax
      p_mg_b (l,mg_fld) = 0
      p_mg_g (l,mg_fld) = 0
      n                 = mg_h1_n(l,mg_fld)


      ng = 3*(ldim-1)  ! 3 or 6 elements to symm dxd tensor

      do l=mg_h1_lmax-1,1,-1

         p_mg_b (l,mg_fld) = p_mg_b (l+1,mg_fld) + n
         p_mg_g (l,mg_fld) = p_mg_g (l+1,mg_fld) + n*ng
         n                 = mg_h1_n(l  ,mg_fld)

      enddo

      do e=1,nelfld(ifield)
       do l=mg_h1_lmax,1,-1

         nx = mg_nh(l)
         ny = mg_nh(l)
         nz = mg_nhz(l)
         nxyz = nx*ny*nz

         p_g = p_mg_g (l,mg_fld) + ng*nx*ny*nz*(e-1)
         p_b = p_mg_b (l,mg_fld) +    nx*ny*nz*(e-1)

         if (l.eq.mg_h1_lmax) then
            call gxfer_e (mg_g(p_g) ,ng,e             ) ! Fine grid=original G
            call copy    (mg_b(p_b) ,bm1(1,1,1,e),nxyz) ! Fine grid=original B
            call mg_scale_mass                          ! Divide out Wghts
     $         (mg_b(p_b),mg_g(p_g),mg_bh(1,l),ng,nx,ny,nz,w,.true.)
         else

c           Generate G and B by interpolating their continous counterparts onto
c           the coarse grid and collocating with coarse-grid quadrature weights

            call mg_intp_gfc_e
     $            (mg_g(p_g),mg_g(l_g),ng,nx,ny,nz,nxl,nyl,nzl,e,l,w)

            call mg_intp_fc_e
     $            (mg_b(p_b),mg_b(l_b)   ,nx,ny,nz,nxl,nyl,nzl,e,l,w)

            call mg_scale_mass                         ! Reinstate weights
     $      (mg_b(l_b),mg_g(l_g),mg_bh(1,l+1),ng,nxl,nyl,nzl,w,.false.)

         endif

         l_b = p_b
         l_g = p_g

         nxl = nx
         nyl = ny
         nzl = nz

       enddo

       call mg_scale_mass                         ! Reinstate weights
     $      (mg_b(l_b),mg_g(l_g),mg_bh(1,1),ng,nxl,nyl,nzl,w,.false.)


      enddo

      p_b  = p_mg_b (l0,mg_fld)
      p_g  = p_mg_g (l0,mg_fld)

      return
      end
c-----------------------------------------------------------------------
      subroutine gxfer_e (g,ng,e) 
      include 'SIZE'
      include 'TOTAL'

      real g(ng,1)
      integer e

      nxyz = lx1*ly1*lz1

c     ifdfrm(e) = .true.  ! TOO LATE

      if (if3d) then
         do i=1,nxyz
            g(1,i) = g1m1(i,1,1,e)
            g(2,i) = g2m1(i,1,1,e)
            g(3,i) = g3m1(i,1,1,e)
            g(4,i) = g4m1(i,1,1,e)
            g(5,i) = g5m1(i,1,1,e)
            g(6,i) = g6m1(i,1,1,e)
         enddo
      else
         do i=1,nxyz
            g(1,i) = g1m1(i,1,1,e)
            g(2,i) = g2m1(i,1,1,e)
            g(3,i) = g4m1(i,1,1,e)
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine chkr(name3,ii)
      include 'SIZE'
      include 'TOTAL'
      include 'HSMG'
      character*3 name3

      write(6,*) mg_h1_lmax,ii,' ',name3,' CHKR'

      return
      end
c-----------------------------------------------------------------------
      subroutine outgmat(a,ng,nx,ny,name6,k,e)

      integer e
      real a(ng,nx,ny)
      common /ctmp0/ w(100000)
      character*6 name6

c     do i=1,ng
      do i=1,1
         sum = 0.
         do ii=1,nx*ny
            w(ii)=a(i,ii,1)
            sum = sum + a(i,ii,1)
         enddo

         write(6,1) name6,i,k,e,nx,ny,ng,sum
    1    format(a6,6i5,f12.5,'  outgmat')

         call outmatz(w,nx,ny,name6,i)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine outmatz(a,m,n,name6,ie)
      real a(m,n)
      character*6 name6

      sum=0.
      sua=0.
      do i=1,m*n
         sum=sum+    a(i,1)
         sua=sua+abs(a(i,1))
      enddo
      sum=sum/(m*n)
      sua=sua/(m*n)

      write(6,*) 
      write(6,1) ie,name6,m,n,sum,sua
    1 format(i8,' matrix: ',a6,2i5,1p2e12.4)

      n12 = min(m,12)
      do j=m,1,-1
         write(6,6) ie,name6,(a(i,j),i=1,n12)
      enddo
    6 format(i3,1x,a6,12f9.5)
c     write(6,*) 
      return
      end
c-----------------------------------------------------------------------
      subroutine h1mg_setup_schwarz_wt_2(wt,ie,n,work,ifsqrt)
      include 'SIZE'
      real wt(1),work(1)
      logical ifsqrt

      if (ldim.eq.2) call h1mg_setup_schwarz_wt2d_2(wt,ie,n,work,ifsqrt)
      if (ldim.eq.3) call h1mg_setup_schwarz_wt3d_2(wt,ie,n,work,ifsqrt)

      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_schwarz_wt2d_2(wt,ie,n,work,ifsqrt)
      include 'SIZE'
      logical ifsqrt
      integer n
      real wt(n,4,2,nelv)
      real work(n,n)
      
      integer ie,i,j
      do j=1,n
         wt(j,1,1,ie)=1.0/work(1,j)
         wt(j,2,1,ie)=1.0/work(2,j)
         wt(j,3,1,ie)=1.0/work(n-1,j)
         wt(j,4,1,ie)=1.0/work(n,j)
      enddo
      do i=1,n
         wt(i,1,2,ie)=1.0/work(i,1)
         wt(i,2,2,ie)=1.0/work(i,2)
         wt(i,3,2,ie)=1.0/work(i,n-1)
         wt(i,4,2,ie)=1.0/work(i,n)
      enddo
      if(ifsqrt) then
         do ii=1,2
         do j=1,4
         do i=1,n
            wt(i,j,ii,ie)=sqrt(wt(i,j,ii,ie))
         enddo
         enddo
         enddo
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_schwarz_wt3d_2(wt,ie,n,work,ifsqrt)
      include 'SIZE'
      logical ifsqrt
      integer n
      real wt(n,n,4,3,nelv)
      real work(n,n,n)
      
      integer ie,i,j,k
      integer lbr,rbr,lbs,rbs,lbt,rbt

      ierr = 0
      do k=1,n
      do j=1,n
         wt(j,k,1,1,ie)=1.0/work(1,j,k)
         wt(j,k,2,1,ie)=1.0/work(2,j,k)
         wt(j,k,3,1,ie)=1.0/work(n-1,j,k)
         wt(j,k,4,1,ie)=1.0/work(n,j,k)
      enddo
      enddo
      do k=1,n
      do i=1,n
         wt(i,k,1,2,ie)=1.0/work(i,1,k)
         wt(i,k,2,2,ie)=1.0/work(i,2,k)
         wt(i,k,3,2,ie)=1.0/work(i,n-1,k)
         wt(i,k,4,2,ie)=1.0/work(i,n,k)
      enddo
      enddo
      do j=1,n
      do i=1,n
         wt(i,j,1,3,ie)=1.0/work(i,j,1)
         wt(i,j,2,3,ie)=1.0/work(i,j,2)
         wt(i,j,3,3,ie)=1.0/work(i,j,n-1)
         wt(i,j,4,3,ie)=1.0/work(i,j,n)
      enddo
      enddo
      if(ifsqrt) then
         do ii=1,3
         do k=1,4
         do j=1,4
         do i=1,n
            wt(i,j,k,ii,ie)=sqrt(wt(i,j,k,ii,ie))
         enddo
         enddo
         enddo
         enddo
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine h1mg_setup_schwarz_wt_1(wt,l,ifsqrt)
      include 'SIZE'
      include 'INPUT'  ! if3d
      include 'TSTEP'  ! ifield
      include 'HSMG'

      real wt(1),work(1)
      logical ifsqrt

      integer enx,eny,enz,pm

      zero =  0
      one  =  1
      onem = -1

      n  = mg_h1_n (l,mg_fld)
      pm = p_mg_msk(l,mg_fld)

      enx=mg_nh(l)+2
      eny=mg_nh(l)+2
      enz=mg_nh(l)+2
      if(.not.if3d) enz=1
      ns = enx*eny*enz*nelfld(ifield)
      i  = ns+1

      call rone(mg_work(i),ns)
 
c     Sum overlap region (border excluded)
      call hsmg_extrude(mg_work,0,zero,mg_work(i),0,one ,enx,eny,enz)
      call hsmg_schwarz_dssum(mg_work(i),l)
      call hsmg_extrude(mg_work(i),0,one ,mg_work,0,onem,enx,eny,enz)
      call hsmg_extrude(mg_work(i),2,one,mg_work(i),0,one,enx,eny,enz)

      if(.not.if3d) then ! Go back to regular size array
         call hsmg_schwarz_toreg2d(mg_work,mg_work(i),mg_nh(l))
      else
         call hsmg_schwarz_toreg3d(mg_work,mg_work(i),mg_nh(l))
      endif

      call hsmg_dssum(mg_work,l)                           ! sum border nodes


      nx = mg_nh(l)
      ny = mg_nh(l)
      nz = mg_nh(l)
      if (.not.if3d) nz=1
      nxyz = nx*ny*nz
      k    = 1
      do ie=1,nelfld(ifield)
c        call outmat(mg_work(k),nx,ny,'NEW WT',ie)
         call h1mg_setup_schwarz_wt_2(wt,ie,nx,mg_work(k),ifsqrt)
         k = k+nxyz
      enddo
c     stop

      return
      end
c----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two tasks with depend clause to ensure execution order, no data races.
!i is shared for two tasks based on implicit data-sharing attribute rules.


program DRB078_taskdep2_orig_no
    use omp_lib
    implicit none

    integer :: i
    i = 0

    !$omp parallel
        !$omp single
            !$omp task depend (out:i)
                call sleep(3)
                i=3
            !$omp end task
            !$omp task depend (out:i)
                i=2
            !$omp end task
        !$omp end single
    !$omp end parallel

    if (i /=2 ) then
        print 100, i
        100 format (i3)
    end if
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two nested loops with loop-carried anti-dependence on the outer level.
!This is a variable-length array version in F95.
!Data race pair: a[i][j]@55:13 vs. a[i+1][j]@55:31

program DRB004_antidep2_var_yes
    use omp_lib
    implicit none

    integer :: i, j, len, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    real, dimension (:,:), allocatable :: a
    len = 1000

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (a(len,len))


    do i = 1, len
        do j = 1, len
            a(i,j) = 0.5
        end do
    end do

    !$omp parallel do private(j)
    do i = 1, len-1
        do j = 1, len
            a(i,j) = a(i,j) + a(i+1,j)
        end do
    end do
    !$omp end parallel do

    write(*,*) 'a(10,10) =', a(10,10)

    deallocate(a)
    deallocate(args)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two tasks without synchronization to protect data write, causing data races.
!Data race pair: i@20 vs. i@22

program DRB023_sections1_orig_yes
    use omp_lib
    implicit none

    integer :: i
    i = 0

    !$omp parallel sections
    !$omp section
    i=1
    !$omp section
    i=2
    !$omp end parallel sections

    print 100, i
    100 format ("i=",i3)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!use of omp target + teams
!Without protection, master threads from two teams cause data races.
!Data race pair: a@24:9 vs. a@24:9

program DRB116_target_teams_orig_yes
    use omp_lib
    implicit none

    integer i, len
    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:), allocatable :: a

    len = 100
    allocate (a(len))

    do i = 1, len
        a(i) = (real(i,dp))/2.0
    end do

    !$omp target map(tofrom: a(0:len))
        !$omp teams num_teams(2)
        a(50) = a(50)*2.0
        !$omp end teams
    !$omp end target

    print*,'a(50)=',a(50)

    deallocate(a)
end program

      subroutine initdim
C-------------------------------------------------------------------
C
C     Transfer array dimensions to common
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
C
      NELT=LELT
      NELV=LELV

      NX1=LX1
      NY1=LY1
      NZ1=LZ1
 
      NX2=LX2
      NY2=LY2
      NZ2=LZ2
 
      NX3=LX3
      NY3=LY3
      NZ3=LZ3
 
      NXD=LXD
      NYD=LYD
      NZD=LZD

      NDIM=LDIM
C
      RETURN
      END
C
      subroutine initdat
C--------------------------------------------------------------------
C
C     Initialize and set default values.
C
C--------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
      COMMON /DOIT/ IFDOIT
      LOGICAL       IFDOIT

c     Set default logicals

      ifdoit    = .false.
      ifcvode   = .false.
      ifexplvis = .false.
      ifvvisp   = .true.

      ifsplit = .false.
      if (lx1.eq.lx2) ifsplit=.true.

      if_full_pres = .false.

      CALL RZERO (PARAM,200)

      CALL BLANK(CCURVE ,12*LELT)
      NEL8 = 8*LELT
      CALL RZERO(XC,NEL8)
      CALL RZERO(YC,NEL8)
      CALL RZERO(ZC,NEL8)

      NTOT=lx1*ly1*lz1*LELT
      CALL RZERO(ABX1,NTOT)
      CALL RZERO(ABX2,NTOT)
      CALL RZERO(ABY1,NTOT)
      CALL RZERO(ABY2,NTOT)
      CALL RZERO(ABZ1,NTOT)
      CALL RZERO(ABZ2,NTOT)
      CALL RZERO(VGRADT1,NTOT)
      CALL RZERO(VGRADT2,NTOT)

      NTOT=lx2*ly2*lz2*LELT
      CALL RZERO(USRDIV,NTOT)
      CALL RZERO(QTL,NTOT)

      NSTEPS = 0

      RETURN
      END
C
      subroutine comment
C---------------------------------------------------------------------
C
C     No need to comment !!
C
C---------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'TSTEP'
      include 'CTIMER'

      LOGICAL  IFCOUR
      SAVE     IFCOUR
      COMMON  /CPRINT/ IFPRINT
      LOGICAL          IFPRINT
      REAL*8 EETIME0,EETIME1,EETIME2
      SAVE   EETIME0,EETIME1,EETIME2
      DATA   EETIME0,EETIME1,EETIME2 /0.0, 0.0, 0.0/

C
C     Only node zero makes comments.
      IF (NIO.NE.0) RETURN
C
C
      IF (EETIME0.EQ.0.0 .AND. ISTEP.EQ.1) EETIME0=DNEKCLOCK()
      EETIME1=EETIME2
      EETIME2=DNEKCLOCK()
C
      IF (ISTEP.EQ.0) THEN
         IFCOUR  = .FALSE.
         DO 10 IFIELD=1,NFIELD
            IF (IFADVC(IFIELD)) IFCOUR = .TRUE.
 10      CONTINUE
         IF (IFWCNO) IFCOUR = .TRUE.
      ELSEIF (ISTEP.GT.0 .AND. LASTEP.EQ.0 .AND. IFTRAN) THEN
         TTIME_STP = EETIME2-EETIME1   ! time per timestep
         TTIME     = EETIME2-EETIME0   ! sum of all timesteps
         IF(ISTEP.EQ.1) THEN
           TTIME_STP = 0
           TTIME     = 0
         ENDIF
         IF (     IFCOUR) 
     $       WRITE(6,100)ISTEP,TIME,DT,COURNO,TTIME,TTIME_STP
         IF (.NOT.IFCOUR) WRITE (6,101) ISTEP,TIME,DT
      ELSEIF (LASTEP.EQ.1) THEN
         TTIME_STP = EETIME2-EETIME1   ! time per timestep
         TTIME     = EETIME2-EETIME0   ! sum of all timesteps
      ENDIF
 100  FORMAT('Step',I7,', t=',1pE14.7,', DT=',1pE14.7
     $,', C=',0pF7.3,2(1pE11.4))
 101  FORMAT('Step',I7,', time=',1pE12.5,', DT=',1pE11.3)

      RETURN
      END
C
      subroutine setvar
C------------------------------------------------------------------------
C
C     Initialize variables
C
C------------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'DEALIAS'
      include 'TSTEP'
      include 'NEKNEK'

      param(120) = 500 ! print runtime stats

C
C     Geometry on Mesh 3 or 1?
C
      IFGMSH3 = .TRUE.
      IF ( IFSTRS )           IFGMSH3 = .FALSE.
      IF (.NOT.IFFLOW)        IFGMSH3 = .FALSE.
      IF ( IFSPLIT )          IFGMSH3 = .FALSE.

      NGEOM  = 2
C
      NFIELD = 1
      IF (IFHEAT) THEN
         NFIELD = 2 + NPSCAL
         NFLDTM = 1 + NPSCAL
      ENDIF
c
      nfldt = nfield
      if (ifmhd) then
         nfldt  = nfield + 1
         nfldtm = nfldtm + 1
      endif
c
      MFIELD = 1
      IF (IFMVBD) MFIELD = 0
C
      DO 100 IFIELD=MFIELD,nfldt+(LDIMT-1 - NPSCAL)
         IF (IFTMSH(IFIELD)) THEN
             NELFLD(IFIELD) = NELT
         ELSE
             NELFLD(IFIELD) = NELV
         ENDIF
 100  CONTINUE

      ! Maximum iteration counts for linear solver
      NMXV   = 1000
      if (iftran) NMXV = 200
      NMXH   =  NMXV ! not used anymore
      NMXP   = 200
      do ifield = 2,ldimt+1
         NMXT(ifield-1) = 200 
      enddo 
      NMXE   = 100
      NMXNL  = 10 
C
      PARAM(86) = 0 ! No skew-symm. convection for now
C
      DT     = abs(PARAM(12))
      DTINIT = DT
      FINTIM = PARAM(10)
      NSTEPS = PARAM(11)
      IOCOMM = PARAM(13)
      TIMEIO = PARAM(14)
      IOSTEP = PARAM(15)
      LASTEP = 0
      TOLPDF = abs(PARAM(21))
      TOLHDF = abs(PARAM(22))
      TOLREL = abs(PARAM(24))
      TOLABS = abs(PARAM(25))
      CTARG  = PARAM(26)
      NBDINP = abs(PARAM(27))
      NABMSH = PARAM(28)

      if (nbdinp.gt.lorder) then
         if (nid.eq.0) then
           write(6,*) 'ERROR: torder > lorder.',nbdinp,lorder
           write(6,*) 'Change SIZE and recompile entire code.'
         endif
         call exitt
      endif

C     Check accuracy requested.
C
      IF (TOLREL.LE.0.) TOLREL = 0.01
C
C     Relaxed pressure iteration; maximum decrease in the residual.
C
      PRELAX = 0.1*TOLREL
      IF (.NOT.IFTRAN .AND. .NOT.IFNAV) PRELAX = 1.E-5
C
C     Tolerance for nonlinear iteration
C
      TOLNL  = 1.E-4
C
C     Fintim overrides nsteps
C
      IF (FINTIM.NE.0.) NSTEPS = 1000000000
      IF (.NOT.IFTRAN ) NSTEPS = 1
C
C     Print interval defaults to 1
C
      IF (IOCOMM.EQ.0)  IOCOMM = nsteps+1
C
C     Set default for mesh integration scheme
C
      IF (NABMSH.LE.0 .OR. NABMSH.GT.3) THEN
         NABMSH    = NBDINP
         PARAM(28) = (NABMSH)
      ENDIF
C
C     Courant number only applicable if convection in ANY field.
C
      IADV  = 0
      IFLD1 = 1
      IF (.NOT.IFFLOW) IFLD1 = 2
      DO 200 IFIELD=IFLD1,nfldt
         IF (IFADVC(IFIELD)) IADV = 1
 200  CONTINUE
C
C     If characteristics, need number of sub-timesteps (DT/DS).
C     Current sub-timeintegration scheme: RK4.
C     If not characteristics, i.e. standard semi-implicit scheme,
C     check user-defined Courant number.
C
      IF (IADV.EQ.1) CALL SETCHAR
C
C     Initialize order of time-stepping scheme (BD)
C     Initialize time step array.
C
      NBD    = 0
      CALL RZERO (DTLAG,10)

      ! neknek 
      ifneknekm = .false.
      ninter = 1
      nfld_neknek = ndim + nfield

      CALL BLANK(cbc_bmap,sizeof(cbc_bmap))

      one = 1.
      PI  = 4.*ATAN(one)

      RETURN
      END
C
      subroutine echopar
C
C     Echo the nonzero parameters from the readfile to the logfile
C
      include 'SIZE'
      include 'INPUT'
      CHARACTER*132 STRING
      CHARACTER*1  STRING1(132)
      EQUIVALENCE (STRING,STRING1)
C
      IF (nid.ne.0) RETURN
C
      OPEN (UNIT=9,FILE=REAFLE,STATUS='OLD')
      REWIND(UNIT=9)
C
C
      READ(9,*,ERR=400)
      READ(9,*,ERR=400) VNEKTON
      NKTONV=VNEKTON
      VNEKMIN=2.5
      IF(VNEKTON.LT.VNEKMIN)THEN
         PRINT*,' Error: This NEKTON Solver Requires a .rea file'
         PRINT*,' from prenek version ',VNEKMIN,' or higher'
         PRINT*,' Please run the session through the preprocessor'
         PRINT*,' to bring the .rea file up to date.'
         call exitt
      ENDIF
      READ(9,*,ERR=400) ldimr
c     error check
      IF(ldimr.NE.LDIM)THEN
         WRITE(6,10) LDIMR,ldim
   10       FORMAT(//,2X,'Error: This NEKTON Solver has been compiled'
     $              /,2X,'       for spatial dimension equal to',I2,'.'
     $              /,2X,'       The data file has dimension',I2,'.')
         CALL exitt
      ENDIF
C
      CALL BLANK(STRING,132)
c      CALL CHCOPY(STRING,REAFLE,132)
      Ls=LTRUNC(STRING,132)
      READ(9,*,ERR=400) NPARAM
      WRITE(6,82) NPARAM,(STRING1(j),j=1,Ls)
C
      DO 20 I=1,NPARAM
         CALL BLANK(STRING,132)
         READ(9,80,ERR=400) STRING
         Ls=LTRUNC(STRING,132)
         IF (PARAM(i).ne.0.0) WRITE(6,81) I,(STRING1(j),j=1,Ls)
   20 CONTINUE
   80 FORMAT(A132) 
   81 FORMAT(I4,3X,132A1)
   82 FORMAT(I4,3X,'Parameters from file:',132A1)
      CLOSE (UNIT=9)
      write(6,*) ' '

c      if(param(2).ne.param(8).and.nio.eq.0) then
c         write(6,*) 'Note VISCOS not equal to CONDUCT!'
c         write(6,*) 'Note VISCOS  =',PARAM(2)
c         write(6,*) 'Note CONDUCT =',PARAM(8)
c      endif
c
      return
C
C     Error handling:
C
  400 CONTINUE
      WRITE(6,401)
  401 FORMAT(2X,'ERROR READING PARAMETER DATA'
     $    ,/,2X,'ABORTING IN ROUTINE ECHOPAR.')
      CALL exitt
C
  500 CONTINUE
      WRITE(6,501)
  501 FORMAT(2X,'ERROR READING LOGICAL DATA'
     $    ,/,2X,'ABORTING IN ROUTINE ECHOPAR.')
      CALL exitt
C
      RETURN
      END
C
      subroutine gengeom (igeom)
C----------------------------------------------------------------------
C
C     Generate geometry data
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      include 'GEOM'
      include 'WZ'
C
      COMMON /SCRUZ/ XM3 (LX3,LY3,LZ3,LELT)
     $ ,             YM3 (LX3,LY3,LZ3,LELT)
     $ ,             ZM3 (LX3,LY3,LZ3,LELT)
C

      if (nio.eq.0.and.istep.le.1) write(6,*) 'generate geometry data'

      IF (IGEOM.EQ.1) THEN
         RETURN
      ELSEIF (IGEOM.EQ.2) THEN
         CALL LAGMASS
         IF (ISTEP.EQ.0) CALL GENCOOR (XM3,YM3,ZM3)
         IF (ISTEP.GE.1) CALL UPDCOOR
         CALL GEOM1 (XM3,YM3,ZM3)
         CALL GEOM2
         CALL UPDMSYS (1)
         CALL VOLUME
         CALL SETINVM
         CALL SETDEF
         CALL SFASTAX
      ENDIF

      if (nio.eq.0.and.istep.le.1) then
        write(6,*) 'done :: generate geometry data' 
        write(6,*) ' '
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine files
C
C     Defines machine specific input and output file names.
C
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
C
      CHARACTER*132 NAME
      CHARACTER*1   SESS1(132),PATH1(132),NAM1(132)
      EQUIVALENCE  (SESSION,SESS1)
      EQUIVALENCE  (PATH,PATH1)
      EQUIVALENCE  (NAME,NAM1)
      CHARACTER*1  DMP(4),FLD(4),REA(4),HIS(4),SCH(4) ,ORE(4), NRE(4)
      CHARACTER*1  RE2(4),PAR(4)
      CHARACTER*4  DMP4  ,FLD4  ,REA4  ,HIS4  ,SCH4   ,ORE4  , NRE4
      CHARACTER*4  RE24  ,PAR4
      EQUIVALENCE (DMP,DMP4), (FLD,FLD4), (REA,REA4), (HIS,HIS4)
     $          , (SCH,SCH4), (ORE,ORE4), (NRE,NRE4)
     $          , (RE2,RE24), (PAR,PAR4)
      DATA DMP4,FLD4,REA4 /'.dmp','.fld','.rea'/
      DATA HIS4,SCH4      /'.his','.sch'/
      DATA ORE4,NRE4      /'.ore','.nre'/
      DATA RE24           /'.re2'       /
      DATA PAR4           /'.par'       /
      CHARACTER*78  STRING
C
C     Find out the session name:
C
c      CALL BLANK(SESSION,132)
c      CALL BLANK(PATH   ,132)

c      ierr = 0
c      IF(NID.EQ.0) THEN
c        OPEN (UNIT=8,FILE='SESSION.NAME',STATUS='OLD',ERR=24)
c        READ(8,10) SESSION
c        READ(8,10) PATH
c  10      FORMAT(A132)
c        CLOSE(UNIT=8)
c        GOTO 23
c  24    ierr = 1
c  23  ENDIF
c      call err_chk(ierr,' Cannot open SESSION.NAME!$')

      len = ltrunc(path,132)
      if(indx1(path1(len),'/',1).lt.1) then
         call chcopy(path1(len+1),'/',1)
      endif

c      call bcast(SESSION,132*CSIZE)
c      call bcast(PATH,132*CSIZE)

      CALL BLANK(PARFLE,132)
      CALL BLANK(REAFLE,132)
      CALL BLANK(RE2FLE,132)
      CALL BLANK(FLDFLE,132)
      CALL BLANK(HISFLE,132)
      CALL BLANK(SCHFLE,132)
      CALL BLANK(DMPFLE,132)
      CALL BLANK(OREFLE,132)
      CALL BLANK(NREFLE,132)
      CALL BLANK(NAME  ,132)
C
C     Construct file names containing full path to host:
C
      LS=LTRUNC(SESSION,132)
      LPP=LTRUNC(PATH,132)
      LSP=LS+LPP
c
      call chcopy(nam1(    1),path1,lpp)
      call chcopy(nam1(lpp+1),sess1,ls )
      l1 = lpp+ls+1
      ln = lpp+ls+4
c
c
c .rea file
      call chcopy(nam1  (l1),rea , 4)
      call chcopy(reafle    ,nam1,ln)
c      write(6,*) 'reafile:',reafle
c
c .par file
      call chcopy(nam1  (l1),par , 4)
      call chcopy(parfle    ,nam1,ln)
c
c .re2 file
      call chcopy(nam1  (l1),re2 , 4)
      call chcopy(re2fle    ,nam1,ln)
c
c .fld file
      call chcopy(nam1  (l1),fld , 4)
      call chcopy(fldfle    ,nam1,ln)
c
c .his file
      call chcopy(nam1  (l1),his , 4)
      call chcopy(hisfle    ,nam1,ln)
c
c .sch file
      call chcopy(nam1  (l1),sch , 4)
      call chcopy(schfle    ,nam1,ln)
c
c
c .dmp file
      call chcopy(nam1  (l1),dmp , 4)
      call chcopy(dmpfle    ,nam1,ln)
c
c .ore file
      call chcopy(nam1  (l1),ore , 4)
      call chcopy(orefle    ,nam1,ln)
c
c .nre file
      call chcopy(nam1  (l1),nre , 4)
      call chcopy(nrefle    ,nam1,ln)
c
C     Write the name of the .rea file to the logfile.
C
C      IF (NIO.EQ.0) THEN
C         CALL CHCOPY(STRING,REAFLE,78)
C         WRITE(6,1000) STRING
C         WRITE(6,1001) 
C 1000    FORMAT(//,1X,'Beginning session:',/,2X,A78)
C 1001    FORMAT(/,' ')
C      ENDIF
C
      RETURN

      END
C
      subroutine settime
C----------------------------------------------------------------------
C
C     Store old time steps and compute new time step, time and timef.
C     Set time-dependent coefficients in time-stepping schemes.
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
      COMMON  /CPRINT/ IFPRINT
      LOGICAL          IFPRINT
      SAVE
C
      irst = param(46)
C
C     Set time step.
C
      DO 10 ILAG=10,2,-1
         DTLAG(ILAG) = DTLAG(ILAG-1)
 10   CONTINUE
      CALL SETDT
      DTLAG(1) = DT
      IF (ISTEP.EQ.1 .and. irst.le.0) DTLAG(2) = DT
C
C     Set time.
C
      TIMEF    = TIME
      TIME     = TIME+DT
C
C     Set coefficients in AB/BD-schemes.
C
      CALL SETORDBD
      if (irst.gt.0) nbd = nbdinp
      CALL RZERO (BD,10)
      CALL SETBD (BD,DTLAG,NBD)
      if (PARAM(27).lt.0) then
         NAB = NBDINP
      else
         NAB = 3
      endif
      IF (ISTEP.lt.NAB.and.irst.le.0) NAB = ISTEP
      CALL RZERO   (AB,10)
      CALL SETABBD (AB,DTLAG,NAB,NBD)
      IF (IFMVBD) THEN
         NBDMSH = 1
         NABMSH = PARAM(28)
         IF (NABMSH.GT.ISTEP .and. irst.le.0) NABMSH = ISTEP
         IF (IFSURT)          NABMSH = NBD
         CALL RZERO   (ABMSH,10)
         CALL SETABBD (ABMSH,DTLAG,NABMSH,NBDMSH)
      ENDIF

C
C     Set logical for printout to screen/log-file
C
      IFPRINT = .FALSE.
      IF (IOCOMM.GT.0.AND.MOD(ISTEP,IOCOMM).EQ.0) IFPRINT=.TRUE.
      IF (ISTEP.eq.1  .or. ISTEP.eq.0           ) IFPRINT=.TRUE.
      IF (NIO.eq.-1)  ifprint=.false.
 
      RETURN
      END
 
 
      subroutine geneig (igeom)
C-----------------------------------------------------------------------
C
C     Compute eigenvalues. 
C     Used for automatic setting of tolerances and to find critical
C     time step for explicit mode. 
C     Currently eigenvalues are computed only for the velocity mesh.
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'EIGEN'
      include 'INPUT'
      include 'TSTEP'
C
      IF (IGEOM.EQ.1) RETURN
C
C     Decide which eigenvalues to be computed.
C
      IF (IFFLOW) THEN
C
         IFAA  = .FALSE.
         IFAE  = .FALSE.
         IFAS  = .FALSE.
         IFAST = .FALSE.
         IFGA  = .TRUE.
         IFGE  = .FALSE.
         IFGS  = .FALSE.
         IFGST = .FALSE.
C
C        For now, only compute eigenvalues during initialization.
C        For deforming geometries the eigenvalues should be 
C        computed every time step (based on old eigenvectors => more memory)
C
         IMESH  = 1
         IFIELD = 1
         TOLEV  = 1.E-3
         TOLHE  = TOLHDF
         TOLHR  = TOLHDF
         TOLHS  = TOLHDF
         TOLPS  = TOLPDF
         CALL EIGENV
         CALL ESTEIG
C
      ELSEIF (IFHEAT.AND..NOT.IFFLOW) THEN
C
         CALL ESTEIG
C
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      subroutine fluid (igeom)
C
C     Driver for solving the incompressible Navier-Stokes equations.
C
C     Current version:
C     (1) Velocity/stress formulation.
C     (2) Constant/variable properties.
C     (3) Implicit/explicit time stepping.
C     (4) Automatic setting of tolerances .
C     (5) Lagrangian/"Eulerian"(operator splitting) modes
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'DEALIAS'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'

      real*8 ts, dnekclock
 
      ifield = 1
      imesh  = 1
      call unorm
      call settolv

      ts = dnekclock() 

      if(nio.eq.0 .and. igeom.eq.2) 
     &   write(*,'(13x,a)') 'Solving for fluid'

      if (ifsplit) then

c        PLAN 4: TOMBO SPLITTING
c                - Time-dependent Navier-Stokes calculation (Re>>1).
c                - Same approximation spaces for pressure and velocity.
c                - Incompressibe or Weakly compressible (div u .ne. 0).

         call plan4 (igeom)                                           
         if (igeom.ge.2) call chkptol         ! check pressure tolerance 
         if (igeom.eq.ngeom) then
           if (ifneknekc) then
              call vol_flow_ms    ! check for fixed flow rate
           else
              call vol_flow       ! check for fixed flow rate
           endif
         endif
         if (igeom.ge.2) call printdiverr

      elseif (iftran) then

c        call plan1 (igeom)       !  Orig. NEKTON time stepper

         if (ifrich) then
            call plan5(igeom)
         else
            call plan3 (igeom)    !  Same as PLAN 1 w/o nested iteration
                                  !  Std. NEKTON time stepper  !
         endif

         if (igeom.ge.2) call chkptol         ! check pressure tolerance
         if (igeom.eq.ngeom) then 
           if (ifneknekc) then
              call vol_flow_ms    ! check for fixed flow rate
           else
              call vol_flow       ! check for fixed flow rate
           endif
         endif

      else   !  steady Stokes, non-split

c             - Steady/Unsteady Stokes/Navier-Stokes calculation.
c             - Consistent approximation spaces for velocity and pressure.
c             - Explicit treatment of the convection term. 
c             - Velocity/stress formulation.

         call plan1 (igeom) ! The NEKTON "Classic".

      endif

      if(nio.eq.0 .and. igeom.ge.2) 
     &   write(*,'(4x,i7,a,1p2e12.4)') 
     &   istep,'  Fluid done',time,dnekclock()-ts

      return
      end
c-----------------------------------------------------------------------
      subroutine heat (igeom)
C
C     Driver for temperature or passive scalar.
C
C     Current version:
C     (1) Varaiable properties.
C     (2) Implicit time stepping.
C     (3) User specified tolerance for the Helmholtz solver
C         (not based on eigenvalues).
C     (4) A passive scalar can be defined on either the 
C         temperatur or the velocity mesh.
C     (5) A passive scalar has its own multiplicity (B.C.).  
C
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      include 'DEALIAS'

      real*8 ts, dnekclock

      ts = dnekclock()

      if (nio.eq.0 .and. igeom.eq.2) 
     &    write(*,'(13x,a)') 'Solving for Hmholtz scalars'

      do ifield = 2,nfield
         if (idpss(ifield-1).eq.0) then      ! helmholtz
            intype        = -1
            if (.not.iftmsh(ifield)) imesh = 1
            if (     iftmsh(ifield)) imesh = 2
            call unorm
            call settolt
            call cdscal(igeom)
         endif
      enddo

      if (nio.eq.0 .and. igeom.eq.2)
     &   write(*,'(4x,i7,a,1p2e12.4)') 
     &   istep,'  Scalars done',time,dnekclock()-ts

      return
      end
c-----------------------------------------------------------------------
      subroutine heat_cvode (igeom)
C
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      include 'DEALIAS'

      real*8 ts, dnekclock

      ts = dnekclock()

      if (igeom.ne.2) return

      if (nio.eq.0) 
     &    write(*,'(13x,a)') 'Solving for CVODE scalars'

      call cdscal_cvode(igeom)

      if (nio.eq.0)
     &   write(*,'(4x,i7,a,1p2e12.4)') 
     &   istep,'  CVODE scalars done',time,dnekclock()-ts

      return
      end
c-----------------------------------------------------------------------
      subroutine meshv (igeom)

C     Driver for mesh velocity used in conjunction with moving geometry.
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
C
      IF (IGEOM.EQ.1) RETURN
C
      IFIELD = 0
      NEL    = NELFLD(IFIELD)
      IMESH  = 1
      IF (IFTMSH(IFIELD)) IMESH = 2
C
      CALL UPDMSYS (0)
      CALL MVBDRY  (NEL)
      CALL ELASOLV (NEL)
C
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine time00
c
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
C
      nmxmf=0
      nmxms=0
      ndsum=0
      nvdss=0
      nsett=0
      ncdtp=0
      npres=0
      nmltd=0
      ngsum=0
      nprep=0
      ndsnd=0
      ndadd=0
      nhmhz=0
      naxhm=0
      ngop =0
      nusbc=0
      ncopy=0
      ninvc=0
      ninv3=0
      nsolv=0
      nslvb=0
      nddsl=0
      ncrsl=0
      ndott=0
      nbsol=0
      nadvc=0
      nspro=0
      ncvf =0
c
      tmxmf=0.0
      tmxms=0.0
      tdsum=0.0
      tvdss=0.0
      tvdss=0.0
      tdsmn=9.9e9
      tdsmx=0.0
      tsett=0.0
      tcdtp=0.0
      tpres=0.0
      teslv=0.0
      tmltd=0.0
      tgsum=0.0
      tgsmn=9.9e9
      tgsmx=0.0
      tprep=0.0
      tdsnd=0.0
      tdadd=0.0
      thmhz=0.0
      taxhm=0.0
      tgop =0.0
      tusbc=0.0
      tcopy=0.0
      tinvc=0.0
      tinv3=0.0
      tsolv=0.0
      tslvb=0.0
      tddsl=0.0
      tcrsl=0.0
      tdott=0.0
      tbsol=0.0
      tbso2=0.0
      tspro=0.0
      tadvc=0.0
      ttime=0.0
      tcvf =0.0
      tproj=0.0
      tuchk=0.0
      tmakf=0.0
      tmakq=0.0
C
      return
      end
C
c-----------------------------------------------------------------------
      subroutine runstat

#ifdef TIMER

      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'

      real min_dsum, max_dsum, avg_dsum
      real min_vdss, max_vdss, avg_vdss
      real min_gop,  max_gop,  avg_gop
      real min_gop_sync,  max_gop_sync,  avg_gop_sync
      real min_crsl, max_crsl, avg_crsl
      real min_usbc, max_usbc, avg_usbc
      real min_syc, max_syc, avg_syc
      real min_wal, max_wal, avg_wal
      real min_irc, max_irc, avg_irc
      real min_isd, max_isd, avg_isd
      real min_comm, max_comm, avg_comm

      real comm_timers(8)
      integer comm_counters(8)
      character*132 s132

      tstop=dnekclock()
      tttstp=ttime         ! sum over all timesteps

c      call opcount(3)      ! print op-counters

      tcomm  = tisd + tirc + tsyc + tgp2+ twal + trc + tsd
      min_comm = tcomm
      call gop(min_comm,wwork,'m  ',1)
      max_comm = tcomm
      call gop(max_comm,wwork,'M  ',1)
      avg_comm = tcomm
      call gop(avg_comm,wwork,'+  ',1)
      avg_comm = avg_comm/np
c
      min_isd = tisd
      call gop(min_isd,wwork,'m  ',1)
      max_isd = tisd
      call gop(max_isd,wwork,'M  ',1)
      avg_isd = tisd
      call gop(avg_isd,wwork,'+  ',1)
      avg_isd = avg_isd/np
c
      min_irc = tirc
      call gop(min_irc,wwork,'m  ',1)
      max_irc = tirc
      call gop(max_irc,wwork,'M  ',1)
      avg_irc = tirc
      call gop(avg_irc,wwork,'+  ',1)
      avg_irc = avg_irc/np
c
      min_syc = tsyc
      call gop(min_syc,wwork,'m  ',1)
      max_syc = tsyc
      call gop(max_syc,wwork,'M  ',1)
      avg_syc = tsyc
      call gop(avg_syc,wwork,'+  ',1)
      avg_syc = avg_syc/np
c
      min_wal = twal
      call gop(min_wal,wwork,'m  ',1)
      max_wal = twal
      call gop(max_wal,wwork,'M  ',1)
      avg_wal = twal
      call gop(avg_wal,wwork,'+  ',1)
      avg_wal = avg_wal/np
c
      min_gop = tgp2
      call gop(min_gop,wwork,'m  ',1)
      max_gop = tgp2
      call gop(max_gop,wwork,'M  ',1)
      avg_gop = tgp2
      call gop(avg_gop,wwork,'+  ',1)
      avg_gop = avg_gop/np
c
      min_gop_sync = tgop_sync
      call gop(min_gop_sync,wwork,'m  ',1)
      max_gop_sync = tgop_sync
      call gop(max_gop_sync,wwork,'M  ',1)
      avg_gop_sync = tgop_sync
      call gop(avg_gop_sync,wwork,'+  ',1)
      avg_gop_sync = avg_gop_sync/np
c
      min_vdss = tvdss
      call gop(min_vdss,wwork,'m  ',1)
      max_vdss = tvdss
      call gop(max_vdss,wwork,'M  ',1)
      avg_vdss = tvdss
      call gop(avg_vdss,wwork,'+  ',1)
      avg_vdss = avg_vdss/np
c
      min_dsum = tdsum
      call gop(min_dsum,wwork,'m  ',1)
      max_dsum = tdsum
      call gop(max_dsum,wwork,'M  ',1)
      avg_dsum = tdsum
      call gop(avg_dsum,wwork,'+  ',1)
      avg_dsum = avg_dsum/np
c

      min_crsl = tcrsl
      call gop(min_crsl,wwork,'m  ',1)
      max_crsl = tcrsl
      call gop(max_crsl,wwork,'M  ',1)
      avg_crsl = tcrsl
      call gop(avg_crsl,wwork,'+  ',1)
      avg_crsl = avg_crsl/np
c
      min_usbc = tusbc
      call gop(min_usbc,wwork,'m  ',1)
      max_usbc = tusbc
      call gop(max_usbc,wwork,'M  ',1)
      avg_usbc = tusbc
      call gop(avg_usbc,wwork,'+  ',1)
      avg_usbc = avg_usbc/np
c
      tttstp = tttstp + 1e-7
      if (nio.eq.0) then
         write(6,*) ''
         write(6,'(A)') 'runtime statistics:'

         pinit=tinit/tttstp
         write(6,*) 'init time',tinit,pinit
         pprep=tprep/tttstp
         write(6,*) 'prep time',nprep,tprep,pprep

c        Pressure solver timings
         ppres=tpres/tttstp
         write(6,*) 'pres time',npres,tpres,ppres

c        Coarse grid solver timings
         pcrsl=tcrsl/tttstp
         write(6,*) 'crsl time',ncrsl,tcrsl,pcrsl
         write(6,*) 'crsl min ',min_crsl
         write(6,*) 'crsl max ',max_crsl
         write(6,*) 'crsl avg ',avg_crsl

c        Helmholz solver timings
         phmhz=thmhz/tttstp
         write(6,*) 'hmhz time',nhmhz,thmhz,phmhz

c        E solver timings
         peslv=teslv/tttstp 
         write(6,*) 'eslv time',neslv,teslv,peslv

c        makef timings
         pmakf=tmakf/tttstp 
         write(6,*) 'makf time',tmakf,pmakf

c        makeq timings
         pmakq=tmakq/tttstp 
         write(6,*) 'makq time',tmakq,pmakq

c        CVODE RHS timings
         pcvf=tcvf/tttstp
         if(ifcvode) write(6,*) 'cfun time',ncvf,tcvf,pcvf

c        Resiual projection timings
         pproj=tproj/tttstp
         write(6,*) 'proj time',tproj,pproj

c        Variable properties timings
         pspro=tspro/tttstp
         write(6,*) 'usvp time',nspro,tspro,pspro

c        User q and f timings
         pusfq=tusfq/tttstp
         write(6,*) 'usfq time',0,tusfq,pusfq

c        USERBC timings
         pusbc=tusbc/tttstp
         write(6,*) 'usbc time',nusbc,tusbc,pusbc
         write(6,*) 'usbc min ',min_usbc 
         write(6,*) 'usbc max ',max_usbc 
         write(6,*) 'usb  avg ',avg_usbc 

c        User check timings
         puchk=tuchk/tttstp
         write(6,*) 'uchk time',tuchk,puchk

c        Operator timings
         pmltd=tmltd/tttstp
         write(6,*) 'mltd time',nmltd,tmltd,pmltd
         pcdtp=tcdtp/tttstp
         write(6,*) 'cdtp time',ncdtp,tcdtp,pcdtp
         paxhm=taxhm/tttstp
         write(6,*) 'axhm time',naxhm,taxhm,paxhm
         padvc=tadvc/tttstp
         write(6,*) 'advc time',nadvc,tadvc,padvc

c        Low-level routines
         pmxmf=tmxmf/tttstp
         write(6,*) 'mxmf time',tmxmf,pmxmf
         padc3=tadc3/tttstp
         write(6,*) 'adc3 time',tadc3,padc3
         pcol2=tcol2/tttstp
         write(6,*) 'col2 time',tcol2,pcol2
         pcol3=tcol3/tttstp
         write(6,*) 'col3 time',tcol3,pcol3
         pa2s2=ta2s2/tttstp
         write(6,*) 'a2s2 time',ta2s2,pa2s2
         padd2=tadd2/tttstp
         write(6,*) 'add2 time',tadd2,padd2
         pinvc=tinvc/tttstp
         write(6,*) 'invc time',tinvc,pinvc

c         pinv3=tinv3/tttstp
c         write(6,*) 'inv3 time',ninv3,tinv3,pinv3

         pgop=tgop/tttstp
         write(6,*) 'tgop time',ngop,tgop,pgop

         pdadd=tdadd/tttstp
         write(6,*) 'dadd time',ndadd,tdadd,pdadd
 
c        Vector direct stiffness summuation timings
         pvdss=tvdss/tttstp
         write(6,*) 'vdss time',nvdss,tvdss,pvdss
         write(6,*) 'vdss min ',min_vdss
         write(6,*) 'vdss max ',max_vdss
         write(6,*) 'vdss avg ',avg_vdss

c        Direct stiffness summuation timings
         pdsum=tdsum/tttstp
         write(6,*) 'dsum time',ndsum,tdsum,pdsum
         write(6,*) 'dsum min ',min_dsum
         write(6,*) 'dsum max ',max_dsum
         write(6,*) 'dsum avg ',avg_dsum

c         pgsum=tgsum/tttstp
c         write(6,*) 'gsum time',ngsum,tgsum,pgsum

c         pdsnd=tdsnd/tttstp
c         write(6,*) 'dsnd time',ndsnd,tdsnd,pdsnd

c         pdsmx=tdsmx/tttstp
c         write(6,*) 'dsmx time',ndsmx,tdsmx,pdsmx
c         pdsmn=tdsmn/tttstp
c         write(6,*) 'dsmn time',ndsmn,tdsmn,pdsmn
c         pslvb=tslvb/tttstp
c         write(6,*) 'slvb time',nslvb,tslvb,pslvb

         pddsl=tddsl/tttstp
         write(6,*) 'ddsl time',nddsl,tddsl,pddsl

c         pbsol=tbsol/tttstp
c         write(6,*) 'bsol time',nbsol,tbsol,pbsol
c         pbso2=tbso2/tttstp
c         write(6,*) 'bso2 time',nbso2,tbso2,pbso2

         write(6,*) ''
      endif

      if (lastep.eq.1) then
        if (nio.eq.0)  ! header for timing
     $    write(6,1) 'tusbc','tdadd','tcrsl','tvdss','tdsum',
     $               ' tgop',ifsync
    1     format(/,'#',2x,'nid',6(7x,a5),4x,'qqq',1x,l4)

        call blank(s132,132)
        write(s132,132) nid,tusbc,tdadd,tcrsl,tvdss,tdsum,tgop
  132   format(i12,1p6e12.4,' qqq')
        call pprint_all(s132,132,6)
      endif
#endif

      return
      end
c-----------------------------------------------------------------------
      subroutine pprint_all(s,n_in,io)
      character*1 s(n_in)
      character*1 w(132)

      include 'SIZE'
      include 'PARALLEL'

      n = min(132,n_in)

      mtag = 999
      m    = 1
      call nekgsync()

      if (nid.eq.0) then
         l = ltrunc(s,n)
         write(io,1) (s(k),k=1,l)
   1     format(132a1)

         do i=1,np-1
            call csend(mtag,s,1,i,0)    ! send handshake
            m = 132
            call blank(w,m)
            call crecv(i,w,m)
            if (m.le.132) then
               l = ltrunc(w,m)
               write(io,1) (w(k),k=1,l)
            else
               write(io,*) 'pprint long message: ',i,m
               l = ltrunc(w,132)
               write(io,1) (w(k),k=1,l)
            endif
         enddo
      else
         call crecv(mtag,w,m)          ! wait for handshake
         l = ltrunc(s,n)
         call csend(nid,s,l,0,0)       ! send data to node 0
      endif
      return
      end
c-----------------------------------------------------------------------

      subroutine opcount(ICALL)
C
      include 'SIZE'
      include 'PARALLEL'
      include 'OPCTR'

      character*6 sname(maxrts)
      integer     ind  (maxrts)
      integer     idum (maxrts)
C
      if (icall.eq.1) then
         nrout=0
      endif
      if (icall.eq.1.or.icall.eq.2) then
         dcount = 0.0
         do 100 i=1,maxrts
            ncall(i) = 0
            dct(i)   = 0.0
  100    continue
      endif
      if (icall.eq.3) then
C
C        Sort and print out diagnostics
C
         if (nid.eq.0) then
            write(6,*) nid,' opcount',dcount
            do i = 1,np-1
              call csend(i,idum,4,i,0) 
              call crecv(i,ddcount,wdsize)
               write(6,*) i,' opcount',ddcount
            enddo
         else
            call crecv (nid,idum,4)
            call csend (nid,dcount,wdsize,0,0) 
         endif

         dhc = dcount
         call gop(dhc,dwork,'+  ',1)
         if (nio.eq.0) then
            write(6,*) ' TOTAL OPCOUNT',dhc
         endif
C
         CALL DRCOPY(rct,dct,nrout)
         CALL SORT(rct,ind,nrout)
         CALL CHSWAPR(rname,6,ind,nrout,sname)
         call iswap(ncall,ind,nrout,idum)
C
         if (nio.eq.0) then
            do 200 i=1,nrout
               write(6,201) nid,rname(i),rct(i),ncall(i)
  200       continue
  201       format(2x,' opnode',i4,2x,a6,g18.7,i12)
         endif
      endif
      return
      end
C
c-----------------------------------------------------------------------
      subroutine dofcnt
      include 'SIZE'
      include 'TOTAL'
      COMMON /SCRNS/ WORK(LCTMP1)

      integer*8 ntot,ntotp,ntotv

      nxyz  = nx1*ny1*nz1
      nel   = nelv

      ! unique points on v-mesh
      vpts = glsum(vmult,nel*nxyz) + .1
      nvtot=vpts

      ! unique points on pressure mesh
      work(1)=nel*nxyz
      ppts = glsum(work,1) + .1
      ntot=ppts
C
      if (nio.eq.0) write(6,'(A,2i13)')
     &   'gridpoints unique/tot: ',nvtot,ntot

      ntot1=nx1*ny1*nz1*nelv
      ntot2=nx2*ny2*nz2*nelv

      ntotv = glsc2(tmult,tmask,ntot1)
      ntotp = i8glsum(ntot2,1)

      if (ifflow)  ntotv = glsc2(vmult,v1mask,ntot1) + .1
      if (ifsplit) ntotp = glsc2(vmult,pmask ,ntot1) + .1
      if (nio.eq.0) write(6,'(A,2i13)') 
     $   'dofs vel/pr:           ',ntotv,ntotp

      return
      end
c-----------------------------------------------------------------------
      subroutine vol_flow
c
c
c     Adust flow volume at end of time step to keep flow rate fixed by
c     adding an appropriate multiple of the linear solution to the Stokes
c     problem arising from a unit forcing in the X-direction.  This assumes
c     that the flow rate in the X-direction is to be fixed (as opposed to Y-
c     or Z-) *and* that the periodic boundary conditions in the X-direction
c     occur at the extreme left and right ends of the mesh.
c
c     pff 6/28/98
c
      include 'SIZE'
      include 'TOTAL'
c
c     Swap the comments on these two lines if you don't want to fix the
c     flow rate for periodic-in-X (or Z) flow problems.
c
      parameter (kx1=lx1,ky1=ly1,kz1=lz1,kx2=lx2,ky2=ly2,kz2=lz2)
c
      common /cvflow_a/ vxc(kx1,ky1,kz1,lelv)
     $                , vyc(kx1,ky1,kz1,lelv)
     $                , vzc(kx1,ky1,kz1,lelv)
     $                , prc(kx2,ky2,kz2,lelv)
     $                , vdc(kx1*ky1*kz1*lelv,2)
      common /cvflow_r/ flow_rate,base_flow,domain_length,xsec
     $                , scale_vf(3)
      common /cvflow_i/ icvflow,iavflow
      common /cvflow_c/ chv(3)
      character*1 chv
c
      real bd_vflow,dt_vflow
      save bd_vflow,dt_vflow
      data bd_vflow,dt_vflow /-99.,-99./

      logical ifcomp

c     Check list:

c     param (55) -- volume flow rate, if nonzero
c     forcing in X? or in Z?


      ntot1 = lx1*ly1*lz1*nelv
      ntot2 = lx2*ly2*lz2*nelv

      if (param(55).eq.0.) return
      if (kx1.eq.1) then
         write(6,*) 'ABORT. Recompile vol_flow with kx1=lx1, etc.'
         call exitt
      endif

      icvflow   = 1                                  ! Default flow dir. = X
      if (param(54).ne.0) icvflow = abs(param(54))
      iavflow   = 0                                  ! Determine flow rate
      if (param(54).lt.0) iavflow = 1                ! from mean velocity
      flow_rate = param(55)

      chv(1) = 'X'
      chv(2) = 'Y'
      chv(3) = 'Z'

c     If either dt or the backwards difference coefficient change,
c     then recompute base flow solution corresponding to unit forcing:

      ifcomp = .false.
      if (dt.ne.dt_vflow.or.bd(1).ne.bd_vflow.or.ifmvbd) ifcomp=.true.
      if (.not.ifcomp) then
         ifcomp=.true.
         do i=1,ntot1
            if (vdiff (i,1,1,1,1).ne.vdc(i,1)) goto 20
            if (vtrans(i,1,1,1,1).ne.vdc(i,2)) goto 20
         enddo
         ifcomp=.false.  ! If here, then vdiff/vtrans unchanged.
   20    continue
      endif
      call gllog(ifcomp,.true.)
      
      call copy(vdc(1,1),vdiff (1,1,1,1,1),ntot1)
      call copy(vdc(1,2),vtrans(1,1,1,1,1),ntot1)
      dt_vflow = dt
      bd_vflow = bd(1)

      if (ifcomp) call compute_vol_soln(vxc,vyc,vzc,prc)

      if (icvflow.eq.1) current_flow=glsc2(vx,bm1,ntot1)/domain_length  ! for X
      if (icvflow.eq.2) current_flow=glsc2(vy,bm1,ntot1)/domain_length  ! for Y
      if (icvflow.eq.3) current_flow=glsc2(vz,bm1,ntot1)/domain_length  ! for Z

      if (iavflow.eq.1) then
         xsec = volvm1 / domain_length
         flow_rate = param(55)*xsec
      endif

      delta_flow = flow_rate-current_flow

c     Note, this scale factor corresponds to FFX, provided FFX has
c     not also been specified in userf.   If ffx is also specified
c     in userf then the true FFX is given by ffx_userf + scale.

      scale = delta_flow/base_flow
      scale_vf(icvflow) = scale
      if (nio.eq.0) write(6,1) istep,chv(icvflow)
     $   ,time,scale,delta_flow,current_flow,flow_rate
    1    format(i11,'  Volflow ',a1,11x,1p5e13.4)

      call add2s2(vx,vxc,scale,ntot1)
      call add2s2(vy,vyc,scale,ntot1)
      call add2s2(vz,vzc,scale,ntot1)
      call add2s2(pr,prc,scale,ntot2)

      return
      end
c-----------------------------------------------------------------------
      subroutine compute_vol_soln(vxc,vyc,vzc,prc)
c
c     Compute the solution to the time-dependent Stokes problem
c     with unit forcing, and find associated flow rate.
c
c     pff 2/28/98
c
      include 'SIZE'
      include 'TOTAL'
c
      real vxc(lx1,ly1,lz1,lelv)
     $   , vyc(lx1,ly1,lz1,lelv)
     $   , vzc(lx1,ly1,lz1,lelv)
     $   , prc(lx2,ly2,lz2,lelv)
c
      common /cvflow_r/ flow_rate,base_flow,domain_length,xsec
     $                , scale_vf(3)
      common /cvflow_i/ icvflow,iavflow
      common /cvflow_c/ chv(3)
      character*1 chv
c
      integer icalld
      save    icalld
      data    icalld/0/
c
c
      ntot1 = lx1*ly1*lz1*nelv
      if (icalld.eq.0) then
         icalld=icalld+1
         xlmin = glmin(xm1,ntot1)
         xlmax = glmax(xm1,ntot1)
         ylmin = glmin(ym1,ntot1)          !  for Y!
         ylmax = glmax(ym1,ntot1)
         zlmin = glmin(zm1,ntot1)          !  for Z!
         zlmax = glmax(zm1,ntot1)
c
         if (icvflow.eq.1) domain_length = xlmax - xlmin
         if (icvflow.eq.2) domain_length = ylmax - ylmin
         if (icvflow.eq.3) domain_length = zlmax - zlmin
c
      endif
c
      if (ifsplit) then
c        call plan2_vol(vxc,vyc,vzc,prc)
         call plan4_vol(vxc,vyc,vzc,prc)
      else
         call plan3_vol(vxc,vyc,vzc,prc)
      endif
c
c     Compute base flow rate
c 
      if (icvflow.eq.1) base_flow = glsc2(vxc,bm1,ntot1)/domain_length
      if (icvflow.eq.2) base_flow = glsc2(vyc,bm1,ntot1)/domain_length
      if (icvflow.eq.3) base_flow = glsc2(vzc,bm1,ntot1)/domain_length
c
      if (nio.eq.0 .and. loglevel.gt.2) write(6,1) 
     $   istep,chv(icvflow),base_flow,domain_length,flow_rate
    1    format(i11,'  basflow ',a1,11x,1p3e13.4)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine plan2_vol(vxc,vyc,vzc,prc)
c
c     Compute pressure and velocity using fractional step method.
c     (classical splitting scheme).
c
c
      include 'SIZE'
      include 'TOTAL'
c
      real vxc(lx1,ly1,lz1,lelv)
     $   , vyc(lx1,ly1,lz1,lelv)
     $   , vzc(lx1,ly1,lz1,lelv)
     $   , prc(lx2,ly2,lz2,lelv)
C
      COMMON /SCRNS/ RESV1 (LX1,LY1,LZ1,LELV)
     $ ,             RESV2 (LX1,LY1,LZ1,LELV)
     $ ,             RESV3 (LX1,LY1,LZ1,LELV)
     $ ,             RESPR (LX2,LY2,LZ2,LELV)
      COMMON /SCRVH/ H1    (LX1,LY1,LZ1,LELV)
     $ ,             H2    (LX1,LY1,LZ1,LELV)
c
      common /cvflow_i/ icvflow,iavflow
C
C
C     Compute pressure 
C
      ntot1  = lx1*ly1*lz1*nelv
c
      if (icvflow.eq.1) then
         call cdtp     (respr,v1mask,rxm2,sxm2,txm2,1)
      elseif (icvflow.eq.2) then
         call cdtp     (respr,v2mask,rxm2,sxm2,txm2,1)
      else
         call cdtp     (respr,v3mask,rxm2,sxm2,txm2,1)
      endif
c
      call ortho    (respr)
c
      call ctolspl  (tolspl,respr)
      call rone     (h1,ntot1)
      call rzero    (h2,ntot1)
c
      call hmholtz  ('PRES',prc,respr,h1,h2,pmask,vmult,
     $                             imesh,tolspl,nmxp,1)
      call ortho    (prc)
C
C     Compute velocity
C
      call opgrad   (resv1,resv2,resv3,prc)
      call opchsgn  (resv1,resv2,resv3)
      call add2col2 (resv1,bm1,v1mask,ntot1)
c
      intype = -1
      call sethlm   (h1,h2,intype)
      call ophinv   (vxc,vyc,vzc,resv1,resv2,resv3,h1,h2,tolhv,nmxv)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine plan3_vol(vxc,vyc,vzc,prc)
c
c     Compute pressure and velocity using fractional step method.
c     (PLAN3).
c
c
      include 'SIZE'
      include 'TOTAL'
c
      real vxc(lx1,ly1,lz1,lelv)
     $   , vyc(lx1,ly1,lz1,lelv)
     $   , vzc(lx1,ly1,lz1,lelv)
     $   , prc(lx2,ly2,lz2,lelv)
C
      COMMON /SCRNS/ rw1   (LX1,LY1,LZ1,LELV)
     $ ,             rw2   (LX1,LY1,LZ1,LELV)
     $ ,             rw3   (LX1,LY1,LZ1,LELV)
     $ ,             dv1   (LX1,LY1,LZ1,LELV)
     $ ,             dv2   (LX1,LY1,LZ1,LELV)
     $ ,             dv3   (LX1,LY1,LZ1,LELV)
     $ ,             RESPR (LX2,LY2,LZ2,LELV)
      COMMON /SCRVH/ H1    (LX1,LY1,LZ1,LELV)
     $ ,             H2    (LX1,LY1,LZ1,LELV)
      COMMON /SCRHI/ H2INV (LX1,LY1,LZ1,LELV)
      common /cvflow_i/ icvflow,iavflow
c
c
c     Compute velocity, 1st part 
c
      ntot1  = lx1*ly1*lz1*nelv
      ntot2  = lx2*ly2*lz2*nelv
      ifield = 1
c
      if (icvflow.eq.1) then
         call copy     (rw1,bm1,ntot1)
         call rzero    (rw2,ntot1)
         call rzero    (rw3,ntot1)
      elseif (icvflow.eq.2) then
         call rzero    (rw1,ntot1)
         call copy     (rw2,bm1,ntot1)
         call rzero    (rw3,ntot1)
      else
         call rzero    (rw1,ntot1)        ! Z-flow!
         call rzero    (rw2,ntot1)        ! Z-flow!
         call copy     (rw3,bm1,ntot1)    ! Z-flow!
      endif
      intype = -1
      call sethlm   (h1,h2,intype)
      call ophinv   (vxc,vyc,vzc,rw1,rw2,rw3,h1,h2,tolhv,nmxv)
      call ssnormd  (vxc,vyc,vzc)
c
c     Compute pressure  (from "incompr")
c
      intype = 1
      dtinv  = 1./dt
c
      call rzero   (h1,ntot1)
      call copy    (h2,vtrans(1,1,1,1,ifield),ntot1)
      call cmult   (h2,dtinv,ntot1)
      call invers2 (h2inv,h2,ntot1)
      call opdiv   (respr,vxc,vyc,vzc)
      call chsign  (respr,ntot2)
      call ortho   (respr)
c
c
c     Set istep=0 so that h1/h2 will be re-initialized in eprec
      i_tmp = istep
      istep = 0
      call esolver (respr,h1,h2,h2inv,intype)
      istep = i_tmp
c
      call opgradt (rw1,rw2,rw3,respr)
      call opbinv  (dv1,dv2,dv3,rw1,rw2,rw3,h2inv)
      call opadd2  (vxc,vyc,vzc,dv1,dv2,dv3)
c
      call cmult2  (prc,respr,bd(1),ntot2)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine plan4_vol(vxc,vyc,vzc,prc)

c     Compute pressure and velocity using fractional step method.
c     (Tombo splitting scheme).



      include 'SIZE'
      include 'TOTAL'

      real vxc(lx1,ly1,lz1,lelv)
     $   , vyc(lx1,ly1,lz1,lelv)
     $   , vzc(lx1,ly1,lz1,lelv)
     $   , prc(lx1,ly1,lz1,lelv)

      common /scrns/ resv1 (lx1,ly1,lz1,lelv)
     $ ,             resv2 (lx1,ly1,lz1,lelv)
     $ ,             resv3 (lx1,ly1,lz1,lelv)
     $ ,             respr (lx1,ly1,lz1,lelv)
      common /scrvh/ h1    (lx1,ly1,lz1,lelv)
     $ ,             h2    (lx1,ly1,lz1,lelv)

      common /cvflow_i/ icvflow,iavflow

      n = lx1*ly1*lz1*nelv
      call invers2  (h1,vtrans,n)
      call rzero    (h2,       n)

c     Compute pressure 

      if (icvflow.eq.1) call cdtp(respr,h1,rxm2,sxm2,txm2,1)
      if (icvflow.eq.2) call cdtp(respr,h1,rym2,sym2,tym2,1)
      if (icvflow.eq.3) call cdtp(respr,h1,rzm2,szm2,tzm2,1)

      call ortho    (respr)
      call ctolspl  (tolspl,respr)

      call hmholtz  ('PRES',prc,respr,h1,h2,pmask,vmult,
     $                             imesh,tolspl,nmxp,1)
      call ortho    (prc)

C     Compute velocity

      call opgrad   (resv1,resv2,resv3,prc)
      if (ifaxis) call col2 (resv2,omask,n)
      call opchsgn  (resv1,resv2,resv3)

      if (icvflow.eq.1) call add2col2(resv1,v1mask,bm1,n) ! add forcing
      if (icvflow.eq.2) call add2col2(resv2,v2mask,bm1,n)
      if (icvflow.eq.3) call add2col2(resv3,v3mask,bm1,n)


      if (ifexplvis) call split_vis ! split viscosity into exp/imp part

      intype = -1
      call sethlm   (h1,h2,intype)
      call ophinv   (vxc,vyc,vzc,resv1,resv2,resv3,h1,h2,tolhv,nmxv)

      if (ifexplvis) call redo_split_vis ! restore vdiff

      end
c-----------------------------------------------------------------------
      subroutine a_dmp
c
      include 'SIZE'
      include 'TOTAL'
      COMMON /SCRNS/ w(LX1,LY1,LZ1,LELT)
      COMMON /SCRUZ/ v (LX1,LY1,LZ1,LELT)
     $             , h1(LX1,LY1,LZ1,LELT)
     $             , h2(LX1,LY1,LZ1,LELT)
c
      ntot = lx1*ly1*lz1*nelv
      call rone (h1,ntot)
      call rzero(h2,ntot)
      do i=1,ntot
         call rzero(v,ntot)
         v(i,1,1,1) = 1.
         call axhelm (w,v,h1,h2,1,1)
         call outrio (w,ntot,55)
      enddo
c     write(6,*) 'quit in a_dmp'
c     call exitt
      return
      end
c-----------------------------------------------------------------------
      subroutine outrio (v,n,io)
c
      real v(1)
c
      write(6,*) 'outrio:',n,io,v(1)
      write(io,6) (v(k),k=1,n)
    6 format(1pe19.11)
c
c     nr = min(12,n)
c     write(io,6) (v(k),k=1,nr)
c   6 format(1p12e11.3)
      return
      end
c-----------------------------------------------------------------------
      subroutine reset_prop
C------------------------------------------------------------------------
C
C     Set variable property arrays
C
C------------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
C
C     Caution: 2nd and 3rd strainrate invariants residing in scratch
C              common /SCREV/ are used in STNRINV and NEKASGN
C
      COMMON /SCREV/ SII (LX1,LY1,LZ1,LELT)
     $             , SIII(LX1,LY1,LZ1,LELT)
      COMMON /SCRUZ/ TA(LX1,LY1,LZ1,LELT)
C
      real    rstart
      save    rstart
      data    rstart  /1/
c
      rfinal   = 1./param(2) ! Target Re
c
      ntot  = lx1*ly1*lz1*nelv
      iramp = 200
      istpp = istep
c     istpp = istep+2033+1250
      if (istpp.ge.iramp) then
         vfinal=1./rfinal
         call cfill(vdiff,vfinal,ntot)
      else
         one = 1.
         pi2 = 2.*atan(one)
         sarg  = (pi2*istpp)/iramp
         sarg  = sin(sarg)
         rnew = rstart + (rfinal-rstart)*sarg
         vnew = 1./rnew
         call cfill(vdiff,vnew,ntot)
         if (nio.eq.0) write(6,*) istep,' New Re:',rnew,sarg,istpp
      endif
      return
      end
C-----------------------------------------------------------------------
      subroutine prinit

      include 'SIZE'
      include 'TOTAL'

      if(nio.eq.0) write(6,*) 'initialize pressure solver'
      isolver = param(40)

      if (isolver.eq.0) then      ! semg_xxt
         if (nelgt.gt.350000)
     $   call exitti('problem size too large for XXT solver!$',0)
         call set_overlap
      else if (isolver.eq.1) then ! semg_amg
         call set_overlap
      else if (isolver.eq.2) then ! semg_amg_hypre
         call set_overlap
      else if (isolver.eq.3) then ! fem_amg_hypre
         null_space = 0
         if (ifvcor) null_space = 1 
         call fem_amg_setup(nx1,ny1,nz1,
     $                      nelv,ndim,
     $                      xm1,ym1,zm1,
     $                      pmask,binvm1,null_space,
     $                      gsh_fld(1),fem_amg_param)
      endif

      return 
      end

c-----------------------------------------------------------------------
      subroutine plan5(igeom)

c     Two-step Richardson Extrapolation.
c     Operator splitting technique.

      include 'SIZE'
      include 'TOTAL'

      common /scrns/  resv  (lx1*ly1*lz1*lelv,3)

      n   = lx1*ly1*lz1*nelv
      n2  = lx2*ly2*lz2*nelv
      dt2 = dt/2
      dti = 1/dt

      if (igeom.eq.2) then

      if (ifmvbd) call opcopy
     $  (wxlag(1,1,1,1,2),wylag(1,1,1,1,2),wzlag(1,1,1,1,2),xm1,ym1,zm1)

      do i=1,n
         s = bm1(i,1,1,1)*vtrans(i,1,1,1,1)*dti  ! Add  density*mass/dt,
         vxlag(i,1,1,1,2)=s*vx(i,1,1,1)          ! equivalent to using
         vylag(i,1,1,1,2)=s*vy(i,1,1,1)          ! density*mass/(dt/2)
         vzlag(i,1,1,1,2)=s*vz(i,1,1,1)          ! in the first place...
      enddo

      call midstep(vxlag,vylag,vzlag,prlag,0,dt)  ! One step of Pn-Pn-2

      do i=1,n                                          ! Add  density*mass/dt,
         bfx(i,1,1,1)=bfx(i,1,1,1)+vxlag(i,1,1,1,2)     ! equivalent to using
         bfy(i,1,1,1)=bfy(i,1,1,1)+vylag(i,1,1,1,2)     ! density*mass/(dt/2)
         bfz(i,1,1,1)=bfz(i,1,1,1)+vzlag(i,1,1,1,2)     ! in the first place...
      enddo

      if (ifmvbd) then
        call opcopy
     $  (xm1,ym1,zm1,wxlag(1,1,1,1,2),wylag(1,1,1,1,2),wzlag(1,1,1,1,2))
        call geom_reset(0)
      endif

      time = time-dt2
      call midstep(vx,vy,vz,pr,1,dt2)      ! One step of Pn-Pn-2, dt/2

      time = time+dt2
      call setup_convect(2)  ! Map vx --> vxd
      call setprop

      call midstep(vx,vy,vz,pr,0,dt2)      ! One step of Pn-Pn-2, dt/2

      do i=1,n
         vx(i,1,1,1)=2*vx(i,1,1,1)-vxlag(i,1,1,1,1)
         vy(i,1,1,1)=2*vy(i,1,1,1)-vylag(i,1,1,1,1)
         vz(i,1,1,1)=2*vz(i,1,1,1)-vzlag(i,1,1,1,1)
      enddo

      do i=1,n2
         pr(i,1,1,1)=2*pr(i,1,1,1)-prlag(i,1,1,1,1)
      enddo

      call ortho(pr)

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine midstep(ux,uy,uz,pu,iresv,dtl)
      include 'SIZE'
      include 'TOTAL'

      parameter (lv=lx1*ly1*lz1*lelt)
      real ux(1),uy(1),uz(1),pu(1)

      common /p5var/ rhs2   (lx1*ly1*lz1*lelv,3)

      common /scrns/  resv  (lx1*ly1*lz1*lelv,3)
     $ ,              dv1   (lx1*ly1*lz1*lelv)
     $ ,              dv2   (lx1*ly1*lz1*lelv)
     $ ,              dv3   (lx1*ly1*lz1*lelv)
      common /scrvh/  h1    (lx1*ly1*lz1*lelv)
     $ ,              h2    (lx1*ly1*lz1*lelv)


      if (lx1.eq.lx2) 
     $   call exitti('midstep requires lx2=lx1-2 in SIZE$',lx2)

      ifield = 1                ! Set field for velocity
      n   = lx1*ly1*lz1*nelv
      n2  = lx2*ly2*lz2*nelv

      dti = 1/dtl
      call copy    (h1,vdiff ,n)
      call cmult2  (h2,vtrans,dti,n)

      if (iresv.eq.0) then ! bfx etc is preserved if iresv=1

                    call makeuf  ! Initialize bfx, bfy, bfz
        if (ifmvbd) call admeshv ! Add div(W.u_i)

        call convop(resv(1,1),vx)
        call convop(resv(1,2),vy)
        call convop(resv(1,3),vz)

        do i=1,n
           b=vtrans(i,1,1,1,1)*bm1(i,1,1,1)
           s=1./dtl
           bfx(i,1,1,1)=bfx(i,1,1,1)+b*(s*vx(i,1,1,1)-resv(i,1))
           bfy(i,1,1,1)=bfy(i,1,1,1)+b*(s*vy(i,1,1,1)-resv(i,2))
           bfz(i,1,1,1)=bfz(i,1,1,1)+b*(s*vz(i,1,1,1)-resv(i,3))
        enddo

      endif

      call adv_geom(dtl) ! Advance the geometry

      call opcopy  (ux,uy,uz,vx,vy,vz)

      call bcdirvc (ux,uy,uz,v1mask,v2mask,v3mask) ! Don't forget bcneutr !
      call ophx    (resv(1,1),resv(1,2),resv(1,3),ux,uy,uz,h1,h2)

      call copy(rhs2,resv,lx1*ly1*lz1*lelv*3)

      do i=1,n
         resv(i,1)=bfx(i,1,1,1)-resv(i,1) ! rhs = rhs - H*u
         resv(i,2)=bfy(i,1,1,1)-resv(i,2)
         resv(i,3)=bfz(i,1,1,1)-resv(i,3)
      enddo

      tolhv = abs(param(22))
      call ophinv(dv1,dv2,dv3
     $   ,resv(1,1),resv(1,2),resv(1,3),h1,h2,tolhv,nmxv)

      call opadd2(ux,uy,uz,dv1,dv2,dv3)

      bd(1) = 1.0
      call rzero(pu,n2)

      dt_old = dt
      dt = dtl
      call incomprn(ux,uy,uz,pu)
      dt = dt_old

      return
      end
c-----------------------------------------------------------------------
      subroutine adv_geom(dtl) ! Advance the geometry
      include 'SIZE'
      include 'TOTAL'

      param(28) = 1   !  This forces Euler Forward for Mesh Update
                      !  Note: p28 must be set prior to call settime

      dt_tmp = dt     ! Save "full" dt value
      dt     = dtl

      ifield = 1
      call gengeom(2)
      ifield = 1

      dt     = dt_tmp ! Restore dt

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!No data race. The data environment of the task is created according to the
!data-sharing attribute clauses, here at line 21:27 it is var. Hence, var is
!modified 10 times, resulting to the value 10.

program DRB122_taskundeferred_orig_no
    use omp_lib
    implicit none

    integer :: var, i
    var = 0

    !$omp parallel sections
    do i = 1, 10
        !$omp task shared(var) if(.FALSE.)
        var = var+1;
        !$omp end task
    end do
    !$omp end parallel sections

    print 100, var
    100 format ('var =', 3i8)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This one has data races due to true dependence.
!But data races happen at instruction level, not thread level.
!Data race pair: a[i+1]@32 vs. a[i]@32

program DRB024_simdtruedep_orig_yes
    use omp_lib
    implicit none

    integer :: i, len
    integer, dimension(:), allocatable :: a
    integer, dimension(:), allocatable :: b

    len = 100

    allocate (a(len))
    allocate (b(len))

    do i = 1, len
        a(i) = i
        b(i) = i+1
    end do

    !$omp simd
    do i = 1, len-1
        a(i+1) = a(i) + b(i)
    end do

    do i = 1, len
        write(6,*) 'Values for i and a(i) are:', i, a(i)
    end do

    deallocate(a,b)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Use of private() clause. No data race pairs.


module DRB057
    use omp_lib
    implicit none

    integer :: MSIZE
    integer :: n,m,mits
    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:,:), pointer :: u,f,uold
    real(dp) :: dx,dy,tol,relax,alpha

contains
    subroutine initialize()
        integer :: i,j,xx,yy

        MSIZE = 200
        mits = 1000
        relax = 1.0
        alpha = 0.0543
        n = MSIZE
        m = MSIZE
        allocate(u(MSIZE,MSIZE))
        allocate(f(MSIZE,MSIZE))
        allocate(uold(MSIZE,MSIZE))

        dx = 2.0D0 / DBLE(n-1)
        dy = 2.0D0 / DBLE(m-1)

        !Initialize initial condition and RHS
        !$omp parallel do private(i,j,xx,yy)
        do i = 1, n
            do j = 1, m
                xx = int(-1.0 + dx * (i-1))
                yy = int(-1.0 + dy * (i-1))
                u(i,j) = 0.0
                f(i,j) = -1.0 * alpha * (1.0-xx*xx) * (1.0-yy*yy) - 2.0* (1.0-xx*xx) -2.0 * (1.0-yy*yy)
            end do
        end do
        !$omp end parallel do

    end subroutine
end module

program DRB057_jacobiinitialize_orig_no
    use omp_lib
    use DRB057
    implicit none

    call initialize()
end program

c-----------------------------------------------------------------------
c
c     TO DO:   Need to monitor dssum when using DG.  (11/29/15, pff)
c
c              Specifically - line 837 in navier4.f
c                           - line 537 in hmholtz.f
c
c-----------------------------------------------------------------------
      subroutine setrhs(p,h1,h2,h2inv)
C
C     Project rhs onto best fit in the "E" norm.
C
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'
C
      REAL             P    (LX2,LY2,LZ2,LELV)
      REAL             H1   (LX1,LY1,LZ1,LELV)
      REAL             H2   (LX1,LY1,LZ1,LELV)
      REAL             H2INV(LX1,LY1,LZ1,LELV)
C
      logical ifdump
      save    ifdump
      data    ifdump /.false./
C
      PARAMETER (LTOT2=LX2*LY2*LZ2*LELV)
      COMMON /ORTHOV/ RHS(LTOT2,MXPREV)
      COMMON /ORTHOX/ Pbar(LTOT2),Pnew(LTOT2)
      COMMON /ORTHOS/ ALPHA(Mxprev), WORK(Mxprev), ALPHAN, DTLAST
      COMMON /ORTHOI/ Nprev,Mprev
      REAL ALPHA,WORK
C
C
      integer icalld
      save    icalld
      data    icalld/0/
C
C     First call, we have no vectors to orthogonalize against.
      IF (ICALLD.EQ.0) THEN
         icalld=icalld+1
         Nprev=0
         Mprev=param(93)
         Mprev=min(Mprev,Mxprev)
      endif
C
C     Diag to see how much reduction in the residual is attained.
C
      NTOT2  = lx2*ly2*lz2*NELV
      ALPHA1 = GLSC3(p,p,bm2inv,NTOT2)
      if (alpha1.gt.0) ALPHA1 = sqrt(alpha1/volvm2)
C
C     Update rhs's if E-matrix has changed
C
      CALL UPDRHSE(P,H1,H2,H2INV,ierr)
      if (ierr.eq.1) Nprev=0
C
C     Perform Gram-Schmidt for previous rhs's.
C
      DO 10 I=1,Nprev
         ALPHA(i) = VLSC2(P,RHS(1,i),NTOT2)
   10 CONTINUE
C
      IF (Nprev.GT.0) CALL gop(alpha,WORK,'+  ',Nprev)
C
      CALL RZERO(Pbar,NTOT2)
      DO 20 I=1,Nprev
         alphas = alpha(i)
         CALL ADD2S2(Pbar,RHS(1,i),alphas,NTOT2)
   20 CONTINUE
C
      if (Nprev.gt.0) then
         INTETYPE = 1
         CALL CDABDTP(Pnew,Pbar,H1,H2,H2INV,INTETYPE)
         CALL SUB2   (P,Pnew,NTOT2)
C    ................................................................
C      Diag.
         ALPHA2 = GLSC3(p,p,bm2inv,NTOT2)
         if (alpha2.gt.0) ALPHA2 = sqrt(alpha2/volvm2)
         ratio  = alpha1/alpha2
         n10=min(10,nprev)
c         IF (NIO.EQ.0) WRITE(6,11)ISTEP,Nprev,(ALPHA(I),I=1,N10)
c         IF (NIO.EQ.0) WRITE(6,12) ISTEP,nprev,ALPHA1,ALPHA2,ratio
   11    FORMAT(2I5,' alpha:',1p10e12.4)
   12    FORMAT(I6,i4,1p3e12.4,' alph12')
C
c        if (alpha1.gt.0.001 .and. .not.ifdump) then
c           IF (NID.EQ.0) WRITE(6,*) 'alph1 large ... '
c           if (istep.gt.10) then 
c              IF (NID.EQ.0) WRITE(6,*) ' ... dumping'
c              call prepost (.true.,'   ')
c              ifdump = .true.
c           else
c              IF (NID.EQ.0) WRITE(6,*) ' ... doing nothing'
c           endif
c        endif
c        if (alpha1.gt.0.1.and.istep.gt.10) then
c           IF (NID.EQ.0) WRITE(6,*) 'alph1 too large ... aborting'
c           call prepost (.true.,'   ')
c           call exitt
c        endif
C    ................................................................
      endif
C
C
      return
      end
c-----------------------------------------------------------------------
      subroutine gensoln(p,h1,h2,h2inv)
C
C     Reconstruct the solution to the original problem by adding back
C     the previous solutions
C     know the soln.
C
      include 'SIZE'
      PARAMETER (LTOT2=LX2*LY2*LZ2*LELV)
      COMMON /ORTHOV/ RHS(LTOT2,MXPREV)
      COMMON /ORTHOX/ Pbar(LTOT2),Pnew(LTOT2)
      COMMON /ORTHOS/ ALPHA(Mxprev), WORK(Mxprev), ALPHAN, DTLAST
      COMMON /ORTHOI/ Nprev,Mprev
      REAL ALPHA,WORK

      REAL             P    (LX2,LY2,LZ2,LELV)
      REAL             H1   (LX1,LY1,LZ1,LELV)
      REAL             H2   (LX1,LY1,LZ1,LELV)
      REAL             H2INV(LX1,LY1,LZ1,LELV)
C
      NTOT2=lx2*ly2*lz2*NELV
C
C     First, save current solution
C
      CALL COPY (Pnew,P,NTOT2)
C
C     Reconstruct solution
C
      CALL ADD2(P,Pbar,NTOT2)
C
C     Update the set of <p,rhs>
C
      CALL UPDTSET(P,H1,H2,H2INV,ierr)
      if (ierr.eq.1) Nprev = 0
c
      return
      end
c-----------------------------------------------------------------------
      subroutine updtset(p,h1,h2,h2inv,IERR)
C
C     Update the set of rhs's and the corresponding p-set:
C
C        . Standard case is to add P_new, and RHS_new = E*P_new
C
C        . However, when Nprev=Mprev (max. allowed), we throw out
C          the old set, and set P_1 = P, RHS_1=E*P_1
C
C        . Other schemes are possible, e.g., let's save a bunch of
C          old vectors, perhaps chosen wisely via P.O.D.
C
C
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      PARAMETER (LTOT2=LX2*LY2*LZ2*LELV)
      COMMON /ORTHOV/ RHS(LTOT2,MXPREV)
      COMMON /ORTHOX/ Pbar(LTOT2),Pnew(LTOT2)
      COMMON /ORTHOS/ ALPHA(Mxprev), WORK(Mxprev), ALPHAN, DTLAST
      COMMON /ORTHOI/ Nprev,Mprev

      REAL ALPHA,WORK

      REAL             P    (LX2,LY2,LZ2,LELV)
      REAL             H1   (LX1,LY1,LZ1,LELV)
      REAL             H2   (LX1,LY1,LZ1,LELV)
      REAL             H2INV(LX1,LY1,LZ1,LELV)
C
      NTOT2=lx2*ly2*lz2*NELV
C
      IF (Nprev.EQ.Mprev) THEN
         CALL COPY(Pnew,P,NTOT2)
         Nprev=0
      endif
C
C     Increment solution set
      Nprev = Nprev+1
C
      CALL COPY   (RHS(1,Nprev),Pnew,NTOT2)

C     Orthogonalize rhs against previous rhs and normalize

      write(6,*) istep,nprev,' call econj2'
      call econj (nprev,h1,h2,h2inv,ierr)
C     call echeck(nprev,h1,h2,h2inv,intetype)
C
c     Save last sol'n
      CALL COPY(Pnew,P,NTOT2)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine econj(kprev,h1,h2,h2inv,ierr)
C
C     Orthogonalize the rhs wrt previous rhs's for which we already
C     know the soln.
C
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'
C
      REAL             H1   (LX1,LY1,LZ1,LELV)
      REAL             H2   (LX1,LY1,LZ1,LELV)
      REAL             H2INV(LX1,LY1,LZ1,LELV)
C
      PARAMETER (LTOT2=LX2*LY2*LZ2*LELV)
      COMMON /ORTHOV/ RHS(LTOT2,MXPREV)
      COMMON /ORTHOX/ Pbar(LTOT2),Pnew(LTOT2),Pbrr(ltot2)
      COMMON /ORTHOS/ ALPHA(Mxprev), WORK(Mxprev), ALPHAN, DTLAST
      COMMON /ORTHOI/ Nprev,Mprev
      REAL ALPHA,WORK
      real ALPHAd
C
C
      ierr  = 0
      NTOT2 = lx2*ly2*lz2*NELV
      INTETYPE=1
C
C     Gram Schmidt, w re-orthogonalization
C
      npass=1
      if (abs(param(105)).eq.2) npass=2
      do ipass=1,npass
c
         CALL CDABDTP(Pbrr,RHS(1,Kprev),H1,H2,H2INV,INTETYPE)
C
C        Compute part of the norm
         Alphad = GLSC2(RHS(1,Kprev),Pbrr,NTOT2)
C
C        Gram-Schmidt
         Kprev1=Kprev-1
         DO 10 I=1,Kprev1
            ALPHA(I) = VLSC2(Pbrr,RHS(1,i),NTOT2)
   10    CONTINUE
         IF (Kprev1.GT.0) CALL gop(alpha,WORK,'+  ',Kprev1)
C
         DO 20 I=1,Kprev1
            alpham = -alpha(i)
            CALL ADD2S2(RHS(1,Kprev),RHS (1,i),alpham,NTOT2)
            Alphad = Alphad - alpha(i)**2
   20    CONTINUE
      enddo
C
C    .Normalize new element in P~
C
      if (ALPHAd.le.0.0) then
         if (nio.eq.0)
     $   write(6,*) 'ERROR:  alphad .le. 0 in econj',alphad,Kprev
         ierr = 1
         return
      endif
      ALPHAd = 1.0/SQRT(ALPHAd)
      ALPHAN = Alphad
      CALL CMULT(RHS (1,Kprev),alphan,NTOT2)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine chkptol
C--------------------------------------------------------------------
C
C     Check pressure tolerance for transient case.
C
C     pff 6/20/92
C     This routine has been modified for diagnostic purposes only.
C     It can be replaced with the standard nekton version.
C 
C--------------------------------------------------------------------
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'INPUT'
      include 'TSTEP'
      COMMON /CTOLPR/ DIVEX
      COMMON /CPRINT/ IFPRINT
      LOGICAL         IFPRINT
C
      COMMON /SCRUZ/  DIVV (LX2,LY2,LZ2,LELV)
     $ ,              BDIVV(LX2,LY2,LZ2,LELV)
C
      if (ifsplit) return
      IF (param(102).eq.0.and.(TOLPDF.NE.0. .OR. ISTEP.LE.5)) return
      five = 5.0
      if (param(102).ne.0.0) five=param(102)
C
      NTOT2 = lx2*ly2*lz2*NELV
      if (ifield.eq.1) then     ! avo: sub arguments?
         CALL OPDIV (BDIVV,VX,VY,VZ)
      else
         CALL OPDIV (BDIVV,BX,BY,BZ)
      endif
      CALL COL3 (DIVV,BDIVV,BM2INV,NTOT2)
      DNORM = SQRT(GLSC2(DIVV,BDIVV,NTOT2)/VOLVM2) 
C
      if (nio.eq.0) WRITE (6,*) istep,' DNORM, DIVEX',DNORM,DIVEX
C
c     IF (istep.gt.10.and.DNORM.GT.(1.01*DIVEX).AND.DIVEX.GT.0.) then
c        if (DNORM.gt.1e-8) then
c           if (nid.eq.0) WRITE(6,*) 'DNORM-DIVEX div. ... aborting'
c           call prepost (.true.,'   ')
c           call exitt
c        else
c           if (nid.eq.0) WRITE(6,*) 'DNORM-DIVEX div. ... small'
c        endif
c     endif
C
c     IF (DNORM.GT.(1.2*DIVEX).AND.DIVEX.GT.0.) TOLPDF = 5.*DNORM
      IF (istep.gt.5.and.tolpdf.eq.0.0.and.
     $    DNORM.GT.(1.2*DIVEX).AND.DIVEX.GT.0.) 
     $     TOLPDF = FIVE*DNORM
C
      return
      end
      FUNCTION VLSC3(X,Y,B,N)
C
C     local inner product, with weight
C
      DIMENSION X(1),Y(1),B(1)
      REAL DT
C
      include 'OPCTR'
C
#ifdef TIMER
C
      if (isclld.eq.0) then
          isclld=1
          nrout=nrout+1
          myrout=nrout
          rname(myrout) = 'VLSC3 '
      endif
      isbcnt = 3*n
      dct(myrout) = dct(myrout) + dfloat(isbcnt)
      ncall(myrout) = ncall(myrout) + 1
      dcount      =      dcount + dfloat(isbcnt)
#endif
C
      DT = 0.0
      DO 10 I=1,N
         T = X(I)*Y(I)*B(I)
         DT = DT+T
 10   CONTINUE
      T=DT
      VLSC3 = T
      return
      end
c-----------------------------------------------------------------------
      subroutine updrhse(p,h1,h2,h2inv,ierr)
C
C     Update rhs's if E-matrix has changed
C
C
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'TSTEP'
C
      PARAMETER (LTOT2=LX2*LY2*LZ2*LELV)
      COMMON /ORTHOV/ RHS(LTOT2,MXPREV)
      COMMON /ORTHOX/ Pbar(LTOT2),Pnew(LTOT2)
      COMMON /ORTHOS/ ALPHA(Mxprev), WORK(Mxprev), ALPHAN, DTLAST
      COMMON /ORTHOI/ Nprev,Mprev
      COMMON /ORTHOL/ IFNEWE
      REAL ALPHA,WORK
      LOGICAL IFNEWE
C
C
      REAL             P    (LX2,LY2,LZ2,LELV)
      REAL             H1   (LX1,LY1,LZ1,LELV)
      REAL             H2   (LX1,LY1,LZ1,LELV)
      REAL             H2INV(LX1,LY1,LZ1,LELV)
C
      integer icalld
      save    icalld
      data    icalld/0/

      ntot2=lx2*ly2*lz2*nelv


C     First, we have to decide if the E matrix has changed.


      if (icalld.eq.0) then
         icalld=1
         dtlast=dt
      endif

      ifnewe=.false.
      if (ifmvbd) then
         ifnewe=.true.
         call invers2(bm2inv,bm2,ntot2)
      endif
      if (dtlast.ne.dt) then
         ifnewe=.true.
         dtlast=dt
      endif
c     if (ifnewe.and.nio.eq.0) write(6,*) istep,'reorthogo:',nprev

     
C     
C     Next, we reconstruct a new rhs set.
C     
      if (ifnewe) then
c
c        new idea...
c        if (nprev.gt.0) nprev=1
c        call copy(rhs,pnew,ntot2)
c
         Nprevt = Nprev
         DO 100 Iprev=1,Nprevt
C           Orthogonalize this rhs w.r.t. previous rhs's
            call econj (iprev,h1,h2,h2inv,ierr)
            if (ierr.eq.1) then
               if (nio.eq.0) write(6,*) istep,ierr,' econj error'
               nprev = 0
               return
            endif
  100    CONTINUE
C
      endif
C
      return
      end
c-----------------------------------------------------------------------
      subroutine hconj(approx,k,h1,h2,vml,vmk,ws,name4,ierr)
c
c     Orthonormalize the kth vector against vector set
c
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'PARALLEL'
      include 'TSTEP'
c
      parameter  (lt=lx1*ly1*lz1*lelt)
      real approx(lt,0:1),h1(1),h2(1),vml(1),vmk(1),ws(1)
      character*4 name4
c
      ierr=0
      ntot=lx1*ly1*lz1*nelfld(ifield)
c
      call axhelm  (approx(1,0),approx(1,k),h1,h2,1,1)
      call col2    (approx(1,0),vmk,ntot)
c
c     Compute part of the norm   (Note:  a(0) already scaled by vml)
c
      alpha = glsc2(approx(1,0),approx(1,k),ntot)
      alph1 = alpha
c
c     Gram-Schmidt
c
      km1=k-1
      do i=1,km1
         ws(i) = vlsc2(approx(1,0),approx(1,i),ntot)
      enddo
      if (km1.gt.0) call gop(ws,ws(k),'+  ',km1)
c
      do i=1,km1
         alpham = -ws(i)
         call add2s2(approx(1,k),approx(1,i),alpham,ntot)
         alpha = alpha - ws(i)**2
      enddo
c
c    .Normalize new element in approximation space
c
      eps = 1.e-7
      if (wdsize.eq.8) eps = 1.e-15
      ratio = alpha/alph1
c
      if (ratio.le.0) then
         ierr=1
         if (nio.eq.0) write(6,12) istep,name4,k,alpha,alph1
   12    format(I6,1x,a4,' alpha b4 sqrt:',i4,1p2e12.4)
      elseif (ratio.le.eps) then
         ierr=2
         if (nio.eq.0) write(6,12) istep,name4,k,alpha,alph1
      else
         ierr=0
         alpha = 1.0/sqrt(alpha)
         call cmult(approx(1,k),alpha,ntot)
      endif
c
      if (ierr.ne.0) then
         call axhelm  (approx(1,0),approx(1,k),h1,h2,1,1)
         call col2    (approx(1,0),vmk,ntot)
c
c        Compute part of the norm   (Note:  a(0) already scaled by vml)
c
         alpha = glsc2(approx(1,0),approx(1,k),ntot)
         if (nio.eq.0) write(6,12) istep,name4,k,alpha,alph1
         if (alpha.le.0) then
            ierr=3
            if (nio.eq.0) write(6,12) istep,name4,k,alpha,alph1
            return
         endif
         alpha = 1.0/sqrt(alpha)
         call cmult(approx(1,k),alpha,ntot)
         ierr = 0
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine hmhzpf(name,u,r,h1,h2,mask,mult,imesh,tli,maxit,isd,bi)
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'FDMH1'
      include 'CTIMER'
c
      CHARACTER*4    NAME
      REAL           U    (LX1,LY1,LZ1,1)
      REAL           R    (LX1,LY1,LZ1,1)
      REAL           H1   (LX1,LY1,LZ1,1)
      REAL           H2   (LX1,LY1,LZ1,1)
      REAL           MASK (LX1,LY1,LZ1,1)
      REAL           MULT (LX1,LY1,LZ1,1)
      REAL           bi   (LX1,LY1,LZ1,1)
      COMMON /CTMP0/ W1   (LX1,LY1,LZ1,LELT)
     $ ,             W2   (LX1,LY1,LZ1,LELT)
c
      etime1=dnekclock()
c
      IF (IMESH.EQ.1) NTOT = lx1*ly1*lz1*NELV
      IF (IMESH.EQ.2) NTOT = lx1*ly1*lz1*NELT
c
      tol = tli
      if (param(22).ne.0) tol = abs(param(22))
      CALL CHKTCG1 (TOL,R,H1,H2,MASK,MULT,IMESH,ISD)
c
c
c     Set flags for overlapping Schwarz preconditioner (pff 11/12/98)
c
                          kfldfdm = -1
c     if (name.eq.'TEMP') kfldfdm =  0
c     if (name.eq.'VELX') kfldfdm =  1
c     if (name.eq.'VELY') kfldfdm =  2
c     if (name.eq.'VELZ') kfldfdm =  3
      if (name.eq.'PRES') kfldfdm =  ldim+1

      if (ifdg) then
         call cggo_dg (u,r,h1,h2,bi,mask,name,tol,maxit)
      else
         call cggo
     $      (u,r,h1,h2,mask,mult,imesh,tol,maxit,isd,bi,name)
      endif
      thmhz=thmhz+(dnekclock()-etime1)
c
c
      return
      end
c-----------------------------------------------------------------------
      subroutine hsolve(name,u,r,h1,h2,vmk,vml,imsh,tol,maxit,isd
     $                 ,approx,napprox,bi)
c
c     Either std. Helmholtz solve, or a projection + Helmholtz solve
c
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
c
      CHARACTER*4    NAME
      REAL           U    (LX1,LY1,LZ1,1)
      REAL           R    (LX1,LY1,LZ1,1)
      REAL           H1   (LX1,LY1,LZ1,1)
      REAL           H2   (LX1,LY1,LZ1,1)
      REAL           vmk  (LX1,LY1,LZ1,1)
      REAL           vml  (LX1,LY1,LZ1,1)
      REAL           bi   (LX1,LY1,LZ1,1)
      REAL           approx (1)
      integer        napprox(1)
      common /ctmp2/ w1   (lx1,ly1,lz1,lelt)
      common /ctmp3/ w2   (2+2*mxprev)

      logical ifstdh
      character*4  cname
      character*6  name6

      logical ifwt,ifvec

      call chcopy(cname,name,4)
      call capit (cname,4)

      ifstdh = .true. ! default is no projection
      if (ifprojfld(ifield)) then
         ifstdh = .false.
      endif

      p945 = param(94)
      if (cname.eq.'PRES') then
         ifstdh = .false.
         p945 = param(95)
      endif

      if (ifield.gt.ldimt_proj+1) ifstdh = .true.
      if (param(93).eq.0)         ifstdh = .true.
      if (p945.eq.0)              ifstdh = .true.
      if (istep.lt.p945)          ifstdh = .true.

      if (ifstdh) then
         call hmholtz(name,u,r,h1,h2,vmk,vml,imsh,tol,maxit,isd)
      else

         n = lx1*ly1*lz1*nelfld(ifield)

         call col2   (r,vmk,n)
         call dssum  (r,lx1,ly1,lz1)

         call blank (name6,6)
         call chcopy(name6,name,4)
         ifwt  = .true.
         ifvec = .false.

         call project1
     $       (r,n,approx,napprox,h1,h2,vmk,vml,ifwt,ifvec,name6)

         call hmhzpf (name,u,r,h1,h2,vmk,vml,imsh,tol,maxit,isd,bi)

         call project2
     $       (u,n,approx,napprox,h1,h2,vmk,vml,ifwt,ifvec,name6)

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine project1(b,n,rvar,ivar,h1,h2,msk,w,ifwt,ifvec,name6)

c     1. Compute the projection of x onto X

c     2. Re-orthogonalize the X basis set and corresponding B=A*X
c        vectors if A has changed.

c     Output:  b = b - projection of b onto B

c     Input:   n     = length of field (or multifields, when ifvec=true)
c              rvar  = real array of field values, including old h1,h2, etc.
c              ivar  = integer array of pointers, etc.
c              h1    = current h1, for Axhelm(.,.,h1,h2,...)
c              h2    = current h2
c              msk   = mask for Dirichlet BCs
c              w     = weight for inner products (typ. w=vmult, tmult, etc.)
c              ifwt  = use weighted inner products when ifwt=.true.
c              ifvec = are x and b vectors, or scalar fields?
c              name6 = discriminator for action of A*x

c     The idea here is to have one pair of projection routines for 
c     constructing the new rhs (project1) and reconstructing the new
c     solution (x = xbar + dx) plus updating the approximation space.
c     The latter functions are done in project2.
c
c     The approximation space X and corresponding right-hand sides,
c     B := A*X are stored in rvar, as well as h1old and h2old and a
c     couple of other auxiliary arrays.

c     In this new code, we retain both X and B=A*X and we re-orthogonalize
c     at each timestep (with no extra matrix-vector products, but O(nm)
c     work.   The idea is to retain fresh vectors by injecting the most 
c     recent solution and pushing the oldest off the stack, hopefully 
c     keeping the number of vectors, m, small.


      include 'SIZE'   ! For nid/nio
      include 'TSTEP'  ! For istep
      include 'CTIMER'

      real b(n),rvar(n,1),h1(n),h2(n),w(n),msk(n)
      integer ivar(1)
      character*6 name6
      logical ifwt,ifvec

      etime0 = dnekclock() 

      nn = n
      if (ifvec) nn = n*ldim

      call proj_get_ivar
     $   (m,mmx,ixb,ibb,ix,ib,ih1,ih2,ivar,n,ifvec,name6)

      if (m.le.0) return

      ireset=iproj_chk(rvar(ih1,1),rvar(ih2,1),h1,h2,n) ! Updated matrix?

      bb4 = glsc3(b,w,b,n)
      bb4 = sqrt(bb4)


c     Re-orthogonalize basis set w.r.t. new vectors if space has changed.

      if (ireset.eq.1) then

         do j=0,m-1         ! First, set B := A*X
            jb = ib+j*nn    !Iterate through xs and bs
            jx = ix+j*nn
            call proj_matvec (rvar(jb,1),rvar(jx,1),n,h1,h2,msk,name6)
         enddo

         if (nio.eq.0 .and. loglevel.gt.2) 
     $      write(6,'(13x,A)') 'Reorthogonalize Basis'

         call proj_ortho_full
     $      (rvar(ix,1),rvar(ib,1),n,m,w,ifwt,ifvec,name6)      

         ivar(2) = m ! Update number of saved vectors

      endif

c     ixb is pointer to xbar,  ibb is pointer to bbar := A*xbar

      call project1_a(rvar(ixb,1),rvar(ibb,1),b,rvar(ix,1),rvar(ib,1)
     $               ,n,m,w,ifwt,ifvec)

      baf = glsc3(b,w,b,n)
      baf = sqrt(baf)
      ratio = bb4/baf

      tproj = tproj + dnekclock() - etime0

      if (nio.eq.0) write(6,1) istep,'  Project ' // name6,
     &                         baf,bb4,ratio,m,mmx
    1 format(i11,a,6x,1p3e13.4,i4,i4)

      return
      end
c-----------------------------------------------------------------------
      subroutine project1_a(xbar,bbar,b,xx,bb,n,m,w,ifwt,ifvec)

c     xbar is best fit in xx, bbar = A*xbar
c     b <-- b - bbar

      include 'SIZE'
      include 'TSTEP'
      include 'INPUT'
      include 'PARALLEL'
      parameter(lt=lx1*ly1*lz1*lelv)
      real xbar(n),bbar(n),b(n),xx(n,m),bb(n,m),w(n)
      logical ifwt,ifvec
      integer e,eg
      parameter(lxyz=lx1*ly1*lz1)
      real tt(lxyz,lelt)

      real work(mxprev),alpha(mxprev)

      if (m.le.0) return

      !First round of CGS
      do k = 1, m 
         if(ifwt) then
            alpha(k) = vlsc3(xx(1,k),w,b,n)
         else
            alpha(k) = vlsc2(xx(1,k),b,n)
         endif
      enddo
      !First one outside loop to avoid zeroing xbar and bbar
      call gop(alpha,work,'+  ',m)
      call cmult2(xbar,xx(1,1),alpha(1),n)
      call cmult2(bbar,bb(1,1),alpha(1),n)
      call add2s2(b,bb(1,1),-alpha(1),n)
      do k = 2,m
         call add2s2(xbar,xx(1,k),alpha(k),n)
         call add2s2(bbar,bb(1,k),alpha(k),n)
         call add2s2(b,bb(1,k),-alpha(k),n)
      enddo
      !Second round of CGS
      do k = 1, m
         if(ifwt) then
            alpha(k) = vlsc3(xx(1,k),w,b,n)
         else
            alpha(k) = vlsc2(xx(1,k),b,n)
         endif
      enddo
      call gop(alpha,work,'+  ',m) 
      do k = 1,m
         call add2s2(xbar,xx(1,k),alpha(k),n)
         call add2s2(bbar,bb(1,k),alpha(k),n)
         call add2s2(b,bb(1,k),-alpha(k),n)
      enddo 

      return
      end
c-----------------------------------------------------------------------
      function iproj_chk(h1old,h2old,h1,h2,n)
      include 'SIZE'
      include 'TOTAL'

c     Matrix has changed if h1/h2 differ from old values

      real h1(n),h2(n),h1old(n),h2old(n)

      iproj_chk = 0

      if (ifmvbd) then
         iproj_chk = 1
         return
      endif

      dh1 = 0.
      dh2 = 0.
      do i=1,n
         dh1 = max(dh1,abs(h1(i)-h1old(i)))
         dh2 = max(dh2,abs(h2(i)-h2old(i)))
      enddo
      dh = max(dh1,dh2)
      dh = glmax(dh,1)  ! Max across all processors

      if (dh.gt.0) then

         call copy(h1old,h1,n)   ! Save old h1 / h2 values
         call copy(h2old,h2,n)

         iproj_chk = 1      ! Force re-orthogonalization of basis

      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine proj_matvec(b,x,n,h1,h2,msk,name6)
      include 'SIZE'
      include 'TOTAL'
      real b(n),x(n),h1(n),h2(n),msk(n)
      character*6 name6

c     This is the default matvec for nekcem.

c     The code can later be updated to support different matvec
c     implementations, which would be discriminated by the character
c     string "name6"

      isd  = 1    ! This probably won't work for axisymmetric
      imsh = 1
      if (iftmsh(ifield)) imsh=2

      call axhelm  (b,x,h1,h2,imsh,isd)       ! b = A x
      call dssum   (b,lx1,ly1,lz1)
      call col2    (b,msk,n)

      return
      end
c-----------------------------------------------------------------------
      !O(nm) method for updating projection space
      !See James Lotte's note or Nicholas Christensen's master's thesis
      subroutine proj_ortho(xx,bb,n,m,w,ifwt,ifvec,name6)

      include 'SIZE'      ! nio
      include 'TSTEP'     ! istep
      include 'PARALLEL'  ! wdsize

      real xx(n,1), bb(n,1), w(n)
      character*6 name6
      logical ifwt, ifvec
      real tol, nrm, scl1, scl2, c, s
      real work(mxprev), alpha(mxprev), beta(mxprev)
      integer h

      if(m.le.0) return !No vectors to ortho-normalize 

      ! AX = B
      ! Calculate dx, db: dx = x-XX^Tb, db=b-BX^Tb     
         
      do k = 1, m !First round CGS
         if(ifwt) then
            alpha(k) = 0.5*(vlsc3(xx(1,k),w,bb(1,m),n)
     $                 +    vlsc3(bb(1,k),w,xx(1,m),n))
         else
            alpha(k) = 0.5*(vlsc2(xx(1,k),bb(1,m),n)
     $                 +    vlsc2(bb(1,k),xx(1,m),n))
         endif
      enddo
      call gop(alpha,work,'+  ',m)
      nrm = sqrt(alpha(m)) !Calculate A-norm of new vector
      do k = 1,m-1
         call add2s2(xx(1,m),xx(1,k),-alpha(k),n)
         call add2s2(bb(1,m),bb(1,k),-alpha(k),n)
      enddo
      
      do k = 1, m-1 !Second round CGS
         if(ifwt) then
            beta(k) = 0.5*(vlsc3(xx(1,k),w,bb(1,m),n)
     $                 +   vlsc3(bb(1,k),w,xx(1,m),n))
         else
            beta(k) = 0.5*(vlsc2(xx(1,k),bb(1,m),n)
     $                 +   vlsc2(bb(1,k),xx(1,m),n))
         endif
      enddo
      call gop(beta,work,'+  ',m-1)
      do k = 1,m-1
         call add2s2(xx(1,m),xx(1,k),-beta(k),n)
         call add2s2(bb(1,m),bb(1,k),-beta(k),n)
         !While we're at it,
         !Sum weights from each round to get the total alpha
         alpha(k) = alpha(k) + beta(k)
      enddo

      !Calculate A-norm of newest solution
      if(ifwt) then
        alpha(m) = glsc3(xx(1,m), w, bb(1,m), n) 
      else
        alpha(m) = glsc2(xx(1,m), bb(1,m), n) 
      endif
      alpha(m) = sqrt(alpha(m))
      !dx and db now stored in last column of xx and bb

c     Set tolerance for linear independence
      tol = 1.e-7
      if (wdsize.eq.4) tol=1.e-3

c     Check for linear independence.
      if(alpha(m).gt.tol*nrm) then !New vector is linearly independent    
       
         !Normalize dx and db
         scl1 = 1.0/alpha(m) 
         call cmult(xx(1,m), scl1, n)   
         call cmult(bb(1,m), scl1, n)   

         !We want to throw away the oldest information
         !The below propagates newest information to first vector.
         !This will make the first vector a scalar 
         !multiple of x.
         do k = m, 2, -1
            h = k - 1   
            call givens_rotation(alpha(h),alpha(k),c,s,nrm)
            alpha(h) = nrm     
            do i = 1, n !Apply rotation to xx and bb
               scl1 = c*xx(i,h) + s*xx(i,k)
               xx(i,k) = -s*xx(i,h) + c*xx(i,k)
               xx(i,h) = scl1       
               scl2 = c*bb(i,h) + s*bb(i,k)
               bb(i,k) = -s*bb(i,h) + c*bb(i,k)    
               bb(i,h) = scl2        
            enddo
         enddo

      else !New vector is not linearly independent, forget about it
         k = m !location of rank deficient column

         if (nio.eq.0 .and. loglevel.gt.2) 
     $      write(6,1) istep,k,m,name6,alpha(m),tol

    1       format(i9,'proj_ortho: ',2i4,1x,a6,
     $             ' Detect rank deficiency:',1p2e12.4)
         
         m = m - 1 !Remove column
      endif   

      return
      end      
c-----------------------------------------------------------------------
      !Function to switch between mgs and cgs2 full reorthogonalization
      subroutine proj_ortho_full(xx,bb,n,m,w,ifwt,ifvec,name6)

      include 'SIZE'

      real xx(n,1),bb(n,1),w(n)
      character*6 name6
      logical ifwt,ifvec
      integer flag(mxprev)
 
      !call proj_ortho_full_mgs(xx,bb,n,m,w,ifwt,ifvec,name6)
      call proj_ortho_full_cgs2(xx,bb,n,m,w,ifwt,ifvec,name6)
     
      return
      end      
c-----------------------------------------------------------------------
c     Full MGS reorthogonalization
      subroutine proj_ortho_full_mgs(xx,bb,n,m,w,ifwt,ifvec,name6)

      include 'SIZE'      ! nio
      include 'TSTEP'     ! istep
      include 'PARALLEL'  ! wdsize

      real xx(n,1),bb(n,1),w(n)
      character*6 name6
      logical ifwt,ifvec
      integer flag(mxprev)
      real normk,normp,alpha

      if (m.le.0) return

      if (      ifwt) alpha = glsc3(xx(1,m),w,bb(1,m),n)
      if (.not. ifwt) alpha = glsc2(xx(1,m),bb(1,m),n)
      if (alpha.eq.0) return

      scale = 1./sqrt(alpha)
      call cmult(xx(1,m),scale,n)
      call cmult(bb(1,m),scale,n)
      flag(m) = 1

      do k=m-1,1,-1  ! Reorthogonalize, starting with latest solution

         if (      ifwt) normk = glsc3(xx(1,k),w,bb(1,k),n)
         if (.not. ifwt) normk = glsc2(xx(1,k),bb(1,k),n)
         normk=sqrt(normk)

         do j=m,k+1,-1   ! Modified GS
            if(flag(j).eq.1) then
               alpha = 0.
               if (ifwt) then
                  alpha = alpha + .5*(vlsc3(xx(1,j),w,bb(1,k),n)
     $                       +     vlsc3(bb(1,j),w,xx(1,k),n))
               else
                  alpha = alpha + .5*(vlsc2(xx(1,j),bb(1,k),n)
     $                       +     vlsc2(bb(1,j),xx(1,k),n))
               endif
               scale = -glsum(alpha,1)
               call add2s2(xx(1,k),xx(1,j),scale,n)
               call add2s2(bb(1,k),bb(1,j),scale,n)
            endif
         enddo
         if (      ifwt) normp = glsc3(xx(1,k),w,bb(1,k),n)
         if (.not. ifwt) normp = glsc2(xx(1,k),bb(1,k),n)
         if (normp.gt.0.0) normp=sqrt(normp)

         tol = 1.e-7
         if (wdsize.eq.4) tol=1.e-3

         if (normp.gt.tol*normk) then ! linearly independent vectors
           scale = 1./normp
           call cmult(xx(1,k),scale,n)
           call cmult(bb(1,k),scale,n)
           flag(k) = 1
c          if (nio.eq.0) write(6,2) istep,k,m,name6,normp,normk
c    2      format(i9,'proj_ortho: ',2i4,1x,a6,' project ok.'
c     $           ,1p2e12.4)
         else
           flag(k) = 0
c           if (nio.eq.0) write(6,1) istep,k,m,name6,normp,normk
c    1      format(i9,'proj_ortho: ',2i4,1x,a6,' Detect rank deficiency:'
c     $           ,1p2e12.4)
         endif

      enddo

      k=0
      do j=1,m
         if (flag(j).eq.1) then
            k=k+1
            if (k.lt.j) then
               call copy(xx(1,k),xx(1,j),n)
               call copy(bb(1,k),bb(1,j),n)
            endif
         endif
      enddo
      m = k

      return
      end
c-----------------------------------------------------------------------
      !CGS2 version of full reorthogonalization, possibly more stable in
      !certain instances. Much faster for large m.
      subroutine proj_ortho_full_cgs2(xx,bb,n,m,w,ifwt,ifvec,name6)

      include 'SIZE'      ! nio
      include 'TSTEP'     ! istep
      include 'PARALLEL'  ! wdsize
            
      real xx(n,1),bb(n,1),w(n)
      character*6 name6
      logical ifwt,ifvec
      integer flag(mxprev)
      real normk,normp,alpha(mxprev),work(mxprev),scl1,tol

      if (m.le.0) return

      tol = 1.e-7
      if (wdsize.eq.4) tol=1.e-3

      do i = 1, 2 !Do this twice for CGS2

      do k = m, 1, -1
         do j = m, k, -1
            alpha(j) = 0.0
            if(ifwt) then
                  alpha(j) = .5*(vlsc3(xx(1,j),w,bb(1,k),n)
     $                       +     vlsc3(bb(1,j),w,xx(1,k),n))
            else
                  alpha(j) = .5*(vlsc2(xx(1,j),bb(1,k),n)
     $                       +     vlsc2(bb(1,j),xx(1,k),n))
            endif
         enddo
         call gop(alpha(k), work,'+  ',(m - k) + 1)
         do j = m, k+1, -1
            call add2s2(xx(1,k),xx(1,j),-alpha(j),n)
            call add2s2(bb(1,k),bb(1,j),-alpha(j),n)
         enddo
         normp = sqrt(alpha(k))
         if(ifwt) then
            normk = glsc3(xx(1,k),w,bb(1,k),n)
         else
            normk = glsc2(xx(1,k),bb(1,k),n)
         endif
         normk = sqrt(normk)
         if(normk.gt.tol*normp) then
            scl1 = 1.0/normk
            call cmult(xx(1,k), scl1, n)
            call cmult(bb(1,k), scl1, n)
            flag(k) = 1
         else
            flag(k) = 0
         endif
      enddo

      enddo

      k=0
      do j=1,m
         if (flag(j).eq.1) then
            k=k+1
            if (k.lt.j) then
               call copy(xx(1,k),xx(1,j),n)
               call copy(bb(1,k),bb(1,j),n)
            endif
         endif
      enddo
      m = k

      return
      end      
c-----------------------------------------------------------------------
      subroutine project2(x,n,rvar,ivar,h1,h2,msk,w,ifwt,ifvec,name6)

      include 'CTIMER'

      real x(n),b(n),rvar(n,1),h1(n),h2(n),w(n),msk(n)
      integer ivar(1)
      character*6 name6
      logical ifwt,ifvec

      etime0 = dnekclock()

      call proj_get_ivar(m,mmx,ixb,ibb,ix,ib,ih1,ih2,
     $                             ivar,n,ifvec,name6)

c     ix  is pointer to X,     ib  is pointer to B
c     ixb is pointer to xbar,  ibb is pointer to bbar := A*xbar

      call project2_a(x,rvar(ixb,1),rvar(ix,1),rvar(ib,1)
     $              ,n,m,mmx,h1,h2,msk,w,ifwt,ifvec,name6)

      ivar(2) = m ! Update number of saved vectors

      tproj = tproj + dnekclock() - etime0

      return
      end
c-----------------------------------------------------------------------
      subroutine project2_a(x,xbar,xx,bb,n,m,mmx,h1,h2,msk,w,ifwt,ifvec,
     $                      name6)

      include 'SIZE'

      real x(n),xbar(n),xx(n,1),bb(n,1),h1(n),h2(n),w(n),msk(n)
      character*6 name6
      logical ifwt,ifvec

      nn = n
      if (ifvec) nn=ldim*n

      if (m.gt.0) call add2(x,xbar,n)      ! Restore desired solution

       !Uncomment this if using full reorthogonalization
c      if (m.eq.mmx) then ! Push old vector off the stack
c         do k=2,mmx
c            call copy (xx(1,k-1),xx(1,k),nn)
c            call copy (bb(1,k-1),bb(1,k),nn)
c         enddo
c      endif

      m = min(m+1,mmx)
      !print *, "m", m
      call copy        (xx(1,m),x,nn)   ! Update (X,B)
      call proj_matvec (bb(1,m),xx(1,m),n,h1,h2,msk,name6)
      call proj_ortho  (xx,bb,n,m,w,ifwt,ifvec,name6) !Update orthogonalization
      !Uncomment the if block above if using full reorthogonalization
c      call proj_ortho_full  (xx,bb,n,m,w,ifwt,ifvec,name6) !Fully reorthogonalize

      return
      end
c-----------------------------------------------------------------------
      subroutine proj_get_ivar
     $    (m,mmx,ixb,ibb,ix,ib,ih1,ih2,ivar,n,ifvec,name6)

      include 'SIZE'
      include 'TSTEP'

      logical ifvec
      character*6 name6

      integer ivar(10)

      integer icalld
      save    icalld
      data    icalld/0/

      m    = ivar(2)
      mmx  = (mxprev-4)/2 ! ivar=0 --> mxprev array
      ivar(1) = mmx

      nn = n
      if (ifvec) nn = n*ldim  ! Number of entries in a vector


      ih1  = 1
      ih2  = ih1 + n
      ixb  = ih2 + n      ! pointer to xbar
      ibb  = ixb + nn     !    "    to bbar
      ix   = ibb + nn     !    "    to X
      ib   = ix  + nn*mmx !    "    to B

      return
      end
c-----------------------------------------------------------------------
      subroutine laplacep(name,u,mask,mult,ifld,tol,maxi,approx,napprox)
c
c     Solve Laplace's equation, with projection onto previous solutions.
c
c     Boundary condition strategy:
c
c     u = u0 + ub
c
c        u0 = 0 on Dirichlet boundaries
c        ub = u on Dirichlet boundaries
c
c        _
c        A ( u0 + ub ) = 0
c
c        _            _
c        A  u0  =   - A ub
c
c        _             _
c       MAM u0  =   -M A ub,    M is the mask
c
c                      _
c        A  u0  =   -M A ub ,  Helmholtz solve with SPD matrix A
c
c        u = u0+ub
c
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
c
      character*4 name
      real u(1),mask(1),mult(1),approx (1)
      integer   napprox(1)

      parameter (lt=lx1*ly1*lz1*lelt)
      common /scrvh/ h1(lt),h2(lt)
      common /scruz/ r (lt),ub(lt)

      logical ifstdh
      character*4  cname
      character*6  name6

      logical ifwt,ifvec

      call chcopy(cname,name,4)
      call capit (cname,4)

      call blank (name6,6)
      call chcopy(name6,name,4)
      ifwt  = .true.
      ifvec = .false.
      isd   = 1
      imsh  = 1
      nel   = nelfld(ifld)

      n = lx1*ly1*lz1*nel

      call copy (ub,u,n)             ! ub = u on boundary
      call dsavg(ub)                 ! Make certain ub is in H1
      call rone (h1,n)
      call rzero(h2,n)
                                     !     _
      call axhelm (r,ub,h1,h2,1,1)   ! r = A*ub

      do i=1,n                       !        _
         r(i)=-r(i)*mask(i)          ! r = -M*A*ub
      enddo

      call dssum  (r,lx1,ly1,lz1)    ! dssum rhs

      call project1
     $    (r,n,approx,napprox,h1,h2,mask,mult,ifwt,ifvec,name6)

      if (nel.eq.nelv) then
        call hmhzpf (name,u,r,h1,h2,mask,mult,imsh,tol,maxi,isd,binvm1)
      else
        call hmhzpf (name,u,r,h1,h2,mask,mult,imsh,tol,maxi,isd,bintm1)
      endif

      call project2
     $     (u,n,approx,napprox,h1,h2,mask,mult,ifwt,ifvec,name6)

      call add2(u,ub,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine givens_rotation(a, b, c, s, r)

      real a, b, c, s, r, h, d

      if(b.ne.0.0) then
         h = hypot(a,b) !Can use library version or below implementation
         d = 1.0/h
         c = abs(a)*d
         s = sign(d,a)*b
         r = sign(1.0,a)*h
      else
         c = 1.0
         s = 0.0
         r = a
      endif
        
      return
      end
c-----------------------------------------------------------------------
      ! Compilers with Fortran 2008 support should have a 
      ! library implementation of this (gfortran and ifort do).
      
      real function hypot(a, b) !Does not handle a = b = 0 case

      real a, b, t, x, c, d, ix

      c = abs(a)
      d = abs(b)
      x = max(c,d)
      ix = 1.0/x      
      t = min(c,d)
      t = ix*t

      hypot = x*sqrt(1.0+t*t) 

      return
      end
c-----------------------------------------------------------------------         

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The second taskwait ensures that the second child task has completed; hence it is safe to access
!the y variable in the following print statement.

program DRB133_taskdep5_orig_no_omp45
    use omp_lib
    implicit none

    !$omp parallel
    !$omp single
    call foo()
    !$omp end single
    !$omp end parallel
contains
    subroutine foo()
        implicit none
        integer :: x, y
        x = 0
        y = 2

        !$omp task depend(inout: x) shared(x)
        x = x+1                                 !!1st Child Task
        !$omp end task

        !$omp task depend(in: x) depend(inout: y) shared(x, y)
        y = y-x                                 !!2nd child task
        !$omp end task

        !$omp task depend(in: x) if(.FALSE.)    !!1st taskwait
        !$omp end task

        print*, "x=", x

        !$omp taskwait                          !!2nd taskwait

        print*, "y=", y

    end subroutine
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This loop has loop-carried output-dependence due to x=... at line 21.
!The problem can be solved by using lastprivate(x).
!Data race pair: x@21:9 vs. x@21:9

program DRB009_lastprivatemissing_orig_yes
    use omp_lib
    implicit none

    integer :: i, x, len
    len = 10000

    !$omp parallel do private(i)
    do i = 0, len
        x = i
    end do
    !$omp end parallel do

    write(*,*) 'x =', x
end program

C                   TREEVERSE MECHANISM V2
C                  ========================

c New version of TreeVerse that does not store the entire
c reversal sequence, but rather uses a stack automaton to
c generate the reversal actions one at a time.
c Allows for nested calls to Treeverse, i.e.
C nested iterative loops that use treeverse.
c Uses a small enough stack,
c allowing for 5 nested calls to TRV_INIT,
c and for a cumulated number of snapshots of 99.

c Usage:
c Call TRV_INIT(length, nbSnap, firstStep)
c  giving to it:
c   -- the length  of the sequence you need to inverse, including the
c     last step, the one that exits. E.g "do i=1,10" has length 11 !!
c   -- the number of snapshots your machine can accomodate,
c   -- the index of the first step in the sequence you need to inverse.
c Then repeated calls to TRV_NEXT_ACTION(action, step)
c  return the successive actions the treeverse loop must perform.
c  Also return in "step" the time step on which the action operates.
c  When all actions are done, TRV_NEXT_ACTION returns .FALSE.

c Global memory used to remember the state
c when the stack automaton runs:
c -STACK1 (one level (index is1) per nested treeverse session) :
c   STACK1(1,is1): index of initial level in STACK2 for this session
c   STACK1(2,is1): max number of snapshots allowed for this session
c   STACK1(3,is1): offset for step numbers in this session
c -STACK2 (one level (index is2) per nested (simultaneous) snapshot) :
c   STACK2(1,is2): number of steps to be reversed by this snapshot level
c   STACK2(2,is2): rank of the current step in STACK2(1,is2)
c   STACK2(3,is2): rank of the chosen recursive cut in STACK2(1,is2)
      BLOCK DATA TRV_GLOBAL_DATA
      INTEGER STACK1(3,5), is1, STACK2(3,99), is2
      COMMON /TRV_GLOBALS/ STACK1, is1, STACK2, is2
      DATA is1/0/
      DATA is2/0/
      END

c Initialize one nested session of treeverse commands,
c  using at most "nbSnap" snapshots, to reverse a sequence
c  of length "length", in which the first step in numbered "firstStep"
c Does not alter its arguments, but modifies STACK1 and STACK2.
      SUBROUTINE TRV_INIT(length, nbSnap, firstStep)
      IMPLICIT NONE
      INTEGER nbSnap, length, firstStep
      INTEGER STACK1(3,5), is1, STACK2(3,99), is2
      COMMON /TRV_GLOBALS/ STACK1, is1, STACK2, is2

      IF (length.le.0) THEN
         PRINT*,"Error: Cannot reverse a sequence of length ", length
         STOP
      ELSE IF (nbSnap.eq.0.and.length.ge.2) THEN
         PRINT*,"Error: Cannot reverse a sequence of length ", length,
     +        " with no snapshot"
         STOP
      ELSE IF (is1.ge.5.or.is2+nbsnap+1.ge.99) THEN
         PRINT*,"Error: Treeverse memory exceeded !"
         STOP
      ELSE
         is1 = is1+1
         is2 = is2+1
         STACK1(1,is1) = is2
         STACK1(2,is1) = nbSnap
         STACK1(3,is1) = firstStep
         STACK2(1,is2) = length
         STACK2(2,is2) = 0
         STACK2(3,is2) = 0
      END IF
      END

c Finds the next action in the process of reversing the current
c sequence of steps, i.e. running the current treeverse session.
c Overwrites "action" withthis next action to perform,
c and overwrites step with the index of the iteration step
c that corresponds to this action. Also returns .TRUE. if there
c is such an action waiting, and .FALSE. otherwise, i.e. the
c current reversal session is terminated.
      LOGICAL FUNCTION TRV_NEXT_ACTION(action, step)
      IMPLICIT NONE
      INTEGER action, step, i
      INTEGER STACK1(3,5), is1, STACK2(3,99), is2
      COMMON /TRV_GLOBALS/ STACK1, is1, STACK2, is2
      INTEGER PUSHSNAP, LOOKSNAP, POPSNAP, ADVANCE, FIRSTTURN, TURN
      PARAMETER (PUSHSNAP=1)
      PARAMETER (LOOKSNAP=2)
      PARAMETER (POPSNAP=3)
      PARAMETER (ADVANCE=4)
      PARAMETER (FIRSTTURN=5)
      PARAMETER (TURN=6)

c Part "only for debug":
c      PRINT*, ""
c      PRINT*, "STACK1:"
c      DO i=is1,1,-1
c         WRITE(*,910) STACK1(2,i), STACK1(1,i), STACK1(3,i)
c      ENDDO
c      PRINT*, "-------------------"
c      PRINT*, "STACK2:"
c      DO i=is2,1,-1
c         WRITE(*,920) i,STACK2(1,i), STACK2(2,i), STACK2(3,i)
c      ENDDO
c      PRINT*, "-------------------"
c 910  format(i2," snapshots, stack2 bottom:",i2," (offset:",i3,")")
c 920  format(i2,": R( ,",i3,") ",i3,"/",i3)
c End of "only for debug" part

      IF (STACK2(1,is2).le.0.and.is2.eq.STACK1(1,is1)) THEN
c If we are at the top snapshot level and no step remains to be
c reversed, then this inversion session is terminated.
c Pop to the enclosing inversion session. Return .FALSE.
         step = -1
         action = -1
         is1 = is1-1
         is2 = is2-1
         TRV_NEXT_ACTION = .FALSE.
      ELSE
c compute the index of the step to which the next action
c corresponds or will apply:
         step = 1 ;
         DO i=STACK1(1,is1)+1,is2
            step = step+STACK2(2,i)
         ENDDO
         IF (STACK2(2,is2).eq.-1) THEN
c If the present position is -1, i.e. the current state does not
c correspond to the next time step we are going to execute,
c then take the correct state back from the snapshot.
            IF (STACK2(1,is2).eq.1) THEN
c POP the snapshot we are at last reversing the 1st step after it...
               action = POPSNAP
            ELSE
c ... otherwise only LOOK at the snapshot, and keep it for later use.
               action = LOOKSNAP
            ENDIF
            STACK2(2,is2) = 0
         ELSE
c Now the current state corresponds to the next time step to run on.
            IF (STACK2(2,is2).eq.STACK2(1,is2)-1) THEN
c if the current position is just before the end of the current
c subsequence to reverse by this snapshot level. Then just TURN ...
               IF (step.eq.STACK2(1,STACK1(1,is1))) THEN 
                  action = FIRSTTURN
               ELSE
                  action = TURN
               ENDIF
c ... and update the stack, popping the current snapshot level
c if its work is finished, i.e. its remaining length to reverse is 0.
c Attention do not pop the initial level of the current session.
               IF (STACK2(2,is2).eq.0.and.is2.gt.STACK1(1,is1)) THEN
                  is2 = is2-1
                  STACK2(1,is2) = STACK2(3,is2)
               ELSE
                  STACK2(1,is2) = STACK2(2,is2)
               ENDIF
c mark that the current state in memory is out of date
               STACK2(2,is2) = -1
c compute the new position for the deeper level snapshot
               CALL TRV_SETCUT()
            ELSE
               IF (STACK2(2,is2).eq.STACK2(3,is2)) THEN
c if we just reached the end of this level advance sequence,
c then me must PUSH a snapshot and begin a new nested level of
c snapshot in the current reversal session.
                  action = PUSHSNAP
                  is2 = is2+1
                  STACK2(1,is2) = STACK2(1,is2-1)-STACK2(2,is2-1)
                  STACK2(2,is2) = 0
                  CALL TRV_SETCUT()
                  step = step-1
               ELSE
c else we still need to ADVANCE to reach the next checkpoint
                  action = ADVANCE
                  STACK2(2,is2) = STACK2(2,is2)+1
               ENDIF
            ENDIF
         ENDIF
         TRV_NEXT_ACTION = .TRUE.
      ENDIF
      END

c Find the index of the next CKP cut at the current checkpoint level.
c Store this index into the current STACK2(3, is2).
c Computation depends on the current length to reverse STACK2(1, is2)
c and of the current number of available snapshots, computed as
c STACK1(2,is1)-(is2-STACK1(1,is1))+1, i.e. the initial number of
c snapshots for this session, minus the number of used snapshots,
c i.e. the number of snapshot levels pushed onto STACK2 (minus 1).
c Algorithm is first to find "minRecomp", the minimum number of 
c  recomputations that allow reversing a sequence of this "length",
c  i.e. such that eta(nbSnap,minRecomp) is greater or equal to length.
c By def, eta(nbSnap,recomp)=(nbSnap+recomp)!/(nbSnap!*recomp!)
c Then this "minRecomp" defines the proportion of the length
c which is before the CKP cut, which is
c  eta(nbSnap,minRecomp-1)/eta(nbSnap,minRecomp) which is
c  (by definition of eta) minRecomp/(minRecomp+nbSnap).
c We find the cut index that approaches this proportion best.
c Assert: length>=1 , nbSnap>=0
c Alters the STACKs.
      SUBROUTINE TRV_SETCUT()
      IMPLICIT NONE
      INTEGER STACK1(3,5), is1, STACK2(3,99), is2
      COMMON /TRV_GLOBALS/ STACK1, is1, STACK2, is2
      INTEGER length, nbSnap, eta, minRecomp

      length = STACK2(1,is2)
      nbSnap = STACK1(2,is1)-(is2-STACK1(1,is1))+1
      IF (length.le.1) THEN
         STACK2(3,is2) = 0
      ELSE IF (nbSnap.eq.1) THEN
         STACK2(3,is2) = length-1
      ELSE
         eta = nbSnap+1
         minRecomp = 1
         DO WHILE (eta.LT.length)
            minRecomp = minRecomp+1
            eta = (eta*(nbSnap+minRecomp))/minRecomp
         END DO
         STACK2(3,is2) = (length*minRecomp)/(minRecomp+nbSnap)
         IF (STACK2(3,is2).eq.0) THEN
            STACK2(3,is2) = 1
         ELSE IF (STACK2(3,is2).ge.length) THEN
            STACK2(3,is2) = length-1
         END IF
      ENDIF
      END

      SUBROUTINE TRV_RESIZE()
      IMPLICIT NONE
      INTEGER step, i
      INTEGER STACK1(3,5), is1, STACK2(3,99), is2
      COMMON /TRV_GLOBALS/ STACK1, is1, STACK2, is2

      step = 1 ;
      DO i=STACK1(1,is1)+1,is2
         step = step+STACK2(2,i)
      ENDDO
      WRITE(*,930) "Binomial iteration exits on step",step-1,
     +     " before expected",STACK2(1,STACK1(1,is1))
 930  format(a,i6,a,i6)
      STACK2(1,STACK1(1,is1)) = step-1
      STACK2(1,is2) = STACK2(2,is2)
      STACK2(2,is2) = STACK2(2,is2)-1
      END

C> @file outflow_bc.f Dirichlet states for outflow boundary conditions
      subroutine outflow(nvar,f,e,facew,wbc) ! don't really need nvar anymore
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'

      integer  nvar,f,e
      real facew(lx1,lz1,2*ldim,nelt,nvar)
      real wbc(lx1,lz1,2*ldim,nelt,nvar)

      call outflow_rflu(nvar,f,e,facew,wbc)

      return
      end

!--------------------------------------------------------------------

      subroutine outflow_rflu(nvar,f,e,facew,wbc)
      include 'SIZE'
      include 'NEKUSE'
      include 'CMTDATA'
      include 'CMTBCDATA'
      include 'INPUT'
      include 'GEOM'
      include 'PARALLEL'
      include 'DG'

      integer i,bcOpt
      integer  f,e,fdim
      real facew(lx1*lz1,2*ldim,nelt,nvar)
      real wbc(lx1*lz1,2*ldim,nelt,nvar)
      real sxn,syn,szn,rhou,rhov,rhow,pl,rhob,rhoub,rhovb,rhowb,rhoeb

      nxz=lx1*lz1
      nxzd=lxd*lzd
      fdim=ldim-1
      ieg=lglel(e)

      call facind(i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)    
      l=0
      do iz=k0,k1
      do iy=j0,j1
      do ix=i0,i1
         call nekasgn(ix,iy,iz,e)     ! gives us phi- and rho-
         call cmtasgn(ix,iy,iz,e)
         call userbc (ix,iy,iz,f,ieg) ! just for molarmass, and
                                      ! pres
         l=l+1
         sxn = unx(l,1,f,e)
         syn = uny(l,1,f,e)
         szn = unz(l,1,f,e)
         rhou= facew(l,f,e,iu2)/phi
         rhov= facew(l,f,e,iu3)/phi
         rhow= facew(l,f,e,iu4)/phi
         rhoe= facew(l,f,e,iu5)/phi
         pl= facew(l,f,e,ipr) ! P- here
         wbc(l,f,e,icpf)=facew(l,f,e,icpf)
         wbc(l,f,e,icvf)=facew(l,f,e,icvf)
         cv=facew(l,f,e,icvf)/rho
! JH080118 FIX THIS fOR NEW JWL CODE
         cp=cpgref
c        fs = 0.0
         if(outflsub)then
            pres= pinfty
            idbc=1
         else
            pres= facew(l,f,e,ipr)
            idbc=0
         endif
         call BcondOutflowPerf(idbc,pres,sxn,syn,szn,cp,molarmass,
     >                         rho,rhou,rhov,rhow,rhoe,pl,
     >                         rhob,rhoub,rhovb,rhowb,rhoeb )
         wbc(l,f,e,irho)=rhob
         wbc(l,f,e,iux)=rhoub/rhob
         wbc(l,f,e,iuy)=rhovb/rhob
         wbc(l,f,e,iuz)=rhowb/rhob
! dammit fix this. tdstate to the rescue?
         wbc(l,f,e,ithm)=(rhoeb-0.5*(rhoub**2+rhovb**2+rhowb**2)/rhob)/
     >                   cv
! dammit fix that
         wbc(l,f,e,iu1)=rhob*phi
         wbc(l,f,e,iu2)=rhoub*phi
         wbc(l,f,e,iu3)=rhovb*phi
         wbc(l,f,e,iu4)=rhowb*phi
         wbc(l,f,e,iu5)=rhoeb*phi
         wbc(l,f,e,iph)=phi
         wbc(l,f,e,ipr)=pres
! dammit fix this. tdstate to the rescue?
         wbc(l,f,e,isnd)=sqrt(cp/cv*pres/rho)
! dammit fix that
      enddo
      enddo
      enddo

      return
      end

!******************************************************************************
!
! Purpose: set outflow boundary condition for one cell.
!
! Description: the subsonic boundary condition is based on non-reflecting,
!              characteristics method of Whitfield and Janus: Three-Dimensional
!              Unsteady Euler Equations Solution Using Flux Vector Splitting.
!              AIAA Paper 84-1552, 1984. The supersonic boundary condition
!              consists of simple extrapolation.
!
! Input: bcOpt    = boundary treatment: subsonic, supersonic, or mixed
!        pout     = given static outlet pressure
!        sx/y/zn  = components of ortho-normalized face vector (outward facing)
!        cpgas    = specific heat at constant pressure (boundary cell)
!        mol      = molecular mass at boundary cell
!        rho      = density at boundary cell
!        rhou/v/w = density * velocity components at boundary cell
!        rhoe     = density * total energy at boundary cell
!        press    = static pressure at boundary cell
!
! Output: rhob      = density at boundary
!         rhou/v/wb = density * velocity components at boundary
!         rhoeb     = density * total energy at boundary
!
! Notes: this condition is valid only for thermally and calorically
!        perfect gas (supersonic outflow valid for all gases).
!
!******************************************************************************
!
! $Id: BcondOutflowPerf.F90,v 1.1.1.1 2014/05/05 21:47:47 tmish Exp $
!
! Copyright: (c) 2002 by the University of Illinois
!
!******************************************************************************

      SUBROUTINE BcondOutflowPerf( bcOpt,pout,sxn,syn,szn,cpgas,mol,
     >                       rho,rhou,rhov,rhow,rhoe,press,
     >                       rhob,rhoub,rhovb,rhowb,rhoeb )

      IMPLICIT NONE
      integer bcopt_subsonic,bcopt_mixed
      parameter (BCOPT_SUBSONIC=1)
      parameter (BCOPT_MIXED=0)
      real MixtPerf_C_DGP,MixtPerf_Eo_DGPUVW,MixtPerf_G_CpR,MixtPerf_R_M
     >   , MixtPerf_P_DEoGVm2
      external MixtPerf_C_DGP,MixtPerf_Eo_DGPUVW,MixtPerf_G_CpR,
     >     MixtPerf_R_M,MixtPerf_P_DEoGVm2

! ... parameters
      INTEGER bcOpt

      REAL pout
      REAL rho, rhou, rhov, rhow, rhoe, press
      REAL sxn, syn, szn, cpgas, mol
      REAL rhob, rhoub, rhovb, rhowb, rhoeb

! ... local variables
      REAL csound, rgas, gamma, gam1, u, v, w, mach, rrhoc, deltp,
     >            ub, vb, wb, vnd

!******************************************************************************
! gas properties; velocity components; Mach number

      rgas  = MixtPerf_R_M( mol )
      gamma = MixtPerf_G_CpR( cpgas,rgas )
      gam1  = gamma - 1.0

      u      = rhou/rho
      v      = rhov/rho
      w      = rhow/rho
      csound = MixtPerf_C_DGP( rho,gamma,press )
      mach   = SQRT(u*u+v*v+w*w)/csound

! subsonic flow ---------------------------------------------------------------

      IF (mach .lt. 1.0 .AND.
     >(bcOpt .eq. BCOPT_SUBSONIC .OR. bcOpt .eq. BCOPT_MIXED)) THEN
         rrhoc = 1.0/(rho*csound)
         deltp = press - pout
         rhob  = rho - deltp/(csound*csound)
         ub    = u + sxn*deltp*rrhoc
         vb    = v + syn*deltp*rrhoc
         wb    = w + szn*deltp*rrhoc

! - special treatment to prevent "deltp" from changing the sign
!   of velocity components. This may happen for very small u, v, w.

         vnd = ub*sxn + vb*syn + wb*szn
         IF ( vnd .lt. 0.0 ) THEN ! inflow at outflow boundary
            ub = SIGN(1.0,u)*MAX(ABS(ub),ABS(u))
            vb = SIGN(1.0,v)*MAX(ABS(vb),ABS(v))
            wb = SIGN(1.0,w)*MAX(ABS(wb),ABS(w))
         END IF ! vnd

         rhoub = rhob*ub
         rhovb = rhob*vb
         rhowb = rhob*wb
         rhoeb = rhob*MixtPerf_Eo_DGPUVW( rhob,gamma,pout,ub,vb,wb )

! supersonic flow -------------------------------------------------------------

      ELSE
         rhob  = rho
         rhoub = rhou
         rhovb = rhov
         rhowb = rhow
         rhoeb = rhoe
      END IF ! mach

      end

!******************************************************************************
!
! RCS Revision history:
!
! $Log: BcondOutflowPerf.F90,v $
! Revision 1.1.1.1  2014/05/05 21:47:47  tmish
! Initial checkin for rocflu macro.
!
! Revision 1.3  2008/12/06 08:43:31  mtcampbe
! Updated license.
!
! Revision 1.2  2008/11/19 22:16:46  mtcampbe
! Added Illinois Open Source License/Copyright
!
! Revision 1.1  2007/04/09 18:48:32  haselbac
! Initial revision after split from RocfloMP
!
! Revision 1.1  2007/04/09 17:59:24  haselbac
! Initial revision after split from RocfloMP
!
! Revision 1.2  2006/03/26 20:21:09  haselbac
! Fix mistake in declarations
!
! Revision 1.1  2004/12/01 16:48:04  haselbac
! Initial revision after changing case
!
! Revision 1.5  2003/11/20 16:40:35  mdbrandy
! Backing out RocfluidMP changes from 11-17-03
!
! Revision 1.2  2002/06/22 00:49:50  jblazek
! Modified interfaces to BC routines.
!
! Revision 1.1  2002/06/10 21:19:34  haselbac
! Initial revision
!
!******************************************************************************

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Vector addition followed by multiplication involving the same var should have a barrier in between.
!omp distribute directive does not have implicit barrier. This will cause data race.
!Data Race Pair: b[i]@36:23 and b[i]@42:13

module DRB160
    integer :: a, i, j, k, val
    integer :: b(8), c(8), temp(8)
end module

program DRB160_nobarrier_orig_gpu_yes
    use omp_lib
    use DRB160
    implicit none

    do i = 1, 8
        b(i) = 0
        c(i) = 2
        temp(i) = 0
    end do

    a = 2
    val = 0

    !$omp target map(tofrom:b) map(to:c,temp,a) device(0)
    !$omp teams
    do i = 1, 100
        !$omp distribute
        do j = 1, 8
            temp(j) = b(j)+c(j)
        end do
        !$omp end distribute

        !$omp distribute
        do j = 8, 1, k-1
            b(j) = temp(j)*a
        end do
        !$omp end distribute
    end do
    !$omp end teams
    !$omp end target

    do i = 1, 100
        val = val+2
        val = val*2
    end do

    do i = 1, 8
        if (val /= b(i)) then
            print*,b(i),val
        end if
    end do

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!!This example is referred from OpenMP Application Programming Interface 5.0, example tasking.7.c
!!A task switch may occur at a task scheduling point. A single thread may execute both of the
!!task regions that modify tp. The parts of these task regions in which tp is modified may be
!!executed in any order so the resulting value of var can be either 1 or 2.
!!There is a  Race pair var@24:13 and var@24:13 but no data race.

module DRB127
    integer :: tp, var
    !$omp threadprivate(tp)
contains
    subroutine foo
        !$omp task
            !$omp task
            tp = 1
                !$omp task
                !$omp end task
            var = tp                ! value of var can be 1 or 2
            !$omp end task
            tp = 2
        !$omp end task
    end subroutine
end module

program DRB127_tasking_threadprivate1_orig_no
    use omp_lib
    use DRB127
    implicit none

    call foo()

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This example is based on fpriv_sections.1.c OpenMP Examples 5.0.0
!The section construct modifies the value of section_count which breaks the independence of the
!section constructs. If the same thread executes both the section one will print 1 and the other
!will print 2. For a same thread execution, there is no data race.

program DRB126_firstprivatesections_orig_no
    use omp_lib
    implicit none

    integer :: section_count

    section_count = 0

    call omp_set_dynamic(.FALSE.)
    call omp_set_num_threads(1)

    !$omp parallel
    !$omp sections firstprivate( section_count )
        !$omp section
        section_count = section_count+1
        print 100, section_count
        100 format ('section_count =',3i8)

        !$omp section
        section_count = section_count+1
        print 101, section_count
        101 format ('section_count =',3i8)
    !$omp end sections
    !$omp end parallel
end program

#ifndef NOMPIIO

      subroutine gfldr(sourcefld)
c
c     generic field file reader
c     reads sourcefld and interpolates all avaiable fields
c     onto current mesh
c
c     memory requirement: 
c     nelgs*nxs**ldim < np*(4*lelt*lx1**ldim)
c
      include 'SIZE'
      include 'TOTAL'
      include 'RESTART'
      include 'GFLDR'

      character sourcefld*(*)

      common /scrcg/  pm1(lx1*ly1*lz1,lelv)
      common /nekmpi/ nidd,npp,nekcomm,nekgroup,nekreal

      character*1   hdr(iHeaderSize)

      integer*8 dtmp8

      logical if_byte_swap_test
      real*4 bytetest

      etime_t = dnekclock_sync()
      if(nio.eq.0) write(6,*) 'call gfldr ',trim(sourcefld) 

      ! open source field file
      ierr = 0
      if(nid.eq.0) then
        open (90,file=sourcefld,status='old',err=100)
        close(90)
        goto 101
 100    ierr = 1
 101  endif
      call err_chk(ierr,' Cannot open source fld file!$')
      call byte_open_mpi(sourcefld,fldh_gfldr,.true.,ierr)

      ! read and parse header
      call byte_read_mpi(hdr,iHeaderSize/4,0,fldh_gfldr,ierr)
      call byte_read_mpi(bytetest,1,0,fldh_gfldr,ierr)

      call mfi_parse_hdr(hdr,ierr)
      call err_chk(ierr,' Invalid header!$')
      ifbswp = if_byte_swap_test(bytetest,ierr)
      call err_chk(ierr,' Invalid endian tag!$')

      nelgs   = nelgr
      nxs     = nxr
      nys     = nyr
      nzs     = nzr
      if(nzs.gt.1) then 
        ldims = 3
      else
        ldims = 2
      endif
      if (ifgtim) time = timer

      ! distribute elements across all ranks
      nels = nelgs/np
      do i = 0,mod(nelgs,np)-1
         if(i.eq.nid) nels = nels + 1
      enddo
      nxyzs      = nxs*nys*nzs
      dtmp8      = nels
      ntots_b    = dtmp8*nxyzs*wdsizr
      rankoff_b  = igl_running_sum(nels) - dtmp8
      rankoff_b  = rankoff_b*nxyzs*wdsizr  
      dtmp8      = nelgs
      nSizeFld_b = dtmp8*nxyzs*wdsizr
      noff0_b    = iHeaderSize + iSize + iSize*dtmp8

      ! do some checks
      if(ldims.ne.ldim) 
     $ call exitti('ldim of source does not match target!$',0)
      if(ntots_b/wdsize .gt. ltots) then
        dtmp8 = nelgs
        lelt_req = dtmp8*nxs*nys*nzs / (np*ltots/lelt)
        lelt_req = lelt_req + 1
        if(nio.eq.0) write(6,*)
     $   'ABORT: buffer too small, increase lelt > ', lelt_req
        call exitt
      endif

      ifldpos = 0
      if(ifgetxr) then
        ! read source mesh coordinates
        call gfldr_getxyz(xm1s,ym1s,zm1s)
        ifldpos = ldim
      else
        call exitti('source does not contain a mesh!$',0)
      endif

      if(if_full_pres) then
        call exitti('no support for if_full_pres!$',0)
      endif

      ! initialize interpolation tool using source mesh
      nxf   = 2*nxs
      nyf   = 2*nys
      nzf   = 2*nzs
      nhash = nels*nxs*nys*nzs 
      nmax  = 128

      call fgslib_findpts_setup(inth_gfldr,nekcomm,np,ldim,
     &                          xm1s,ym1s,zm1s,nxs,nys,nzs,
     &                          nels,nxf,nyf,nzf,bb_t,
     &                          nhash,nhash,nmax,tol)

      ! read source fields and interpolate
      if(ifgetur) then
        if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'reading vel'
        ntot = nx1*ny1*nz1*nelv 
        call gfldr_getfld(vx,vy,vz,ntot,ldim,ifldpos+1)
        ifldpos = ifldpos + ldim
      endif
      if(ifgetpr) then
        if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'reading pr'
        ntot = nx1*ny1*nz1*nelv 
        call gfldr_getfld(pm1,dum,dum,ntot,1,ifldpos+1)
        ifldpos = ifldpos + 1
        if (ifaxis) call axis_interp_ic(pm1)
        call map_pm1_to_pr(pm1,1)
      endif
      if(ifgettr .and. ifheat) then
        if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'reading temp'
        ntot = nx1*ny1*nz1*nelfld(2) 
        call gfldr_getfld(t(1,1,1,1,1),dum,dum,ntot,1,ifldpos+1)
        ifldpos = ifldpos + 1
      endif
      do i = 1,ldimt-1
         if(ifgtpsr(i)) then
           if(nid.eq.0 .and. loglevel.gt.2) 
     $       write(6,*) 'reading scalar',i
           ntot = nx1*ny1*nz1*nelfld(i+2) 
           call gfldr_getfld(t(1,1,1,1,i+1),dum,dum,ntot,1,ifldpos+1) 
           ifldpos = ifldpos + 1
         endif
      enddo

      call byte_close_mpi(fldh_gfldr,ierr)
      etime_t = dnekclock_sync() - etime_t
      call fgslib_findpts_free(inth_gfldr)
      if(nio.eq.0) write(6,'(A,1(1g9.2),A)')
     &                   ' done :: gfldr  ', etime_t, ' sec'

      return
      end
c-----------------------------------------------------------------------
      subroutine gfldr_getxyz(xout,yout,zout)

      include 'SIZE'
      include 'GFLDR'
      include 'RESTART'

      real xout(*)
      real yout(*)
      real zout(*)

      integer*8 ioff_b

 
      ioff_b = noff0_b + ldim*rankoff_b
      call byte_set_view(ioff_b,fldh_gfldr)

      nread = ldim*ntots_b/4
      call byte_read_mpi(bufr,nread,-1,fldh_gfldr,ierr)
      if(ifbswp) then
        if(wdsizr.eq.4) call byte_reverse (bufr,nread,ierr)
        if(wdsizr.eq.8) call byte_reverse8(bufr,nread,ierr)
      endif

      call gfldr_buf2vi (xout,1,bufr,ldim,wdsizr,nels,nxyzs)
      call gfldr_buf2vi (yout,2,bufr,ldim,wdsizr,nels,nxyzs)
      if(ldim.eq.3)
     $ call gfldr_buf2vi(zout,3,bufr,ldim,wdsizr,nels,nxyzs)

      return
      end
c-----------------------------------------------------------------------
      subroutine gfldr_getfld(out1,out2,out3,nout,nldim,ifldpos)

      include 'SIZE'
      include 'GEOM'
      include 'GFLDR'
      include 'RESTART'

      real out1(*)
      real out2(*)
      real out3(*)

      integer*8 ioff_b

      logical ifpts

      integer icalld
      save    icalld
      data    icalld /0/


      ifpts = .false.
      if(icalld.eq.0) then
        ifpts = .true. ! find points
        icalld = 1
      endif

      ! read field data from source fld file
      ioff_b = noff0_b + (ifldpos-1)*nSizeFld_b
      ioff_b = ioff_b  + nldim*rankoff_b
      call byte_set_view(ioff_b,fldh_gfldr)
      nread = nldim*ntots_b/4
      call byte_read_mpi(bufr,nread,-1,fldh_gfldr,ierr)
      if(ifbswp) then
        if(wdsizr.eq.4) call byte_reverse (bufr,nread,ierr)
        if(wdsizr.eq.8) call byte_reverse8(bufr,nread,ierr)
      endif

      ! interpolate onto current mesh
      call gfldr_buf2vi  (buffld,1,bufr,nldim,wdsizr,nels,nxyzs)
      call gfldr_intp    (out1,nout,buffld,ifpts)
      if(nldim.eq.1) return

      call gfldr_buf2vi  (buffld,2,bufr,nldim,wdsizr,nels,nxyzs)
      call gfldr_intp    (out2,nout,buffld,.false.)
      if(nldim.eq.2) return

      if(nldim.eq.3) then
        call gfldr_buf2vi(buffld,3,bufr,nldim,wdsizr,nels,nxyzs)
        call gfldr_intp  (out3,nout,buffld,.false.)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine gfldr_buf2vi(vi,index,buf,ldim,wds,nel,nxyz)

      real    vi(*)
      real*4  buf(*)
      integer wds


      do iel = 1,nel
         j = (iel-1)*nxyz
         k = (iel-1)*ldim*nxyz

         if(index.eq.2) k = k+nxyz
         if(index.eq.3) k = k+2*nxyz

         if(wds.eq.4) call copy4r(vi(j+1),buf(k+1)  ,nxyz)
         if(wds.eq.8) call copy  (vi(j+1),buf(2*k+1),nxyz)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine gfldr_intp(fieldout,nout,fieldin,iffpts)

      include 'SIZE'
      include 'RESTART'
      include 'GEOM'
      include 'GFLDR'

      real    fieldout(nout)
      real    fieldin (*)
      logical iffpts

      integer*8 i8glsum,nfail,nfail_sum

      if(iffpts) then ! locate points (iel,iproc,r,s,t)
        nfail = 0
        toldist = 5e-6
        if(wdsizr.eq.8) toldist = 5e-14

        ntot  = lx1*ly1*lz1*nelt
        call fgslib_findpts(inth_gfldr,
     &                      grcode,1,
     &                      gproc,1,
     &                      gelid,1,
     &                      grst,ldim,
     &                      gdist,1,
     &                      xm1,1,
     &                      ym1,1,
     &                      zm1,1,ntot)

        do i=1,ntot
           if(grcode(i).eq.1 .and. sqrt(gdist(i)).gt.toldist)
     &       nfail = nfail + 1
           if(grcode(i).eq.2) nfail = nfail + 1
        enddo

        nfail_sum = i8glsum(nfail,1)
        if(nfail_sum.gt.0) then
          if(nio.eq.0) write(6,*)
     &      ' WARNING: Unable to find all mesh points in source fld ',
     &      nfail_sum
        endif
      endif

      ! evaluate inut field at given points
      npt = nout
      call fgslib_findpts_eval(inth_gfldr,
     &                         fieldout,1,
     &                         grcode,1,
     &                         gproc,1,
     &                         gelid,1,
     &                         grst,ldim,npt,
     &                         fieldin)

      return
      end

#endif

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Example use of firstprivate(). No data race pairs.

module DRB048
    use omp_lib
    implicit none

    integer, dimension(:), allocatable :: a
contains
    subroutine foo(a,n,g)
        use omp_lib
        implicit none
        integer :: i
        integer, value :: n, g
        integer, dimension(:), allocatable :: a

        !$omp parallel do firstprivate(g)
        do i = 1, n
            a(i)=a(i)+g
        end do
        !$omp end parallel do
    end subroutine
end module

program DRB048_firstprivate_orig_no
    use omp_lib
    use DRB048
    implicit none

    allocate (a(100))
    call foo(a, 100, 7)
    print*,a(50)
end program

C PRIMITIVES FOR DEBUGGING THE TANGENT AND ADJOINT CODES GENERATED BY TAPENADE.
C These primitives are called by the code produced by Tapenade when using
C the differentiation command-line options -debugTGT and -debugADJ.

C GLOBAL VARIABLES DEFINED IN debugAD.inc:
C-----------------------------------------
C dbad_mode is 1 when running divided-differences test to validate the tangent mode
C             -1 when running dot-product test to validate the adjoint mode.
C dbad_phase is 1 for the 1st executable that is called for the test
C               2 for the 2nd executable that is called for the test
C           Both tests are run by calling $> exe1 | exe2
C dbad_file is the file that is used to make exe1 communicate towards exe2
C           by default it is std_out (6) in phase 1, and std_in (5) in phase 2.
C           It's not actually parametrable, but one may change this
C           if std_in or std_out are unavailable.
C dbad_ddeps is the epsilon used by divided-differences test ONLY.
C           The test 1st order, not centered.
C           dbad_ddeps is not used in the dot-product test.
C           dbad_ddeps is set by DEBUG_TGT_INIT[1,2], as its 1st argument.
C dbad_epszero is the absolute value under which a derivative is
C           considered to be in fact zero. It is used in both tests
C           to eliminate differences between a zero deriv and an undefined deriv.
C           dbad_epszero is set by DEBUG_TGT_INIT[1,2], as its 2nd argument,
C           and by DEBUG_[F,B]WD_INIT, as its 1st argument.
C dbad_errormax is the percentage of difference above which a "difference"
C           message is issued. In divided-differences test, this is about
C           the comparison of tgt diff wrt divided-differences.
C           In dot-product mode, this is about the comparison between
C           the (sum of the) bwd Jacobian wrt the (sum of the) tgt Jacobian.
C           dbad_errormax is set by DEBUG_TGT_INIT[1,2], as its 3rd argument,
C           and by DEBUG_[F,B]WD_INIT, as its 2nd argument.
C dbad_seed is the increment used to "randomize" the X_d and Y_b used in the
C           dot-product test. X_d and Y_d are filled with values in [1.d0 , 2.d0[,
C           starting with 1.d0 and incremented by steps of dbad_seed.
C           dbad_seed is set by DEBUG_[F,B]WD_INIT, as its 3rd argument.
C dbad_callsz is the max depth of nested calls during execution.
C           It is set by default to 99 in debugAD.inc.
C           It may be changed in debugAD.inc, if needed.
C dbad_callnames is the stack of the procedure names in the current call stack.
C           These names are stored without the _D or _B extension.
C dbad_callcodes is a stack of codes of the current call stack.
C           It is currently not used and may disappear sone day.
C dbad_calltraced is a stack of booleans on the current call stack.
C           "true" means that the current call is being traced.
C           A "false" means not traced, and implies a "false" in all
C           deeper calls. In divided-differences test ONLY, this can be
C           overriden by passing "true" as the 3rd argument of
C           DEBUG_TGT_CALL or DEBUG_TGT_HERE.

      BLOCK DATA DEBUG_AD
      IMPLICIT NONE
      INCLUDE 'debugAD.inc'
      DATA dbad_callindex/0/
      DATA dbad_sum/0.d0/
      DATA dbad_coeff/1.d0/
      DATA dbad_seed/0.137d0/
      END

C DEBUG PRIMITIVES FOR THE TANGENT MODE (DIVIDED-DIFFERENCES METHOD)

      SUBROUTINE DEBUG_TGT_INIT1(epsilon, ezero, errmax)
      IMPLICIT NONE
      REAL*8 epsilon, ezero, errmax
      INCLUDE 'debugAD.inc'
      dbad_mode = 1
      dbad_phase = 1
      dbad_file = 6
      dbad_ddeps = epsilon
      dbad_epszero = ezero
      dbad_errormax = errmax
      end

      SUBROUTINE DEBUG_TGT_INIT2(epsilon, ezero, errmax)
      IMPLICIT NONE
      REAL*8 epsilon, ezero, errmax
      INCLUDE 'debugAD.inc'
      dbad_mode = 1
      dbad_phase = 2
      dbad_file = 5
      dbad_ddeps = epsilon
      dbad_epszero = ezero
      dbad_errormax = errmax
      write (*,'("Starting TGT test, epsilon=",e8.1,
     +     ", zero=",e8.1,", errmax=",f4.1,"%")'),
     +     epsilon,ezero,errmax
      write (*,
     +'("===========================================================")')
      end

      SUBROUTINE DEBUG_TGT_INITREAL4(indep, indepd)
      IMPLICIT NONE
      REAL*4 indep, indepd
      INCLUDE 'debugAD.inc'
      if (dbad_phase.eq.1) then
         indep = indep+dbad_ddeps*indepd
      endif
      end

      SUBROUTINE DEBUG_TGT_INITREAL4ARRAY(indep, indepd, length)
      IMPLICIT NONE
      INTEGER length
      REAL*4 indep(length), indepd(length)
      INCLUDE 'debugAD.inc'
      INTEGER i
      if (dbad_phase.eq.1) then
         do i=1,length
            indep(i) = indep(i)+dbad_ddeps*indepd(i)
         enddo
      endif
      end

      SUBROUTINE DEBUG_TGT_INITREAL8(indep, indepd)
      IMPLICIT NONE
      REAL*8 indep, indepd
      INCLUDE 'debugAD.inc'
      if (dbad_phase.eq.1) then
         indep = indep+dbad_ddeps*indepd
      endif
      end

      SUBROUTINE DEBUG_TGT_INITREAL8ARRAY(indep, indepd, length)
      IMPLICIT NONE
      INTEGER length
      REAL*8 indep(length), indepd(length)
      INCLUDE 'debugAD.inc'
      INTEGER i
      if (dbad_phase.eq.1) then
         do i=1,length
            indep(i) = indep(i)+dbad_ddeps*indepd(i)
         enddo
      endif
      end

      SUBROUTINE DEBUG_TGT_CONCLUDEREAL4(varname, var, vard)
      IMPLICIT NONE
      character varname*(*)
      real*4 var, vard
      INCLUDE 'debugAD.inc'
      REAL*4 ddvar, dd, diff, varwr
      LOGICAL areNaNs
      if (dbad_phase.eq.1) then
         write (dbad_file, '(a)') 'final_result'
         write (dbad_file, *) var
      else
         call DDCHECKVARNAME('final_result')
         call DDPICKTWO4(var, varwr, dbad_file, ddvar, areNaNs)
         if (.not.areNaNs) then
            dd = (ddvar-varwr)/dbad_ddeps
            diff = (abs(vard-dd)*100.0)/ max(abs(vard),abs(dd))
            write (*,'("Final result",a20,": ",e20.8," (ad)",
     +           f9.5,"% DIFF WITH (dd) ",e20.8)')
     +           varname,vard,diff,dd
         else
            write (*, '(a)') 'Final result has NaNs'
         endif
      endif
      write (*,
     +'("===========================================================")')
      END

      SUBROUTINE DEBUG_TGT_CONCLUDEREAL4ARRAY
     +                           (varname, tvar, tvard, length)
      IMPLICIT NONE
      integer length
      real*4 tvar(length)
      real*4 tvard(length)
      character varname*(*)
      REAL*4 var, vard
      INTEGER i
      var = 0.0
      vard = 0.0
      DO i=1,length
         var = var + tvar(i)
         vard = vard + tvard(i)
      ENDDO
      call DEBUG_TGT_CONCLUDEREAL4(varname, var, vard)
      END

      SUBROUTINE DEBUG_TGT_CONCLUDEREAL8(varname, var, vard)
      IMPLICIT NONE
      character varname*(*)
      real*8 var, vard
      INCLUDE 'debugAD.inc'
      REAL*8 ddvar, dd, diff, varwr
      LOGICAL areNaNs
      if (dbad_phase.eq.1) then
         write (dbad_file, '(a)') 'final_result'
         write (dbad_file, *) var
      else
         call DDCHECKVARNAME('final_result')
         call DDPICKTWO8(var, varwr, dbad_file, ddvar, areNaNs)
         if (.not.areNaNs) then
            dd = (ddvar-varwr)/dbad_ddeps
            diff = (abs(vard-dd)*100.0)/ max(abs(vard),abs(dd))
            write (*,'("Final result",a20,": ",e24.16," (ad)",
     +           f9.5,"% DIFF WITH (dd) ",e24.16)')
     +           varname,vard,diff,dd
         else
            write (*, '(a)') 'Final result has NaNs'
         endif
      endif
      write (*,
     +'("===========================================================")')
      END

      SUBROUTINE DEBUG_TGT_CONCLUDEREAL8ARRAY
     +                           (varname, tvar, tvard, length)
      IMPLICIT NONE
      integer length
      real*8 tvar(length)
      real*8 tvard(length)
      character varname*(*)
      REAL*8 var, vard
      INTEGER i
      var = 0.d0
      vard = 0.d0
      DO i=1,length
         var = var + tvar(i)
         vard = vard + tvard(i)
      ENDDO
      call DEBUG_TGT_CONCLUDEREAL8(varname, var, vard)
      END

      SUBROUTINE DEBUG_TGT_CALL(unitname, traced, forcetraced)
      IMPLICIT NONE
      CHARACTER unitname*(*)
      LOGICAL traced, forcetraced
      INCLUDE 'debugAD.inc'
      dbad_callindex = dbad_callindex+1
      write (dbad_callnames(dbad_callindex),'(a40)') unitname
      dbad_calltraced(dbad_callindex) =
     +     ((dbad_callindex.eq.1.OR.
     +       dbad_calltraced(dbad_callindex-1))
     +     .AND.traced) .OR. forcetraced
      END

      SUBROUTINE DEBUG_TGT_EXIT()
      IMPLICIT NONE
      INCLUDE 'debugAD.inc'
      dbad_callindex = dbad_callindex-1
      END

      LOGICAL FUNCTION DEBUG_TGT_HERE(placename, forcetraced)
      IMPLICIT NONE
      CHARACTER placename*(*)
      LOGICAL forcetraced
      INCLUDE 'debugAD.inc'
      DEBUG_TGT_HERE =
     +     (dbad_callindex.eq.0.OR.dbad_calltraced(dbad_callindex))
     +     .OR.forcetraced
      RETURN
      END

      SUBROUTINE DEBUG_TGT_REAL4(varname, var, vard)
      IMPLICIT NONE
      character varname*(*)
      REAL*4 var, vard
      INCLUDE 'debugAD.inc'
      REAL*4 ddvar, dd, diff, varwr
      LOGICAL areNaNs
      character*12 diffstr
      character*50 ddvarname
      if (dbad_phase.eq.1) then
         WRITE(dbad_file, '(a)') varname
         WRITE(dbad_file, *) var
      else if (dbad_phase.eq.2) then
         call DDCHECKVARNAME(varname)
         call DDPICKTWO4(var, varwr, dbad_file, ddvar, areNaNs)
         if (.not.areNaNs) then
            dd = (ddvar-varwr)/dbad_ddeps
            if ((abs(vard).gt.dbad_epszero)
     +           .or.(abs(dd).gt.dbad_epszero)) then
               diff = (abs(vard-dd)*100.0)/max(abs(vard),abs(dd))
               if (diff.gt.dbad_errormax) then
                  diffstr = 'DIFFERENCE!!'
               else
                  diffstr = '            '
               endif
               write (*,'("   ", a,":",e11.4,
     +              " (dd:",e11.4,")   ",a14)')
     +              varname, vard, dd, diffstr
            endif
         endif
      endif
      END

      SUBROUTINE DEBUG_TGT_REAL4ARRAY (varname, var, vard, length)
      IMPLICIT NONE
      integer length
      real*4 var(length)
      real*4 vard(length)
      character varname*(*)
      INCLUDE 'debugAD.inc'
      real*4 ddvar, dd, diff, varwr
      real*4 valbuf(10),ddbuf(10)
      character*50 ddvarname
      integer indexbuf1(10)
      character*14 diffbuf(10)
      integer i1,j
      integer ibuf
      logical notprintedheader
      LOGICAL areNaNs
      if (dbad_phase.eq.1) then
         WRITE(dbad_file, '(a)') varname
         do i1=1,length
            WRITE(dbad_file, *) var(i1)
         enddo
      else if (dbad_phase.eq.2) then
         call DDCHECKVARNAME(varname)
         notprintedheader=.true.
         ibuf = 1
         do i1=1,length
            call DDPICKTWO4(var(i1),varwr,dbad_file,ddvar,areNaNs)
            if (.not.areNaNs) then
               dd = (ddvar-varwr)/dbad_ddeps
               if ((abs(vard(i1)).gt.dbad_epszero)
     +              .or.(abs(dd).gt.dbad_epszero)) then
                  valbuf(ibuf) = vard(i1)
                  ddbuf(ibuf) = dd
                  indexbuf1(ibuf) = i1
                  diff = (abs(vard(i1)-dd)*100.0)
     +                    /max(abs(vard(i1)),abs(dd))
                  if (diff.gt.dbad_errormax) then
                     diffbuf(ibuf) = '  DIFFERENCE!!'
                     ibuf = ibuf+1
                  else
!                     diffbuf(ibuf) = '              '
!                     ibuf = ibuf+1
                  endif
               endif
            endif
            if(ibuf.gt.10.or.(i1.eq.length.and.ibuf.gt.1)) then
               if (notprintedheader) then
                  write(*,'("   ", a, ":")') varname
                  notprintedheader=.false.
               endif
               write (*, '("          ", 10(i4,"->",e11.4))')
     +              (indexbuf1(j),valbuf(j), j=1,ibuf-1)
               write (*, '("      (dd:)", 10("    (",e11.4,")"))')
     +              (ddbuf(j), j=1,ibuf-1)
               write (*, '("          ", 10(a16))')
     +              (diffbuf(j), j=1,ibuf-1)
               ibuf = 1
            endif
         end do
      endif
      END

      SUBROUTINE DDPICKTWO4(var, varwr, dbad_file, ddvar, areNaNs)
      IMPLICIT NONE
      REAL*4 var,varwr,ddvar
      LOGICAL areNaNs
      INTEGER dbad_file,stat1,stat2
      OPEN(38, FILE='ddwrfile')
      WRITE(38, *) var
      REWIND(38)
      READ(38, *,IOSTAT=stat1) varwr
      CLOSE(38)
      READ(dbad_file, *,IOSTAT=stat2) ddvar
      areNaNs = stat1.eq.225.and.stat2.eq.225
      END

      SUBROUTINE DEBUG_TGT_REAL8(varname, var, vard)
      IMPLICIT NONE
      CHARACTER varname*(*)
      REAL*8 var, vard
      INCLUDE 'debugAD.inc'
      REAL*8 ddvar, dd, diff, varwr
      character*12 diffstr
      character*50 ddvarname
      LOGICAL areNaNs
      if (dbad_phase.eq.1) then
         WRITE(dbad_file, '(a)') varname
         WRITE(dbad_file, *) var
      else if (dbad_phase.eq.2) then
         call DDCHECKVARNAME(varname)
         call DDPICKTWO8(var, varwr, dbad_file, ddvar, areNaNs)
         if (.not.areNaNs) then
            dd = (ddvar-varwr)/dbad_ddeps
            if ((abs(vard).gt.dbad_epszero)
     +           .or.(abs(dd).gt.dbad_epszero)) then
               diff = (abs(vard-dd)*100.0)/ max(abs(vard),abs(dd))
               if (diff.gt.dbad_errormax) then
                  diffstr = 'DIFFERENCE!!'
                  write (*,'(a20,":  ",e24.16," (ad)",
     +                 f5.1,"% DIFF WITH (dd) ",e24.16)')
     +                 varname, vard, diff, dd
               else
                  diffstr = '            '
               endif
!               write (*,*) ddvar,varwr,dd,'=?=',vard,' %',diff,varname
!               write (*,*) varname, vard, 'dd:', dd, diffstr
            endif
         endif
      endif
      END

      SUBROUTINE DEBUG_TGT_REAL8v(varname, var, vard)
      IMPLICIT NONE
      CHARACTER varname*(*)
      REAL*8 var, vard
      INCLUDE 'debugAD.inc'
      REAL*8 ddvar, dd, diff, varwr
      character*12 diffstr
      character*50 ddvarname
      LOGICAL areNaNs
      if (dbad_phase.eq.1) then
         WRITE(dbad_file, '(a)') varname
         WRITE(dbad_file, *) var
      else if (dbad_phase.eq.2) then
         call DDCHECKVARNAME(varname)
         call DDPICKTWO8(var, varwr, dbad_file, ddvar, areNaNs)
         if (.not.areNaNs) then
            dd = (ddvar-varwr)/dbad_ddeps
            if ((abs(vard).gt.dbad_epszero)
     +           .or.(abs(dd).gt.dbad_epszero)) then
               diff = (abs(vard-dd)*100.0)/ max(abs(vard),abs(dd))
               if (diff.gt.dbad_errormax) then
                  diffstr = 'DIFFERENCE!!'
                  write (*,'(a20,":  ",e24.16," (ad)",
     +                 f5.1,"% DIFF WITH (dd) ",e24.16)')
     +                 varname, vard, diff, dd
               else
                  diffstr = '            '
               endif
               write (*,*) varname,ddvar,varwr,dd,'=?=',vard,' %',diff
            else
               write (*,*) varname,ddvar,varwr,dd,'=?zero?=',vard
            endif
         endif
      endif
      END

      SUBROUTINE DEBUG_TGT_REAL8ARRAY(varname, var, vard, length)
      IMPLICIT NONE
      integer length
      real*8 var(length)
      real*8 vard(length)
      character varname*(*)
      INCLUDE 'debugAD.inc'
      LOGICAL areNaNs
      real*8 ddvar, dd, diff, varwr
      real*8 valbuf(10),ddbuf(10)
      character*50 ddvarname
      integer indexbuf1(10)
      character*14 diffbuf(10)
      integer i1,j
      integer ibuf
      logical notprintedheader
      if (dbad_phase.eq.1) then
         WRITE(dbad_file, '(a)') varname
         do i1=1,length
            WRITE(dbad_file, *) var(i1)
         enddo
      else if (dbad_phase.eq.2) then
         call DDCHECKVARNAME(varname)
         notprintedheader=.true.
         ibuf = 1
         do i1=1,length
            call DDPICKTWO8(var(i1),varwr,dbad_file,ddvar,areNaNs)
            if (.not.areNaNs) then
               dd = (ddvar-varwr)/dbad_ddeps
               if ((abs(vard(i1)).gt.dbad_epszero)
     +              .or.(abs(dd).gt.dbad_epszero)) then
                  valbuf(ibuf) = vard(i1)
                  ddbuf(ibuf) = dd
                  indexbuf1(ibuf) = i1
                  diff = (abs(vard(i1)-dd)*100.0)
     +                 /max(abs(vard(i1)),abs(dd))
                  if (diff.gt.dbad_errormax) then
                     diffbuf(ibuf) = '  DIFFERENCE!!'
                     ibuf = ibuf+1
                  else
!                     diffbuf(ibuf) = '              '
!                     ibuf = ibuf+1
                  endif
               endif
            endif
            if(ibuf.gt.10.or.(i1.eq.length.and.ibuf.gt.1)) then
               if (notprintedheader) then
                  write(*,'("   ", a, ":")') varname
                  notprintedheader=.false.
               endif
               write (*, '("          ", 10(i4,"->",e11.4))')
     +              (indexbuf1(j),valbuf(j), j=1,ibuf-1)
               write (*, '("      (dd:)", 10("    (",e11.4,")"))')
     +              (ddbuf(j), j=1,ibuf-1)
               write (*, '("          ", 10(a16))')
     +              (diffbuf(j), j=1,ibuf-1)
               ibuf = 1
            endif
         end do
      endif
      END

      SUBROUTINE DDPICKTWO8(var, varwr, dbad_file, ddvar, areNaNs)
      IMPLICIT NONE
      REAL*8 var,varwr,ddvar
      LOGICAL areNaNs
      INTEGER dbad_file,stat1,stat2
      OPEN(38, FILE='ddwrfile')
      WRITE(38, *) var
      REWIND(38)
      READ(38, *,IOSTAT=stat1) varwr
      CLOSE(38)
      READ(dbad_file, *,IOSTAT=stat2) ddvar
      areNaNs = stat1.eq.225.and.stat2.eq.225
      END

      SUBROUTINE DDCHECKVARNAME(varname)
      IMPLICIT NONE
      character varname*(*)
      INCLUDE 'debugAD.inc'
      character*50 ddvarname
      integer linesskip
      linesskip = 0
 100  CONTINUE
      if (linesskip.GT.990000) THEN
         write(*,*)
     +    'ERROR: Too many lines skipped. Bad DD program control ?'
         write(*,*) 'Was looking for variable:',varname
         STOP
      ENDIF
      READ(dbad_file, '(a)') ddvarname
      if (ddvarname.ne.varname) then
!         write(*,*) 'ERROR: mismatch in DD program control !!!',
!     +        ' read ', ddvarname, ' expecting ', varname
         linesskip = linesskip+1
         GOTO 100
      endif
      END

      SUBROUTINE DEBUG_TGT_DISPLAY(placename)
      IMPLICIT NONE
      CHARACTER placename*(*)
      INCLUDE 'debugAD.inc'
      if (dbad_phase.eq.2) then
         CALL DEBUG_DISPLAY_LOCATION(placename)
      endif
      END

C DEBUG PRIMITIVES FOR THE ADJOINT MODE, BACKWARD SWEEP (DOT-PRODUCT METHOD)

      SUBROUTINE DEBUG_BWD_INIT(ezero, errmax, seed)
      IMPLICIT NONE
      REAL*8 ezero, errmax, seed
      INCLUDE 'debugAD.inc'
      dbad_mode = -1
      dbad_phase = 1
      dbad_file = 6
      dbad_epszero = ezero
      dbad_errormax = errmax
      dbad_seed = seed
      write(dbad_file,'(i3,a40)') 3, 'StartOfPhase1'
      END

      SUBROUTINE DEBUG_BWD_CONCLUDE()
      IMPLICIT NONE
      INCLUDE 'debugAD.inc'
      REAL*8 sumd
      INTEGER*4 smallsize, nbblocks, SMALLSTACKSIZE
      INTEGER*4 nbreals, i
      write(dbad_file,'(i3,a40)') -3, 'EndOfPhase1'
      END

      SUBROUTINE DEBUG_BWD_CALL(unitname, traced)
      IMPLICIT NONE
      CHARACTER unitname*(*)
      LOGICAL traced
      INCLUDE 'debugAD.inc'
      dbad_callindex = dbad_callindex+1
      write (dbad_callnames(dbad_callindex),'(a40)') unitname
      dbad_calltraced(dbad_callindex) =
     +     (dbad_callindex.eq.1.OR.
     +       dbad_calltraced(dbad_callindex-1))
     +     .AND.traced
      end

      SUBROUTINE DEBUG_BWD_EXIT()
      IMPLICIT NONE
      INCLUDE 'debugAD.inc'
      IF (dbad_callindex.eq.1 .OR.
     +     dbad_calltraced(dbad_callindex-1)) THEN
         IF (dbad_calltraced(dbad_callindex)) THEN
            write(dbad_file,'(i3,a40)')
     +           2, dbad_callnames(dbad_callindex)
         ELSE
            write(dbad_file,'(i3,a40)')
     +           -2, dbad_callnames(dbad_callindex)
         ENDIF
      ENDIF
      dbad_callindex = dbad_callindex-1
      END

      LOGICAL FUNCTION DEBUG_BWD_HERE(placename)
      IMPLICIT NONE
      CHARACTER placename*(*)
      INCLUDE 'debugAD.inc'
      DEBUG_BWD_HERE =
     +     (dbad_callindex.eq.0.OR.dbad_calltraced(dbad_callindex))
      RETURN
      END

C DEBUG PRIMITIVES FOR THE ADJOINT MODE, FORWARD SWEEP (DOT-PRODUCT METHOD)

      SUBROUTINE DEBUG_FWD_INIT(ezero, errmax, seed)
      IMPLICIT NONE
      REAL*8 ezero, errmax, seed
      INCLUDE 'debugAD.inc'
      INTEGER label
      CHARACTER*40 startstring
      CHARACTER*40 placestring
      REAL*8 bigsum
      dbad_mode = -1
      dbad_phase = 2
      dbad_file = 5
      dbad_epszero = ezero
      dbad_errormax = errmax
      dbad_seed = seed
      dbad_nberrors = 0
      write (*,'("Starting ADJ test, zero=",e8.1,
     +     ", errmax=",f4.1,"%, seed=",f5.3)'),
     +     ezero,errmax,seed
      write (*,
     +'("===========================================================")')
C labels:  3 -> StartOfPhase1
C         -1 -> a debug point, skipped
C          0 -> a debug point, traced but no associated value.
C          1 -> a debug point, traced, with an associated value.
C         -2 -> a call, skipped
C          2 -> a call, traced
C         -3 -> EndOfPhase1
 100  READ(dbad_file,'(i3,a40)',ERR=200,END=500) label,startstring
      if (label.eq.3.AND.
     +     startstring.EQ.'                           StartOfPhase1')
     +     GOTO 300
 200  GOTO 100
 300  CALL PUSHINTEGER4(3)
 400  READ(dbad_file,'(i3,a40)',ERR=500,END=500) label,placestring
      IF (label.eq.-3) GOTO 500
      IF (label.eq.1) THEN
         READ(dbad_file,*) bigsum
         CALL PUSHREAL8(bigsum)
      ENDIF
      CALL PUSHCHARACTERARRAY(placestring, 40)
      CALL PUSHINTEGER4(label)
      GOTO 400
 500  CONTINUE
C FOR DEBUG OF DEBUG ONLY:
c      CALL LOOKINTEGER4(label)
c      IF (label.eq.3) GOTO 600
c      call LOOKCHARACTERARRAY(placestring, 40)
c      if (label.eq.-2) then
c         write (*,*) 'untraced  call ',placestring
c      else if (label.eq.2) then
c         write (*,*) 'TRACED    call ',placestring
c      else if (label.eq.-1) then
c         write (*,*) 'untraced place ',placestring
c      else if (label.eq.1) then
c         write (*,*) 'TRACED   place ',placestring
c      else if (label.eq.0) then
c         call LOOKREAL8(bigsum)
c         write (*,*) 'TRACED   place ',placestring, bigsum
c      endif
c      GOTO 500
C end FOR DEBUG OF DEBUG ONLY.
 600  CONTINUE
      END

      SUBROUTINE DEBUG_FWD_CONCLUDE()
      IMPLICIT NONE
      INCLUDE 'debugAD.inc'
      write (*,'("End of ADJ test.",i2,
     +     " error(s) found. WARNING: testing alters derivatives!")')
     +     dbad_nberrors
      write (*,
     +'("===========================================================")')
      END

      SUBROUTINE DEBUG_FWD_CALL(unitname)
      IMPLICIT NONE
      CHARACTER unitname*(*)
      INCLUDE 'debugAD.inc'
      INTEGER label
      CHARACTER*40 refcallstring, herecallstring
      label = 999
      IF (dbad_callindex.eq.0.OR.dbad_calltraced(dbad_callindex)) THEN
         call POPINTEGER4(label)
         IF (label.ne.2 .AND. label.ne.-2) THEN
            write(*,*) 'Control mismatch: FWD call ',
     +           unitname,'; BWD ',label
            STOP
         ENDIF
         call POPCHARACTERARRAY(refcallstring, 40)
         write (herecallstring,'(a40)') unitname
         IF (refcallstring.NE.herecallstring) THEN
            write(*,*) 'Control mismatch: FWD call ',
     +           herecallstring,'; BWD call ',refcallstring
            STOP
         ENDIF
      ENDIF
      dbad_callindex = dbad_callindex+1
      write (dbad_callnames(dbad_callindex),'(a40)') unitname
      dbad_calltraced(dbad_callindex) = (label.eq.2)
      END

      SUBROUTINE DEBUG_FWD_EXIT()
      IMPLICIT NONE
      INCLUDE 'debugAD.inc'
      dbad_callindex = dbad_callindex-1
      END

      LOGICAL FUNCTION DEBUG_FWD_HERE(placename)
      IMPLICIT NONE
      CHARACTER placename*(*)
      INCLUDE 'debugAD.inc'
      INTEGER label
      CHARACTER*40 refplacestring, hereplacestring
      label = 999
      IF (dbad_callindex.eq.0.OR.dbad_calltraced(dbad_callindex)) THEN
         call POPINTEGER4(label)
         IF (label.ne.1 .AND. label.ne.0 .AND. label.ne.-1) THEN
            write(*,*) 'Control mismatch: FWD place ',
     +           placename,'; BWD ',label
            STOP
         ENDIF
         call POPCHARACTERARRAY(refplacestring, 40)
         write (hereplacestring,'(a40)') placename
         IF (refplacestring.NE.hereplacestring) THEN
            write(*,*) 'Control mismatch: FWD place ',
     +           hereplacestring,'; BWD place ',refplacestring
            STOP
         ENDIF
         DEBUG_FWD_HERE = (label.NE.-1)
         IF (label.eq.1) THEN
            call POPREAL8(dbad_nextrefsum)
         ENDIF
      ELSE
         DEBUG_FWD_HERE = .FALSE.
      ENDIF
      RETURN
      END

C DEBUG PRIMITIVES FOR THE ADJOINT MODE, BOTH SWEEPS (DOT-PRODUCT METHOD)

      SUBROUTINE DEBUG_ADJ_SKIP(placename)
      IMPLICIT NONE
      CHARACTER placename*(*)
      INCLUDE 'debugAD.inc'
      IF (dbad_phase.eq.1) THEN
         IF (dbad_callindex.eq.0 .OR.
     +        dbad_calltraced(dbad_callindex)) THEN
            write(dbad_file,'(i3,a40)') -1, placename
         ENDIF
      ENDIF
      END

      SUBROUTINE DEBUG_ADJ_rwREAL4(vard)
      IMPLICIT NONE
      REAL*4 vard
      INCLUDE 'debugAD.inc'
      CALL DEBUG_ADJ_INCRCOEFF()
      dbad_sum = dbad_sum + dbad_coeff*vard
      vard = dbad_coeff
      END

      SUBROUTINE DEBUG_ADJ_rREAL4(vard)
      IMPLICIT NONE
      REAL*4 vard
      INCLUDE 'debugAD.inc'
      CALL DEBUG_ADJ_INCRCOEFF()
      dbad_sum = dbad_sum + dbad_coeff*vard
      END

      SUBROUTINE DEBUG_ADJ_wREAL4(vard)
      IMPLICIT NONE
      REAL*4 vard
      INCLUDE 'debugAD.inc'
      CALL DEBUG_ADJ_INCRCOEFF()
      vard = dbad_coeff
      END

      SUBROUTINE DEBUG_ADJ_rwREAL4ARRAY(vard, length)
      IMPLICIT NONE
      INTEGER length
      REAL*4 vard(length)
      INTEGER i
      DO i=1,length
         CALL DEBUG_ADJ_rwREAL4(vard(i))
      ENDDO
      END

      SUBROUTINE DEBUG_ADJ_rREAL4ARRAY(vard, length)
      IMPLICIT NONE
      INTEGER length
      REAL*4 vard(length)
      INTEGER i
      DO i=1,length
         CALL DEBUG_ADJ_rREAL4(vard(i))
      ENDDO
      END

      SUBROUTINE DEBUG_ADJ_wREAL4ARRAY(vard, length)
      IMPLICIT NONE
      INTEGER length
      REAL*4 vard(length)
      INTEGER i
      DO i=1,length
         CALL DEBUG_ADJ_wREAL4(vard(i))
      ENDDO
      END

      SUBROUTINE DEBUG_ADJ_rwREAL8(vard)
      IMPLICIT NONE
      REAL*8 vard
      INCLUDE 'debugAD.inc'
      CALL DEBUG_ADJ_INCRCOEFF()
      dbad_sum = dbad_sum + dbad_coeff*vard
      vard = dbad_coeff
      END

      SUBROUTINE DEBUG_ADJ_rREAL8(vard)
      IMPLICIT NONE
      REAL*8 vard
      INCLUDE 'debugAD.inc'
      CALL DEBUG_ADJ_INCRCOEFF()
      dbad_sum = dbad_sum + dbad_coeff*vard
      END

      SUBROUTINE DEBUG_ADJ_PRINT()
      IMPLICIT NONE
      REAL*8 vard
      INCLUDE 'debugAD.inc'
      print *, 'dbad sum:',dbad_sum
      END

      SUBROUTINE DEBUG_ADJ_wREAL8(vard)
      IMPLICIT NONE
      REAL*8 vard
      INCLUDE 'debugAD.inc'
      CALL DEBUG_ADJ_INCRCOEFF()
      vard = dbad_coeff
      END

      SUBROUTINE DEBUG_ADJ_rwREAL8ARRAY(vard, length)
      IMPLICIT NONE
      INTEGER length
      REAL*8 vard(length)
      INTEGER i
      DO i=1,length
         CALL DEBUG_ADJ_rwREAL8(vard(i))
      ENDDO
      END

      SUBROUTINE DEBUG_ADJ_rREAL8ARRAY(vard, length)
      IMPLICIT NONE
      INTEGER length
      REAL*8 vard(length)
      INTEGER i
      DO i=1,length
         CALL DEBUG_ADJ_rREAL8(vard(i))
      ENDDO
      END

      SUBROUTINE DEBUG_ADJ_wREAL8ARRAY(vard, length)
      IMPLICIT NONE
      INTEGER length
      REAL*8 vard(length)
      INTEGER i
      DO i=1,length
         CALL DEBUG_ADJ_wREAL8(vard(i))
      ENDDO
      END

      SUBROUTINE DEBUG_ADJ_rwDISPLAY(placename, deltaindent)
      IMPLICIT NONE
      CHARACTER placename*(*)
      INTEGER deltaindent
      INCLUDE 'debugAD.inc'
      CALL DEBUG_ADJ_rDISPLAY(placename, deltaindent)
      IF (dbad_phase.eq.2) THEN
         dbad_refsum = dbad_nextrefsum
      ENDIF
      END

      SUBROUTINE DEBUG_ADJ_INCRCOEFF()
      IMPLICIT NONE
      INCLUDE 'debugAD.inc'
      dbad_coeff = dbad_coeff + dbad_seed
      IF (dbad_coeff.ge.2.d0) dbad_coeff = dbad_coeff - 1.d0
      END

      SUBROUTINE DEBUG_ADJ_rDISPLAY(placename, deltaindent)
      IMPLICIT NONE
      CHARACTER placename*(*)
      INTEGER deltaindent
      INCLUDE 'debugAD.inc'
      REAL diffpercent
      IF (dbad_phase.eq.1) THEN
         write(dbad_file,'(i3,a40)') 1, placename
         write(dbad_file,*) dbad_sum
      ELSE
         if (abs(dbad_refsum).le.dbad_epszero
     +        .and.abs(dbad_sum).le.dbad_epszero) then
            diffpercent = 0.0
         else
            diffpercent = abs(dbad_refsum-dbad_sum)*100.0
     +           /max(abs(dbad_refsum),abs(dbad_sum))
         endif
         if (diffpercent.le.dbad_errormax) then
c            write (*,'("                                     ok (",
c     +           f4.1,"% )  fwd:",e23.16,"  bwd:",e23.16)')
c     +           diffpercent,dbad_sum,dbad_refsum
         else
            dbad_nberrors = dbad_nberrors+1
            write (*,'("                             ", f5.1,
     +           "% DIFFERENCE!!  fwd:",e23.16,"  bwd:",e23.16)')
     +           diffpercent,dbad_sum,dbad_refsum
         endif
         IF (deltaindent.eq.0) THEN
            CALL DEBUG_DISPLAY_LOCATION(placename)
         ENDIF
      ENDIF
      dbad_sum = 0.d0
      dbad_coeff = 1.d0
      END

      SUBROUTINE DEBUG_ADJ_wDISPLAY(placename, deltaindent)
      IMPLICIT NONE
      CHARACTER placename*(*)
      INTEGER deltaindent
      INCLUDE 'debugAD.inc'
      IF (dbad_phase.eq.1) THEN
         write(dbad_file,'(i3,a40)') 0, placename
      ELSE
         IF (deltaindent.eq.0) THEN
            CALL DEBUG_DISPLAY_LOCATION(placename)
         ENDIF
         dbad_refsum = dbad_nextrefsum
      ENDIF
      dbad_sum = 0.d0
      dbad_coeff = 1.d0
      END

      SUBROUTINE DEBUG_DISPLAY_LOCATION(placename)
      IMPLICIT NONE
      CHARACTER placename*(*)
      INCLUDE 'debugAD.inc'
      CHARACTER whites*(50),enclosproc*(40)
      whites = '                                                  '
      if (dbad_callindex.EQ.0) then
         enclosproc = 'Top level'
      else
         enclosproc = dbad_callnames(dbad_callindex)
      endif
      write(*,*) whites(:2*(dbad_callindex-1)),
     +     ' AT:',placename,' OF ',enclosproc
      END

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Only the outmost loop can be parallelized.
!The inner loop has loop carried true data dependence.
!However, the loop is not parallelized so no race condition.

program DRB064_outeronly2_orig_no
    use omp_lib
    implicit none

    call foo()
contains
    subroutine foo()
        integer :: i, j, n, m, len
        real, dimension(:,:), allocatable :: b

        len = 100
        allocate (b(len,len))
        n = len
        m = len

        !$omp parallel do private(j)
        do i = 1, n
            do j = 2, m
                b(i,j) = b(i,j-1)
            end do
        end do
        !$omp end parallel do
    end subroutine foo
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two tasks with a lock synchronization to ensure execution order. No data race pairs.

program DRB069_sectionslock1_orig_no
    use omp_lib
    implicit none

    integer (kind=omp_lock_kind) lock
    integer :: i
    i = 0
    call omp_init_lock(lock)

    !$omp parallel sections
        !$omp section
        call omp_set_lock(lock)
        i = i + 1
        call omp_unset_lock(lock)
        !$omp section
        call omp_set_lock(lock)
        i = i + 2
        call omp_unset_lock(lock)
    !$omp end parallel sections

    call omp_destroy_lock(lock)

    print 100, i
    100 format ('I =',i3)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This example is from DRACC by Adrian Schmitz et al.
!Concurrent access on a counter with no lock with simd. Atomicity Violation. Intra Region.
!Data Race Pairs: var@29:13 and var@29:22.

program DRB161_nolocksimd_orig_gpu_yes
    use omp_lib
    implicit none

    integer :: var(8)
    integer :: i, j

    do i = 1, 8
        var(i) = 0
    end do

    !$omp target map(tofrom:var) device(0)
    !$omp teams num_teams(1) thread_limit(1048)
    !$omp distribute parallel do
    do i = 1, 20
        !$omp simd
        do j = 1, 8
            var(j) = var(j)+1
        end do
        !$omp end simd
    end do
    !$omp end distribute parallel do
    !$omp end teams
    !$omp end target

    print*,var(8)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Matrix-vector multiplication: outer-level loop parallelization. No data race pairs.

program DRB061_matrixvector1_orig_no
    use omp_lib
    implicit none
    call foo
contains
    subroutine foo()
        integer :: i, j, N
        real :: sum
        real, dimension(:,:), allocatable :: a
        real, dimension(:), allocatable :: v, v_out

        N = 100
        allocate (a(N,N))
        allocate (v(N))
        allocate (v_out(N))

        !$omp parallel do private (i,j,sum)
        do i = 1, N
            do j = 1, N
                sum = sum + a(i,j)*v(j)
            end do
            v_out(i) = sum
        end do
        !$omp end parallel do

    end subroutine foo
end program

c*********************************************************************72
      subroutine mpi_scan(data1, data2, n, datatype,
     &  operation, comm, ierror )

      implicit none

      include "mpi_dummy.h"

      integer n

      integer comm
      integer data1(n)
      integer data2(n)
      integer datatype
      integer ierror
      integer operation    ! currently hardwired only for sum only

      ierror = MPI_SUCCESS

      if ( datatype .eq. mpi_double_precision ) then

        call copy  (  data2, data1, n )

      else if ( datatype .eq. mpi_integer ) then

        call icopy (  data2, data1, n )

      else if ( datatype .eq. mpi_integer8 ) then

        call i8copy ( data2, data1, n )

      else if ( datatype .eq. mpi_real ) then

        call rrcopy ( data2, data1, n )

      else

        ierror = MPI_FAILURE

      end if

      return
      end

c*********************************************************************72
      subroutine mpi_abort ( comm, errorcode, ierror )

c*********************************************************************72
c
cc MPI_ABORT shuts down the processes in a given communicator.
c
      implicit none

      integer comm
      integer errorcode
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_ABORT:'
      write ( *, '(a,i12)' ) 
     &  '  Shut down with error code = ', errorcode

      stop
      end
      subroutine mpi_allgather ( data1, nsend, sendtype, data2, 
     &  nrecv, recvtype, comm, ierror )

c*********************************************************************72
c
cc MPI_ALLGATHER gathers data from all the processes in a communicator.
c
      implicit none

      include "mpi_dummy.h"

      integer nsend

      integer comm
      integer data1(nsend)
      integer data2(nsend)
      integer ierror
      integer nrecv
      integer recvtype
      integer sendtype

      ierror = MPI_SUCCESS

      if ( sendtype .eq. mpi_double_precision ) then
        call mpi_copy_double_precision ( data1, data2, nsend, ierror )
      else if ( sendtype .eq. mpi_integer ) then
        call mpi_copy_integer ( data1, data2, nsend, ierror )
      else if ( sendtype .eq. mpi_real ) then
        call mpi_copy_real ( data1, data2, nsend, ierror )
      else
        ierror = MPI_FAILURE
      end if

      return
      end
      subroutine mpi_allgatherv ( data1, nsend, sendtype,
     &  data2, nrecv, ndispls, recvtype, comm, ierror )

c*********************************************************************72
c
cc MPI_ALLGATHERV gathers data from all the processes in a communicator.
c
      implicit none

      include "mpi_dummy.h"

      integer nsend

      integer comm
      integer data1(nsend)
      integer data2(nsend)
      integer ierror
      integer ndispls
      integer nrecv
      integer recvtype
      integer sendtype

      ierror = MPI_SUCCESS

      if ( sendtype .eq. mpi_double_precision ) then
        call mpi_copy_double_precision ( data1, data2, nsend, ierror )
      else if ( sendtype .eq. mpi_integer ) then
        call mpi_copy_integer ( data1, data2, nsend, ierror )
      else if ( sendtype .eq. mpi_real ) then
        call mpi_copy_real ( data1, data2, nsend, ierror )
      else
        ierror = MPI_FAILURE
      end if

      return
      end
      subroutine mpi_allreduce ( data1, data2, n, datatype,
     &  operation, comm, ierror )

c*********************************************************************72
c
cc MPI_ALLREDUCE carries out a reduction operation.
c
      implicit none

      include "mpi_dummy.h"

      integer n

      integer comm
      integer data1(n)
      integer data2(n)
      integer datatype
      integer ierror
      integer operation

      ierror = MPI_SUCCESS

      if ( datatype .eq. mpi_double_precision ) then

        call mpi_reduce_double_precision ( 
     &    data1, data2, n, operation, ierror )

      else if ( datatype .eq. mpi_integer ) then

        call mpi_reduce_integer ( 
     &    data1, data2, n, operation, ierror )

      else if ( datatype .eq. mpi_integer8 ) then

        call mpi_reduce_integer8( 
     &    data1, data2, n, operation, ierror )

      else if ( datatype .eq. mpi_real ) then

        call mpi_reduce_real ( 
     &    data1, data2, n, operation, ierror )

      else

        ierror = MPI_FAILURE

      end if

      return
      end

      subroutine mpi_barrier ( comm, ierror )

c*********************************************************************72
c
cc MPI_BARRIER forces processes within a communicator to wait together.
c
      implicit none

      integer comm
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      return
      end
      subroutine mpi_bcast ( data, n, datatype, node, comm, ierror )

c*********************************************************************72
c
cc MPI_BCAST broadcasts data from one process to all others.
c
      implicit none

      integer n

      integer comm
      integer data(n)
      integer datatype
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )
      integer node

      ierror = MPI_SUCCESS

      return
      end
      subroutine mpi_bsend ( data, n, datatype, iproc, itag,
     &  comm, ierror )

c*********************************************************************72
c
cc MPI_BSEND sends data from one process to another, using buffering.
c
      implicit none

      integer n

      integer comm
      integer data(n)
      integer datatype
      integer ierror
      integer iproc
      integer itag
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_BSEND - Error!'
      write ( *, '(a)' )  '  Should not send message to self.'

      return
      end
      subroutine mpi_cart_create ( comm, ldims, dims, periods,
     &  reorder, comm_cart, ierror )

c*********************************************************************72
c
cc MPI_CART_CREATE creates a communicator for a Cartesian topology.
c
      implicit none

      integer ldims

      integer comm
      integer comm_cart
      integer dims(*)
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )
      logical periods(*)
      logical reorder

      ierror = MPI_SUCCESS

      return
      end
      subroutine mpi_cart_get ( comm, ldims, dims, periods,
     &  coords, ierror )

c*********************************************************************72
c
cc MPI_CART_GET returns the "Cartesian coordinates" of the calling process.
c
      implicit none

      integer ldims

      integer comm
      integer coords(*)
      integer dims(*)
      integer i
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )
      logical periods(*)

      ierror = MPI_SUCCESS

      do i = 1, ldims
        coords(i) = 0
      end do

      return
      end
      subroutine mpi_cart_shift ( comm, idir, idisp, isource, 
     &  idest, ierror )

c*********************************************************************72
c
cc MPI_CART_SHIFT finds the destination and source for Cartesian shifts.
c
      implicit none

      integer comm
      integer idest
      integer idir
      integer idisp
      integer ierror
      integer isource
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS
      isource = 0
      idest = 0

      return
      end
      subroutine mpi_comm_dup ( comm, comm_out, ierror )

c*********************************************************************72
c
cc MPI_COMM_DUP duplicates a communicator.
c
      implicit none

      integer comm
      integer comm_out
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS
      comm_out = comm

      return
      end
      subroutine mpi_comm_free ( comm, ierror )

c*********************************************************************72
c
cc MPI_COMM_FREE "frees" a communicator.
c
      implicit none

      integer comm
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS

      return
      end
      subroutine mpi_comm_rank ( comm, me, ierror )

c*********************************************************************72
c
cc MPI_COMM_RANK reports the rank of the calling process.
c
      implicit none

      integer comm
      integer ierror
      integer me
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS
      me = 0

      return
      end
      subroutine mpi_comm_size ( comm, nprocs, ierror )

c*********************************************************************72
c
cc MPI_COMM_SIZE reports the number of processes in a communicator.
c
      implicit none

      integer comm
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )
      integer nprocs

      ierror = MPI_SUCCESS
      nprocs = 1

      return
      end
      subroutine mpi_comm_split ( comm, icolor, ikey, comm_new,
     &  ierror )

c*********************************************************************72
c
cc MPI_COMM_SPLIT splits up a communicator based on a key.
c
      implicit none

      integer comm
      integer comm_new
      integer icolor
      integer ierror
      integer ikey
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS

      return
      end
      subroutine mpi_copy_double_precision ( data1, data2, n, ierror )

c*********************************************************************72
c
cc MPI_COPY_DOUBLE copies a real*8 vector.
c
      implicit none

      integer n

      real*8 data1(n)
      real*8 data2(n)
      integer i
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS

      do i = 1, n
        data2(i) = data1(i)
      end do

      return
      end
      subroutine mpi_copy_integer ( data1, data2, n, ierror )

c*********************************************************************72
c
cc MPI_COPY_INTEGER copies an integer vector.
c
      implicit none

      integer n

      integer data1(n)
      integer data2(n)
      integer i
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS

      do i = 1, n
        data2(i) = data1(i)
      end do

      return
      end
      subroutine mpi_copy_real ( data1, data2, n, ierror )

c*********************************************************************72
c
      implicit none

      integer n

      real data1(n)
      real data2(n)
      integer i
      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS

      do i = 1, n
        data2(i) = data1(i)
      end do

      return
      end
      subroutine mpi_finalize ( ierror )

c*********************************************************************72
c
cc MPI_FINALIZE shuts down the MPI library.
c
      implicit none

      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_SUCCESS

      return
      end
      subroutine mpi_get_count ( istatus, datatype, icount, ierror )

c*********************************************************************72
c
cc MPI_GET_COUNT reports the actual number of items transmitted.
c
      implicit none

      integer datatype
      integer icount
      integer ierror
      integer istatus
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_GET_COUNT - Error!'
      write ( *, '(a)' ) '  Should not query message from self.'

      return
      end
      subroutine mpi_init ( ierror )

c*********************************************************************72
c
cc MPI_INIT initializes the MPI library.
c
      implicit none

      integer ierror
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      write(6,*) 'Initialize dummy MPI library'
      ierror = MPI_SUCCESS

      return
      end
      subroutine mpi_irecv ( data, n, datatype, iproc, itag,
     &  comm, irequest, ierror )

c*********************************************************************72
c
cc MPI_IRECV receives data from another process.
c
      implicit none

      integer n

      integer comm
      integer data(n)
      integer datatype
      integer ierror
      integer iproc
      integer irequest
      integer itag
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_IRECV - Error!'
      write ( *, '(a)' ) '  Should not recv message from self.'

      return
      end
      subroutine mpi_isend ( data, n, datatype, iproc, itag,
     &  comm, request, ierror )

c*********************************************************************72
c
cc MPI_ISEND sends data from one process to another using nonblocking transmission.
c
      implicit none

      integer n

      integer comm
      integer data(n)
      integer datatype
      integer ierror
      integer iproc
      integer itag
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )
      integer request

      request = 0
      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_ISEND - Error!'
      write ( *, '(a)' )  '  Should not send message to self.'

      return
      end
      subroutine mpi_recv ( data, n, datatype, iproc, itag,
     &  comm, istatus, ierror )

c*********************************************************************72
c
cc MPI_RECV receives data from another process within a communicator.
c
      implicit none

      integer n

      integer comm
      integer data(n)
      integer datatype
      integer ierror
      integer iproc
      integer istatus
      integer itag
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_RECV - Error!'
      write ( *, '(a)' ) '  Should not recv message from self.'

      return
      end
      subroutine mpi_reduce ( data1, data2, n, datatype, operation,
     &  receiver, comm, ierror )

c*********************************************************************72
c
cc MPI_REDUCE carries out a reduction operation.
c
      implicit none

      include "mpi_dummy.h"

      integer n

      integer comm
      integer data1(n)
      integer data2
      integer datatype
      integer ierror
      integer operation
      integer receiver

      ierror = MPI_SUCCESS

      if ( datatype .eq. mpi_double_precision ) then

        call mpi_reduce_double_precision ( 
     &    data1, data2, n, operation, ierror )

      else if ( datatype .eq. mpi_integer ) then

        call mpi_reduce_integer ( 
     &    data1, data2, n, operation, ierror )

      else if ( datatype .eq. mpi_real ) then

        call mpi_reduce_real ( 
     &    data1, data2, n, operation, ierror )

      else

        ierror = MPI_FAILURE

      end if

      return
      end
      subroutine mpi_reduce_double_precision ( 
     &  data1, data2, n, operation, ierror )

c*********************************************************************72
c
cc MPI_REDUCE_DOUBLE_PRECISION carries out a reduction operation on real*8 values.
c
      implicit none

      include "mpi_dummy.h"

      integer n

      real*8 data1(n)
      real*8 data2(n)
      integer i
      integer ierror
      integer operation


      ierror = MPI_SUCCESS

      do i = 1, n
        data2(i) = data1(i)
      end do

      return
      end

      subroutine mpi_reduce_integer8 ( 
     &  data1, data2, n, operation, ierror )

c*********************************************************************72
c
      implicit none

      include "mpi_dummy.h"

      integer n

      integer*8 data1(n)
      integer*8 data2(n)
      integer i
      integer ierror
      integer operation

      ierror = MPI_SUCCESS

      do i = 1, n
         data2(i) = data1(i)
      end do

      ierror = MPI_FAILURE

      return
      end
 
      subroutine mpi_reduce_integer ( 
     &  data1, data2, n, operation, ierror )

c*********************************************************************72
c
      implicit none

      include "mpi_dummy.h"

      integer n

      integer data1(n)
      integer data2(n)
      integer i
      integer ierror
      integer operation

      ierror = MPI_SUCCESS

      do i = 1, n
         data2(i) = data1(i)
      end do

      ierror = MPI_FAILURE

      return
      end

      subroutine mpi_reduce_real ( 
     &  data1, data2, n, operation, ierror )

c*********************************************************************72
c
cc MPI_REDUCE_REAL carries out a reduction operation on reals.
c
c  Discussion:
c
      implicit none

      include "mpi_dummy.h"

      integer n

      real data1(n)
      real data2(n)
      integer i
      integer ierror
      integer operation

      ierror = MPI_SUCCESS

        do i = 1, n
          data2(i) = data1(i)
        end do

      return
      end
      subroutine mpi_reduce_scatter ( data1, data2, n, datatype,
     &  operation, comm, ierror )

c*********************************************************************72
c
cc MPI_REDUCE_SCATTER collects a message of the same length from each process.
c
      implicit none

      include "mpi_dummy.h"

      integer n

      integer comm
      integer data1(n)
      integer data2(n)
      integer datatype
      integer ierror
      integer operation

      ierror = MPI_SUCCESS

      if ( datatype .eq. mpi_double_precision ) then
        call mpi_copy_double_precision ( data1, data2, n, ierror )
      else if ( datatype .eq. mpi_integer ) then
        call mpi_copy_integer ( data1, data2, n, ierror )
      else if ( datatype .eq. mpi_real ) then
        call mpi_copy_real ( data1, data2, n, ierror )
      else
        ierror = MPI_FAILURE
      end if

      return
      end
      subroutine mpi_rsend ( data, n, datatype, iproc, itag,
     &  comm, ierror )

c*********************************************************************72
c
cc MPI_RSEND "ready sends" data from one process to another.
c
      implicit none

      integer n

      integer comm
      integer data(n)
      integer datatype
      integer ierror
      integer iproc
      integer itag
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_RSEND - Error!'
      write ( *, '(a)' ) '  Should not send message to self.'

      return
      end
      subroutine mpi_send ( data, n, datatype, iproc, itag,
     &  comm, ierror )

c*********************************************************************72
c
cc MPI_SEND sends data from one process to another.
c
      implicit none

      integer n

      integer comm
      integer data(n)
      integer datatype
      integer ierror
      integer iproc
      integer itag
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_SEND - Error!'
      write ( *, '(a)' )  '  Should not send message to self.'

      return
      end
      subroutine mpi_wait ( irequest, istatus, ierror )

c*********************************************************************72
c
cc MPI_WAIT waits for an I/O request to complete.
c
      implicit none

      integer ierror
      integer irequest
      integer istatus
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_WAIT - Error!'
      write ( *, '(a)' ) '  Should not wait on message from self.'

      return
      end
      subroutine mpi_waitall ( icount, irequest, istatus, ierror )

c*********************************************************************72
c
cc MPI_WAITALL waits until all I/O requests have completed.
c
      implicit none

      integer icount
      integer ierror
      integer irequest
      integer istatus
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_WAITALL - Error!'
      write ( *, '(a)' ) '  Should not wait on message from self.'

      return
      end
      subroutine mpi_waitany ( icount, array_of_requests, index, 
     &  istatus, ierror )

c*********************************************************************72
c
cc MPI_WAITANY waits until one I/O requests has completed.
c
      implicit none

      integer array_of_requests(*)
      integer icount
      integer ierror
      integer index
      integer istatus
      integer MPI_FAILURE
      parameter ( MPI_FAILURE = 1 )
      integer MPI_SUCCESS
      parameter ( MPI_SUCCESS = 0 )

      ierror = MPI_FAILURE

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'MPI_WAITANY - Error!'
      write ( *, '(a)' ) '  Should not wait on message from self.'

      return
      end
      function mpi_wtick ( )

c*********************************************************************72
c
cc MPI_WTICK returns the time between clock ticks.
c
      implicit none
      
      real*8 mpi_wtick
      
      mpi_wtick = 1.0D+00
      
      return
      end
      function mpi_wtime ( )

c*********************************************************************72
c
cc MPI_WTIME returns the elapsed wall clock time.
c
      implicit none

      real*8 mpi_wtime
      real*4 a(2),etime
      a(1)=0.0
      a(2)=0.0
      mpi_wtime = etime(a)

      return
      end

      subroutine mpi_initialized(mpi_is_initialized, ierr)

      mpi_is_initialized = 0 
      ierr = 0

      return
      end

      subroutine mpi_comm_create(icomm,igroup,icommd,ierr)

      icommd = 1

      return
      end

      subroutine mpi_intercomm_create(ilcomm,ill,ipcomm,irl,itag,
     $                                newcomm,ierr)

      call exitti('mpi_intercomm_create not supported!$',1)

      return
      end

      subroutine mpi_intercomm_merge(icomm,ihigh,icommd,ierr)

      call exitti('mpi_intercomm_merge not supported!$',1)

      return
      end

      subroutine mpi_comm_group(icomm,igroup,ierr)

      igroup = 1
      ierr = 0

      return
      end

      subroutine mpi_group_free

      return
      end

      subroutine mpi_comm_get_attr(icomm,ikey,ival,iflag,ierr)

      integer*8 ival 
      logical iflag

      ival =  9 999 999  ! dummy
 
      return
      end
c

      subroutine mpi_attr_get(icomm,ikey,ival,iflag,ierr)
 
      logical iflag

      ival =  9 999 999  ! dummy
 
      return
      end
c-----------------------------------------------------------------------
      subroutine mpi_type_get_extent(ikey,ib,isize,ierr)

      include "mpi_dummy.h"
      integer*8 ib, isize

      if (ikey.eq.MPI_DOUBLE_PRECISION) isize = 8 
      if (ikey.eq.MPI_INTEGER)  isize = 4 
      if (ikey.eq.MPI_INTEGER8) isize = 8 

      ierr = 0

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A two-level loop nest with loop carried anti-dependence on the outer level.
!Data race pair: a[i][j]@29:13 vs. a[i+1][j]@29:31

program DRB003_antidep2_orig_yes
    use omp_lib
    implicit none

    integer :: i, j, len
    real :: a(20,20)

    len = 20

    do i = 1, len
        do j = 1, len
            a(i,j) = 0.5
        end do
    end do

    !$omp parallel do private(j)
    do i = 1, len-1
        do j = 1, len
            a(i,j) = a(i,j) + a(i+1,j)
        end do
    end do
    !$omp end parallel do

    write(*,*) 'a(10,10) =', a(10,10)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The barrier construct specifies an explicit barrier at the point at which the construct appears.
!Barrier construct at line:27 ensures that there is no data race.

program DRB120_barrier_orig_no
    use omp_lib
    implicit none

    integer :: var

    !$omp parallel shared(var)
    !$omp single
    var = var + 1;
    !$omp end single
    !$omp barrier

    !$omp single
    var = var + 1;
    !$omp end single
    !$omp end parallel

    print 100, var
    100 format ('var =',i3)
end program

      subroutine intp_setup(tolin)

      call exitti('intp_setup is deprecated, see release notes!!$',1)  
       
      return
      end
c-----------------------------------------------------------------------
      subroutine intp_do(fldout,fldin,nfld,xp,yp,zp,n,iwk,rwk,nmax,iflp)

      call exitti('intp_do is deprecated, see release notes!!$',1)  

      return
      end
c-----------------------------------------------------------------------
      subroutine intp_free()

      call exitti('intp_free is deprecated, see release notes!!$',1)  

      return
      end

c-----------------------------------------------------------------------
      subroutine nek_init(comm)
c
      include 'SIZE'
      include 'TOTAL'
      include 'DOMAIN'
c
      include 'OPCTR'
      include 'CTIMER'

C     used scratch arrays
C     NOTE: no initial declaration needed. Linker will take 
c           care about the size of the CBs automatically
c
c      COMMON /CTMP1/ DUMMY1(LCTMP1)
c      COMMON /CTMP0/ DUMMY0(LCTMP0)
c
c      COMMON /SCRNS/ DUMMY2(LX1,LY1,LZ1,LELT,7)
c      COMMON /SCRUZ/ DUMMY3(LX1,LY1,LZ1,LELT,4)
c      COMMON /SCREV/ DUMMY4(LX1,LY1,LZ1,LELT,2)
c      COMMON /SCRVH/ DUMMY5(LX1,LY1,LZ1,LELT,2)
c      COMMON /SCRMG/ DUMMY6(LX1,LY1,LZ1,LELT,4)
c      COMMON /SCRCH/ DUMMY7(LX1,LY1,LZ1,LELT,2)
c      COMMON /SCRSF/ DUMMY8(LX1,LY1,LZ1,LELT,3)
c      COMMON /SCRCG/ DUMM10(LX1,LY1,LZ1,LELT,1)

      integer comm
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
  
      common /rdump/ ntdump

      real kwave2
      logical ifemati

      real rtest
      integer itest
      integer*8 itest8
      character ctest
      logical ltest 

      common /c_is1/ glo_num(lx1 * ly1 * lz1, lelt)
      common /ivrtx/ vertex((2 ** ldim) * lelt)
      integer*8 glo_num, ngv
      integer vertex

      ! set word size for REAL
      wdsize = sizeof(rtest)
      ! set word size for INTEGER
      isize = sizeof(itest)
      ! set word size for INTEGER*8
      isize8 = sizeof(itest8) 
      ! set word size for LOGICAL
      lsize = sizeof(ltest) 
      ! set word size for CHARACTER
      csize = sizeof(ctest)

      call setupcomm(comm,newcomm,newcommg,'','')
      intracomm   = newcomm   ! within a session
      nekcomm     = newcomm
      iglobalcomm = newcommg  ! across all sessions
      call iniproc()

      if (nid.eq.nio) call printHeader

      etimes = dnekclock()
      istep  = 0

      call opcount(1)

      call initdim         ! Initialize / set default values.
      call initdat
      call files

      call readat          ! Read .rea +map file

      call setvar          ! Initialize most variables

      instep=1             ! Check for zero steps
      if (nsteps.eq.0 .and. fintim.eq.0.) instep=0

      igeom = 2
      call setup_topo      ! Setup domain topology  

      call genwz           ! Compute GLL points, weights, etc.

      if(nio.eq.0) write(6,*) 'call usrdat'
      call usrdat
      if(nio.eq.0) write(6,'(A,/)') ' done :: usrdat' 

      call gengeom(igeom)  ! Generate geometry, after usrdat 

      if (ifmvbd) call setup_mesh_dssum ! Set mesh dssum (needs geom)

      if(nio.eq.0) write(6,*) 'call usrdat2'
      call usrdat2
      if(nio.eq.0) write(6,'(A,/)') ' done :: usrdat2' 

      call fix_geom
      call geom_reset(1)    ! recompute Jacobians, etc.

      call vrdsmsh          ! verify mesh topology
      call mesh_metrics     ! print some metrics

      call setlog(.true.)   ! Initalize logical flags

      if (ifneknekc) call neknek_setup

      call bcmask  ! Set BC masks for Dirichlet boundaries.

      if (fintim.ne.0.0 .or. nsteps.ne.0) 
     $   call geneig(igeom) ! eigvals for tolerances

      call dg_setup ! Setup DG, if dg flag is set.

      if (ifflow.and.iftran) then ! Init pressure solver 
         if (fintim.ne.0 .or. nsteps.ne.0) call prinit
      endif

      if(ifcvode) call cv_setsize

      if(nio.eq.0) write(6,*) 'call usrdat3'
      call usrdat3
      if(nio.eq.0) write(6,'(A,/)') ' done :: usrdat3'

#ifdef CMTNEK
        call nek_cmt_init
#endif

      call setics
      call setprop

      if (instep.ne.0) then
         if (ifneknekc) call neknek_exchange
         if (ifneknekc) call chk_outflow

         if (nio.eq.0) write(6,*) 'call userchk'
         call userchk
         if(nio.eq.0) write(6,'(A,/)') ' done :: userchk' 
      endif

      call setprop      ! call again because input has changed in userchk

      if (ifcvode .and. nsteps.gt.0) call cv_init

      call comment
      call sstest (isss) 

      call dofcnt

      jp = 0  ! Set perturbation field count to 0 for baseline flow
      p0thn = p0th

      call in_situ_init()

      call time00       !     Initalize timers to ZERO
      call opcount(2)

      ntdump=0
      if (timeio.ne.0.0) ntdump = int( time/timeio )

      tinit = dnekclock_sync() - etimes
      if (nio.eq.0) then
        write (6,*) ' '
        if (time.ne.0.0) write (6,'(a,e14.7)') ' Initial time:',time
        write (6,'(a,g13.5,a)') 
     &     ' Initialization successfully completed ', tinit, ' sec'
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine nek_solve

      include 'SIZE'
      include 'TSTEP'
      include 'INPUT'
      include 'CTIMER'

      call nekgsync()

      if (instep.eq.0) then
        if(nid.eq.0) write(6,'(/,A,/,A,/)') 
     &     ' nsteps=0 -> skip time loop',
     &     ' running solver in post processing mode'
      else
        if(nio.eq.0) write(6,'(/,A,/)') 'Starting time loop ...'
      endif

      isyc  = 0
      if(ifsync) isyc=1
      itime = 0
#ifdef TIMER
      itime = 1
#endif

      ! start measurements
      dtmp = dnekgflops()

      istep  = 0
      msteps = 1

      irstat = int(param(120))

      do kstep=1,nsteps,msteps
         call nek__multi_advance(kstep,msteps)
         if(kstep.ge.nsteps) lastep = 1
         call check_ioinfo  
         call set_outfld
         etime1 = dnekclock()
         call userchk
         tuchk = tuchk + dnekclock()-etime1
         call prepost (ifoutfld,'his')
         call in_situ_check()
         if (mod(kstep,irstat).eq.0 .and. lastep.eq.0) call runstat 
         if (lastep .eq. 1) goto 1001
      enddo
 1001 lastep=1

      call comment

c     check for post-processing mode
      if (instep.eq.0) then
         nsteps=0
         istep=0
         if(nio.eq.0) write(6,*) 'call userchk'
         call userchk
         if(nio.eq.0) write(6,*) 'done :: userchk'
         call prepost (.true.,'his')
      else
         if (nio.eq.0) write(6,'(/,A,/)') 
     $      'end of time-step loop' 
      endif


      RETURN
      END

c-----------------------------------------------------------------------
      subroutine nek_advance

      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'

      common /cgeom/ igeom

      ntot = lx1*ly1*lz1*nelv

      call nekgsync

      call setup_convect(2) ! Save conv vel

      if (iftran) call settime
      if (ifmhd ) call cfl_check
      call setsolv
      call comment

#ifdef CMTNEK
      if (nio.eq.0.and.istep.le.1) write(6,*) 'CMT branch active'
      call cmt_nek_advance
      return
#endif

      if (ifsplit) then   ! PN/PN formulation

         do igeom=1,ngeom

         if (ifneknekc .and. igeom.gt.2) then
            if (ifneknekm.and.igeom.eq.3) call neknek_setup
            call neknek_exchange
         endif

         ! call here before we overwrite wx 
         if (ifheat .and. ifcvode) call heat_cvode (igeom)   

         if (ifgeom) then
            call gengeom (igeom)
            call geneig  (igeom)
         endif

         if (ifheat) call heat (igeom)

         if (igeom.eq.2) then  
            call setprop
            call rzero(qtl,ntot)
            if (iflomach) call qthermal
         endif

         if (ifflow)          call fluid    (igeom)
         if (ifmvbd)          call meshv    (igeom)
         if (igeom.eq.ngeom.and.filterType.eq.1)
     $                        call q_filter(param(103))

         enddo

      else                ! PN-2/PN-2 formulation
         call setprop
         do igeom=1,ngeom

            if (ifneknekc .and. igeom.gt.2) then
              if (ifneknekm.and.igeom.eq.3) call neknek_setup
              call neknek_exchange
            endif

            ! call here before we overwrite wx 
            if (ifheat .and. ifcvode) call heat_cvode (igeom)   

            if (ifgeom) then
               if (.not.ifrich) call gengeom (igeom)
               call geneig  (igeom)
            endif

            if (ifmhd) then
               if (ifheat)      call heat     (igeom)
                                call induct   (igeom)
            elseif (ifpert) then
               if (ifbase.and.ifheat)  call heat          (igeom)
               if (ifbase.and.ifflow)  call fluid         (igeom)
               if (ifflow)             call fluidp        (igeom)
               if (ifheat)             call heatp         (igeom)
            else  ! std. nek case
               if (ifheat)             call heat          (igeom)
               if (ifflow)             call fluid         (igeom)
               if (ifmvbd)             call meshv         (igeom)
            endif
            if (igeom.eq.ngeom.and.filterType.eq.1)
     $         call q_filter(param(103))
         enddo
      endif

      return
      end

c-----------------------------------------------------------------------
      subroutine nek_end

      include 'SIZE'
      include 'TOTAL'

      if(instep.ne.0) call runstat

c      if (ifstrs) then
c         call fgslib_crs_free(xxth_strs) 
c      else
c         call fgslib_crs_free(xxth(1))
c      endif

      call in_situ_end()
      call exitt0()

      return
      end
c-----------------------------------------------------------------------
      subroutine nek__multi_advance(kstep,msteps)

      include 'SIZE'
      include 'TOTAL'

      do i=1,msteps
         istep = istep+i
         call nek_advance

         if (ifneknekc) then 
            call neknek_exchange
            call bcopy
            call chk_outflow
         endif
      enddo

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Classic PI calculation using reduction. No data race pairs.

program DRB065_pireduction_orig_no
    use omp_lib
    implicit none

    real(kind = 16) :: x, interval_width, pi
    integer(kind = 8) :: i, num_steps

    pi = 0.0
    num_steps = 2000000000
    interval_width = 1.0/num_steps

    !$omp parallel do reduction(+:pi) private(x)
    do i = 1, num_steps
        x = (i + 0.5) * interval_width
        pi = pi + 1.0 / (x*x + 1.0);
    end do
    !$omp end parallel do

    pi = pi * 4.0 * interval_width;
    print 100, pi
    100 format ("PI =",F24.20)

end program

c Various support routines for perturbation related calculuations.
c------------------------------------------------------------------------
      subroutine flushBuffer(k)
      integer k

c     call flush(k)  ! this works most places (including the pgi compiler)
      call flush_(k) ! this works on nersc seaborg

      return
      end
c------------------------------------------------------------------------

      function opnormOld(v1,v2,v3,weight)
      include 'SIZE'
      include 'INPUT'
c
      real v1(1),v2(1),v3(1),weight(1)
      real normsq1,normsq2,normsq3,opnormOld,opnorm
c
      ntotv=lx1*ly1*lz1*nelv
      normsq1=glsc3(v1,weight,v1,ntotv)
      normsq2=glsc3(v2,weight,v2,ntotv)
      if(if3d) then
         normsq3=glsc3(v3,weight,v3,ntotv)
      else
         normsq3=0
      endif

      opnorm=normsq1+normsq2+normsq3
      if (opnorm.gt.0) opnormOld=sqrt(opnorm)
      return
      end
c-----------------------------------------------------------------------

      function opnorm2(v1,v2,v3)
      include 'SIZE'
      include 'TOTAL'
c
      real v1(1) , v2(1), v3(1)
      real normsq1,normsq2,normsq3,opnorm
c
      ntotv=lx1*ly1*lz1*nelv
      normsq1=glsc3(v1,bm1,v1,ntotv)
      normsq2=glsc3(v2,bm1,v2,ntotv)
      if(if3d) then
         normsq3=glsc3(v3,bm1,v3,ntotv)
      else
         normsq3=0
      endif

      opnorm2=normsq1+normsq2+normsq3
      if (opnorm2.gt.0) opnorm2=sqrt(opnorm2/volvm1)
      return
      end
c-----------------------------------------------------------------------

      function Tnorm(temp)
      include 'SIZE'
      include 'TOTAL'

      real temp(*)
c
      ntotv = lx1*ly1*lz1*nelv
      Tnorm = sqrt( glsc3(temp,BM1,temp,ntotv) /voltm1)
c
      return
      end
c--------------------------------------------
      function dmnorm(v1,v2,v3,temp)
c     Norm weighted by mass matrix
      include 'SIZE'
      include 'TOTAL'

      real v1(1),v2(1),v3(1),temp(1)
      real normsq1,normsq2,normsq3,normsqT,dMnorm
      common/normset/pran, ray, rayc

      ntotv=lx1*ly1*lz1*nelv
      normsq1=(rayc)*glsc3(v1,BM1,v1,ntotv)
      normsq2=(rayc)*glsc3(v2,BM1,v2,ntotv)
      if(if3d) then
         normsq3=(rayc)*glsc3(v3,BM1,v3,ntotv)
      else
         normsq3=0
      endif

      if(ifheat) then
         normsqT = (pran*ray*ray)*glsc3(temp,BM1,temp,ntotv)
      else
         normsqT = 0
      endif

      dmnorm=sqrt((normsq1+normsq2+normsq3+normsqT)/volvm1)

      return
      end

c---------------------------------------------------------------
      subroutine opscale(v1,v2,v3,temp,alpha)
c     v =  alpha*v
      include 'SIZE'
      include 'INPUT'

      real alpha
      real v1(1),v2(1),v3(1),temp(1)

      ltotv=lx1*ly1*lz1*lelv
      ltott=lx1*ly1*lz1*lelt

      call cmult(v1,alpha,ltotv)
      call cmult(v2,alpha,ltotv)
      if (if3d)   call cmult(v3,alpha,ltotv)
      if (ifheat) call cmult(temp,alpha,ltott*ldimt)

      return
      end

c---------------------------------------------------------------
      subroutine opscaleV(v1,v2,v3,alpha)
c     v =  alpha*v
      include 'SIZE'
      include 'INPUT'
      real alpha
      real v1(*),v2(*),v3(*)

      ntotv=lx1*ly1*lz1*nelv

      call cmult(v1,alpha,ntotv)
      call cmult(v2,alpha,ntotv)

      if (if3d)   call cmult(v3,alpha,ntotv)
c
      return
      end

c-----------------------------------------------------------------------
      subroutine computelyap
      include 'SIZE'
      include 'TOTAL'

      do jpp=1,npert         ! Loop through each Lyapunov eigenvalue
         call computelyap1
     $     (vxp(1,jpp),vyp(1,jpp),vzp(1,jpp),tp(1,1,jpp),jpp)
      enddo

      return
      end
c-----------------------------------------------------------------------

      subroutine computelyap1(vxq,vyq,vzq,tq,jpp)
      include 'SIZE'
      include 'TOTAL'

      real vxq(1),vyq(1),vzq(1),tq(1)
      real lyapsum,twt
      common /pertsave/ timestart,tinitial

      integer icount
      save    icount
      data    icount /0/

      logical       if_restart,if_ortho_lyap
      common/restar/if_restart,if_ortho_lyap

      character*132 lyprestart
      common/restflename/lyprestart  !file for restart data

      twt = param(126) !time to wait to start computing exponents

      if (nio.eq.0) 
     $  write(6,8) istep,icount,time,twt,(lyap(k,jpp),k=1,3),jpp
    8 format(i9,i4,2f8.4,1p3e12.4,i3,'clyap')

      if(time.lt.twt) then
c
c        For a  fresh simulation, then we wait 5 vertical diffusion 
c        times before we start measuring, so in this case just rescale
c
         pertnorm = dmnorm(vxq,vyq,vzq,tq)
         pertinvnorm = 1.0/pertnorm
         call rescalepert(pertnorm,pertinvnorm,jpp)
         lyap(3,jpp) = pertnorm !store latest norm
         timestart   = time
         tinitial    = time
         icount      = 0
         return
      else
         if (jpp.eq.1) icount = icount + 1
      endif

      irescale = param(128)
      if (icount.eq.irescale) then

         lyapsum     = lyap(2,jpp)
         oldpertnorm = lyap(3,jpp)
         pertnorm=dmnorm(vxq,vyq,vzq,tq)
c
         lyap(1,jpp) = log(pertnorm/oldpertnorm)/(time-timestart)
         lyapsum     = lyapSum + log(pertnorm/oldpertnorm)
         lyap(2,jpp) = lyapSum

         if(nid.eq.0) then        ! write out results to the .lyp file
 
           write(6 ,1) istep,time,lyap(1,jpp),lyapsum,pertnorm,jpp
           write(79,2) time,lyap(1,jpp),lyapsum,pertporm,oldpertnorm,jpp
 1         format(i9,1p4e17.8,i4,'lyap')
 2         format(1p5e17.8,i4,'lyap')
           call flushbuffer(79)
 
           if (jpp.eq.1) open(unit=96,file=lyprestart)
           write(96,9) lyapsum,timestart,timeinit,jpp
 9         format(1p3e19.11,i9)
           if (jpp.eq.npert) close(96)
         endif

         pertinvnorm = 1.0/pertnorm
         call rescalepert(pertnorm,pertinvnorm,jpp)
         lyap(3,jpp) = pertnorm  !save current pertnorm as old pertnorm

         if (jpp.eq.npert) then
            icount    = 0
            timestart = time
         endif

         if_ortho_lyap = .false.
         if (param(125).gt.0) if_ortho_lyap = .true.
         if (jpp.eq.npert .and. if_ortho_lyap) call pert_ortho_norm

      endif

      return
      end
c-----------------------------------------------------------------------

      subroutine rescalepert(pertnorm,pertinvnorm,jpp)
      include 'SIZE'
      include 'TOTAL'

      ntotp = lx2*ly2*lz2*nelv

      call opscale                     !normalize vectors to unit norm
     $      (vxp(1,jpp),vyp(1,jpp),vzp(1,jpp),tp(1,1,jpp),pertinvnorm)
      call cmult(prp(1,jpp),pertinvnorm,ntotp)

      call opscale(exx1p(1,jpp),exy1p(1,jpp),exz1p(1,jpp)
     $                           ,vgradt1p(1,1,jpp),pertinvnorm)
      call opscale(exx2p(1,jpp),exy2p(1,jpp),exz2p(1,jpp)
     $                           ,vgradt2p(1,1,jpp),pertinvnorm)

      ltotv = lx1*ly1*lz1*lelv
      ltotp = lx2*ly2*lz2*lelv

      call cmult( tlagp(1,1,1,jpp),pertinvnorm,ltotv*(lorder-1)*ldimt)
      call cmult(vxlagp(1,1,jpp),pertinvnorm,ltotv*(lorder-1))
      call cmult(vylagp(1,1,jpp),pertinvnorm,ltotv*(lorder-1))
      call cmult(vzlagp(1,1,jpp),pertinvnorm,ltotv*(lorder-1))
      call cmult(prlagp(1,1,jpp),pertinvnorm,ltotp*(Lorder-2))

      if (nio.eq.0) write(6,1) istep,pertnorm,pertinvnorm,jpp,'PNORM'
  1   format(i4,1p2e12.4,i4,a5)
      pertnorm = pertnorm*pertinvnorm

      return
      end
c-----------------------------------------------------------------------
      subroutine initialize
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'

      do jpp = 1,npert
         call initialize1(jpp)
      enddo

      return
      end
c----------------------------------------------------------------------
      subroutine initialize1(jpp)
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'

      real tmp(4),lyapSum,timeStart
      common/pertsave/timeStart,tinitial
      common/normset/pran,ray,rayc
      character*1 lyp(4),sch(5)
      character*4 lyp4
      character*5 sch5
      character*7 lypres,lypold
      CHARACTER*1 SESS1(132),PATH1(132),NAM1(132)
      EQUIVALENCE (SESSION,SESS1)
      EQUIVALENCE (PATH,PATH1)
      EQUIVALENCE (NAME,NAM1)
      equivalence (lyp,lyp4)
      equivalence (sch,sch5)
      data lyp4 /'.lyp'/
      data sch5 /'.schp'/
      data lypold /'.lypold'/
      data lypres /'.lypsum'/
      character*132 lypfile,lypfileold,lyprestart,lypsch
      common/restflename/lyprestart      !file where restart data is written
      logical if_restart
      common/restar/if_restart
      logical ifdebug
      common/debug/ ifdebug

      ntotv     = lx1*ly1*lz1*nelv
      ntotp     = lx2*ly2*lz2*nelv
      nconv_max = nbdinp
      nconv     = nconv_max 
      nconv     = 1
      nprex     = 0
      nprex_max = max(0,nbdinp-2)
     
      nr = lx1-1
      ns = ly1-1
      nt = lz1-1

      if(param(31).eq.0) return !param(31) is number of exponents
      
      tinitial = time

      call opzero(bfxp(1,jpp),bfyp(1,jpp),bfzp(1,jpp))

      itmp = lx1*ly1*lz1*lelv*(lorder-1)

      call rzero(vxlagp(1,1,jpp),itmp)
      call rzero(vylagp(1,1,jpp),itmp)
      if(if3d)   call rzero(vzlagp(1,1,jpp),itmp)
      if(ifheat) call rzero(tlagp (1,1,1,jpp),itmp*LdimT)

      call opzero(exx1p(1,jpp),exy1p(1,jpp),exz1p(1,jpp))
      call opzero(exx2p(1,jpp),exy2p(1,jpp),exz2p(1,jpp))

      pertvnorm = sqrt(rayc)*opnorm2(vxp(1,jpp),vyp(1,jpp),vzp(1,jpp))
      perttnorm = sqrt(pran*ray*ray)*tnorm(tp(1,1,jpp))
      pertnorm  = sqrt(pertvnorm**2+perttnorm**2)

      if(param(64).ne.1) then !fresh start, param(64) is restart flag
         call opzero(vxp(1,jpp),vyp(1,jpp),vzp(1,jpp))
         call rzero(tp(1,1,jpp),ntotv)
         call get_useric
         if_restart = .false.
         call rzero(lyap(1,jpp),3)
      else
         if(nio.eq.0) write(6,*)jpp,'norm of pert IC=',pertnorm
         if_restart  = .true.
         pertInvNorm = 1.0/pertNorm
         call rescalepert(pertnorm,pertinvnorm,jpp)
         if(nio.eq.0) write(6,*) jpp,'Rescaled the perturbation'
         call rzero(lyap(1,jpp),3)
         lyap(3,jpp) = pertnorm
      endif
c
      ifdebug=.false.

c     opening the lyp file in unit=79

      call blank(lypfile,132)
      call blank(lypfileold,132)
      call blank(lyprestart,132)
      call blank(lypsch,132)

      ls  = ltrunc(session,132)
      lpp = ltrunc(path,132)

      call chcopy(nam1(    1),path1,lpp)
      call chcopy(nam1(lpp+1),sess1,ls )
      l1 = lpp+ls+1
      ln = lpp+ls+4
         
      call chcopy(nam1  (l1),lyp , 4)
      call chcopy(lypfile    ,nam1,ln)

      lns = lpp+ls+5
      call chcopy(nam1 (l1),sch , 5)
      call chcopy(lypsch    ,nam1,lns)

      ln2 = lpp+ls+7
      call chcopy(nam1  (l1),lypold , 7)
      call chcopy(lypfileold    ,nam1,ln2)

      call chcopy(nam1  (l1),lypres , 7)
      call chcopy(lyprestart    ,nam1,ln2)

      if(nid.eq.0.and.jpp.eq.1) then
         write(6,*) 'opening file ',lypfile
         open(unit=79,file=lypfile,status='UNKNOWN')
         write(79,5757) ! put a header on the lyp file
5757     format(1x,"time",5x,"lyap",5x,"lyapsum",5x,"pertnorm",
     &          5x,"oldpertnorm")
 
         write(6,*) 'opening file ',lypsch
         open(unit=146,file=lypsch)
      endif
         
      if(if_restart) then
         if(nid.eq.0) then
            if (jpp.eq.1) then
               print*,'opening file ',lypfileold
               open(unit=86,file=lypfileold,status='OLD')
            endif
            read(86,*) tmp(1)    !lyapsum
            read(86,*) tmp(2)    !timeStart
            if (jpp.eq.npert) close(86)
         endif
         len = 4*wdsize
         call bcast(tmp,len)  !broadcast to all cpus
         lyapSum  =  tmp(1)
         timeStart = tmp(2)
         lyap(2,jpp) = lyapsum
         print*,'nid,lyapsum,timestart=',nid,lyapSum,timestart,jpp
         if(timeStart.gt.time) then
            write(6,*) nid,' reporting! timestart.gt.time! time=',time
            call exitt
         endif
      endif

      return
      end
c------------------------------------------------------------------------

      subroutine get_useric
c
      include 'SIZE'
      include 'TOTAL'
      include 'NEKUSE'
c
      integer e,eg
c
      do jp=1,npert
         l = 0
         do iel=1,nelv
            ielg = lglel(iel)     ! Global element number
            do k=1,lz1
            do j=1,ly1
            do i=1,lx1
               l = l+1
c              call set_nekuse (l)
               call nekasgnp (i,j,k,iel,l)
               call useric   (i,j,k,ielg)
               vxP(l,jp)   = ux
               vyP(l,jp)   = uy
               vzP(l,jp)   = uz
               tP (l,1,jp) = temp
            enddo
            enddo
            enddo
         enddo
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine out_pert  ! dump perturbation .fld files
c
      include 'SIZE'
      include 'TOTAL'
      include 'NEKUSE'
c
      character*3 s3
c
      do jpp=1,npert
         write(s3,3) jpp
 3       format('p',i2.2)
         call outpost2
     $     (vxp(1,jpp),vyp(1,jpp),vzp(1,jpp),prp(1,jpp),tp(1,1,jpp),
     $     1,s3)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine pert_add2s2(i,j,scale)   ! xi = xi + scale * xj
      include 'SIZE'
      include 'TOTAL'

      ntotp = lx2*ly2*lz2*nelv
      ntotv = lx1*ly1*lz1*nelv
      ntott = lx1*ly1*lz1*nelt

      call add2s2(vxp(1,i),vxp(1,j),scale,ntotv)
      call add2s2(vyp(1,i),vyp(1,j),scale,ntotv)
      if (if3d) call add2s2(vzp(1,i),vzp(1,j),scale,ntotv)
      call add2s2(prp(1,i),prp(1,j),scale,ntotp)

      do l=1,lorder-1
         call add2s2(vxlagp(1,l,i),vxlagp(1,l,j),scale,ntotv)
         call add2s2(vylagp(1,l,i),vylagp(1,l,j),scale,ntotv)
         if (if3d) call add2s2(vzlagp(1,l,i),vzlagp(1,l,j),scale,ntotv)
         call add2s2(prlagp(1,l,i),prlagp(1,l,j),scale,ntotp)
      enddo

      call add2s2(exx1p(1,i),exx1p(1,j),scale,ntotv)
      call add2s2(exy1p(1,i),exy1p(1,j),scale,ntotv)
      if (if3d) call add2s2(exz1p(1,i),exz1p(1,j),scale,ntotv)

      call add2s2(exx2p(1,i),exx2p(1,j),scale,ntotv)
      call add2s2(exy2p(1,i),exy2p(1,j),scale,ntotv)
      if (if3d) call add2s2(exz2p(1,i),exz2p(1,j),scale,ntotv)

      if (ifheat) then
        do k=0,npscal
          k1=k+1
          ntotk = lx1*ly1*lz1*nelfld(k+2)
          call add2s2(tp(1,k1,i),tp(1,k1,j),scale,ntotk)
          do l=1,lorder-1
            call add2s2(tlagp(1,l,k1,i),tlagp(1,l,k1,j),scale,ntotk)
          enddo
          call add2s2(vgradt1p(1,k1,i),vgradt1p(1,k1,j),scale,ntotk)
          call add2s2(vgradt2p(1,k1,i),vgradt2p(1,k1,j),scale,ntotk)
        enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      function pert_inner_prod(i,j) ! weighted inner product vi^T vj
      include 'SIZE'
      include 'TOTAL'

      common/normset/pran, ray, rayc

      ntotv=lx1*ly1*lz1*nelv
      ntott=lx1*ly1*lz1*nelt

      s1 = rayc*glsc3(vxp(1,i),bm1,vxp(1,j),ntotv)
      s2 = rayc*glsc3(vyp(1,i),bm1,vyp(1,j),ntotv)
      s3 = 0
      if (if3d) s3 = rayc*glsc3(vzp(1,i),bm1,vzp(1,j),ntotv)

      t1 = 0
      if (ifheat) t1=pran*ray*ray*glsc3(tp(1,1,i),bm1,tp(1,1,j),ntott)

      pert_inner_prod = (s1+s2+s3+t1)/volvm1

      return
      end
c-----------------------------------------------------------------------
      subroutine pert_ortho_norm ! orthogonalize and rescale pert. arrays
      include 'SIZE'
      include 'TOTAL'

      do k=1,npert
         call pert_ortho_norm1(k)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine pert_ortho_norm1 (k) ! orthogonalize k against 1...k-1
      include 'SIZE'
      include 'TOTAL'

      do j=1,k-1
         scale = -pert_inner_prod(j,k)
         call pert_add2s2(k,j,scale)   ! xi = xi + scale * xj
      enddo
      scale = pert_inner_prod(k,k)
      if (scale.gt.0) scale = 1./scale
      call rescalepert(pertnorm,scale,k)

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two-dimensional array computation:
!Two loops are associated with omp taskloop due to collapse(2).
!Both loop index variables are private.
!taskloop requires OpenMP 4.5 compilers. No data race pairs.

module DRB096
    implicit none
    integer, dimension(:,:), allocatable :: a
end module

program DRB096_doall2_taskloop_collapse_orig_no
    use omp_lib
    use DRB096
    implicit none

    integer :: len, i, j
    len = 100

    allocate (a(len,len))

    !$omp parallel
        !$omp single
            !$omp taskloop collapse(2)
            do i = 1, len
                do j = 1, len
                    a(i,j) = a(i,j)+1
                end do
            end do
            !$omp end taskloop
        !$omp end single
    !$omp end parallel

    print 100, a(50,50)
    100 format ('a(50,50) =',i3)

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

! *  loop missing the linear clause
! *  Data race pair:  j@36 vs. j@37


program DRB111_linearmissing_orig_yes
    use omp_lib
    implicit none

    integer len, i, j
    integer, parameter :: dp = kind(1.0d0)
    real(dp), dimension(:), allocatable :: a,b,c

    len = 100
    i = 0
    j = 0

    allocate (a(len))
    allocate (b(len))
    allocate (c(len))

    do i = 1, len
        a(i) = (real(i,dp))/2.0
        b(i) = (real(i,dp))/3.0
        c(i) = (real(i,dp))/7.0
    end do

    !$omp parallel do
    do i = 1, len
        c(j) = c(j)+a(i)*b(i)
        j = j+1
    end do
    !$omp end parallel do

    print*,'c(50) =',c(50)

    if(allocated(a))deallocate(a)
    if(allocated(b))deallocate(b)
   
end program

      SUBROUTINE SETAXW1 (IFAXWG)
C
      INCLUDE 'SIZE'
      INCLUDE 'WZ'
C
      LOGICAL IFAXWG
C
      IF (IFAXWG) THEN
         CALL COPY (W3M1,W2AM1,lx1*ly1)
      ELSE
         CALL COPY (W3M1,W2CM1,lx1*ly1)
      ENDIF
C
      RETURN
      END
      SUBROUTINE SETAXW2 (IFAXWG)
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'WZ'
C
      LOGICAL IFAXWG
C
      IF (IFAXWG) THEN
         CALL COPY (W3M2,W2AM2,lx2*ly2)
      ELSE
         CALL COPY (W3M2,W2CM2,lx2*ly2)
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE STNRINV
C
C     Calculate 2nd and 3rd strain-rate invariants
C
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      common /screv/ ei2(lx1,ly1,lz1,lelt)
     $             , ei3(lx1,ly1,lz1,lelt)
      common /ctmp1/ exx(lx1,ly1,lz1,lelt)
     $             , exy(lx1,ly1,lz1,lelt)
     $             , eyy(lx1,ly1,lz1,lelt)
     $             , ezz(lx1,ly1,lz1,lelt)
      common /ctmp0/ exz(lx1,ly1,lz1,lelt)
     $             , eyz(lx1,ly1,lz1,lelt)
c
      NTOT1  = lx1*ly1*lz1*NELV
      CALL RZERO (EI2,NTOT1)
      CALL RZERO (EI3,NTOT1)
      IF (ISTEP.EQ.0) RETURN
C
      MATMOD = 0
      CALL STNRATE (VX,VY,VZ,NELV,MATMOD)
C
      IF (ldim.EQ.2) THEN
          CALL COL3    (EI2,EXX,EYY,NTOT1)
          CALL SUBCOL3 (EI2,EXY,EXY,NTOT1)
          CALL RZERO   (EI3,NTOT1)
      ELSE
          CONST = 2.0
          CALL COL4    (EI3,EXX,EYY,EZZ,NTOT1)          
          CALL COL4    (EI2,EXY,EXZ,EYZ,NTOT1)
          CALL ADD2S2  (EI3,EI2,CONST,NTOT1)
          CALL SUBCOL4 (EI3,EXX,EYZ,EYZ,NTOT1)
          CALL SUBCOL4 (EI3,EYY,EXZ,EXZ,NTOT1)
          CALL SUBCOL4 (EI3,EZZ,EXY,EXY,NTOT1)
          CALL COL3    (EI2,EXX,EYY,NTOT1)
          CALL ADDCOL3 (EI2,EXX,EZZ,NTOT1)
          CALL ADDCOL3 (EI2,EYY,EZZ,NTOT1)
          CALL SUBCOL3 (EI2,EXY,EXY,NTOT1)
          CALL SUBCOL3 (EI2,EXZ,EXZ,NTOT1)
          CALL SUBCOL3 (EI2,EYZ,EYZ,NTOT1)
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OPDOT (DP,A1,A2,A3,B1,B2,B3,N)
C
      INCLUDE 'SIZE'
C
      DIMENSION DP(LX1,LY1,LZ1,1)
     $        , A1(LX1,LY1,LZ1,1)
     $        , A2(LX1,LY1,LZ1,1)
     $        , A3(LX1,LY1,LZ1,1)
     $        , B1(LX1,LY1,LZ1,1)
     $        , B2(LX1,LY1,LZ1,1)
     $        , B3(LX1,LY1,LZ1,1)
C
      IF (ldim.EQ.2) THEN
         CALL VDOT2 (DP,A1,A2,B1,B2,N)
      ELSE
         CALL VDOT3 (DP,A1,A2,A3,B1,B2,B3,N)
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OPADDS (A1,A2,A3,B1,B2,B3,CONST,N,ISC)
C
      INCLUDE 'SIZE'
C
      DIMENSION A1(LX1,LY1,LZ1,1)
     $        , A2(LX1,LY1,LZ1,1)
     $        , A3(LX1,LY1,LZ1,1)
     $        , B1(LX1,LY1,LZ1,1)
     $        , B2(LX1,LY1,LZ1,1)
     $        , B3(LX1,LY1,LZ1,1)
C
      IF (ISC.EQ.1) THEN
         CALL ADD2S1 (A1,B1,CONST,N)
         CALL ADD2S1 (A2,B2,CONST,N)
         IF (ldim.EQ.3) CALL ADD2S1 (A3,B3,CONST,N)
      ELSEIF (ISC.EQ.2) THEN
         CALL ADD2S2 (A1,B1,CONST,N)
         CALL ADD2S2 (A2,B2,CONST,N)
         IF (ldim.EQ.3) CALL ADD2S2 (A3,B3,CONST,N)
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FACEXS (A,B,IFACE1,IOP)
C
C     IOP = 0
C     Extract scalar A from B on face IFACE1.
C
C     IOP = 1
C     Extract scalar B from A on face IFACE1.
C
C     A has the (NX,NY,NFACE) data structure
C     B has the (NX,NY,NZ)    data structure
C     IFACE1 is in the preprocessor notation 
C     IFACE  is the dssum notation.
C
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
C
      DIMENSION A(LX1,LY1),B(LX1,LY1,LZ1)
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      I = 0
      IF (IOP.EQ.0) THEN
         DO 100 J2=JS2,JF2,JSKIP2
         DO 100 J1=JS1,JF1,JSKIP1
            I = I+1
            A(I,1) = B(J1,J2,1)
  100    CONTINUE
      ELSE
         DO 150 J2=JS2,JF2,JSKIP2
         DO 150 J1=JS1,JF1,JSKIP1
            I = I+1
            B(J1,J2,1) = A(I,1)
  150    CONTINUE
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FACEXV (A1,A2,A3,B1,B2,B3,IFACE1,IOP)
C
C     IOP = 0
C     Extract vector (A1,A2,A3) from (B1,B2,B3) on face IFACE1.
C
C     IOP = 1
C     Extract vector (B1,B2,B3) from (A1,A2,A3) on face IFACE1.
C
C     A1, A2, A3 have the (NX,NY,NFACE) data structure
C     B1, B2, B3 have the (NX,NY,NZ)    data structure
C     IFACE1 is in the preprocessor notation 
C     IFACE  is the dssum notation.
C
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
C
      DIMENSION A1(LX1,LY1),A2(LX1,LY1),A3(LX1,LY1),
     $          B1(LX1,LY1,LZ1),B2(LX1,LY1,LZ1),B3(LX1,LY1,LZ1)
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
      I = 0
C
      IF (IOP.EQ.0) THEN
         DO 100 J2=JS2,JF2,JSKIP2
         DO 100 J1=JS1,JF1,JSKIP1
            I = I+1
            A1(I,1) = B1(J1,J2,1)
            A2(I,1) = B2(J1,J2,1)
            A3(I,1) = B3(J1,J2,1)
  100    CONTINUE
      ELSE
         DO 150 J2=JS2,JF2,JSKIP2
         DO 150 J1=JS1,JF1,JSKIP1
            I = I+1
            B1(J1,J2,1) = A1(I,1)
            B2(J1,J2,1) = A2(I,1)
            B3(J1,J2,1) = A3(I,1)
  150    CONTINUE
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FACSUB2 (A1,A2,A3,B1,B2,B3,IFACE1)
C
C     Subtract B1,B2,B3 from A1,A2,A3 on surface IFACE1 of element IE.
C
C     A1, A2, A3 have the (NX,NY,NZ)    data structure
C     B1, B2, B3 have the (NX,NY,NFACE) data structure
C     IFACE1 is in the preprocessor notation 
C     IFACE  is the dssum notation.
C
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
C
      DIMENSION A1(LX1,LY1,LZ1),A2(LX1,LY1,LZ1),A3(LX1,LY1,LZ1),
     $          B1(LX1,LY1),B2(LX1,LY1),B3(LX1,LY1)
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      I = 0
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         I = I+1
         A1(J1,J2,1) = A1(J1,J2,1) - B1(I,1)
         A2(J1,J2,1) = A2(J1,J2,1) - B2(I,1)
         A3(J1,J2,1) = A3(J1,J2,1) - B3(I,1)
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE GAMMASF (H1,H2)
C-----------------------------------------------------------------------
C
C     Compute lagrest eigenvalue of coupled Helmholtz operator
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'EIGEN'
      INCLUDE 'INPUT'
      INCLUDE 'MASS'
      INCLUDE 'MVGEOM'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      INCLUDE 'WZ'
      common /scrmg/ ae1(lx1,ly1,lz1,lelv)
     $             , ae2(lx1,ly1,lz1,lelv)
     $             , ae3(lx1,ly1,lz1,lelv)
      common /scruz/ e1(lx1,ly1,lz1,lelv)
     $             , e2(lx1,ly1,lz1,lelv)
     $             , e3(lx1,ly1,lz1,lelv)
C
      DIMENSION H1(LX1,LY1,LZ1,1),H2(LX1,LY1,LZ1,1)
C
      NTOT1  = lx1*ly1*lz1*NELV
      IMESH  = 1
      MATMOD = 0
C
      IF (ISTEP.EQ.0) THEN
         EIGGA = 0.0
         CALL STX1SF
      ELSE
         CALL COPY (E1,EV1,NTOT1)
         CALL COPY (E2,EV2,NTOT1)
         IF (ldim.EQ.3) CALL COPY (E3,EV3,NTOT1)
      ENDIF
C
      EVNEW = EIGGA
C
      DO 1000 ITER=1,NMXE
C
      CALL AXHMSF  (AE1,AE2,AE3,E1,E2,E3,H1,H2,MATMOD)
      CALL RMASK   (AE1,AE2,AE3,NELV)
      CALL OPDSSUM (AE1,AE2,AE3)
C
      EVOLD = EVNEW
      EVNEW = GLSC3(E1,AE1,VMULT,NTOT1) + GLSC3(E2,AE2,VMULT,NTOT1)
      IF (ldim.EQ.3) EVNEW = EVNEW + GLSC3(E3,AE3,VMULT,NTOT1)
      CRIT = ABS( (EVNEW - EVOLD)/EVNEW )
      IF ( CRIT .LT. TOLEV ) GOTO 2000
C
      CALL COL3 (E1,BINVM1,AE1,NTOT1)
      CALL COL3 (E2,BINVM1,AE2,NTOT1)
      IF (ldim.EQ.3) CALL COL3 (E3,BINVM1,AE3,NTOT1)
      XX = GLSC3(E1,AE1,VMULT,NTOT1) + GLSC3(E2,AE2,VMULT,NTOT1)
      IF (ldim.EQ.3) XX = XX + GLSC3(E3,AE3,VMULT,NTOT1)
      IF (XX .LT. 0.0) GO TO 9000
C
      XNORM=1./SQRT( XX )
      CALL CMULT (E1,XNORM,NTOT1)
      CALL CMULT (E2,XNORM,NTOT1)
      IF (ldim.EQ.3) CALL CMULT (E3,XNORM,NTOT1)
C
 1000 CONTINUE
C
C     Save eigenvalue for all cases.
C     Save eigenvectors for deforming geometries.
C
 2000 EIGGA = EVNEW
      IF (IFMVBD) THEN
         CALL COPY (EV1,E1,NTOT1)
         CALL COPY (EV2,E2,NTOT1)
         IF (ldim.EQ.3) CALL COPY (EV3,E3,NTOT1)
      ENDIF
C
      RETURN
C
 9000 CONTINUE
      IF (NID.EQ.0) 
     $WRITE ( 6,*) ' Non +ve def. A-operator detected during eigenvalue 
     $computation : tran(x)Ax =',XX
      CALL EMERXIT
      call exitt
C
      END
C-----------------------------------------------------------------------
      SUBROUTINE CMULT2 (A,B,CONST,N)
      DIMENSION A(1),B(1)
      DO 100 I=1,N
         A(I)=B(I)*CONST
 100  CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE ADD3S (A,B,C,CONST,N)
      DIMENSION A(1),B(1),C(1)
      DO 100 I=1,N
        A(I)=B(I)+CONST*C(I)
  100 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EMERXIT
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      INCLUDE 'PARALLEL'
C
C     Try to hang in there on the first few time steps (pff 8/92)
      IF (IFTRAN.AND.ISTEP.LT.9) RETURN
C
      LASTEP = 1
      CALL PREPOST(.true.,'   ')
C
      IF (NP.EQ.1) THEN
         WRITE (6,*) '       '
         WRITE (6,*) 
     $   ' Emergency exit:',ISTEP,'   time =',TIME
         WRITE (6,*) 
     $   ' Latest solution and data are dumped for post-processing.'
         WRITE (6,*) ' *** STOP ***'
      ELSE
         WRITE (6,*) '       '
         WRITE (6,*) NID,
     $   ' Emergency exit:',ISTEP,'   time =',TIME
         WRITE (6,*) 
     $   ' Latest solution and data are dumped for post-processing.'
         WRITE (6,*) ' *** STOP ***'
      ENDIF
C
      call runstat
c
      call exitt
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FACCVS (A1,A2,A3,B,IFACE1)
C
C     Collocate scalar B with vector A, components A1,A2,A3,
C     on the surface IFACE1 of an element.
C
C         A1,A2,A3 have the (NX,NY,NZ) data structure
C         B has the (NX,NY,IFACE) data structure
C         IFACE1 is in the preprocessor notation 
C         IFACE  is the dssum notation.
C
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
      DIMENSION A1(LX1,LY1,LZ1),A2(LX1,LY1,LZ1),A3(LX1,LY1,LZ1),
     $          B(LX1,LY1)
C
C     Set up counters
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
      I = 0
C
      IF (ldim.EQ.2) THEN    
         DO 100 J2=JS2,JF2,JSKIP2
         DO 100 J1=JS1,JF1,JSKIP1
            I = I+1
            A1(J1,J2,1) = A1(J1,J2,1)*B(I,1)
            A2(J1,J2,1) = A2(J1,J2,1)*B(I,1)
  100    CONTINUE
      ELSE
         DO 200 J2=JS2,JF2,JSKIP2
         DO 200 J1=JS1,JF1,JSKIP1
            I = I+1
            A1(J1,J2,1) = A1(J1,J2,1)*B(I,1)
            A2(J1,J2,1) = A2(J1,J2,1)*B(I,1)
            A3(J1,J2,1) = A3(J1,J2,1)*B(I,1)
  200    CONTINUE
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE STX1SF
C------------------------------------------------------------------
C
C     Compute startvector for finding an eigenvalue on mesh 1.
C     Normalization: XT*B*X = 1
C
C------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'SOLN'
      common /scrmg/ ae1(lx1,ly1,lz1,lelv)
     $             , ae2(lx1,ly1,lz1,lelv)
     $             , ae3(lx1,ly1,lz1,lelv)
      common /scruz/ e1(lx1,ly1,lz1,lelv)
     $             , e2(lx1,ly1,lz1,lelv)
     $             , e3(lx1,ly1,lz1,lelv)
C
      NTOT1 = lx1*ly1*lz1*NELV
      CALL RZERO3 (E1 ,E2 ,E3 ,NTOT1)
      CALL RZERO3 (AE1,AE2,AE3,NTOT1)
C
      CALL COPY  (E1,BM1,NTOT1)
      CALL COPY  (E2,BM1,NTOT1)
      IF (ldim.EQ.3) CALL COPY  (E3,BM1,NTOT1)
C
      CALL RMASK (E1,E2,E3,NELV)
      CALL COL3  (AE1,BM1,E1,NTOT1)
      CALL COL3  (AE2,BM1,E2,NTOT1)
      IF (ldim.EQ.3) CALL COL3  (AE3,BM1,E3,NTOT1)
C
      CALL OPDSSUM (AE1,AE2,AE3)
C
      XX = GLSC3 (E1,AE1,VMULT,NTOT1) + GLSC3 (E2,AE2,VMULT,NTOT1)
      IF (ldim.EQ.3) XX = XX + GLSC3 (E3,AE3,VMULT,NTOT1)      
      XNORM  = 1./SQRT(XX)
      CALL CMULT (E1,XNORM,NTOT1)
      CALL CMULT (E2,XNORM,NTOT1)
      IF (ldim.EQ.3) CALL CMULT (E3,XNORM,NTOT1)

c     call exitti   ('quit in stx1sf$,',nel)

C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SOLVEL
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
C
      DO 100 IEL=1,NELV
      DO 100 K=1,lz1
      DO 100 J=1,ly1
      DO 100 I=1,lx1
         CALL VSOLN (VX (I,J,K,IEL),VY (I,J,K,IEL),VZ (I,J,K,IEL),
     $               XM1(I,J,K,IEL),YM1(I,J,K,IEL),ZM1(I,J,K,IEL),PI)
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE VSOLN (UX,UY,UZ,X,Y,Z,PI)
C                                                                               
C       URR=(1.-0.75/SQRT(X**2+Y**2)+0.0625/(SQRT(X**2+Y**2)**3))*(X/
C     $     SQRT(X**2+Y**2))
C       UTETA=-(1.-0.375/SQRT(X**2+Y**2)-0.03125/(SQRT(X**2+Y**2)**3))*
C     $       (Y/SQRT(X**2+Y**2))
C       UX=URR*(X/SQRT(X**2+Y**2))-UTETA*(Y/SQRT(X**2+Y**2))
C       UY=URR*(Y/SQRT(X**2+Y**2))+UTETA*(X/SQRT(X**2+Y**2))
C
C       UX = 2.*COS( PI*X )
C       UY = PI*Y*SIN( PI*X )
C
        UX = 0.0
        UY = 0.0
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SOLPRES
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
C
      DO 100 IEL=1,NELV
      DO 100 K=1,lz2
      DO 100 J=1,ly2
      DO 100 I=1,lx2
         CALL PRSOLN (PR (I,J,K,IEL),XM2(I,J,K,IEL),YM2(I,J,K,IEL),
     *                ZM2(I,J,K,IEL),PI)
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PRSOLN (P,X,Y,Z,PI)
C                                                                               
C      R  = SQRT( X**2 + Y**2 )
C      CS = X/R
C      P  = -0.75 * CS / R**2
C
C      P  = -SIN( PI*X )*COS( PI*Y )
C
      P = 0.0
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PRINTEL (TA,A,IEL)
C
      INCLUDE 'SIZE'
      DIMENSION TA(LX1,LY1,LZ1,LELT)
      CHARACTER A*10
C
      lz1I   =  1
      lz1J   = lz1
      lz1INC =  1
C
      WRITE (21,*) 'ELEMENT NUMBER ',IEL
      DO 101 IPL=lz1I,lz1J,lz1INC
         CALL OUTM1 (TA,A,lz1,IEL,IPL)
 101  CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PRINTV (TA,A,NEL)
C-----------------------------------------------------------------------
C
C     Store the results
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      DIMENSION TA(LX1,LY1,LZ1,LELT)
      CHARACTER A*10
C
      lz1I   =  1
      lz1J   = lz1
      lz1INC =  1
C
      DO 9001 IEL = 1,NEL
         WRITE (21,*) 'ELEMENT NUMBER ',IEL
         DO 101 IPL=lz1I,lz1J,lz1INC
            CALL OUTM1 (TA,A,lz1,IEL,IPL)
 101     CONTINUE
 9001 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OUTF1 (X,TXT,IEL,IFC)
      INCLUDE 'SIZE'
      DIMENSION X(LX1,LZ1,6,LELT)
      CHARACTER*10 TXT
C
         NFACE = 2*ldim
         NZI   = lz1
         NZJ   =  1
         NZINC = -1
         NXI   =  1
         NXJ   = lx1
         NXINC =  1
C
         WRITE(21,106) TXT,IFC,NFACE
         DO 100 J=NZI,NZJ,NZINC
         WRITE(21,105) (X(I,J,IFC,IEL),I=NXI,NXJ,NXINC)
  100    CONTINUE
C
  105 FORMAT(5E15.6)
  106 FORMAT(///,5X,'     ^              ',/,
     $           5X,'   S |              ',/,
     $           5X,'     |              ',A10,/,
     $           5X,'     +---->         ','Plane = ',I2,'/',I2,/,
     $           5X,'       R            ',/)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OUTM1 (X,TXT,NP,IEL,IP)
      INCLUDE 'SIZE'
      DIMENSION X(LX1,LY1,LZ1,LELT)
      CHARACTER*10 TXT
C
         NYI   = ly1
         NYJ   =  1
         NYINC = -1
         NXI   =  1
         NXJ   = lx1
         NXINC =  1
C
         WRITE(6,106) TXT,IP,NP
         DO 100 J=NYI,NYJ,NYINC
         WRITE(6,105) (X(I,J,IP,IEL),I=NXI,NXJ,NXINC)
  100    CONTINUE
C
c 105 FORMAT(1p8e10.3)
  105 FORMAT(8f10.3)
  106 FORMAT(///,5X,'     ^              ',/,
     $           5X,'   Y |              ',/,
     $           5X,'     |              ',A10,/,
     $           5X,'     +---->         ','Plane = ',I2,'/',I2,/,
     $           5X,'       X            ',/)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OUTM2 (X,TXT,NP,IEL,IP)
      INCLUDE 'SIZE'
      DIMENSION X(LX2,LY2,LZ2,LELV)
      CHARACTER*10 TXT
C
         NYI   = ly2
         NYJ   =  1
         NYINC = -1
         NXI   =  1
         NXJ   = lx2
         NXINC =  1
C
         WRITE(21,106) TXT,IP,NP
         DO 100 J=NYI,NYJ,NYINC
         WRITE(21,105) (X(I,J,IP,IEL),I=NXI,NXJ,NXINC)
  100    CONTINUE
C
  105 FORMAT(5E15.6)
  106 FORMAT(///,5X,'     ^              ',/,
     $           5X,'   Y |              ',/,
     $           5X,'     |              ',A10,/,
     $           5X,'     +---->         ','Plane = ',I2,'/',I2,/,
     $           5X,'       X            ',/)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE STSMASK (C1MASK,C2MASK,C3MASK)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      include 'INPUT'
      common /screv/ hfmask(lx1,lz1,6,lelt)
     $             , hvmask(lx1,ly1,lz1,lelt)
C
      DIMENSION C1MASK(LX1,LY1,LZ1,1)
     $        , C2MASK(LX1,LY1,LZ1,1)
     $        , C3MASK(LX1,LY1,LZ1,1)
      INTEGER   IMDATA
      SAVE      IMDATA
      DATA      IMDATA /0/
C
      IFLD = IFIELD
      NEL  = NELFLD(IFIELD)
C
      IF (IMDATA.EQ.0) THEN
          CALL SETCDAT
          IMDATA=1
      ENDIF
C
      IF (IFLD.EQ.1) CALL SKIPCNR (NEL)
      CALL SETHMSK (HVMASK,HFMASK,IFLD,NEL)
      CALL SETMLOG (HVMASK,HFMASK,IFLD,NEL)
      CALL SETMASK (C1MASK,C2MASK,C3MASK,HVMASK,NEL)
      IF (IFLMSF(IFLD)) CALL SETCSYS (HVMASK,HFMASK,NEL)
      IF (IFLD.EQ.0)    CALL FIXWMSK (C2MASK,C3MASK,HVMASK,HFMASK,NEL)

      if (ifaxis.and.ifld.eq.1)  call fixmska (c1mask,c2mask,c3mask)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE UPDMSYS (IFLD)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      common /screv/ hfmask(lx1,lz1,6,lelt)
     $             , hvmask(lx1,ly1,lz1,lelt)
C
      IF (.NOT.IFLMSF(IFLD)) RETURN
C
      NEL  = NELFLD(IFLD)
      CALL SETHMSK (HVMASK,HFMASK,IFLD,NEL)
      CALL SETCSYS (HVMASK,HFMASK,NEL)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SETHMSK (HVMASK,HFMASK,IFLD,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
C
      DIMENSION HVMASK(LX1,LY1,LZ1,1)
     $        , HFMASK(LX1,LZ1,6,1)
      CHARACTER CB*3
C
      NTOT1 = lx1*ly1*lz1*NEL
      NXZ1  = lx1*lz1
      NTOTF = NXZ1*6*NEL
      NFACE = 2*ldim
      CONST = 5.0
      CALL CFILL (HVMASK,CONST,NTOT1)
      CALL CFILL (HFMASK,CONST,NTOTF)
C
      IF (IFLD.EQ.1) THEN
C
      DO 110 IEL=1,NEL
      DO 110 IFC=1,NFACE
         CB=CBC(IFC,IEL,IFLD)
         IF (CB.EQ.'ON ' .OR. CB.EQ.'on ' .or.
     $       CB.EQ.'MM ' .OR. CB.EQ.'mm ' ) THEN
             CALL FACEV (HVMASK,IEL,IFC,3.0,lx1,ly1,lz1)
             CALL CFILL (HFMASK(1,1,IFC,IEL),3.0,NXZ1)
         ENDIF
  110 CONTINUE
C
      DO 120 IEL=1,NEL
      DO 120 IFC=1,NFACE
         CB=CBC(IFC,IEL,IFLD)
         IF (CB.EQ.'SYM' .OR. CB.EQ.'A  ' .OR. CB.EQ.'WS ' .OR.
     $       CB.EQ.'ws ' .OR. CB.EQ.'WSL' .OR. CB.EQ.'wsl' .OR. 
     $       CB.EQ.'SH ' .OR. CB.EQ.'sh ' .OR. CB.EQ.'SHL' .OR. 
     $       CB.EQ.'shl')                                  THEN
             CALL FACEV (HVMASK,IEL,IFC,2.0,lx1,ly1,lz1)
             CALL CFILL (HFMASK(1,1,IFC,IEL),2.0,NXZ1)
         ENDIF
  120 CONTINUE
C
      DO 130 IEL=1,NEL
      DO 130 IFC=1,NFACE
         CB=CBC(IFC,IEL,IFLD)
         IF (CB.EQ.'MF ' .OR. CB.EQ.'V  ' .OR. CB.EQ.'v  ' .OR.
     $       CB.EQ.'VL ' .OR. CB.EQ.'vl ' .OR. CB(1:2).EQ.'mv') THEN
             CALL FACEV (HVMASK,IEL,IFC,1.0,lx1,ly1,lz1)
             CALL CFILL (HFMASK(1,1,IFC,IEL),1.0,NXZ1)
         ENDIF
  130 CONTINUE
C
      DO 140 IEL=1,NEL
      DO 140 IFC=1,NFACE
         CB=CBC(IFC,IEL,IFLD)
         IF (CB.EQ.'W  ') THEN
             CALL FACEV (HVMASK,IEL,IFC,0.0,lx1,ly1,lz1)
             CALL CFILL (HFMASK(1,1,IFC,IEL),0.0,NXZ1)
         ENDIF
  140 CONTINUE
C
      ELSE
C
      DO 210 IEL=1,NEL
      DO 210 IFC=1,NFACE
         CB=CBC(IFC,IEL,IFLD)
         IF (CB.EQ.'SYM') THEN
             CALL FACEV (HVMASK,IEL,IFC,2.0,lx1,ly1,lz1)
             CALL CFILL (HFMASK(1,1,IFC,IEL),2.0,NXZ1)
         ENDIF
  210 CONTINUE
C
c     write(6,*) 'MASK this is ifield:',ifield
      DO 220 IEL=1,NEL
      DO 220 IFC=1,NFACE
         CB=CBC(IFC,IEL,IFLD)
         IF (CB(1:1).EQ.'M' .OR. CB(1:1).EQ.'m') THEN
c            CALL FACEV (HVMASK,IEL,IFC,1.0,lx1,ly1,lz1)
c            CALL CFILL (HFMASK(1,1,IFC,IEL),1.0,NXZ1)
             CALL FACEV (HVMASK,IEL,IFC,2.0,lx1,ly1,lz1)
             CALL CFILL (HFMASK(1,1,IFC,IEL),2.0,NXZ1)
         ENDIF
  220 CONTINUE
C
      DO 230 IEL=1,NEL
      DO 230 IFC=1,NFACE
         CB=CBC(IFC,IEL,IFLD)
         IF (CB.EQ.'FIX') THEN
             CALL FACEV (HVMASK,IEL,IFC,0.0,lx1,ly1,lz1)
             CALL CFILL (HFMASK(1,1,IFC,IEL),0.0,NXZ1)
         ENDIF
  230 CONTINUE
C
      ENDIF
C
      CALL DSOP (HVMASK,'MNA',lx1,ly1,lz1)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SKIPCNR (NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      NFACE = 2*ldim
      NCRFC = NFACE - 2
      NMXCR = 8*NEL
      CALL LFALSE (IFNSKP,NMXCR)
C
      DO 100 IEL=1,NEL
      DO 100 IFC=1,NFACE
         IF (CDOF(IFC,IEL).EQ.'1') THEN
             ICR=MCRFC(1,IFC)
             IFNSKP(ICR,IEL)=.TRUE.
         ELSEIF (CDOF(IFC,IEL).EQ.'2') THEN
             ICR=MCRFC(2,IFC)
             IFNSKP(ICR,IEL)=.TRUE.
         ELSEIF (CDOF(IFC,IEL).EQ.'3') THEN
             ICR=MCRFC(3,IFC)
             IFNSKP(ICR,IEL)=.TRUE.
         ELSEIF (CDOF(IFC,IEL).EQ.'4') THEN
             ICR=MCRFC(4,IFC)
             IFNSKP(ICR,IEL)=.TRUE.
         ENDIF
         IF (CDOF(IFC,IEL).EQ.'*') THEN
         DO 160 ICRFC=1,NCRFC
            ICR=MCRFC(ICRFC,IFC)
            IFNSKP(ICR,IEL)=.TRUE.
  160    CONTINUE
         ENDIF
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SETMASK (C1MASK,C2MASK,C3MASK,HVMASK,NEL) 
C 
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL' !XXXXX
C
      DIMENSION HVMASK (LX1,LY1,LZ1,1)
     $        , C1MASK(LX1,LY1,LZ1,1)
     $        , C2MASK(LX1,LY1,LZ1,1)
     $        , C3MASK(LX1,LY1,LZ1,1)
C
      NTOT1 = lx1*ly1*lz1*NEL
      CALL RZERO3  (C1MASK,C2MASK,C3MASK,NTOT1)
C
      DO 100 IEL=1,NEL
      DO 100 IZ=1,lz1
      DO 100 IY=1,ly1
      DO 100 IX=1,lx1
         HMV=ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .GT. 2.9) THEN
             C1MASK(IX,IY,IZ,IEL) = 1.0
         ENDIF
         IF ((HMV.GT.1.9 .AND. HMV.LT.2.1) .OR. HMV.GT.4.9) THEN
             C2MASK(IX,IY,IZ,IEL) = 1.0
         ENDIF
  100 CONTINUE
C
      IF (ldim.EQ.3) CALL COPY (C3MASK,C2MASK,NTOT1)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SETMLOG (HVMASK,HFMASK,IFLD,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      DIMENSION HVMASK(LX1,LY1,LZ1,1)
     $        , HFMASK(LX1,LZ1,6,1)
C
      NFACE = 2*ldim
      NEDGE = 12
      NCRNR = 2**ldim
      NTOTF = NFACE*NEL
      NTOTS = NEDGE*NEL
      NTOTC = NCRNR*NEL
      EPSA  = 1.E-6
C
      IFLMSF(IFLD) = .FALSE.
      IFLMSE(IFLD) = .FALSE.
      IFLMSC(IFLD) = .FALSE.
      CALL LFALSE (IFMSFC(1,1,IFLD),NTOTF)
      CALL LFALSE (IFMSEG(1,1,IFLD),NTOTS)
      CALL LFALSE (IFMSCR(1,1,IFLD),NTOTC)
C
      DO 100 IEL=1,NEL
      DO 100 IFC=1,NFACE
         HMF = ABS( HFMASK(1,1,IFC,IEL) )
         IF (HMF .GT. 1.9  .AND. HMF .LT. 3.1 ) THEN
             IFLMSF(IFLD)         = .TRUE.
             IFMSFC(IFC,IEL,IFLD) = .TRUE.
         ENDIF
 100  CONTINUE
      CALL GLLOG(IFLMSF(IFLD),.TRUE.)
C
      IF (ldim.EQ.3) THEN
         DO 200 IEL=1,NEL
         DO 200 ISD=1,NEDGE
            IX  = MIDRST(1,ISD)
            IY  = MIDRST(2,ISD)
            IZ  = MIDRST(3,ISD)
            HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
            IF (HMV .LT. 1.9  .OR.  HMV .GT. 3.1) GOTO 200
            IDIFF = 0
            DO 220 II=1,2
               IFC = MFCEG(II,ISD)
               HMF = ABS( HFMASK(1,1,IFC,IEL) )
               IF (ABS(HMV - HMF) .GT. EPSA) IDIFF=IDIFF + 1
 220        CONTINUE
            IF (IDIFF.EQ.2) THEN
               IFLMSE(IFLD)         = .TRUE.
               IFMSEG(ISD,IEL,IFLD) = .TRUE.
            ENDIF
 200     CONTINUE
         CALL GLLOG(IFLMSE(IFLD),.TRUE.)
      ENDIF
C
      DO 300 IEL=1,NEL
      DO 300 ICR=1,NCRNR
         IX  = MCRRST(1,ICR)
         IY  = MCRRST(2,ICR)
         IZ  = MCRRST(3,ICR)
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR.  HMV .GT. 3.1) GOTO 300
         IDIFF = 0
         DO 330 II=1,ldim
            IFC = MFCCR(II,ICR)
            HMF = ABS( HFMASK(1,1,IFC,IEL) )
            IF (ABS(HMV - HMF) .GT. EPSA) IDIFF=IDIFF + 1
 330     CONTINUE
         IF (ldim.EQ.3) THEN
            DO 360 II=1,ldim
               ISD = MEGCR(II,ICR)
               IXS = MIDRST(1,ISD)
               IYS = MIDRST(2,ISD)
               IZS = MIDRST(3,ISD)
               HMS = ABS( HVMASK(IXS,IYS,IZS,IEL) )
               IF (ABS(HMV - HMS) .GT. EPSA) IDIFF=IDIFF + 1
 360        CONTINUE
         ENDIF
         IF ( (ldim.EQ.2 .AND. IDIFF.EQ.2)   .OR.
     $        (ldim.EQ.3 .AND. IDIFF.EQ.6) ) THEN
              IFLMSC(IFLD)         = .TRUE.
              IFMSCR(ICR,IEL,IFLD) = .TRUE.
         ENDIF
 300  CONTINUE
      CALL GLLOG(IFLMSC(IFLD),.TRUE.)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SETCSYS (HVMASK,HFMASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      DIMENSION HVMASK(LX1,LY1,LZ1,1)
     $        , HFMASK(LX1,LZ1,6,1)
C
      NFACE  = 2*ldim
      NTOT1  = lx1*ly1*lz1*NEL
C
      CALL RZERO3  (VNX,VNY,VNZ,NTOT1)
      CALL RZERO3  (V1X,V1Y,V1Z,NTOT1)
      CALL RZERO3  (V2X,V2Y,V2Z,NTOT1)
C
      DO 10 IEL=1,NEL
      DO 10 IFC=1,NFACE
         HMF = ABS( HFMASK(1,1,IFC,IEL) )
         IF (HMF .GT. 1.9  .AND.  HMF .LT. 3.1)
     $   CALL FACEXV(UNX(1,1,IFC,IEL),UNY(1,1,IFC,IEL),UNZ(1,1,IFC,IEL),
     $               VNX(1,1,1,IEL),VNY(1,1,1,IEL),VNZ(1,1,1,IEL),IFC,1)
   10 CONTINUE
C
      IF (ldim.EQ.2) THEN
          CALL COMAVN2 (HVMASK,HFMASK,NEL)
      ELSE
          CALL COMAVN3 (HVMASK,HFMASK,NEL)
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE COMAVN2 (HVMASK,HFMASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      DIMENSION HVMASK(LX1,LY1,LZ1,1)
     $        , HFMASK(LX1,LZ1,6,1)
C
      NTOT1  = lx1*ly1*lz1*NEL
      NFACE  = 2*ldim
      NCRNR  = 2**ldim
      EPSA   = 1.0E-06
      CALL RZERO (VNZ,NTOT1)
C
      IZ = 1
      DO 100 IEL=1,NEL
      DO 100 ICR=1,NCRNR
         IX  = MCRRST(1,ICR)
         IY  = MCRRST(2,ICR)           
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR. HMV .GT. 3.1) GOTO 100
         VNX(IX,IY,IZ,IEL) = 0.0
         VNY(IX,IY,IZ,IEL) = 0.0
  100 CONTINUE
C
      DO 200 IEL=1,NEL
      DO 200 ICR=1,NCRNR
         IF (IFNSKP(ICR,IEL)) GOTO 200
         IX  = MCRRST(1,ICR)           
         IY  = MCRRST(2,ICR)           
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR. HMV .GT. 3.1) GOTO 200
         DO 220 II=1,2
            IFC = MFCCR(II,ICR)
            HMF = ABS( HFMASK(1,1,IFC,IEL) )
            IF (ABS(HMV - HMF) .LT. EPSA) THEN
               IR = MCRRST(II,ICR)
               VNX(IX,IY,IZ,IEL)=VNX(IX,IY,IZ,IEL) + UNX(IR,IZ,IFC,IEL)
               VNY(IX,IY,IZ,IEL)=VNY(IX,IY,IZ,IEL) + UNY(IR,IZ,IFC,IEL)
            ENDIF
  220    CONTINUE
  200 CONTINUE
C
      CALL DSSUM   (VNX,lx1,ly1,lz1)
      CALL DSSUM   (VNY,lx1,ly1,lz1)
      CALL UNITVEC (VNX,VNY,VNZ,NTOT1)
C
      CALL COPY   (V1Y,VNX,NTOT1)
      CALL COPY   (V1X,VNY,NTOT1)
      CALL CHSIGN (V1X,NTOT1)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE COMAVN3 (HVMASK,HFMASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      common /scrcg/  vnmag(lx1,ly1,lz1,lelt)
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      DIMENSION HVMASK(LX1,LY1,LZ1,1)
     $        , HFMASK(LX1,LZ1,6,1)
C
      NTOT1  = lx1*ly1*lz1*NEL
      NFACE  = 2*ldim
      NCRNR  = 2**ldim
      NEDGE  = 12
      NMID   =(lx1 + 1)/2
      NXM1   = lx1 - 1
      EPSA   = 1.0E-06
      EPSN   = 1.0E-03
C
      DO 100 IEL=1,NEL
      DO 100 ISD=1,NEDGE
         IX  = MIDRST(1,ISD)
         IY  = MIDRST(2,ISD)
         IZ  = MIDRST(3,ISD)
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR. HMV .GT. 3.1) GOTO 100
         CALL EDGINDV (LV1,LV2,LVSKIP,ISD)
         DO 120 I=2,NXM1
            LV = LV1 + (I-1)*LVSKIP
            VNX(LV,1,1,IEL) = 0.0
            VNY(LV,1,1,IEL) = 0.0
            VNZ(LV,1,1,IEL) = 0.0
  120    CONTINUE
  100 CONTINUE
C
      DO 150 IEL=1,NEL
      DO 150 ICR=1,NCRNR
         IX  = MCRRST(1,ICR)
         IY  = MCRRST(2,ICR)
         IZ  = MCRRST(3,ICR)
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR. HMV .GT. 3.1) GOTO 150
         VNX(IX,IY,IZ,IEL) = 0.0
         VNY(IX,IY,IZ,IEL) = 0.0
         VNZ(IX,IY,IZ,IEL) = 0.0
 150  CONTINUE
C
C     (1) All Edges
C
      DO 200 IEL=1,NEL
      DO 200 ISD=1,NEDGE
         IX  = MIDRST(1,ISD)
         IY  = MIDRST(2,ISD)
         IZ  = MIDRST(3,ISD)
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR. HMV .GT. 3.1) GOTO 200
         DO 220 II=1,2
            IFC = MFCEG(II,ISD)
            HMF = ABS( HFMASK(1,1,IFC,IEL) )
            IF (ABS(HMV - HMF) .LT. EPSA) THEN
               CALL EDGINDV (LV1,LV2,LVSKIP,ISD)
               CALL EDGINDF (LF1,LF2,LFSKIP,ISD,II)
               DO 240 I=2,NXM1
                  LV = LV1 + (I-1)*LVSKIP
                  LF = LF1 + (I-1)*LFSKIP
                  VNX(LV,1,1,IEL)=VNX(LV,1,1,IEL)+UNX(LF,1,IFC,IEL)
                  VNY(LV,1,1,IEL)=VNY(LV,1,1,IEL)+UNY(LF,1,IFC,IEL)
                  VNZ(LV,1,1,IEL)=VNZ(LV,1,1,IEL)+UNZ(LF,1,IFC,IEL)
  240          CONTINUE    
            ENDIF
  220    CONTINUE 
  200 CONTINUE
C
C     (2) All Corners
C
      DO 300 IEL=1,NEL
      DO 300 ICR=1,NCRNR
         IX  = MCRRST(1,ICR)
         IY  = MCRRST(2,ICR)
         IZ  = MCRRST(3,ICR)
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR. HMV .GT. 3.1) GOTO 300
         DO 320 II=1,3
            IFC = MFCCR(II,ICR)
            HMF = ABS( HFMASK(1,1,IFC,IEL) )
            IF (ABS(HMV - HMF) .LT. EPSA) THEN
               IRA = NTCRF(1,II)
               ISA = NTCRF(2,II)
               IR  = MCRRST(IRA,ICR)
               IS  = MCRRST(ISA,ICR)
               VNX(IX,IY,IZ,IEL)=VNX(IX,IY,IZ,IEL)+UNX(IR,IS,IFC,IEL)
               VNY(IX,IY,IZ,IEL)=VNY(IX,IY,IZ,IEL)+UNY(IR,IS,IFC,IEL)
               VNZ(IX,IY,IZ,IEL)=VNZ(IX,IY,IZ,IEL)+UNZ(IR,IS,IFC,IEL)
            ENDIF
  320    CONTINUE
  300 CONTINUE
C
      CALL DSSUM   (VNX,lx1,ly1,lz1)
      CALL DSSUM   (VNY,lx1,ly1,lz1)
      CALL DSSUM   (VNZ,lx1,ly1,lz1)
      CALL UNITVEC (VNX,VNY,VNZ,NTOT1)
      CALL VDOT3   (VNMAG,VNX,VNY,VNZ,VNX,VNY,VNZ,NTOT1)
C
      DO 500 IEL=1,NEL
      DO 500 IFC=1,NFACE
         HMF = ABS( HFMASK(1,1,IFC,IEL) )
         IF (HMF .LT. 1.9  .OR. HMF .GT. 3.1) GOTO 500
         CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
         DO 520 J2=JS2,JF2,JSKIP2
         DO 520 J1=JS1,JF1,JSKIP1
            IF (VNMAG(J1,J2,1,IEL) .LT. EPSA) GOTO 520
            VlzdIF = ABS(VNZ(J1,J2,1,IEL)) - 1.0
            IF (ABS(VlzdIF) .LT. EPSN) THEN
                V1X(J1,J2,1,IEL) = 1.0
                V1Y(J1,J2,1,IEL) = 0.0
                V1Z(J1,J2,1,IEL) = 0.0
            ELSE
                SSN = SQRT(VNX(J1,J2,1,IEL)**2 + VNY(J1,J2,1,IEL)**2)
                V1X(J1,J2,1,IEL) = -VNY(J1,J2,1,IEL) / SSN
                V1Y(J1,J2,1,IEL) =  VNX(J1,J2,1,IEL) / SSN
                V1Z(J1,J2,1,IEL) =  0.0
            ENDIF
  520    CONTINUE
  500 CONTINUE
C
      CALL DSSUM   (V1X,lx1,ly1,lz1)
      CALL DSSUM   (V1Y,lx1,ly1,lz1)
      CALL DSSUM   (V1Z,lx1,ly1,lz1)
      CALL UNITVEC (V1X,V1Y,V1Z,NTOT1)
C
      CALL VCROSS (V2X,V2Y,V2Z,VNX,VNY,VNZ,V1X,V1Y,V1Z,NTOT1)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FIXWMSK (W2MASK,W3MASK,HVMASK,HFMASK,NEL)
C
      INCLUDE 'SIZE'
      DIMENSION HVMASK(LX1,LY1,LZ1,1)
     $        , HFMASK(LX1,LZ1,6,1)
C
      DIMENSION W2MASK(LX1,LY1,LZ1,1)
     $        , W3MASK(LX1,LY1,LZ1,1)
C
      IF (ldim.EQ.2) THEN
         CALL FXWMS2 (W2MASK,HVMASK,HFMASK,NEL)
      ELSE
         CALL FXWMS3 (W2MASK,W3MASK,HVMASK,HFMASK,NEL)
      ENDIF
C
      CALL DSOP(W2MASK,'MUL',lx1,ly1,lz1)
      IF (ldim.EQ.3) CALL DSOP(W3MASK,'MUL',lx1,ly1,lz1)
C 
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FXWMS2 (W2MASK,HVMASK,HFMASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      DIMENSION W2MASK(LX1,LY1,LZ1,1)
     $        , HVMASK(LX1,LY1,LZ1,1)
     $        , HFMASK(LX1,LZ1,6,1)
C
      NCRNR  = 2**ldim
      EPSA   = 1.0E-06
C
      IZ = 1
      DO 100 IEL=1,NEL
      DO 100 ICR=1,NCRNR
         IX  = MCRRST(1,ICR)           
         IY  = MCRRST(2,ICR)           
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR.  HMV .GT. 2.1) GOTO 100
         DO 120 II=1,2
            IFC = MFCCR(II,ICR)
            HMF = ABS( HFMASK(1,1,IFC,IEL) )
            IF (ABS(HMV - HMF) .LT. EPSA) THEN
               IR  = MCRRST(II,ICR)
               DOT = VNX(IX,IY,IZ,IEL)*UNX(IR,IZ,IFC,IEL) + 
     $               VNY(IX,IY,IZ,IEL)*UNY(IR,IZ,IFC,IEL)
               IF (DOT .LT. 0.99) THEN
                  W2MASK(IX,IY,IZ,IEL) = 0.0
                  GOTO 100
               ENDIF
            ENDIF
  120    CONTINUE
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FXWMS3 (W2MASK,W3MASK,HVMASK,HFMASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      DIMENSION W2MASK(LX1,LY1,LZ1,1)
     $        , W3MASK(LX1,LY1,LZ1,1)
     $        , HVMASK(LX1,LY1,LZ1,1)
     $        , HFMASK(LX1,LZ1,6,1)
C
      NCRNR = 2**ldim
      NEDGE = 12
      NMID  = (lx1 + 1)/2
      EPSA  = 1.0E-06
C
      DO 100 IEL=1,NEL
      DO 100 ISD=1,12
         IX  = MIDRST(1,ISD)
         IY  = MIDRST(2,ISD)
         IZ  = MIDRST(3,ISD)
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR.  HMV .GT. 2.1) GOTO 100
         DO 120 II=1,2
            IFC = MFCEG(II,ISD)
            HMF = ABS( HFMASK(1,1,IFC,IEL) )
            IF (ABS(HMV - HMF) .LT. EPSA) THEN
               CALL EDGINDF (LF1,LF2,LFSKIP,ISD,II)
               LF  = LF1 + (NMID-1)*LFSKIP
               DOT = VNX(IX,IY,IZ,IEL)*UNX(LF,1,IFC,IEL) + 
     $               VNY(IX,IY,IZ,IEL)*UNY(LF,1,IFC,IEL) +
     $               VNZ(IX,IY,IZ,IEL)*UNZ(LF,1,IFC,IEL)
               IF (DOT .LT. 0.99) THEN
                  CALL EDGINDV (LV1,LV2,LVSKIP,ISD)
                  DO 140 LV=LV1,LV2,LVSKIP
                     W3MASK(LV,1,1,IEL) = 0.0
  140             CONTINUE    
               ENDIF
            ENDIF
  120    CONTINUE
  100 CONTINUE
C
C     All Corners
C
      DO 300 IEL=1,NEL
      DO 300 ICR=1,NCRNR
         IX  = MCRRST(1,ICR)
         IY  = MCRRST(2,ICR)
         IZ  = MCRRST(3,ICR)
         HMV = ABS( HVMASK(IX,IY,IZ,IEL) )
         IF (HMV .LT. 1.9  .OR. HMV .GT. 2.1) GOTO 300
         DO 320 II=1,3
            IFC = MFCCR(II,ICR)
            HMF = ABS( HFMASK(1,1,IFC,IEL) )
            IF (ABS(HMV - HMF) .LT. EPSA) THEN
               IRA = NTCRF(1,II)
               ISA = NTCRF(2,II)
               IR  = MCRRST(IRA,ICR)
               IS  = MCRRST(ISA,ICR)
               DOT = VNX(IX,IY,IZ,IEL)*UNX(IR,IS,IFC,IEL) + 
     $               VNY(IX,IY,IZ,IEL)*UNY(IR,IS,IFC,IEL) +
     $               VNZ(IX,IY,IZ,IEL)*UNZ(IR,IS,IFC,IEL)
            ENDIF
            IF (DOT .LT. 0.99) THEN
                W2MASK(IX,IY,IZ,IEL) = 0.0
                GOTO 300
            ENDIF 
  320    CONTINUE
  300 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SETCDAT 
C
      INCLUDE 'SIZE'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      NMID = (lx1 +1)/2
C
C     Corners on faces
C
      MCRFC(1,1) = 1
      MCRFC(2,1) = 2
      MCRFC(3,1) = 6
      MCRFC(4,1) = 5
      MCRFC(1,2) = 2
      MCRFC(2,2) = 3
      MCRFC(3,2) = 7
      MCRFC(4,2) = 6
      MCRFC(1,3) = 3
      MCRFC(2,3) = 4
      MCRFC(3,3) = 8
      MCRFC(4,3) = 7
      MCRFC(1,4) = 4
      MCRFC(2,4) = 1
      MCRFC(3,4) = 5
      MCRFC(4,4) = 8
      MCRFC(1,5) = 4
      MCRFC(2,5) = 3
      MCRFC(3,5) = 2
      MCRFC(4,5) = 1
      MCRFC(1,6) = 5
      MCRFC(2,6) = 6
      MCRFC(3,6) = 7
      MCRFC(4,6) = 8
C
C     Faces at corners
C
      MFCCR(1,1) = 4
      MFCCR(2,1) = 1
      MFCCR(3,1) = 5
      MFCCR(1,2) = 1
      MFCCR(2,2) = 2
      MFCCR(3,2) = 5
      MFCCR(1,3) = 2
      MFCCR(2,3) = 3
      MFCCR(3,3) = 5
      MFCCR(1,4) = 3
      MFCCR(2,4) = 4
      MFCCR(3,4) = 5
      MFCCR(1,5) = 4
      MFCCR(2,5) = 1
      MFCCR(3,5) = 6
      MFCCR(1,6) = 1
      MFCCR(2,6) = 2
      MFCCR(3,6) = 6
      MFCCR(1,7) = 2
      MFCCR(2,7) = 3
      MFCCR(3,7) = 6
      MFCCR(1,8) = 3
      MFCCR(2,8) = 4
      MFCCR(3,8) = 6
C
C     Edges at corners
C
      MEGCR(1,1) = 4
      MEGCR(2,1) = 1
      MEGCR(3,1) = 9
      MEGCR(1,2) = 1
      MEGCR(2,2) = 2
      MEGCR(3,2) = 10
      MEGCR(1,3) = 2
      MEGCR(2,3) = 3
      MEGCR(3,3) = 11
      MEGCR(1,4) = 3
      MEGCR(2,4) = 4
      MEGCR(3,4) = 12
      MEGCR(1,5) = 8
      MEGCR(2,5) = 5
      MEGCR(3,5) = 9
      MEGCR(1,6) = 5
      MEGCR(2,6) = 6
      MEGCR(3,6) = 10
      MEGCR(1,7) = 6
      MEGCR(2,7) = 7
      MEGCR(3,7) = 11
      MEGCR(1,8) = 7
      MEGCR(2,8) = 8
      MEGCR(3,8) = 12
C
C     Faces on edges
C
      MFCEG(1,1)  = 1
      MFCEG(2,1)  = 5
      MFCEG(1,2)  = 2
      MFCEG(2,2)  = 5
      MFCEG(1,3)  = 3
      MFCEG(2,3)  = 5
      MFCEG(1,4)  = 4
      MFCEG(2,4)  = 5
      MFCEG(1,5)  = 1
      MFCEG(2,5)  = 6
      MFCEG(1,6)  = 2
      MFCEG(2,6)  = 6
      MFCEG(1,7)  = 3
      MFCEG(2,7)  = 6
      MFCEG(1,8)  = 4
      MFCEG(2,8)  = 6
      MFCEG(1,9)  = 4
      MFCEG(2,9)  = 1
      MFCEG(1,10) = 1
      MFCEG(2,10) = 2
      MFCEG(1,11) = 2
      MFCEG(2,11) = 3
      MFCEG(1,12) = 3
      MFCEG(2,12) = 4
C
C     Corners at edges
C
      MCREG(1,1)  = 1
      MCREG(2,1)  = 2
      MCREG(1,2)  = 2
      MCREG(2,2)  = 3
      MCREG(1,3)  = 4
      MCREG(2,3)  = 3
      MCREG(1,4)  = 1
      MCREG(2,4)  = 4
      MCREG(1,5)  = 5
      MCREG(2,5)  = 6
      MCREG(1,6)  = 6
      MCREG(2,6)  = 7
      MCREG(1,7)  = 8
      MCREG(2,7)  = 7
      MCREG(1,8)  = 5
      MCREG(2,8)  = 8
      MCREG(1,9)  = 1
      MCREG(2,9)  = 5
      MCREG(1,10) = 2
      MCREG(2,10) = 6
      MCREG(1,11) = 3
      MCREG(2,11) = 7
      MCREG(1,12) = 4
      MCREG(2,12) = 8
C
C     Corner indices (Vol array)
C
      MCRRST(1,1) = 1
      MCRRST(2,1) = 1
      MCRRST(3,1) = 1
      MCRRST(1,2) = lx1
      MCRRST(2,2) = 1
      MCRRST(3,2) = 1
      MCRRST(1,3) = lx1
      MCRRST(2,3) = lx1
      MCRRST(3,3) = 1
      MCRRST(1,4) = 1
      MCRRST(2,4) = lx1
      MCRRST(3,4) = 1
      MCRRST(1,5) = 1
      MCRRST(2,5) = 1
      MCRRST(3,5) = lx1
      MCRRST(1,6) = lx1
      MCRRST(2,6) = 1
      MCRRST(3,6) = lx1
      MCRRST(1,7) = lx1
      MCRRST(2,7) = lx1
      MCRRST(3,7) = lx1
      MCRRST(1,8) = 1
      MCRRST(2,8) = lx1
      MCRRST(3,8) = lx1
C
C     Mid-edge indcies (Vol array)
C 
      MIDRST(1,1)  = NMID
      MIDRST(1,2)  = lx1
      MIDRST(1,3)  = NMID
      MIDRST(1,4)  = 1
      MIDRST(1,5)  = NMID
      MIDRST(1,6)  = lx1
      MIDRST(1,7)  = NMID
      MIDRST(1,8)  = 1
      MIDRST(1,9)  = 1
      MIDRST(1,10) = lx1
      MIDRST(1,11) = lx1
      MIDRST(1,12) = 1
      MIDRST(2,1)  = 1
      MIDRST(2,2)  = NMID
      MIDRST(2,3)  = lx1
      MIDRST(2,4)  = NMID
      MIDRST(2,5)  = 1
      MIDRST(2,6)  = NMID
      MIDRST(2,7)  = lx1
      MIDRST(2,8)  = NMID
      MIDRST(2,9)  = 1
      MIDRST(2,10) = 1
      MIDRST(2,11) = lx1
      MIDRST(2,12) = lx1
      MIDRST(3,1)  = 1
      MIDRST(3,2)  = 1
      MIDRST(3,3)  = 1
      MIDRST(3,4)  = 1
      MIDRST(3,5)  = lx1
      MIDRST(3,6)  = lx1
      MIDRST(3,7)  = lx1
      MIDRST(3,8)  = lx1
      MIDRST(3,9)  = NMID
      MIDRST(3,10) = NMID
      MIDRST(3,11) = NMID
      MIDRST(3,12) = NMID
C
C     1-D corners indices (Vol array)
C
      MCRIND(1) = 1
      MCRIND(2) = lx1
      MCRIND(3) = lx1**2
      MCRIND(7) = lx1**3
      MCRIND(4) = MCRIND(3) - lx1 + 1
      MCRIND(5) = MCRIND(7) - MCRIND(3) + 1
      MCRIND(6) = MCRIND(5) + lx1 - 1
      MCRIND(8) = MCRIND(7) - lx1 + 1
C
C     1-D  edge indices (Face array)
C
      MEDIND(1,1) = 1
      MEDIND(2,1) = lx1
      MEDIND(1,2) = lx1**2 - lx1 + 1
      MEDIND(2,2) = lx1**2
      MEDIND(1,3) = 1
      MEDIND(2,3) = MEDIND(1,2)
      MEDIND(1,4) = lx1
      MEDIND(2,4) = lx1**2
C
C     1-D edge index type (Face array)
C
      NTEFC(1,1)  = 1
      NTEFC(2,1)  = 1
      NTEFC(1,2)  = 1
      NTEFC(2,2)  = 4
      NTEFC(1,3)  = 1
      NTEFC(2,3)  = 2
      NTEFC(1,4)  = 1
      NTEFC(2,4)  = 3
      NTEFC(1,5)  = 2
      NTEFC(2,5)  = 1
      NTEFC(1,6)  = 2
      NTEFC(2,6)  = 4
      NTEFC(1,7)  = 2
      NTEFC(2,7)  = 2
      NTEFC(1,8)  = 2
      NTEFC(2,8)  = 3
      NTEFC(1,9)  = 3
      NTEFC(2,9)  = 3
      NTEFC(1,10) = 4
      NTEFC(2,10) = 3
      NTEFC(1,11) = 4
      NTEFC(2,11) = 4
      NTEFC(1,12) = 3
      NTEFC(2,12) = 4
C
C     Corner index address on face in MCRRST
C
      NTCRF(1,1) = 1
      NTCRF(2,1) = 3
      NTCRF(1,2) = 2
      NTCRF(2,2) = 3
      NTCRF(1,3) = 1
      NTCRF(2,3) = 2
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EDGINDF (LF1,LF2,LFSKIP,ISD,IFCN)
C
      INCLUDE 'SIZE'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      ITYP = NTEFC(IFCN,ISD)
C
      LF1 = MEDIND(1,ITYP)
      LF2 = MEDIND(2,ITYP)
C
      LFSKIP = 1
      IF (ITYP .GE. 3) LFSKIP = lx1
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EDGINDV (LV1,LV2,LVSKIP,ISD)
C
      INCLUDE 'SIZE'
      common /indxfc/ mcrfc(4,6)
     $              , mfccr(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
C
      IODD = ISD - ISD/2*2
      ICR1 = MCREG(1,ISD)
      ICR2 = MCREG(2,ISD)
C
      LV1  = MCRIND(ICR1)
      LV2  = MCRIND(ICR2)
C
      IF (ISD .GE. 9) THEN
         LVSKIP = lx1**2
      ELSE
         IF (IODD.EQ.0) THEN
            LVSKIP = lx1
         ELSE
            LVSKIP = 1
         ENDIF
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SETCDOF
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
C
      NFACE = 2*ldim
C
      DO 100 IEL=1,NELT
      DO 100 IFC=1,NFACE
         CDOF(IFC,IEL)=CBC(IFC,IEL,0)(1:1)
 100  CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE AMASK (VB1,VB2,VB3,V1,V2,V3,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      common /scrsf/ a1mask(lx1,ly1,lz1,lelt)
     $             , a2mask(lx1,ly1,lz1,lelt)
     $             , a3mask(lx1,ly1,lz1,lelt)
      common /ctmp0/ wa(lx1,ly1,lz1,lelt)
C
      DIMENSION VB1(LX1,LY1,LZ1,1)
     $        , VB2(LX1,LY1,LZ1,1)
     $        , VB3(LX1,LY1,LZ1,1)
     $        , V1(LX1,LY1,LZ1,1)
     $        , V2(LX1,LY1,LZ1,1)
     $        , V3(LX1,LY1,LZ1,1)
C
      NTOT1 = lx1*ly1*lz1*NEL
      CALL RONE (WA,NTOT1)
      CALL COPY (VB1,V1,NTOT1)
      CALL COPY (VB2,V2,NTOT1)
      IF (ldim.EQ.3) CALL COPY (VB3,V3,NTOT1)
C
      IF (IFIELD.EQ.1) THEN
         CALL SUB3  (A1MASK,WA,V1MASK,NTOT1)
         CALL SUB3  (A2MASK,WA,V2MASK,NTOT1)
         IF (ldim.EQ.3) CALL SUB3 (A3MASK,WA,V3MASK,NTOT1)
      ELSEIF (IFIELD.EQ.ifldmhd) THEN
         CALL SUB3  (A1MASK,WA,B1MASK,NTOT1)
         CALL SUB3  (A2MASK,WA,B2MASK,NTOT1)
         IF (ldim.EQ.3) CALL SUB3 (A3MASK,WA,B3MASK,NTOT1)
      ELSE
         CALL SUB3  (A1MASK,WA,W1MASK,NTOT1)
         CALL SUB3  (A2MASK,WA,W2MASK,NTOT1)
         IF (ldim.EQ.3) CALL SUB3 (A3MASK,WA,W3MASK,NTOT1)
      ENDIF
C
      CALL QMASK (VB1,VB2,VB3,A1MASK,A2MASK,A3MASK,NEL)
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE RMASK (R1,R2,R3,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      INCLUDE 'MVGEOM'
C
      DIMENSION R1  (LX1,LY1,LZ1,1)
     $        , R2  (LX1,LY1,LZ1,1)
     $        , R3  (LX1,LY1,LZ1,1)
C
c      if (ifsplit) then
c         call opmask(r1,r2,r3)
c         return
c      endif

c     call outfldro (v1mask,'v1mask rmk',0)
c     call outfldro (v2mask,'v2mask rmk',1)

      IF (IFIELD.EQ.1) THEN
         CALL QMASK (R1,R2,R3,V1MASK,V2MASK,V3MASK,NEL)
      ELSEIF (ifield.eq.ifldmhd) then
         CALL QMASK (R1,R2,R3,B1MASK,B2MASK,B3MASK,NEL)
      ELSE
         CALL QMASK (R1,R2,R3,W1MASK,W2MASK,W3MASK,NEL)
      ENDIF

c     call outfldro (r1,'r1   rmask',0)
c     call outfldro (r2,'r2   rmask',1)
c     call exitti   ('quit in rmask$,',nel)

      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE QMASK (R1,R2,R3,R1MASK,R2MASK,R3MASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      common /ctmp1/ s1(lx1,ly1,lz1,lelt)
     $             , s2(lx1,ly1,lz1,lelt)
     $             , s3(lx1,ly1,lz1,lelt)
C
      DIMENSION R1(LX1,LY1,LZ1,1)
     $        , R2(LX1,LY1,LZ1,1)
     $        , R3(LX1,LY1,LZ1,1)
     $        , R1MASK(LX1,LY1,LZ1,1)
     $        , R2MASK(LX1,LY1,LZ1,1)
     $        , R3MASK(LX1,LY1,LZ1,1)
C
      NTOT1 = lx1*ly1*lz1*NEL
C
C     (0) Collocate Volume Mask
C
      CALL COPY  (S1,R1,NTOT1)
      CALL COPY  (S2,R2,NTOT1)
      CALL COL2  (R1,R1MASK,NTOT1)
      CALL COL2  (R2,R2MASK,NTOT1)
      IF (ldim.EQ.3) THEN
         CALL COPY (S3,R3,NTOT1)
         CALL COL2 (R3,R3MASK,NTOT1)
      ENDIF
C
C     (1) Face Mask
C
      IF (IFLMSF(IFIELD)) THEN
         IF (ldim.EQ.2) THEN
            CALL FCMSK2 (R1,R2,S1,S2,R1MASK,R2MASK,NEL)
         ELSE
            CALL FCMSK3 (R1,R2,R3,S1,S2,S3,R1MASK,R2MASK,R3MASK,NEL)
         ENDIF
      ENDIF
C
C     (2) Edge Mask  (3-D only)
C
      IF (ldim.EQ.3 .AND. IFLMSE(IFIELD)) 
     $   CALL EGMASK (R1,R2,R3,S1,S2,S3,R1MASK,R2MASK,R3MASK,NEL)
C
C     (3) Corner Mask
C
      IF (IFLMSC(IFIELD)) THEN
         IF (ldim.EQ.2) THEN
            CALL CRMSK2 (R1,R2,S1,S2,R1MASK,R2MASK,NEL)
         ELSE
            CALL CRMSK3 (R1,R2,R3,S1,S2,S3,R1MASK,R2MASK,R3MASK,NEL)
         ENDIF
      ENDIF
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FCMSK2 (R1,R2,S1,S2,R1MASK,R2MASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      DIMENSION R1(LX1,LY1,LZ1,1)
     $        , R2(LX1,LY1,LZ1,1)
     $        , S1(LX1,LY1,LZ1,1)
     $        , S2(LX1,LY1,LZ1,1)
     $        , R1MASK(LX1,LY1,LZ1,1)
     $        , R2MASK(LX1,LY1,LZ1,1)
C
      NFACE = 2*ldim
C
      DO 100 IEL=1,NEL
      DO 100 IFC=1,NFACE
         IF (.NOT.IFMSFC(IFC,IEL,IFIELD)) GO TO 100
         CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
         DO 120 J2=JS2,JF2,JSKIP2
         DO 120 J1=JS1,JF1,JSKIP1
            RNOR = ( S1(J1,J2,1,IEL)*VNX(J1,J2,1,IEL) +
     $               S2(J1,J2,1,IEL)*VNY(J1,J2,1,IEL) ) *
     $               R1MASK(J1,J2,1,IEL)
            RTN1 = ( S1(J1,J2,1,IEL)*V1X(J1,J2,1,IEL) +
     $               S2(J1,J2,1,IEL)*V1Y(J1,J2,1,IEL) ) *
     $               R2MASK(J1,J2,1,IEL)
            R1(J1,J2,1,IEL) = RNOR*VNX(J1,J2,1,IEL) +
     $                        RTN1*V1X(J1,J2,1,IEL)
            R2(J1,J2,1,IEL) = RNOR*VNY(J1,J2,1,IEL) +
     $                        RTN1*V1Y(J1,J2,1,IEL)
  120       CONTINUE
  100    CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FCMSK3 (R1,R2,R3,S1,S2,S3,R1MASK,R2MASK,R3MASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      DIMENSION R1(LX1,LY1,LZ1,1)
     $        , R2(LX1,LY1,LZ1,1)
     $        , R3(LX1,LY1,LZ1,1)
     $        , S1(LX1,LY1,LZ1,1)
     $        , S2(LX1,LY1,LZ1,1)
     $        , S3(LX1,LY1,LZ1,1)
     $        , R1MASK(LX1,LY1,LZ1,1)
     $        , R2MASK(LX1,LY1,LZ1,1)
     $        , R3MASK(LX1,LY1,LZ1,1)
C
      NFACE = 2*ldim
C
      DO 100 IEL=1,NEL
      DO 100 IFC=1,NFACE
         IF (.NOT.IFMSFC(IFC,IEL,IFIELD)) GO TO 100
         CALL FACIND2 (JS1,JF1,JSKIP1,JS2,JF2,JSKIP2,IFC)
         DO 120 J2=JS2,JF2,JSKIP2
         DO 120 J1=JS1,JF1,JSKIP1
            RNOR = ( S1(J1,J2,1,IEL)*VNX(J1,J2,1,IEL) +
     $               S2(J1,J2,1,IEL)*VNY(J1,J2,1,IEL) +
     $               S3(J1,J2,1,IEL)*VNZ(J1,J2,1,IEL) ) *
     $               R1MASK(J1,J2,1,IEL)
            RTN1 = ( S1(J1,J2,1,IEL)*V1X(J1,J2,1,IEL) +
     $               S2(J1,J2,1,IEL)*V1Y(J1,J2,1,IEL) +
     $               S3(J1,J2,1,IEL)*V1Z(J1,J2,1,IEL) ) *
     $               R2MASK(J1,J2,1,IEL)
            RTN2 = ( S1(J1,J2,1,IEL)*V2X(J1,J2,1,IEL) +
     $               S2(J1,J2,1,IEL)*V2Y(J1,J2,1,IEL) +
     $               S3(J1,J2,1,IEL)*V2Z(J1,J2,1,IEL) ) *
     $               R3MASK(J1,J2,1,IEL)
            R1(J1,J2,1,IEL) = RNOR*VNX(J1,J2,1,IEL) +
     $                        RTN1*V1X(J1,J2,1,IEL) +
     $                        RTN2*V2X(J1,J2,1,IEL)
            R2(J1,J2,1,IEL) = RNOR*VNY(J1,J2,1,IEL) +
     $                        RTN1*V1Y(J1,J2,1,IEL) +
     $                        RTN2*V2Y(J1,J2,1,IEL)
            R3(J1,J2,1,IEL) = RNOR*VNZ(J1,J2,1,IEL) +
     $                        RTN1*V1Z(J1,J2,1,IEL) +
     $                        RTN2*V2Z(J1,J2,1,IEL) 
  120       CONTINUE
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EGMASK (R1,R2,R3,S1,S2,S3,R1MASK,R2MASK,R3MASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      DIMENSION R1(LX1,LY1,LZ1,1)
     $        , R2(LX1,LY1,LZ1,1)
     $        , R3(LX1,LY1,LZ1,1)
     $        , S1(LX1,LY1,LZ1,1)
     $        , S2(LX1,LY1,LZ1,1)
     $        , S3(LX1,LY1,LZ1,1)
     $        , R1MASK(LX1,LY1,LZ1,1)
     $        , R2MASK(LX1,LY1,LZ1,1)
     $        , R3MASK(LX1,LY1,LZ1,1)
C
      NEDGE = 12
C
      DO 100 IEL=1,NEL
      DO 100 ISD=1,NEDGE
         IF (.NOT.IFMSEG(ISD,IEL,IFIELD)) GOTO 100
         CALL EDGINDV (LV1,LV2,LVSKIP,ISD)
         DO 120 LV=LV1,LV2,LVSKIP
            RNOR = ( S1(LV,1,1,IEL)*VNX(LV,1,1,IEL) +
     $               S2(LV,1,1,IEL)*VNY(LV,1,1,IEL) +
     $               S3(LV,1,1,IEL)*VNZ(LV,1,1,IEL) ) *
     $               R1MASK(LV,1,1,IEL)
            RTN1 = ( S1(LV,1,1,IEL)*V1X(LV,1,1,IEL) +
     $               S2(LV,1,1,IEL)*V1Y(LV,1,1,IEL) +
     $               S3(LV,1,1,IEL)*V1Z(LV,1,1,IEL) ) *
     $               R2MASK(LV,1,1,IEL)
            RTN2 = ( S1(LV,1,1,IEL)*V2X(LV,1,1,IEL) +
     $               S2(LV,1,1,IEL)*V2Y(LV,1,1,IEL) +
     $               S3(LV,1,1,IEL)*V2Z(LV,1,1,IEL) ) *
     $               R3MASK(LV,1,1,IEL)
            R1(LV,1,1,IEL) = RNOR*VNX(LV,1,1,IEL) +
     $                       RTN1*V1X(LV,1,1,IEL) +
     $                       RTN2*V2X(LV,1,1,IEL)
            R2(LV,1,1,IEL) = RNOR*VNY(LV,1,1,IEL) +
     $                       RTN1*V1Y(LV,1,1,IEL) +
     $                       RTN2*V2Y(LV,1,1,IEL)
            R3(LV,1,1,IEL) = RNOR*VNZ(LV,1,1,IEL) +
     $                       RTN1*V1Z(LV,1,1,IEL) +
     $                       RTN2*V2Z(LV,1,1,IEL) 
  120    CONTINUE
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE CRMSK2 (R1,R2,S1,S2,R1MASK,R2MASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
      DIMENSION R1(LX1,LY1,LZ1,1)
     $        , R2(LX1,LY1,LZ1,1)
     $        , S1(LX1,LY1,LZ1,1)
     $        , S2(LX1,LY1,LZ1,1)
     $        , R1MASK(LX1,LY1,LZ1,1)
     $        , R2MASK(LX1,LY1,LZ1,1)
C
      NCRNR = 2**ldim
C
      DO 100 IEL=1,NEL
      DO 100 ICR=1,NCRNR
         IF (.NOT.IFMSCR(ICR,IEL,IFIELD)) GO TO 100
         IX = MCRRST(1,ICR)
         IY = MCRRST(2,ICR)
         IZ = 1
         RNOR = ( S1(IX,IY,IZ,IEL)*VNX(IX,IY,IZ,IEL) +
     $            S2(IX,IY,IZ,IEL)*VNY(IX,IY,IZ,IEL) ) *
     $            R1MASK(IX,IY,IZ,IEL)
         RTN1 = ( S1(IX,IY,IZ,IEL)*V1X(IX,IY,IZ,IEL) +
     $            S2(IX,IY,IZ,IEL)*V1Y(IX,IY,IZ,IEL) ) *
     $            R2MASK(IX,IY,IZ,IEL)
         R1(IX,IY,IZ,IEL) = RNOR*VNX(IX,IY,IZ,IEL) +
     $                      RTN1*V1X(IX,IY,IZ,IEL)
         R2(IX,IY,IZ,IEL) = RNOR*VNY(IX,IY,IZ,IEL) +
     $                      RTN1*V1Y(IX,IY,IZ,IEL)
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE CRMSK3 (R1,R2,R3,S1,S2,S3,R1MASK,R2MASK,R3MASK,NEL)
C
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'TSTEP'
      common /indxfc/ mcrfc(4,6)
     $              , MFCCR(3,8)
     $              , MEGCR(3,8)
     $              , MFCEG(2,12)
     $              , MCREG(2,12)
     $              , MCRRST(3,8)
     $              , MIDRST(3,12)
     $              , MCRIND(8)
     $              , MEDIND(2,4)
     $              , NTEFC(2,12)
     $              , NTCRF(2,3)     
      DIMENSION R1(LX1,LY1,LZ1,1)
     $        , R2(LX1,LY1,LZ1,1)
     $        , R3(LX1,LY1,LZ1,1)
     $        , S1(LX1,LY1,LZ1,1)
     $        , S2(LX1,LY1,LZ1,1)
     $        , S3(LX1,LY1,LZ1,1)
     $        , R1MASK(LX1,LY1,LZ1,1)
     $        , R2MASK(LX1,LY1,LZ1,1)
     $        , R3MASK(LX1,LY1,LZ1,1)
C
      NCRNR = 2**ldim
C
      DO 100 IEL=1,NEL
      DO 100 ICR=1,NCRNR
         IF (.NOT.IFMSCR(ICR,IEL,IFIELD)) GO TO 100
         IX = MCRRST(1,ICR)
         IY = MCRRST(2,ICR)
         IZ = MCRRST(3,ICR)
         RNOR = ( S1(IX,IY,IZ,IEL)*VNX(IX,IY,IZ,IEL) +
     $            S2(IX,IY,IZ,IEL)*VNY(IX,IY,IZ,IEL) +
     $            S3(IX,IY,IZ,IEL)*VNZ(IX,IY,IZ,IEL) ) *
     $            R1MASK(IX,IY,IZ,IEL)
         RTN1 = ( S1(IX,IY,IZ,IEL)*V1X(IX,IY,IZ,IEL) +
     $            S2(IX,IY,IZ,IEL)*V1Y(IX,IY,IZ,IEL) +
     $            S3(IX,IY,IZ,IEL)*V1Z(IX,IY,IZ,IEL) ) *
     $            R2MASK(IX,IY,IZ,IEL)
         RTN2 = ( S1(IX,IY,IZ,IEL)*V2X(IX,IY,IZ,IEL) +
     $            S2(IX,IY,IZ,IEL)*V2Y(IX,IY,IZ,IEL) +
     $            S3(IX,IY,IZ,IEL)*V2Z(IX,IY,IZ,IEL) ) *
     $            R3MASK(IX,IY,IZ,IEL)
         R1(IX,IY,IZ,IEL) = RNOR*VNX(IX,IY,IZ,IEL) +
     $                      RTN1*V1X(IX,IY,IZ,IEL) +
     $                      RTN2*V2X(IX,IY,IZ,IEL)
         R2(IX,IY,IZ,IEL) = RNOR*VNY(IX,IY,IZ,IEL) +
     $                      RTN1*V1Y(IX,IY,IZ,IEL) +
     $                      RTN2*V2Y(IX,IY,IZ,IEL)
         R3(IX,IY,IZ,IEL) = RNOR*VNZ(IX,IY,IZ,IEL) +
     $                      RTN1*V1Z(IX,IY,IZ,IEL) +
     $                      RTN2*V2Z(IX,IY,IZ,IEL) 
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      subroutine getSnormal(sn,ix,iy,iz,iside,e)

c     calculate surface normal

      include 'SIZE'
      include 'GEOM'
      include 'TOPOL'

      real sn(3)
      integer e,f

      f = eface1(iside)

      if (1.le.f.and.f.le.2) then     ! "r face"
         sn(1) = unx(iy,iz,iside,e)
         sn(2) = uny(iy,iz,iside,e)
         sn(3) = unz(iy,iz,iside,e)
      elseif (3.le.f.and.f.le.4) then ! "s face"
         sn(1) = unx(ix,iz,iside,e)
         sn(2) = uny(ix,iz,iside,e)
         sn(3) = unz(ix,iz,iside,e)
      elseif (5.le.f.and.f.le.6) then ! "t face"
         sn(1) = unx(ix,iy,iside,e)
         sn(2) = uny(ix,iy,iside,e)
         sn(3) = unz(ix,iy,iside,e)
      endif

      return
      end

      subroutine fixmska (c1mask,c2mask,c3mask)

c     fixes masks for A/SYM face corners

      include 'SIZE'
      include 'INPUT'
 
      real   c1mask(lx1,ly1,lz1,1)
     $      ,c2mask(lx1,ly1,lz1,1)
     $      ,c3mask(lx1,ly1,lz1,1)

      common /ctmp0/ im1(lx1,ly1,lz1),im2(lx1,ly1,lz1)
      integer e,f,val,im1,im2

      character*3 cb

      n = lx1*ly1*lz1

      nface = 2*ldim

      do e=1,nelv
         call izero (im1,n)
         call izero (im2,n)
         do f=1,nface
            cb  = cbc (f,e,1)
            if (cb.eq.'SYM')  call iface_e(im1,f,1,lx1,ly1,lz1)
            if (cb.eq.'A  ')  call iface_e(im2,f,2,lx1,ly1,lz1)
         enddo
         call icol2(im2,im1,n)

         k = 1
         do j=1,ly1,ly1-1
         do i=1,lx1,lx1-1
            if  ( im2(i,j,k) .eq. 2) then  ! corner of SYM & 'A  ' faces
               c1mask(i,j,k,e) = 0. 
               c2mask(i,j,k,e) = 0. 
            endif
         enddo
         enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine icol2(a,b,n)
      integer a(1),b(1)

      do i=1,n
         a(i)=a(i)*b(i)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine iface_e(a,iface,val,nx,ny,nz)

C     Assign the value VAL to face(IFACE,IE) of array A.
C     IFACE is the input in the pre-processor ordering scheme.

      include 'SIZE'
      integer a(nx,ny,nz),val
      call facind (kx1,kx2,ky1,ky2,kz1,kz2,nx,ny,nz,iface)
      do 100 iz=kz1,kz2
      do 100 iy=ky1,ky2
      do 100 ix=kx1,kx2
         a(ix,iy,iz)=val
  100 continue
      return
      end
c-----------------------------------------------------------------------
      function op_vlsc2_wt(b1,b2,b3,x1,x2,x3,wt)
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      real b1(1),b2(1),b3(1),x1(1),x2(1),x3(1),wt(1)

      nel = nelfld(ifield)
      n   = lx1*ly1*lz1*nel

      s = 0
      if (if3d) then
         do i=1,n
            s=s+wt(i)*(b1(i)*x1(i)+b2(i)*x2(i)+b3(i)*x3(i))
         enddo
      else
         do i=1,n
            s=s+wt(i)*(b1(i)*x1(i)+b2(i)*x2(i))
         enddo
      endif
      op_vlsc2_wt = s
      
      return
      end
c-----------------------------------------------------------------------
      function op_glsc2_wt(b1,b2,b3,x1,x2,x3,wt)
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      real b1(1),b2(1),b3(1),x1(1),x2(1),x3(1),wt(1)

      nel = nelfld(ifield)
      n   = lx1*ly1*lz1*nel

      s = 0
      if (if3d) then
         do i=1,n
            s=s+wt(i)*(b1(i)*x1(i)+b2(i)*x2(i)+b3(i)*x3(i))
         enddo
      else
         do i=1,n
            s=s+wt(i)*(b1(i)*x1(i)+b2(i)*x2(i))
         enddo
      endif
      op_glsc2_wt = glsum(s,1)
      
      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A single directive is used to protect a write. No data race pairs.

program DRB077_single_orig_no
    use omp_lib
    implicit none

    integer :: count
    count = 0

    !$omp parallel shared(count)
        !$omp single
        count = count + 1
        !$omp end single
    !$omp end parallel

    print 100, count
    100 format ('count =',i3)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two-dimensional array computation:
!ordered(2) is used to associate two loops with omp for.
!The corresponding loop iteration variables are private.
!
!ordered(n) is an OpenMP 4.5 addition. No data race pairs.


module DRB094
    implicit none
    integer, dimension(:,:), allocatable :: a
end module

program DRB094_doall2_ordered_orig_no
    use omp_lib
    use DRB094
    implicit none

    integer :: len, i, j
    len = 100

    allocate (a(len,len))

    !$omp parallel do ordered(2)
    do i = 1, len
        do j = 1, len
            a(i,j) = a(i,j)+1
            !$omp ordered depend(sink:i-1,j) depend (sink:i,j-1)
            print*,'test i =',i,'  j =',j
            !$omp ordered depend(source)
        end do
    end do
    !$omp end parallel do


end program

c-----------------------------------------------------------------------
      subroutine readat_par
C
C     Read in run parameters from .par file
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'RESTART'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'
c
      logical ifbswap

      call setDefaultParam

      if(nid.eq.0) call par_read(ierr)
      call bcast(ierr,isize)
      if(ierr .ne. 0) call exitt
      call bcastParam

      call usrdat0

      call read_re2_hdr(ifbswap, .true.)

      call chkParam

      call mapelpr  ! read .map file, est. gllnid, etc.

      call read_re2_data(ifbswap, .true., .true., .true.)

      call nekgsync()

      return
      end
c-----------------------------------------------------------------------
      subroutine setDefaultParam
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'RESTART'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'

      loglevel = 1
      optlevel = 1

      call rzero(param,200)
      call rzero(uparam,20)

      param(10) = 0    ! stop at numSteps
      param(14) = 0    ! iostep
      param(15) = 0    ! iotime 

      param(21) = 1e-5 ! pressure tolerance
      param(22) = 1e-7 ! velocity tolerance

      param(26) = 0.5  ! target Courant number
      param(27) = 2    ! 2nd order in time
      param(28) = 0    ! use same torder for mesh solver

      param(31) = 0    ! zero perturbations
      param(32) = 0    ! read all BC from .re2 
      param(33) = 0    ! use default field index for BCs to read from .re2 

      param(40) = 0    ! XXT 

      param(41) = 0    ! additive SEMG
      param(42) = 0    ! GMRES for iterative solver w/ nonsymmetric weighting
      param(43) = 0    ! additive multilevel scheme (requires param(42).eq.0)
      param(44) = 0    ! base top-level additive Schwarz on restrictions of E

      param(47) = 0.4  ! viscosity for mesh elasticity solver

      param(59) = 1    ! No fast operator eval

      param(65) = 1    ! just one i/o node
      param(66) = 6    ! write in binary
      param(67) = 6    ! read in binary
      param(93) = mxprev ! number of vectors for projection

      param(94) = 5    ! projection for helmholz solves (controled by ifprojfld) 
      param(95) = 0    ! projection for pressure solve
      param(99) = 4    ! enable dealising

      param(101) = 0   ! no additional modes
      param(103) = 0   ! filter weight
      filterType = 0   ! no filtering

      param(160) = 1   ! cvode use normal mode 
      param(161) = 2   ! cvode use stiff integration 
      param(162) = 0   ! cvode absolute tolerance
      param(163) = -1  ! cvode realtive tolerance
      param(164) = 100 ! cvode don't limit internal dt
      param(165) = 1   ! cvode increment factor DQJ
      param(166) = 0   ! cvode use default ratio linear/non-linear tolerances
      param(167) = 0   ! cvode use no preconditioner

      restol(0) = param(22)
      restol(1) = param(22)
      do i=1,ldimt
         restol(1+i) = param(22) 
      enddo

      iftmsh(0) = .false. 
      iftmsh(1) = .false. 
      do i=1,ldimt
         iftmsh(1+i) = .false.
      enddo

      ifxyo = .true.
      ifvo  = .false.
      ifpo  = .false.
      ifto  = .false.   
      do i=1,ldimt1
         ifpsco(i) = .false.
      enddo 

      ifadvc(1) = .true.  
      do i=1,ldimt
         ifadvc(i+1) = .true.  
      enddo 

      iffilter(1) = .false.  
      do i=1,ldimt
         iffilter(i+1) = .false.  
      enddo 

      ifdgfld(0) = .false. 
      ifdgfld(1) = .false. 
      do i=1,ldimt
         ifdgfld(i+1) = .false.  
      enddo 

      ifdiff(1) = .true.  
      do i=1,ldimt
         ifdiff(i+1) = .true.  
      enddo 

      ifdeal(1) = .true.  
      do i=1,ldimt
         ifdeal(i+1) = .true.  
      enddo 

      do i=1,ldimt
         idpss(i) = -1
      enddo 

      meshPartitioner=3 ! HYBRID (RSB+RCB)

      ifprojfld(0) = .false. 
      ifprojfld(1) = .false. 
      do i=1,ldimt
         ifprojfld(1+i) = .false.
      enddo

      ifflow    = .false.
      ifheat    = .false.  
      iftran    = .true.   
      ifaxis    = .false.  
      ifstrs    = .false. 
      iflomach  = .false. 
      ifmvbd    = .false.
      ifchar    = .false.  
      ifmhd     = .false. 
      ifuservp  = .false.  
      ifcyclic  = .false.
      ifusermv  = .false.
      ifmgrid   = .true.
      ifessr    = .false.
      ifreguo   = .false.
      ifbase    = .true.   
      ifpert    = .false. 
      ifaziv    = .false. 
      ifmoab    = .false.  
      ifcvode   = .false.

      ifdg      = .false.
      ifsync    = .false.  
      ifanls    = .false.  
      ifcoup    = .false.  
      ifvcoup   = .false.  
      ifexplvis = .false.
      ifcons    = .false.   

      ifmodel   = .false. 
      ifkeps    = .false.
      ifschclob = .false. 

      ifdp0dt   = .false.
      ifreguo   = .false.   ! dump on the GLL mesh

      fem_amg_param(1) = 0
      crs_param(1) = 0

      call izero(matype,16*ldimt1)
      call rzero(cpgrp ,48*ldimt1)

      call blank (initc,15*132)

      return
      end
c-----------------------------------------------------------------------
      subroutine par_read(ierr)
c
c     parse .par file and set run parameters
c
c     todo:
c     - check for invalid values for a given key
c     - print default value to screen
c     - separate settings for tol, proj, dealiasing for ps
c     - mhd support

      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'ADJOINT'
      INCLUDE 'RESTART'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'
      INCLUDE 'TSTEP'

      character*132 c_out,txt, txt2

      call finiparser_load(parfle,ierr)
      if(ierr .ne. 0) return

      call par_verify(ierr)
      if(ierr .ne. 0) return

c set parameters
      call finiparser_getDbl(d_out,'general:loglevel',ifnd)
      if(ifnd .eq. 1) loglevel = d_out

      call finiparser_getDbl(d_out,'general:optlevel',ifnd)
      if(ifnd .eq. 1) optlevel = d_out

      call finiparser_getString(c_out,'general:stopAt',ifnd)
      if (ifnd .eq. 1) then
         call capit(c_out,132)
         if (index(c_out,'ENDTIME') .eq. 1) then
            call finiparser_getDbl(d_out,'general:endTime',ifnd)
            if (ifnd .eq. 1) then
               param(10) = d_out
            else
               write(6,*) 'general:endTime'
               write(6,*) 'is required for general:stopAt = endTime!'
               goto 999
            endif
         else if (index(c_out,'NUMSTEPS') .eq. 1) then
            call finiparser_getDbl(d_out,'general:numSteps',ifnd)
            if (ifnd .eq. 1) then
               param(11) = d_out 
            else
               write(6,*) 'general:numSteps'
               write(6,*) 'is required for general:stopAt = numSteps!'
               goto 999
            endif
         else
            write(6,*) 'value: ',trim(c_out)
            write(6,*) 'is invalid for general:stopAt!'
            goto 999
         endif
      else
         call finiparser_getDbl(d_out,'general:numSteps',ifnd)
         if (ifnd .eq. 1) then 
            param(11) = d_out 
         endif
      endif

      call finiparser_getDbl(d_out,'general:dt',ifnd)
      if (ifnd .eq. 1) then
         param(12) = d_out
      endif

      param(12) = -1*abs(param(12))
      call finiparser_getBool(i_out,'general:variableDt',ifnd)
      if (ifnd .eq. 1) then
         if (i_out .eq. 1) then
            param(12) = abs(param(12)) 
            call finiparser_getDbl(d_out,'general:targetCFL',ifnd)
            if (ifnd .eq. 1) then
               param(26) = d_out
            else
               write(6,*) 'general:targetCFL'
               write(6,*) 'is required for general:variableDt!'
               goto 999
            endif
         endif
      endif

      call finiparser_getDbl(d_out,'general:writeInterval',ifnd)
      if (ifnd .eq. 1) param(15) = d_out
      call finiparser_getString(c_out,'general:writeControl',ifnd)
      if (ifnd .eq. 1) then
         call capit(c_out,132)
         if (index(c_out,'RUNTIME') .eq. 1) then
            param(14) = d_out
            param(15) = 0
         else if (index(c_out,'TIMESTEP') .eq. 1) then
            param(14) = 0
            param(15) = d_out
         else if (index(c_out,'ELAPSEDTIME') .eq. 1) then
            param(14) = d_out
            param(15) = 0
            timeioe = 1
         else
            write(6,*) 'value: ',trim(c_out)
            write(6,*) 'is invalid for general:writeControl!'
            goto 999
         endif
      endif

      call finiparser_getDbl(d_out,'pressure:residualTol',ifnd)
      if(ifnd .eq. 1) param(21) = d_out 
      call finiparser_getDbl(d_out,'velocity:residualTol',ifnd)
      if(ifnd .eq. 1) then
        restol(1) = d_out 
        param(22) = d_out
      endif

      call finiparser_find(i_out,'temperature',ifnd)
      if(ifnd .eq. 1) then
        ifheat = .true.
        ifto   = .true.
        idpss(1) = 0 ! Helmholtz is default
      endif

      j = 0
      do i = 1,99
         write(txt,"('scalar',i2.2)") i
         call finiparser_find(i_out,txt,ifnd)
         if (ifnd .eq. 1) j = j + 1
      enddo
      if (j.gt.ldimt-1) then
         write(6,*) 'found more scalars than specified in SIZE!' 
         goto 999
      endif

      j = 0
      do i = 1,ldimt-1
         write(txt,"('scalar',i2.2)") i
         call finiparser_find(i_out,txt,ifnd)
         if (ifnd .eq. 1) then
            j = j + 1 
            ifpsco(i) = .true.
            idpss(i+1) = 0 ! Helmholtz is default
         endif
      enddo
      param(23) = j ! number of scalars 
      n = param(23)
 
      is = 2
      if (ifheat) is = 1 

      do i = is,n+1

      if (i.eq.1) then
        txt = 'temperature'
      else
        write(txt,"('scalar',i2.2)") i-1
      endif

      call finiparser_getString(c_out,trim(txt)//':solver',ifnd)
      call capit(c_out,132)
      if(ifnd .eq. 1) then 
        if (index(c_out,'CVODE') .eq. 1) then
          idpss(i) = 1
          call finiparser_getDbl(d_out,trim(txt)//':absoluteTol',ifnd)
          if (ifnd .eq. 1) then
             atol(i+1) = d_out 
          else
             write(6,*) trim(txt) // ':absoluteTol' 
             write(6,*) 'is required for ',trim(txt)//':solver = CVODE'
             goto 999
          endif
        else if (index(c_out,'HELM') .eq. 1) then
          continue
        else if (index(c_out,'NONE') .eq. 1) then
          idpss(i) = -1
        else
           write(6,*) 'value: ',trim(c_out)
           write(6,*) 'is invalid for ',trim(txt)//':solver!' 
           goto 999
        endif
      else
        call finiparser_getDbl(d_out,trim(txt)//':residualTol',ifnd)
        if (ifnd .eq. 1) then
           restol(i+1) = d_out 
        endif
      endif
      call finiparser_getBool(i_out,trim(txt)//':residualProj',ifnd)
      if (ifnd .eq. 1) then
         ifprojfld(i+1) = .false.
         if(i_out .eq. 1) ifprojfld(i+1) = .true.
      endif
 
      enddo

      call finiparser_getDbl(d_out,'cvode:absoluteTol',ifnd)
      if(ifnd .eq. 1) param(162) = d_out 
      call finiparser_getDbl(d_out,'cvode:relativeTol',ifnd)
      if(ifnd .eq. 1) param(163) = d_out 
      call finiparser_getDbl(d_out,'cvode:dtmax',ifnd)
      if(ifnd .eq. 1) param(164) = d_out 
      call finiparser_getDbl(d_out,'cvode:DQJincrementFactor',ifnd)
      if(ifnd .eq. 1) param(165) = d_out 
      call finiparser_getDbl(d_out,'cvode:ratioLNLtol',ifnd)
      if(ifnd .eq. 1) param(166) = d_out 

      call finiparser_getString(c_out,'cvode:preconditioner',ifnd)
      call capit(c_out,132)
      if(ifnd .eq. 1) then 
        if (index(c_out,'USER') .eq. 1) then
           param(167) = 1
        else if (index(c_out,'NONE') .eq. 1) then
           param(167) = 0
        else
           write(6,*) 'value: ',trim(c_out)
           write(6,*) 'is invalid for cvode:preconditioner!' 
           goto 999
        endif
      endif

      j = 0
      do i = 1,ldimt
         if (idpss(i).ge.0) j = j + 1
      enddo
      if (j .ge. 1) then ! we have to solve for temp and/or ps
         ifheat = .true.  
      else
         ifheat = .false.
      endif

      call finiparser_getDbl(d_out,'magnetic:viscosity',ifnd)
      if(ifnd .eq. 1) param(29) = d_out 
      if(param(29).lt.0.0) param(29) = -1.0/param(29)

      call finiparser_getDbl(d_out,'mesh:numberOfBCFields',ifnd)
      if(ifnd .eq. 1) param(32) = int(d_out)

      call finiparser_getDbl(d_out,'mesh:firstBCFieldIndex',ifnd)
      if(ifnd .eq. 1) param(33) = int(d_out)

      call finiparser_getString(c_out,'pressure:solver',ifnd)
      if (ifnd .eq. 1) then 
         call capit(c_out,132)
         if (index(c_out,'GMRES') .eq. 1) then
            param(42) = 0
         else if (index(c_out,'CGFLEX') .eq. 1) then
            param(42) = 2
         else
            write(6,*) 'value: ',trim(c_out)
            write(6,*) 'not supported for pressure:solver!'
            goto 999
         endif
      endif

      call finiparser_getString(c_out,'pressure:preconditioner',ifnd)
      if (ifnd .eq. 1) then 
         call capit(c_out,132)
         if (index(c_out,'SEMG_XXT') .eq. 1) then
            param(40) = 0
        else if (index(c_out,'SEMG_AMG_HYPRE') .eq. 1) then
            param(40) = 2
         else if (index(c_out,'SEMG_AMG') .eq. 1) then
            param(40) = 1
         else if (index(c_out,'FEM_AMG_HYPRE') .eq. 1) then
            param(40) = 3
         else
           write(6,*) 'value: ',trim(c_out)
           write(6,*) 'is invalid for pressure:preconditioner!'
           goto 999
         endif
      endif 

      call finiparser_getBool(i_out,'general:writeDoublePrecision',ifnd)
      if(ifnd .eq. 1 .and. i_out .eq. 1) param(63) = 1 

      call finiparser_getDbl(d_out,'general:writeNFiles',ifnd)
      if(ifnd .eq. 1) param(65) = int(d_out) 

      call finiparser_getBool(i_out,'velocity:residualProj',ifnd)
      if(ifnd .eq. 1) then
        ifprojfld(1) = .false.
        if(i_out .eq. 1) ifprojfld(1) = .true. 
      endif

      call finiparser_getBool(i_out,'pressure:residualProj',ifnd)
      if(ifnd .eq. 1) then
        param(95) = 0
        if(i_out .eq. 1) param(95) = 5 
      endif

      call finiparser_getBool(i_out,'general:dealiasing',ifnd)
      if(ifnd .eq. 1 .and. i_out .eq. 0) param(99) = -1 

c     filtering parameters
      call finiparser_getString(c_out,'general:filtering',ifnd)
      if (ifnd .eq. 1) then
c        stabilization type: none, explicit or hpfrt    
         call capit(c_out,132)
         if (index(c_out,'NONE') .eq. 1) then
            filterType = 0
            goto 101
         else if (index(c_out,'EXPLICIT') .eq. 1) then
            filterType = 1
            call ltrue(iffilter,size(iffilter))
         else if (index(c_out,'HPFRT') .eq. 1) then
            filterType = 2
            call ltrue(iffilter,size(iffilter))
         else
           write(6,*) 'value: ',c_out
           write(6,*) 'is invalid for general:filtering!'
           goto 999
         endif
         call finiparser_getDbl(d_out,'general:filterWeight',ifnd)
         if (ifnd .eq. 1) then
            param(103) = d_out 
         else
            write(6,*) 'general:filterWeight'
            write(6,*) 'is required for general:filtering!'
            goto 999
         endif
         call finiparser_getDbl(d_out,'general:filterModes',ifnd)
         if (ifnd .eq. 1) then
            param(101) = int(d_out) - 1
            if (int(param(101)).eq.0) filterType = 0
         else
            call finiparser_getDbl
     $           (d_out,'general:filterCutoffRatio',ifnd)
            if (ifnd .eq. 1) then
              dtmp = anint(lx1*(1.0 - d_out)) 
              param(101) = max(dtmp-1,0.0)
              if (abs(1.0 - d_out).lt.0.01) filterType = 0
            else 
              write(6,*) 'general:filterCutoffRatio or filterModes'
              write(6,*) 'is required for general:filtering!'
              goto 999
            endif
         endif
 101     continue 
      endif

      call finiparser_getString(c_out,'cvode:mode',ifnd)
      call capit(c_out,132)
      if (index(c_out,'NORMAL') .eq. 1) param(160) = 1
      if (index(c_out,'NORMAL_TSTOP' ) .eq. 1) param(160) = 3
 
      do i = 1,20
         call blank(txt,132)
         write(txt,"('general:userParam',i2.2)") i
         call finiparser_getDbl(d_out,txt,ifnd)
         if(ifnd .eq. 1) uparam(i) = d_out
      enddo

c set logical flags
      call finiparser_getString(c_out,'general:timeStepper',ifnd)
      if (ifnd .eq. 1) then
        call capit(c_out,132)

        if (index(c_out,'BDF1') .eq. 1) then
           param(27) = 1 
        else if (index(c_out,'BDF2') .eq. 1) then
           param(27) = 2 
        else if (index(c_out,'BDF3') .eq. 1) then
           param(27) = 3 
        else
           write(6,*) 'value: ',trim(c_out)
           write(6,*) 'is invalid for general:timeStepper!'
           goto 999
        endif
      endif

      call finiparser_getString(c_out,'general:extrapolation',ifnd)
      if (ifnd .eq. 1) then
        call capit(c_out,132)
        if (index(c_out,'OIFS') .eq. 1) then
           ifchar = .true.

           call finiparser_getDbl(d_out,'general:targetCFL',ifnd)
           if (ifnd .eq. 1) then
              param(26) = d_out
           else
              write(6,*) 'general:targetCFL'
              write(6,*) 'is required for general:extrapolation!'
              goto 999
           endif
        else if (index(c_out,'STANDARD') .eq. 1) then
           continue
        else
           write(6,*) 'value: ',trim(c_out)
           write(6,*) 'is invalid for general:extrapolation!'
           goto 999
        endif
      endif

      call finiparser_find(i_out,'velocity',ifnd)
      if(ifnd .eq. 1) then
        ifflow = .true.
        ifvo   = .true.
        ifpo   = .true.
      endif

      call finiparser_getString(c_out,'mesh:motion',ifnd)
      if (ifnd .eq. 1) then
       call capit(c_out,132)
       if (index(c_out,'ELASTICITY') .eq. 1) then
          ifmvbd = .true.
          call finiparser_getDbl(d_out,'mesh:viscosity',ifnd)
          if (ifnd .eq. 1) param(47) = d_out
          call finiparser_getBool(i_out,'mesh:residualProj',ifnd)
          if (ifnd .eq. 1) then
             ifprojfld(0) = .false.
             if(i_out .eq. 1) ifprojfld(0) = .true. 
          endif
        else if (index(c_out,'USER') .eq. 1) then
          ifmvbd = .true.
          ifusermv = .true.
        else if (index(c_out,'NONE') .eq. 1) then
          continue
        else
          write(6,*) 'value: ',trim(c_out)
          write(6,*) 'is invalid for mesh:motion!'
          goto 999
        endif
      endif
      call finiparser_getDbl(d_out,'mesh:residualTol',ifnd)
      if(ifnd .eq. 1) restol(0) = d_out 

      call finiparser_getBool(i_out,'problemType:axiSymmetry',ifnd)
      if(ifnd .eq. 1) then
        ifaxis = .false.
        if(i_out .eq. 1) ifaxis = .true.
      endif

      call finiparser_getBool(i_out,'problemType:swirl',ifnd)
      if(ifnd .eq. 1) then
        ifaziv = .false.
        if(i_out .eq. 1) ifaziv = .true.
      endif

      call finiparser_getBool(i_out,'problemType:cyclicBoundaries',ifnd)
      if(ifnd.eq.1) then
        ifcyclic = .false.
        if(i_out .eq. 1) ifcyclic = .true.
      endif

      call finiparser_getString(c_out,'problemType:equation',ifnd)
      call capit(c_out,132)
      if (index(c_out,'STEADYSTOKES').eq.1) then
         iftran = .false.
         ifadvc(1) = .false.
      else if (index(c_out,'STOKES').eq.1) then
         ifadvc(1) = .false.
      else if (index(c_out,'STEADYHEAT').eq.1) then
         iftran = .false.
         ifflow = .false. 
         ifheat = .true.
         ifadvc(2) = .false.
      else if (index(c_out,'LOWMACHNS').eq.1) then
         iflomach = .true.
      else if (index(c_out,'INCOMPLINNS').eq.1 .or.
     $         index(c_out,'INCOMPLINADJNS').eq.1) then
         ifpert = .true.
         if (index(c_out,'INCOMPLINADJNS').eq.1) ifadj  = .true.
         call finiparser_getDbl
     $        (d_out,'problemType:numberOfPerturbations',ifnd)
         if (ifnd .eq. 1) then
            param(31) = int(d_out) 
         else
            param(31) = 1 
         endif
         call finiparser_getBool
     $        (i_out,'problemType:solveBaseFlow',ifnd)
         if (ifnd .eq. 1) then
            ifbase = .false.
            if(i_out .eq. 1) ifbase = .true.
         else
            write(6,*) 'problemType:solveBaseFlow'
            write(6,*) 'is required for ', trim(c_out) 
            goto 999
         endif
      else if (index(c_out,'COMPNS') .eq. 1) then
#ifdef CMTNEK
         continue
#else
         write(6,*) 'value: ',trim(c_out)
         write(6,*) 'not supported for problemType:equation!'
         write(6,*) 'Recompile with CMTNEK ...'
         goto 999
#endif
      else if (index(c_out,'INCOMPMHD') .eq. 1) then
         write(6,*) 'value: ',trim(c_out)
         write(6,*) 'not yet supported for problemType:equation!'
         goto 999
      endif

      call finiparser_getBool(i_out,
     &                        'problemType:stressFormulation',ifnd)
      if(ifnd .eq. 1) then
        ifstrs = .false.
        if(i_out .eq. 1) ifstrs = .true.
      endif

      call finiparser_getBool(i_out,
     &                        'problemType:variableProperties',ifnd)
      if(ifnd .eq. 1) then
        ifuservp = .false.
        if(i_out .eq. 1) ifuservp = .true.
      endif

      call finiparser_getBool(i_out,'problemType:dp0dt',ifnd)
      if(ifnd .eq. 1) then
        if(i_out .eq. 1) ifdp0dt = .true.
      endif

      call finiparser_getBool(i_out,'cvode:stiff',ifnd)
      if(ifnd .eq. 1) then
        param(161) = 1 ! AM
        if(i_out .eq. 1) param(161) = 2 !BDF
      endif

c set advection
      call finiparser_getBool(i_out,'velocity:advection',ifnd)
      if(ifnd .eq. 1) then
        ifadvc(1) = .false.
        if(i_out .eq. 1) ifadvc(1) = .true.
      endif
 
      call finiparser_getBool(i_out,'temperature:advection',ifnd)
      if(ifnd .eq. 1) then
        ifadvc(2) = .false.
        if(i_out .eq. 1) ifadvc(2) = .true.
      endif

      do i = 1,ldimt-1
         write(txt,"('scalar',i2.2,a)") i,':advection'
         call finiparser_getBool(i_out,txt,ifnd)
         if(ifnd .eq. 1) then
           ifadvc(i+2) = .false.
           if(i_out .eq. 1) ifadvc(i+2) = .true.
         endif
      enddo

c set mesh-field mapping
      call finiparser_getBool(i_out,'temperature:conjugateHeatTransfer',
     &                        ifnd)
      if(ifnd .eq. 1) then
        if(i_out .eq. 1) then
          iftmsh(0) = .true.
          iftmsh(2) = .true.
        endif
      endif

      do i = 1,ldimt-1
         write(txt,"('scalar',i2.2,a)") i,':conjugateHeatTransfer'
         call finiparser_getBool(i_out,txt,ifnd)
         if(ifnd .eq. 1) then
           iftmsh(i+2) = .false.
           if(i_out .eq. 1) iftmsh(i+2) = .true.
         endif
      enddo

c set output flags
      call finiparser_getBool(i_out,'mesh:writeToFieldFile',ifnd) 
      if(ifnd .eq. 1) then
        ifxyo = .false.
        if(i_out .eq. 1) ifxyo = .true.
      endif

      call finiparser_getBool(i_out,'velocity:writeToFieldFile',ifnd)
      if(ifnd .eq. 1) then
        ifvo = .false.
        if(i_out .eq. 1) ifvo = .true.
      endif

      call finiparser_getBool(i_out,'pressure:writeToFieldFile',ifnd)
      if(ifnd .eq. 1) then
        ifpo = .false.
        if(i_out .eq. 1) ifpo = .true.
      endif

      call finiparser_getBool(i_out,'temperature:writeToFieldFile',ifnd)
      if(ifnd .eq. 1) then
        ifto = .false.
        if(i_out .eq. 1) ifto = .true.
      endif

      do i = 1,ldimt-1
         write(txt,"('scalar',i2.2,a)") i,':writeToFieldFile'
         call finiparser_getBool(i_out,txt,ifnd)
         if(ifnd .eq. 1) then
           ifpsco(i) = .false.
           if(i_out .eq. 1) ifpsco(i) = .true.
         endif
      enddo

c set properties
      call finiparser_getDbl(d_out,'velocity:viscosity',ifnd)
      if(ifnd .eq. 1) cpfld(1,1) = d_out 
      if (cpfld(1,1) .lt.0.0) cpfld(1,1)  = -1.0/cpfld(1,1)
      call finiparser_getDbl(d_out,'velocity:density',ifnd)
      if(ifnd .eq. 1) cpfld(1,2) = d_out 

      call finiparser_getDbl(d_out,'temperature:conductivity',ifnd)
      if(ifnd .eq. 1) cpfld(2,1) = d_out 
      if (cpfld(2,1) .lt.0.0) cpfld(2,1)  = -1.0/cpfld(2,1)
      call finiparser_getDbl(d_out,'temperature:rhoCp',ifnd)
      if(ifnd .eq. 1) cpfld(2,2) = d_out 

      do i = 1,ldimt-1
         write(txt,"('scalar',i2.2,a)") i,':diffusivity'
         call finiparser_getDbl(d_out,txt,ifnd)
         if(ifnd .eq. 1) cpfld(2+i,1) = d_out 
         if(cpfld(2+i,1) .lt.0.0) cpfld(2+i,1)  = -1.0/cpfld(2+i,1)
         write(txt,"('scalar',i2.2,a)") i,':density'
         call finiparser_getDbl(d_out,txt,ifnd)
         if(ifnd .eq. 1) cpfld(2+i,2) = d_out 
      enddo

c set restart options
      call finiparser_findTokens('general:startFrom', ',' , ifnd)
      do i = 1,min(ifnd,15)
         call finiparser_getToken(initc(i),i)
         if(index(initc(i),'0') .eq. 1) call blank(initc(i),132)
      enddo

c set partitioner options
      call finiparser_getString(c_out,'mesh:partitioner',ifnd)
      call capit(c_out,132)
      if(index(c_out,'RSB').eq.1) then
         meshPartitioner=1
      else if(index(c_out,'RCB').eq.1) then
         meshPartitioner=2
      else if (index(c_out,'RCBRSB').eq.1) then
         meshPartitioner=3
      else if (index(c_out,'METIS').eq.1) then
         meshPartitioner=4
      endif

100   if(ierr.eq.0) call finiparser_dump()
      return

c error handling
 999  continue
      ierr = 1
      goto 100

      end
c-----------------------------------------------------------------------
      subroutine bcastParam
C
C     Broadcast run parameters to all processors
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      INCLUDE 'RESTART'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'
      INCLUDE 'ADJOINT'
      INCLUDE 'CVODE'

      call bcast(loglevel, isize)
      call bcast(optlevel, isize)

      call bcast(param , 200*wdsize)
      call bcast(uparam, 20*wdsize)

      call bcast(filterType, wdsize)

      call bcast(atol ,  (ldimt1+1)*wdsize)
      call bcast(restol, (ldimt1+1)*wdsize)

      call bcast(ifchar , lsize)
      call bcast(iftran  , lsize)
      call bcast(ifflow  , lsize)
      call bcast(ifheat  , lsize)     
      call bcast(iflomach, lsize)
      call bcast(ifstrs  , lsize)
      call bcast(ifmvbd  , lsize)
      call bcast(ifusermv, lsize)
      call bcast(ifdp0dt,  lsize)
      call bcast(ifaxis  , lsize)
      call bcast(ifcyclic, lsize)
      call bcast(ifmhd   , lsize)
      call bcast(ifuservp, lsize)
      call bcast(ifpert, lsize)
      call bcast(ifbase, lsize)
      call bcast(ifmoab, lsize)
      call bcast(ifaziv, lsize)
      call bcast(ifadj , lsize)

      call bcast(ifadvc ,  ldimt1*lsize)
      call bcast(ifdiff ,  ldimt1*lsize)
      call bcast(ifdeal ,  ldimt1*lsize)
      call bcast(iffilter, ldimt1*lsize)

      call bcast(idpss    ,  ldimt*isize)

      call bcast(meshPartitioner,isize)

      call bcast(iftmsh   , (ldimt1+1)*lsize)
      call bcast(ifprojfld, (ldimt1+1)*lsize)

      call bcast(cpfld, 3*ldimt1*wdsize)

      call bcast(ifxyo , lsize)
      call bcast(ifvo  , lsize)
      call bcast(ifpo  , lsize)
      call bcast(ifto  , lsize)
      call bcast(ifpsco, ldimt1*lsize)

      call bcast(initc, 15*132*csize) 

      call bcast(timeioe,sizeof(timeioe))

c set some internals 
      if (ldim.eq.3) if3d=.true.
      if (ldim.ne.3) if3d=.false.

      param(1) = cpfld(1,2)
      param(2) = cpfld(1,1)
      param(7) = cpfld(2,2)
      param(8) = cpfld(2,1)

      npscal=int(param(23)) ! number of scalar sections
      npscl1=npscal+1
      npscl2=npscal+2
 
      npert = abs(param(31)) 

      if (if3d) ifaxis = .false.
      if (ifaxis) param(99) = 3             ! For now, at least.

      ifldmhd = npscal + 3
      if (ifmhd) then
         ifessr = .true.
         ifchar = .false.
         npscl1 = npscl1 + 1
         cpfld(ifldmhd,1) = param(29)  ! magnetic viscosity
         cpfld(ifldmhd,2) = param( 1)  ! magnetic rho same as for fluid
      endif

      if (ifaxis.and..not.ifsplit) then ! Use standard Schwarz/PCG solver
         ifmgrid   = .false.
         param(42) = 1.00000  !  p042 0=gmres/1=pcg
         param(43) = 1.00000  !  p043 0=semg/1=schwarz
         param(44) = 1.00000  !  p044 0=E-based/1=A-based prec.
      endif

      if (.not.iftran) then
         if (ifflow.and.ifsplit) then
            iftran=.true. ! no steady Stokes support for Pn/Pn
         else
            param(11) = 1.0
            param(12) = 1.0
            param(19) = 0.0
         endif
      endif

      cv_nfld = 0
      do i = 1,ldimt
         if (idpss(i) .gt. 0) then
           cv_nfld = cv_nfld + 1
           ifcvfld(i+1) = .true.
         endif
      enddo
      if (cv_nfld.gt.0) ifcvode = .true.

      return
      END
c-----------------------------------------------------------------------
      subroutine chkParam
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'RESTART'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'
c
      neltmx=np*lelt
      nelvmx=np*lelv

      neltmx=min(neltmx,lelg)
      nelvmx=min(nelvmx,lelg)

      nelgt = iglmax(nelgt,1)
      nelgv = iglmax(nelgv,1)

      if (npscal+1.gt.ldimt) then
         if(nid.eq.0) then
           write(6,21) ldimt,npscal+1
   21      format(//,2x,'Error: Nek has been compiled'
     $             /,2x,'       for max.',i4,' scalars. This run'
     $             /,2x,'       requires that ldimt be set to',i4,'.')
         endif
         call exitt
      endif

      if (nelgt.gt.neltmx.or.nelgv.gt.nelvmx) then
         if (nid.eq.0) then
          lelt_needed = nelgt/np
          if (mod(nelgt,np).ne.0) lelt_needed = lelt_needed + 1 
          write(6,82) lelt,lelg,lelt_needed,np,nelgt
   82         format(//,2X,'Error: Nek has has been compiled for'
     $         ,/,2X,      '       number of elements/proc  (lelt):',i12
     $         ,/,2X,      '       total number of elements (lelg):',i12
     $         ,/,2X
     $         ,/,2X,'This run requires:'
     $         ,/,2X,'   lelt >= ',i12,'  for np = ',i12
     $         ,/,2X,'   lelg >= ',i12,/)
         endif
         call exitt
      endif

      if (ifmvbd) then
         if (lx1.ne.lx1m.or.ly1.ne.ly1m.or.lz1.ne.lz1m) 
     $    call exitti
     $    ('Error: Mesh motion requires lx1m=lx1 etc. in SIZE . $',lx1m)
      endif

      IF(ldimr.NE.LDIM) THEN
         IF(NID.EQ.0) THEN
           WRITE(6,10) LDIM,ldimr
   10      FORMAT(//,2X,'Error: Nek has been compiled'
     $             /,2X,'       for spatial dimension equal to',I2,'.'
     $             /,2X,'       The mesh file has dimension',I2,'.')
         ENDIF
         call exitt
      ENDIF

      if (lpert.lt.npert) then
         if(nid.eq.0) write(6,*) 
     $   'ERROR: Increase lpert in SIZE to', npert
         call exitt
      endif

      IF (NPSCAL+1.GT.LDIMT .AND. IFMHD) THEN
         if(nid.eq.0) then
           WRITE(6,22) LDIMT,NPSCAL+1
   22      FORMAT(/s,2X,'Error: Nek has been compiled'
     $             /,2X,'       for',I4,' scalars.  A MHD run'
     $             /,2X,'       requires that LDIMT be set to',I4,'.')
         endif
         call exitt
      ENDIF

      if (if3d) then
         if (ly1.ne.lx1.or.lz1.ne.lx1) then
            if (nid.eq.0) write(6,13) lx1,ly1,lz1
   13       format('ERROR: lx1,ly1,lz1:',3i5,' must be equal for 3D')
            call exitt
         endif
         if (ly2.ne.lx2.or.lz2.ne.lx2) then
            if (nid.eq.0) write(6,14) lx2,ly2,lz2
   14       format('ERROR: lx2,ly2,lz2:',3i5,' must be equal for 3D')
            call exitt
         endif
      else
         if (ly1.ne.lx1.or.lz1.ne.1) then
            if (nid.eq.0) write(6,12) lx1,ly1,lz1
   12       format('ERROR: ',3i5,' must have lx1=ly1; lz1=1, for 2D')
            call exitt
         endif
         if (ly2.ne.lx2.or.lz2.ne.1) then
            if (nid.eq.0) write(6,11) lx2,ly2,lz2
   11       format('ERROR: ',3i5,' must have lx2=ly2; lz2=1, for 2D')
            call exitt
         endif
      endif

      if (lgmres.lt.5 .and. param(42).eq.0) then
         if(nid.eq.0) write(6,*)
     $   'WARNING: lgmres might be too low!'
      endif

      if (ifsplit) then
         if (lx1.ne.lx2) then
            if (nid.eq.0) write(6,43) lx1,lx2
   43    format('ERROR: lx1,lx2:',2i4,' must be equal for IFSPLIT=T')
            call exitt
         endif
      else
         if (lx2.ne.lx1-2) then
            if (nid.eq.0) write(6,44) lx1,lx2
   44    format('ERROR: lx1,lx2:',2i4,' lx2 must be lx-2 for IFSPLIT=F')
           call exitt
         endif
      endif

      if (param(40).eq.3 .and. .not.ifsplit) then
         call exitti
     $    ('ERROR: Selected preconditioner requires lx2=lx1$',lx2)
      endif

      if (ifsplit .and. ifuservp .and. .not.ifstrs) then
         if(nid.eq.0) write(6,*) 
     $   'Enable stress formulation to support PN/PN and IFUSERVP=T' 
         ifstrs = .true.
      endif

      if (ifcyclic .and. .not.ifstrs) then
         if(nid.eq.0) write(6,*) 
     $   'Enable stress formulation to support cyclic BC' 
         ifstrs = .true.
      endif

      ktest = (lx1-lx1m) + (ly1-ly1m) + (lz1-lz1m)
      if (ifstrs.and.ktest.ne.0) then
         if(nid.eq.0) write(6,*) 
     $   'ERROR: Stress formulation requires lx1m=lx1, etc. in SIZE'
         call exitt
      endif

      if (ifsplit .and. ifmhd) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: No MHD support for Pn-Pn'
         call exitt
      endif

      if (ifmhd .and. lbx1.ne.lx1) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: For MHD, need lbx1=lx1, etc.; Change SIZE '
         call exitt
      endif

      if (ifpert .and. lpx1.ne.lx1) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: For Lyapunov, need lpx1=lx1, etc.; Change SIZE '
      endif

      if (ifpert .and. ifsplit) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: For Lyapunov, need lx2=lx1-2, etc. in SIZE'
      endif 

      if (iflomach .and. .not.ifsplit) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: For lowMach, need lx2=lx1, etc.; Change SIZE '
         call exitt
      endif

      if (iflomach .and. .not.ifheat) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: For lowMach, need to solve for temperature too!'
         call exitt
      endif

      if (ifdp0dt .and. .not.iflomach) then
         if(nid.eq.0) write(6,*) 
     $   'ABORT: Varying p0 requires lowMach! '
         call exitt
      endif

      if (ifchar .and. param(99).lt.0) then
        if (nid.eq.0) write(6,*) 
     &     'ABORT: Characteristic scheme needs dealiasing!'
        call exitt
      endif

      if (.not.ifsplit .and. ifaxis .and. ifstrs) then
        if (nid.eq.0) write(6,*)
     $    'ABORT: Axisymetric and stress formulation not supported ' //
     $    'for PN/PN-2$'
        call exitt
      endif

      if (ifchar.and.(nelgv.ne.nelgt)) call exitti(
     $ 'ABORT: Characteristics not supported w/ conj. ht transfer$',1)

      if (param(99).gt.-1 .and. (lxd.lt.lx1 .or. lyd.lt.ly1 .or.
     &   lzd.lt.lz1)) then
         if(nid.eq.0) write(6,*)
     &   'ABORT: Dealiasing space too small; Check lxd,lyd,lzd in SIZE '
         call exitt
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine par_verify(ierr)

      INCLUDE 'PARDICT'

      
      character*132  key
      character*1024 val

      character*132 txt
      character*1   tx1(132)
      equivalence   (tx1,txt)

      ierr = 0

      call finiparser_getDictEntries(n)
      do i = 1,n
         call finiparser_getPair(key,val,i,ifnd)
         call capit(key,132)

         is = index(key,'_') ! ignore user keys
         if (is.eq.1) goto 10

         do j = 1,PARDICT_NKEYS ! do we find the key in the par-dictionary 
            if(index(pardictkey(j),key).eq.1) goto 10      

            is = index(key,'SCALAR')
            if(is .eq. 1) then
              call chcopy(txt,key,132)
              call chcopy(tx1(is+6),'%%',2) 
              if(index(pardictkey(j),txt).eq.1) goto 10
            endif
         enddo
         write(6,*) 'ERROR: Par file contains unknown key ', key
         ierr = ierr + 1
   10 enddo

      return
      end

c---------------------------------------------------------------------
c VisIt Simulation Code for Nek5000
c
c   Provide a connection to VisIt simulation code. You will be able
c to connect to VisIt and drive the simulation though VisIt or
c have sim code send data to VisIt. 
c---------------------------------------------------------------------

c---------------------------------------------------------------------
c visit_init
c
c   Initialize VisIt. This will create the sim file needed by Visit
c and create the initial VisIt setup.
c---------------------------------------------------------------------
      subroutine visit_init
      implicit none
      include "visitfortransimV2interface.inc"
      include "mpif.h"
c     // local variables
      integer err
c     // SIMSTATE common block
      integer runflag, endflag
      common /SIMSTATE/ runflag, endflag
      save /SIMSTATE/
c     // PARALLEL state common block
      integer par_rank, par_size
      common /PARALLEL/ par_rank, par_size
      save /PARALLEL/

#ifdef VISIT_STOP
c     // The sim will wait for VisIt to connect after first step.
      runflag = 0
#else
c     // Default is to run sim and VisIt can connect any time.
      runflag = 1
#endif
      endflag = 0

c     // Determine the rank and size of this MPI task so we can tell
c     // VisIt's libsim about it.
      call MPI_COMM_RANK(MPI_COMM_WORLD, par_rank, err)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, par_size, err)
      if(par_size.gt.1) then
          err = visitsetparallel(1)
      endif
      err = visitsetparallelrank(par_rank)

      call simulationarguments()
c     // TODO: look for the visitsetupenv2 function.
c     // Has better scaling, but has not been release for fortran.
      err = visitsetupenv()
c     // Have the master process create the sim file.
      if(par_rank.eq.0) then
          err = visitinitializesim("nek5000", 7,
     .       "Nek5000 Simulation", 18,
     .       "/no/useful/path", 15,
     .       VISIT_F77NULLSTRING, VISIT_F77NULLSTRINGLEN,
     .       VISIT_F77NULLSTRING, VISIT_F77NULLSTRINGLEN,
     .       VISIT_F77NULLSTRING, VISIT_F77NULLSTRINGLEN)
      endif

      end

c---------------------------------------------------------------------
c simulationarguments
c     This routine handles command line arguments
c     -dir <VisIt directory> 
c     -options <VisIt Options> 
c     -trace <VisIt trace file>
c---------------------------------------------------------------------
      subroutine simulationarguments()
      implicit none
      character (len=80) str
      integer err, i, N, len
      integer visitsetoptions, visitsetdirectory, visitopentracefile

      N = iargc()
      i = 1
      len = 80
5     if (i.le.N) then
          call getarg(i, str)
          if(str.eq."-dir") then
              call getarg(i+1, str)
              err = visitsetdirectory(str, len)
              i = i + 1
          elseif(str.eq."-options") then
              call getarg(i+1, str)
              err = visitsetoptions(str, len)
              i = i + 1
          elseif(str.eq."-trace") then
              call getarg(i+1, str)
              err = visitopentracefile(str, len)
              i = i + 1
          endif
          i = i + 1
          goto 5
      endif
      end

c---------------------------------------------------------------------
c processvisitcommand
c---------------------------------------------------------------------
      integer function processvisitcommand()
      implicit none
      include "mpif.h"
      include "visitfortransimV2interface.inc"
c     // PARALLEL state common block
      integer par_rank, par_size
      common /PARALLEL/ par_rank, par_size
      integer command, e, doloop, success, ret
      integer VISIT_COMMAND_PROCESS
      integer VISIT_COMMAND_SUCCESS
      integer VISIT_COMMAND_FAILURE
      parameter (VISIT_COMMAND_PROCESS = 0)
      parameter (VISIT_COMMAND_SUCCESS = 1)
      parameter (VISIT_COMMAND_FAILURE = 2)

      if(par_rank.eq.0) then
          success = visitprocessenginecommand()

          if(success.gt.0) then
              command = VISIT_COMMAND_SUCCESS
              ret = 1
          else
              command = VISIT_COMMAND_FAILURE
              ret = 0
          endif

          call MPI_BCAST(command,1,MPI_INTEGER,0,MPI_COMM_WORLD,e)
      else
          doloop = 1
2345      call MPI_BCAST(command,1,MPI_INTEGER,0,MPI_COMM_WORLD,e)
          if(command.eq.VISIT_COMMAND_PROCESS) then
              success = visitprocessenginecommand()
          elseif(command.eq.VISIT_COMMAND_SUCCESS) then
              ret = 1
              doloop = 0
          else
              ret = 0
              doloop = 0
          endif

          if(doloop.ne.0) then
              goto 2345
          endif
      endif
      processvisitcommand = ret
      end

c---------------------------------------------------------------------
c visit_check
c---------------------------------------------------------------------
      subroutine visit_check()
      implicit none
      include "mpif.h"
      include "visitfortransimV2interface.inc"
c     // functions
      integer processvisitcommand
c     // local variables
      integer visitstate, result, blocking, ierr
c     // SIMSTATE common block
      integer runflag, endflag
      common /SIMSTATE/ runflag, endflag
c     // PARALLEL state common block
      integer par_rank, par_size
      common /PARALLEL/ par_rank, par_size

c     // If at the end of sim, lets not force an update.
      if(endflag.eq.0) then
c        // Check if we are connected to VisIt
         result = visitisconnected()
         if(result.eq.1) then
c            // Tell VisIt that the timestep changed
             result = visittimestepchanged()
c            // Tell VisIt to update its plots
             result = visitupdateplots()
         endif
      endif

c     write (6, 2000)
 2000 format('VisIt Check!')
      do 10
c         // If we are running don't block
          if(runflag.eq.1) then
              blocking = 0
          else
              blocking = 1
          endif

c         // Detect input from VisIt on processor 0 and then broadcast
c         // the results of that input to all processors.
          if(par_rank.eq.0) then
              visitstate = visitdetectinput(blocking, -1)
          endif
          call MPI_BCAST(visitstate,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)

          if (visitstate.eq.0) then
c             // Okay - Process time step.
              goto 1234
          elseif (visitstate.eq.1) then
c             // Attempt to Connect VisIt
              ierr = runflag
              runflag = 0
              result = visitattemptconnection()
              if (result.eq.1) then
                  write (6, 2001)
 2001             format('VisIt connected!')
              else
                  write (6, 2002)
 2002             format('VisIt did not connected!')
              endif
              flush( 6 )
              runflag = ierr
          elseif (visitstate.eq.2) then
c             // Engine socket input
c             ierr = runflag
c             runflag = 0
              if (processvisitcommand().eq.0) then
                  result = visitdisconnect()
c                 // If VisIt is disconnect lets run.
                  runflag = 1
              endif
c             // Check if user wants to exit sim.
              if(runflag.eq.2) then
                  goto 1234
              endif
          elseif (visitstate.eq.3) then
c             // Console socket input
          elseif (visitstate.lt.0) then
c             // Error
              goto 1234
          endif
10    continue
1234  end

c---------------------------------------------------------------------
c visit_end
c---------------------------------------------------------------------
      subroutine visit_end()
      implicit none
      include "visitfortransimV2interface.inc"
c     // local variables
      integer result
c     // SIMSTATE common block
      integer runflag, endflag
      common /SIMSTATE/ runflag, endflag

c     // Check if we are connected to VisIt
      result = visitisconnected()
      if(result.eq.1) then
c        // Let VisIt exit the sim.

c        // This will tell the visit_check function we are at the end.
         endflag = 1
         runflag = 0

         do 10
            call visit_check()

c           // User asked to finish.
            if (endflag.eq.2) then
               EXIT
            endif
10       continue
      endif

      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c These functions must be defined to satisfy the 
c visitfortransimV2interface lib.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c---------------------------------------------------------------------
c visitcommandcallback
c   Handle User defined functions from VisIt user interface.
c---------------------------------------------------------------------
      subroutine visitcommandcallback (cmd, lcmd, args, largs)
      implicit none
      character*8 cmd, args
      integer     lcmd, largs
      include "visitfortransimV2interface.inc"
c     // SIMSTATE common block
      integer runflag, endflag
      common /SIMSTATE/ runflag, endflag

c     // Handle the commands that we define in visitgetmetadata.
      if(visitstrcmp(cmd, lcmd, "stop", 4).eq.0) then
          runflag = 0
      elseif(visitstrcmp(cmd, lcmd, "step", 4).eq.0) then
          runflag = 2
      elseif(visitstrcmp(cmd, lcmd, "run", 3).eq.0) then
          runflag = 1
      elseif(visitstrcmp(cmd, lcmd, "exit", 4).eq.0) then
          call exitt()
      elseif(visitstrcmp(cmd, lcmd, "finish", 6).eq.0) then
          if(endflag.eq.1) then
              endflag = 2
              runflag = 2
          endif
      endif
      end

c---------------------------------------------------------------------
c visitbroadcastintfunction
c---------------------------------------------------------------------
      integer function visitbroadcastintfunction(value, sender)
      implicit none
      include "mpif.h"
      integer value, sender, ierr
      call MPI_BCAST(value,1,MPI_INTEGER,sender,MPI_COMM_WORLD,ierr)
      visitbroadcastintfunction = 0
      end

c---------------------------------------------------------------------
c visitbroadcaststringfunction
c---------------------------------------------------------------------
      integer function visitbroadcaststringfunction(str, lstr, sender)
      implicit none
      include "mpif.h"
      character*8 str
      integer     lstr, sender, ierr
      call MPI_BCAST(str,lstr,MPI_CHARACTER,sender,MPI_COMM_WORLD,ierr)
      visitbroadcaststringfunction = 0
      end

c---------------------------------------------------------------------
c visitslaveprocesscallback
c---------------------------------------------------------------------
      subroutine visitslaveprocesscallback ()
      implicit none
      include "mpif.h"
      integer c, ierr, VISIT_COMMAND_PROCESS
      parameter (VISIT_COMMAND_PROCESS = 0)
      c = VISIT_COMMAND_PROCESS
      call MPI_BCAST(c, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, ierr)
      end

c---------------------------------------------------------------------
c visitactivatetimestep
c---------------------------------------------------------------------
      integer function visitactivatetimestep()
      implicit none
      include "visitfortransimV2interface.inc"
      visitactivatetimestep = VISIT_OKAY
      end

c---------------------------------------------------------------------
c visitgetmetadata
c   This function tells VisIt about all of the data that this
c   simulation will output. Mesh, variables, expressions and commands.
c---------------------------------------------------------------------
      integer function visitgetmetadata()
      include 'SIZE'
      include 'TSTEP'
      include 'INPUT'
      INCLUDE 'PARALLEL'
      include "visitfortransimV2interface.inc"
c     // SIMSTATE common block
      integer runflag, endflag
      common /SIMSTATE/ runflag, endflag
c     // PARALLEL state common block
      integer par_rank, par_size
      common /PARALLEL/ par_rank, par_size
c     // Local variables
      integer md, mmd, vmd, cmd, emd, err, iDim, k
      character*3 seqstring

      if(visitmdsimalloc(md).eq.VISIT_OKAY) then
        err = visitmdsimsetcycletime(md, ISTEP, TIME)
        if(runflag.eq.1) then
          err = visitmdsimsetmode(md, VISIT_SIMMODE_RUNNING)
        else
          err = visitmdsimsetmode(md, VISIT_SIMMODE_STOPPED)
        endif

c       // TODO: ask why this changes after first save?
c       write(6,*) 'VISIT: IFXYO',IFXYO
c       if(IFXYO) then
c         // Add a mesh
          if(IF3D) then
             iDim = 3
          else
             iDim = 2
          endif

          if(visitmdmeshalloc(mmd).eq.VISIT_OKAY) then
            err = visitmdmeshsetname(mmd, "mesh", 4)
            err = visitmdmeshsetmeshtype(mmd,
     .          VISIT_MESHTYPE_CURVILINEAR)
            err = visitmdmeshsettopologicaldim(mmd, iDim)
            err = visitmdmeshsetspatialdim(mmd, iDim)
            err = visitmdmeshsetnumdomains(mmd, NELGT)
            err = visitmdmeshsetdomaintitle(mmd, "Domains", 7)
            err = visitmdmeshsetdomainpiecename(mmd, "domain", 6)
c           err = visitmdmeshsetxunits(mmd, "cm", 2)
c           err = visitmdmeshsetyunits(mmd, "cm", 2)
            err = visitmdmeshsetxlabel(mmd, "X-Axis", 6)
            err = visitmdmeshsetylabel(mmd, "Y-Axis", 6)
            if(IF3D) then
c             err = visitmdmeshsetzunits(mmd, "cm", 2)
              err = visitmdmeshsetzlabel(mmd, "Z-Axis", 6)
            endif
            err = visitmdsimaddmesh(md, mmd)
          endif
c       endif

        if(IFVO) then
c         // Add a X velocity variable on the mesh.
          if(visitmdvaralloc(vmd).eq.VISIT_OKAY) then
            err = visitmdvarsetname(vmd, "x_velocity", 10)
            err = visitmdvarsetmeshname(vmd, "mesh", 4)
c           err = visitmdvarsetunits(vmd, "cm", 2)
            err = visitmdvarsetcentering(vmd, VISIT_VARCENTERING_NODE)
            err = visitmdvarsettype(vmd, VISIT_VARTYPE_SCALAR)
c           err = visitmdvarsettreatasascii(vmd, 0)
            err = visitmdsimaddvariable(md, vmd)
          endif

c         // Add a Y velocity variable on the mesh.
          if(visitmdvaralloc(vmd).eq.VISIT_OKAY) then
            err = visitmdvarsetname(vmd, "y_velocity", 10)
            err = visitmdvarsetmeshname(vmd, "mesh", 4)
c           err = visitmdvarsetunits(vmd, "cm", 2)
            err = visitmdvarsetcentering(vmd, VISIT_VARCENTERING_NODE)
            err = visitmdvarsettype(vmd, VISIT_VARTYPE_SCALAR)
c           err = visitmdvarsettreatasascii(vmd, 0)
            err = visitmdsimaddvariable(md, vmd)
          endif

          if(IF3D) then
c           // Add a Z velocity variable on the mesh.
            if(visitmdvaralloc(vmd).eq.VISIT_OKAY) then
              err = visitmdvarsetname(vmd, "z_velocity", 10)
              err = visitmdvarsetmeshname(vmd, "mesh", 4)
c             err = visitmdvarsetunits(vmd, "cm", 2)
              err = visitmdvarsetcentering(vmd, VISIT_VARCENTERING_NODE)
              err = visitmdvarsettype(vmd, VISIT_VARTYPE_SCALAR)
c             err = visitmdvarsettreatasascii(vmd, 0)
              err = visitmdsimaddvariable(md, vmd)
            endif
          endif

c         // Add a velocity expression.
          if(visitmdexpralloc(emd).eq.VISIT_OKAY) then
              err = visitmdexprsetname(emd, "velocity", 8)
              if(IF3D) then
                  err = visitmdexprsetdefinition(emd, 
     .                      "{x_velocity, y_velocity, z_velocity}", 36)
              else
                  err = visitmdexprsetdefinition(emd, 
     .                      "{x_velocity, y_velocity}", 24)
              endif
              err = visitmdexprsettype(emd, VISIT_VARTYPE_VECTOR)

              err = visitmdsimaddexpression(md, emd)
          endif

c         // Add a velocity magnitude expression.
          if(visitmdexpralloc(emd).eq.VISIT_OKAY) then
              err = visitmdexprsetname(emd, "velocity_mag", 12)
              err = visitmdexprsetdefinition(emd, 
     .                  "magnitude(velocity)", 19)
              err = visitmdexprsettype(emd, VISIT_VARTYPE_SCALAR)

              err = visitmdsimaddexpression(md, emd)
          endif
        endif

        if(IFPO) then
c         // Add a pressure variable on the mesh.
          if(visitmdvaralloc(vmd).eq.VISIT_OKAY) then
            err = visitmdvarsetname(vmd, "pressure", 8)
            err = visitmdvarsetmeshname(vmd, "mesh", 4)
c           err = visitmdvarsetunits(vmd, "cm", 2)
            err = visitmdvarsetcentering(vmd, VISIT_VARCENTERING_NODE)
            err = visitmdvarsettype(vmd, VISIT_VARTYPE_SCALAR)
c           err = visitmdvarsettreatasascii(vmd, 0)
            err = visitmdsimaddvariable(md, vmd)
          endif
        endif

        if(IFTO) then
c         // Add a temperature variable on the mesh.
          if(visitmdvaralloc(vmd).eq.VISIT_OKAY) then
            err = visitmdvarsetname(vmd, "temperature", 11)
            err = visitmdvarsetmeshname(vmd, "mesh", 4)
c           err = visitmdvarsetunits(vmd, "cm", 2)
            err = visitmdvarsetcentering(vmd, VISIT_VARCENTERING_NODE)
            err = visitmdvarsettype(vmd, VISIT_VARTYPE_SCALAR)
c           err = visitmdvarsettreatasascii(vmd, 0)
            err = visitmdsimaddvariable(md, vmd)
          endif
        endif

        do k=1,LDIMT-1
c         // Add a user defined variable on the mesh.
          if(IFPSCO(k)) then
            if(visitmdvaralloc(vmd).eq.VISIT_OKAY) then
              write (seqstring,'(I0)') k
              err = visitmdvarsetname(vmd, "s"//trim(seqstring),
     .                                1+len_trim(seqstring))
              err = visitmdvarsetmeshname(vmd, "mesh", 4)
c             err = visitmdvarsetunits(vmd, "cm", 2)
              err = visitmdvarsetcentering(vmd, VISIT_VARCENTERING_NODE)
              err = visitmdvarsettype(vmd, VISIT_VARTYPE_SCALAR)
c             err = visitmdvarsettreatasascii(vmd, 0)
              err = visitmdsimaddvariable(md, vmd)
            endif
          endif
        enddo


c       // Add simulation commands
        err = visitmdcmdalloc(cmd)
        if(err.eq.VISIT_OKAY) then
           err = visitmdcmdsetname(cmd, "stop", 4)
           err = visitmdsimaddgenericcommand(md, cmd)
        endif
        err = visitmdcmdalloc(cmd)
        if(err.eq.VISIT_OKAY) then
           err = visitmdcmdsetname(cmd, "step", 4)
           err = visitmdsimaddgenericcommand(md, cmd)
        endif
        err = visitmdcmdalloc(cmd)
        if(err.eq.VISIT_OKAY) then
           err = visitmdcmdsetname(cmd, "run", 3)
           err = visitmdsimaddgenericcommand(md, cmd)
        endif
        err = visitmdcmdalloc(cmd)
        if(err.eq.VISIT_OKAY) then
           err = visitmdcmdsetname(cmd, "exit", 4)
           err = visitmdsimaddgenericcommand(md, cmd)
        endif
        err = visitmdcmdalloc(cmd)
        if(err.eq.VISIT_OKAY) then
           err = visitmdcmdsetname(cmd, "finish", 6)
           err = visitmdsimaddgenericcommand(md, cmd)
        endif
      endif
      visitgetmetadata = md
      end

c---------------------------------------------------------------------
c visitgetmesh
c    Use this function to return mesh data to VisIt.
c---------------------------------------------------------------------
      integer function visitgetmesh(domain, name, lname)
      include 'SIZE'
      include 'TOTAL'
      character*8 name
      integer     domain, lname
      include "visitfortransimV2interface.inc" 

c     // local variables
      integer vh, x, y, z, err, dl, dmdims(3)

      vh = VISIT_INVALID_HANDLE

c     // Fortran starting index 1, but VisIt is 0
c     // Also need to get local domain index
      domain = GLLEL(domain + 1)

      if(visitstrcmp(name, lname, "mesh", 4).eq.0) then
        if(visitcurvmeshalloc(vh).eq.VISIT_OKAY) then
          err = visitvardataalloc(x)
          err = visitvardataalloc(y)
          if(IF3D) err = visitvardataalloc(z)

          dl = lx1 * ly1 * lz1
          err = visitvardatasetd(x, VISIT_OWNER_SIM, 1, dl, 
     .                           XM1(1,1,1,domain))
          err = visitvardatasetd(y, VISIT_OWNER_SIM, 1, dl,
     .                           YM1(1,1,1,domain))
          if(IF3D) then
            err = visitvardatasetd(z, VISIT_OWNER_SIM, 1, dl,
     .                             ZM1(1,1,1,domain))
          endif

          dmdims(1) = lx1
          dmdims(2) = ly1
          dmdims(3) = lz1
          if(IF3D) then
            err = visitcurvmeshsetcoordsxyz(vh, dmdims, x, y, z)
          else
            err = visitcurvmeshsetcoordsxy(vh, dmdims, x, y)
          endif
        endif
      endif

      visitgetmesh = vh
      end

c---------------------------------------------------------------------
c visitgetmaterial
c    Use this function to return material data to VisIt.
c---------------------------------------------------------------------
      integer function visitgetmaterial(domain, name, lname)
      implicit none
      character*8 name
      integer     domain, lname
      include "visitfortransimV2interface.inc"
      visitgetmaterial = VISIT_INVALID_HANDLE
      end

c---------------------------------------------------------------------
c visitgetvariable
c    Use this function to return variable data to VisIt.
c---------------------------------------------------------------------
      integer function visitgetvariable(gdomain, name, lname)
c     implicit none
      include 'SIZE'
      include 'TOTAL'
      character*8 name
      integer     gdomain, lname
      include "visitfortransimV2interface.inc"
c     // local vars
      integer h, nvals, err, domain, k

      nvals = lx1 * ly1 * lz1

      h = VISIT_INVALID_HANDLE

c     // Fortran starting index 1, but VisIt is 0
c     // Also need to get local domain index
      gdomain = gdomain + 1
      domain = GLLEL(gdomain)

      if(visitvardataalloc(h).eq.VISIT_OKAY) then
          if(visitstrcmp(name, lname, "temperature", 11).eq.0) then
              err = visitvardatasetd(h, VISIT_OWNER_SIM, 1, nvals,
     .                               T(1,1,1,domain,1))
          elseif(visitstrcmp(name, lname, "pressure", 8).eq.0) then
            if(gdomain.le.NELGV) then
              err = visitvardatasetd(h, VISIT_OWNER_SIM, 1, nvals,
     .                               PR(1,1,1,domain))
            endif
          elseif(visitstrcmp(name, lname, "x_velocity", 10).eq.0) then
            if(gdomain.le.NELGV) then
              err = visitvardatasetd(h, VISIT_OWNER_SIM, 1, nvals,
     .                               VX(1,1,1,domain))
            endif
          elseif(visitstrcmp(name, lname, "y_velocity", 10).eq.0) then
            if(gdomain.le.NELGV) then
              err = visitvardatasetd(h, VISIT_OWNER_SIM, 1, nvals,
     .                               VY(1,1,1,domain))
            endif
          elseif(visitstrcmp(name, lname, "z_velocity", 10).eq.0) then
            if(gdomain.le.NELGV) then
              err = visitvardatasetd(h, VISIT_OWNER_SIM, 1, nvals,
     .                               VZ(1,1,1,domain))
            endif
          elseif(visitstrcmp("s", 1, name, 1).eq.0) then
c             // Handle the user define variables.
              read( name(2:lname), '(i10)' ) k
              if(IFPSCO(k)) then
                  k = k + 1
                  err = visitvardatasetd(h, VISIT_OWNER_SIM, 1, nvals,
     .                                   T(1,1,1,domain,k))
              endif
          endif
      endif

      visitgetvariable = h
      end

c---------------------------------------------------------------------
c visitgetcurve
c    Use this function to return curve data to VisIt.
c---------------------------------------------------------------------
      integer function visitgetcurve(handle, name, lname)
      implicit none
      character*8 name
      integer     handle, lname
      include "visitfortransimV2interface.inc"
      visitgetcurve = VISIT_INVALID_HANDLE
      end

c---------------------------------------------------------------------
c visitgetdomainlist
c    This function returns a list of domains owned by this process.
c---------------------------------------------------------------------
      integer function visitgetdomainlist()
      INCLUDE 'SIZE'
      INCLUDE 'PARALLEL'
      include "visitfortransimV2interface.inc"
c     // local vars
      integer h, dl, err

      h = VISIT_INVALID_HANDLE

      if(visitdomainlistalloc(h).eq.VISIT_OKAY) then
          if(visitvardataalloc(dl).eq.VISIT_OKAY) then
c             // Hack to work around the index difference between
c             // fortran and VisIt C. Temp change and make copy.
              do i=1,NELT
                  LGLEL(i) = LGLEL(i) - 1
              enddo
              err = visitvardataseti(dl, VISIT_OWNER_COPY,1,NELT,LGLEL)
              err = visitdomainlistsetdomains(h, NELGT, dl)
c             // restore correct fortran values.
              do i=1,NELT
                  LGLEL(i) = LGLEL(i) + 1
              enddo
          endif
      endif

      visitgetdomainlist = h
      end

c---------------------------------------------------------------------
c visitgetdomainbounds
c    This function allows VisIt to create ghost zones between domains.
c---------------------------------------------------------------------
      integer function visitgetdomainbounds(name, lname)
      implicit none
      character*8 name
      integer     lname
      include "visitfortransimV2interface.inc"
      visitgetdomainbounds = VISIT_INVALID_HANDLE
      end

c---------------------------------------------------------------------
c visitgetdomainnesting
c    This is used to tell VisIt how AMR patches are nested.
c---------------------------------------------------------------------
      integer function visitgetdomainnesting(name, lname)
      implicit none
      character*8 name
      integer     lname
      include "visitfortransimV2interface.inc"
      visitgetdomainnesting = VISIT_INVALID_HANDLE
      end

c---------------------------------------------------------------------
c     visitgetmixedvariable
c     This is needed to run with newer version of Visit (2.12.0 tested).
c     TODO: The comment should be changed
c---------------------------------------------------------------------
      integer function visitgetmixedvariable(domain, name, lname)
      implicit none
      character*8 name
      integer     domain, lname
      include "visitfortransimV2interface.inc"
      visitgetmixedvariable = VISIT_INVALID_HANDLE
      end

        subroutine mxm_bgq_8(a,n1,b,n2,c,n3)
          implicit none

          integer  n1, n2, n3
          real(8)  a(n1,n2),b(n2,n3)
          real(8)  c(n1,n3)

          integer i, j
          vector(real(8)) av1, av2, av3, av4, av5, av6, av7, av8
          vector(real(8)) bv1, bsv1, bsv2, bsv3, bsv4
          vector(real(8)) bv2, bsv5, bsv6, bsv7, bsv8
          vector(real(8)) cv

          call alignx(32, a(1,1))
          call alignx(32, b(1,1))
          call alignx(32, c(1,1))

          do i = 1, n1, 4
            av1 = vec_ld(0,a(i,1))
            av2 = vec_ld(0,a(i,2))
            av3 = vec_ld(0,a(i,3))
            av4 = vec_ld(0,a(i,4))
            av5 = vec_ld(0,a(i,5))
            av6 = vec_ld(0,a(i,6))
            av7 = vec_ld(0,a(i,7))
            av8 = vec_ld(0,a(i,8))

            do j = 1, n3
              bv1 = vec_ld(0,b(1,j))
              bv2 = vec_ld(0,b(5,j))
              bsv1 = vec_splat(bv1, 0)
              bsv2 = vec_splat(bv1, 1)
              bsv3 = vec_splat(bv1, 2)
              bsv4 = vec_splat(bv1, 3)
              bsv5 = vec_splat(bv2, 0)
              bsv6 = vec_splat(bv2, 1)
              bsv7 = vec_splat(bv2, 2)
              bsv8 = vec_splat(bv2, 3)

              cv =  vec_mul(av1, bsv1)
              cv =  vec_madd(av2, bsv2, cv)
              cv =  vec_madd(av3, bsv3, cv)
              cv =  vec_madd(av4, bsv4, cv)
              cv =  vec_madd(av5, bsv5, cv)
              cv =  vec_madd(av6, bsv6, cv)
              cv =  vec_madd(av7, bsv7, cv)
              cv =  vec_madd(av8, bsv8, cv)

              call vec_st(cv, 0, c(i,j))
            end do
          end do
          return
        end subroutine mxm_bgq_8

        subroutine mxm_bgq_16(a,n1,b,n2,c,n3)
          implicit none

          integer n1, n2, n3
          real(8) a(n1,n2),b(n2,n3)
          real(8) c(n1,n3)

          integer i, j

          vector(real(8)) av1, av2, av3, av4, av5, av6, av7, av8
          vector(real(8)) av9, av10, av11, av12, av13, av14, av15, av16
          vector(real(8)) bv1, bsv1, bsv2, bsv3, bsv4
          vector(real(8)) bv2, bsv5, bsv6, bsv7, bsv8
          vector(real(8)) bv3, bsv9, bsv10, bsv11, bsv12
          vector(real(8)) bv4, bsv13, bsv14, bsv15, bsv16

          vector(real(8)) cv

          call alignx(32, a(1,1))
          call alignx(32, b(1,1))
          call alignx(32, c(1,1))

          do i = 1, n1, 4
            av1 = vec_ld(0,a(i,1))
            av2 = vec_ld(0,a(i,2))
            av3 = vec_ld(0,a(i,3))
            av4 = vec_ld(0,a(i,4))
            av5 = vec_ld(0,a(i,5))
            av6 = vec_ld(0,a(i,6))
            av7 = vec_ld(0,a(i,7))
            av8 = vec_ld(0,a(i,8))
            av9 = vec_ld(0,a(i,9))
            av10 = vec_ld(0,a(i,10))
            av11 = vec_ld(0,a(i,11))
            av12 = vec_ld(0,a(i,12))
            av13 = vec_ld(0,a(i,13))
            av14 = vec_ld(0,a(i,14))
            av15 = vec_ld(0,a(i,15))
            av16 = vec_ld(0,a(i,16))

            do j = 1, n3
              bv1 = vec_ld(0,b(1,j))
              bv2 = vec_ld(0,b(5,j))
              bv3 = vec_ld(0,b(9,j))
              bv4 = vec_ld(0,b(13,j))

              bsv1 = vec_splat(bv1, 0)
              bsv2 = vec_splat(bv1, 1)
              bsv3 = vec_splat(bv1, 2)
              bsv4 = vec_splat(bv1, 3)
              bsv5 = vec_splat(bv2, 0)
              bsv6 = vec_splat(bv2, 1)
              bsv7 = vec_splat(bv2, 2)
              bsv8 = vec_splat(bv2, 3)
              bsv9 = vec_splat(bv3, 0)
              bsv10 = vec_splat(bv3, 1)
              bsv11 = vec_splat(bv3, 2)
              bsv12 = vec_splat(bv3, 3)
              bsv13 = vec_splat(bv4, 0)
              bsv14 = vec_splat(bv4, 1)
              bsv15 = vec_splat(bv4, 2)
              bsv16 = vec_splat(bv4, 3)

              cv =  vec_mul(av1, bsv1)
              cv =  vec_madd(av2, bsv2, cv)
              cv =  vec_madd(av3, bsv3, cv)
              cv =  vec_madd(av4, bsv4, cv)
              cv =  vec_madd(av5, bsv5, cv)
              cv =  vec_madd(av6, bsv6, cv)
              cv =  vec_madd(av7, bsv7, cv)
              cv =  vec_madd(av8, bsv8, cv)
              cv =  vec_madd(av9, bsv9, cv)
              cv =  vec_madd(av10, bsv10, cv)
              cv =  vec_madd(av11, bsv11, cv)
              cv =  vec_madd(av12, bsv12, cv)
              cv =  vec_madd(av13, bsv13, cv)
              cv =  vec_madd(av14, bsv14, cv)
              cv =  vec_madd(av15, bsv15, cv)
              cv =  vec_madd(av16, bsv16, cv)

              call vec_st(cv, 0, c(i,j))
            end do
          end do
          return
        end subroutine mxm_bgq_16


        subroutine mxm_bgq_6(a,n1,b,n2,c,n3)
          implicit none

          integer n1, n2, n3
          real(8) a(n1,n2),b(n2,n3)
          real(8) c(n1,n3)

          integer i, j

          vector(real(8)) av1, av2, av3, av4, av5, av6
          vector(real(8)) bv1, bsv1, bsv2, bsv3, bsv4
          vector(real(8)) bv2, bsv5, bsv6

          vector(real(8)) cv

          call alignx(32, a(1,1))
          call alignx(32, b(1,1))
          call alignx(32, c(1,1))

          do i = 1, n1, 4
            av1 = vec_ld(0,a(i,1))
            av2 = vec_ld(0,a(i,2))
            av3 = vec_ld(0,a(i,3))
            av4 = vec_ld(0,a(i,4))
            av5 = vec_ld(0,a(i,5))
            av6 = vec_ld(0,a(i,6))

            do j = 1, n3, 2
              bv1 = vec_ld(0,b(1,j))
              bv2 = vec_ld(0,b(5,j))

              bsv1 = vec_splat(bv1, 0)
              bsv2 = vec_splat(bv1, 1)
              bsv3 = vec_splat(bv1, 2)
              bsv4 = vec_splat(bv1, 3)
              bsv5 = vec_splat(bv2, 0)
              bsv6 = vec_splat(bv2, 1)

              cv =  vec_mul(av1, bsv1)
              cv =  vec_madd(av2, bsv2, cv)
              cv =  vec_madd(av3, bsv3, cv)
              cv =  vec_madd(av4, bsv4, cv)
              cv =  vec_madd(av5, bsv5, cv)
              cv =  vec_madd(av6, bsv6, cv)

              call vec_st(cv, 0, c(i,j))

              bv1 = vec_ld(0,b(9,j))

              bsv1 = vec_splat(bv2, 2)
              bsv2 = vec_splat(bv2, 3)
              bsv3 = vec_splat(bv1, 0)
              bsv4 = vec_splat(bv1, 1)
              bsv5 = vec_splat(bv1, 2)
              bsv6 = vec_splat(bv1, 3)

              cv =  vec_mul(av1, bsv1)
              cv =  vec_madd(av2, bsv2, cv)
              cv =  vec_madd(av3, bsv3, cv)
              cv =  vec_madd(av4, bsv4, cv)
              cv =  vec_madd(av5, bsv5, cv)
              cv =  vec_madd(av6, bsv6, cv)

              call vec_st(cv, 0, c(i,j+1))
            end do
          end do
          return
        end subroutine mxm_bgq_6

        subroutine mxm_bgq_10(a,n1,b,n2,c,n3)
          implicit none

          integer n1, n2, n3
          real(8) a(n1,n2),b(n2,n3)
          real(8) c(n1,n3)

          integer i, j

          vector(real(8)) av1, av2, av3, av4, av5, av6, av7, av8
          vector(real(8)) av9, av10
          vector(real(8)) bv1, bsv1, bsv2, bsv3, bsv4
          vector(real(8)) bv2, bsv5, bsv6, bsv7, bsv8
          vector(real(8)) bv3, bsv9, bsv10
          vector(real(8)) cv

          call alignx(32, a(1,1))
          call alignx(32, b(1,1))
          call alignx(32, c(1,1))

          do i = 1, n1, 4
            av1 = vec_ld(0,a(i,1))
            av2 = vec_ld(0,a(i,2))
            av3 = vec_ld(0,a(i,3))
            av4 = vec_ld(0,a(i,4))
            av5 = vec_ld(0,a(i,5))
            av6 = vec_ld(0,a(i,6))
            av7 = vec_ld(0,a(i,7))
            av8 = vec_ld(0,a(i,8))
            av9 = vec_ld(0,a(i,9))
            av10 = vec_ld(0,a(i,10))

            do j = 1, n3, 2
              bv1 = vec_ld(0,b(1,j))
              bv2 = vec_ld(0,b(5,j))
              bv3 = vec_ld(0,b(9,j))

              bsv1 = vec_splat(bv1, 0)
              bsv2 = vec_splat(bv1, 1)
              bsv3 = vec_splat(bv1, 2)
              bsv4 = vec_splat(bv1, 3)
              bsv5 = vec_splat(bv2, 0)
              bsv6 = vec_splat(bv2, 1)
              bsv7 = vec_splat(bv2, 2)
              bsv8 = vec_splat(bv2, 3)
              bsv9 = vec_splat(bv3, 0)
              bsv10 = vec_splat(bv3, 1)

              cv =  vec_mul(av1, bsv1)
              cv =  vec_madd(av2, bsv2, cv)
              cv =  vec_madd(av3, bsv3, cv)
              cv =  vec_madd(av4, bsv4, cv)
              cv =  vec_madd(av5, bsv5, cv)
              cv =  vec_madd(av6, bsv6, cv)
              cv =  vec_madd(av7, bsv7, cv)
              cv =  vec_madd(av8, bsv8, cv)
              cv =  vec_madd(av9, bsv9, cv)
              cv =  vec_madd(av10, bsv10, cv)

              call vec_st(cv, 0, c(i,j))

              bv1 = vec_ld(0,b(13,j))
              bv2 = vec_ld(0,b(17,j))

              bsv1 = vec_splat(bv3, 2)
              bsv2 = vec_splat(bv3, 3)
              bsv3 = vec_splat(bv1, 0)
              bsv4 = vec_splat(bv1, 1)
              bsv5 = vec_splat(bv1, 2)
              bsv6 = vec_splat(bv1, 3)
              bsv7 = vec_splat(bv2, 0)
              bsv8 = vec_splat(bv2, 1)
              bsv9 = vec_splat(bv2, 2)
              bsv10 = vec_splat(bv2, 3)

              cv =  vec_mul(av1, bsv1)
              cv =  vec_madd(av2, bsv2, cv)
              cv =  vec_madd(av3, bsv3, cv)
              cv =  vec_madd(av4, bsv4, cv)
              cv =  vec_madd(av5, bsv5, cv)
              cv =  vec_madd(av6, bsv6, cv)
              cv =  vec_madd(av7, bsv7, cv)
              cv =  vec_madd(av8, bsv8, cv)
              cv =  vec_madd(av9, bsv9, cv)
              cv =  vec_madd(av10, bsv10, cv)

              call vec_st(cv, 0, c(i,j+1))
            end do
          end do
          return
        end subroutine mxm_bgq_10

C> @file surface_fluxes.f Routines for surface terms on RHS.

C> \ingroup isurf
C> @{
C> Restrict and copy face data and compute inviscid numerical flux 
C> \f$\oint \mathbf{H}^{c\ast}\cdot\mathbf{n}dA\f$ on face points
      subroutine fluxes_full_field
!-----------------------------------------------------------------------
! JH060314 First, compute face fluxes now that we have the primitive variables
! JH091514 renamed from "surface_fluxes_inviscid" since it handles all fluxes
!          that we compute from variables stored for the whole field (as
!          opposed to one element at a time).
!-----------------------------------------------------------------------
      include 'SIZE'
      include 'DG'
      include 'SOLN'
      include 'CMTDATA'
      include 'INPUT'

      integer lfq,heresize,hdsize
      parameter (lfq=lx1*lz1*2*ldim*lelt,
     >                   heresize=nqq*3*lfq,! guarantees transpose of Q+ fits
     >                   hdsize=toteq*3*lfq) ! might not need ldim
! JH070214 OK getting different answers whether or not the variables are
!          declared locally or in common blocks. switching to a different
!          method of memory management that is more transparent to me.
      common /CMTSURFLX/ fatface(heresize),notyet(hdsize)
      real fatface,notyet
      integer eq
      character*32 cname
      nfq=lx1*lz1*2*ldim*nelt
      nstate = nqq
! where different things live
      iwm =1
      iwp =iwm+nstate*nfq
      iflx=iwp+nstate*nfq

      call fillq(irho,vtrans,fatface(iwm),fatface(iwp))
      call fillq(iux, vx,    fatface(iwm),fatface(iwp))
      call fillq(iuy, vy,    fatface(iwm),fatface(iwp))
      call fillq(iuz, vz,    fatface(iwm),fatface(iwp))
      call fillq(ipr, pr,    fatface(iwm),fatface(iwp))
      call fillq(ithm,t,     fatface(iwm),fatface(iwp))
      call fillq(isnd,csound,fatface(iwm),fatface(iwp))
      call fillq(iph, phig,  fatface(iwm),fatface(iwp))
      call fillq(icvf,vtrans(1,1,1,1,icv),fatface(iwm),fatface(iwp))
      call fillq(icpf,vtrans(1,1,1,1,icp),fatface(iwm),fatface(iwp))
      call fillq(imuf, vdiff(1,1,1,1,imu), fatface(iwm),fatface(iwp))
      call fillq(ikndf,vdiff(1,1,1,1,iknd),fatface(iwm),fatface(iwp))
      call fillq(ilamf,vdiff(1,1,1,1,ilam),fatface(iwm),fatface(iwp))

      i_cvars=(iu1-1)*nfq+1
      do eq=1,toteq
         call faceu(eq,fatface(i_cvars))
! JH080317 at least get the product rule right until we figure out how
!          we want the governing equations to look
         call invcol2(fatface(i_cvars),fatface(iwm+nfq*(iph-1)),nfq)
         i_cvars=i_cvars+nfq
      enddo

      call face_state_commo(fatface(iwm),fatface(iwp),nfq,nstate
     >                     ,dg_hndl)

      call InviscidBC(fatface(iwm),fatface(iwp),nstate)

      call InviscidFlux(fatface(iwm),fatface(iwp),fatface(iflx)
     >                 ,nstate,toteq)

!     call face_flux_commo(fatface(iflx),fatface(iflx),ndg_face,toteq,
!    >                     flux_hndl) ! for non-symmetric gs_op someday

C> @}

      return
      end

!-----------------------------------------------------------------------

      subroutine faceu(ivar,yourface)
! get faces of conserved variables stored contiguously
      include 'SIZE'
      include 'CMTDATA'
      include 'DG'
      integer e
      real yourface(lx1,lz1,2*ldim,nelt)

      do e=1,nelt
         call full2face_cmt(1,lx1,ly1,lz1,iface_flux(1,e),
     >                      yourface(1,1,1,e),u(1,1,1,ivar,e))
      enddo

      return
      end

!-----------------------------------------------------------------------

      subroutine fillq(ivar,field,wminus,yourface)
      include 'SIZE'
      include 'DG'

      integer ivar! intent(in)
      real field(lx1,ly1,lz1,nelt)! intent(in)
!     real, intent(out)wminus(7,lx1*lz1*2*ldim*nelt) ! gs_op no worky
      real wminus(lx1*lz1*2*ldim*nelt,*)! intent(out)
      real yourface(lx1,lz1,2*ldim,*)
      integer e,f

      nxz  =lx1*lz1
      nface=2*ldim

      call full2face_cmt(nelt,lx1,ly1,lz1,iface_flux,yourface,field)

      do i=1,ndg_face
         wminus(i,ivar)=yourface(i,1,1,1)
      enddo

      return
      end

!-----------------------------------------------------------------------

      subroutine face_state_commo(mine,yours,nf,nstate,handle)

! JH060414 if we ever want to be more intelligent about who gets what,
!          who gives what and who does what, this is the place where all
!          that is done. At the very least, gs_op may need the transpose
!          flag set to 1. Who knows. Everybody duplicates everything for
!          now.
! JH070714 figure out gs_op_fields, many, vec, whatever (and the
!          corresponding setup) to get this done for the transposed
!          ordering of state variables. I want variable innermost, not
!          grid point.

      integer handle,nf,nstate ! intent(in)
      real yours(*),mine(*)

      ntot=nf*nstate
      call copy(yours,mine,ntot)
!-----------------------------------------------------------------------
! operation flag is second-to-last arg, an integer
!                                                1 ==> +
      call fgslib_gs_op_fields(handle,yours,nf,nstate,1,1,0)
      call sub2 (yours,mine,ntot)
      return
      end

!-----------------------------------------------------------------------

      subroutine face_flux_commo(flux1,flux2,nf,neq,handle)
! JH060514 asymmetric transposed gs_op, gs_unique magic may be needed if
!          we ever decide to avoid redundancy. For now, this routine
!          doesn't need to do anything.
      integer ntot,handle
      real flux1(*),flux2(*)
! JH061814 It doesn't need to do anything, but a sanity check would be
!          wise.
      return
      end

!-------------------------------------------------------------------------------

      subroutine InviscidFlux(wminus,wplus,flux,nstate,nflux)
!-------------------------------------------------------------------------------
! JH091514 A fading copy of RFLU_ModAUSM.F90 from RocFlu
!-------------------------------------------------------------------------------

!#ifdef SPEC
!      USE ModSpecies, ONLY: t_spec_type
!#endif
      include 'SIZE'
      include 'INPUT' ! do we need this?
      include 'GEOM' ! for unx
      include 'CMTDATA' ! do we need this without outflsub?
      include 'TSTEP' ! for ifield?
      include 'DG'

! ==============================================================================
! Arguments
! ==============================================================================
      integer nstate,nflux
      real wminus(lx1*lz1,2*ldim,nelt,nstate),
     >     wplus(lx1*lz1,2*ldim,nelt,nstate),
     >     flux(lx1*lz1,2*ldim,nelt,nflux)

! ==============================================================================
! Locals
! ==============================================================================

      integer e,f,fdim,i,k,nxz,nface
      parameter (lfd=lxd*lzd)
! JH111815 legacy rocflu names.
!
! nx,ny,nz : outward facing unit normal components
! fs       : face speed. zero until we have moving grid
! jaco_c   : fdim-D GLL grid Jacobian
! nm       : jaco_c, fine grid
!
! State on the interior (-, "left") side of the face
! rl       : density
! ul,vl,wl : velocity
! tl       : temperature
! al       : sound speed
! pl       : pressure, then phi
! el      : rho*cp
! State on the exterior (+, "right") side of the face
! rr       : density
! ur,vr,wr : velocity
! tr       : temperature
! ar       : sound speed
! pr       : pressure
! er      : rho*cp

      COMMON /SCRNS/ nx(lfd), ny(lfd), nz(lfd), rl(lfd), ul(lfd),
     >               vl(lfd), wl(lfd), pl(lfd), tl(lfd), al(lfd),
     >               el(lfd),rr(lfd), ur(lfd), vr(lfd), wr(lfd),
     >               pr(lfd),tr(lfd), ar(lfd),er(lfd),phl(lfd),fs(lfd),
     >               jaco_f(lfd),flx(lfd,toteq),jaco_c(lx1*lz1)
      real nx, ny, nz, rl, ul, vl, wl, pl, tl, al, el, rr, ur, vr, wr,
     >                pr,tr, ar,er,phl,fs,jaco_f,flx,jaco_c

!     REAL vf(3)
      real nTol
      character*132 deathmessage
      common /nekcb/ cb
      character*3 cb

      nTol = 1.0E-14

      fdim=ldim-1
      nface = 2*ldim
      nxz   = lx1*lz1
      nxzd  = lxd*lzd
      ifield= 1 ! You need to figure out the best way of dealing with
                ! this variable

!     if (outflsub)then
!        call maxMachnumber
!     endif
      do e=1,nelt
      do f=1,nface

! JH021717 Finally corrected BC wrongheadedness. Riemann solver handles
!          all fluxes with even the slightest Dirichlet interpretation,
!          and BC fill wplus sanely for the Riemann solver to provide
!          a good flux for weak BC.
! JH111715 now with dealiased surface integrals. I am too lazy to write
!          something better

! diagnostic
!        if (cbc(f,e,ifield).eq.'v  '.or.cbc(f,e,ifield).eq.'V  ')then
!        if (istep .eq. 1000) then
!           do i=1,nxz
!              write(10+istep,'(2i3,a3,16e15.7)') e,f,cbc(f,e,ifield),
!    .         wminus(i,f,e,irho),wplus(i,f,e,irho),
!    .      wminus(i,f,e,iux), wplus(i,f,e,iux), wminus(i,f,e,iuy),
!    .      wplus(i,f,e,iuy), wminus(i,f,e,ipr), wplus(i,f,e,ipr),
!    .      wminus(i,f,e,ithm), wplus(i,f,e,ithm), wminus(i,f,e,isnd),
!    .      wplus(i,f,e,isnd), wminus(i,f,e,icpf), wplus(i,f,e,icpf),
!    .      wminus(i,f,e,iph), wplus(i,f,e,iph)
!           enddo
!        endif
! diagnostic

         if (lxd.gt.lx1) then
            call map_faced(nx,unx(1,1,f,e),lx1,lxd,fdim,0)
            call map_faced(ny,uny(1,1,f,e),lx1,lxd,fdim,0)
            call map_faced(nz,unz(1,1,f,e),lx1,lxd,fdim,0)

            call map_faced(rl,wminus(1,f,e,irho),lx1,lxd,fdim,0)
            call map_faced(ul,wminus(1,f,e,iux),lx1,lxd,fdim,0)
            call map_faced(vl,wminus(1,f,e,iuy),lx1,lxd,fdim,0)
            call map_faced(wl,wminus(1,f,e,iuz),lx1,lxd,fdim,0)
            call map_faced(pl,wminus(1,f,e,ipr),lx1,lxd,fdim,0)
            call map_faced(tl,wminus(1,f,e,ithm),lx1,lxd,fdim,0)
            call map_faced(al,wminus(1,f,e,isnd),lx1,lxd,fdim,0)
            call map_faced(el,wminus(1,f,e,icpf),lx1,lxd,fdim,0)

            call map_faced(rr,wplus(1,f,e,irho),lx1,lxd,fdim,0)
            call map_faced(ur,wplus(1,f,e,iux),lx1,lxd,fdim,0)
            call map_faced(vr,wplus(1,f,e,iuy),lx1,lxd,fdim,0)
            call map_faced(wr,wplus(1,f,e,iuz),lx1,lxd,fdim,0)
            call map_faced(pr,wplus(1,f,e,ipr),lx1,lxd,fdim,0)
            call map_faced(tr,wplus(1,f,e,ithm),lx1,lxd,fdim,0)
            call map_faced(ar,wplus(1,f,e,isnd),lx1,lxd,fdim,0)
            call map_faced(er,wplus(1,f,e,icpf),lx1,lxd,fdim,0)

            call map_faced(phl,wminus(1,f,e,iph),lx1,lxd,fdim,0)

            call invcol3(jaco_c,area(1,1,f,e),wghtc,nxz)
            call map_faced(jaco_f,jaco_c,lx1,lxd,fdim,0) 
            call col2(jaco_f,wghtf,nxzd)
         else

            call copy(nx,unx(1,1,f,e),nxz)
            call copy(ny,uny(1,1,f,e),nxz)
            call copy(nz,unz(1,1,f,e),nxz)

            call copy(rl,wminus(1,f,e,irho),nxz)
            call copy(ul,wminus(1,f,e,iux),nxz)
            call copy(vl,wminus(1,f,e,iuy),nxz)
            call copy(wl,wminus(1,f,e,iuz),nxz)
            call copy(pl,wminus(1,f,e,ipr),nxz)
            call copy(tl,wminus(1,f,e,ithm),nxz)
            call copy(al,wminus(1,f,e,isnd),nxz)
            call copy(el,wminus(1,f,e,icpf),nxz)

            call copy(rr,wplus(1,f,e,irho),nxz)
            call copy(ur,wplus(1,f,e,iux),nxz)
            call copy(vr,wplus(1,f,e,iuy),nxz)
            call copy(wr,wplus(1,f,e,iuz),nxz)
            call copy(pr,wplus(1,f,e,ipr),nxz)
            call copy(tr,wplus(1,f,e,ithm),nxz)
            call copy(ar,wplus(1,f,e,isnd),nxz)
            call copy(er,wplus(1,f,e,icpf),nxz)

            call copy(phl,wminus(1,f,e,iph),nxz)

            call copy(jaco_f,area(1,1,f,e),nxz) 
         endif
         call rzero(fs,nxzd) ! moving grid stuff later

         call AUSM_FluxFunction(nxzd,nx,ny,nz,jaco_f,fs,rl,ul,vl,wl,pl,
     >                          al,tl,rr,ur,vr,wr,pr,ar,tr,flx,el,er)

         do j=1,toteq
            call col2(flx(1,j),phl,nxzd)
         enddo

         if (lxd.gt.lx1) then
            do j=1,toteq
               call map_faced(flux(1,f,e,j),flx(1,j),lx1,lxd,fdim,1)
            enddo
         else
            do j=1,toteq
               call copy(flux(1,f,e,j),flx(1,j),nxz)
            enddo
         endif

      enddo
      enddo

      end

!-----------------------------------------------------------------------

      subroutine surface_integral_full(vol,flux)
! Integrate surface fluxes for an entire field. Add contribution of flux
! to volume according to add_face2full_cmt
      include 'SIZE'
      include 'GEOM'
      include 'DG'
      include 'CMTDATA'
      real vol(lx1*ly1*lz1*nelt),flux(*)
      integer e,f

! weak form until we get the time loop rewritten
!     onem=-1.0
!     ntot=lx1*lz1*2*ldim*nelt
!     call cmult(flux,onem,ntot)
! weak form until we get the time loop rewritten
      call add_face2full_cmt(nelt,lx1,ly1,lz1,iface_flux,vol,flux)

      return
      end

!-------------------------------------------------------------------------------

      subroutine diffh2graduf(e,eq,graduf)
! peels off diffusiveH into contiguous face storage via restriction operator R
! for now, stores {{gradU}} for igu
      include  'SIZE'
      include  'DG' ! iface
      include  'CMTDATA'
      include  'GEOM'
      integer e,eq
      real graduf(lx1*lz1*2*ldim,nelt,toteq)
      common /scrns/ hface(lx1*lz1,2*ldim)
     >              ,normal(lx1*ly1,2*ldim)
      real hface, normal

      integer f

      nf    = lx1*lz1*2*ldim*nelt
      nfaces=2*ldim
      nxz   =lx1*lz1
      nxzf  =nxz*nfaces
      nxyz  = lx1*ly1*lz1

      call rzero(graduf(1,e,eq),nxzf) !   . dot nhat -> overwrites beginning of flxscr
      do j =1,ldim
         if (j .eq. 1) call copy(normal,unx(1,1,1,e),nxzf)
         if (j .eq. 2) call copy(normal,uny(1,1,1,e),nxzf)
         if (j .eq. 3) call copy(normal,unz(1,1,1,e),nxzf)
         call full2face_cmt(1,lx1,ly1,lz1,iface_flux,hface,diffh(1,j)) 
         call addcol3(graduf(1,e,eq),hface,normal,nxzf)
      enddo
      call col2(graduf(1,e,eq),area(1,1,1,e),nxzf)

      return
      end

!-----------------------------------------------------------------------

      subroutine igu_cmt(flxscr,gdudxk,wminus)
! Hij^{d*}
      include 'SIZE'
      include 'CMTDATA'
      include 'DG'

      real flxscr(lx1*lz1*2*ldim*nelt,toteq)
      real gdudxk(lx1*lz1*2*ldim,nelt,toteq)
      real wminus(lx1*lz1,2*ldim,nelt,nqq)
      real const
      integer e,eq,f

      nxz = lx1*lz1
      nfaces=2*ldim
      nxzf=nxz*nfaces
      nfq =lx1*lz1*nfaces*nelt
      ntot=nfq*toteq

      call copy (flxscr,gdudxk,ntot) ! save AgradU.n
      const = 0.5
      call cmult(gdudxk,const,ntot)
!-----------------------------------------------------------------------
! supa huge gs_op to get {{AgradU}}
! operation flag is second-to-last arg, an integer
!                                                   1 ==> +
      call fgslib_gs_op_fields(dg_hndl,gdudxk,nfq,toteq,1,1,0)
!-----------------------------------------------------------------------
      call sub2  (flxscr,gdudxk,ntot) ! overwrite flxscr with
                                      !           -
                                      ! (AgradU.n)  - {{AgradU.n}}
! [v] changes character on boundaries, so we actually need
! 1. (AgradU.n)- on Dirichlet boundaries
      call igu_dirichlet(flxscr,gdudxk)
! 2. (Fbc.n)- on Neumann boundaries
      call bcflux(flxscr,gdudxk,wminus)
      call chsign(flxscr,ntot) ! needs to change with sign changes

      return
      end

!-----------------------------------------------------------------------

      subroutine igu_dirichlet(flux,agradu)
! Acts on ALL boundary faces because I'm lazy. SET NEUMANN BC AFTER THIS
! CALL. BCFLUX IS PICKIER ABOUT THE BOUNDARY FACES IT ACTS ON.
      include 'SIZE'
      include 'TOTAL'
      integer e,eq,f
      real flux(lx1*lz1,2*ldim,nelt,toteq)
      real agradu(lx1*lz1,2*ldim,nelt,toteq)
      character*3 cb2

      nxz=lx1*lz1
      nfaces=2*ldim

      ifield=1
      do e=1,nelt
         do f=1,nfaces
            cb2=cbc(f, e, ifield)
            if (cb2.ne.'E  '.and.cb2.ne.'P  ') then ! cbc bndy.
! all Dirichlet conditions result in IGU being
! strictly one-sided, so we undo 0.5*QQT
! UNDER THE ASSUMPTIONS THAT
! 1. agradu's actual argument is really gdudxk AND
! 2. IT HAS ALREADY BEEN MULTIPLIED BY 0.5
! 3. gs_op has not changed it at all.
! overwriting flux with it and and multiplying it 2.0 should do the trick
               do eq=1,toteq
!                  call copy(flux(1,f,e,eq),agradu(1,f,e,eq),nxz)
!! in fact, that copy should not be necessary at all. TEST WITHOUT IT
!                  call cmult(flux(1,f,e,eq),2.0,nxz)
! JH112216 This may be better because agradu (without the factor of 1/2) is
!          needed for some Neumann conditions (like adiabatic walls)
                   call cmult(agradu(1,f,e,eq),2.0,nxz)
                   call copy(flux(1,f,e,eq),agradu(1,f,e,eq),nxz)
               enddo
            endif
         enddo
      enddo

      return
      end

!-----------------------------------------------------------------------
!      subroutine ihu(hu,uminus,uplus,flxscr,eta,he) ! INTERIOR PENALTY
!      include 'SIZE'
!      include 'TOTAL'
!      include 'CMTDATA'
!      include 'DG'
!      
!      real uminus(lx1*lz1*2*ldim*nelt),uplus(lx1*lz1*2*ldim*nelt),
!     >     flxscr(lx1*lz1*2*ldim*nelt),hu(lx1*lz1*lz1*nelt),
!     >     eta(lx1*lz1*2*ldim*nelt),he(lx1*lz1*lz1*nelt)
!      integer  e, n, npl, nf, f, i, k
!      integer eg
!
!      n  = lx1*ny1*lz1*nelt
!      nfaces=2*ldim
!      nxz=lx1*lz1
!      npl = lx1 - 1
!      nf = lx1*lz1*2*ldim*nelt
!         
!c   . R     
!      call add3(flxscr,uminus,uplus,nf) ! {{u}}
!      const=-0.5 
!      call cmult(flxscr,const,nf)  !       -
!      
!      call add2(flxscr,uminus,nf)     !flxscr = u -{{u}}
!      ifield=1 ! FIX THIS NOW  
!      ifield=2 ! FIX THIS NOW
!      
!c   . area, eta, he
!      k = 0
!      do e=1,nelt
!         eg = lglel(e)
!         do f=1,nfaces
!         do i=1,nxz
!            k=k+1
!            if (cbc(f,e,ifield).eq.'W  ') then ! unfuck this loop and if-statement
!               flxscr(k)=(uminus(k)-uplus(k))*area(i,1,f,e)*eta(k)/he(k)
!            else
!               flxscr(k)=flxscr(k)*area(i,1,f,e)*eta(k)/he(k)*2.0 ! universal fred at boundary?
!            endif
!         enddo
!         enddo
!      enddo
!
!      call add_face2full_cmt(nelt,lx1,ny1,lz1,iface_flux,hu,flxscr)
!c     write(6,*) 'done in ihu'
!
!      return
!      end
!

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!One dimension array computation
!with finer granularity than traditional 4 bytes.
!There is no data race pair.

program DRB047_doallchar_orig_no
    use omp_lib
    implicit none

    character(len=100), dimension(:), allocatable :: a
    character(50) :: str
    integer :: i

    allocate (a(100))

    !$omp parallel do private(str)
    do i = 1, 100
        write( str, '(i10)' )  i
        a(i) = str
    end do
    !$omp end parallel do

    print*,'a(i)',a(23)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A file-scope variable used within a function called by a parallel region.
!No threadprivate is used to avoid data races.
!This is the case for a variable referenced within a construct.
!
!Data race pairs  sum0@34:13 vs. sum0@34:20
!                 sum0@34:13 vs. sum0@34:13


module DRB092
    implicit none
    integer :: sum0, sum1
end module

program DRB092_threadprivatemissing2_orig_yes
    use omp_lib
    use DRB092
    implicit none

    integer :: i, sum
    sum = 0
    sum0 = 0
    sum1 = 0

    !$omp parallel
        !$omp do
        do i = 1, 1001
            sum0 = sum0+i
        end do
        !$omp end do
        !$omp critical
        sum = sum+sum0
        !$omp end critical
    !$omp end parallel

    do i = 1, 1001
        sum1=sum1+i
    end do

    print*,'sum =',sum,'sum1 =',sum1

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Classic i-k-j matrix multiplication. No data race pairs.

program DRB149_missingdata1_orig_gpu_no
    use omp_lib
    implicit none

    integer :: len, i, j
    integer, dimension(:), allocatable :: a, b, c

    len = 100

    allocate (a(len))
    allocate (b(len+len*len))
    allocate (c(len))

    do i = 1, len
        do j = 1, len
            b(j+i*len)=1
        end do
        a(i) = 1
        c(i) = 0
    end do

    !$omp target map(to:a,b) map(tofrom:c) device(0)
    !$omp teams distribute parallel do
    do i = 1, len
        do j = 1, len
            c(i) = c(i)+a(j)*b(j+i*len)
        end do
    end do
    !$omp end teams distribute parallel do
    !$omp end target

    do i = 1, len
        if (c(i)/=len) then
            print*, c(i)
        end if
    end do

    deallocate(a,b,c)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!For the case of a variable which is referenced within a construct:
!objects with dynamic storage duration should be shared.
!Putting it within a threadprivate directive may cause seg fault
!since threadprivate copies are not allocated.
!
!Dependence pair: *counter@25:5 vs. *counter@25:15

program DRB088_dynamic_storage_orig_yes
    use omp_lib
    implicit none
    integer, pointer :: counter

    allocate(counter)

    counter = 0

    !$omp parallel
    counter = counter+1
    !$omp end parallel

    print*,counter

    deallocate(counter)

end program

c-----------------------------------------------------------------------
      subroutine readat
C
C     Read in data from preprocessor input file (.rea)
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'GEOM'
      INCLUDE 'PARALLEL'
      INCLUDE 'CTIMER'
 
      logical ifbswap,ifre2,parfound
      character*132 string
      integer idum(3*numsts+3)

      ierr = 0
      call flush_io

      ! check if new rea file version exists
      if(nid.eq.0) inquire(file=parfle, exist=parfound)
      call bcast(parfound,lsize)
      if (parfound) then
         if(nio.eq.0) write(6,'(A,A)') ' Reading ', parfle
         call readat_par
         goto 99
      endif  

      etime0 = dnekclock_sync()

      if(nid.eq.0) then
        write(6,'(A,A)') ' Reading ', reafle
        open (unit=9,file=reafle,status='old', iostat=ierr)
      endif

      call bcast(ierr,isize)
      if (ierr .gt. 0) call exitti('Cannot open rea file!$',1)

C     Read parameters and logical flags
      call rdparam
      meshPartitioner=3 ! HYBRID (RSB+RCB)

C     Read Mesh Info 
      if(nid.eq.0) then
        read(9,*)    ! xfac,yfac,xzero,yzero
        read(9,*)    ! dummy
        read(9,*)  nelgs,ldimr,nelgv
        nelgt = abs(nelgs)
      endif
      call bcast(ldimr,ISIZE)
      call bcast(nelgs,ISIZE)
      call bcast(nelgv,ISIZE)
      call bcast(nelgt,ISIZE)
      ifre2 = .false.
      if (nelgs.lt.0) ifre2 = .true.

      call usrdat0

      if (nelgt.gt.350000 .and. .not.ifre2) 
     $   call exitti('Problem size requires .re2!$',1)

      if (ifre2) call read_re2_hdr(ifbswap, .true.) ! rank0 will open and read
      call chk_nel  ! make certain sufficient array sizes

      call mapelpr

      if (ifre2) then
        call read_re2_data(ifbswap, .true., .true., .true.)
      else
        maxrd = 32               ! max # procs to read at once
        mread = (np-1)/maxrd+1   ! mod param
        iread = 0                ! mod param
        x     = 0
        do i=0,np-1,maxrd
           call nekgsync()
           if (mod(nid,mread).eq.iread) then
              if (nid.ne.0) then
                open(UNIT=9,FILE=REAFLE,STATUS='OLD')
                call cscan(string,'MESH DATA',9)
                read(9,*) string
              endif 
              call rdmesh
              call rdcurve !  Curved side data
              call rdbdry  !  Boundary Conditions
              if (nid.ne.0) close(unit=9)
           endif
           iread = iread + 1
        enddo
      endif

C     Read Restart options / Initial Conditions / Drive Force
      CALL RDICDF
C     Read materials property data
      CALL RDMATP
C     Read history data
      CALL RDHIST
C     Read output specs
      CALL RDOUT
C     Read objects
      CALL RDOBJ

      call nekgsync()

C     End of input data, close read file.
      if(nid.eq.0) then
        close(unit=9)
        call echopar
        write(6,'(A,g13.5,A,/)')  ' done :: read .rea file ',
     $                             dnekclock()-etime0,' sec'
      endif

 99   call izero(boundaryID, size(boundaryID))
      call izero(boundaryIDt, size(boundaryIDt))

      ifld = 2 
      if(ifflow) ifld = 1
      do iel = 1,nelv
      do ifc = 1,2*ndim   
         boundaryID(ifc,iel) = bc(5,ifc,iel,ifld)
      enddo
      enddo

      ntmsh = 0
      do i=1,ldimt
         if(iftmsh(1+i)) ntmsh = ntmsh + 1 
      enddo

      if (ntmsh.gt.0) then
        do iel = 1,nelt
        do ifc = 1,2*ndim   
           boundaryIDt(ifc,iel) = bc(5,ifc,iel,2)
        enddo
        enddo
      endif 

      return
      END
c-----------------------------------------------------------------------
      subroutine vrdsmsh
C
C=====================================================================
C     Verify that mesh and dssum are properly defined by performing
C        a direct stiffness operation on the X,Y and Z coordinates.
C     Note that periodic faces are not checked here.
C=====================================================================
C
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
      COMMON /SCRNS/ TA(LX1,LY1,LZ1,LELT),TB(LX1,LY1,LZ1,LELT)
     $           ,QMASK(LX1,LY1,LZ1,LELT),tmp(2)
      CHARACTER*3 CB

c      call  vrdsmshx  ! verify mesh topology

      if(nio.eq.0) write(*,*) 'verify mesh topology'

      IERR      = 0
      EPS       = 1.0e-04
      EPS       = 1.0e-03
      IFIELD    = 1
      if (nelgv.ne.nelgt .or. .not.ifflow) ifield = 2
      NXYZ1     = lx1*ly1*lz1
      NTOT      = lx1*ly1*lz1*NELT
      NFACES    = 2*ldim

      xmx = glmax(xm1,ntot)
      xmn = glmin(xm1,ntot)
      ymx = glmax(ym1,ntot)
      ymn = glmin(ym1,ntot)
      zmx = glmax(zm1,ntot)
      zmn = glmin(zm1,ntot)
      if (nio.eq.0) write(6,*) xmn,xmx,' Xrange'
      if (nio.eq.0) write(6,*) ymn,ymx,' Yrange'
      if (nio.eq.0) write(6,*) zmn,zmx,' Zrange'
c     return
C
C     First check - use 1/Multiplicity
C
      IF (IFHEAT) THEN 
         CALL COPY(TA,TMULT,NTOT)
      ELSE
         CALL COPY(TA,VMULT,NTOT)
      ENDIF
c
c     write(6,1) 
c    $(nid,'tab4',lglel(ie),(ta(k,1,1,ie),k=1,lx1*ly1),ie=1,nelt)
c   1 format(i3,a4,i3,16f5.2)
c
      CALL DSSUM(TA,lx1,ly1,lz1)
c
c     write(6,1) 
c    $(nid,'taaf',lglel(ie),(ta(k,1,1,ie),k=1,lx1*ly1),ie=1,nelt)
c
      CALL RONE (TB,NTOT)
      CALL SUB2 (TB,TA,NTOT)
      DO 1000 IE=1,NELT
      ieg=lglel(ie)
      DO 1000 IZ=1,lz1
      DO 1000 IY=1,ly1
      DO 1000 IX=1,lx1
         IF (ABS(TB(IX,IY,IZ,IE)).GT.EPS ) THEN
            WRITE(6,1005) IX,IY,IZ,IEG
     $      ,XM1(IX,IY,IZ,IE),YM1(IX,IY,IZ,IE),ZM1(IX,IY,IZ,IE)
     $      ,TA(IX,IY,IZ,IE),eps
c           WRITE(7,1005) IX,IY,IZ,IEG
c    $      ,XM1(IX,IY,IZ,IE),TB(IX,IY,IZ,IE),TA(IX,IY,IZ,IE)
c    $      ,QMASK(IX,IY,IZ,IE)
 1005       FORMAT(2X,'WARNING: DSSUM problem at:',/
     $            ,1X,'I,J,K,IE:',3I5,i12,/
     $            ,2X,'Near X =',3G16.8,', d:',2G16.8)
            IERR=4
         ENDIF
 1000 CONTINUE
C
C     Set up QMASK quickly to annihilate checks on periodic bc's
C
      CALL RONE(QMASK,NTOT)
      DO 100 IEL=1,NELT
      DO 100 IFACE=1,NFACES
         CB =CBC(IFACE,IEL,IFIELD)
         IF (CB.EQ.'P  '.or.cb.eq.'p  ') 
     $         CALL FACEV(QMASK,IEL,IFACE,0.0,lx1,ly1,lz1)
  100 CONTINUE
      CALL DSOP(QMASK,'MUL',lx1,ly1,lz1)

c      xxmin = glmin(xm1,ntot)
c      yymin = glmin(ym1,ntot)
c      zzmin = glmin(zm1,ntot)
c      xxmax = glmax(xm1,ntot)
c      yymax = glmax(ym1,ntot)
c      zzmax = glmax(zm1,ntot)
c      if (nio.eq.0) write(6,7) xxmin,yymin,zzmin,xxmax,yymax,zzmax
c    7 format('xyz minmx2:',6g13.5)



C
C     X-component
C
      CALL COPY(TA,XM1,NTOT)
      CALL COPY(TB,XM1,NTOT)
      CALL DSOP(TA,'MIN',lx1,ly1,lz1)
      CALL DSOP(TB,'MAX',lx1,ly1,lz1)
      CALL SUB2(TA,XM1,NTOT)
      CALL SUB2(TB,XM1,NTOT)
      CALL COL2(TA,QMASK,NTOT)
      CALL COL2(TB,QMASK,NTOT)
      DO 1100 IE=1,NELT
         XSCMAX = VLMAX(XM1(1,1,1,IE),NXYZ1)
         XSCMIN = VLMIN(XM1(1,1,1,IE),NXYZ1)
         SCAL1=ABS(XSCMAX-XSCMIN)
         SCAL2=ABS(XSCMAX)
         SCAL3=ABS(XSCMIN)
         SCAL1=MAX(SCAL1,SCAL2)
         SCAL1=MAX(SCAL1,SCAL3)
         XSCALE = 1./SCAL1
         ieg=lglel(ie)
         DO 1100 IZ=1,lz1
         DO 1100 IY=1,ly1
         DO 1100 IX=1,lx1
         if (abs(ta(ix,iy,iz,ie)*xscale).gt.eps .or.
     $       abs(tb(ix,iy,iz,ie)*xscale).gt.eps ) then
            write(6,1105) ix,iy,iz,ieg
     $      ,xm1(ix,iy,iz,ie),ym1(ix,iy,iz,ie),zm1(ix,iy,iz,ie)
     $      ,tb(ix,iy,iz,ie),ta(ix,iy,iz,ie),XSCALE
 1105       format(1x,'WARNING1 Element mesh mismatch at:',/
     $            ,1x,'i,j,k,ie:',3i5,I12,/
     $            ,1X,'Near X =',3G16.8,', d:',3G16.8)
            ierr=1
         endif
 1100 CONTINUE
C
C     Y-component
C
      CALL COPY(TA,YM1,NTOT)
      CALL COPY(TB,YM1,NTOT)
      CALL DSOP(TA,'MIN',lx1,ly1,lz1)
      CALL DSOP(TB,'MAX',lx1,ly1,lz1)
      CALL SUB2(TA,YM1,NTOT)
      CALL SUB2(TB,YM1,NTOT)
      CALL COL2(TA,QMASK,NTOT)
      CALL COL2(TB,QMASK,NTOT)
      DO 1200 IE=1,NELT
         YSCMAX = VLMAX(YM1(1,1,1,IE),NXYZ1)
         YSCMIN = VLMIN(YM1(1,1,1,IE),NXYZ1)
         SCAL1=ABS(YSCMAX-YSCMIN)
         SCAL2=ABS(YSCMAX)
         SCAL3=ABS(YSCMIN)
         SCAL1=MAX(SCAL1,SCAL2)
         SCAL1=MAX(SCAL1,SCAL3)
         YSCALE = 1./SCAL1
         ieg=lglel(ie)
         DO 1200 IZ=1,lz1
         DO 1200 IY=1,ly1
         DO 1200 IX=1,lx1
         IF (ABS(TA(IX,IY,IZ,IE)*YSCALE).GT.EPS .OR.
     $       ABS(TB(IX,IY,IZ,IE)*YSCALE).GT.EPS ) THEN
            WRITE(6,1205) IX,IY,IZ,IEG
     $      ,XM1(IX,IY,IZ,IE),YM1(IX,IY,IZ,IE),ZM1(IX,IY,IZ,IE)
     $      ,TB(IX,IY,IZ,IE),TA(IX,IY,IZ,IE),yscale
 1205       FORMAT(1X,'WARNING2 Element mesh mismatch at:',/
     $            ,1X,'I,J,K,IE:',3I5,i12,/
     $            ,1X,'Near Y =',3G16.8,', d:',3G16.8)
            IERR=2
         ENDIF
 1200 CONTINUE
C
C     Z-component
C
      IF (IF3D) THEN
       CALL COPY(TA,ZM1,NTOT)
       CALL COPY(TB,ZM1,NTOT)
       CALL DSOP(TA,'MIN',lx1,ly1,lz1)
       CALL DSOP(TB,'MAX',lx1,ly1,lz1)
       CALL SUB2(TA,ZM1,NTOT)
       CALL SUB2(TB,ZM1,NTOT)
       CALL COL2(TA,QMASK,NTOT)
       CALL COL2(TB,QMASK,NTOT)
       DO 1300 IE=1,NELT
          ZSCMAX = VLMAX(ZM1(1,1,1,IE),NXYZ1)
          ZSCMIN = VLMIN(ZM1(1,1,1,IE),NXYZ1)
          SCAL1=ABS(ZSCMAX-ZSCMIN)
          SCAL2=ABS(ZSCMAX)
          SCAL3=ABS(ZSCMIN)
          SCAL1=MAX(SCAL1,SCAL2)
          SCAL1=MAX(SCAL1,SCAL3)
          ZSCALE = 1./SCAL1
          ieg=lglel(ie)
          DO 1300 IZ=1,lz1
          DO 1300 IY=1,ly1
          DO 1300 IX=1,lx1
          IF (ABS(TA(IX,IY,IZ,IE)*ZSCALE).GT.EPS .OR.
     $        ABS(TB(IX,IY,IZ,IE)*ZSCALE).GT.EPS ) THEN
           WRITE(6,1305) IX,IY,IZ,IEG
     $      ,XM1(IX,IY,IZ,IE),YM1(IX,IY,IZ,IE),ZM1(IX,IY,IZ,IE)
     $      ,TB(IX,IY,IZ,IE),TA(IX,IY,IZ,IE),zscale
 1305       FORMAT(1X,'WARNING3 Element mesh mismatch at:',/
     $            ,1X,'I,J,K,IE:',3I5,i12,/
     $            ,1X,'Near Z =',3G16.8,', d:',3G16.8)
            IERR=3
          ENDIF
 1300  CONTINUE
      ENDIF

      ierr = iglsum(ierr,1)
      IF (IERR.gt.0) THEN
         if(nid.eq.0) WRITE(6,1400) 
 1400    FORMAT
     $   (' Mesh consistency check failed.  EXITING in VRDSMSH.')
            call exitt
      ENDIF
 
      tmp(1)=ierr
      CALL GOP(tmp,tmp(2),'M  ',1)
      IF (tmp(1).ge.4.0) THEN
         WRITE(6,1400) 
     $   (' Mesh consistency check failed.  EXITING in VRDSMSH.')
         call exitt
      ENDIF
 
      if(nio.eq.0) then
        write(6,*) 'done :: verify mesh topology'
        write(6,*) ' '
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine vrdsmshx  ! verify mesh topology
C
C=====================================================================
C     Verify that mesh and dssum are properly defined by performing
C        a direct stiffness operation on the X,Y and Z coordinates.
C     Note that periodic faces are not checked here.
C=====================================================================
C
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
      common /scrns/ tc(lx1,ly1,lz1,lelt),td(lx1,ly1,lz1,lelt)
     $             , ta(lx1,ly1,lz1,lelt),tb(lx1,ly1,lz1,lelt)
     $             , qmask(lx1,ly1,lz1,lelt)
      CHARACTER*3 CB
C
      IERR      = 0
      EPS       = 1.0e-04
      EPS       = 1.0e-03
      IFIELD    = 1
      IF (IFHEAT) IFIELD = 2
      NXYZ1     = lx1*ly1*lz1
      NTOT      = lx1*ly1*lz1*NELT
      NFACES    = 2*ldim

      xmx = glmax(xm1,ntot)
      xmn = glmin(xm1,ntot)
      ymx = glmax(ym1,ntot)
      ymn = glmin(ym1,ntot)
      zmx = glmax(zm1,ntot)
      zmn = glmin(zm1,ntot)
      if (nio.eq.0) write(6,*) xmn,xmx,' Xrange'
      if (nio.eq.0) write(6,*) ymn,ymx,' Yrange'
      if (nio.eq.0) write(6,*) zmn,zmx,' Zrange'
c     return
C
C     First check - use 1/Multiplicity
C
      IF (IFHEAT) THEN 
         CALL COPY(TA,TMULT,NTOT)
      ELSE
         CALL COPY(TA,VMULT,NTOT)
      ENDIF
c
c     write(6,1) 
c    $(nid,'tab4',lglel(ie),(ta(k,1,1,ie),k=1,lx1*ly1),ie=1,nelt)
c   1 format(i3,a4,i3,16f5.2)
c
      CALL DSSUM(TA,lx1,ly1,lz1)
c
c     write(6,1) 
c    $(nid,'taaf',lglel(ie),(ta(k,1,1,ie),k=1,lx1*ly1),ie=1,nelt)
c
      CALL RONE (TB,NTOT)
      CALL SUB2 (TB,TA,NTOT)
      DO 1000 IE=1,NELT
      ieg=lglel(ie)
      DO 1000 IZ=1,lz1
      DO 1000 IY=1,ly1
      DO 1000 IX=1,lx1
         IF (ABS(TB(IX,IY,IZ,IE)).GT.EPS ) THEN
            WRITE(6,1005) IX,IY,IZ,IEG
     $      ,XM1(IX,IY,IZ,IE),YM1(IX,IY,IZ,IE),ZM1(IX,IY,IZ,IE)
     $      ,TA(IX,IY,IZ,IE),eps
c           WRITE(7,1005) IX,IY,IZ,IEG
c    $      ,XM1(IX,IY,IZ,IE),TB(IX,IY,IZ,IE),TA(IX,IY,IZ,IE)
c    $      ,QMASK(IX,IY,IZ,IE)
 1005       FORMAT(2X,'WARNING: DSSUM problem at:',/
     $            ,1X,'I,J,K,IE:',3I5,i12,/
     $            ,2X,'Near X =',3G16.8,', d:',2G16.8)
            IERR=4
         ENDIF
 1000 CONTINUE
C
C     Set up QMASK quickly to annihilate checks on periodic bc's
C
      CALL RONE(QMASK,NTOT)
      DO 100 IEL=1,NELT
      DO 100 IFACE=1,NFACES
         CB =CBC(IFACE,IEL,IFIELD)
         IF (CB.EQ.'P  '.or.cb.eq.'p  ') 
     $         CALL FACEV(QMASK,IEL,IFACE,0.0,lx1,ly1,lz1)
  100 CONTINUE
      call dsop(QMASK,'MUL',lx1,ly1,lz1)

      xxmin = glmin(xm1,ntot)
      yymin = glmin(ym1,ntot)
      zzmin = glmin(zm1,ntot)
      xxmax = glmax(xm1,ntot)
      yymax = glmax(ym1,ntot)
      zzmax = glmax(zm1,ntot)
      if (nio.eq.0) write(6,7) xxmin,yymin,zzmin,xxmax,yymax,zzmax
    7 format('xyz minmx2:',6g13.5)


C
C     X-component
C
      call copy(ta,xm1,ntot)
      call copy(tb,xm1,ntot)
      call dsop(ta,'min',lx1,ly1,lz1)
      call dsop(tb,'max',lx1,ly1,lz1)

      call copy(tc,xm1,ntot)
      call copy(td,xm1,ntot)
      call dsop(tc,'min',lx1,ly1,lz1)
      call dsop(td,'max',lx1,ly1,lz1)

      xxmin = glmin(xm1,ntot)
      xxmax = glmax(xm1,ntot)
      yymax = glmax(ta ,ntot)
      yymin = glmin(ta ,ntot)
      zzmin = glmin(tb ,ntot)
      zzmax = glmax(tb ,ntot)
      if (nio.eq.0) write(6,9) xxmin,yymin,zzmin,xxmax,yymax,zzmax
    9 format('xyz minmx3:',6g13.5)

      CALL SUB2(TA,XM1,NTOT)
      CALL SUB2(TB,XM1,NTOT)

      xxmin = glmin(qmask,ntot)
      xxmax = glmax(qmask,ntot)
      yymax = glmax(ta ,ntot)
      yymin = glmin(ta ,ntot)
      zzmin = glmin(tb ,ntot)
      zzmax = glmax(tb ,ntot)
      if (nio.eq.0) write(6,19) xxmin,yymin,zzmin,xxmax,yymax,zzmax
   19 format('xyz minmx4:',6g13.5)

      CALL COL2(TA,QMASK,NTOT)
      CALL COL2(TB,QMASK,NTOT)

      xxmin = glmin(qmask,ntot)
      xxmax = glmax(qmask,ntot)
      yymax = glmax(ta ,ntot)
      yymin = glmin(ta ,ntot)
      zzmin = glmin(tb ,ntot)
      zzmax = glmax(tb ,ntot)
      if (nio.eq.0) write(6,29) xxmin,yymin,zzmin,xxmax,yymax,zzmax
   29 format('xyz minmx5:',6g13.5)

      DO 1100 IE=1,NELT
         XSCMAX = VLMAX(XM1(1,1,1,IE),NXYZ1)
         XSCMIN = VLMIN(XM1(1,1,1,IE),NXYZ1)
         SCAL1=ABS(XSCMAX-XSCMIN)
         SCAL2=ABS(XSCMAX)
         SCAL3=ABS(XSCMIN)
         SCAL1=MAX(SCAL1,SCAL2)
         SCAL1=MAX(SCAL1,SCAL3)
         XSCALE = 1./SCAL1
         ieg=lglel(ie)
         DO 1100 IZ=1,lz1
         DO 1100 IY=1,ly1
         DO 1100 IX=1,lx1
         if (abs(ta(ix,iy,iz,ie)*xscale).gt.eps .or.
     $       abs(tb(ix,iy,iz,ie)*xscale).gt.eps ) then
            write(6,1105) nid,ix,iy,iz,ie,ieg
     $      ,xm1(ix,iy,iz,ie),tc(ix,iy,iz,ie),td(ix,iy,iz,ie)
     $      ,ym1(ix,iy,iz,ie),zm1(ix,iy,iz,ie)
     $      ,ta(ix,iy,iz,ie),tb(ix,iy,iz,ie),xscale
     $      ,qmask(ix,iy,iz,ie)
 1105       format(i4.4,1x,'ie:',3i3,i10,i10,1p9e11.3)
c1105       format(i4.4,1x,'ie:',3i3,i6,1p9e11.3)
            ierr=1
            goto 1101
         endif
 1100 CONTINUE
 1101 CONTINUE

      xxmin = glmin(xm1,ntot)
      xxmax = glmax(xm1,ntot)
      yymax = glmax(ta ,ntot)
      yymin = glmin(ta ,ntot)
      zzmin = glmin(tb ,ntot)
      zzmax = glmax(tb ,ntot)
      if (nio.eq.0) write(6,39) xxmin,yymin,zzmin,xxmax,yymax,zzmax
   39 format('xyz minmx5:',6g13.5)

c     ifvo = .true.
c     ifpo = .false.
c     ifto = .true.
c     call outpost(xm1,ta,tb,pr,qmask,'   ')
c     call exitt

      return
      end
c-----------------------------------------------------------------------
      subroutine rotat2(xyz,angle,npts)
C
C     Rotate NPTS through ANGLE (in two directions IF3D).
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      DIMENSION XYZ(3,1)
      COMMON /CTMP0/ RMTRX(3,3),RX(3,3),RZ(3,3),XYZN(3,10)
C
      SINA=SIN(ANGLE)
      COSA=COS(ANGLE)
      CALL RZERO(RX,9)
      CALL RZERO(RZ,9)
      RX(1,1)=COSA
      RX(2,2)=COSA
      RX(1,2)=SINA
      RX(2,1)=-SINA
      RX(3,3)=1.0
      IF (IF3D) THEN
         RZ(1,1)=COSA
         RZ(3,3)=COSA
         RZ(1,3)=SINA
         RZ(3,1)=-SINA
         RZ(2,2)=1.0
      ELSE
         RZ(1,1)=1.0
         RZ(2,2)=1.0
         RZ(3,3)=1.0
      ENDIF
      CALL MXM(RX,3,RZ,3,RMTRX,3)
C
C     Strip mine mxms in chunks of 10:
      DO 100 I=1,NPTS-10,10
         CALL MXM(RMTRX,3,XYZ(1,I),3,XYZN,10)
         CALL COPY(XYZ(1,I),XYZN,30)
  100 CONTINUE
      N10=MOD1(NPTS,10)
      I=NPTS-N10+1
      CALL RZERO(XYZN,30)
      IF (N10.GT.0) THEN
         CALL MXM(RMTRX,3,XYZ(1,I),3,XYZN,N10)
         CALL COPY(XYZ(1,I),XYZN,3*N10)
      ENDIF
C
      return
      END
c-----------------------------------------------------------------------
      subroutine scale(xyzl,nl)
C
C     Rescale XYZL such that the mean value of IXX=IYY=IZZ for each element.
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      DIMENSION XYZL(3,8,LELT)
      COMMON /CTMP0/ VO(LELT),XYZI(3,LELT),CG(3,LELT)
     $              ,TI(6),WORK(6)
C
C     Compute volumes -
C
      CALL VOLUME2(VO,XYZL,NL)
      VTOT=GLSUM (VO,NL)
C
C     Compute (weighted) average inertia for each element.
C
      NCRNR=2**ldim
      CALL RZERO(TI,6)
      DO 100 IL=1,NL
         VO0 = VO(IL)/VTOT
         CALL INRTIA(XYZI(1,IL),CG(1,IL),XYZL(1,1,IL),NCRNR,1)
         TI(1)=TI(1)+XYZI(1,IL)*VO0
         TI(2)=TI(2)+XYZI(2,IL)*VO0
         TI(3)=TI(3)+XYZI(3,IL)*VO0
         TI(4)=TI(4)+CG(1,IL)  *VO0
         TI(5)=TI(5)+CG(2,IL)  *VO0
         TI(6)=TI(6)+CG(3,IL)  *VO0
  100 CONTINUE
      CALL GOP(TI,WORK,'+  ',6)
      XI  =SQRT(TI(1))
      YI  =SQRT(TI(2))
      ZI  =1.0
      IF (IF3D) ZI=SQRT(TI(3))
C
C     Rescale ( & shift to a nearly mean zero )
C
      DO 200 IL=1,NL
      DO 200 IC=1,NCRNR
         XYZL(1,IC,IL)=(XYZL(1,IC,IL)-TI(4))/XI
         XYZL(2,IC,IL)=(XYZL(2,IC,IL)-TI(5))/YI
         XYZL(3,IC,IL)=(XYZL(3,IC,IL)-TI(6))/ZI
  200 CONTINUE
C
      return
      END
c-----------------------------------------------------------------------
      subroutine inrtia(xyzi,cg,xyzl,n,itype)
C
C     Compute cg and inertia for a collection of unit point masses.
C     This is a global (multiprocessor) operation, only IF itype=2.
C
      DIMENSION XYZI(3),CG(3),XYZL(3,1)
      DIMENSION TI(4),WORK(4)
C
      TI(1)=0.0
      TI(2)=0.0
      TI(3)=0.0
      TI(4)=N
      DO 100 I=1,N
         TI(1)=TI(1)+XYZL(1,I)
         TI(2)=TI(2)+XYZL(2,I)
         TI(3)=TI(3)+XYZL(3,I)
  100 CONTINUE
      IF (ITYPE.EQ.2) CALL GOP(TI,WORK,'+  ',4)
      IF (TI(4).EQ.0.0) TI(4)=1.0
      CG(1)=TI(1)/TI(4)
      CG(2)=TI(2)/TI(4)
      CG(3)=TI(3)/TI(4)
C
      TI(1)=0.0
      TI(2)=0.0
      TI(3)=0.0
      DO 200 I=1,N
         TI(1)=TI(1)+( XYZL(1,I)-CG(1) )**2
         TI(2)=TI(2)+( XYZL(2,I)-CG(2) )**2
         TI(3)=TI(3)+( XYZL(3,I)-CG(3) )**2
  200 CONTINUE
      IF (ITYPE.EQ.2) CALL GOP(TI,WORK,'+  ',3)
      TI(1)=TI(1)/TI(4)
      TI(2)=TI(2)/TI(4)
      TI(3)=TI(3)/TI(4)
      IF (ITYPE.EQ.2) THEN
C        std. def'n of inertia.
         XYZI(1)=TI(2)+TI(3)
         XYZI(2)=TI(3)+TI(1)
         XYZI(3)=TI(1)+TI(2)
      ELSE
         XYZI(1)=TI(1)
         XYZI(2)=TI(2)
         XYZI(3)=TI(3)
      ENDIF
C
      return
      END
c-----------------------------------------------------------------------
      subroutine volume2(vol,xyz,n)
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      DIMENSION XYZ(3,2,2,2,1)
      DIMENSION VOL(1)
C
      DO 1000 IE=1,N
         VOL(IE)=0.0
         IF (IF3D) THEN        
           DO 20 K=1,2
           DO 20 J=1,2
           DO 20 I=1,2
              VOL1 = (XYZ(1,2,J,K,IE)-XYZ(1,1,J,K,IE))
     $             * (XYZ(2,I,2,K,IE)-XYZ(2,I,1,K,IE))
     $             * (XYZ(3,I,J,2,IE)-XYZ(3,I,J,1,IE))
              VOL2 = (XYZ(1,2,J,K,IE)-XYZ(1,1,J,K,IE))
     $             * (XYZ(2,I,J,2,IE)-XYZ(2,I,J,1,IE))
     $             * (XYZ(3,I,2,K,IE)-XYZ(3,I,1,K,IE))
              VOL3 = (XYZ(1,I,2,K,IE)-XYZ(1,I,1,K,IE))
     $             * (XYZ(2,2,J,K,IE)-XYZ(2,1,J,K,IE))
     $             * (XYZ(3,I,J,2,IE)-XYZ(3,I,J,1,IE))
              VOL4 = (XYZ(1,I,J,2,IE)-XYZ(1,I,J,1,IE))
     $             * (XYZ(2,I,2,K,IE)-XYZ(2,I,1,K,IE))
     $             * (XYZ(3,I,2,K,IE)-XYZ(3,I,1,K,IE))
              VOL5 = (XYZ(1,I,2,K,IE)-XYZ(1,I,1,K,IE))
     $             * (XYZ(2,I,J,2,IE)-XYZ(2,I,J,1,IE))
     $             * (XYZ(3,2,J,K,IE)-XYZ(3,1,J,K,IE))
              VOL6 = (XYZ(1,I,J,2,IE)-XYZ(1,I,J,1,IE))
     $             * (XYZ(2,I,2,K,IE)-XYZ(2,I,1,K,IE))
     $             * (XYZ(3,2,J,K,IE)-XYZ(3,1,J,K,IE))
              VOL(IE) = VOL(IE)+VOL1+VOL2+VOL3+VOL4+VOL5+VOL6
   20      CONTINUE
           VOL(IE)=VOL(IE)/8.0
         ELSE
C     2-D:
            DO 40 J=1,2
            DO 40 I=1,2
              VOL1 = (XYZ(1,2,J,1,IE)-XYZ(1,1,J,1,IE))
     $             * (XYZ(2,I,2,1,IE)-XYZ(2,I,1,1,IE))
              VOL3 = (XYZ(1,I,2,1,IE)-XYZ(1,I,1,1,IE))
     $             * (XYZ(2,2,J,1,IE)-XYZ(2,1,J,1,IE))
              VOL(IE)=VOL(IE)+VOL1+VOL3
   40      CONTINUE
           VOL(IE)=VOL(IE)/4.0
         ENDIF
         VOL(IE)=ABS(VOL(IE))
 1000 CONTINUE
C
      return
      END
c-----------------------------------------------------------------------
      subroutine findcg(cg,xyz,n)
C
C     Compute cg for N elements.
C
      INCLUDE 'SIZE'
      DIMENSION CG(3,1),XYZ(3,8,1)
C
      NCRNR=2**ldim
      CALL RZERO(CG,3*N)
      DO 100 I =1,N
      DO 100 IC=1,NCRNR
         CG(1,I)=CG(1,I)+XYZ(1,IC,I)
         CG(2,I)=CG(2,I)+XYZ(2,IC,I)
         CG(3,I)=CG(3,I)+XYZ(3,IC,I)
  100 CONTINUE
      TMP=1.0/(NCRNR)
      CALL CMULT(CG,TMP,3*N)
      return
      END
c-----------------------------------------------------------------------
      subroutine divide(list1,list2,nl1,nl2,ifok,list,nl,xyzi,cg,WGT)
C
C     Divide the elements associated with this subdomain according to
C     the direction having the smallest moment of inertia (the "long"
C     direction).
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      INCLUDE 'TSTEP'
C
      DIMENSION LIST(LELT),LIST1(LELT),LIST2(LELT)
      DIMENSION XYZI(3),CG(3,LELT),wgt(1)
      COMMON /CTMP0/ XCG(LELT),YCG(LELT),ZCG(LELT)
      REAL IXX,IYY,IZZ
      INTEGER WORK(2),WRK2(2)
      LOGICAL IFOK
C
C     Choose "long" direction:
C
      IXX=XYZI(1)
      IYY=XYZI(2)
      IZZ=XYZI(3)
      IF (IF3D) THEN
         IF (IXX.LE.IYY.AND.IXX.LE.IZZ) THEN
            DO 104 IE=1,NL
               XCG(IE)=CG(1,IE)
               YCG(IE)=CG(2,IE)
               ZCG(IE)=CG(3,IE)
  104       CONTINUE
         ELSEIF (IYY.LE.IXX.AND.IYY.LE.IZZ) THEN
            DO 106 IE=1,NL
               XCG(IE)=CG(2,IE)
               YCG(IE)=CG(3,IE)
               ZCG(IE)=CG(1,IE)
  106       CONTINUE
         ELSEIF (IZZ.LE.IXX.AND.IZZ.LE.IYY) THEN
            DO 108 IE=1,NL
               XCG(IE)=CG(3,IE)
               YCG(IE)=CG(1,IE)
               ZCG(IE)=CG(2,IE)
  108       CONTINUE
         ENDIF
      ELSE
C     2-D:
         IF (IXX.LE.IYY) THEN
            DO 114 IE=1,NL
               XCG(IE)=CG(1,IE)
               YCG(IE)=CG(2,IE)
  114       CONTINUE
         ELSE
            DO 116 IE=1,NL
               XCG(IE)=CG(2,IE)
               YCG(IE)=CG(1,IE)
  116       CONTINUE
         ENDIF
      ENDIF
      call col2(xcg,wgt,nl)
      call col2(ycg,wgt,nl)
      call col2(zcg,wgt,nl)
C
C     Find median value of CG to determine dividing point:
C
      XM=FMDIAN(XCG,NL,IFOK)
      YM=FMDIAN(YCG,NL,IFOK)
      ZM=0.0
      IF (IF3D) ZM=FMDIAN(ZCG,NL,IFOK)
C
C     Diagnostics
C
      IF (.NOT.IFOK) THEN
         WRITE(6,130) NID,NL,XM,YM,ZM
         DO 120 IL=1,NL
            WRITE(6,135) NID,IL,XCG(IL),YCG(IL),ZCG(IL)
  120    CONTINUE
  130    FORMAT(I10,'DIVIDE: NL,XM,YM,ZM',I3,3F12.5)
  135    FORMAT(I10,'DIVIDE: NID,IL,XC,YC,ZCG',I4,3F12.5)
      ENDIF
C
C=============================================================
C     Divide LIST into LIST1 (XCG < XM) and LIST2 (XCG>XM).
C=============================================================
C
      NL1=0
      NL2=0
      DO 200 IE=1,NL
         IF (XCG(IE).LT.XM) THEN
            NL1=NL1+1
            LIST1(NL1)=LIST(IE)
         ENDIF
         IF (XCG(IE).GT.XM) THEN
            NL2=NL2+1
            LIST2(NL2)=LIST(IE)
         ENDIF
         IF (XCG(IE).EQ.XM) THEN
C
C           We have to look at the other directions to arrive at
C           a unique subdivision algortithm.
C
C
C           More Diagnostics
C
            IF (.NOT.IFOK) WRITE(6,201) NID,IE,XCG(IE),XM
  201    FORMAT(I10,'DIVIDE: IE,XCG,XM:',I4,3F12.5)
C
            IF (YCG(IE).LT.YM) THEN
               NL1=NL1+1
               LIST1(NL1)=LIST(IE)
            ENDIF
            IF (YCG(IE).GT.YM) THEN
               NL2=NL2+1
               LIST2(NL2)=LIST(IE)
            ENDIF
            IF (YCG(IE).EQ.YM) THEN
C              look at 3rd direction.  
               IF (IF3D .AND. ZCG(IE).LT.ZM) THEN
                  NL1=NL1+1
                  LIST1(NL1)=LIST(IE)
               ELSE IF (IF3D .AND. ZCG(IE).GT.ZM) THEN
                  NL2=NL2+1
                  LIST2(NL2)=LIST(IE)
               ELSE 
C                 for 2- or 3-D intdeterminate case:
                  NL1=NL1+1
                  LIST1(NL1)=LIST(IE)
               ENDIF
            ENDIF
C
         ENDIF
  200 CONTINUE
C
C     Check for an even distribution (i.e. - not different by
C     more than 1):
C
      IFOK=.TRUE.  
      WORK(1)=NL1 
      WORK(2)=NL2
      CALL IGOP(WORK,WRK2,'+  ',2)
      IF (ABS(WORK(1)-WORK(2)).GT.1) IFOK=.FALSE.
C
      return
      END
c-----------------------------------------------------------------------
      subroutine bufchk(buf,n)
      integer n
      real buf(n)
      do i=1,n
         write(6,*) buf(i), ' whhhh'
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine chk_xyz
      include 'SIZE'
      include 'TOTAL'
      integer e,f,eg

      do e=1,nelt
         eg = lglel(e)
         write(6,1) nid,eg,e,(cbc(f,e,1),f=1,6)
      enddo
    1 format(3i12,6(1x,a3),'  cbc')

      return
      end
c-----------------------------------------------------------------------
      subroutine chk_nel
      include 'SIZE'
      include 'TOTAL'

      neltmx=np*lelt
      nelvmx=np*lelv

      neltmx=min(neltmx,lelg)
      nelvmx=min(nelvmx,lelg)

      nelgt = iglmax(nelgt,1)
      nelgv = iglmax(nelgv,1)

c     write(6,*) nid,' inside chk_nel',nelgt,neltmx,nelvmx

      if (nelgt.gt.neltmx.or.nelgv.gt.nelvmx) then
         if (nid.eq.0) then
          lelt_needed = nelgt/np
          if (mod(nelgt,np).ne.0) lelt_needed = lelt_needed + 1 
          write(6,12) lelt,lelg,lelt_needed,np,nelgt
 12         format(//,2X,'ABORT: Problem size too large!'
     $         ,/,2X
     $         ,/,2X,'This solver has been compiled for:'
     $         ,/,2X,'   number of elements/proc  (lelt):',i12
     $         ,/,2X,'   total number of elements (lelg):',i12
     $         ,/,2X
     $         ,/,2X,'Recompile with the following SIZE  parameters:'
     $         ,/,2X,'   lelt >= ',i12,'  for np = ',i12
     $         ,/,2X,'   lelg >= ',i12,/)
c           write(6,*)'help:',lp,np,nelvmx,nelgv,neltmx,nelgt
c           write(6,*)'help:',lelt,lelv,lelgv
         endif
         call exitt
      endif

      if(nelgt.gt.nelgt_max) then
        if(nid.eq.0) write(6,*)
     $               'ABORT: Total number of elements too large!',
     $               '       nel_max = ', nelgt_max 
        call exitt
      endif

      if (nelt.gt.lelt) then
        write(6,'(A,3I12)') 'ABORT: nelt>lelt!', nid, nelt, lelt
        call exitt
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine cscan(sout,key,nk)

      character*132 sout,key
      character*132 string
      character*1  string1(132)
      equivalence (string1,string)
c
      do i=1,100000000
         call blank(string,132)
         read (nk,80,end=100,err=100) string
         call chcopy(sout,string,132)
c        write (6,*) string
         if (indx1(string,key,nk).ne.0) return
      enddo
  100 continue
c
   80 format(a132)
      return

      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two-dimensional array computation:
!Only one loop is associated with the omp for construct.
!The inner loop's loop iteration variable needs an explicit private() clause,
!otherwise it will be shared by default. No data race pairs.

program DRB046_doall2_orig_no
    use omp_lib
    implicit none

    integer :: i, j
    integer :: a(100,100)

    !$omp parallel do private(j)
    do i = 1, 100
        do j = 1, 100
            a(i,j) = a(i,j)+1
        end do
    end do
    !$omp end parallel do
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The outmost loop is be parallelized.
!But the inner level loop has out of bound access for b[i][j] when i equals to 1.
!This will case memory access of a previous column's last element.
!
!For example, an array of 4x4:
!    j=1 2 3 4
! i=1  x x x x
!   2  x x x x
!   3  x x x x
!   4  x x x x
!  outer loop: j=3,
!  inner loop: i=1
!  array element accessed b[i-1][j] becomes b[0][3], which in turn is b[4][2]
!  due to linearized column-major storage of the 2-D array.
!  This causes loop-carried data dependence between j=2 and j=3.
!
!
!Data race pair: b[i][j]@67 vs. b[i-1][j]@67


program DRB015_outofbounds_var_yes
    use omp_lib
    implicit none

    integer :: i, j, n, m, len, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    real, dimension (:,:), allocatable :: b
    len = 100

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    n = len
    m = len

    allocate (b(n,m))

    !$omp parallel do private(i)
    do j = 2, n
        do i = 1, m
            b(i,j) = b(i-1,j)
        end do
    end do
    !$omp end parallel do
    print*,"b(50,50)=",b(50,50)

    deallocate(args,b)
end program

      subroutine MAKE_HPF

      include 'SIZE'
      include 'SOLN'
      include 'INPUT'         ! param(110),(111)
      include 'TSTEP'         ! ifield
      include 'MASS'          ! BM1

      integer nxyz
      parameter (nxyz=lx1*ly1*lz1)
      integer n

      integer lm,lm2
      parameter (lm=40)
      parameter (lm2=lm*lm)
      real hpf_filter(lm2)

      integer hpf_kut
      real hpf_chi
      logical hpf_ifboyd

      integer nel

      integer icalld
      save icalld
      data icalld /0/

      real TA1,TA2,TA3
      COMMON /SCRUZ/ TA1 (LX1,LY1,LZ1,LELV)
     $ ,             TA2 (LX1,LY1,LZ1,LELV)
     $ ,             TA3 (LX1,LY1,LZ1,LELV)

      real hpf_op(lx1,lx1)
      save hpf_op

c---------------------------------------- 
      if(.not. iffilter(ifield)) return

      hpf_kut = int(param(101))+1
      hpf_chi = -1.0*abs(param(103))
c     Boyd transform to preserve element boundary values is 
c     linearly unstable when used as forcing.
      hpf_ifboyd = .false.      

      nel = nelv
      n = nxyz*nel

      if (hpf_chi.eq.0) return
      if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'apply hpf ',
     $                                 ifield, hpf_kut, hpf_chi

      if (icalld.eq.0) then
c       Create the filter transfer function
        call hpf_trns_fcn(hpf_filter,hpf_kut)

c       Build the matrix to apply the filter function
c       to an input field
        call build_hpf_mat(hpf_op,hpf_filter,hpf_ifboyd)

c       Only initialize once    
        icalld=icalld+1 
      endif

      if (ifield.eq.1) then
c       Apply the filter
c       to velocity fields
        if (jp.eq.0) then 
          call build_hpf_fld(ta1,vx,hpf_op,lx1,lz1)
          call build_hpf_fld(ta2,vy,hpf_op,lx1,lz1)
          if (if3d) call build_hpf_fld(ta3,vz,hpf_op,lx1,lz1)

c         Multiply by filter weight (chi)
          call cmult(ta1,hpf_chi,n)    
          call cmult(ta2,hpf_chi,n)    
          if (if3d) call cmult(ta3,hpf_chi,n)    

c         Multiply by Mass matrix 
c         and add to forcing term 
          call opadd2col (bfx,bfy,bfz,ta1,ta2,ta3,bm1)
        else
c         Apply filter on velocity perturbation fields
          call build_hpf_fld(ta1,vxp(1,jp),hpf_op,lx1,lz1)
          call build_hpf_fld(ta2,vyp(1,jp),hpf_op,lx1,lz1)
          if (if3d) call build_hpf_fld(ta3,vzp(1,jp),hpf_op,lx1,lz1)

c         Multiply by filter weight (chi)
          call cmult(ta1,hpf_chi,n)    
          call cmult(ta2,hpf_chi,n)    
          if (if3d) call cmult(ta3,hpf_chi,n)    

c         Multiply by Mass matrix 
c         and add to forcing term 
          call opadd2col (bfxp(1,jp),bfyp(1,jp),bfzp(1,jp),
     $                    ta1,ta2,ta3,bm1)
        endif        

      else

c       Apply filter to temp/passive scalar fields
        if (jp.eq.0) then
          call build_hpf_fld(ta1,t(1,1,1,1,ifield-1),
     $         hpf_op,lx1,lz1)

c         Multiply by filter weight (chi)
          call cmult(ta1,hpf_chi,n)    

c         Multiply by Mass matrix    
c         and add to source term
          call addcol3(bq(1,1,1,1,ifield-1),ta1,bm1,n)
        else
c         Apply filter on scalar perturbation field                
          call build_hpf_fld(ta1,tp(1,ifield-1,jp),hpf_op,lx1,lz1)

c         Multiply by filter weight (chi)
          call cmult(ta1,hpf_chi,n)    

c         Multiply by Mass matrix    
c         and add to source term
          call addcol3(bqp(1,ifield-1,jp),ta1,bm1,n)
        endif  

      endif

      return
      end

c----------------------------------------------------------------------

      subroutine build_hpf_mat(op_mat,f_filter,ifboyd)

c     Builds the operator for high pass filtering
c     Transformation matrix from nodal to modal space.
c     Applies f_filter to the the legendre coefficients
c     Transforms back to nodal space
c     Operation: V * f_filter * V^(-1)
c     Where V is the transformation matrix from modal to nodal space

c      implicit none

      include 'SIZE'

      logical IFBOYD 
      integer n
      parameter (n=lx1*lx1)
      integer lm, lm2
      parameter (lm=40)
      parameter (lm2=lm*lm)

      real f_filter(lm2)
      real op_mat(lx1,lx1)

      real ref_xmap(lm2)
      real wk_xmap(lm2)

      real wk1(lm2),wk2(lm2)
      real indr(lm),ipiv(lm),indc(lm)

      real rmult(lm)
      integer ierr

      integer i,j

      call spec_coeff_init(ref_xmap,ifboyd)
      
      call copy(wk_xmap,ref_xmap,lm2)
      call copy(wk1,wk_XMAP,lm2)

      call gaujordf  (wk1,lx1,lx1,indr,indc,ipiv,ierr,rmult)  ! xmap inverse

      call mxm  (f_filter,lx1,wk1,lx1,wk2,lx1)        !          -1
      call mxm  (wk_xmap,lx1,wk2,lx1,op_mat,lx1)      !     V D V

      return
      end

c---------------------------------------------------------------------- 

      subroutine build_hpf_fld(v,u,f,nx,nz)

c     Appies the operator f to field u
c     using tensor operations
c     v = f*u

c      implicit none

      include 'SIZE'
      include 'TSTEP'         ! ifield

      integer nxyz 
      parameter (nxyz=lx1*ly1*lz1)

      real w1(nxyz),w2(nxyz)              ! work arrays
      real v(nxyz,lelv)                   ! output fld
      real u(nxyz,lelv)                   ! input fld
c
      integer nx,nz

      real f(nx,nx),ft(nx,nx)             ! operator f and its transpose
c
      integer e,i,j,k
      integer nel

      nel = nelv

      call copy(v,u,nxyz*nel)
c
      call transpose(ft,nx,f,nx)
c
      if (ldim.eq.3) then
        do e=1,nel
c         Filter
          call copy(w2,v(1,e),nxyz)
          call mxm(f,nx,w2,nx,w1,nx*nx)
          i=1
          j=1
          do k=1,nx
             call mxm(w1(i),nx,ft,nx,w2(j),nx)
             i = i+nx*nx
             j = j+nx*nx
          enddo
          call mxm (w2,nx*nx,ft,nx,w1,nx)

          call sub3(w2,u(1,e),w1,nxyz)
          call copy(v(1,e),w2,nxyz)
c          call copy(v(1,e),w1,nxyz)  

        enddo
      else
        do e=1,nel
c         Filter
          call copy(w1,v(1,e),nxyz)
          call mxm(f ,nx,w1,nx,w2,nx)
          call mxm(w2,nx,ft,nx,w1,nx)

          call sub3(w2,u(1,e),w1,nxyz)
          call copy(v(1,e),w2,nxyz)
c          call copy(v(1,e),w1,nxyz) 
        enddo
      endif
c
      return
      end

c---------------------------------------------------------------------- 

      subroutine hpf_trns_fcn(diag,kut)

c      implicit none

      include 'SIZE'
      include 'PARALLEL'

      real diag(lx1*lx1)
      integer nx,k0,kut,kk,k

      real amp

c     Set up transfer function
c
      nx = lx1
      call ident   (diag,nx)
c
      kut=kut                                     ! kut=additional modes
      k0 = nx-kut
      do k=k0+1,nx
        kk = k+nx*(k-1)
        amp = ((k-k0)*(k-k0)+0.)/(kut*kut+0.)     ! Normalized amplitude. quadratic growth
        diag(kk) = 1.-amp
      enddo

c     Output normalized transfer function
      k0 = lx1+1
      if (nio.eq.0) then
        write(6,6) 'HPF :',((1.-diag(k)), k=1,lx1*lx1,k0)
   6    format(a8,16f9.6,6(/,8x,16f9.6))
      endif

      return
      end

c---------------------------------------------------------------------- 

      subroutine spec_coeff_init(ref_xmap,ifboyd)
c     Initialise spectral coefficients
c     For legendre transform

c      implicit none

      include 'SIZE'
      include 'WZ'

      integer lm, lm2
      parameter (lm=40)
      parameter (lm2=lm*lm)

c     local variables
      integer i, j, k, n, nx, kj
c     Legendre polynomial
      real plegx(lm)
      real z
      real ref_xmap(lm2)
      real pht(lm2)

c     Change of basis
      logical IFBOYD
c---------------------------------------- 

      nx = LX1
      kj = 0
      n  = nx-1
      do j=1,nx
        z = ZGM1(j,1)
        call legendre_poly(plegx,z,n)
        kj = kj+1
        pht(kj) = plegx(1)
        kj = kj+1
        pht(kj) = plegx(2)

        if (IFBOYD) then        ! change basis to preserve element boundary values
          do k=3,nx
             kj = kj+1
             pht(kj) = plegx(k)-plegx(k-2)
          enddo
        else                    ! legendre basis    
          do k=3,nx
             kj = kj+1
             pht(kj) = plegx(k)
          enddo         
        endif
      enddo

      call transpose (ref_xmap,nx,pht,nx)

      return
      end

#ifndef CVODE
      subroutine cv_setsize

      include 'SIZE'
      if(nio.eq.0) write(6,*) 'ABORT: not compiled with CVODE support!'
      call exitt

      return
      end
c----------------------------------------------------------------------
      subroutine cv_init

      include 'SIZE'
      if(nio.eq.0) write(6,*) 'ABORT: not compiled with CVODE support!'
      call exitt

      return
      end
c----------------------------------------------------------------------
      subroutine cdscal_cvode

      include 'SIZE'
      if(nio.eq.0) write(6,*) 'ABORT: not compiled with CVODE support!'
      call exitt

      return
      end
c----------------------------------------------------------------------
#else
      subroutine cv_setsize

      include 'SIZE'
      include 'TOTAL'
      include 'CVODE'

      integer*8 i8glsum

      nxyz = lx1*ly1*lz1

      ! set local ODE size
      cv_nlocal = 0
      do i = 2,nfield
         if (ifcvfld(i)) then
           ntot = nxyz*nelfld(i)
           cv_nlocal = cv_nlocal + ntot
         endif
      enddo

      ! check array size is large enough
      if (cv_nlocal .gt. cv_lysize) then
        if(nio.eq.0) write(6,*)
     &  'ABORT cv_setsize(): workspace too small, check SIZE! ' 
        call exitt
      endif 

      ! determine global ODE size
      cv_nglobal = i8glsum(cv_nlocal,1)

      return
      end
c----------------------------------------------------------------------
      subroutine cv_init

      include 'SIZE'
      include 'TOTAL'
      include 'CVODE'

      common /CVWRK1/  y0(cv_lysize) 

      ! cvode will not allocate these arrays
      common /cv_rout/ rout(6),rpar(1)

      integer*8 iout,ipar
      integer cvcomm
      common /cv_iout/ iout(21),ipar(1),cvcomm

      real cv_atol_(lx1,ly1,lz1,lelt,ldimt)
      common /CV_YDOT/ cv_atol_ ! used as scratch

      integer cv_meth

      real*8 etime1
      character*15 txt_meth,txt_itask

      real atol_t(ldimt)


      nxyz = lx1*ly1*lz1
      ifcvodeinit   = .false.

      if(nio.eq.0) write(*,*) 'Initializing CVODE ...'
      etime1=dnekclock_sync()

      cv_timel = -1
      call cv_rstat

      ! set solver parameters
      cv_itask    = param(160)
      cv_meth     = param(161) ! AM or BDF
      cv_rtol     = param(163) 
      cv_dtmax    = param(164)
      cv_sigs     = param(165) 
      cv_delt     = param(166)
      cv_ipretype = param(167) ! 0: no, 1:left, 2: right
      cv_maxl     = 20         ! max dimension of Krylov subspace
      cv_iatol    = 2          ! 1: scalar 2: vector

      ! setup absolute tolerances
      if (cv_iatol.eq.1) then
         cv_atol(1) = param(162)
      else if (cv_iatol.eq.2) then
         do i = 2,nfield
            if (ifcvfld(i)) then
               ntot = nxyz*nelfld(i)
               call cfill(cv_atol_(1,1,1,1,i-1),atol(i),ntot)
            endif
         enddo
         call cvpack(cv_atol,cv_atol_,.false.)
      endif

      ! initialize vector module
      call create_comm(cvcomm)
#ifdef MPI
      call fnvinitp(cvcomm, 1, cv_nlocal, cv_nglobal, ier)
#else
      call fnvinits(1, cv_nlocal, ier)
#endif
      if (ier.ne.0) then
        write(*,'(a,i3)') 'ABORT cv_init(): fnvinitp ier=', ier
        call exitt
      endif

      ! initialize cvode
      call cvpack(y0,t,.false.)
      call fcvmalloc(time, y0, cv_meth, itmeth, cv_iatol,
     &               cv_rtol, cv_atol, iout, rout, ipar, rpar, ier)
      if (ier.ne.0) then
        write(*,'(a,i3)') 'ABORT cv_init(): fcvmalloc ier=', ier
        call exitt
      endif

      ! initialize linear solver
      call fcvspGMR(cv_ipretype,igstype,cv_maxl,cv_delt,ier)
      if (ier .ne. 0) then
        write(*,'(a,i3)') 'ABORT cv_init(): fcvspgmr ier=', ier
        call exitt
      endif

      ! preconiditoner
      if(cv_ipretype.gt.0) call fcvspilssetprec(1, ier)

      ! enable user-supplied Jacobian routine
      call fcvspilssetjac(1, ier)

      ! print solver settings
      etime1 = dnekclock_sync() - etime1
      if(nio.eq.0) then
        if(cv_meth.eq.1) txt_meth='AM'      
        if(cv_meth.eq.2) txt_meth='BDF'      
        write(6,'(A,A)')         '   integration method             : ',
     &                         txt_meth
        if(cv_itask.eq.1) txt_itask='NORMAL'      
        if(cv_itask.eq.3) txt_itask='NORMAL_TSTOP'      
        write(6,'(A,A)')         '   integration mode               : ',
     &                         txt_itask
        write(6,'(A,i10)')       '   Nglobal                        : ',
     &                         cv_nglobal
        write(6,'(A,1pe8.1)')    '   relative tolerance             : ',
     &                         cv_rtol

        do i = 2,nfield
           if (ifcvfld(i)) then
              if (cv_iatol.eq.1) then
                 dd = cv_atol(1)
              else
                 ntot = nxyz*nelfld(i)
                 dd = vlmax(cv_atol_(1,1,1,1,i-1),ntot)
              endif

              write(6,1000) i, dd
 1000         format(3x,'absolute tolerance field ',i3,'   : ',1pe8.1)
           endif
        enddo

        write(6,'(A,i3)')     '   krylov dimension               : ',
     &                         cv_maxl
        write(6,'(A,f5.3)')   '   ratio linear/non-linear tol    : ',
     &                         cv_delt
        write(6,'(A,i3)')     '   preconditioner                 : ',
     &                         int(param(167))
        write(6,'(A,1pe8.1)') '   dt_max                         : ',
     &                         cv_dtmax
        write(6,'(A,f5.3)')  '   increment factor         DQJ   : ',
     &                         cv_sigs
        write(6,'(A,g15.3,A,/)') ' done :: initializing CVODE',
     &                         etime1, ' sec'
      endif

      ifcvodeinit = .true.

      return
      end
c----------------------------------------------------------------------
      subroutine cdscal_cvode
c
c     Top level driver for CVODE
c     webpage: https://computation.llnl.gov/casc/sundials 
c
c     Integrate the IVP d/dt[y] = f(y(t),t); y(t=t0) := f0
c     using BDF(stiff) or AM(non-stiff).
c     f denotes the RHS function and is evaluated in fcvfun().
c
      include 'SIZE'
      include 'TOTAL'
      include 'CVODE'

      common /CVWRK1/  y(cv_lysize) 

      common /CVWRK2/  vx_ (lx1,ly1,lz1,lelv) 
     &                ,vy_ (lx1,ly1,lz1,lelv)
     &                ,vz_ (lx1,ly1,lz1,lelv)
     &                ,xm1_(lx1,ly1,lz1,lelv)
     &                ,ym1_(lx1,ly1,lz1,lelv)
     &                ,zm1_(lx1,ly1,lz1,lelv)
     &                ,wx_ (lx1,ly1,lz1,lelv)
     &                ,wy_ (lx1,ly1,lz1,lelv)
     &                ,wz_ (lx1,ly1,lz1,lelv)

      integer*8 iout,ipar
      integer cvcomm
      common /cv_iout/ iout(21),ipar(1),cvcomm

      nxyz = lx1*ly1*lz1
      ntot = nxyz * nelv

      if (.not.ifcvodeinit) then
        write(6,*) 'ABORT: CVODE was not initialized!'
        call exitt
      endif 

      ! save old output values
      if (cv_itask.eq.1) then
        do i=1,21
           iout_save(i) = iout(i)
        enddo
      endif

      ! save coord and mesh vel
      if(ifmvbd) then
        call copy(xm1_,xm1,ntot)           
        call copy(ym1_,ym1,ntot)           
        if (if3d) call copy(zm1_,zm1,ntot) 
        call copy(wx_,wx,ntot)           
        call copy(wy_,wy,ntot)           
        if (if3d) call copy(wz_,wz,ntot) 
      endif

      ! save velocities                  
      call copy(vx_,vx,ntot)             
      call copy(vy_,vy,ntot)            
      if (if3d) call copy(vz_,vz,ntot)  

      ! MAIN solver call
      time_ = time
      call fcvsetrin('MAX_STEP',cv_dtmax,ier)
c      call fcvsetiin('MAX_ORD' ,3       ,ier)

      if (cv_itask.eq.3) then
        if(istep.gt.1) then 
          call cvpack(y,t,.false.)
          call fcvreinit(timef,y,cv_iatol,cv_rtol,cv_atol,ier)
          if (ier .ne. 0) then
            write(*,'(a,i3)') 'ABORT: fcvsetrin ier=', ier
            call exitt
          endif
          cv_timel = 0
          call cv_rstat
        endif
        call fcvsetrin('STOP_TIME',time,ier)
      endif

      call fcvode(time,tout,y,cv_itask,ier)
      time = time_

      if (ier.lt.0) then
         if (nid.eq.0) then
            write(*,'(a)') ' Restart integrator and try again  ...'
         endif
         call cvpack(y,t,.false.)
         call fcvreinit(timef,y,cv_iatol,cv_rtol,cv_atol,ier)
         cv_timel = 0
         call cv_rstat
         call fcvode(time,tout,y,cv_itask,ier)
         time = time_
      endif
        
      if (ier.lt.0) then
         if (nid.eq.0) then
            write(*,'(a,i3)') 'ABORT: fcvode returned ier =', ier
         endif
         call exitt
      endif

      cv_istep = cv_istep + 1 
      call cvunpack(t,y)

      ! restore velocities               
      call copy(vx,vx_,ntot)             
      call copy(vy,vy_,ntot)             
      if (if3d) call copy(vz,vz_,ntot) 
      if (param(99).gt.0) call set_convect_new(vxd,vyd,vzd,vx,vy,vz)
 
      ! restore coord and mesh vel 
      if(ifmvbd) then        
        call copy(xm1,xm1_,ntot)           
        call copy(ym1,ym1_,ntot)          
        if (if3d) call copy(zm1,zm1_,ntot) 
        call copy(wx,wx_,ntot)           
        call copy(wy,wy_,ntot)           
        if (if3d) call copy(wz,wz_,ntot) 

        call cv_eval_geom                      
      endif

      ! print solver statistics 
      if (nid.eq.0) call cv_pstat

      return
      end
c----------------------------------------------------------------------
      subroutine cv_upd_v
c
      include 'SIZE'
      include 'TSTEP'
      include 'DEALIAS'
      include 'SOLN'
      include 'INPUT'
      include 'CVODE'

      common /CVWRK2/  vx_ (lx1,ly1,lz1,lelv) 
     &                ,vy_ (lx1,ly1,lz1,lelv)
     &                ,vz_ (lx1,ly1,lz1,lelv)
     &                ,xm1_(lx1,ly1,lz1,lelv)
     &                ,ym1_(lx1,ly1,lz1,lelv)
     &                ,zm1_(lx1,ly1,lz1,lelv)
     &                ,wx_ (lx1,ly1,lz1,lelv)
     &                ,wy_ (lx1,ly1,lz1,lelv)
     &                ,wz_ (lx1,ly1,lz1,lelv)

      ntot = lx1*ly1*lz1*nelv

      call sumab(vx,vx_,vxlag,ntot,cv_ab,nbd)
      call sumab(vy,vy_,vylag,ntot,cv_ab,nbd)
      if(if3d) call sumab(vz,vz_,vzlag,ntot,cv_ab,nbd)

      return
      end
c----------------------------------------------------------------------
      subroutine cv_upd_w
c
      include 'SIZE'
      include 'TSTEP'
      include 'MVGEOM'
      include 'INPUT'
      include 'CVODE'

      common /CVWRK2/  vx_ (lx1,ly1,lz1,lelv) 
     &                ,vy_ (lx1,ly1,lz1,lelv)
     &                ,vz_ (lx1,ly1,lz1,lelv)
     &                ,xm1_(lx1,ly1,lz1,lelv)
     &                ,ym1_(lx1,ly1,lz1,lelv)
     &                ,zm1_(lx1,ly1,lz1,lelv)
     &                ,wx_ (lx1,ly1,lz1,lelv)
     &                ,wy_ (lx1,ly1,lz1,lelv)
     &                ,wz_ (lx1,ly1,lz1,lelv)

      ntot = lx1*ly1*lz1*nelv

      call sumab(wx,wx_,wxlag,ntot,cv_ab,nbd)
      call sumab(wy,wy_,wylag,ntot,cv_ab,nbd)
      if(if3d) call sumab(wz,wz_,wzlag,ntot,cv_ab,nbd)

      return
      end
c----------------------------------------------------------------------
      subroutine cv_upd_coor
c
      include 'SIZE'
      include 'TSTEP'
      include 'GEOM'
      include 'MVGEOM'
      include 'INPUT'
      include 'CVODE'

      common /CVWRK2/  vx_ (lx1,ly1,lz1,lelv) 
     &                ,vy_ (lx1,ly1,lz1,lelv)
     &                ,vz_ (lx1,ly1,lz1,lelv)
     &                ,xm1_(lx1,ly1,lz1,lelv)
     &                ,ym1_(lx1,ly1,lz1,lelv)
     &                ,zm1_(lx1,ly1,lz1,lelv)
     &                ,wx_ (lx1,ly1,lz1,lelv)
     &                ,wy_ (lx1,ly1,lz1,lelv)
     &                ,wz_ (lx1,ly1,lz1,lelv)

      COMMON /SCRSF/ dtmp(lx1*ly1*lz1*lelv)

      ntot = lx1*ly1*lz1*nelv

      call sumab(dtmp,wx_,wxlag,ntot,cv_abmsh,nabmsh)
      call add3 (xm1,xm1_,dtmp,ntot)

      call sumab(dtmp,wy_,wylag,ntot,cv_abmsh,nabmsh)
      call add3 (ym1,ym1_,dtmp,ntot)

      if(if3d) then
        call sumab(dtmp,wz_,wzlag,ntot,cv_abmsh,nabmsh)
        call add3 (zm1,zm1_,dtmp,ntot)
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine fcvfun (time_, y, ydot, ipar, rpar, ier)
c
c     Compute RHS function f (called within cvode)
c     CAUTION: never touch y! 
c
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
      include 'CVODE'

      real time_,y(*),ydot(*),rpar(*)
      integer*8 ipar(*)

      real w1(lx1,ly1,lz1,lelt),
     $     w2(lx1,ly1,lz1,lelt),
     $     w3(lx1,ly1,lz1,lelt)

      real ydott(lx1,ly1,lz1,lelt,ldimt)
      common /CV_YDOT/ ydott

      ifcvfun = .true.
      etime1  = dnekclock()
      time    = time_   
      nxyz    = lx1*ly1*lz1
      ntotv   = nxyz*nelv
       
      if (time.ne.cv_timel) then
         call cv_settime     
 
         if(nio.eq.0) write(6,10) istep,time,time-cv_timel
  10       format(4x,i7,2x,'t=',1pE14.7,'  stepsize=',1pE13.4)

         call cv_upd_v
         call copy(w1,vx,ntotv)
         call copy(w2,vy,ntotv)
         if (if3d) call copy(w3,vz,ntotv)

         if (ifmvbd) then
            call cv_upd_coor 
            call cv_eval_geom
            call cv_upd_w
            call sub2(vx,wx,ntotv)
            call sub2(vy,wy,ntotv)
            if (if3d) call sub2(vz,wz,ntotv)
         endif
        
         if (param(99).gt.0) call set_convect_new(vxd,vyd,vzd,vx,vy,vz)

         call copy(vx,w1,ntotv)
         call copy(vy,w2,ntotv)
         if (if3d) call copy(vz,w3,ntotv)

         cv_timel = time          
      endif

      call cvunpack(t,y)          

      if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'fcvfun',
     $                                 ifdqj

      ifield = 1
      call vprops ! we may use fluid properties somewhere
      do ifield=2,nfield
         if (ifcvfld(ifield)) call vprops
      enddo  

      do ifield=2,nfield
         if (ifcvfld(ifield)) then
           ntot = nxyz*nelfld(ifield)
           call makeq

           if (iftmsh(ifield)) then                                
              call dssum(bq(1,1,1,1,ifield-1),lx1,ly1,lz1)
              call col2(bq(1,1,1,1,ifield-1),bintm1,ntot)

              call col3(w1,vtrans(1,1,1,1,ifield),bm1,ntot)      
              call dssum(w1,lx1,ly1,lz1)                        
              call col2(w1,bintm1,ntot)                           
           else                                                    
              call copy(w1,vtrans(1,1,1,1,ifield),ntot)
           endif    

           call invcol3(ydott(1,1,1,1,ifield-1),bq(1,1,1,1,ifield-1),
     &                  w1,ntot)           
         endif
      enddo

      if (ifgsh_fld_same) then ! all fields are on the v-mesh
         istride = lx1*ly1*lz1*lelt
         call nvec_dssum(ydott,istride,nfield-1,gsh_fld(1))
      else
         do ifield = 2,nfield
            if (ifcvfld(ifield) .and. gsh_fld(ifield).ge.0) then
               if(.not.iftmsh(ifield))       
     &         call dssum(ydott(1,1,1,1,ifield-1),lx1,ly1,lz1)
            endif
         enddo
      endif

      do ifield = 2,nfield
         if (ifcvfld(ifield)) then                                
           ntot = nxyz*nelfld(ifield)
           if (.not.iftmsh(ifield) .and. gsh_fld(ifield).ge.0) then
              call col2(ydott(1,1,1,1,ifield-1),binvm1,ntot)
           endif
         endif
      enddo

      call cvpack(ydot,ydott,.true.)

      tcvf = tcvf + dnekclock()-etime1 
      ncvf = ncvf + 1 

      ier = 0
      ifcvfun = .false.

      return
      end

#endif
c----------------------------------------------------------------------
      subroutine cv_eval_geom

      call glmapm1
      call geodat1
      call geom2
      call volume
      call setinvm
      call setdef

      return
      end

c----------------------------------------------------------------------
      subroutine cv_settime

      include 'SIZE'
      include 'TSTEP'
      include 'CVODE'

      cv_dtNek = time - timef ! stepsize between nek and cvode    

      cv_dtlag(1) = cv_dtNek 
      cv_dtlag(2) = dtlag(2)
      cv_dtlag(3) = dtlag(3)

      call rzero(cv_abmsh,3)
      call setabbd(cv_abmsh,cv_dtlag,nabmsh,1)
      do i = 1,3
         cv_abmsh(i) = cv_dtNek*cv_abmsh(i) 
      enddo

      call rzero(cv_ab,3)
      call setabbd(cv_ab,cv_dtlag,nbd,nbd)

      call rzero(cv_bd,4)
      call setbd(cv_bd,cv_dtlag,nbd)

      return
      end
c----------------------------------------------------------------------
      subroutine cv_pstat

      include 'SIZE'
      include 'CVODE'

      integer*8 iout,ipar
      integer cvcomm
      common /cv_iout/ iout(21),ipar(1),cvcomm

      real nli_nni

      nstp        = iout(3) - iout_save(3)
      nfe         = iout(4) - iout_save(4) + iout(20)-iout_save(20)
      nni         = iout(7) - iout_save(7)
      nli         = iout(20)- iout_save(20)
      nli_nni     = float(nli)/max(1,nni)

      nfe_avg     = (1.-1./cv_istep)*nfe_avg     + nfe/cv_istep
      nli_nni_avg = (1.-1./cv_istep)*nli_nni_avg + nli_nni/cv_istep      

      write(*,'(13x,a8,i8,3x,a8,i8,3x,a10,f5.1)')
     &    'nsteps: ',   nstp     ,
     &    'nfe:    ',   nfe      ,
     &    '<nfe>:    ', nfe_avg
      write(*,'(13x,a8,i8,3x,a8,i8,3x,a10,f5.1)')  
     &    'nni:    ',   nni      ,
     &    'nli:    ',   nli      ,
     &    '<nli/nni>:', nli_nni_avg
      write(*,'(13x,a8,i8,3x,a8,i8,3x,a10,i5)') 
     &    'ncfn:   '  ,iout(6)-iout_save(6),
     &    'ncfl:   '  ,iout(21)-iout_save(21),  
     &    'netf:     ',iout(5)-iout_save(5) 

      return
      end
c----------------------------------------------------------------------
      subroutine cv_rstat

      include 'SIZE'
      include 'CVODE'

      do i=1,21
         iout_save(i) = 0.0
      enddo

      nfe_avg     = 0
      nli_nni_avg = 0
      cv_istep    = 0
 
      return
      end
c----------------------------------------------------------------------

      subroutine setupds(gs_handle,nx,ny,nz,nel,melg,vertex,glo_num)
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'NONCON'

      integer gs_handle
      integer vertex(1)
      integer*8 glo_num(1),ngv

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      t0 = dnekclock()

c     Global-to-local mapping for gs
      call set_vert(glo_num,ngv,nx,nel,vertex,.false.)

c     Initialize gather-scatter code
      ntot      = nx*ny*nz*nel
      call fgslib_gs_setup(gs_handle,glo_num,ntot,nekcomm,mp)

c     call gs_chkr(glo_num)

      t1 = dnekclock() - t0
      if (nio.eq.0) then
         write(6,1) t1,gs_handle,nx,ngv,melg
    1    format('   setupds time',1pe11.4,' seconds ',2i3,2i12)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine dssum(u,nx,ny,nz)
      include 'SIZE'
      include 'CTIMER'
      include 'INPUT'
      include 'NONCON'
      include 'PARALLEL'
      include 'TSTEP'
      real u(1)

      parameter (lface=lx1*ly1)
      common /nonctmp/ uin(lface,2*ldim),uout(lface)

      ifldt = ifield
c     if (ifldt.eq.0)       ifldt = 1
      if (ifldt.eq.ifldmhd) ifldt = 1
c     write(6,*) ifldt,ifield,gsh_fld(ifldt),imesh,' ifldt'

      if (ifsync) call nekgsync()

#ifdef TIMER
      if (icalld.eq.0) then
         tdsmx=0.
         tdsmn=0.
      endif
      icalld=icalld+1
      etime1=dnekclock()
#endif

c
c                 T         ~  ~T  T
c     Implement QQ   :=   J Q  Q  J
c 
c 
c                  T
c     This is the J  part,  translating child data
c
c      call apply_Jt(u,nx,ny,nz,nel)
c
c
c
c                 ~ ~T
c     This is the Q Q  part
c
      if (gsh_fld(ifldt).ge.0) then
         if (nio.eq.0.and.loglevel.gt.5)
     $   write(6,*) 'dssum', ifldt 
         call fgslib_gs_op(gsh_fld(ifldt),u,1,1,0)  ! 1 ==> +
      endif
c
c
c 
c     This is the J  part,  interpolating parent solution onto child
c
c      call apply_J(u,nx,ny,nz,nel)
c
c
#ifdef TIMER
      timee=(dnekclock()-etime1)
      tdsum=tdsum+timee
      ndsum=icalld
      tdsmx=max(timee,tdsmx)
      tdsmn=min(timee,tdsmn)
#endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine dsop(u,op,nx,ny,nz)
      include 'SIZE'
      include 'PARALLEL'
      include 'INPUT'
      include 'TSTEP'
      include  'CTIMER'

      real u(1)
      character*3 op
      character*10 s1,s2
c
c     o gs recognized operations:
c     
c             o "+" ==> addition.
c             o "*" ==> multiplication.
c             o "M" ==> maximum.
c             o "m" ==> minimum.
c             o "A" ==> (fabs(x)>fabs(y)) ? (x) : (y), ident=0.0.
c             o "a" ==> (fabs(x)<fabs(y)) ? (x) : (y), ident=MAX_DBL
c             o "e" ==> ((x)==0.0) ? (y) : (x),        ident=0.0.
c     
c             o note: a binary function pointer flavor exists.
c     
c     
c     o gs level:
c     
c             o level=0 ==> pure tree
c             o level>=num_nodes-1 ==> pure pairwise
c             o level = 1,...num_nodes-2 ==> mix tree/pairwise.
c      
c
      ifldt = ifield
c     if (ifldt.eq.0)       ifldt = 1
      if (ifldt.eq.ifldmhd) ifldt = 1

c     if (nio.eq.0) 
c    $   write(6,*) istep,' dsop: ',op,ifield,ifldt,gsh_fld(ifldt)

      if(ifsync) call nekgsync()

      if (op.eq.'+  ') call fgslib_gs_op(gsh_fld(ifldt),u,1,1,0)
      if (op.eq.'sum') call fgslib_gs_op(gsh_fld(ifldt),u,1,1,0)
      if (op.eq.'SUM') call fgslib_gs_op(gsh_fld(ifldt),u,1,1,0)

      if (op.eq.'*  ') call fgslib_gs_op(gsh_fld(ifldt),u,1,2,0)
      if (op.eq.'mul') call fgslib_gs_op(gsh_fld(ifldt),u,1,2,0)
      if (op.eq.'MUL') call fgslib_gs_op(gsh_fld(ifldt),u,1,2,0)

      if (op.eq.'m  ') call fgslib_gs_op(gsh_fld(ifldt),u,1,3,0)
      if (op.eq.'min') call fgslib_gs_op(gsh_fld(ifldt),u,1,3,0)
      if (op.eq.'mna') call fgslib_gs_op(gsh_fld(ifldt),u,1,3,0)
      if (op.eq.'MIN') call fgslib_gs_op(gsh_fld(ifldt),u,1,3,0)
      if (op.eq.'MNA') call fgslib_gs_op(gsh_fld(ifldt),u,1,3,0)

      if (op.eq.'M  ') call fgslib_gs_op(gsh_fld(ifldt),u,1,4,0)
      if (op.eq.'max') call fgslib_gs_op(gsh_fld(ifldt),u,1,4,0)
      if (op.eq.'mxa') call fgslib_gs_op(gsh_fld(ifldt),u,1,4,0)
      if (op.eq.'MAX') call fgslib_gs_op(gsh_fld(ifldt),u,1,4,0)
      if (op.eq.'MXA') call fgslib_gs_op(gsh_fld(ifldt),u,1,4,0)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine vec_dssum(u,v,w,nx,ny,nz)
c
c     Direct stiffness summation of the face data, for field U.
c
c     Boundary condition data corresponds to component IFIELD of 
c     the CBC array.
c
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      INCLUDE 'TSTEP'
      include 'CTIMER'

      REAL U(1),V(1),W(1)

      if(ifsync) call nekgsync()

#ifdef TIMER
      if (icalld.eq.0) tvdss=0.0d0
      if (icalld.eq.0) tgsum=0.0d0
      icalld=icalld+1
      nvdss=icalld
      etime1=dnekclock()
#endif

c
c============================================================================
c     execution phase
c============================================================================
c
      ifldt = ifield
c     if (ifldt.eq.0)       ifldt = 1
      if (ifldt.eq.ifldmhd) ifldt = 1

      call fgslib_gs_op_many(gsh_fld(ifldt),u,v,w,u,u,u,ldim,1,1,0)

#ifdef TIMER
      timee=(dnekclock()-etime1)
      tvdss=tvdss+timee
      tdsmx=max(timee,tdsmx)
      tdsmn=min(timee,tdsmn)
#endif

      return
      end

c-----------------------------------------------------------------------
      subroutine vec_dsop(u,v,w,nx,ny,nz,op)
c
c     Direct stiffness summation of the face data, for field U.
c
c     Boundary condition data corresponds to component IFIELD of 
c     the CBC array.
c
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
      INCLUDE 'INPUT'
      INCLUDE 'PARALLEL'
      INCLUDE 'TSTEP'
      include 'CTIMER'
c
      real u(1),v(1),w(1)
      character*3 op

c============================================================================
c     execution phase
c============================================================================

      ifldt = ifield
c     if (ifldt.eq.0)       ifldt = 1
      if (ifldt.eq.ifldmhd) ifldt = 1

c     write(6,*) 'opdsop: ',op,ifldt,ifield
      if(ifsync) call nekgsync()

      if (op.eq.'+  ' .or. op.eq.'sum' .or. op.eq.'SUM')
     $   call fgslib_gs_op_many(gsh_fld(ifldt),u,v,w,u,u,u,ldim,1,1,0)


      if (op.eq.'*  ' .or. op.eq.'mul' .or. op.eq.'MUL')
     $   call fgslib_gs_op_many(gsh_fld(ifldt),u,v,w,u,u,u,ldim,1,2,0)


      if (op.eq.'m  ' .or. op.eq.'min' .or. op.eq.'mna'
     $                .or. op.eq.'MIN' .or. op.eq.'MNA')
     $   call fgslib_gs_op_many(gsh_fld(ifldt),u,v,w,u,u,u,ldim,1,3,0)


      if (op.eq.'M  ' .or. op.eq.'max' .or. op.eq.'mxa'
     $                .or. op.eq.'MAX' .or. op.eq.'MXA')
     $   call fgslib_gs_op_many(gsh_fld(ifldt),u,v,w,u,u,u,ldim,1,4,0)


      return
      end
c-----------------------------------------------------------------------
      subroutine nvec_dssum(u,stride,n,gs_handle)

c     Direct stiffness summation of the array u for n fields
c
      include 'SIZE'
      include 'CTIMER'

      real u(1)
      integer n,stride,gs_handle

      if(ifsync) call nekgsync()

#ifdef TIMER
      icalld=icalld+1
      nvdss=icalld
      etime1=dnekclock()
#endif
      call fgslib_gs_op_fields(gs_handle,u,stride,n,1,1,0)

#ifdef TIMER
      timee=(dnekclock()-etime1)
      tvdss=tvdss+timee
      tdsmx=max(timee,tdsmx)
      tdsmn=min(timee,tdsmn)
#endif

      return
      end

c----------------------------------------------------------------------
      subroutine matvec3(uout,Jmat,uin,iftrsp,n1,n2)
c
      include 'SIZE'
c
      real Jmat (n1,n1,2)
      real uin   (1)
      real uout  (1)
      logical iftrsp
c
      common /matvtmp/ utmp(lx1,ly1)
c
      if (ldim.eq.2) then
         call mxm (Jmat(1,1,1),n1,uin,n1,uout,n2)
      else
         if (iftrsp) then
            call transpose(uout,n2,uin,n1)
         else
            call copy     (uout,uin,n1*n2)
         endif
         call mxm (Jmat(1,1,1),n1,uout,n1,utmp,n2)
         call mxm (utmp,n2,Jmat(1,1,2),n1,uout,n1)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine matvec3t(uout,Jmat,uin,iftrsp,n1,n2)
c
      include 'SIZE'
c
      real Jmat (n1,n1,2)
      real uin   (n1,n2)
      real uout  (n1,n2)
      logical iftrsp
c
      common /matvtmp/ utmp(lx1*ly1)
c
      call transpose(utmp,n2,uin,n1)
      call mxm (Jmat(1,1,2),n1,utmp,n1,uout,n2)
      call mxm (uout,n2,Jmat(1,1,1),n1,utmp,n1)
      if (iftrsp) then
         call copy     (uout,utmp,n1*n2)
      else
         call transpose(uout,n2,utmp,n1)
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine matvect (out,d,vec,n1,n2)
      dimension d(n1,n2),out(1),vec(1)
c
c   handle non-square matrix in mat-vec mult -- TRANSPOSE
c    N1 is still the number of rows
c    N2 is still the number of cols
c
c
      call mxm(vec,1,d,n1,out,n2)
c
      return
      end
c-----------------------------------------------------------------------
c      subroutine opq_in_place(a,b,c)
c      include 'SIZE'
c      real a(1),b(1),c(1)
c
c      call q_in_place(a)
c      call q_in_place(b)
c      if (ldim .eq.3) call q_in_place(c)
c
c      return
c      end
c-----------------------------------------------------------------------
      subroutine vectof_add(b,a,ie,iface,nx,ny,nz)
C
C     Copy vector A to the face (IFACE) of B
C     IFACE is the input in the pre-processor ordering scheme.
C
      DIMENSION A(NX,NY)
      DIMENSION B(NX,NY,NZ,1)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      k = 0
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
        k = k + 1
        B(IX,IY,IZ,IE) = B(IX,IY,IZ,IE) + A(k,1)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine zero_f(b,ie,iface,nx,ny,nz)
C
C     ZERO the face (IFACE) of B
C     IFACE is the input in the pre-processor ordering scheme.
C
      DIMENSION B(NX,NY,NZ,1)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
c
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
        B(IX,IY,IZ,IE) = 0.
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine ftovec_0(a,b,ie,iface,nx,ny,nz)
C
C     Copy the face (IFACE) of B to vector A.
C     IFACE is the input in the pre-processor ordering scheme.
C
      DIMENSION A(NX,NY)
      DIMENSION B(NX,NY,NZ,1)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      k = 0
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
        k = k + 1
        A(k,1)=B(IX,IY,IZ,IE)
        B(IX,IY,IZ,IE)=0.0
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine ftovec(a,b,ie,iface,nx,ny,nz)
C
C     Copy the face (IFACE) of B to vector A.
C     IFACE is the input in the pre-processor ordering scheme.
C
      real A(NX,NY)
      real B(NX,NY,NZ,1)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      k = 0
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
        k = k + 1
        A(k,1)=B(IX,IY,IZ,IE)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine vectof(b,a,ie,iface,nx,ny,nz)
C
C     Copy vector A to the face (IFACE) of B
C     IFACE is the input in the pre-processor ordering scheme.
C
      real A(NX,NY)
      real B(NX,NY,NZ,1)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      k = 0
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
        k = k + 1
        B(IX,IY,IZ,IE) = A(k,1)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine ftoveci(a,b,ie,iface,nx,ny,nz)
C
C     Copy the face (IFACE) of B to vector A.
C     IFACE is the input in the pre-processor ordering scheme.
C
      integer A(NX,NY)
      integer B(NX,NY,NZ,1)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      k = 0
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
        k = k + 1
        A(k,1)=B(IX,IY,IZ,IE)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine vectofi(b,a,ie,iface,nx,ny,nz)
C
C     Copy vector A to the face (IFACE) of B
C     IFACE is the input in the pre-processor ordering scheme.
C
      integer A(NX,NY)
      integer B(NX,NY,NZ,1)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      k = 0
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
        k = k + 1
        B(IX,IY,IZ,IE) = A(k,1)
  100 CONTINUE
      return
      END
c-----------------------------------------------------------------------
      subroutine apply_Jt(u,nx,ny,nz,nel)
      include 'SIZE'
      include 'CTIMER'
      include 'INPUT'
      include 'NONCON'
      include 'PARALLEL'
      include 'TSTEP'
      real u(1)
c
      parameter (lface=lx1*ly1)
      common /nonctmp/ uin(lface,2*ldim),uout(lface)
c
c 
c                  T
c     This is the J  part,  translating child data
c
      do ie = 1 , nel
c        Note, we zero out u() on this face after extracting, for
c        consistency reasons discovered during Jerry's thesis. 
c        Thus,  "ftovec_0" rather than ftovec().   (iface -- Ed notation)
         do iface = 1 , 2*ldim
            im = mortar(iface,ie)
            if (im.ne.0) then
               call ftovec_0(uin(1,iface),u,ie,iface,nx,ny,nz)
            endif
         enddo
         do iface=1,2*ldim
            im = mortar(iface,ie)
            if (im.ne.0) then
               if (if3d) then
                 call matvec3t
     $               (uout,Jmat(1,1,1,im),uin(1,iface),ifJt(im),nx,nx)
               else
                 call matvect (uout,Jmat(1,1,1,im),uin(1,iface),nx,nx)
               endif
               call vectof_add(u,uout,ie,iface,nx,ny,nz)
            endif
         enddo
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine apply_J(u,nx,ny,nz,nel)
      include 'SIZE'
      include 'CTIMER'
      include 'INPUT'
      include 'NONCON'
      include 'PARALLEL'
      include 'TSTEP'
      real u(1)
c
      parameter (lface=lx1*ly1)
      common /nonctmp/ uin(lface,2*ldim),uout(lface)
c
c     This is the J  part,  interpolating parent solution onto child
c
c
      do ie = 1 , nel
         do iface = 1 , 2*ldim
            im = mortar(iface,ie)
            if (im.ne.0) then
               call ftovec(uin(1,iface),u,ie,iface,nx,ny,nz)
            endif
         enddo
         do iface=1,2*ldim
            im = mortar(iface,ie)
            if (im.ne.0) then
               call matvec3
     $            (uout,Jmat(1,1,1,im),uin(1,iface),ifJt(im),nx,nz)
               call vectof (u,uout,ie,iface,nx,ny,nz)
            endif
         enddo
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine h1_proj(u,nx,ny,nz)
      include 'SIZE'
      include 'CTIMER'
      include 'INPUT'
      include 'NONCON'
      include 'PARALLEL'
      include 'TSTEP'
      real u(1)
c
      parameter (lface=lx1*ly1)
      common /nonctmp/ uin(lface,2*ldim),uout(lface)

      if(ifsync) call nekgsync()

#ifdef TIMER
      if (icalld.eq.0) then
         tdsmx=0.
         tdsmn=0.
      endif
      icalld=icalld+1
      etime1=dnekclock()
#endif
c
      ifldt = ifield
c     if (ifldt.eq.0) ifldt = 1
      nel = nelv
      if (ifield.ge.2) nel=nelt
      ntot = nx*ny*nz*nel


c
c
c                        ~  ~T  
c     Implement   :=   J Q  Q  Mu
c 
c 
c                  T
c
      call col2  (u,umult,ntot)
c
c                 ~ ~T
c     This is the Q Q  part
c
      call fgslib_gs_op(gsh_fld(ifldt),u,1,1,0) 
c
c 
c     This is the J  part,  interpolating parent solution onto child
c
      call apply_J(u,nx,ny,nz,nel)
c
c
#ifdef TIMER
      timee=(dnekclock()-etime1)
      tdsum=tdsum+timee
      ndsum=icalld
      tdsmx=max(timee,tdsmx)
      tdsmn=min(timee,tdsmn)
#endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine dssum_msk(u,mask,nx,ny,nz)
      include 'SIZE'
      include 'CTIMER'
      include 'INPUT'
      include 'NONCON'
      include 'PARALLEL'
      include 'TSTEP'
      real u(1),mask(1)
c
      parameter (lface=lx1*ly1)
      common /nonctmp/ uin(lface,2*ldim),uout(lface)

      if(ifsync) call nekgsync()

#ifdef TIMER
      if (icalld.eq.0) then
         tdsmx=0.
         tdsmn=0.
      endif
      icalld=icalld+1
      etime1=dnekclock()
#endif
c
      ifldt = ifield
c     if (ifldt.eq.0) ifldt = 1
      nel = nelv
      if (ifield.ge.2) nel=nelt
      ntot = nx*ny*nz*nel


c
c                    T           ~  ~T  T
c     Implement Q M Q   :=   J M Q  Q  J
c 
c 
c                  T
c     This is the J  part,  translating child data
c
      call apply_Jt(u,nx,ny,nz,nel)
c
c
c
c                 ~ ~T
c     This is the Q Q  part
c
      call fgslib_gs_op(gsh_fld(ifldt),u,1,1,0) 
      call col2  (u,mask,ntot)
c
c 
c     This is the J  part,  interpolating parent solution onto child
c
      call apply_J(u,nx,ny,nz,nel)
c
c
#ifdef TIMER
      timee=(dnekclock()-etime1)
      tdsum=tdsum+timee
      ndsum=icalld
      tdsmx=max(timee,tdsmx)
      tdsmn=min(timee,tdsmn)
#endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine dssum_msk2(u,mask,binv,nx,ny,nz)
      include 'SIZE'
      include 'CTIMER'
      include 'INPUT'
      include 'NONCON'
      include 'PARALLEL'
      include 'TSTEP'
      real u(1),mask(1),binv(1)
c
      parameter (lface=lx1*ly1)
      common /nonctmp/ uin(lface,2*ldim),uout(lface)

      if(ifsync) call nekgsync()

#ifdef TIMER
      if (icalld.eq.0) then
         tdsmx=0.
         tdsmn=0.
      endif
      icalld=icalld+1
      etime1=dnekclock()
#endif

c
      ifldt = ifield
c     if (ifldt.eq.0) ifldt = 1
      nel = nelv
      if (ifield.ge.2) nel=nelt
      ntot = nx*ny*nz*nel


c
c
c                    T           ~  ~T  T
c     Implement Q M Q   :=   J M Q  Q  J
c 
c 
c                  T
c     This is the J  part,  translating child data
c
      call apply_Jt(u,nx,ny,nz,nel)
c
c
c
c                 ~ ~T
c     This is the Q Q  part
c
      call fgslib_gs_op(gsh_fld(ifldt),u,1,1,0) 
      call col3  (u,mask,binv,ntot)
c
c 
c     This is the J  part,  interpolating parent solution onto child
c
      call apply_J(u,nx,ny,nz,nel)
c
c
#ifdef TIMER
      timee=(dnekclock()-etime1)
      tdsum=tdsum+timee
      ndsum=icalld
      tdsmx=max(timee,tdsmx)
      tdsmn=min(timee,tdsmn)
#endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine gtpp_gs_op(u,op,hndl)
c
c     gather-scatter operation across global tensor product planes
c
      include 'SIZE'
      include 'TOTAL'

      real u(*)
      character*3 op
      integer hndl

      if     (op.eq.'+  ' .or. op.eq.'sum' .or. op.eq.'SUM') then
         call fgslib_gs_op(hndl,u,1,1,0)
      elseif (op.eq.'*  ' .or. op.eq.'mul' .or. op.eq.'MUL') then
         call fgslib_gs_op(hndl,u,1,2,0)
      elseif (op.eq.'m  ' .or. op.eq.'min' .or. op.eq.'mna'
     &        .or. op.eq.'MIN' .or. op.eq.'MNA') then
         call fgslib_gs_op(hndl,u,1,3,0)
      elseif (op.eq.'M  ' .or. op.eq.'max' .or. op.eq.'mxa'
     &        .or. op.eq.'MAX' .or. op.eq.'MXA') then
         call fgslib_gs_op(hndl,u,1,4,0)
      else
         call exitti('gtpp_gs_op: invalid operation!$',1)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine gtpp_gs_setup(hndl,nelgx,nelgy,nelgz,idir)

      include 'SIZE'
      include 'TOTAL'

      integer hndl,nelgx,nelgy,nelgz,idir

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
      common /c_is1/ glo_num(lx1,ly1,lz1,lelv)
      integer e,ex,ey,ez,eg
      integer*8 glo_num,ex_g

      nelgxyz = nelgx*nelgy*nelgz
      if (nelgxyz .ne. nelgv)
     $ call exitti('gtpp_gs_setup: invalid gtp mesh dimensions!$',
     $             nelgxyz) 

      nel    = nelv 
      nelgxy = nelgx*nelgy
      nelgyz = nelgy*nelgz
      nelgzx = nelgz*nelgx

      if (idir.eq.1) then
         ! x-direction
         do e=1,nel
            eg = lglel(e)
            call get_exyz(ex,ey,ez,eg,nelgx,nelgyz,1)
            ex_g = ey
            do k=1,nz1 ! Enumerate points in the y-z plane
            do j=1,ny1
            do i=1,nx1
               glo_num(i,j,k,e) = j+ny1*(k-1) + ny1*nz1*(ex_g-1)
            enddo
            enddo
            enddo
         enddo
      elseif (idir.eq.2) then
         ! y-direction
         do e=1,nel
            eg = lglel(e)
            call get_exyz(ex,ey,ez,eg,nelgx,nelgy,nelgz)            
            ex_g = (ez-1)*nelgx+ex
            do k=1,nz1 ! Enumerate points in the x-z plane
            do j=1,ny1
            do i=1,nx1
               glo_num(i,j,k,e) = k+nz1*(i-1) + nx1*nz1*(ex_g-1) 
            enddo
            enddo
            enddo
         enddo
      elseif (idir.eq.3) then
         ! z-direction
         do e=1,nel
            eg = lglel(e)
            call get_exyz(ex,ey,ez,eg,nelgxy,1,1)
            ex_g = ex
            do k=1,nz1 ! Enumerate points in the x-y plane
            do j=1,ny1
            do i=1,nx1
               glo_num(i,j,k,e) = i+nx1*(j-1) + nx1*ny1*(ex_g-1)
            enddo
            enddo
            enddo
         enddo
      endif
 
      n = nel*nx1*ny1*nz1
      call fgslib_gs_setup(hndl,glo_num,n,nekcomm,np)

      return
      end
c-----------------------------------------------------------------------
      subroutine gs_setup_ms(hndl,nel,nx,ny,nz)

      include 'SIZE'
      include 'TOTAL'
      include 'mpif.h'

      integer hndl
      integer e,eg

      common /c_is1/ glo_num(lx1*ly1*lz1*lelt)
      integer*8 glo_num

      do e=1,nel
         eg = lglel(e)
         do k=1,nz      
         do j=1,ny
         do i=1,nx
            ii = i + nx*(j-1) + nx*ny*(k-1) + nx*ny*nz*(e-1)
            glo_num(ii) = i + nx*(j-1) + nx*ny*(k-1) + 
     $                    nx*ny*nz*(eg-1)
         enddo
         enddo
         enddo
      enddo

      n = nel*nx*ny*nz
      call fgslib_gs_setup(hndl,glo_num,n,iglobalcomm,np_global)

      return
      end
c-----------------------------------------------------------------------
      subroutine gs_op_ms(u,op,hndl)
c
c     gather-scatter operation across sessions 
c
      include 'SIZE'
      include 'PARALLEL'
      include 'INPUT'
      include 'TSTEP'
      include 'CTIMER'

      real u(*)
      character*3 op

      if(ifsync) call nekgsync()

      if      (op.eq.'+  ' .or. op.eq.'sum' .or. op.eq.'SUM') then
         call fgslib_gs_op(hndl,u,1,1,0)
      else if (op.eq.'*  ' .or. op.eq.'mul' .or. op.eq.'MUL') then
         call fgslib_gs_op(hndl,u,1,2,0)
      else if (op.eq.'m  ' .or. op.eq.'min' .or. op.eq.'mna' 
     &         .or. op.eq.'MIN' .or. op.eq.'MNA') then
         call fgslib_gs_op(hndl,u,1,3,0)
      else if (op.eq.'M  ' .or. op.eq.'max' .or. op.eq.'mxa'
     &         .or. op.eq.'MAX' .or. op.eq.'MXA') then
         call fgslib_gs_op(hndl,u,1,4,0)
      else
         call exitti('gs_op_ms: invalid operation!$',1)
      endif

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Taken from OpenMP Examples 5.0, example tasking.12.c
!x is a shared variable the outcome does not depend on whether or not the task is merged (that is,
!the task will always increment the same variable and will always compute the same value for x).


program DRB130_mergeable_taskwait_orig_no
    use omp_lib
    implicit none

    integer :: x
    x = 2

    !$omp task shared(x) mergeable
    x = x+1
    !$omp end task

    print 100, x
    100 format ('x =',3i8)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The -1 operation is not protected, causing race condition.
!Data race pair: numNodes2@59:13 vs. numNodes2@59:13

program DRB012_minusminus_var_yes
    use omp_lib
    implicit none

    integer :: i, len, numNodes, numNodes2, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    integer, dimension (:), allocatable :: x

    len = 100

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (x(len))

    numNodes=len
    numNodes2=0
    !initialize x()
    do i = 1, len
        if (MOD(i,2) == 0) then
            x(i) = 5
        else
            x(i) = -5
        end if
    end do

    !$omp parallel do
    do i = numNodes, 1, -1
        if (x(i) <= 0) then
            numNodes2 = numNodes2-1
        end if
    end do
    !$omp end parallel do

    print*,"numNodes2 =", numNodes2

    deallocate(args,x)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The outmost loop is parallelized.
!But the inner level loop has out of bound access for b[i][j] when i equals to 1.
!This will case memory access of a previous columns's last element.
!
!For example, an array of 4x4:
!    j=1 2 3 4
! i=1  x x x x
!   2  x x x x
!   3  x x x x
!   4  x x x x
!  inner loop: i=1,
!  outer loop: j=3
!  array element accessed b[i-1][j] becomes b[0][3], which in turn is b[4][2]
!  due to linearized column-major storage of the 2-D array.
!  This causes loop-carried data dependence between j=2 and j=3.
!
!Data race pair: b[i][j]@41 vs. b[i-1][j]@41.

program DRB014_outofbounds_orig_yes
    use omp_lib
    implicit none

    integer :: i, j, n, m
    real, dimension (:,:), allocatable :: b

    n = 100
    m = 100

    allocate (b(n,m))

    !$omp parallel do private(i)
    do j = 2, n
        do i = 1, m
            b(i,j) = b(i-1,j)
        end do
    end do
    !$omp end parallel do
    print*,"b(50,50)=",b(50,50)

    deallocate(b)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Only the outmost loop can be parallelized in this program.
!The inner loop has true dependence.
!Data race pair: b[i][j]@29:13 vs. b[i][j-1]@29:22


program DRB037_truedepseconddimension_orig_yes
    use omp_lib
    implicit none

    integer i, j, n, m, len
    real, dimension(:,:), allocatable :: b

    len = 1000
    n = len
    m = len

    allocate (b(len,len))

    do i = 1, n
        !$omp parallel do
        do j = 2, m
            b(i,j) = b(i,j-1)
        end do
        !$omp end parallel do
    end do

    print 100, b(500,500)
    100 format ('b(500,500) =', F20.6)

    deallocate(b)
end program

c-----------------------------------------------------------------------
      subroutine makeq

C     Generate forcing function for the solution of a passive scalar.
C     !! NOTE: Do not change the content of the array BQ until the current

      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'

      logical  if_conv_std
      common /SCRUZ/ w1(lx1,ly1,lz1,lelt)

      nxyz = lx1*ly1*lz1
      ntot = nxyz*nelv

      etime0 = dnekclock()      

      if (nio.eq.0.and.loglevel.gt.2)
     $   write(6,*) 'makeq', ifield

      if_conv_std = .true.
      if (ifmhd.and.ifaxis) if_conv_std = .false. ! conv. treated in induct.f

      call makeq_aux ! nekuq, etc.

      if (ifadvc(ifield) .and. if_conv_std) then

         if (ifcvfld(ifield)) then
            if (ifmvbd) then
               call sub2 (vx, wx, ntot)
               call sub2 (vy, wy, ntot)
               call sub2 (vz, wz, ntot)
             endif

             call convab

             if (ifmvbd) then
                call add2 (vx, wx, ntot)
                call add2 (vy, wy, ntot)
                call add2 (vz, wz, ntot)
             endif
         else
             if (.not.ifchar) call convab
         endif

      endif

      if (iftran) then

         if (ifcvfld(ifield)) then

           if (ifdiff(ifield)) then
              ntot = lx1*ly1*lz1*nelfld(ifield)
              call wlaplacian(w1,t(1,1,1,1,ifield-1),
     &                        vdiff(1,1,1,1,ifield),ifield)
              call add2(bq(1,1,1,1,ifield-1),w1,ntot)
           endif

         else

           if (ifmvbd.and..not.ifchar) call admesht

           call makeabq

           if (ifchar.and.ifadvc(ifield)) then
              call convch
           else
              call makebdq
           endif

         endif

      endif

      tmakq=tmakq+(dnekclock()-etime0)

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A single thread will spawn all the tasks. Add if(0) to avoid the data race, undeferring the tasks.
!Data Race Pairs, var@21:9 and var@21:15

program DRB123_taskundeferred_orig_yes
    use omp_lib
    implicit none

    integer :: var, i
    var = 0

    !$omp parallel sections
    do i = 1, 10
        !$omp task shared(var) 
        var = var+1;
        !$omp end task
    end do
    !$omp end parallel sections

    print 100, var
    100 format ('var =', 3i8)
end program

program omp_do
  use omp_lib
  implicit none
  integer :: i
  integer :: a(10)

  !$omp parallel do
    do i = 1, 10
      a(i) = i
      a(i) = a(i) + 1
    end do
  !$omp end parallel do
end program omp_do

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!There is no completion restraint on the second child task. Hence, immediately after the first
!taskwait it is unsafe to access the y variable since the second child task may still be
!executing.
!Data Race at y@34:8 and y@41:23

program DRB165_taskdep4_orig_yes_omp_50
    use omp_lib
    implicit none

    !$omp parallel
    !$omp single
    call foo()
    !$omp end single
    !$omp end parallel
contains
    subroutine foo()
        implicit none
        integer :: x, y
        x = 0
        y = 2

        !$omp task depend(inout: x) shared(x)
        x = x+1                                 !!1st Child Task
        !$omp end task

        !$omp task shared(y)
        y = y-1                                 !!2nd child task
        !$omp end task

        !$omp taskwait depend(in: x)            !!1st taskwait

        print*, "x=", x
        print*, "y=", y

        !$omp taskwait                          !!2nd taskwait
    end subroutine foo
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The outer loop has a loop-carried true dependence.
!Data race pair: b[i][j]@56:13 vs. b[i-1][j-1]@56:22

program DRB032_truedepfirstdimension_var_yes
    use omp_lib
    implicit none

    integer :: i, j, n, m, len, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    real, dimension(:,:), allocatable :: b

    len = 1000

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    n = len
    m = len
    allocate (b(n,m))

    do i = 1, n
        do j = 1, m
            b(i,j) = 0.5
        end do
    end do

    !$omp parallel do private(j)
    do i = 2, n
        do j = 2, m
            b(i,j) = b(i-1, j-1)
        end do
    end do
    !$omp end parallel do

    print 100, b(500,500)
    100 format ('b(500,500) =',F10.6)


    deallocate(args,b)
end program

!-----------------------------------------------------------------------
      subroutine lpm_io_read(filein1,npart)
      include 'SIZE'
      include 'SOLN'
      include 'INPUT'
      include 'MASS'
      include 'GEOM'
      include 'CTIMER'
      include 'TSTEP'
      include 'PARALLEL'
#     include "LPM"

      real*4  rout_pos(3      *LPM_LPART) 
     >       ,rout_sln(LPM_LRS*LPM_LPART)
     >       ,rout_lrp(LPM_LRP*LPM_LPART)
     >       ,rout_lip(3      *LPM_LPART)

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      real                  tcoef(3,3),dt_cmt,time_cmt
      common /timestepcoef/ tcoef,dt_cmt,time_cmt

      character*5 sprop1
      character*9 rprop1

      character (len = *)  filein1
      character*3 filein
      character*12 vtufile
      character*13 vtufile1
      character*50 dumstr
      character*1 dum_read

      integer icalld1
      save    icalld1
      data    icalld1 /0/

      logical partl         
      integer vtu,vtu1,prevs(2,np)
      integer*4 iint
      integer*8 idisp_pos,idisp_sln,idisp_lrp,idisp_lip,disp
      integer*8 stride_len
      real*4 rnptot

      icalld1 = icalld1+1

      LPM_RESTART = .true.

      nnp   = np
      nxx   = LPM_NPART
      npt_total = iglsum(nxx,1)

      jx    = 1
      jy    = 2
      jz    = 3

! --------------------------------------------------
! COPY PARTICLES TO OUTPUT ARRAY
! --------------------------------------------------

      iadd = 0
      if_pos = 3      *isize*npt_total
      if_sln = LPM_LRS*isize*npt_total
      if_lrp = LPM_LRP*isize*npt_total
      if_lip = 3      *isize*npt_total

      if (nid .eq. 0) then

      vtu=867+nid
      open(unit=vtu,file=filein1,access='stream',form="unformatted")

      ivtu_size = -1
      ifound = 0
      do i=1,1000000
      read(vtu) dum_read
      if (dum_read == '_') ifound = ifound + 1
      if (ifound .eq. 2) then
         ivtu_size = i
         exit
      endif
      enddo
      read(vtu) npt_total
      close(vtu)

      npt_total = npt_total/isize/3

      endif

      call bcast(npt_total,isize)

      idisp_pos = ivtu_size + isize*(1)
      idisp_sln = ivtu_size + isize*(3   *npt_total + 2)
      idisp_lrp = ivtu_size + isize*(3   *npt_total + LPM_LRS*npt_total 
     >                               + 3)
      idisp_lip = ivtu_size + isize*(3   *npt_total + LPM_LRS*npt_total 
     >                               + LPM_LRP*npt_total + 4)

      npmax = min(npt_total/LPM_LPART+1,mp)
      stride_len = 0
      if (nid .le. npmax-1 .and. nid. ne. 0) stride_len = nid*LPM_LPART

      npart = LPM_LPART
      if (nid .gt. npmax-1) npart = 0

      ndiff = npt_total - (npmax-1)*LPM_LPART
      if (nid .eq. npmax-1) npart = ndiff

      idisp_pos = idisp_pos + isize*3      *stride_len
      idisp_sln = idisp_sln + isize*LPM_LRS*stride_len
      idisp_lrp = idisp_lrp + isize*LPM_LRP*stride_len
      idisp_lip = idisp_lip + isize*3      *stride_len

      icount_pos = npart*3   
      icount_sln = npart*LPM_LRS
      icount_lrp = npart*LPM_LRP
      icount_lip = npart*3

      iorank = -1

      call byte_open_mpi(filein1,pth,.true.,ierr)


      call byte_set_view(idisp_pos,pth)
      call byte_read_mpi(rout_pos,icount_pos,iorank,pth,ierr)
      call byte_set_view(idisp_sln,pth)
      call byte_read_mpi(rout_sln,icount_sln,iorank,pth,ierr)
      call byte_set_view(idisp_lrp,pth)
      call byte_read_mpi(rout_lrp,icount_lrp,iorank,pth,ierr)
      call byte_set_view(idisp_lip,pth)
      call byte_read_mpi(rout_lip,icount_lip,iorank,pth,ierr)


      call byte_close_mpi(pth,ierr)

      ic_pos = 0
      ic_sln = 0
      ic_lrp = 0
      ic_lip = 0
      do i=1,npart

         ic_pos = ic_pos + 1
         lpm_y(jx,i) = rout_pos(ic_pos)
         ic_pos = ic_pos + 1
         lpm_y(jy,i) = rout_pos(ic_pos)
         if (if3d) then
            ic_pos = ic_pos + 1
            lpm_y(jz,i) = rout_pos(ic_pos)
         else
            ic_pos = ic_pos + 1
            lpm_y(jz,i) = 0.0
         endif

         do j=1,LPM_LRS
            ic_sln = ic_sln + 1
            lpm_y(j,i) = rout_sln(ic_sln)
         enddo

         do j=1,LPM_LRP
            ic_lrp = ic_lrp + 1
            lpm_rprop(j,i) = rout_lrp(ic_lrp)
         enddo

         ic_lip = ic_lip + 1
         lpm_iprop(5,i) = int(rout_lip(ic_lip))
         ic_lip = ic_lip + 1
         lpm_iprop(6,i) = int(rout_lip(ic_lip))
         ic_lip = ic_lip + 1
         lpm_iprop(7,i) = int(rout_lip(ic_lip))

      enddo
         
      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_io_write(filein1,iobig)
      include 'SIZE'
      include 'SOLN'
      include 'INPUT'
      include 'MASS'
      include 'GEOM'
      include 'CTIMER'
      include 'TSTEP'
      include 'PARALLEL'
#     include "LPM"

      real*4  rout_pos(3      *LPM_LPART) 
     >       ,rout_sln(LPM_LRS*LPM_LPART)
     >       ,rout_lrp(LPM_LRP*LPM_LPART)
     >       ,rout_lip(3      *LPM_LPART)

      real                  tcoef(3,3),dt_cmt,time_cmt
      common /timestepcoef/ tcoef,dt_cmt,time_cmt

      character*5 sprop1
      character*9 rprop1

      character filein1*(*)
      character*3 filein
      character*12 vtufile
      character*13 vtufile1
      character*50 dumstr

      integer icalld1
      save    icalld1
      data    icalld1 /0/

      logical partl         
      integer vtu,vtu1,prevs(2,np)
      integer*4 iint
      integer*8 idisp_pos,idisp_sln,idisp_lrp,idisp_lip
      integer*8 stride_len

      icalld1 = icalld1+1

      nnp   = np
      nxx   = LPM_NPART
      npt_total = iglsum(nxx,1)

      jx    = 1
      jy    = 2
      jz    = 3

      if_sz = len(filein1)
      if (if_sz .lt. 3) then
         filein = 'par'
      else 
         write(filein,'(A3)') filein1
      endif

! --------------------------------------------------
! COPY PARTICLES TO OUTPUT ARRAY
! --------------------------------------------------

      iadd = 0
      if_pos = 3      *isize*npt_total
      if_sln = LPM_LRS*isize*npt_total
      if_lrp = LPM_LRP*isize*npt_total
      if_lip = 3      *isize*npt_total

      ic_pos = iadd
      ic_sln = iadd
      ic_lrp = iadd
      ic_lip = iadd
      do i=1,nxx

         ic_pos = ic_pos + 1
         rout_pos(ic_pos) = lpm_y(jx,i)
         ic_pos = ic_pos + 1
         rout_pos(ic_pos) = lpm_y(jy,i)
         if (if3d) then
            ic_pos = ic_pos + 1
            rout_pos(ic_pos) = lpm_y(jz,i)
         else
            ic_pos = ic_pos + 1
            rout_pos(ic_pos) = 0.0
         endif

         do j=1,LPM_LRS
            ic_sln = ic_sln + 1
            rout_sln(ic_sln) = lpm_y(j,i)
         enddo

         do j=1,LPM_LRP
            ic_lrp = ic_lrp + 1
            rout_lrp(ic_lrp) = lpm_rprop(j,i)
         enddo

         ic_lip = ic_lip + 1
         rout_lip(ic_lip) = lpm_iprop(5,i)
         ic_lip = ic_lip + 1
         rout_lip(ic_lip) = lpm_iprop(6,i)
         ic_lip = ic_lip + 1
         rout_lip(ic_lip) = lpm_iprop(7,i)

      enddo

! --------------------------------------------------
! FIRST GET HOW MANY PARTICLES WERE BEFORE THIS RANK
! --------------------------------------------------
      do i=1,nnp
         prevs(1,i) = i-1
         prevs(2,i) = nxx
      enddo

      nps   = 1 ! index of new proc for doing stuff
      nglob = 1 ! unique key to sort by
      nkey  = 1 ! number of keys (just 1 here)
      ndum = 2
      call fgslib_crystal_ituple_transfer(i_cr_hndl,prevs,
     >                 ndum,nnp,nnp,nps)
      call fgslib_crystal_ituple_sort(i_cr_hndl,prevs,
     >                 ndum,nnp,nglob,nkey)

      stride_len = 0
      if (nid .ne. 0) then
      do i=1,nid
         stride_len = stride_len + prevs(2,i)
      enddo
      endif

! ----------------------------------------------------
! WRITE EACH INDIVIDUAL COMPONENT OF A BINARY VTU FILE
! ----------------------------------------------------
      write(vtufile,'(A3,I5.5,A4)') filein,icalld1,'.vtu'

      if (nid .eq. 0) then

      vtu=867+nid
      open(unit=vtu,file=vtufile,status='replace')

! ------------
! FRONT MATTER
! ------------
      write(vtu,'(A)',advance='no') '<VTKFile '
      write(vtu,'(A)',advance='no') 'type="UnstructuredGrid" '
      write(vtu,'(A)',advance='no') 'version="1.0" '
      if (iobig .eq. 0) then
         write(vtu,'(A)',advance='yes') 'byte_order="LittleEndian">'
      elseif (iobig .eq. 1) then
         write(vtu,'(A)',advance='yes') 'byte_order="BigEndian">'
      endif

      write(vtu,'(A)',advance='yes') ' <UnstructuredGrid>'

      write(vtu,'(A)',advance='yes') '  <FieldData>' 
      write(vtu,'(A)',advance='no')  '   <DataArray '  ! time
      write(vtu,'(A)',advance='no') 'type="Float32" '
      write(vtu,'(A)',advance='no') 'Name="TIME" '
      write(vtu,'(A)',advance='no') 'NumberOfTuples="1" '
      write(vtu,'(A)',advance='no') 'format="ascii"> '
      write(vtu,'(E14.7)',advance='no') time
      write(vtu,'(A)',advance='yes') ' </DataArray> '
      write(vtu,'(A)',advance='no') '   <DataArray '  ! cycle
      write(vtu,'(A)',advance='no') 'type="Int32" '
      write(vtu,'(A)',advance='no') 'Name="CYCLE" '
      write(vtu,'(A)',advance='no') 'NumberOfTuples="1" '
      write(vtu,'(A)',advance='no') 'format="ascii"> '
      write(vtu,'(I0)',advance='no') istep
      write(vtu,'(A)',advance='yes') ' </DataArray> '

      write(vtu,'(A)',advance='yes') '  </FieldData>'
      write(vtu,'(A)',advance='no') '  <Piece '
      write(vtu,'(A)',advance='no') 'NumberOfPoints="'
      write(vtu,'(I0)',advance='no') npt_total
      write(vtu,'(A)',advance='yes') '" NumberOfCells="0"> '

! -----------
! COORDINATES 
! -----------
      iint = 0
      write(vtu,'(A)',advance='yes') '   <Points>'
      call lpm_io_vtu_data(vtu,"Position",3   ,iint)
      iint = iint + 3   *isize*npt_total + isize
      write(vtu,'(A)',advance='yes') '   </Points>'

! ----
! DATA 
! ----
      write(vtu,'(A)',advance='yes') '   <PointData>'

      call lpm_io_vtu_data(vtu,'lpm-y',LPM_LRS,iint)
      iint = iint + LPM_LRS*isize*npt_total + isize

      call lpm_io_vtu_data(vtu,'lpm-rprop',LPM_LRP,iint)
      iint = iint + LPM_LRP*isize*npt_total + isize

      call lpm_io_vtu_data(vtu,'lpm-iprop',3,iint)
      iint = iint + 3*isize*npt_total + isize

      write(vtu,'(A)',advance='yes') '   </PointData> '

! ----------
! END MATTER
! ----------
      write(vtu,'(A)',advance='yes') '   <Cells> '
      write(vtu,'(A)',advance='no')  '    <DataArray '
      write(vtu,'(A)',advance='no') 'type="Int32" '
      write(vtu,'(A)',advance='no') 'Name="connectivity" '
      write(vtu,'(A)',advance='yes') 'format="ascii"/> '
      write(vtu,'(A)',advance='no') '    <DataArray '
      write(vtu,'(A)',advance='no') 'type="Int32" '
      write(vtu,'(A)',advance='no') 'Name="offsets" '
      write(vtu,'(A)',advance='yes') 'format="ascii"/> '
      write(vtu,'(A)',advance='no') '    <DataArray '
      write(vtu,'(A)',advance='no') 'type="Int32" '
      write(vtu,'(A)',advance='no') 'Name="types" '
      write(vtu,'(A)',advance='yes') 'format="ascii"/> '
      write(vtu,'(A)',advance='yes') '   </Cells> '
      write(vtu,'(A)',advance='yes') '  </Piece> '
      write(vtu,'(A)',advance='yes') ' </UnstructuredGrid> '

! -----------
! APPEND DATA  
! -----------
      write(vtu,'(A)',advance='no') ' <AppendedData encoding="raw">'
      close(vtu)

      open(unit=vtu,file=vtufile,access='stream',form="unformatted"
     >    ,position='append')
      write(vtu) '_'
      close(vtu)

      inquire(file=vtufile,size=ivtu_size)
      endif

      call bcast(ivtu_size, isize)

      ! byte-displacements
      idisp_pos = ivtu_size + isize*(3   *stride_len + 1)
      idisp_sln = ivtu_size + isize*(3   *npt_total + LPM_LRS*stride_len
     >                      + 2)
      idisp_lrp = ivtu_size + isize*(3   *npt_total  + LPM_LRS*npt_total
     >                      + LPM_LRP*stride_len + 3)
      idisp_lip = ivtu_size + isize*(3   *npt_total  + LPM_LRS*npt_total
     >                      + LPM_LRP*npt_total + 3*stride_len + 4 )

      ! how much to write
      icount_pos = 3      *nxx
      icount_sln = LPM_LRS*nxx
      icount_lrp = LPM_LRP*nxx
      icount_lip = 3      *nxx

      iorank = -1

      ! integer write
      if (nid .eq. 0) then
        open(unit=vtu,file=vtufile,access='stream',form="unformatted"
     >      ,position='append')
        write(vtu) if_pos
        close(vtu)
      endif

      rdum = dnekclock_sync()

      ! write
      call byte_open_mpi(vtufile,pth,.false.,ierr)
      call byte_set_view(idisp_pos,pth)
      call byte_write_mpi(rout_pos,icount_pos,iorank,pth,ierr)
      call byte_close_mpi(pth,ierr)

      rdum = dnekclock_sync()

      ! integer write
      if (nid .eq. 0) then
        open(unit=vtu,file=vtufile,access='stream',form="unformatted"
     >      ,position='append')
        write(vtu) if_sln
        close(vtu)
      endif

      rdum = dnekclock_sync()

      ! write
      call byte_open_mpi(vtufile,pth,.false.,ierr)
      call byte_set_view(idisp_sln,pth)
      call byte_write_mpi(rout_sln,icount_sln,iorank,pth,ierr)
      call byte_close_mpi(pth,ierr)

      ! integer write
      if (nid .eq. 0) then
        open(unit=vtu,file=vtufile,access='stream',form="unformatted"
     >      ,position='append')
        write(vtu) if_lrp
        close(vtu)
      endif

      rdum = dnekclock_sync()

      ! write
      call byte_open_mpi(vtufile,pth,.false.,ierr)
      call byte_set_view(idisp_lrp,pth)
      call byte_write_mpi(rout_lrp,icount_lrp,iorank,pth,ierr)
      call byte_close_mpi(pth,ierr)

      ! integer write
      if (nid .eq. 0) then
        open(unit=vtu,file=vtufile,access='stream',form="unformatted"
     >      ,position='append')
        write(vtu) if_lip
        close(vtu)
      endif

      ! write
      call byte_open_mpi(vtufile,pth,.false.,ierr)
      call byte_set_view(idisp_lip,pth)
      call byte_write_mpi(rout_lip,icount_lip,iorank,pth,ierr)
      call byte_close_mpi(pth,ierr)

      if (nid .eq. 0) then
      vtu=867+nid
      open(unit=vtu,file=vtufile,status='old',position='append')

      write(vtu,'(A)',advance='yes') '</AppendedData>'
      write(vtu,'(A)',advance='yes') '</VTKFile>'

      close(vtu)
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_io_vtu_data(vtu,dataname,ncomp,idist)

      integer vtu,ncomp
      integer*4 idist
      character (len = *) dataname
      character*50 dumstr

      write(vtu,'(A)',advance='no') '    <DataArray '
      write(vtu,'(A)',advance='no') 'type="Float32" '
      write(vtu,'(A)',advance='no') 'Name="'
      write(vtu,'(A)',advance='no') dataname
      write(vtu,'(A)',advance='no') '" NumberOfComponents="'
      write(vtu,'(I0)',advance='no') ncomp
      write(vtu,'(A)',advance='no') '" format="append" '
      write(vtu,'(A)',advance='no') 'offset="'
      write(vtu,'(I0)',advance='no') idist
      write(vtu,'(A)',advance='yes') '"/>'

      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_io_read_restart(filename)
      include 'SIZE'
      include 'SOLN'
      include 'INPUT'
      include 'MASS'
      include 'GEOM'
      include 'TSTEP'
      include 'PARALLEL'
#     include "LPM"

      PARAMETER(LPM_LRF=3+LPM_LRP+LPM_LRS)
      COMMON /LPM_RFPTS_C/ LPM_RFPTS
      REAL*4 LPM_RFPTS(LPM_LRF,LPM_LPART)

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      character*12 filename

      logical partl         ! This is a dummy placeholder, used in cr()

      integer vtu,vtu1,prevs(2,mp)
      integer*4 iint
      integer*8 stride_len

      integer*8 disp
      integer*4 nptot
      integer pth, nread
      real*4 rnptot

! ------------------------------
! LOAD TOTAL NUMBER OF PARTICLES
! ------------------------------
      pth = 185

      write(6,*) filename

      disp = 0
      icount = 0
      if (nid .eq. 0) icount = 1
      iorank = -1
      call byte_open_mpi(trim(filename),pth,.true.,ierr)
      call byte_set_view(disp,pth)
      call byte_read_mpi(rnptot,icount,iorank,pth,ierr)
      call byte_close_mpi(pth,ierr)

      nptot = int(rnptot)
      call bcast(nptot, isize)

! --------------------------------------------------
! FIRST GET HOW MANY PARTICLES WERE BEFORE THIS RANK
! --------------------------------------------------
      npmax = min(nptot/LPM_LPART+1,mp)
      stride_len = 0
      if (nid .le. npmax-1 .and. nid. ne. 0) stride_len = nid*LPM_LPART

      nread = LPM_LPART
      if (nid .gt. npmax-1) nread = 0

      ndiff = nptot - (npmax-1)*LPM_LPART
      if (nid .eq. npmax-1) nread = ndiff

! -------------------------
! Parallel MPI file read in
! -------------------------
      disp   = isize + stride_len*LPM_LRF*isize ! is there real*4 var?
      icount = nread*LPM_LRF
      iorank = -1
      call byte_open_mpi(filename,pth,.true.,ierr)
      call byte_set_view(disp,pth)
      call byte_read_mpi(lpm_rfpts,icount,iorank,pth,ierr)
      call byte_close_mpi(pth,ierr)

! ----------------------------------------
! Assign values read in to rpart and ipart
! ----------------------------------------
      i = lpm_npart
      do ii = 1,nread
         i = lpm_npart + ii

         ic = 1
         lpm_iprop(5,i) = int(lpm_rfpts(ic,ii))
         ic = ic + 1
         lpm_iprop(6,i) = int(lpm_rfpts(ic,ii))
         ic = ic + 1
         lpm_iprop(7,i) = int(lpm_rfpts(ic,ii))

         do j=1,LPM_LRS
            ic = ic + 1
            lpm_y(j,i) = lpm_rfpts(ic,ii)
         enddo
         do j=1,LPM_LRP
            ic = ic + 1
            lpm_rprop(j,i) = lpm_rfpts(ic,ii)
         enddo
      enddo
      lpm_npart = i

      call lpm_comm_findpts
      call lpm_comm_crystal

      return
      end
c----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!use of omp target: len is not mapped. It should be firstprivate within target. No data race pairs.

program DRB071_targetparallelfor_orig_no
    use omp_lib
    implicit none

    integer :: i, len
    integer, dimension(:), allocatable :: a

    allocate(a(len))

    do i = 1, len
        a(i) = i
    end do

    !$omp target map(a(1:len))
    !$omp parallel do
    do i = 1, len
        a(i) = a(i)+1
    end do
    !$omp end target

    deallocate(a)
end program

      PROGRAM TEST
      INTEGER N
      PARAMETER (N=10)
      REAL ARRAY(N) !The index of ARRAY should from 1 to 10.
      ARRAY(N+1) = 1.0 !It uses an index out of the bound.
      END
      

      

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!tmp should be annotated as private to avoid race condition.
!Data race pairs: tmp@28 vs. tmp@29
!                 tmp@28 vs. tmp@28

program DRB028_privatemissing_orig_yes
    use omp_lib
    implicit none

    integer :: i, tmp, len
    integer, dimension(:), allocatable :: a

    len = 100
    allocate (a(len))

    do i = 1, len
        a(i) = i
    end do

    !$omp parallel do
    do i = 1, len
        tmp = a(i) + i
        a(i) = tmp
    end do
    !$omp end parallel do

    print 100, a(50)
    100 format ('a(50)=',i3)

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This example is derived from an example by Simone Atzeni, NVIDIA.
!
!Description: Race on variable init if used master construct. The variable is written by the
!master thread and concurrently read by the others.
!
!Solution: master construct does not have an implicit barrier better
!use single at line 26. Fixed version for DRB124-master-orig-yes.c. No data race.


program DRB125_single_orig_no
    use omp_lib
    implicit none

    integer :: init, local

    !$omp parallel shared(init) private(local)
        !$omp single
        init = 10
        !$omp end single
        local = init
    !$omp end parallel
end program

c===============================================================================
c     pff@cfm.brown.edu   3/19/96
c
c
c     This  is a suite of routines for solving overlapping subdomain
c     problems with finite elements on distributed memory machines.
c
c     The overall hierarchy of data structures is as follows:
c
c         System        -  index set denoted by       _glob
c
c            Processor  -  index set denoted by       _pglob
c
c              .Domain  -  index set denoted by       _dloc  (1,2,3,...,n_dloc)
c
c              .Sp.Elem -  index set denoted by       _sloc  (1,2,3,...,n_sloc)
c
c
c     A critical component of the parallel DD solver is the gather-scatter
c     operation.   As there may be more than one domain on a processor, and
c     communication must be minimized, it is critical that communication be
c     processor oriented, not domain oriented.  Hence domains will access data
c     via the dloc_to_pglob interface, and the pglob indexed variables will
c     be accessed via a gather-scatter which interacts via the pglob_glob
c     interface.   Noticed that, in a uni-processor application, the pglob_glob
c     map will be simply the identity.
c
c===============================================================================
c
      subroutine set_overlap
c
c     Set up arrays for overlapping Schwartz algorithm *for pressure solver*
c
      include 'SIZE'
      include 'DOMAIN'
      include 'ESOLV'
      include 'INPUT'
      include 'TSTEP'
c
      REAL*8 dnekclock,t0
c
      parameter (          n_tri = 7*ltotd )
      common /scrns/  tri (n_tri)
      integer         tri,elem
c
      common /screv/ x(2*ltotd)
      common /scrvh/ y(2*ltotd)
      common /scrch/ z(2*ltotd)
c
      common /ctmp0/ nv_to_t(2*ltotd)
c
      parameter (lia = ltotd - 2 - 2*lelt)
      common /scrcg/ ntri(lelt+1),nmask(lelt+1)
     $             , ia(lia)
c
      common /scruz/ color   (4*ltotd)
      common /scrmg/ ddmask  (4*ltotd)
      common /ctmp1/ mask    (4*ltotd)

      parameter(lxx=lx1*lx1, levb=lelv+lbelv)
      common /fastd/  df(lx1*ly1*lz1,levb)
     $             ,  sr(lxx*2,levb),ss(lxx*2,levb),st(lxx*2,levb)


      integer e

      if (lx1.eq.2) param(43)=1.
      if (lx1.eq.2.and.nid.eq.0) write(6,*) 'No mgrid for lx1=2!'

      if (ifaxis) ifmgrid = .false.
      if (param(43).ne.0) ifmgrid = .false.

      npass = 1
      if (ifmhd) npass = 2
      do ipass=1,npass
         ifield = 1

         if (ifsplit.and.ifmgrid) then

            if (ipass.gt.1) ifield = ifldmhd

            call swap_lengths
            call gen_fast_spacing(x,y,z)
 
            call hsmg_setup
            call h1mg_setup

         elseif (.not.ifsplit) then ! Pn-Pn-2

            if (ipass.gt.1) ifield = ifldmhd

            if (param(44).eq.1) then !  Set up local overlapping solves 
               call set_fem_data_l2(nel_proc,ndom,n_o,x,y,z,tri)
            else
               call swap_lengths
            endif
 
            e = 1
            if (ifield.gt.1) e = nelv+1

            call gen_fast_spacing(x,y,z)
            call gen_fast(df(1,e),sr(1,e),ss(1,e),st(1,e),x,y,z)

            call init_weight_op
            if (param(43).eq.0) call hsmg_setup
         endif

         call set_up_h1_crs

      enddo
 
      return
      end
c-----------------------------------------------------------------------
      subroutine overflow_ck(n_req,n_avail,signal)
c
c     Check for buffer overflow
c
      character*11 signal
c
      nid = mynode()
c
      if (n_req.gt.n_avail) then
         write(6,9) nid,n_req,n_avail,nid,signal
    9    format(i7,' ERROR: requested array space (',i12
     $            ,') exceeds allocated amount (',i12,').'
     $            ,/,i12,' ABORTING.',3x,a11
     $            ,/,i12,' ABORTING.',3x,'from overflow_ck call.')
         call exitt
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine iunswap(b,ind,n,temp)
      integer b(1),ind(1),temp(1)
c
c     sort associated elements by putting item(jj)
c     into item(i), where jj=ind(i).
c
      do 20 i=1,n
         jj=ind(i)
         temp(jj)=b(i)
   20 continue
      do 30 i=1,n
   30 b(i)=temp(i)
      return
      end
c-----------------------------------------------------------------------
      subroutine set_fem_data_l2(nep,nd,no,x,y,z,p)
      include 'SIZE'
      include 'DOMAIN'
      include 'NONCON'
      include 'TOTAL'
c
      real x(lx1,ly1,lz1,1),y(lx1,ly1,lz1,1),z(lx1,ly1,lz1,1)
      real p(lx1,ly1,lz1,1)
      integer ce,cf
c
      common /ctmp0/ w1(lx1,ly1),w2(lx1,ly1)
c
c     First, copy local geometry to temporary, expanded, arrays
c
      nxy1  = lx1*ly1
      nxy2  = lx2*ly2
      nxyz1 = lx1*ly1*lz1
      nxyz2 = lx2*ly2*lz2
      ntot1 = nelv*nxyz1
      ntot2 = nelv*nxyz2
c
      call rzero(x,ntot1)
      call rzero(y,ntot1)
      call rzero(z,ntot1)
c
c     Take care of surface geometry
c
      call map_face12(x,xm1,w1,w2)
      call map_face12(y,ym1,w1,w2)
      call map_face12(z,zm1,w1,w2)
c
c     Take care of interior geometry
c
      iz1 = 0
      if (if3d) iz1=1
      do ie=1,nelv
         do iz=1,lz2
         do iy=1,ly2
         do ix=1,lx2
            x(ix+1,iy+1,iz+iz1,ie) = xm2(ix,iy,iz,ie)
            y(ix+1,iy+1,iz+iz1,ie) = ym2(ix,iy,iz,ie)
            z(ix+1,iy+1,iz+iz1,ie) = zm2(ix,iy,iz,ie)
         enddo
         enddo
         enddo
      enddo
c
c
c     Compute absolute value of distance between pressure and vel. planes
c
      call dface_add1sa(x)
      call dface_add1sa(y)
      call dface_add1sa(z)
c
c     Sum this distance
c
      ifielt = ifield
      ifield = 1
c     call dssum(x,lx1,ly1,lz1)
c     call dssum(y,lx1,ly1,lz1)
c     call dssum(z,lx1,ly1,lz1)
c
c     Scale children values by 0.5.  This is a hack, based on assumption
c     that number of children sharing a parent edge is 2
c
      scale = 0.5
      if (if3d) scale = 0.25
      do im   = 1 , mort_m
         cf = noncon_f(im)
         ce = noncon_e(im)
         call faces(x,scale,ce,cf,lx1,ly1,lz1)
         call faces(y,scale,ce,cf,lx1,ly1,lz1)
         if (if3d) call faces(z,scale,ce,cf,lx1,ly1,lz1)
      enddo
      call fgslib_gs_op_many(gsh_fld(ifield), x,y,z,x,x,x,ldim, 1,1,0)
c
      ifield = ifielt
c
c     Dirichlet (pmask=0) faces  all set...
c
      nel_proc = nelv
      ndom     = nelv
c     ndom     = 1
c
      n_o =  1
c
c     These are the return values, since the calling routine doesn't
c     know DOMAIN
c
      nep     = nel_proc
      nd      = ndom
      no      = n_o
      ifield  = ifielt
      return
      end
c-----------------------------------------------------------------------
      subroutine map_face12(x2,x1,w1,w2)
      include 'SIZE'
      include 'INPUT'
      include 'IXYZ'
c
c     Interpolate iface of x1 (GLL pts) onto x2 (GL pts).
c     Work arrays should be of size lx1*lx1 each.
c
      real x2(lx1*ly1*lz1,1)
      real x1(lx1*ly1*lz1,1)
      real w1(1),w2(1)
c
c
      do ie=1,nelv
       if (if3d) then
        call map_one_face12(x2(1,ie),x1(1,ie),1,ixm12,ixtm12,w1,w2)
        call map_one_face12(x2(1,ie),x1(1,ie),2,ixm12,ixtm12,w1,w2)
        call map_one_face12(x2(1,ie),x1(1,ie),3,ixm12,ixtm12,w1,w2)
        call map_one_face12(x2(1,ie),x1(1,ie),4,ixm12,ixtm12,w1,w2)
        call map_one_face12(x2(1,ie),x1(1,ie),5,ixm12,ixtm12,w1,w2)
        call map_one_face12(x2(1,ie),x1(1,ie),6,ixm12,ixtm12,w1,w2)
       else
        call map_one_face12(x2(1,ie),x1(1,ie),1,ixm12,ixtm12,w1,w2)
        call map_one_face12(x2(1,ie),x1(1,ie),2,ixm12,ixtm12,w1,w2)
        call map_one_face12(x2(1,ie),x1(1,ie),3,ixm12,ixtm12,w1,w2)
        call map_one_face12(x2(1,ie),x1(1,ie),4,ixm12,ixtm12,w1,w2)
       endif
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine map_one_face12(x2,x1,iface,i12,i12t,w1,w2)
      include 'SIZE'
      include 'INPUT'
c
c     Interpolate iface of x1 (GLL pts) onto interior of face of x2 (GL pts).
c     Work arrays should be of size lx1*lx1 each.
c
      real x2(lx1,ly1,lz1)
      real x1(lx1,ly1,lz1)
      real w1(1),w2(1)
      real i12(1),i12t(1)
c
c
c     Extract surface data from x1
c
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,lx1,ly1,lz1,IFACE)
      i=0
      do iz=kz1,kz2
      do iy=ky1,ky2
      do ix=kx1,kx2
         i     = i+1
         w1(i) = x1(ix,iy,iz)
      enddo
      enddo
      enddo
c
c     Interpolate from mesh 1 to 2
c
      if (if3d) then
         call mxm(i12 ,lx2,w1,lx1,w2,lx1)
         call mxm(w2,lx2,i12t,lx1,w1,lx2)
      else
         call mxm(i12 ,lx2,w1,lx1,w2,  1)
         call copy(w1,w2,lx2)
      endif
c
c     Write to interior points on face of x2
c
      kx1=min(kx1+1,lx1,kx2)
      kx2=max(kx2-1,  1,kx1)
      ky1=min(ky1+1,ly1,ky2)
      ky2=max(ky2-1,  1,ky1)
      kz1=min(kz1+1,lz1,kz2)
      kz2=max(kz2-1,  1,kz1)
c
      i=0
      do iz=kz1,kz2
      do iy=ky1,ky2
      do ix=kx1,kx2
         i     = i+1
         x2(ix,iy,iz) = w1(i)
      enddo
      enddo
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine dface_add1sa(x)
c     Compute |face-interior|
c
      include 'SIZE'
      include 'INPUT'
      real x(lx1,ly1,lz1,1)
c
      do ie=1,nelv
c
        if (if3d) then
c
          do iz=2,lz1-1
          do ix=2,lx1-1
            x(ix,1  ,iz,ie)=abs(x(ix,1  ,iz,ie) - x(ix,2    ,iz,ie))
            x(ix,ly1,iz,ie)=abs(x(ix,ly1,iz,ie) - x(ix,ly1-1,iz,ie))
          enddo
          enddo
c
          do iz=2,lz1-1
          do iy=2,ly1-1
            x(1  ,iy,iz,ie)=abs(x(1  ,iy,iz,ie) - x(2    ,iy,iz,ie))
            x(lx1,iy,iz,ie)=abs(x(lx1,iy,iz,ie) - x(lx1-1,iy,iz,ie))
          enddo
          enddo
c
          do iy=2,ly1-1
          do ix=2,lx1-1
            x(ix,iy,1  ,ie)=abs(x(ix,iy,1  ,ie) - x(ix,iy,2    ,ie))
            x(ix,iy,lz1,ie)=abs(x(ix,iy,lz1,ie) - x(ix,iy,lz1-1,ie))
          enddo
          enddo
c
        else
c
c         2D
c
          do ix=2,lx1-1
            x(ix,1  ,1,ie)=abs(x(ix,1  ,1,ie) - x(ix,2    ,1,ie))
            x(ix,ly1,1,ie)=abs(x(ix,ly1,1,ie) - x(ix,ly1-1,1,ie))
          enddo
          do iy=2,ly1-1
            x(1  ,iy,1,ie)=abs(x(1  ,iy,1,ie) - x(2    ,iy,1,ie))
            x(lx1,iy,1,ie)=abs(x(lx1,iy,1,ie) - x(lx1-1,iy,1,ie))
          enddo
c
        endif
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine faces(a,s,ie,iface,nx,ny,nz)
C
C     Scale face(IFACE,IE) of array A by s.
C     IFACE is the input in the pre-processor ordering scheme.
C
      INCLUDE 'SIZE'
      DIMENSION A(NX,NY,NZ,LELT)
      CALL FACIND (KX1,KX2,KY1,KY2,KZ1,KZ2,NX,NY,NZ,IFACE)
      DO 100 IZ=KZ1,KZ2
      DO 100 IY=KY1,KY2
      DO 100 IX=KX1,KX2
         A(IX,IY,IZ,IE)=S*A(IX,IY,IZ,IE)
  100 CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!threadprivate+copyprivate: no data races

module DRB102
    implicit none
    integer y
    integer, parameter :: dp = kind(1.0d0)
    real(dp) :: x
    !$omp threadprivate(x,y)
end module

program DRB102_copyprivate_orig_no
    use omp_lib
    use DRB102
    implicit none

    !$omp parallel
        !$omp single
        x=1.0
        y=1
        !$omp end single copyprivate(x,y)
    !$omp end parallel

    print 100, x, y
    100 format ('x =',F3.1,2x,'y =',i3)

end program

c-----------------------------------------------------------------------
      subroutine arcsrf(xml,yml,zml,nxl,nyl,nzl,ie,isid)
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'TOPOL'
      include 'WZ'
C
C     ....note..... CTMP1 is used in this format in several subsequent routines
C
      COMMON /CTMP1/ H(LX1,3,2),XCRVED(LX1),YCRVED(LY1),ZCRVED(LZ1)
     $             , ZGML(LX1,3),WORK(3,LX1,LZ1)
      DIMENSION XML(NXL,NYL,NZL,1),YML(NXL,NYL,NZL,1),ZML(NXL,NYL,NZL,1)
      LOGICAL IFGLJ
C
      IFGLJ = .FALSE.
      IF (IFAXIS .AND. IFRZER(IE) .AND. (ISID.EQ.2 .OR. ISID.EQ.4)) 
     $IFGLJ = .TRUE.
C
      PT1X  = XC(ISID,IE)
      PT1Y  = YC(ISID,IE)
      IF(ISID.EQ.4) THEN
         PT2X = XC(1,IE)
         PT2Y = YC(1,IE)
      ELSE IF(ISID.EQ.8) THEN
         PT2X = XC(5,IE)
         PT2Y = YC(5,IE)
      ELSE
         PT2X = XC(ISID+1,IE)
         PT2Y = YC(ISID+1,IE)
      ENDIF
C
C     Find slope of perpendicular
      RADIUS=CURVE(1,ISID,IE)
      GAP=SQRT( (PT1X-PT2X)**2 + (PT1Y-PT2Y)**2 )
      IF (ABS(2.0*RADIUS).LE.GAP*1.00001) THEN
         write(6,10) RADIUS,ISID,IE,GAP
   10    FORMAT(//,2X,'ERROR: Too small a radius (',G11.3
     $  ,') specified for side',I2,' of element',I4,':  '
     $  ,G11.3,/,2X,'ABORTING during mesh generation.')
         call exitt
      ENDIF
      XS = PT2Y-PT1Y
      YS = PT1X-PT2X
C     Make length Radius
      XYS=SQRT(XS**2+YS**2)
C     Find Center
      DTHETA = ABS(ASIN(0.5*GAP/RADIUS))
      PT12X  = (PT1X + PT2X)/2.0
      PT12Y  = (PT1Y + PT2Y)/2.0
      XCENN  = PT12X - XS/XYS * RADIUS*COS(DTHETA)
      YCENN  = PT12Y - YS/XYS * RADIUS*COS(DTHETA)
      THETA0 = ATAN2((PT12Y-YCENN),(PT12X-XCENN))
      IF (IFGLJ) THEN
         FAC    = SIGN(1.0,RADIUS)
         THETA1 = THETA0 - FAC*DTHETA
         THETA2 = THETA0 + FAC*DTHETA
      ENDIF
C     Compute perturbation of geometry
      ISID1 = MOD1(ISID,4)
      IF (IFGLJ) THEN
         I1 = ISID/2
         I2 = 2 - ISID/4
         DO 15 IY=1,NYL
           ANG  = H(IY,2,I1)*THETA1 + H(IY,2,I2)*THETA2
           XCRVED(IY)=XCENN + ABS(RADIUS)*COS(ANG)
     $                      - (H(IY,2,I1)*PT1X + H(IY,2,I2)*PT2X)
           YCRVED(IY)=YCENN + ABS(RADIUS) * SIN(ANG)
     $                      - (H(IY,2,I1)*PT1Y + H(IY,2,I2)*PT2Y)
   15    CONTINUE
      ELSE
         DO 20 IX=1,NXL
            IXT=IX
            IF (ISID1.GT.2) IXT=NXL+1-IX
            R=ZGML(IX,1)
            IF (RADIUS.LT.0.0) R=-R
            XCRVED(IXT) = XCENN + ABS(RADIUS) * COS(THETA0 + R*DTHETA)
     $                          - ( H(IX,1,1)*PT1X + H(IX,1,2)*PT2X )
            YCRVED(IXT) = YCENN + ABS(RADIUS) * SIN(THETA0 + R*DTHETA)
     $                          - ( H(IX,1,1)*PT1Y + H(IX,1,2)*PT2Y )
   20    CONTINUE
      ENDIF
C     Points all set, add perturbation to current mesh.
      ISID1 = MOD1(ISID,4)
      ISID1 = EFACE1(ISID1)
      IZT = (ISID-1)/4+1
      IYT = ISID1-2
      IXT = ISID1
      IF (ISID1.LE.2) THEN
         CALL ADDTNSR(XML(1,1,1,IE),H(1,1,IXT),XCRVED,H(1,3,IZT)
     $               ,NXL,NYL,NZL)
         CALL ADDTNSR(YML(1,1,1,IE),H(1,1,IXT),YCRVED,H(1,3,IZT)
     $               ,NXL,NYL,NZL)
      ELSE
         CALL ADDTNSR(XML(1,1,1,IE),XCRVED,H(1,2,IYT),H(1,3,IZT)
     $               ,NXL,NYL,NZL)
         CALL ADDTNSR(YML(1,1,1,IE),YCRVED,H(1,2,IYT),H(1,3,IZT)
     $               ,NXL,NYL,NZL)
      ENDIF
      return
      end
c-----------------------------------------------------------------------
      subroutine defsrf(xml,yml,zml,nxl,nyl,nzl,ie,iface1,ccv)
      include 'SIZE'
      include 'TOPOL'
      include 'GEOM'
      include 'WZ'
      COMMON /CTMP1/ H(LX1,3,2),XCRVED(LX1),YCRVED(LY1),ZCRVED(LZ1)
     $             , ZGML(LX1,3),WORK(3,LX1,LZ1)
C
      DIMENSION XML(NXL,NYL,NZL,1),YML(NXL,NYL,NZL,1),ZML(NXL,NYL,NZL,1)
      DIMENSION X1(3),X2(3),X3(3),DX(3)
      DIMENSION IOPP(3),NXX(3)
      CHARACTER*1 CCV
C
      CALL DSSET(NXL,NYL,NZL)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      IOPP(1) = NXL-1
      IOPP(2) = NXL*(NYL-1)
      IOPP(3) = NXL*NYL*(NZL-1)
      NXX(1)  = NXL
      NXX(2)  = NYL
      NXX(3)  = NZL
      IDIR    = 2*MOD(IFACE,2) - 1
      IFC2    = (IFACE+1)/2
      DELT    = 0.0
C      DELT    = SIDE(4,IFACE,IE)
C
C     Compute surface deflection and perturbation due to face IFACE
C
      DO 200 J2=JS2,JF2,JSKIP2
      DO 200 J1=JS1,JF1,JSKIP1
         JOPP = J1 + IOPP(IFC2)*IDIR
         X2(1) = XML(J1,J2,1,IE)
         X2(2) = YML(J1,J2,1,IE)
         X2(3) = ZML(J1,J2,1,IE)
         X1(1) = XML(JOPP,J2,1,IE)
         X1(2) = YML(JOPP,J2,1,IE)
         X1(3) = ZML(JOPP,J2,1,IE)
         CALL INTRSC(X3,X2,X1,DELT,IE,IFACE1)
C
         DX(1) = X3(1)-X2(1)
         DX(2) = X3(2)-X2(2)
         DX(3) = X3(3)-X2(3)
C
         NXS = NXX(IFC2)
         JOFF = (J1-JOPP)/(NXS-1)
         DO 100 IX = 2,NXS
            J = JOPP + JOFF*(IX-1)
            ZETA = 0.5*(ZGML(IX,IFC2) + 1.0)
            XML(J,J2,1,IE) = XML(J,J2,1,IE)+DX(1)*ZETA
            YML(J,J2,1,IE) = YML(J,J2,1,IE)+DX(2)*ZETA
            ZML(J,J2,1,IE) = ZML(J,J2,1,IE)+DX(3)*ZETA
  100    CONTINUE
  200 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine intrsc(x3,x2,x1,delt,ie,iface)
C
      DIMENSION X1(3),X2(3),X3(3)
      COMMON /SRFCEI/ IEL,IFCE
      COMMON /SRFCER/ X0(3),DX(3)
      COMMON /SRFCEL/ SUCCES
      LOGICAL SUCCES
      COMMON /TOLRNC/ TOL
C
C     Load parameters for surface function FNC
C
      IEL   = IE
      IFCE  = IFACE
      X0(1) = X1(1)
      X0(2) = X1(2)
      X0(3) = X1(3)
      DX(1) = X2(1)-X1(1)
      DX(2) = X2(2)-X1(2)
      DX(3) = X2(3)-X1(3)
      DIST  = SQRT ( DX(1)**2 + DX(2)**2 + DX(3)**2 )
C
C     Initial guess for bracket is given by size of element face (DELT).
C
      ETA2  = 1.0
      ETA1  = ETA2 - DELT/DIST
      ETA1  = MAX(ETA1,0.0)
      CALL ZBRAC(ETA1,ETA2,SUCCES)
C
      TOL    = 1.0E-5
      TOLSRF = TOL*(ETA2-ETA1)
      IF (SUCCES) ETA3 = ZBRENT(ETA1,ETA2,TOLSRF)
C
      X3(1) = X0(1) + DX(1)*ETA3
      X3(2) = X0(2) + DX(2)*ETA3
      X3(3) = X0(3) + DX(3)*ETA3
C
      return
      end
c-----------------------------------------------------------------------
      subroutine zbrac(x1,x2,succes)
C
C     Given a function FNC and an initial guess (X1,X2), the routine
C     expands the range geometrically until a root is bracketed by the
C     returned range (X1,X2) [SUCCES=.TRUE.], or until the range becomes
C     unacceptably large [SUCCES=.FALSE.].
C     ( Numerical Recipes, p. 245; pff 9 Aug 1989 09:00:20 )
C
      PARAMETER (FACTOR=1.08,NTRY=50)
      LOGICAL SUCCES
C
      SUCCES = .TRUE.
C
      IF (X1.EQ.X2)  X1 = .99*X1
      IF (X1.EQ.0.0) X1 = 1.0E-04
C
      F1 = FNC(X1)
      F2 = FNC(X2)
      DO 100 J=1,NTRY
         IF (F1*F2.LT.0.0) return
         IF (ABS(F1).LT.ABS(F2)) THEN
            X1 = X1 + FACTOR*(X1-X2)
            F1 = FNC(X1)
         ELSE
            X2 = X2 + FACTOR*(X2-X1)
            F2 = FNC(X2)
         ENDIF
  100 CONTINUE
      SUCCES = .FALSE.
      return
      end
      FUNCTION ZBRENT(X1,X2,TOL)
C
C     Using the Van Wijngaarden-Dekker-Brent Method, find the root
C     of a function FNC known to lie between X1 and X2.  The root,
C     returned as ZBRENT, will be refined until its accuracy is TOL.
C
      PARAMETER (ITMAX=100,EPS=3.0E-8)
C
      A = X1
      B = X2
      FA = FNC(A)
      FB = FNC(B)
      IF (FB*FA.GT.0.0) GOTO 9000
      FC=FB
C
      DO 1000 ITER=1,ITMAX
         IF (FB*FC.GT.0.0) THEN
            C  = A
            FC = FA
            D  = B-A
            E  = D
         ENDIF
         IF (ABS(FC).LT.ABS(FB)) THEN
            A = B
            B = C
            C = A
            FA = FB
            FB = FC
            FC = FA
         ENDIF
         TOL1 = 2.0*EPS*ABS(B)+0.5*TOL
         XM = 0.5*(C-B)
         IF (ABS(XM).LE.TOL1.OR.FB.EQ.0.0) THEN
            ZBRENT = B
            return
         ENDIF
         IF (ABS(E).GT.TOL1.AND. ABS(FA).GT.ABS(FB)) THEN
C
C           Attempt inverse quadratic interpolation
C
            S=FB/FA
            IF (A.EQ.C) THEN
               P=2.0*XM*S
               Q=1.0-S
            ELSE
               Q=FA/FC
               R=FB/FC
               P=S*( 2.0*XM*Q*(Q-R) - (B-A)*(R-1.0) )
               Q=(Q-1.0)*(R-1.0)*(S-1.0)
            ENDIF
C
C           Check whether in bounds...
C
            IF (P.GT.0.0) Q = -Q
            P = ABS(P)
            IF (2.0*P.LT.MIN(3.0*XM*Q-ABS(TOL1*Q),ABS(E*Q))) THEN
C              Accept interpolation.
               E=D
               D=P/Q
            ELSE
C              Interpolation failed, use bisection.
               D=XM
               E=D
            ENDIF
         ELSE
C           Bounds decreasing too slowly, use bisection.
            D=XM
            E=D
         ENDIF
         A=B
         FA=FB
         IF (ABS(D).GT.TOL1) THEN
C           Evaluate new trial root
            B=B+D
         ELSE
            B=B+SIGN(TOL1,XM)
         ENDIF
         FB=FNC(B)
 1000 CONTINUE
C
C
 9000 CONTINUE
      write(6 ,*) 'Exceeding maximum number of iterations.'
C      WRITE(21,*) 'Exceeding maximum number of iterations.'
      ZBRENT=B
      return
      end
      FUNCTION FNC(ETA)
      include 'SIZE'
      include 'INPUT'
      COMMON /SRFCEI/ IEL,IFCE
      COMMON /SRFCER/ X0(3),DX(3)
      COMMON /SRFCEL/ SUCCES
      DIMENSION X3(3)
      integer icalld
      save    icalld
      data    icalld /0/
C
      IF (CCURVE(IFCE,IEL).EQ.'s') THEN
        xctr   = CURVE(1,IFCE,IEL)
        yctr   = CURVE(2,IFCE,IEL)
        zctr   = CURVE(3,IFCE,IEL)
        RADIUS = CURVE(4,IFCE,IEL)
        X = X0(1) + DX(1)*ETA - XCTR
        Y = X0(2) + DX(2)*ETA - YCTR
        Z = X0(3) + DX(3)*ETA - ZCTR
C
        FNC    = (RADIUS**2 - (X**2+Y**2+Z**2))/(RADIUS**2)
C
      ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine setdef
C-------------------------------------------------------------------
C
C     Set up deformed element logical switches
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      DIMENSION XCC(8),YCC(8),ZCC(8)
      DIMENSION INDX(8)
      REAL VEC(3,12)
      LOGICAL IFVCHK
C
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV
C
C   Corner notation:
C                
C                  4+-----+3    ^ Y
C                  /     /|     |
C                 /     / |     |
C               8+-----+7 +2    +----> X
C                |     | /     /
C                |     |/     /
C               5+-----+6    Z
C                
C
      DO 10 IE=1,NELT
         IFDFRM(IE)=.TRUE.
   10 CONTINUE
C
      IF (IFMVBD) return
c
c     Force IFDFRM=.true. for all elements (for timing purposes only)
c
      IF (param(59).ne.0.and.nio.eq.0) 
     $   write(6,*) 'NOTE: All elements deformed , param(59) ^=0'
      IF (param(59).ne.0) return
C
C     Check against cases which won't allow for savings in HMHOLTZ
C
      INDX(1)=1
      INDX(2)=2
      INDX(3)=4
      INDX(4)=3
      INDX(5)=5
      INDX(6)=6
      INDX(7)=8
      INDX(8)=7
C
C     Check for deformation (rotation is acceptable).
C
      DO 500 IE=1,NELT
C
      call rzero(vec,36)
      IF (IF3D) THEN
         DO 100 IEDG=1,8
            IF(CCURVE(IEDG,IE).NE.' ') THEN
               IFDFRM(IE)=.TRUE.
               GOTO 500
            ENDIF
  100    CONTINUE
C
         DO 105 I=1,8
            XCC(I)=XC(INDX(I),IE)
            YCC(I)=YC(INDX(I),IE)
            ZCC(I)=ZC(INDX(I),IE)
  105    CONTINUE
C
         DO 110 I=1,4
            VEC(1,I)=XCC(2*I)-XCC(2*I-1)
            VEC(2,I)=YCC(2*I)-YCC(2*I-1)
            VEC(3,I)=ZCC(2*I)-ZCC(2*I-1)
  110    CONTINUE
C
         I1=4
         DO 120 I=0,1
         DO 120 J=0,1
            I1=I1+1
            I2=4*I+J+3
            VEC(1,I1)=XCC(I2)-XCC(I2-2)
            VEC(2,I1)=YCC(I2)-YCC(I2-2)
            VEC(3,I1)=ZCC(I2)-ZCC(I2-2)
  120    CONTINUE
C
         I1=8
         DO 130 I=5,8
            I1=I1+1
            VEC(1,I1)=XCC(I)-XCC(I-4)
            VEC(2,I1)=YCC(I)-YCC(I-4)
            VEC(3,I1)=ZCC(I)-ZCC(I-4)
  130    CONTINUE
C
         DO 140 I=1,12
            VECLEN = VEC(1,I)**2 + VEC(2,I)**2 + VEC(3,I)**2
            VECLEN = SQRT(VECLEN)
            VEC(1,I)=VEC(1,I)/VECLEN
            VEC(2,I)=VEC(2,I)/VECLEN
            VEC(3,I)=VEC(3,I)/VECLEN
  140    CONTINUE
C
C        Check the dot product of the adjacent edges to see that it is zero.
C
         IFDFRM(IE)=.FALSE.
         IF (  IFVCHK(VEC,1,5, 9)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,1,6,10)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,2,5,11)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,2,6,12)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,3,7, 9)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,3,8,10)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,4,7,11)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,4,8,12)  ) IFDFRM(IE)=.TRUE.
C
C      Check the 2D case....
C
       ELSE
C
         DO 200 IEDG=1,4
            IF(CCURVE(IEDG,IE).NE.' ') THEN
               IFDFRM(IE)=.TRUE.
               GOTO 500
            ENDIF
  200    CONTINUE
C
         DO 205 I=1,4
            XCC(I)=XC(INDX(I),IE)
            YCC(I)=YC(INDX(I),IE)
  205    CONTINUE
C
         VEC(1,1)=XCC(2)-XCC(1)
         VEC(1,2)=XCC(4)-XCC(3)
         VEC(1,3)=XCC(3)-XCC(1)
         VEC(1,4)=XCC(4)-XCC(2)
         VEC(1,5)=0.0
         VEC(2,1)=YCC(2)-YCC(1)
         VEC(2,2)=YCC(4)-YCC(3)
         VEC(2,3)=YCC(3)-YCC(1)
         VEC(2,4)=YCC(4)-YCC(2)
         VEC(2,5)=0.0
C
         DO 220 I=1,4
            VECLEN = VEC(1,I)**2 + VEC(2,I)**2
            VECLEN = SQRT(VECLEN)
            VEC(1,I)=VEC(1,I)/VECLEN
            VEC(2,I)=VEC(2,I)/VECLEN
  220    CONTINUE
C
C        Check the dot product of the adjacent edges to see that it is zero.
C
         IFDFRM(IE)=.FALSE.
         IF (  IFVCHK(VEC,1,3,5)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,1,4,5)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,2,3,5)  ) IFDFRM(IE)=.TRUE.
         IF (  IFVCHK(VEC,2,4,5)  ) IFDFRM(IE)=.TRUE.
       ENDIF
  500 CONTINUE
      return
      end
      LOGICAL FUNCTION IFVCHK(VEC,I1,I2,I3)
C
C     Take the dot product of the three components of VEC to see if it's zero.
C
      DIMENSION VEC(3,12)
      LOGICAL IFTMP
C
      IFTMP=.FALSE.
      EPSM=1.0E-06
C
      DOT1=VEC(1,I1)*VEC(1,I2)+VEC(2,I1)*VEC(2,I2)+VEC(3,I1)*VEC(3,I2)
      DOT2=VEC(1,I2)*VEC(1,I3)+VEC(2,I2)*VEC(2,I3)+VEC(3,I2)*VEC(3,I3)
      DOT3=VEC(1,I1)*VEC(1,I3)+VEC(2,I1)*VEC(2,I3)+VEC(3,I1)*VEC(3,I3)
C
      DOT1=ABS(DOT1)
      DOT2=ABS(DOT2)
      DOT3=ABS(DOT3)
      DOT=DOT1+DOT2+DOT3
      IF (DOT.GT.EPSM) IFTMP=.TRUE.
C
      IFVCHK=IFTMP
      return
      end
c-----------------------------------------------------------------------
      subroutine gencoor (xm3,ym3,zm3)
C-----------------------------------------------------------------------
C
C     Generate xyz coordinates  for all elements.
C        Velocity formulation : mesh 3 is used
C        Stress   formulation : mesh 1 is used
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      DIMENSION XM3(LX3,LY3,LZ3,1),YM3(LX3,LY3,LZ3,1),ZM3(LX3,LY3,LZ3,1)
C
C     Select appropriate mesh
C
      IF ( IFGMSH3 ) THEN
         CALL GENXYZ (XM3,YM3,ZM3,lx3,ly3,lz3)
      ELSE
         CALL GENXYZ (XM1,YM1,ZM1,lx1,ly1,lz1)
      ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine genxyz (xml,yml,zml,nxl,nyl,nzl)
C
      include 'SIZE'
      include 'WZ'
      include 'GEOM'
      include 'TOPOL'
      include 'INPUT'
      include 'PARALLEL'

      real xml(nxl,nyl,nzl,1),yml(nxl,nyl,nzl,1),zml(nxl,nyl,nzl,1)

C     Note : CTMP1 is used in this format in several subsequent routines
      common /ctmp1/ h(lx1,3,2),xcrved(lx1),ycrved(ly1),zcrved(lz1)
     $             , zgml(lx1,3),work(3,lx1,lz1)

      parameter (ldw=2*lx1*ly1*lz1)
      common /ctmp0/ w(ldw)

      character*1 ccv

c     Initialize geometry arrays with bi- triquadratic deformations
      call linquad(xml,yml,zml,nxl,nyl,nzl)


      do ie=1,nelt

         call setzgml (zgml,ie,nxl,nyl,nzl,ifaxis)
         call sethmat (h,zgml,nxl,nyl,nzl)

c        Deform surfaces - general 3D deformations
c                        - extruded geometry deformations
         nfaces = 2*ldim
         do iface=1,nfaces
           ccv = ccurve(iface,ie)
           if (ccv.eq.'s') 
     $        call sphsrf(xml,yml,zml,iface,ie,nxl,nyl,nzl,work) 
           if (ccv.eq.'e') 
     $        call gensrf(xml,yml,zml,iface,ie,nxl,nyl,nzl,zgml) 
         enddo

         do isid=1,8
           ccv = ccurve(isid,ie)
           if (ccv.eq.'C') call arcsrf(xml,yml,zml,nxl,nyl,nzl,ie,isid)
         enddo

      enddo

c     call user_srf(xml,yml,zml,nxl,nyl,nzl)
c     call opcopy(xm1,ym1,zm1,xml,yml,zml)
c     call outpost(xml,yml,zml,xml,yml,'   ')
c     call exitt
C
      return
      end
c-----------------------------------------------------------------------
      subroutine sethmat(h,zgml,nxl,nyl,nzl)

      include 'SIZE'
      include 'INPUT'  ! if3d

      real h(lx1,3,2),zgml(lx1,3)

      do 10 ix=1,nxl
         h(ix,1,1)=(1.0-zgml(ix,1))*0.5
         h(ix,1,2)=(1.0+zgml(ix,1))*0.5
   10 continue
      do 20 iy=1,nyl
         h(iy,2,1)=(1.0-zgml(iy,2))*0.5
         h(iy,2,2)=(1.0+zgml(iy,2))*0.5
   20 continue
      if (if3d) then
         do 30 iz=1,nzl
            h(iz,3,1)=(1.0-zgml(iz,3))*0.5
            h(iz,3,2)=(1.0+zgml(iz,3))*0.5
   30    continue
      else
         call rone(h(1,3,1),nzl)
         call rone(h(1,3,2),nzl)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine setzgml (zgml,e,nxl,nyl,nzl,ifaxl)

      include 'SIZE'
      include 'WZ'
      include 'GEOM'

      real zgml(lx1,3)
      integer e
      logical ifaxl

      call rzero (zgml,3*lx1)


      if (nxl.eq.3 .and. .not. ifaxl) then
         do k=1,3
            zgml(1,k) = -1
            zgml(2,k) =  0
            zgml(3,k) =  1
         enddo
      elseif (ifgmsh3.and.nxl.eq.lx3) then
         call copy(zgml(1,1),zgm3(1,1),lx3)
         call copy(zgml(1,2),zgm3(1,2),ly3)
         call copy(zgml(1,3),zgm3(1,3),lz3)
         if (ifaxl .and. ifrzer(e)) call copy(zgml(1,2),zam3,ly3)
      elseif (nxl.eq.lx1) then
         call copy(zgml(1,1),zgm1(1,1),lx1)
         call copy(zgml(1,2),zgm1(1,2),ly1)
         call copy(zgml(1,3),zgm1(1,3),lz1)
         if (ifaxl .and. ifrzer(e)) call copy(zgml(1,2),zam1,ly1)
      else
         call exitti('ABORT setzgml! $',nxl)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine sphsrf(xml,yml,zml,ifce,ie,nx,ny,nz,xysrf) 
C
C     5 Aug 1988 19:29:52 
C
C     Program to generate spherical shell elements for NEKTON
C     input.  Paul F. Fischer
C
      include 'SIZE'
      include 'INPUT'
      include 'WZ'
      include 'TOPOL'
      DIMENSION XML(NX,NY,NZ,1),YML(NX,NY,NZ,1),ZML(NX,NY,NZ,1)
      DIMENSION XYSRF(3,NX,NZ)
C
      COMMON /CTMP1/ H(LX1,3,2),XCRVED(LX1),YCRVED(LY1),ZCRVED(LZ1)
     $             , ZGML(LX1,3),WORK(3,LX1,LZ1)
      COMMON /CTMP0/ XCV(3,2,2),VN1(3),VN2(3)
     $              ,X1(3),X2(3),X3(3),DX(3)
      DIMENSION IOPP(3),NXX(3)
c
c
c     These are representative nodes on a given face, and their opposites
c
      integer cface(2,6)
      save    cface
      data    cface / 1,4 , 2,1 , 3,2 , 4,3 , 1,5 , 5,1 /
      real    vout(3),vsph(3)
      logical ifconcv
c
C
C     Determine geometric parameters
C
      NXM1 = NX-1
      NYM1 = NY-1
      NXY  = NX*NZ
      NXY3 = 3*NX*NZ
      XCTR   = CURVE(1,IFCE,IE)
      YCTR   = CURVE(2,IFCE,IE)
      ZCTR   = CURVE(3,IFCE,IE)
      RADIUS = CURVE(4,IFCE,IE)
      IFACE  = EFACE1(IFCE)
C
C     Generate (normalized) corner vectors XCV(1,i,j):
C
      CALL CRN3D(XCV,XC(1,IE),YC(1,IE),ZC(1,IE),CURVE(1,IFCE,IE),IFACE)
C
C     Generate edge vectors on the sphere RR=1.0, 
C     for (r,s) = (-1,*),(1,*),(*,-1),(*,1)      
C
      CALL EDG3D(XYSRF,XCV(1,1,1),XCV(1,1,2), 1, 1, 1,NY,NX,NY)
      CALL EDG3D(XYSRF,XCV(1,2,1),XCV(1,2,2),NX,NX, 1,NY,NX,NY)
      CALL EDG3D(XYSRF,XCV(1,1,1),XCV(1,2,1), 1,NX, 1, 1,NX,NY)
      CALL EDG3D(XYSRF,XCV(1,1,2),XCV(1,2,2), 1,NX,NY,NY,NX,NY)
C
C     Generate intersection vectors for (i,j)
C
C     quick check on sign of curvature:        (pff ,  12/08/00)
c
c
      ivtx = cface(1,ifce)
      ivto = cface(2,ifce)
      vout(1) = xc(ivtx,ie)-xc(ivto,ie)
      vout(2) = yc(ivtx,ie)-yc(ivto,ie)
      vout(3) = zc(ivtx,ie)-zc(ivto,ie)
c
      vsph(1) = xc(ivtx,ie)-xctr
      vsph(2) = yc(ivtx,ie)-yctr
      vsph(3) = zc(ivtx,ie)-zctr
      ifconcv = .true.
      sign    = DOT(vsph,vout,3)
      if (sign.gt.0) ifconcv = .false.
c     write(6,*) 'THIS IS SIGN:',sign
c
      DO 200 J=2,NYM1
         CALL CROSS(VN1,XYSRF(1,1,J),XYSRF(1,NX,J))
         DO 200 I=2,NXM1
            CALL CROSS(VN2,XYSRF(1,I,1),XYSRF(1,I,NY))
            if (ifconcv) then
c           IF (IFACE.EQ.1.OR.IFACE.EQ.4.OR.IFACE.EQ.5) THEN
               CALL CROSS(XYSRF(1,I,J),VN2,VN1)
            ELSE
               CALL CROSS(XYSRF(1,I,J),VN1,VN2)
            ENDIF
  200 CONTINUE
C
C     Normalize all vectors to the unit sphere.
C
      DO 300 I=1,NXY
         CALL NORM3D(XYSRF(1,I,1))
  300 CONTINUE
C
C     Scale by actual radius
C
      CALL CMULT(XYSRF,RADIUS,NXY3)
C
C     Add back the sphere center offset
C
      DO 400 I=1,NXY
         XYSRF(1,I,1)=XYSRF(1,I,1)+XCTR
         XYSRF(2,I,1)=XYSRF(2,I,1)+YCTR
         XYSRF(3,I,1)=XYSRF(3,I,1)+ZCTR
  400 CONTINUE
C
C
C     Transpose data, if necessary
C
      IF (IFACE.EQ.1.OR.IFACE.EQ.4.OR.IFACE.EQ.5) THEN
         DO 500 J=1  ,NY
         DO 500 I=J+1,NX
            TMP=XYSRF(1,I,J)
            XYSRF(1,I,J)=XYSRF(1,J,I)
            XYSRF(1,J,I)=TMP
            TMP=XYSRF(2,I,J)
            XYSRF(2,I,J)=XYSRF(2,J,I)
            XYSRF(2,J,I)=TMP
            TMP=XYSRF(3,I,J)
            XYSRF(3,I,J)=XYSRF(3,J,I)
            XYSRF(3,J,I)=TMP
  500    CONTINUE
      ENDIF
C
C     Compute surface deflection and perturbation due to face IFACE
C
      CALL DSSET(NX,NY,NZ)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      IOPP(1) = NX-1
      IOPP(2) = NX*(NY-1)
      IOPP(3) = NX*NY*(NZ-1)
      NXX(1)  = NX
      NXX(2)  = NY
      NXX(3)  = NZ
      IDIR    = 2*MOD(IFACE,2) - 1
      IFC2    = (IFACE+1)/2
      DELT    = 0.0
      I=0
      DO 700 J2=JS2,JF2,JSKIP2
      DO 700 J1=JS1,JF1,JSKIP1
         I=I+1
         JOPP = J1 + IOPP(IFC2)*IDIR
         X2(1) = XML(J1,J2,1,IE)
         X2(2) = YML(J1,J2,1,IE)
         X2(3) = ZML(J1,J2,1,IE)
C
         DX(1) = XYSRF(1,I,1)-X2(1)
         DX(2) = XYSRF(2,I,1)-X2(2)
         DX(3) = XYSRF(3,I,1)-X2(3)
C
         NXS = NXX(IFC2)
         JOFF = (J1-JOPP)/(NXS-1)
         DO 600 IX = 2,NXS
            J = JOPP + JOFF*(IX-1)
            ZETA = 0.5*(ZGML(IX,IFC2) + 1.0)
            XML(J,J2,1,IE) = XML(J,J2,1,IE)+DX(1)*ZETA
            YML(J,J2,1,IE) = YML(J,J2,1,IE)+DX(2)*ZETA
            ZML(J,J2,1,IE) = ZML(J,J2,1,IE)+DX(3)*ZETA
  600    CONTINUE
  700 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine edg3d(xysrf,x1,x2,i1,i2,j1,j2,nx,ny)
C
C     Generate XYZ vector along an edge of a surface.
C
      include 'SIZE'
      COMMON /CTMP1/ H(LX1,3,2),XCRVED(LX1),YCRVED(LY1),ZCRVED(LZ1)
     $             , ZGML(LX1,3),WORK(3,LX1,LZ1)
C
      DIMENSION XYSRF(3,NX,NY)
      DIMENSION X1(3),X2(3)
      REAL U1(3),U2(3),VN(3),B(3)
C
C     Normalize incoming vectors
C
      CALL COPY (U1,X1,3)
      CALL COPY (U2,X2,3)
      CALL NORM3D (U1)
      CALL NORM3D (U2)
C
C     Find normal to the plane and tangent to the curve.
C
      CALL CROSS(VN,X1,X2)
      CALL CROSS( B,VN,X1)
      CALL NORM3D (VN)
      CALL NORM3D (B)
C
      CTHETA = DOT(U1,U2,3)
      THETA  = ACOS(CTHETA)
C
      IJ = 0
      DO 200 J=J1,J2
      DO 200 I=I1,I2
         IJ = IJ + 1
         THETAP = 0.5*THETA*(ZGML(IJ,1)+1.0)
         CTP = COS(THETAP)
         STP = SIN(THETAP)
         DO 200 IV = 1,3
            XYSRF(IV,I,J) = CTP*U1(IV) + STP*B(IV)
  200 CONTINUE
      return
      end
      REAL FUNCTION DOT(V1,V2,N)
C
C     Compute Cartesian vector dot product.
C
      DIMENSION V1(N),V2(N)
C
      SUM = 0
      DO 100 I=1,N
         SUM = SUM + V1(I)*V2(I)
  100 CONTINUE
      DOT = SUM
      return
      end
c-----------------------------------------------------------------------
      subroutine cross(v1,v2,v3)
C
C     Compute Cartesian vector dot product.
C
      DIMENSION V1(3),V2(3),V3(3)
C
      V1(1) = V2(2)*V3(3) - V2(3)*V3(2)
      V1(2) = V2(3)*V3(1) - V2(1)*V3(3)
      V1(3) = V2(1)*V3(2) - V2(2)*V3(1)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine norm3d(v1)
C
C     Compute Cartesian vector dot product.
C
      DIMENSION V1(3)
C
      VLNGTH = DOT(V1,V1,3)
      VLNGTH = SQRT(VLNGTH)
      if (vlngth.gt.0) then
         V1(1) = V1(1) / VLNGTH
         V1(2) = V1(2) / VLNGTH
         V1(3) = V1(3) / VLNGTH
      endif
C
      return
      end
c-----------------------------------------------------------------------
      subroutine crn3d(xcv,xc,yc,zc,curve,iface)
      include 'SIZE'
      include 'TOPOL'
      DIMENSION XCV(3,2,2),XC(8),YC(8),ZC(8),CURVE(4)
      DIMENSION INDVTX(4,6)
      SAVE      INDVTX
      DATA      INDVTX  / 1,5,3,7 , 2,4,6,8 , 1,2,5,6  
     $                  , 3,7,4,8 , 1,3,2,4 , 5,6,7,8 /
C
      EPS    = 1.0E-4
      XCTR   = CURVE(1)
      YCTR   = CURVE(2)
      ZCTR   = CURVE(3)
      RADIUS = CURVE(4)
C
      DO 10 I=1,4
         J=INDVTX(I,IFACE)
         K=INDX(J)
         XCV(1,I,1)=XC(K)-XCTR
         XCV(2,I,1)=YC(K)-YCTR
         XCV(3,I,1)=ZC(K)-ZCTR
   10 CONTINUE
C
C     Check to ensure that these points are indeed on the sphere.
C
      IF (RADIUS.LE.0.0) THEN
         write(6,20) NID,XCTR,YCTR,ZCTR,IFACE
  20     FORMAT(I5,'ERROR: Sphere of radius zero requested.'
     $       ,/,5X,'EXITING in CRN3D',3E12.4,I3)
         call exitt
      ELSE
         DO 40 I=1,4
            RADT=XCV(1,I,1)**2+XCV(2,I,1)**2+XCV(3,I,1)**2
            RADT=SQRT(RADT)
            TEST=ABS(RADT-RADIUS)/RADIUS
            IF (TEST.GT.EPS) THEN
             write(6,30) NID
     $      ,RADT,RADIUS,XCV(1,I,1),XCV(2,I,1),XCV(3,I,1)
   30        FORMAT(I5,'ERROR: Element vertex not on requested sphere.'
     $           ,/,5X,'EXITING in CRN3D',5E12.4)
             call exitt
            ENDIF
   40    CONTINUE
      ENDIF
C
      return
      end
c-----------------------------------------------------------------------
      subroutine rotxyz 
C-----------------------------------------------------------------------
C
C     Establish rotation of undeformed elements.
C     Used for fast evaluation of D*x and DT*x.
C     Currently used for 2-d problems.
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'ESOLV'
      COMMON /FASTMD/ IFDFRM(LELT), IFFAST(LELT), IFH2, IFSOLV
      LOGICAL IFDFRM, IFFAST, IFH2, IFSOLV
C
      IF (IFMVBD)    return
      IF (ldim.EQ.3) return
C
      EPS    = 1.E-6
      EPSINV = 1./EPS
      NXYZ1 = lx1*ly1*lz1
      DO 100 IEL=1,NELV
         IF (.NOT.IFDFRM(IEL)) THEN
            RXAVER = VLSUM(RXM1(1,1,1,IEL),NXYZ1)/(NXYZ1)
            SXAVER = VLSUM(SXM1(1,1,1,IEL),NXYZ1)/(NXYZ1)
            IF (SXAVER.NE.0.) THEN
               ROTXY = ABS(SXAVER/RXAVER)
               IF (ROTXY.LT.EPS) THEN
                  IFALGN(IEL) = .TRUE.
                  IFRSXY(IEL) = .TRUE.
               ELSEIF (ROTXY.GT.EPSINV) THEN
                  IFALGN(IEL) = .TRUE.
                  IFRSXY(IEL) = .FALSE.
               ELSE
                  IFALGN(IEL) = .FALSE.
                  IFRSXY(IEL) = .FALSE.
               ENDIF
            ELSE
               IFALGN(IEL) = .TRUE.
               IFRSXY(IEL) = .TRUE.
            ENDIF
         ENDIF
 100  CONTINUE
      return
      end
c-----------------------------------------------------------------------
      subroutine gensrf(XML,YML,ZML,IFCE,IE,MX,MY,MZ,zgml)
C
C     9 Mar 1994 
C
C     Program to generate surface deformations for NEKTON
C     input.  Paul F. Fischer
C
c     include 'basics.inc'
      include 'SIZE'
      include 'INPUT'
      include 'WZ'
      include 'TOPOL'
C
      DIMENSION XML(MX,MY,MZ,1),YML(MX,MY,MZ,1),ZML(MX,MY,MZ,1)
     $             ,ZGML(MX,3)
C
      real IOPP(3),MXX(3),X0(3),DX(3)
C
C
C     Algorithm:  .Project original point onto surface S
C                 .Apply Gordon Hall to vector of points between x_s and
C                  opposite face
C
C
      CALL DSSET(MX,MY,MZ)
C
      IFACE  = EFACE1(IFCE)
c
c     Beware!!  SKPDAT different from preprocessor/postprocessor!
c
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
c
      IOPP(1) = MX-1
      IOPP(2) = MX*(MY-1)
      IOPP(3) = MX*MY*(MZ-1)
      MXX(1)  = MX
      MXX(2)  = MY
      MXX(3)  = MZ
      IDIR    = 2*MOD(IFACE,2) - 1
      IFC2    = (IFACE+1)/2
      I=0
C
C     Find a characteristic length scale for initializing secant method
C
      x0(1) = xml(js1,js2,1,ie)
      x0(2) = yml(js1,js2,1,ie)
      x0(3) = zml(js1,js2,1,ie)
      rmin  = 1.0e16
c
c
c
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         if (j1.ne.js1.or.j2.ne.js2) then
            r2 = (x0(1) - xml(j1,j2,1,ie))**2 
     $         + (x0(2) - yml(j1,j2,1,ie))**2 
     $         + (x0(3) - zml(j1,j2,1,ie))**2 
            rmin = min(r2,rmin)
         endif
  100 CONTINUE
      dxc = 0.05*sqrt(rmin)
C
C     Project each point on this surface onto curved surface
C
      DO 300 J2=JS2,JF2,JSKIP2
      DO 300 J1=JS1,JF1,JSKIP1
         I=I+1
         JOPP = J1 + IOPP(IFC2)*IDIR
         X0(1) = XML(J1,J2,1,IE)
         X0(2) = YML(J1,J2,1,IE)
         X0(3) = ZML(J1,J2,1,IE)
C 
         call prjects(x0,dxc,curve(1,ifce,ie),ccurve(ifce,ie))
         DX(1) = X0(1)-xml(j1,j2,1,ie)
         DX(2) = X0(2)-yml(j1,j2,1,ie)
         DX(3) = X0(3)-zml(j1,j2,1,ie)
         MXS = MXX(IFC2)
         JOFF = (J1-JOPP)/(MXS-1)
         DO 200 IX = 2,MXS
            J = JOPP + JOFF*(IX-1)
            ZETA = 0.5*(ZGML(IX,1) + 1.0)
            XML(J,J2,1,IE) = XML(J,J2,1,IE)+DX(1)*ZETA
            YML(J,J2,1,IE) = YML(J,J2,1,IE)+DX(2)*ZETA
            ZML(J,J2,1,IE) = ZML(J,J2,1,IE)+DX(3)*ZETA
  200    CONTINUE
  300 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine prjects(x0,dxc,c,cc)
c
c     Project the point x0 onto surface described by characteristics
c     given in the array c and cc.  
c
c     dxc - characteristic length scale used to estimate gradient.
c
      real x0(3)
      real c(5)
      character*1 cc
      real x1(3)
      logical if3d
c
      if3d = .true.
      if (dxc.le.0.0) then
         write(6,*) 'invalid dxc',dxc,x0
         write(6,*) 'Abandoning prjects'
         return
      endif
c
      call copy(x1,x0,3)
      R0 = ressrf(x0,c,cc)
      if (r0.eq.0) return
c
c     Must at least use ctr differencing to capture symmetry!
c
      x1(1) = x0(1) - dxc
      R1 = ressrf(x1,c,cc)
      x1(1) = x0(1) + dxc
      R2 = ressrf(x1,c,cc)
      x1(1) = x0(1)
      Rx = 0.5*(R2-R1)/dxc
c
      x1(2) = x0(2) - dxc
      R1 = ressrf(x1,c,cc)/dxc
      x1(2) = x0(2) + dxc
      R2 = ressrf(x1,c,cc)/dxc
      x1(2) = x0(2)
      Ry = 0.5*(R2-R1)/dxc
c
      if (if3d) then
         x1(3) = x0(3) - dxc
         R1 = ressrf(x1,c,cc)/dxc
         x1(3) = x0(3) + dxc
         R2 = ressrf(x1,c,cc)/dxc
         Rz = 0.5*(R2-R1)/dxc
      endif
      Rnorm2 = Rx**2 + Ry**2 + Rz**2
      alpha  = - R0/Rnorm2
c
c     Apply secant method:  Use an initial segment twice expected length
c
      x1(1) = x0(1) + 2.0*Rx * alpha
      x1(2) = x0(2) + 2.0*Ry * alpha
      x1(3) = x0(3) + 2.0*Rz * alpha
      call srfind(x1,x0,c,cc)
c
c     write(6,6) cc,c(2),c(3),x0,x1
c   6 format(1x,a1,1x,2f5.2,3f9.4,3x,3f9.4)
c
      call copy(x0,x1,3)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine srfind(x1,x0,c,cc)
      real x1(3),x0(3)
      real c(5)
      character*1 cc
c
c     Find point on line segment that intersects the ellipsoid 
c     specified by:
c                       (x/a)**2 + (y/b)**2 + (z/b)**2 = 1
c
c
c     Algorithm:  4 rounds of secant  x_k+1 = x_k - f/f'
c
      a0 = 0.0
      a1 = 1.0
      r0 = ressrf(x0,c,cc)
      dx = x1(1) - x0(1)
      dy = x1(2) - x0(2)
      dz = x1(3) - x0(3)
c     write(6,*) 'dxyz',dx,dy,dz
c     write(6,*) 'cc  ',x0,cc,c(2),c(3)
      do 10 i=1,9
         r1 = ressrf(x1,c,cc)
         if (r1.ne.r0) then
            da = r1*(a1-a0)/(r1-r0)
            r0 = r1
            a0 = a1
            a1 = a1 - da
         endif
         x1(1) = x0(1) + a1*dx
         x1(2) = x0(2) + a1*dy
         x1(3) = x0(3) + a1*dz
   10 continue
c     write(6,*) ' r1',r1,r0,a1
      return
      end
c-----------------------------------------------------------------------
      function ressrf(x,c,cc)
      real x(3) 
      real c(5)
      character*1 cc
c
      ressrf = 0.0
      if (cc.eq.'e') then
         a = c(2)
         b = c(3)
         ressrf = 1.0 - (x(1)/a)**2 - (x(2)/b)**2 - (x(3)/b)**2
         return
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine linquad(xl,yl,zl,nxl,nyl,nzl)

      include 'SIZE'
      include 'WZ'
      include 'GEOM'
      include 'TOPOL'
      include 'INPUT'
      include 'PARALLEL'

      real xl(nxl*nyl*nzl,1),yl(nxl*nyl*nzl,1),zl(nxl*nyl*nzl,1)

      integer e
      logical ifmid

      nedge = 4 + 8*(ldim-2)

      do e=1,nelt ! Loop over all elements

         ifmid = .false.
         do k=1,nedge
            if (ccurve(k,e).eq.'m') ifmid = .true.
         enddo

         if (lx1.eq.2) ifmid = .false.
         if (ifmid) then
            call xyzquad(xl(1,e),yl(1,e),zl(1,e),nxl,nyl,nzl,e)
         else
            call xyzlin (xl(1,e),yl(1,e),zl(1,e),nxl,nyl,nzl,e,ifaxis)
         endif
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine xyzlin(xl,yl,zl,nxl,nyl,nzl,e,ifaxl)
c     Generate bi- or trilinear mesh

      include 'SIZE'
      include 'INPUT'

      real xl(nxl,nyl,nzl),yl(nxl,nyl,nzl),zl(nxl,nyl,nzl)
      integer e
      logical ifaxl ! local ifaxis specification

c   Preprocessor Corner notation:      Symmetric Corner notation:
c
c           4+-----+3    ^ s                    3+-----+4    ^ s
c           /     /|     |                      /     /|     |
c          /     / |     |                     /     / |     |
c        8+-----+7 +2    +----> r            7+-----+8 +2    +----> r
c         |     | /     /                     |     | /     /
c         |     |/     /                      |     |/     /
c        5+-----+6    t                      5+-----+6    t

      integer indx(8)
      save    indx
      data    indx / 1,2,4,3,5,6,8,7 /

      parameter (ldw=4*lx1*ly1*lz1)
      common /ctmp0/ xcb(2,2,2),ycb(2,2,2),zcb(2,2,2),w(ldw)

      common /cxyzl/ zgml(lx1,3),jx (lx1*2),jy (lx1*2),jz (lx1*2)
     $                          ,jxt(lx1*2),jyt(lx1*2),jzt(lx1*2)
     $                          ,zlin(2)
      real jx,jy,jz,jxt,jyt,jzt

      call setzgml (zgml,e,nxl,nyl,nzl,ifaxl)

      zlin(1) = -1
      zlin(2) =  1

      k = 1
      do i=1,nxl
         call fd_weights_full(zgml(i,1),zlin,1,0,jxt(k))
         call fd_weights_full(zgml(i,2),zlin,1,0,jyt(k))
         call fd_weights_full(zgml(i,3),zlin,1,0,jzt(k))
         k=k+2
      enddo
      call transpose(jx,nxl,jxt,2)

      ldim2 = 2**ldim
      do ix=1,ldim2          ! Convert prex notation to lexicographical
         i=indx(ix)
         xcb(ix,1,1)=xc(i,e)
         ycb(ix,1,1)=yc(i,e)
         zcb(ix,1,1)=zc(i,e)
      enddo

c     Map R-S-T space into physical X-Y-Z space.

      ! NOTE:  Assumes nxl=nyl=nzl !

      call tensr3(xl,nxl,xcb,2,jx,jyt,jzt,w)
      call tensr3(yl,nxl,ycb,2,jx,jyt,jzt,w)
      call tensr3(zl,nxl,zcb,2,jx,jyt,jzt,w)

      return
      end
c-----------------------------------------------------------------------
      subroutine xyzquad(xl,yl,zl,nxl,nyl,nzl,e)
c     Generate bi- or trilinear mesh

      include 'SIZE'
      include 'INPUT'

      real xl(nxl,nyl,nzl),yl(nxl,nyl,nzl),zl(nxl,nyl,nzl)
      real xq(27),yq(27),zq(27)
      integer e

      parameter (ldw=4*lx1*ly1*lz1)
      common /ctmp0/ w(ldw,2),zg(3)

c     Note : CTMP1 is used in this format in several subsequent routines

      integer eindx(12)  ! index of 12 edges into 3x3x3 tensor
      save    eindx      ! Follows preprocessor notation..
      data    eindx /  2 ,  6 ,  8 ,  4
     $              , 20 , 24 , 26 , 22
     $              , 10 , 12 , 18 , 16  /  ! preproc. vtx notation

      common /cxyzl/ zgml(lx1,3),jx (lx1*3),jy (lx1*3),jz (lx1*3)
     $                          ,jxt(lx1*3),jyt(lx1*3),jzt(lx1*3)
     $                          ,zquad(3)
      real jx,jy,jz,jxt,jyt,jzt

      call xyzlin(xq,yq,zq,3,3,3,e,.false.) ! map bilin to 3x3x3

      nedge = 4 + 8*(ldim-2)

      do k=1,nedge
         if (ccurve(k,e).eq.'m') then
            j = eindx(k)
            xq(j) = curve(1,k,e)
            yq(j) = curve(2,k,e)
            zq(j) = curve(3,k,e)
         endif
      enddo

      zg(1) = -1
      zg(2) =  0 
      zg(3) =  1

      if (if3d) then
         call gh_face_extend(xq,zg,3,2,w(1,1),w(1,2)) ! 2 --> edge extend
         call gh_face_extend(yq,zg,3,2,w(1,1),w(1,2))
         call gh_face_extend(zq,zg,3,2,w(1,1),w(1,2))
      else
         call gh_face_extend_2d(xq,zg,3,2,w(1,1),w(1,2)) ! 2 --> edge extend
         call gh_face_extend_2d(yq,zg,3,2,w(1,1),w(1,2))
      endif
      call clean_xyzq(xq,yq,zq,if3d) ! verify that midside node is in "middle"


c     Map R-S-T space into physical X-Y-Z space.
      ! NOTE:  Assumes nxl=nyl=nzl !

      zquad(1) = -1
      zquad(2) =  0
      zquad(3) =  1

      call setzgml (zgml,e,nxl,nyl,nzl,ifaxis)  ! Here we address axisymm.

      k = 1
      do i=1,nxl
         call fd_weights_full(zgml(i,1),zquad,2,0,jxt(k))
         call fd_weights_full(zgml(i,2),zquad,2,0,jyt(k))
         call fd_weights_full(zgml(i,3),zquad,2,0,jzt(k))
         k=k+3
      enddo
      call transpose(jx,nxl,jxt,3)

      call tensr3(xl,nxl,xq,3,jx,jyt,jzt,w)
      call tensr3(yl,nxl,yq,3,jx,jyt,jzt,w)
      call tensr3(zl,nxl,zq,3,jx,jyt,jzt,w)

      return
      end
c-----------------------------------------------------------------------
      subroutine clean_xyzq(x,y,z,if3d) ! verify that midside node is in "middle"

      real x(3,3,3),y(3,3,3),z(3,3,3)
      logical if3d

      integer eindx(12)  ! index of 12 edges into 3x3x3 tensor
      save    eindx      ! Follows preprocessor notation..
      data    eindx /  2 ,  6 ,  8 ,  4
     $              , 20 , 24 , 26 , 22
     $              , 10 , 12 , 18 , 16  /  ! preproc. vtx notation


c     if (if3d) then ! 12 edges
c     else
c     endif

c     Here - see routine "fix_m_curve" in prenek for indexing strategy
c
c     Note that "fix_m_curve" does not yet perform the actual fix, and
c     it too should be updated.

      return
      end
c-----------------------------------------------------------------------
      subroutine mesh_metrics
      include 'SIZE'
      include 'TOTAL'

      parameter(nedge = 4 + 8*(ldim-2))
      real ledg(nedge)

      nxyz = nx1*ny1*nz1
      ntot = nxyz*nelt

      ! aspect ratio
      ddmin = 1e20
      ddmax = -1
      ddavg = 0 
      do ie = 1,nelt
         ledg(1) = dist_xyzc(1,2,ie)
         ledg(2) = dist_xyzc(1,4,ie)
         ledg(3) = dist_xyzc(2,3,ie)
         ledg(4) = dist_xyzc(4,3,ie)
         if (ndim.eq.3) then
            ledg(5)  = dist_xyzc(1,5,ie)
            ledg(6)  = dist_xyzc(2,6,ie)
            ledg(7)  = dist_xyzc(4,8,ie)
            ledg(8)  = dist_xyzc(3,7,ie)

            ledg(9)  = dist_xyzc(5,6,ie)
            ledg(10) = dist_xyzc(5,8,ie)
            ledg(11) = dist_xyzc(8,7,ie)
            ledg(12) = dist_xyzc(6,7,ie)
         endif

         dratio = vlmax(ledg,nedge)/vlmin(ledg,nedge)
         ddmin  = min(ddmin,dratio)
         ddmax  = max(ddmax,dratio)
         ddavg  = ddavg + dratio 
      enddo 
      darmin = glmin(ddmin,1)
      darmax = glmax(ddmax,1)
      daravg = glsum(ddavg,1)/nelgt

      ! scaled Jac
      ddmin = 1e20
      ddmax = -1
      ddavg = 0 
      do ie = 1,nelt
         dratio = vlmin(JACM1(1,1,1,ie),nxyz)/
     $            vlmax(JACM1(1,1,1,ie),nxyz)
         ddmin = min(ddmin,dratio)
         ddmax = max(ddmax,dratio)
         ddavg = ddavg + dratio 
      enddo 
      dsjmin = glmin(ddmin,1)
      dsjmax = glmax(ddmax,1)
      dsjavg = glsum(ddavg,1)/nelgt 

      ! dx
      ddmin = 1e20
      ddmax = -1
      ddavg = 0 
      do ie = 1,nelt
         ddmin = min(ddmin,dxmin_e(ie)) 
         ddmax = max(ddmax,dxmax_e(ie))
         dtmp  = vlsum(JACM1(1,1,1,ie),nxyz)**1./3
         ddavg = ddavg + dtmp/(lx1-1) 
      enddo 
      dxmin = glmin(ddmin,1)
      dxmax = glmax(ddmax,1)
      dxavg = glsum(ddavg,1)/nelgt 

      if (nid.eq.0) then
         write(6,*) 'mesh metrics:'
         write(6,'(A,1p2E9.2)') ' GLL grid spacing min/max    :',
     $   dxmin,dxmax
         write(6,'(A,1p3E9.2)') ' scaled Jacobian  min/max/avg:',
     $   dsjmin,dsjmax,dsjavg
         write(6,'(A,1p3E9.2)') ' aspect ratio     min/max/avg:',
     $   darmin,darmax,daravg
         write(6,*)
      endif
 
      return
      end
c-----------------------------------------------------------------------
      real function dist_xyzc(i,j,ie)
c
c     distance between two element corner points
c     
      include 'SIZE'
      include 'INPUT'

      dist_xyzc = (xc(i,ie) - xc(j,ie))**2
      dist_xyzc = dist_xyzc + (yc(i,ie) - yc(j,ie))**2
      if(ndim.eq.3) dist_xyzc = dist_xyzc + (zc(i,ie) - zc(j,ie))**2
      dist_xyzc = sqrt(dist_xyzc)

      return
      end
c-----------------------------------------------------------------------
      function dxmin_e(e)

      include 'SIZE'
      include 'GEOM'
      include 'INPUT'

      integer  e

      d2m = 1.e20

      if (ldim.eq.3) then
         do k=1,nz1-1
         do j=1,ny1-1
         do i=1,nx1-1
            dx = xm1(i+1,j,k,e) - xm1(i,j,k,e)
            dy = ym1(i+1,j,k,e) - ym1(i,j,k,e)
            dz = zm1(i+1,j,k,e) - zm1(i,j,k,e)
            d2 = dx*dx + dy*dy + dz*dz
            d2m = min(d2m,d2)

            dx = xm1(i,j+1,k,e) - xm1(i,j,k,e)
            dy = ym1(i,j+1,k,e) - ym1(i,j,k,e)
            dz = zm1(i,j+1,k,e) - zm1(i,j,k,e)
            d2 = dx*dx + dy*dy + dz*dz
            d2m = min(d2m,d2)

            dx = xm1(i,j,k+1,e) - xm1(i,j,k,e)
            dy = ym1(i,j,k+1,e) - ym1(i,j,k,e)
            dz = zm1(i,j,k+1,e) - zm1(i,j,k,e)
            d2 = dx*dx + dy*dy + dz*dz
            d2m = min(d2m,d2)
         enddo
         enddo
         enddo
      else  ! 2D
         do j=1,ny1-1
         do i=1,nx1-1
            dx = xm1(i+1,j,1,e) - xm1(i,j,1,e)
            dy = ym1(i+1,j,1,e) - ym1(i,j,1,e)
            d2 = dx*dx + dy*dy
            d2m = min(d2m,d2)

            dx = xm1(i,j+1,1,e) - xm1(i,j,1,e)
            dy = ym1(i,j+1,1,e) - ym1(i,j,1,e)
            d2 = dx*dx + dy*dy
            d2m = min(d2m,d2)
         enddo
         enddo
      endif

      dxmin_e = sqrt(d2m)

      return
      end
c-----------------------------------------------------------------------
      function dxmax_e(e)

      include 'SIZE'
      include 'GEOM'
      include 'INPUT'

      integer  e

      d2m = -1.e20

      if (ldim.eq.3) then
         do k=1,nz1-1
         do j=1,ny1-1
         do i=1,nx1-1
            dx = xm1(i+1,j,k,e) - xm1(i,j,k,e)
            dy = ym1(i+1,j,k,e) - ym1(i,j,k,e)
            dz = zm1(i+1,j,k,e) - zm1(i,j,k,e)
            d2 = dx*dx + dy*dy + dz*dz
            d2m = max(d2m,d2)

            dx = xm1(i,j+1,k,e) - xm1(i,j,k,e)
            dy = ym1(i,j+1,k,e) - ym1(i,j,k,e)
            dz = zm1(i,j+1,k,e) - zm1(i,j,k,e)
            d2 = dx*dx + dy*dy + dz*dz
            d2m = max(d2m,d2)

            dx = xm1(i,j,k+1,e) - xm1(i,j,k,e)
            dy = ym1(i,j,k+1,e) - ym1(i,j,k,e)
            dz = zm1(i,j,k+1,e) - zm1(i,j,k,e)
            d2 = dx*dx + dy*dy + dz*dz
            d2m = max(d2m,d2)
         enddo
         enddo
         enddo
      else  ! 2D
         do j=1,ny1-1
         do i=1,nx1-1
            dx = xm1(i+1,j,1,e) - xm1(i,j,1,e)
            dy = ym1(i+1,j,1,e) - ym1(i,j,1,e)
            d2 = dx*dx + dy*dy
            d2m = max(d2m,d2)

            dx = xm1(i,j+1,1,e) - xm1(i,j,1,e)
            dy = ym1(i,j+1,1,e) - ym1(i,j,1,e)
            d2 = dx*dx + dy*dy
            d2m = max(d2m,d2)
         enddo
         enddo
      endif

      dxmax_e = sqrt(d2m)

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!* This is a program based on a test contributed by Yizi Gu@Rice Univ.
!* Classic Fibonacci calculation using task+taskwait. No data races.


module DRB105
    implicit none
    integer input
contains
    recursive function fib(n) result(r)
        use omp_lib
        implicit none
        integer :: n, i, j, r

        if (n<2) then
            r = n
        else
            !$omp task shared(i)
            i = fib(n-1)
            !$omp end task
            !$omp task shared(j)
            j = fib(n-2)
            !$omp end task
            !$omp taskwait
            r = i+j
        end if
    end function
end module

program DRB105_taskwait_orig_no
    use omp_lib
    use DRB105
    implicit none

    integer :: result
    input = 30

    !$omp parallel
    !$omp single
    result = fib(input)
    !$omp end single
    !$omp end parallel

    print 100, input, result
    100 format ('Fib for ',3i8,' =',3i8)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Example with loop-carried data dependence at the outer level loop.
!The inner level loop can be parallelized. No data race pairs.

program DRB054_inneronly2_orig_no
    use omp_lib
    implicit none

    integer i,j,n,m
    real, dimension(:,:), allocatable :: b

    n = 100
    m = 100

    allocate (b(n,m))

    do i = 1, n
        do j = 1, m
            b(i,j) = i*j
        end do
    end do

    do i = 2, n
        !$omp parallel do
        do j =2, m
            b(i,j)=b(i-1,j-1)
        end do
        !$omp end parallel do
    end do

    deallocate(b)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A kernel with two level parallelizable loop with reduction:
!if reduction(+:sum) is missing, there is race condition.
!Data race pairs: we allow multiple pairs to preserve the pattern.
!  sum@37"13 vs. sum@37:13
!  sum@37:13 vs. sum@37:22

program DRB021_reductionmissing_orig_yes
    use omp_lib
    implicit none

    integer :: i, j, len
    real :: temp, getSum
    real, dimension (:,:), allocatable :: u

    len = 100
    getSum = 0.0

    allocate (u(len, len))

    do i = 1, len
        do j = 1, len
            u(i,j) = 0.5
        end do
    end do

    !$omp parallel do private(temp, i, j)
    do i = 1, len
        do j = 1, len
            temp = u(i,j)
            getSum = getSum + temp * temp
        end do
    end do
    !$omp end parallel do

    print*,"sum =", getSum
    deallocate(u)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Data race pair: a[i]@49:9 vs. a[0]@49:16


program DRB040_truedepsingleelement_var_yes
    use omp_lib
    implicit none

    integer :: len, i, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    integer, dimension(:), allocatable :: a

    len = 1000

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (a(len))

    a(1) = 2

    !$omp parallel do
    do i = 1, len
        a(i) = a(i)+a(1)
    end do
    !$omp end parallel do

    print 100, a(0)
    100 format ('a(0) =',i3)

    deallocate(args,a)
end program

program intent_arg
  implicit none
!$CVL $input
  integer max
  integer n, i, k
!$CVL $assume(0 .LE. max .AND. max .LE. 10);
  n = 0
  do i=1,max 
    call incr(n)
  end do
!$CVL $assert(n .EQ. 0);
end program intent_arg

subroutine incr(i)
  integer, intent(out) :: i
  i = -1;
  i = i + 1
end subroutine incr

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Missing ordered directive causes data race pairs var@24:9 and var24:18.

program DRB156_missingordered_orig_gpu_yes
    use omp_lib
    implicit none

    integer :: var(100)
    integer :: i

    do i = 1, 100
        var(i) = 1
    end do

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do
    do i = 2, 100
        var(i) = var(i-1)+1
    end do
    !$omp end teams distribute parallel do
    !$omp end target

    print*,var(100)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Taken from OpenMP Examples 5.0, example tasking.12.c
!The created task will access different instances of the variable x if the task is not merged,
!as x is firstprivate, but it will access the same variable x if the task is merged. It can
!Data Race Pairs, x@22:5 and x@22:9
!print two different values for x depending on the decisions taken by the implementation.

program DRB129_mergeable_taskwait_orig_yes
    use omp_lib
    implicit none

    integer :: x
    x = 2

    !$omp task mergeable
    x = x+1
    !$omp end task

    print 100, x
    100 format ('x =',3i8)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

! * Cover the implicitly determined rule: In an orphaned task generating construct,
! * formal arguments passed by reference are firstprivate.
! * This requires OpenMP 4.5 to work.
! * Earlier OpenMP does not allow a reference type for a variable within firstprivate().
! * No data race pairs.


module DRB100
    implicit none
    integer, dimension(:), allocatable :: a
contains
    subroutine gen_task(i)
        use omp_lib
        implicit none
        integer :: i
        !$omp task
        a(i) = i+1
        !$omp end task
    end subroutine
end module

program DRB100_task_reference_orig_no
    use omp_lib
    use DRB100
    implicit none

    integer :: i
    allocate (a(100))

    !$omp parallel
        !$omp single
        do i = 1, 100
            call gen_task(i)
        end do
        !$omp end single
    !$omp end parallel

    do i = 1, 100
        if (a(i) /= i+1) then
            print*,'warning: a(',i,') =',a(i),' not expected',i+1
        end if
!        print*,a(i),i+1
    end do
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Referred from worksharing_critical.1.f
!A single thread executes the one and only section in the sections region, and executes the
!critical region. The same thread encounters the nested parallel region, creates a new team
!of threads, and becomes the master of the new team. One of the threads in the new team enters
!the single region and increments i by 1. At the end of this example i is equal to 2.

program DRB139_worksharingcritical_orig_no
    use omp_lib
    implicit none

    integer :: i
    i = 1

    !$OMP PARALLEL SECTIONS
    !$OMP SECTION
        !$OMP CRITICAL (NAME)
            !$OMP PARALLEL
                !$OMP SINGLE
                i = i + 1
                !$OMP END SINGLE
            !$OMP END PARALLEL
        !$OMP END CRITICAL (NAME)
    !$OMP END PARALLEL SECTIONS

    print 100,i
    100 format ("i = ", 3i8)
end program

c-----------------------------------------------------------------------
      subroutine local_solves_fdm(u,v)
c
c     Given an input vector v, this returns the additive Schwarz solution
c
c                       -1
c                  u = M   v
c
c                      T     -1  
c     where M = sum ( R_i A_i    R_i )
c                i
c
c     The R_i's are simply index_set restriction operators.
c
c     The local solves are performed with the fast diagonalization method.
c
      include 'SIZE'
      include 'INPUT'
      include 'DOMAIN'
      include 'PARALLEL'
c
      include 'TSTEP'
      include 'CTIMER'
c
      real u(lx2,ly2,lz2,lelv),v(lx2,ly2,lz2,lelv)
      common /scrpre/ v1(lx1,ly1,lz1,lelv)
     $               ,w1(lx1,ly1,lz1),w2(lx1,ly1,lz1)
      common /scrover/ ar(lelv)

      parameter(lxx=lx1*lx1, levb=lelv+lbelv)
      common /fastd/  df(lx1*ly1*lz1,levb)
     $             ,  sr(lxx*2,levb),ss(lxx*2,levb),st(lxx*2,levb)
      integer e,eb,eoff

c
      if (icalld.eq.0) tsolv=0.0
      icalld=icalld+1
      nsolv=icalld
c
      ntot1 = lx1*ly1*lz1*nelv
      ntot2 = lx2*ly2*lz2*nelv
c
c     Fill interiors
      iz1 = 0
      if (if3d) iz1=1
      call rzero(v1,ntot1)
      do e=1,nelv
         do iz=1,lz2
         do iy=1,ly2
         do ix=1,lx2
            v1(ix+1,iy+1,iz+iz1,e) = v(ix,iy,iz,e)
         enddo
         enddo
         enddo
      enddo
      call dface_ext    (v1)
      call dssum        (v1,lx1,ly1,lz1)
      call dface_add1si (v1,-1.)
c
c     Now solve each subdomain problem:
c
      etime1=dnekclock()

      eoff  = 0
      if (ifield.gt.1) eoff  = nelv

      do e = 1,nelv
         eb = e + eoff
         call fastdm1(v1(1,1,1,e),df(1,eb)
     $                           ,sr(1,eb),ss(1,eb),st(1,eb),w1,w2)
      enddo
      tsolv=tsolv+dnekclock()-etime1
c
c     Exchange/add elemental solutions
c
      call s_face_to_int (v1,-1.)
      call dssum         (v1,lx1,ly1,lz1)
      call s_face_to_int (v1, 1.)
      if(param(42).eq.0) call do_weight_op(v1)
c
c     Map back to pressure grid (extract interior values)
c
      do e=1,nelv
         do iz=1,lz2
         do iy=1,ly2
         do ix=1,lx2
            u(ix,iy,iz,e) = v1(ix+1,iy+1,iz+iz1,e)
         enddo
         enddo
         enddo
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine fastdm1(r,df,sr,ss,st,w1,w2)
c
c     Fast diagonalization solver for FEM on mesh 1
c
      include 'SIZE'
      parameter (lxx=lx1*lx1,lxyz=lx1*ly1*lz1)

      real r(1),df(1),sr(lxx,2),ss(lxx,2),st(lxx,2),w1(1),w2(1)
c
c
c      T
c     S  r
      call tensr3 (w1,lx1,r ,lx1,sr(1,2),ss(1,1),st(1,1),w2)
c
c     
c      -1 T
c     D  S  r
c
      call col2   (w1,df,lxyz)
c
c
c        -1 T
c     S D  S  r
c
      call tensr3 (r ,lx1,w1,lx1,sr(1,1),ss(1,2),st(1,2),w2)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine tensr3(v,nv,u,nu,A,Bt,Ct,w)
C
C     -  Tensor product application of v = (C x B x A) u
C        NOTE -- the transpose of B & C must be input, rather than B & C.
C
C     -  scratch arrays: w(nu*nu*nv)
C
C
      include 'SIZE'
      include 'INPUT'
      real v(nv,nv,nv),u(nu,nu,nu)
      real A(1),Bt(1),Ct(1)
      real w(1)

      if (nu.gt.nv) then
         write(6,*) nid,nu,nv,' ERROR in tensr3. Contact P.Fischer.'
         write(6,*) nid,nu,nv,' Memory problem.'
         call exitt
      endif

      if (if3d) then
         nuv = nu*nv
         nvv = nv*nv
         call mxm(A,nv,u,nu,v,nu*nu)
         k=1
         l=1
         do iz=1,nu
            call mxm(v(k,1,1),nv,Bt,nu,w(l),nv)
            k=k+nuv
            l=l+nvv
         enddo
         call mxm(w,nvv,Ct,nu,v,nv)
      else
         call mxm(A,nv,u,nu,w,nu)
         call mxm(w,nv,Bt,nu,v,nv)
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine s_face_to_int(x,c)
c
c     Scale face and add to interior of element     
c
      include 'SIZE'
      include 'INPUT'
      real x(lx1,ly1,lz1,1)
c
      do ie=1,nelv
c
        if (if3d) then
c
          do iz=2,lz1-1
          do ix=2,lx1-1
            x(ix,2    ,iz,ie) = c*x(ix,1  ,iz,ie) + x(ix,2    ,iz,ie)
            x(ix,ly1-1,iz,ie) = c*x(ix,ly1,iz,ie) + x(ix,ly1-1,iz,ie)
          enddo
          enddo
c
          do iz=2,lz1-1
          do iy=2,ly1-1
            x(2    ,iy,iz,ie) = c*x(1  ,iy,iz,ie) + x(2    ,iy,iz,ie)
            x(lx1-1,iy,iz,ie) = c*x(lx1,iy,iz,ie) + x(lx1-1,iy,iz,ie)
          enddo
          enddo
c
          do iy=2,ly1-1
          do ix=2,lx1-1
            x(ix,iy,2    ,ie) = c*x(ix,iy,1  ,ie) + x(ix,iy,2    ,ie)
            x(ix,iy,lz1-1,ie) = c*x(ix,iy,lz1,ie) + x(ix,iy,lz1-1,ie)
          enddo
          enddo
c
        else
c         2D
          do ix=2,lx1-1
            x(ix,2    ,1,ie) = c*x(ix,1  ,1,ie) + x(ix,2    ,1,ie)
            x(ix,ly1-1,1,ie) = c*x(ix,ly1,1,ie) + x(ix,ly1-1,1,ie)
          enddo
          do iy=2,ly1-1
            x(2    ,iy,1,ie) = c*x(1  ,iy,1,ie) + x(2    ,iy,1,ie)
            x(lx1-1,iy,1,ie) = c*x(lx1,iy,1,ie) + x(lx1-1,iy,1,ie)
          enddo
        endif
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine dface_ext(x)
c     Extend interior to face of element     
c
      include 'SIZE'
      include 'INPUT'
      real x(lx1,ly1,lz1,1)
c
      do ie=1,nelv
c
         if (if3d) then
c
          do iz=2,lz1-1
          do ix=2,lx1-1
            x(ix,1  ,iz,ie) = x(ix,2    ,iz,ie)
            x(ix,ly1,iz,ie) = x(ix,ly1-1,iz,ie)
          enddo
          enddo
c
          do iz=2,lz1-1
          do iy=2,ly1-1
            x(1  ,iy,iz,ie) = x(2    ,iy,iz,ie)
            x(lx1,iy,iz,ie) = x(lx1-1,iy,iz,ie)
          enddo
          enddo
c
          do iy=2,ly1-1
          do ix=2,lx1-1
            x(ix,iy,1  ,ie) = x(ix,iy,2    ,ie)
            x(ix,iy,lz1,ie) = x(ix,iy,lz1-1,ie)
          enddo
          enddo
c
        else
c
          do ix=2,lx1-1
            x(ix,1  ,1,ie) = x(ix,2    ,1,ie)
            x(ix,ly1,1,ie) = x(ix,ly1-1,1,ie)
          enddo
          do iy=2,ly1-1
            x(1  ,iy,1,ie) = x(2    ,iy,1,ie)
            x(lx1,iy,1,ie) = x(lx1-1,iy,1,ie)
          enddo
c
        endif
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine dface_add1si(x,c)
c     Scale interior and add to face of element     
c
      include 'SIZE'
      include 'INPUT'
      real x(lx1,ly1,lz1,1)
c
      do ie=1,nelv
c
        if (if3d) then
c
          do iz=2,lz1-1
          do ix=2,lx1-1
            x(ix,1  ,iz,ie) = x(ix,1  ,iz,ie) + c*x(ix,2    ,iz,ie)
            x(ix,ly1,iz,ie) = x(ix,ly1,iz,ie) + c*x(ix,ly1-1,iz,ie)
          enddo
          enddo
c
          do iz=2,lz1-1
          do iy=2,ly1-1
            x(1  ,iy,iz,ie) = x(1  ,iy,iz,ie) + c*x(2    ,iy,iz,ie)
            x(lx1,iy,iz,ie) = x(lx1,iy,iz,ie) + c*x(lx1-1,iy,iz,ie)
          enddo
          enddo
c
          do iy=2,ly1-1
          do ix=2,lx1-1
            x(ix,iy,1  ,ie) = x(ix,iy,1  ,ie) + c*x(ix,iy,2    ,ie)
            x(ix,iy,lz1,ie) = x(ix,iy,lz1,ie) + c*x(ix,iy,lz1-1,ie)
          enddo
          enddo
c
        else
c
c         2D
c
          do ix=2,lx1-1
            x(ix,1  ,1,ie) = x(ix,1  ,1,ie) + c*x(ix,2    ,1,ie)
            x(ix,ly1,1,ie) = x(ix,ly1,1,ie) + c*x(ix,ly1-1,1,ie)
          enddo
          do iy=2,ly1-1
            x(1  ,iy,1,ie) = x(1  ,iy,1,ie) + c*x(2    ,iy,1,ie)
            x(lx1,iy,1,ie) = x(lx1,iy,1,ie) + c*x(lx1-1,iy,1,ie)
          enddo
c
        endif
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine init_weight_op

      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      parameter(levb=lelv+lbelv)
      common /swaplengths/ l(lx1,ly1,lz1,lelv)
      common /weightop/ w(lx2,lz2,2,3,levb)
      real l
      real w
      integer e,e0,eb

      e0  = 0
      if (ifield.gt.1) e0 = nelv

      n=lx2+1
      if (if3d) then
         do e=1,nelv
            call rzero(l(1,1,1,e),lx1*ly1*lz1)
            do k=2,n
               do j=2,n
                  l(2,j,k,e)=1
                  l(n,j,k,e)=1
               enddo
            enddo
            do k=2,n
               do i=2,n
                  l(i,2,k,e)=1
                  l(i,n,k,e)=1
               enddo
            enddo
            do j=2,n
               do i=2,n
                  l(i,j,2,e)=1
                  l(i,j,n,e)=1
               enddo
            enddo
         enddo
      else
         do e=1,nelv
            call rzero(l(1,1,1,e),lx1*ly1*lz1)
            do j=2,n
               l(2,j,1,e)=1
               l(n,j,1,e)=1
            enddo
            do i=2,n
               l(i,2,1,e)=1
               l(i,n,1,e)=1
            enddo
         enddo
      endif
      
      call dface_ext(l)
      call dssum(l,lx1,ly1,lz1)
      call dface_add1si(l,-1.)
      call s_face_to_int(l,1.)
c     l now holds the count matrix C on the outer pressure nodes
      if (if3d) then
         do e=1,nelv
            eb = e0+e
            do k=1,lz2
               do j=1,ly2
                  w(j,k,1,1,eb)=1.0/l(2,j+1,k+1,e)
                  w(j,k,2,1,eb)=1.0/l(n,j+1,k+1,e)
               enddo
            enddo
            do k=1,lz2
               do i=1,lx2
                  w(i,k,1,2,eb)=1.0/l(i+1,2,k+1,e)
                  w(i,k,2,2,eb)=1.0/l(i+1,n,k+1,e)
               enddo
            enddo
            do j=1,ly2
               do i=1,lx2
                  w(i,j,1,3,eb)=1.0/l(i+1,j+1,2,e)
                  w(i,j,2,3,eb)=1.0/l(i+1,j+1,n,e)
               enddo
            enddo
         enddo
      else
         do e=1,nelv
            eb = e0+e
            do j=1,ly2
               w(j,1,1,1,eb)=1.0/l(2,j+1,1,e)
               w(j,1,2,1,eb)=1.0/l(n,j+1,1,e)
            enddo
            do i=1,lx2
               w(i,1,1,2,eb)=1.0/l(i+1,2,1,e)
               w(i,1,2,2,eb)=1.0/l(i+1,n,1,e)
            enddo
         enddo
      endif
      end
c-----------------------------------------------------------------------
      subroutine do_weight_op(x)
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      parameter(levb=lelv+lbelv)
      common /weightop/ w(lx2,lz2,2,3,levb)
      real w

      real x(0:lx1-1,0:ly1-1,0:lz1-1,1)
      integer e,e0,eb

      e0  = 0
      if (ifield.gt.1) e0 = nelv

      if (if3d) then
         do e=1,nelv
            eb = e0 + e
            do k=1,lz2
               do j=1,ly2
                  x(  1,j,k,e)=w(j,k,1,1,eb)*x(  1,j,k,e)
                  x(lx2,j,k,e)=w(j,k,2,1,eb)*x(lx2,j,k,e)
               enddo
            enddo
            do k=1,lz2
               do i=2,lx2-1
                  x(i,  1,k,e)=w(i,k,1,2,eb)*x(i,  1,k,e)
                  x(i,ly2,k,e)=w(i,k,2,2,eb)*x(i,ly2,k,e)
               enddo
            enddo
            do j=2,ly2-1
               do i=2,lx2-1
                  x(i,j,  1,e)=w(i,j,1,3,eb)*x(i,j,  1,e)
                  x(i,j,lz2,e)=w(i,j,2,3,eb)*x(i,j,lz2,e)
               enddo
            enddo
         enddo
      else
         do e=1,nelv
            eb = e0 + e
            do j=1,ly2
               x(  1,j,0,e)=w(j,1,1,1,eb)*x(  1,j,0,e)
               x(lx2,j,0,e)=w(j,1,2,1,eb)*x(lx2,j,0,e)
            enddo
            do i=2,lx2-1
               x(i,  1,0,e)=w(i,1,1,2,eb)*x(i,  1,0,e)
               x(i,ly2,0,e)=w(i,1,2,2,eb)*x(i,ly2,0,e)
            enddo
         enddo
      endif
      end

      function dnekgflpops()
      real*4 rtime,ptime,mflops
      integer*8 flpops

      call getflops_papi(flpops,mflops)
      dnekgflpops = flpops

      return
      end
c-----------------------------------------------------------------------
      function dnekgflops()
      real*4 mflops
      integer*8 flpops

      call getflops_papi(flpops,mflops)
      dnekgflops = mflops/1e3

      return
      end
c-----------------------------------------------------------------------
      subroutine getflops_papi(flpops,mflops)
#ifdef PAPI
      include 'f77papi.h'
      real*4 rtime,ptime,mflops
      integer*8 flpops

      call papif_flops(rtime,ptime,flpops,mflops,ierr)
      if(ierr.ne.0) then
        flpops = -1
        mflops = -1
      endif
#else
      flpops = -1
      mflops = -0
#endif
 
      return
      end 

program modulespec
  implicit none
!$CVL $input 
  integer :: inval
!$CVL $output
  integer :: outval
  integer :: i, n ,m
!$CVL $assume(0 .LE. inval .AND. inval .LE. 10);
  m = inval
  n = inval/2
  do i=1,n
    m = m - 2
  end do
  outval = m
end program modulespec

      subroutine mxm44_0(A,N1,B,N2,C,N3)
      real a(n1,n2),b(n2,n3),c(n1,n3),s

      do j=1,n3
         do i=1,n1
            c(i,j) = 0.0
            do k=1,n2
               c(i,j) = c(i,j) + a(i,k)*b(k,j)
            enddo
         enddo
      enddo

      return
      end

!*********************************************************************
!* Illinois Open Source License                                      *
!*                                                                   *
!* University of Illinois/NCSA                                       * 
!* Open Source License                                               *
!*                                                                   *
!* Copyright@2008, University of Illinois.  All rights reserved.     *
!*                                                                   *
!*  Developed by:                                                    *
!*                                                                   *
!*     Center for Simulation of Advanced Rockets                     *
!*                                                                   *
!*     University of Illinois                                        *
!*                                                                   *
!*     www.csar.uiuc.edu                                             *
!*                                                                   *
!* Permission is hereby granted, free of charge, to any person       *
!* obtaining a copy of this software and associated documentation    *
!* files (the "Software"), to deal with the Software without         *
!* restriction, including without limitation the rights to use,      *
!* copy, modify, merge, publish, distribute, sublicense, and/or      *
!* sell copies of the Software, and to permit persons to whom the    *
!* Software is furnished to do so, subject to the following          *
!* conditions:                                                       *
!*                                                                   *
!*                                                                   *
!* @ Redistributions of source code must retain the above copyright  * 
!*   notice, this list of conditions and the following disclaimers.  *
!*                                                                   * 
!* @ Redistributions in binary form must reproduce the above         *
!*   copyright notice, this list of conditions and the following     *
!*   disclaimers in the documentation and/or other materials         *
!*   provided with the distribution.                                 *
!*                                                                   *
!* @ Neither the names of the Center for Simulation of Advanced      *
!*   Rockets, the University of Illinois, nor the names of its       *
!*   contributors may be used to endorse or promote products derived * 
!*   from this Software without specific prior written permission.   *
!*                                                                   *
!* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,   *
!* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES   *
!* OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND          *
!* NONINFRINGEMENT.  IN NO EVENT SHALL THE CONTRIBUTORS OR           *
!* COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       * 
!* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   *
!* ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE    *
!* USE OR OTHER DEALINGS WITH THE SOFTWARE.                          *
!*********************************************************************
!* Please acknowledge The University of Illinois Center for          *
!* Simulation of Advanced Rockets in works and publications          *
!* resulting from this software or its derivatives.                  *
!*********************************************************************
!******************************************************************************
!
! Purpose: Collect relations for static and total speed of sound for perfect
!   gases.
!
! Description: None.
!
! Notes: None.
!
!******************************************************************************
!
! $Id: MixtPerf.f,v 1.5 2015/07/17 15:58:14 mrugeshs Exp $
!
! Copyright: (c) 2002 by the University of Illinois
!
!******************************************************************************

      FUNCTION MixtJWL_Enthalpy(DE,PRES,VEL1,VEL2,VEL3,EN)
      IMPLICIT NONE
      REAL DE,PRES,VEL1,VEL2,VEL3,EN
      REAL MixtJWL_Enthalpy
      MixtJWL_Enthalpy = 0.5*(VEL1*VEL1+VEL2*VEL2+VEL3*VEL3)
     >                  + EN+PRES/DE
      END
      FUNCTION MixtPerf_C_Co2GUVW(Co2,G,U,V,W)
      IMPLICIT NONE
      REAL Co2,G,U,V,W ! INTENT(IN) W
      REAL MixtPerf_C_Co2GUVW
      MixtPerf_C_Co2GUVW = SQRT(Co2 - 0.5*(G - 1.0)*(U*U + V*V + W*W))
      END

      FUNCTION MixtPerf_C_DGP(D,G,P)
      IMPLICIT NONE
      REAL D,G,P! INTENT(IN) 
      REAL MixtPerf_C_DGP
      MixtPerf_C_DGP = SQRT(G*P/D)
      END

      FUNCTION MixtPerf_C_GHoVm2(G,Ho,Vm2)
      IMPLICIT NONE
      REAL G,Ho,Vm2! INTENT(IN) 
      REAL MixtPerf_C_GHoVm2
      MixtPerf_C_GHoVm2 = SQRT((G - 1.0)*(Ho - 0.5*Vm2))
      END

      FUNCTION MixtPerf_C_GRT(G,R,T)
      IMPLICIT NONE
      REAL G,R,T! INTENT(IN) 
      REAL MixtPerf_C_GRT
      MixtPerf_C_GRT = SQRT(G*R*T)
      END

      FUNCTION MixtPerf_C2_GRT(G,R,T)
      IMPLICIT NONE
      REAL G,R,T! INTENT(IN) 
      REAL MixtPerf_C2_GRT
      MixtPerf_C2_GRT = G*R*T
      END

      FUNCTION MixtPerf_Co2_CGUVW(C,G,U,V,W)
      IMPLICIT NONE
      REAL C,G,U,V,W! INTENT(IN) 
      REAL MixtPerf_Co2_CGUVW
      MixtPerf_Co2_CGUVW = C*C + 0.5*(G - 1.0)*(U*U + V*V + W*W)
      END

      FUNCTION MixtPerf_Cv_CpR(Cp,R)
      IMPLICIT NONE
      REAL Cp,R! INTENT(IN) 
      REAL MixtPerf_Cv_CpR
      MixtPerf_Cv_CpR = Cp - R  
      END

      FUNCTION MixtPerf_Cp_CvR(Cv,R)
      IMPLICIT NONE
      REAL Cv,R! INTENT(IN) 
      REAL MixtPerf_Cp_CvR
      MixtPerf_Cp_CvR = Cv + R  
      END

      FUNCTION MixtPerf_D_CGP(C,G,P)
      IMPLICIT NONE
      REAL C,G,P! INTENT(IN) 
      REAL MixtPerf_D_CGP
      MixtPerf_D_CGP = G*P/(C*C)
      END

      FUNCTION MixtPerf_D_DoGMa(D,G,Ma)
      IMPLICIT NONE
      REAL D,G,Ma! INTENT(IN) 
      REAL MixtPerf_D_DoGMa
      MixtPerf_D_DoGMa = D/ (1.0 + 0.5*(G-1.0)*Ma*Ma)**(1.0/(G-1.0))
      END

      FUNCTION MixtPerf_D_PRT(P,R,T)
      IMPLICIT NONE
      REAL P,R,T ! INTENT(IN) 
      REAL MixtPerf_D_PRT
      MixtPerf_D_PRT = P/(R*T)
      END

      FUNCTION MixtPerf_Eo_DGPUVW(D,G,P,U,V,W)
      IMPLICIT NONE
      REAL D,G,P,U,V,W! INTENT(IN) 
      REAL MixtPerf_Eo_DGPUVW
      MixtPerf_Eo_DGPUVW = P/(D*(G - 1.0)) + 0.5*(U*U + V*V + W*W)
      END

      FUNCTION MixtPerf_Eo_DGPVm(D,G,P,Vm)
      IMPLICIT NONE
      REAL D,G,P,Vm! INTENT(IN) 
      REAL MixtPerf_Eo_DGPVm
      MixtPerf_Eo_DGPVm = P/(D*(G - 1.0)) + 0.5*Vm*Vm
      END

      FUNCTION MixtPerf_Eo_GRTUVW(G,R,T,U,V,W)
      IMPLICIT NONE
      REAL  G,R,T,U,V,W
      REAL  MixtPerf_Eo_GRTUVW
      MixtPerf_Eo_GRTUVW = R*T/(G - 1.0) + 0.5*(U*U + V*V + W*W)
      END

      FUNCTION MixtPerf_G_CpR(Cp,R)
      IMPLICIT NONE
      REAL  Cp,R
      REAL  MixtPerf_G_CpR
      MixtPerf_G_CpR = Cp/(Cp - R)
      END

      FUNCTION MixtPerf_Ho_CpTUVW(Cp,T,U,V,W)
      IMPLICIT NONE
      REAL  Cp,T,U,V,W
      REAL  MixtPerf_Ho_CpTUVW
      MixtPerf_Ho_CpTUVW = Cp*T + 0.5*(U*U + V*V + W*W)
      END

      FUNCTION MixtPerf_M_R(R)
      IMPLICIT NONE
      REAL  R
      REAL  MixtPerf_M_R
      MixtPerf_M_R = 8314.3/R
      END

      FUNCTION MixtPerf_P_DEoGVm2(D,Eo,G,Vm2)
      IMPLICIT NONE
      REAL  D,Eo,G,Vm2
      REAL  MixtPerf_P_DEoGVm2
      MixtPerf_P_DEoGVm2 = (G - 1.0)*D*(Eo - 0.5*Vm2)
      END

      FUNCTION MixtPerf_P_DRT(D,R,T)
      IMPLICIT NONE
      REAL  D,R,T
      REAL  MixtPerf_P_DRT
      MixtPerf_P_DRT = D*R*T
      END

      FUNCTION MixtPerf_P_GMaPo(G,Ma,Po)
      IMPLICIT NONE
      REAL  G,Ma,Po
      REAL  MixtPerf_P_GMaPo
      MixtPerf_P_GMaPo = Po/((1.0 + 0.5*(G - 1.0)*Ma*Ma)**(G/(G - 1.0)))
      END

      FUNCTION MixtPerf_P_DDoGPo(D,Do,G,Po)
      IMPLICIT NONE
      REAL  D,Do,G,Po
      REAL  MixtPerf_P_DDoGPo
      MixtPerf_P_DDoGPo = Po*(D/Do)**G
      END

      FUNCTION MixtPerf_P_GPoTTo(G,Po,T,To)
      IMPLICIT NONE
      REAL  G,Po,T,To
      REAL  MixtPerf_P_GPoTTo
      MixtPerf_P_GPoTTo = Po*(T/To)**(G/(G - 1.0))
      END

      FUNCTION MixtPerf_Po_GPTTo(G,P,T,To)
      IMPLICIT NONE
      REAL  G,P,T,To
      REAL  MixtPerf_Po_GPTTo
      MixtPerf_Po_GPTTo = P*(To/T)**(G/(G - 1.0))
      END

      FUNCTION MixtPerf_Po_CGPUVW(C,G,P,U,V,W)
      IMPLICIT NONE
      REAL  C,G,P,U,V,W
      REAL  MixtPerf_Po_CGPUVW
      MixtPerf_Po_CGPUVW =
     >        P*(1.0 + 0.5*(G - 1.0)*(U*U+V*V+W*W)/(C*C))**(G/(G - 1.0))
      END

      FUNCTION MixtPerf_R_CpG(Cp,G)
      IMPLICIT NONE
      REAL  Cp,G
      REAL  MixtPerf_R_CpG
      MixtPerf_R_CpG = Cp - Cp/G  
      END

      FUNCTION MixtPerf_R_M(M,whatev)
      IMPLICIT NONE
      REAL  M,whatev
      REAL  MixtPerf_R_M
      MixtPerf_R_M = 8314.3/M
      END

      FUNCTION MixtPerf_T_CGR(C,G,R)
      IMPLICIT NONE
      REAL  C,G,R
      REAL  MixtPerf_T_CGR
      MixtPerf_T_CGR = C*C/(G*R)
      END

      FUNCTION MixtPerf_T_CpHoVm2(Cp,Ho,Vm2)
      IMPLICIT NONE
      REAL  Cp,Ho,Vm2
      REAL  MixtPerf_T_CpHoVm2
      MixtPerf_T_CpHoVm2 = (Ho-0.5*Vm2)/Cp
      END

      FUNCTION MixtPerf_T_CvEoVm2(Cv,Eo,Vm2)
      IMPLICIT NONE
      REAL  Cv,Eo,Vm2
      REAL  MixtPerf_T_CvEoVm2
      MixtPerf_T_CvEoVm2 = (Eo-0.5*Vm2)/Cv
      END

      FUNCTION MixtPerf_T_DPR(D,P,R)
      IMPLICIT NONE
      REAL  D,P,R
      REAL  MixtPerf_T_DPR
      MixtPerf_T_DPR = P/(D*R)
      END

      FUNCTION MixtPerf_HM_T_DGMP(D,G,M,P)
      IMPLICIT NONE
      REAL  D,G,M,P
      REAL  MixtPerf_HM_T_DGMP
      MixtPerf_HM_T_DGMP = (G*M*M*P + 1.0)/D 
      END

      FUNCTION MixtPerf_T_GMaTo(G,Ma,To)
      IMPLICIT NONE
      REAL  G,Ma,To
      REAL  MixtPerf_T_GMaTo
      MixtPerf_T_GMaTo = To/(1.0 + 0.5*(G - 1.0)*Ma*Ma)
      END

      FUNCTION MixtPerf_To_CpTUVW(Cp,T,U,V,W)
      IMPLICIT NONE
      REAL  Cp,T,U,V,W
      REAL  MixtPerf_To_CpTUVW
      MixtPerf_To_CpTUVW = T + 0.5*(U*U + V*V + W*W)/Cp
      END

      FUNCTION MixtPerf_Vm_C2Co2G(C2,Co2,G)
      IMPLICIT NONE
      REAL  C2,Co2,G
      REAL  MixtPerf_Vm_C2Co2G
      IF ( Co2 .gt. C2 ) THEN  
         MixtPerf_Vm_C2Co2G = SQRT(2.0/(G - 1.0)*(Co2 - C2))
      ELSE 
         MixtPerf_Vm_C2Co2G = 0.0
      END IF ! Co2
      END

! JH060614 stitched bloodily into cmt-nek. Before that,
!******************************************************************************
!
! RCS Revision history:
!
! $Log: MixtPerf.f,v $
! Revision 1.5  2015/07/17 15:58:14  mrugeshs
!  - MS making the code fortran 77 compatible -- not there yet. regression
!       testing going on
!
! Revision 1.4  2015/07/17 15:21:36  jhackl
! JH071715 more fortran 77 goodness
!
! Revision 1.3  2015/03/03 21:09:25  jhackl
! compiles gfortran 4.8.2
!
! Revision 1.2  2015/02/27 22:13:27  mrugeshs
!  - MS022715 - Added function to compute Cp when Cv and R are known
!
! Revision 1.1  2014/06/30 16:42:11  mrugeshs
! - Add CMT souce code
!
! Revision 1.1.1.1  2014/05/05 21:47:47  tmish
! Initial checkin for rocflu macro.
!
! Revision 1.3  2008/12/06 08:43:31  mtcampbe
! Updated license.
!
! Revision 1.2  2008/11/19 22:16:47  mtcampbe
! Added Illinois Open Source License/Copyright
!
! Revision 1.1  2007/04/09 18:48:32  haselbac
! Initial revision after split from RocfloMP
!
! Revision 1.1  2007/04/09 17:59:25  haselbac
! Initial revision after split from RocfloMP
!
! Revision 1.1  2004/12/01 16:48:47  haselbac
! Initial revision after changing case
!
! Revision 1.2  2002/05/28 13:44:44  haselbac
! Added new functions
!
! Revision 1.1  2002/05/04 16:16:52  haselbac
! Initial revision
!
!******************************************************************************
!NTN-----------JWL
      FUNCTION MixtJWL_SO(DE,EN,pres,AA,BB,R1,R2,MW,MA,MB,OM,rho0)
      IMPLICIT NONE
      REAL DE,EN,pres,AA,BB,R1,R2,MW,MA,MB,OM,rho0
      REAL MixtJWL_SO
      MixtJWL_SO =SQRT((AA*(R1*(rho0/DE)/DE-OM/DE-OM/(R1*rho0)-
     >                MW/(R1*rho0/DE))+
     >        MA*pres/(DE*DE)*(1.-OM/(R1*rho0/DE)))*exp(-R1*rho0/DE)+
     >        (BB*(R2*(rho0/DE)/DE-OM/DE-OM/(R2*rho0)-MW/(R2*rho0/DE))+
     >        MB*pres/(DE*DE)*(1.-OM/(R2*rho0/DE)))*exp(-R2*rho0/DE)+
     >        OM*(EN+pres/DE)+MW*DE*EN)
      END

      FUNCTION MixtJWL_PR(DE,EN,AA,BB,R1,R2,OM,rho0)
      IMPLICIT NONE
      REAL DE,EN,AA,BB,R1,R2,OM,rho0
      REAL MixtJWL_PR
      MixtJWL_PR =AA*(1.-(OM*DE)/(R1*rho0))*exp(-R1*rho0/DE)+
     >            BB*(1.-(OM*DE)/(R2*rho0))*exp(-R2*rho0/DE)+OM*DE*EN
      END

      FUNCTION MixtJWL_TE(cv,DE,EN,AA,BB,R1,R2,rho0)
      IMPLICIT NONE
      REAL cv,DE,EN,AA,R1,R2,rho0,BB
      REAL MixtJWL_TE
      MixtJWL_TE = 1./cv*(EN-AA/(R1*rho0)*exp(-R1*rho0/DE)-
     >             BB/(R2*rho0)*exp(-R2*rho0/DE))
      END
!Temperature as a function of pressure and density
!      FUNCTION MixtJWL_TE(cv,DE,pres,AA,BB,R1,R2,rho0,OM)  
!      IMPLICIT NONE
!      REAL cv,DE,pres,AA,BB,R1,R2,rho0,OM  
!      REAL MixtJWL_TE 
!      MixtJWL_TE=1./OM/cv/DE*(pres-AA*exp(-R1*rho0/DE)-
!     >           BB*exp(-R2*rho0/DE))
!      END
      FUNCTION MixtJWL_I_ENE(DE,PRES,AA,BB,R1,R2,rho0,OM)
      IMPLICIT NONE
      REAL DE,PRES,AA,BB,R1,R2,rho0,OM
      REAL  MixtJWL_I_ENE
      MixtJWL_I_ENE =(pres-(AA*(1.-OM/(R1*rho0/DE))
     > *exp(-R1*rho0/DE)+BB*(1.-OM/(R2*rho0/DE))
     > *exp(-R2*rho0/DE)))/(OM*DE)
      END

c-----------------------------------------------------------------------
      subroutine mapelpr()
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'SCRCT'
      include 'SOLN'
      include 'TSTEP'
      include 'CTIMER'
c
      logical ifverbm
c
      if (nio.eq.0) then
         write(6,12) 'nelgt/nelgv/lelt:',nelgt,nelgv,lelt
         write(6,12) 'lx1/lx2/lx3/lxd: ',lx1,lx2,lx3,lxd
 12      format(1X,A,4I12)
         write(6,*)
      endif

      etime0 = dnekclock_sync()
      if(nio.eq.0) write(6,'(A)') ' partioning elements to MPI ranks'

      MFIELD=2
      IF (IFFLOW) MFIELD=1
      IF (IFMVBD) MFIELD=0

c     Set up TEMPORARY value for NFIELD - NFLDT
      NFLDT = 1
      IF (IFHEAT) NFLDT = 2 + NPSCAL
c
c     Distributed memory processor mapping
      IF (NP.GT.NELGT) THEN
         IF(NID.EQ.0) THEN
           WRITE(6,1000) NP,NELGT
 1000      FORMAT(2X,'ABORT: Too many processors (',I8
     $          ,') for to few elements (',I12,').'
     $          ,/,2X,'ABORTING IN MAPELPR.')
         ENDIF
         call exitt
      ENDIF

      call set_proc_map()

      if (nelt.gt.lelt) then
         call exitti('nelt > lelt, increase lelt!$',nelt)
      endif

      DO 1200 IFIELD=MFIELD,NFLDT
         IF (IFTMSH(IFIELD)) THEN
            NELG(IFIELD)      = NELGT
         ELSE
            NELG(IFIELD)      = NELGV
         ENDIF
 1200 CONTINUE

C     Output the processor-element map:
      ifverbm=.false.
      if (loglevel .gt. 2) ifverbm=.true.

      if(ifverbm) then
        idum = 1
        if(nid.eq.0) then
           N8 = min(8,nelt)
           write(6 ,1310) node-1,(lglel(ie),ie=1,n8)
           if (NELT.GT.8) write(6 ,1315) (lglel(ie),ie=9,NELT)
           DO inid=1,NP-1
              mtype = inid
              call csend(mtype,idum,4,inid,0)         ! handshake
              call crecv(mtype,inelt,4)               ! nelt of other cpus
              N8 = min(8,inelt)
           ENDDO
 1310      FORMAT(' RANK',I6,' IEG',8I8)
 1315      FORMAT('     ',6X,'    ',8I8)
        else
           mtype = nid
           call crecv(mtype,idum,4)                ! hand-shake
           call csend(mtype,nelt,4,0,0)            ! nelt
           if (loglevel .gt. 2) then
              N8 = min(8,nelt)
              write(6 ,1310) node-1,(lglel(ie),ie=1,n8)
              if (NELT.GT.8) write(6 ,1315) (lglel(ie),ie=9,NELT)
           endif
        endif
      endif

      dtmp = dnekclock_sync() - etime0
      if(nio.eq.0) then
        write(6,*) ' '
        write(6,'(A,g13.5,A,/)')  ' done :: partioning ',dtmp,' sec'
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine outmati(u,m,n,name6)
      integer u(m,n)
      character*6 name6
      common /nekmpi/ nid,np,nekcomm,nekgroup,nekreal
c
c     Print out copies of a global matrix
c
      do mid=0,np-1
        call nekgsync
        if (mid.eq.nid) then
         n20 = min(n,20)
         write(6,1) nid,m,n,name6
   1     format(//,3i6,'  Matrix:',2x,a6,/)
         do i=1,m
            write(6,2) nid,name6,(u(i,j),j=1,n20)
         enddo
   2     format(i3,1x,a6,20i6)
        endif
        call nekgsync
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine get_map

      call get_vert

      return
      end
c-----------------------------------------------------------------------
      subroutine get_vert
c
c     Distribute and assign partitions using the .map file
c
      include 'SIZE'
      include 'TOTAL'

      parameter(mdw=2+2**ldim)
      parameter(ndw=7*lx1*ly1*lz1*lelv/mdw)
      common /scrns/ wk(mdw,ndw)
      integer wk

      common /ivrtx/ vertex ((2**ldim),lelt)
      integer vertex

      integer icalld
      save    icalld
      data    icalld  /0/

      if(icalld.gt.0) return
      icalld = 1

      nv = 2**ldim
      call get_vert_map(vertex,nv,wk,mdw,ndw)

      return
      end
c-----------------------------------------------------------------------
      subroutine get_vert_map(vertex,nlv,wk,mdw,ndw)

      include 'SIZE'
      include 'TOTAL'

      integer vertex(nlv,1)
      integer wk(mdw*ndw)

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      integer ibuf(2)
      integer hrsb

      integer*8 eid8(lelt), vtx8(lelt*2**ldim)
      integer iwork(lelt)
      common /SCRCG/ xyz(ldim*lelt*2**ldim)
      common /ctmp0/ eid8, vtx8, iwork

      integer tt,cnt,nrank,ierr

      integer opt_parrsb(3), opt_parmetis(10)
      logical ifbswap

      integer start

#if !defined(PARRSB) && !defined(PARMETIS)
#if defined(DPROCMAP)
      call exitti('DPROCMAP requires PARRSB or PARMETIS!$',0)
#else
      call read_map(vertex,nlv,wk,mdw,ndw)
      return
#endif      
#endif

#if defined(PARRSB) || defined(PARMETIS)
      neli = nelt
      call get_con(wk,size(wk),neli,nlv)

c fluid elements
      j  = 0
      ii = 0
      cnt= 0
      do i = 1,neli
         if (wk(ii+1) .le. nelgv) then
            j = j + 1
            eid8(j) = wk(ii+1)
            call icopy48(vtx8((j-1)*nlv+1),wk(ii+2),nlv)

            do tt=1,nlv
              xyz(cnt+1)=xc(tt,i)
              xyz(cnt+2)=yc(tt,i)
              if(ldim.eq.3) then
                xyz(cnt+3)=zc(tt,i)
                cnt=cnt+3
              else
                cnt=cnt+2
              endif
            enddo
         endif
         ii = ii + (nlv+1)
      enddo
      neliv = j

      nel = neliv
      call fpartMesh(eid8,vtx8,xyz,lelt,nel,nlv,nekcomm,
     $  meshPartitioner,ierr)
      call err_chk(ierr,'partMesh fluid failed!$')

      nelv = nel
      nelt = nelv
      ierr = 0 
      if (nelv .gt. lelv) ierr = 1
      call err_chk(ierr,'nelv > lelv!$')
 
      do i = 1,nelv
         lglel(i) = eid8(i)
      enddo
      call isort(lglel,iwork,nelv)
      do i = 1,nelv
         call icopy84(vertex(1,i),vtx8((iwork(i)-1)*nlv+1),nlv)
      enddo

      cnt=0
c solid elements
      if (nelgt.ne.nelgv) then
         j  = 0
         ii = 0
         do i = 1,neli
            if (wk(ii+1) .gt. nelgv) then
               j = j + 1
               eid8(j) = wk(ii+1)
               call icopy48(vtx8((j-1)*nlv+1),wk(ii+2),nlv)

               do tt=1,nlv
                 xyz(cnt+1)=xc(tt,i)
                 xyz(cnt+2)=yc(tt,i)
                 if(ldim.eq.3) then
                   xyz(cnt+3)=zc(tt,i)
                   cnt=cnt+3
                 else
                   cnt=cnt+2
                 endif
               enddo
            endif
            ii = ii + (nlv+1)
         enddo
         nelit = j

         nel = nelit
         call fpartMesh(eid8,vtx8,xyz,lelt,nel,nlv,nekcomm,
     $                  meshPartitioner,ierr)
         call err_chk(ierr,'partMesh solid failed!$')

         nelt = nelv + nel
         ierr = 0 
         if (nelt .gt. lelt) ierr = 1
         call err_chk(ierr,'nelt > lelt!$')
    
         do i = 1,nel
            lglel(nelv+i) = eid8(i)
         enddo
         call isort(lglel(nelv+1),iwork,nel) ! sort locally by global element id
         do i = 1,nel
            call icopy84(vertex(1,nelv+i),vtx8((iwork(i)-1)*nlv+1),nlv)
         enddo
      endif

#ifdef DPROCMAP
      do i = 1,nelt
         ieg = lglel(i)
         if (ieg.lt.1 .or. ieg.gt.nelgt) 
     $      call exitti('invalid ieg!$',ieg)
         ibuf(1) = i
         ibuf(2) = nid
         call dProcmapPut(ibuf,2,0,ieg)
      enddo
#else
      call izero(gllnid,nelgt)
      do i = 1,nelt
         ieg = lglel(i)
         gllnid(ieg) = nid
      enddo
      npass = 1 + nelgt/lelt
      k=1
      do ipass = 1,npass
         m = nelgt - k + 1
         m = min(m,lelt)
         if (m.gt.0) call igop(gllnid(k),iwork,'+  ',m)
         k = k+m
      enddo
#endif

#endif

      return
      end
c-----------------------------------------------------------------------
      subroutine get_con(wk,nwk,nelr,nv)

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'

      integer nwk,nelr,nv
      integer wk(nwk)

      logical ifbswap,if_byte_swap_test
      logical ifco2, ifcon

      character*132 confle
      character*1   confle1(132)
      equivalence  (confle,confle1)

      character*132 hdr
      character*5   version
      real*4        test

      integer ierr,nvi
      integer*8 nelgti,nelgvi
      integer*8 offs, offs0

      ierr = 0

      ifco2 = .false.
      ifmpiio = .true.
#ifdef NOMPIIO
      ifmpiio = .false.
#endif

      if (nid.eq.0) then
         lfname = ltrunc(reafle,132) - 4
         call blank (confle,132)
         call chcopy(confle,reafle,lfname)
         call chcopy(confle1(lfname+1),'.con',4)
         inquire(file=confle, exist=ifcon)

         if (.not.ifcon) then
            call chcopy(confle1(lfname+1),'.co2',4)
            inquire(file=confle, exist=ifco2)
         endif

        if(.not.ifcon .and. .not.ifco2) ierr = 1
      endif

      call bcast(ierr,sizeof(ierr))
      if(ierr.ne.0) goto 50

      call bcast(confle,sizeof(confle))
      if(nid.eq.0) write(6,'(A,A)') ' reading ', confle
c      call err_chk(ierr,' Cannot find con file!$')
      call bcast(ifco2,lsize)
      ierr = 0

      ! read header
      if (nid.eq.0) then
         if (ifco2) then
            call byte_open(confle,ierr)
            if(ierr.ne.0) goto 100

            call blank(hdr,sizeof(hdr))
            call byte_read(hdr,sizeof(hdr)/4,ierr)
            if(ierr.ne.0) goto 100

            read (hdr,*) version,nelgti,nelgvi,nvi
c    1       format(a5,2i12,i2)

            call byte_read(test,1,ierr)
            if(ierr.ne.0) goto 100
            ifbswap = if_byte_swap_test(test,ierr)
            if(ierr.ne.0) goto 100
         endif
      endif
      call bcast(nelgti,sizeof(nelgti))
      call bcast(nelgvi,sizeof(nelgvi))
      call bcast(nvi,sizeof(nvi))
      call bcast(ifbswap,sizeof(ifbswap))

      if (nvi .ne. nv)
     $   call exitti('Number of vertices do not match!$',0)
      if (nelgti .ne. nelgt)
     $   call exitti('nelgt for mesh/con differs!$',0)
      if (nelgvi .ne. nelgv)
     $   call exitti('nelgt for mesh/con differs!$',0)

      if (ifco2 .and. ifmpiio) then
        if (nid.eq.0) call byte_close(ierr)
        call byte_open_mpi(confle,ifh,.true.,ierr)
        offs0 = sizeof(hdr) + sizeof(test)

        call lim_chk(nelr*(nvi+1),nwk,'nelr ','nwk   ','read_con  ')

        nelBr = igl_running_sum(nelr) - nelr
        offs  = offs0 + int(nelBr,8)*(nvi+1)*ISIZE

        call byte_set_view(offs,ifh)
        call byte_read_mpi(wk,(nvi+1)*nelr,-1,ifh,ierr)
        call err_chk(ierr,' Error while reading con file!$')
        call byte_close_mpi(ifh,ierr)
        if (ifbswap) call byte_reverse(wk,(nvi+1)*nelr,ierr)
      endif

      return

  50  continue

#if defined(PARRSB)      
      call find_con(wk,nwk,ierr)
      return
#endif

 100  continue
      call err_chk(ierr,'Error opening/reading con file$')
      return

      end
c-----------------------------------------------------------------------
#if defined(PARRSB)      
      subroutine find_con(wk,nwk,ierr)

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'

      integer nwk,ierr
      integer wk(nwk)

      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
      common /SCRCG/ xyz(ldim*(2**ldim)*lelt)

      integer*8 eid8(4*lelt),vtx8(lelt*(2**ldim+1))
      common /ctmp0/ eid8, vtx8, iwork

      integer npf,nv,nf,i,j,k,verbose
      integer*8 start
      real*8 tol

      nv=2**ndim
      nf=2*ndim

      k=0
      if(ndim.eq.3) then
        do i=1,nelt
          do j=1,nv
            xyz(k+1)=xc(j,i)
            xyz(k+2)=yc(j,i)
            xyz(k+3)=zc(j,i)
            k=k+3
          enddo
        enddo
      else
        do i=1,nelt
          do j=1,nv
            xyz(k+1)=xc(j,i)
            xyz(k+2)=yc(j,i)
            k=k+2
          enddo
        enddo
      endif

      start=igl_running_sum(nelt)-nelt

      !calculate number of periodic pairs
      npf=0
      do i=1,nelt
        do j=1,nf
          if(cbc(j,i,1).eq.'P  ') then
            eid8(4*npf+1)=i+start
            eid8(4*npf+2)=j
            eid8(4*npf+3)=bc(1,j,i,1)
            eid8(4*npf+4)=bc(2,j,i,1)
            npf=npf+1
          endif
        enddo
      enddo

      ierr = 0
      toli = 5e-3
      verbose = 1
      call fparrsb_findConnectivity(vtx8,xyz,nelt,ndim,
     $  eid8,npf,tol,nekcomm,verbose,ierr)
      call err_chk(ierr,' findConnectivity failed!$')

      do i=1,nelt*(nv+1)
        wk(i)=vtx8(i)
      enddo

      end
#endif
c-----------------------------------------------------------------------
      subroutine set_proc_map()
C
C     Compute element to processor distribution according to (weighted) 
C     physical distribution in an attempt to minimize exposed number of
C     element interfaces.
C
      include 'SIZE'
      include 'PARALLEL'
      include 'INPUT'
      include 'DPROCMAP'

      integer ibuf(2)
      logical ifbswap
      logical ifre2

      integer iwork(lelt)

      if(nid.eq.0) inquire(file=re2fle, exist=ifre2)
      call bcast(ifre2,lsize)
      if(.not.ifre2) then
        call set_proc_map_legacy
        return
      endif

      call read_re2_hdr(ifbswap, .false.)
      nelt = nelgt/np
      do i = 1,mod(nelgt,np)
        if (np-i.eq.nid) nelt = nelt + 1
      enddo

      if (nelt .gt. lelt)
     $   call exitti('nelt > lelt!$',nelt)

      ! setup gllnid + gllel
#if defined(DPROCMAP)
      call dProcmapInit()  
      dProcmapCache = .false.
#endif
      nelB = igl_running_sum(nelt) - nelt
      do i = 1,nelt
         ieg = nelB + i
         lglel(i) = ieg 
         if (ieg.lt.1 .or. ieg.gt.nelgt)
     $      call exitti('invalid ieg!$',ieg)
#if defined(DPROCMAP)
         ibuf(1) = i
         ibuf(2) = nid
         call dProcmapPut(ibuf,2,0,ieg)
#else
         gllnid(ieg) = nid
         gllel(ieg) = i 
#endif
      enddo
#if !defined(DPROCMAP)
      npass = 1 + nelgt/lelt
      k=1
      do ipass = 1,npass
         m = nelgt - k + 1
         m = min(m,lelt)
         if (m.gt.0) call igop(gllnid(k),iwork,'+  ',m)
         if (m.gt.0) call igop(gllel(k) ,iwork,'+  ',m)
         k = k+m
      enddo
#endif

      ! read coord for RCB and/or connectivity
      call read_re2_data(ifbswap, .true., .false., .true.) 

      ! get element-proc mapping      
      call get_map() 

      itmp = gllnid(0) ! reset last element cache
      itmp = gllel(0)  ! reset last element cache
      dProcmapCache = .true.

#if !defined(DPROCMAP)
      IEL=0
      CALL IZERO(GLLEL,NELGT)
      DO IEG=1,NELGT
         IF (GLLNID(IEG).EQ.NID) THEN
            IEL = IEL + 1
            GLLEL(IEG)=IEL
            NELT = IEL
            if (ieg.le.nelgv) NELV = IEL
         ENDIF
c        write(6,*) 'map2 ieg:',ieg,nelv,nelt,nelgv,nelgt
      ENDDO
      npass = 1 + nelgt/lelt
      k=1
      do ipass = 1,npass
         m = nelgt - k + 1
         m = min(m,lelt)
         if (m.gt.0) call igop(gllel(k),iwork,'+  ',m)
         k = k+m
      enddo

      do ieg=1,nelgt
         mid  =gllnid(ieg)
         ie   =gllel (ieg)
         if (mid.eq.nid) lglel(ie)=ieg
      enddo
#endif

      return
      end
c-----------------------------------------------------------------------
      subroutine set_proc_map_legacy()
C
C     Compute element to processor distribution according to (weighted) 
C     physical distribution in an attempt to minimize exposed number of
C     element interfaces.
C
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'SOLN'
      include 'SCRCT'
      include 'TSTEP'
      common /ctmp0/ iwork(lelt)

      REAL*8 dnekclock,t0

#if defined(PARRSB) || defined(PARMETIS) || defined(DPROCMAP)
      call exitti(' DPROCMAP/PARRSB not supported for rea files$',0)
#else      
      t0 = dnekclock()
      call get_map

c     compute global to local map (no processor info)
      IEL=0
      CALL IZERO(GLLEL,NELGT)
      DO IEG=1,NELGT
         IF (GLLNID(IEG).EQ.NID) THEN
            IEL = IEL + 1
            GLLEL(IEG)=IEL
            NELT = IEL
            if (ieg.le.nelgv) NELV = IEL
         ENDIF
c        write(6,*) 'map2 ieg:',ieg,nelv,nelt,nelgv,nelgt
      ENDDO

c     dist. global to local map to all processors
      npass = 1 + nelgt/lelt
      k=1
      do ipass = 1,npass
         m = nelgt - k + 1
         m = min(m,lelt)
         if (m.gt.0) call igop(gllel(k),iwork,'+  ',m)
         k = k+m
      enddo

c     compute local to global map
c     (i.e. returns global element number given local index and proc id)
      do ieg=1,nelgt
         mid  =gllnid(ieg)
         ie   =gllel (ieg)
         if (mid.eq.nid) lglel(ie)=ieg
      enddo
#endif

      return
      end
c-----------------------------------------------------------------------

#ifndef DPROCMAP

c-----------------------------------------------------------------------
      subroutine read_map(vertex,nlv,wk,mdw,ndw)

      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'

      integer vertex(nlv,1)
      integer wk(mdw,ndw)

      logical ifbswap,if_byte_swap_test

      character*132 mapfle
      character*1   mapfle1(132)
      equivalence  (mapfle,mapfle1)

      character*132 hdr
      character*5   version
      real*4        test

      logical ifma2,ifmap
      integer e,eg,eg0,eg1
      integer itmp20(20)

      ierr = 0
      ifma2 = .false.

      if (nid.eq.0) then
         lfname = ltrunc(reafle,132) - 4
         call blank (mapfle,132)
         call chcopy(mapfle,reafle,lfname)
         call chcopy(mapfle1(lfname+1),'.map',4)
         inquire(file=mapfle, exist=ifmap)

         if (.not.ifmap) then
            call chcopy(mapfle1(lfname+1),'.ma2',4)
            inquire(file=mapfle, exist=ifma2)
         endif

        if(.not.ifmap .and. .not.ifma2) ierr = 1 
      endif
      if(nid.eq.0) write(6,'(A,A)') ' Reading ', mapfle
      call err_chk(ierr,' Cannot find map file!$')
      call bcast(ifma2,lsize)
      ierr = 0

      if (nid.eq.0) then
         if (ifma2) then         
            call byte_open(mapfle,ierr)
            if(ierr.ne.0) goto 100

            call blank(hdr,132)
            call byte_read(hdr,132/4,ierr)
            if(ierr.ne.0) goto 100

            read (hdr,1) version,neli,nnzi
    1       format(a5,2i12)

            call byte_read(test,1,ierr)
            if(ierr.ne.0) goto 100
            ifbswap = if_byte_swap_test(test,ierr)
            if(ierr.ne.0) goto 100
         else
            open(unit=80,file=mapfle,status='old',err=100)
            read(80,*,err=100) neli,nnzi
         endif
      endif
 
      call bcast(neli, ISIZE)

      npass = 1 + (neli/ndw)
      if (npass.gt.np) then
         if (nid.eq.0) write(6,*) npass,np,neli,ndw,'Error get_vert_map'
         call exitt
      endif 

      len = 4*mdw*ndw
      if (nid.gt.0.and.nid.lt.npass) msg_id=irecv(nid,wk,len)
      call nekgsync

      if (nid.eq.0) then
         eg0 = 0
         do ipass=1,npass
            eg1 = min(eg0+ndw,neli)

            if (ifma2) then
               nwds = (eg1 - eg0)*(mdw-1)
               call byte_read(wk,nwds,ierr)
               if (ierr.ne.0) goto 200
               if (ifbswap) call byte_reverse(wk,nwds,ierr)

               m = eg1 - eg0
               do eg=eg1,eg0+1,-1 ! reshuffle array
                  jj = (m-1)*(mdw-1) + 1
                  call icopy(itmp20,wk(jj,1),mdw-1)
                  call icopy(wk(1,m),itmp20 ,mdw-1)
                  m = m - 1
               enddo
            else
               m = 0
               do eg=eg0+1,eg1
                  m = m + 1
                  read(80,*,err=200) (wk(k,m),k=1,mdw-1)
               enddo
            endif
            
            m = 0
            do eg=eg0+1,eg1
               m = m + 1
               gllnid(eg) = wk(1,m)  ! must still be divided
               wk(mdw,m) = eg
            enddo
    
            if (ipass.lt.npass) call csend(ipass,wk,len,ipass,0) !send to ipass
            eg0 = eg1
         enddo

         ntuple = m

         if (ifma2) then
            call byte_close(ierr)
         else
            close(80)
         endif
      elseif (nid.lt.npass) then
         call msgwait(msg_id)
         ntuple = ndw
      else
         ntuple = 0
      endif

      lng = isize*neli
      call bcast(gllnid,lng)
      call assign_gllnid(gllnid,gllel,nelgt,nelgv,np) ! gllel is used as scratch

      nelt=0 !     Count number of elements on this processor
      nelv=0
      do eg=1,neli
         if (gllnid(eg).eq.nid) then
            if (eg.le.nelgv) nelv=nelv+1
            if (eg.le.nelgt) nelt=nelt+1
         endif
      enddo

c      if (np.le.64) write(6,*) nid,nelv,nelt,nelgv,nelgt,' NELV'

c     NOW: crystal route vertex by processor id

      ntuple_sum = iglsum(ntuple,1)
      if (ntuple_sum .ne. nelgt) then
         if (nid.eq.0) write(6,*) 'Error invalid tuple sum!'
         call exitt
      endif 

      do i=1,ntuple
         eg=wk(mdw,i)
         wk(1,i)=gllnid(eg)        ! processor id for element eg
      enddo

      key = 1  ! processor id is in wk(1,:)
      call fgslib_crystal_ituple_transfer(cr_h,wk,mdw,ntuple,ndw,key)

      key = mdw  ! Sort tuple list by eg
      nkey = 1
      call fgslib_crystal_ituple_sort(cr_h,wk,mdw,nelt,key,nkey)

      iflag = 0
      if (ntuple.ne.nelt) then
         write(6,*) nid,ntuple,nelv,nelt,nelgt,' NELT FAIL'
         write(6,*) 'Check that .map file and .rea file agree'
         iflag=1
      else
         do e=1,nelt
            call icopy(vertex(1,e),wk(2,e),nlv)
         enddo
      endif

      iflag = iglmax(iflag,1)
      if (iflag.gt.0) then
         do mid=0,np-1
            call nekgsync
            if (mid.eq.nid)
     $      write(6,*) nid,ntuple,nelv,nelt,nelgt,' NELT FB'
            call nekgsync
         enddo
         call nekgsync
         call exitt
      endif

      return

 100  continue
      call err_chk(ierr,'Error opening or reading map header$')

 200  continue
      call err_chk(ierr,'Error while reading map file$')

      return
      end
c-----------------------------------------------------------------------
      subroutine assign_gllnid(gllnid,iunsort,nelgt,nelgv,np)
c
      integer gllnid(1),iunsort(1),nelgt,np 
      integer e,eg


      log2p = log2(np)
      np2   = 2**log2p
      if (np2.eq.np.and.nelgv.eq.nelgt) then   ! std power of 2 case

         npstar = ivlmax(gllnid,nelgt)+1
         nnpstr = npstar/np
         do eg=1,nelgt
            gllnid(eg) = gllnid(eg)/nnpstr
         enddo

         return

      elseif (np2.eq.np) then   ! std power of 2 case, conjugate heat xfer

c        Assign fluid elements
         npstar = max(np,ivlmax(gllnid,nelgv)+1)
         nnpstr = npstar/np
         do eg=1,nelgv
            gllnid(eg) = gllnid(eg)/nnpstr
         enddo

c        Assign solid elements
         nelgs  = nelgt-nelgv  ! number of solid elements
         npstar = max(np,ivlmax(gllnid(nelgv+1),nelgs)+1)
         nnpstr = npstar/np
         do eg=nelgv+1,nelgt
            gllnid(eg) = gllnid(eg)/nnpstr
         enddo

         return

      elseif (nelgv.ne.nelgt) then
         call exitti
     $       ('Conjugate heat transfer requires P=power of 2.$',np)
      endif


c  Below is the code for P a non-power of two:

c  Split the sorted gllnid array (read from .map file) 
c  into np contiguous partitions. 

c  To load balance the partitions in case of mod(nelgt,np)>0 
c  add 1 contiguous entry out of the sorted list to NODE_i 
c  where i = np-mod(nelgt,np) ... np


      nel   = nelgt/np       ! number of elements per processor
      nmod  = mod(nelgt,np)  ! bounded between 1 ... np-1
      npp   = np - nmod      ! how many paritions of size nel 
 
      ! sort gllnid  
      call isort(gllnid,iunsort,nelgt)

      ! setup partitions of size nel 
      k   = 0
      do ip = 0,npp-1
         do e = 1,nel  
            k = k + 1 
            gllnid(k) = ip
         enddo
      enddo
      ! setup partitions of size nel+1
      if(nmod.gt.0) then 
        do ip = npp,np-1
           do e = 1,nel+1  
              k = k + 1 
              gllnid(k) = ip
           enddo
        enddo 
      endif

      ! unddo sorting to restore initial ordering by
      ! global element number
      call iswapt_ip(gllnid,iunsort,nelgt)

      return
      end
c-----------------------------------------------------------------------

#endif

c-----------------------------------------------------------------------
      subroutine cggosf (u1,u2,u3,r1,r2,r3,h1,h2,rmult,binv,
     $                   vol,tin,maxit,matmod)

C     Conjugate gradient iteration for solution of coupled 
C     Helmholtz equations 

      include 'SIZE'
      include 'TOTAL'
      include 'DOMAIN'
      include 'FDMH1'

      common /screv/  dpc(lx1*ly1*lz1*lelt)
     $     ,          p1 (lx1*ly1*lz1*lelt)
      common /scrch/  p2 (lx1*ly1*lz1*lelt)
     $     ,          p3 (lx1*ly1*lz1*lelt)
      common /scrsl/  qq1(lx1*ly1*lz1*lelt)
     $     ,          qq2(lx1*ly1*lz1*lelt)
     $     ,          qq3(lx1*ly1*lz1*lelt)
      common /scrmg/  pp1(lx1*ly1*lz1*lelt)
     $     ,          pp2(lx1*ly1*lz1*lelt)
     $     ,          pp3(lx1*ly1*lz1*lelt)
     $     ,          wa (lx1*ly1*lz1*lelt)
      real ap1(1),ap2(1),ap3(1)
      equivalence (ap1,pp1),(ap2,pp2),(ap3,pp3)

      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      common /cprint/ ifprint
      logical ifdfrm, iffast, ifh2, ifsolv, ifprint

      real u1(1),u2(1),u3(1),
     $     r1(1),r2(1),r3(1),h1(1),h2(1),rmult(1),binv(1)


      logical iffdm,ifcrsl

      iffdm  = .true.
      iffdm  = .false.
c     ifcrsl = .true.
      ifcrsl = .false.

      nel   = nelfld(ifield)
      nxyz  = lx1*ly1*lz1
      n     = nxyz*nel

      if (istep.le.1.and.iffdm) call set_fdm_prec_h1A

      tol  = tin

c     overrule input tolerance
      if (restol(ifield).ne.0) tol=restol(ifield)

      if (ifcrsl) call set_up_h1_crs_strs(h1,h2,ifield,matmod)

c      if (nio.eq.0.and.istep.eq.1) write(6,6) ifield,tol,tin
c   6  format(i3,1p2e12.4,' ifield, tol, tol_in')

      if ( .not.ifsolv ) then           !     Set logical flags
         call setfast (h1,h2,imesh)
         ifsolv = .true.
      endif

      call opdot (wa,r1,r2,r3,r1,r2,r3,n)
      rbnorm = glsc3(wa,binv,rmult,n)
      rbnorm = sqrt ( rbnorm / vol )
      if (rbnorm .lt. tol**2) then
         iter = 0
         r0 = rbnorm
c        if ( .not.ifprint )  goto 9999
         if (matmod.ge.0.and.nio.eq.0) write (6,3000) 
     $                                 istep,iter,rbnorm,r0,tol
         if (matmod.lt.0.and.nio.eq.0) write (6,3010) 
     $                                 istep,iter,rbnorm,r0,tol
         goto 9999
      endif

C     Evaluate diagional pre-conidtioner for fluid solve
      call setprec (dpc,h1,h2,imesh,1)
      call setprec (wa ,h1,h2,imesh,2)
      call add2    (dpc,wa,n)
      if (ldim.eq.3) then
         call setprec (wa,h1,h2,imesh,3)
         call add2    (dpc,wa,n)
      endif
c     call rone (dpc,n)
c     call copy (dpc,binv,n)

      if (iffdm) then
         call set_fdm_prec_h1b(dpc,h1,h2,nel)
         call fdm_h1a (pp1,r1,dpc,nel,ktype(1,1,1),wa)
         call fdm_h1a (pp2,r2,dpc,nel,ktype(1,1,2),wa)
         call fdm_h1a (pp3,r3,dpc,nel,ktype(1,1,3),wa)
         call rmask   (pp1,pp2,pp3,nel)
         call opdssum (pp1,pp2,pp3)
      else
         call col3 (pp1,dpc,r1,n)
         call col3 (pp2,dpc,r2,n)
         if (if3d) call col3 (pp3,dpc,r3,n)
      endif
      if (ifcrsl) then
         call crs_strs(p1,p2,p3,r1,r2,r3)
         call rmask   (p1,p2,p3,nel)
      else
         call opzero(p1,p2,p3)
      endif
      call opadd2       (p1,p2,p3,pp1,pp2,pp3)
      rpp1 = op_glsc2_wt(p1,p2,p3,r1,r2,r3,rmult)

      maxit=200
      do 1000 iter=1,maxit
         call axhmsf  (ap1,ap2,ap3,p1,p2,p3,h1,h2,matmod)
         call rmask   (ap1,ap2,ap3,nel)
         call opdssum (ap1,ap2,ap3)
         pap   = op_glsc2_wt(p1,p2,p3,ap1,ap2,ap3,rmult)
         alpha = rpp1 / pap

         call opadds (u1,u2,u3,p1 ,p2 ,p3 , alpha,n,2)
         call opadds (r1,r2,r3,ap1,ap2,ap3,-alpha,n,2)

         call opdot  (wa,r1,r2,r3,r1,r2,r3,n)
         rbnorm = glsc3(wa,binv,rmult,n)
         rbnorm = sqrt (rbnorm/vol)

         if (iter.eq.1) r0 = rbnorm

         if (rbnorm.lt.tol) then
            ifin = iter
            if (nio.eq.0) then
               if (matmod.ge.0) write(6,3000) istep,ifin,rbnorm,r0,tol
               if (matmod.lt.0) write(6,3010) istep,ifin,rbnorm,r0,tol
            endif
            goto 9999
         endif

         if (iffdm) then
            call fdm_h1a (pp1,r1,dpc,nel,ktype(1,1,1),wa)
            call fdm_h1a (pp2,r2,dpc,nel,ktype(1,1,2),wa)
            call fdm_h1a (pp3,r3,dpc,nel,ktype(1,1,3),wa)
            call rmask   (pp1,pp2,pp3,nel)
            call opdssum (pp1,pp2,pp3)
         else
            call col3 (pp1,dpc,r1,n)
            call col3 (pp2,dpc,r2,n)
            if (if3d) call col3 (pp3,dpc,r3,n)
         endif

         if (ifcrsl) then
           call crs_strs(qq1,qq2,qq3,r1,r2,r3)
           call rmask   (qq1,qq2,qq3,nel)
           call opadd2  (pp1,pp2,pp3,qq1,qq2,qq3)
         endif

         call opdot (wa,r1,r2,r3,pp1,pp2,pp3,n)

         rpp2 = rpp1
         rpp1 = glsc2(wa,rmult,n)
         beta = rpp1/rpp2
         call opadds (p1,p2,p3,pp1,pp2,pp3,beta,n,1)

 1000 continue
      if (matmod.ge.0.and.nio.eq.0) write (6,3001) 
     $                              istep,iter,rbnorm,r0,tol
      if (matmod.lt.0.and.nio.eq.0) write (6,3011) 
     $                              istep,iter,rbnorm,r0,tol

 9999 continue
      ifsolv = .false.


 3000 format(i11,'  Helmh3 fluid  ',I6,1p3E13.4)
 3010 format(i11,'  Helmh3 mesh   ',I6,1p3E13.4)
 3001 format(i11,'  Helmh3 fluid unconverged! ',I6,1p3E13.4)
 3011 format(i11,'  Helmh3 mesh unconverged! ',I6,1p3E13.4)

      return
      end
c-----------------------------------------------------------------------
      subroutine setdt
c
c     Set the new time step. All cases covered.
c
      include 'SIZE'
      include 'SOLN'
      include 'MVGEOM'
      include 'INPUT'
      include 'TSTEP'
      include 'PARALLEL'

      common /scruz/ cx(lx1*ly1*lz1*lelt)
     $ ,             cy(lx1,ly1,lz1,lelt)
     $ ,             cz(lx1,ly1,lz1,lelt)

      common /cprint/ ifprint
      logical         ifprint
      common /udxmax/ umax
      REAL     DTOLD
      SAVE     DTOLD
      DATA     DTOLD /0.0/
      REAL     DTOpf
      SAVE     DTOpf
      DATA     DTOpf /0.0/
      logical iffxdt
      save    iffxdt
      data    iffxdt /.false./
C

      if (param(12).lt.0.or.iffxdt) then
         iffxdt    = .true.
         param(12) = abs(param(12))
         dt        = param(12)
         dtopf     = dt
         if (ifmvbd) then
           call opsub3 (cx,cy,cz,vx,vy,vz,wx,wy,wz)
           call compute_cfl(umax,cx,cy,cz,1.0)
         else
           call compute_cfl(umax,vx,vy,vz,1.0)
         endif

         goto 200
      else IF (PARAM(84).NE.0.0) THEN
         if (dtold.eq.0.0) then
            dt   =param(84)
            dtold=param(84)
            dtopf=param(84)
            return
         else
            dtold=dt
            dtopf=dt
            dt=dtopf*param(85)
            dt=min(dt,param(12))
         endif
      endif

C
C     Find DT=DTCFL based on CFL-condition (if applicable)
C
      CALL SETDTC
      DTCFL = DT
C
C     Find DTFS based on surface tension (if applicable)
C
      CALL SETDTFS (DTFS)
C
C     Select appropriate DT
C
      IF ((DT.EQ.0.).AND.(DTFS.GT.0.)) THEN
          DT = DTFS
      ELSEIF ((DT.GT.0.).AND.(DTFS.GT.0.)) THEN
          DT = MIN(DT,DTFS)
      ELSEIF ((DT.EQ.0.).AND.(DTFS.EQ.0.)) THEN
          DT = 0.
          IF (IFFLOW.AND.NID.EQ.0.AND.IFPRINT) THEN
             WRITE (6,*) 'WARNING: CFL-condition & surface tension'
             WRITE (6,*) '         are not applicable'
          endif
      ELSEIF ((DT.GT.0.).AND.(DTFS.EQ.0.)) THEN
          DT = DT
      ELSE
          DT = 0.
          IF (NIO.EQ.0) WRITE (6,*) 'WARNING: DT<0 or DTFS<0'
          IF (NIO.EQ.0) WRITE (6,*) '         Reset DT      '
      endif
C
C     Check DT against user-specified input, DTINIT=PARAM(12).
C
      IF ((DT.GT.0.).AND.(DTINIT.GT.0.)) THEN
         DT = MIN(DT,DTINIT)
      ELSEIF ((DT.EQ.0.).AND.(DTINIT.GT.0.)) THEN
         DT = DTINIT
      ELSEIF ((DT.GT.0.).AND.(DTINIT.EQ.0.)) THEN
         DT = DT
      ELSEIF (.not.iffxdt) THEN
         DT = 0.001
         IF(NIO.EQ.0)WRITE (6,*) 'WARNING: Set DT=0.001 (arbitrarily)'
      endif
C
C     Check if final time (user specified) has been reached.
C
 200  IF (TIME+DT .GE. FINTIM .AND. FINTIM.NE.0.0) THEN
C        Last step
         LASTEP = 1
         DT = FINTIM-TIME
         IF (NIO.EQ.0) WRITE (6,*) 'Final time step = ',DT
      endif
C
      COURNO = DT*UMAX
      IF (NIO.EQ.0.AND.IFPRINT.AND.DT.NE.DTOLD)
     $   WRITE (6,100) DT,DTCFL,DTFS,DTINIT
 100     FORMAT(5X,'DT/DTCFL/DTFS/DTINIT',4E12.3)
C
C     Put limits on how much DT can change.
C
      IF (DTOLD.NE.0.0 .AND. LASTEP.NE.1) THEN
         DTMIN=0.8*DTOLD
         DTMAX=1.2*DTOLD
         DT = MIN(DTMAX,DT)
         DT = MAX(DTMIN,DT)
      endif
      DTOLD=DT

C      IF (PARAM(84).NE.0.0) THEN
C            dt=dtopf*param(85)
C            dt=min(dt,param(12))
C      endif

      if (iffxdt) dt=dtopf
      COURNO = DT*UMAX

! synchronize time step for multiple sessions
      if (ifneknek) dt = glmin_ms(dt,1)
c
      if (iffxdt.and.abs(courno).gt.10.*abs(ctarg)) then
         if (nid.eq.0) write(6,*) 'CFL, Ctarg!',courno,ctarg
         call emerxit
      endif


      return
      end
C
C--------------------------------------------------------
C
      subroutine cvgnlps (ifconv)
C----------------------------------------------------------------------
C
C     Check convergence for non-linear passisve scalar solver.
C     Relevant for solving heat transport problems with radiation b.c.
C
C----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      LOGICAL  IFCONV
C
      IF (IFNONL(IFIELD)) THEN
         IFCONV = .FALSE.
      ELSE
         IFCONV = .TRUE.
         return
      endif
C
      TNORM1 = TNRMH1(IFIELD-1)
      CALL UNORM
      TNORM2 = TNRMH1(IFIELD-1)
      EPS = ABS((TNORM2-TNORM1)/TNORM2)
      IF (EPS .LT. TOLNL) IFCONV = .TRUE.
C
      return
      end
C
      subroutine unorm
C---------------------------------------------------------------------
C
C     Norm calculation.
C
C--------------------------------------------------------------------- 
      include 'SIZE'
      include 'SOLN'
      include 'TSTEP'
C
      IF (IFIELD.EQ.1) THEN
C
C        Compute norms of the velocity.
C        Compute time mean (L2) of the inverse of the time step. 
C        Compute L2 in time, H1 in space of the velocity.
C
         CALL NORMVC (VNRMH1,VNRMSM,VNRML2,VNRML8,VX,VY,VZ)
         IF (ISTEP.EQ.0) return
         IF (ISTEP.EQ.1) THEN
            DTINVM = 1./DT
            VMEAN  = VNRML8
         ELSE
            tden   = time
            if (time.le.0) tden = abs(time)+1.e-9
            arg    = ((TIME-DT)*DTINVM**2+1./DT)/tden
            if (arg.gt.0) DTINVM = SQRT(arg)
            arg    = ((TIME-DT)*VMEAN**2+DT*VNRMH1**2)/tden
            if (arg.gt.0) VMEAN  = SQRT(arg)
         endif
      ELSE
C
C     Compute norms of a passive scalar
C
         CALL NORMSC (TNRMH1(IFIELD-1),TNRMSM(IFIELD-1),
     $                TNRML2(IFIELD-1),TNRML8(IFIELD-1),
     $                     T(1,1,1,1,IFIELD-1),IMESH)
         TMEAN(IFIELD-1) = 0.
      endif
C
      return
      end
C
      subroutine chktmg (tol,res,w1,w2,mult,mask,imesh)
C-------------------------------------------------------------------
C
C     Check that the tolerances are not too small for the MG-solver.
C     Important when calling the MG-solver (Gauss-Lobatto mesh).
C     Note: direct stiffness summation
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'EIGEN'
C
      REAL RES  (LX1,LY1,LZ1,1)
      REAL W1   (LX1,LY1,LZ1,1)
      REAL W2   (LX1,LY1,LZ1,1)
      REAL MULT (LX1,LY1,LZ1,1)
      REAL MASK (LX1,LY1,LZ1,1)
C
C     Single or double precision???
C
      DELTA = 1.E-9
      X     = 1.+DELTA
      Y     = 1.
      DIFF  = ABS(X-Y)
      IF (DIFF.EQ.0.) EPS = 1.E-6*EIGGA/EIGAA
      IF (DIFF.GT.0.) EPS = 1.E-13*EIGGA/EIGAA
C
      IF (IMESH.EQ.1) NL = NELV
      IF (IMESH.EQ.2) NL = NELT
      NTOT1 = lx1*ly1*lz1*NL
      CALL COPY (W1,RES,NTOT1)
C
      CALL DSSUM (W1,lx1,ly1,lz1)
C
      IF (IMESH.EQ.1) THEN
         CALL COL3 (W2,BINVM1,W1,NTOT1)
         RINIT  = SQRT(GLSC3 (W2,W1,MULT,NTOT1)/VOLVM1)
      ELSE
         CALL COL3 (W2,BINTM1,W1,NTOT1)
         RINIT  = SQRT(GLSC3 (W2,W1,MULT,NTOT1)/VOLTM1)
      endif
      RMIN   = EPS*RINIT
      IF (TOL.LT.RMIN) THEN
         TOLOLD=TOL
         TOL = RMIN
         IF (NIO.EQ.0)
     $   WRITE (6,*) 'New MG-tolerance (RINIT*epsm*cond) = ',TOL,TOLOLD
      endif
C
      CALL RONE (W1,NTOT1)
      BCNEU1 = GLSC3(W1,MASK,MULT,NTOT1)
      BCNEU2 = GLSC3(W1,W1  ,MULT,NTOT1)
      BCTEST = ABS(BCNEU1-BCNEU2)
      IF (BCTEST .LT. .1) THEN
         OTR = GLSUM (RES,NTOT1)
         TOLMIN = ABS(OTR)*EIGGA/EIGAA
         IF (TOL .LT. TOLMIN) THEN
             TOLOLD = TOL
             TOL = TOLMIN
             IF (NIO.EQ.0)
     $       WRITE (6,*) 'New MG-tolerance (OTR) = ',TOL,TOLOLD
         endif
      endif
C
      return
      end
C
C
      subroutine setdtc
C--------------------------------------------------------------
C
C     Compute new timestep based on CFL-condition
C
C--------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'MVGEOM'
      include 'MASS'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
C
      common /ctmp1/ u(lx1,ly1,lz1,lelv)
     $ ,             v(lx1,ly1,lz1,lelv)
     $ ,             w(lx1,ly1,lz1,lelv)
      common /ctmp0/ x(lx1,ly1,lz1,lelv)
     $ ,             r(lx1,ly1,lz1,lelv)
      common /udxmax/ umax

      common /scruz/ cx(lx1*ly1*lz1*lelv)
     $ ,             cy(lx1,ly1,lz1,lelv)
     $ ,             cz(lx1,ly1,lz1,lelv)
C
C
      REAL VCOUR
      SAVE VCOUR
C
      INTEGER IFIRST
      SAVE    IFIRST
      DATA    IFIRST/0/
C
C
C     Steady state => all done
C
C
      IF (.NOT.IFTRAN) THEN
         IFIRST=1
         LASTEP=1
         return
      endif
C
      irst = param(46)
      if (irst.gt.0) ifirst=1
C
C     First time around
C
      IF (IFIRST.EQ.0) THEN
         DT     = DTINIT
         IF (IFFLOW) THEN
            IFIELD = 1
            CALL BCDIRVC (VX,VY,VZ,v1mask,v2mask,v3mask)
         endif
      endif
      IFIRST=IFIRST+1
C
      DTOLD = DT
C
C     Convection ?
C
C     Don't enforce Courant condition if there is no convection.
C
C
      ICONV=0
      IF (IFFLOW .AND. IFNAV) ICONV=1
      IF (IFWCNO)             ICONV=1
      IF (IFHEAT) THEN
         DO 10 IPSCAL=0,NPSCAL
            IF (IFADVC(IPSCAL+2)) ICONV=1
   10    CONTINUE
      endif

      IF (ICONV.EQ.0) THEN
         DT=0.
         return
      endif
C
C
C     Find Courant and Umax
C
C
      NTOT   = lx1*ly1*lz1*NELV
      NTOTL  = LX1*LY1*LZ1*LELV
      NTOTD  = NTOTL*ldim
      COLD   = COURNO
      CMAX   = 1.2*CTARG
      CMIN   = 0.8*CTARG
 
      if (ifmvbd) then
        call opsub3 (cx,cy,cz,vx,vy,vz,wx,wy,wz)
           call compute_cfl(umax,cx,cy,cz,1.0)
      else
           call compute_cfl(umax,vx,vy,vz,1.0)
      endif

c      if (nio.eq.0) write(6,1) istep,time,umax,cmax
c   1  format(i9,1p3e12.4,' cmax')

C     Zero DT

      IF (DT .EQ. 0.0) THEN

         IF (UMAX .NE. 0.0) THEN
            DT = CTARG/UMAX
            VCOUR = UMAX
         ELSEIF (IFFLOW) THEN
C
C           We'll use the body force to predict max velocity
C
            CALL SETPROP
            IFIELD = 1
C
            CALL MAKEUF
            CALL OPDSSUM (BFX,BFY,BFZ)
            CALL OPCOLV  (BFX,BFY,BFZ,BINVM1)
            FMAX=0.0
            CALL RZERO (U,NTOTD)
            DO 600 I=1,NTOT
               U(I,1,1,1) = ABS(BFX(I,1,1,1))
               V(I,1,1,1) = ABS(BFY(I,1,1,1))
               W(I,1,1,1) = ABS(BFZ(I,1,1,1))
 600        CONTINUE
            FMAX    = GLMAX (U,NTOTD)
            DENSITY = AVTRAN(1)
            AMAX    = FMAX/DENSITY
            DXCHAR  = SQRT( (XM1(1,1,1,1)-XM1(2,1,1,1))**2 +
     $                      (YM1(1,1,1,1)-YM1(2,1,1,1))**2 + 
     $                      (ZM1(1,1,1,1)-ZM1(2,1,1,1))**2 ) 
            DXCHAR  = GLMIN (dxchar,1)
            IF (AMAX.NE.0.) THEN
               DT = SQRT(CTARG*DXCHAR/AMAX)
            ELSE
               IF (NID.EQ.0) 
     $         WRITE (6,*) 'CFL: Zero velocity and body force'
               DT = 0.0
               return
            endif
         ELSEIF (IFWCNO) THEN
            IF (NID.EQ.0) 
     $      WRITE (6,*) ' Stefan problem with no fluid flow'
            DT = 0.0
            return
         endif
C
      ELSEIF ((DT.GT.0.0).AND.(UMAX.NE.0.0)) THEN
C
C
C     Nonzero DT & nonzero velocity
C
C
      COURNO = DT*UMAX
      VOLD   = VCOUR
      VCOUR  = UMAX
      IF (IFIRST.EQ.1) THEN
         COLD = COURNO
         VOLD = VCOUR
      endif
      CPRED  = 2.*COURNO-COLD
C
C     Change DT if it is too big or if it is too small 
C
c     if (nid.eq.0) 
c    $write(6,917) dt,umax,vold,vcour,cpred,cmax,courno,cmin
c 917 format(' dt',4f9.5,4f10.6)
      IF(COURNO.GT.CMAX .OR. CPRED.GT.CMAX .OR. COURNO.LT.CMIN) THEN
C
            A=(VCOUR-VOLD)/DT
            B=VCOUR
C           -C IS Target Courant number
            C=-CTARG
            DISCR=B**2-4*A*C
            DTOLD=DT
            IF(DISCR.LE.0.0)THEN
c               if (nio.eq.0) 
c     $         PRINT*,'Problem calculating new DT Discriminant=',discr
               DT=DT*(CTARG/COURNO)
C               IF(DT.GT.DTOLD) DT=DTOLD
            ELSE IF(ABS((VCOUR-VOLD)/VCOUR).LT.0.001)THEN
C              Easy: same v as before (LINEARIZED)
               DT=DT*(CTARG/COURNO)
c     if (nid.eq.0) 
c    $write(6,918) dt,dthi,dtlow,discr,a,b,c
c 918 format(' d2',4f9.5,4f10.6)
            ELSE
               DTLOW=(-B+SQRT(DISCR) )/(2.0*A)
               DTHI =(-B-SQRT(DISCR) )/(2.0*A)
               IF(DTHI .GT. 0.0 .AND. DTLOW .GT. 0.0)THEN
                  DT = MIN (DTHI,DTLOW)
c     if (nid.eq.0) 
c    $write(6,919) dt,dthi,dtlow,discr,a,b,c
c 919 format(' d3',4f9.5,4f10.6)
               ELSE IF(DTHI .LE. 0.0 .AND. DTLOW .LE. 0.0)THEN
c                 PRINT*,'DTLOW,DTHI',DTLOW,DTHI
c                 PRINT*,'WARNING: Abnormal DT from CFL-condition'
c                 PRINT*,'         Keep going'
                  DT=DT*(CTARG/COURNO)
               ELSE
C                 Normal case; 1 positive root, one negative root
                  DT = MAX (DTHI,DTLOW)
c     if (nid.eq.0) 
c    $write(6,929) dt,dthi,dtlow,discr,a,b,c
c 929 format(' d4',4f9.5,4f10.6)
               endif
            endif
C           We'll increase gradually-- make it the geometric mean between
c     if (nid.eq.0) 
c    $write(6,939) dt,dtold
c 939 format(' d5',4f9.5,4f10.6)
            IF (DTOLD/DT .LT. 0.2) DT = DTOLD*5
      endif
C
      endif
C
      return
      end
C
      subroutine setdtfs (dtfs)
C
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'GEOM'
      include 'TSTEP'
      common /ctmp0/  stc(lx1,ly1,lz1),sigst(lx1,ly1),dtst(lx1,ly1)
      character cb*3,cb2*2
C
C     Applicable?
C
      IF (.NOT.IFSURT) THEN
         DTFS = 0.0
         return
      endif
C
      NFACE  = 2*ldim
      NXZ1   = lx1*lz1
      NTOT1  = lx1*ly1*lz1*NELV
      DTFS   = 1.1E+10
C
C     Kludge : for debugging purpose Fudge Factor comes in
C              as PARAM(45)
C
      FACTOR = PARAM(45)
      IF (FACTOR .LE. 0.0) FACTOR=1.0
      FACTOR = FACTOR / SQRT( PI**3 )
C
      IF (ISTEP.EQ.1) CALL SETPROP
C
      IFIELD = 1
      RHOMIN = GLMIN( VTRANS(1,1,1,1,IFIELD),NTOT1 )
C
      DO 100 IEL=1,NELV
      DO 100 IFC=1,NFACE
         CB =CBC(IFC,IEL,IFIELD)
         CB2=CBC(IFC,IEL,IFIELD)
         IF (CB2.NE.'MS' .AND. CB2.NE.'ms') GOTO 100
             IF (CB2(1:1).EQ.'M') THEN
                BC4 = BC(4,IFC,IEL,IFIELD)
                CALL CFILL  (SIGST,BC4,NXZ1)
             ELSE
                CALL FACEIS (CB,STC,IEL,IFC,lx1,ly1,lz1)
                CALL FACEXS (SIGST,STC,IFC,0)
             endif
             SIGMAX = VLMAX (SIGST,NXZ1)
             IF (SIGMAX.LE.0.0) GOTO 100
             RHOSIG = SQRT( RHOMIN/SIGMAX )
             IF (ldim.EQ.2) THEN
                CALL CDXMIN2 (DTST,RHOSIG,IEL,IFC,IFAXIS)
             ELSE
                CALL CDXMIN3 (DTST,RHOSIG,IEL,IFC)
             endif
             DTMIN = VLMIN( DTST,NXZ1 )
             DTFS  = MIN( DTFS,DTMIN )
  100 CONTINUE
      DTFS    = GLMIN( dtfs,1 )
C
      IF (DTFS .GT. 1.E+10) DTFS = 0.0
      DTFS = DTFS * FACTOR
C
      IF (DTFS.EQ.0.0) THEN
         IF (ISTEP.EQ.1.AND.NIO.EQ.0) THEN
            WRITE (6,*) ' Warning - zero surface-tension may results in'
            WRITE (6,*) ' instability of free-surface update'
         endif
      endif
C
      return
      end
      subroutine cdxmin2 (dtst,rhosig,iel,ifc,ifaxis)
C
      include 'SIZE'
      include 'GEOM'
      include 'DXYZ'
      common /delrst/ drst(lx1),drsti(lx1)
      common /ctmp0/  xfm1(lx1),yfm1(lx1),t1xf(lx1),t1yf(lx1)
      DIMENSION DTST(LX1,1)
      LOGICAL IFAXIS
C
      DELTA = 1.E-9
      X     = 1.+DELTA
      Y     = 1.
      DIFF  = ABS(X-Y)
      IF (DIFF.EQ.0.) EPS = 1.E-6
      IF (DIFF.GT.0.) EPS = 1.E-13
C
      CALL FACEC2 (XFM1,YFM1,XM1(1,1,1,IEL),YM1(1,1,1,IEL),IFC)
C
      IF (IFC.EQ.1 .OR. IFC.EQ.3) THEN
         CALL MXM (DXM1,lx1,XFM1,lx1,T1XF,1)
         CALL MXM (DXM1,lx1,YFM1,lx1,T1YF,1)
      ELSE
         IF (IFAXIS) CALL SETAXDY ( IFRZER(IEL) )
         CALL MXM (DYM1,ly1,XFM1,ly1,T1XF,1)
         CALL MXM (DYM1,ly1,YFM1,ly1,T1YF,1)
      endif
C
      IF (IFAXIS) THEN
         DO 100 IX=1,lx1
            IF (YFM1(IX) .LT. EPS) THEN
               DTST(IX,1) = 1.e+10
            ELSE
               XJ = SQRT( T1XF(IX)**2 + T1YF(IX)**2 )*DRST(IX)
               DTST(IX,1) = RHOSIG * SQRT( XJ**3 ) * YFM1(IX)
            endif
  100    CONTINUE
      ELSE
         DO 200 IX=1,lx1
            XJ = SQRT( T1XF(IX)**2 + T1YF(IX)**2 )*DRST(IX)
            DTST(IX,1) = RHOSIG * SQRT( XJ**3 )
  200    CONTINUE
      endif
C
      return
      end
      subroutine cdxmin3 (dtst,rhosig,iel,ifc)
C
      include 'SIZE'
      include 'GEOM'
      include 'DXYZ'
      common /delrst/ drst(lx1),drsti(lx1)
      common /ctmp0/  xfm1(lx1,ly1),yfm1(lx1,ly1),zfm1(lx1,ly1)
      common /ctmp1/  drm1(lx1,lx1),drtm1(lx1,ly1)
     $             ,  dsm1(lx1,lx1),dstm1(lx1,ly1)
      common /scrmg/  xrm1(lx1,ly1),yrm1(lx1,ly1),zrm1(lx1,ly1)
     $             ,  xsm1(lx1,ly1),ysm1(lx1,ly1),zsm1(lx1,ly1)
      dimension dtst(lx1,ly1)
C
      call facexv (xfm1,yfm1,zfm1,xm1(1,1,1,iel),ym1(1,1,1,iel),
     $             zm1(1,1,1,iel),ifc,0)
      call setdrs (drm1,drtm1,dsm1,dstm1,ifc)
C
      CALL MXM (DRM1,lx1, XFM1,lx1,XRM1,ly1)
      CALL MXM (DRM1,lx1, YFM1,lx1,YRM1,ly1)
      CALL MXM (DRM1,lx1, ZFM1,lx1,ZRM1,ly1)
      CALL MXM (XFM1,lx1,DSTM1,ly1,XSM1,ly1)
      CALL MXM (YFM1,lx1,DSTM1,ly1,YSM1,ly1)
      CALL MXM (ZFM1,lx1,DSTM1,ly1,ZSM1,ly1)
C
      DO 100 IX=1,lx1
      DO 100 IY=1,ly1
         DELR = XRM1(IX,IY)**2 + YRM1(IX,IY)**2 + ZRM1(IX,IY)**2
         DELS = XSM1(IX,IY)**2 + YSM1(IX,IY)**2 + ZSM1(IX,IY)**2
         DELR = SQRT( DELR )*DRST(IX)
         DELS = SQRT( DELS )*DRST(IY)
         XJ   = MIN( DELR,DELS )
         DTST(IX,IY) = RHOSIG * SQRT( XJ**3 )
  100 CONTINUE
C
      return
      end
C
      FUNCTION FACDOT(A,B,IFACE1)
C
C     Take the dot product of A and B on the surface IFACE1 of element IE.
C
C         IFACE1 is in the preprocessor notation 
C         IFACE  is the dssum notation.
C         5 Jan 1989 15:12:22      PFF
C
      include 'SIZE'
      include 'TOPOL'
      DIMENSION A(LX1,LY1,LZ1),B(LX1,LY1)
C
C     Set up counters
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      SUM=0.0
      I = 0
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         I = I+1
         SUM = SUM + A(J1,J2,1)*B(I,1)
  100 CONTINUE
C
      FACDOT = SUM
C
      return
      end
C
      subroutine fcaver(xaver,a,iel,iface1)
C------------------------------------------------------------------------
C
C     Compute the average of A over the face IFACE1 in element IEL.
C
C         A is a (NX,NY,NZ) data structure
C         IFACE1 is in the preprocessor notation 
C         IFACE  is the dssum notation.
C------------------------------------------------------------------------
      include 'SIZE'
      include 'GEOM'
      include 'TOPOL'
      REAL A(LX1,LY1,LZ1,1)
C
      FCAREA = 0.
      XAVER  = 0.
C
C     Set up counters
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      I = 0
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         I = I+1
         FCAREA = FCAREA+AREA(I,1,IFACE1,IEL)
         XAVER  = XAVER +AREA(I,1,IFACE1,IEL)*A(J1,J2,1,IEL)
  100 CONTINUE
C
      XAVER = XAVER/FCAREA
      return
      end
      subroutine faccl2(a,b,iface1)
C
C     Collocate B with A on the surface IFACE1 of element IE.
C
C         A is a (NX,NY,NZ) data structure
C         B is a (NX,NY,IFACE) data structure
C         IFACE1 is in the preprocessor notation 
C         IFACE  is the dssum notation.
C         5 Jan 1989 15:12:22      PFF
C
      include 'SIZE'
      include 'TOPOL'
      DIMENSION A(LX1,LY1,LZ1),B(LX1,LY1)
C
C     Set up counters
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      I = 0
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         I = I+1
         A(J1,J2,1) = A(J1,J2,1)*B(I,1)
  100 CONTINUE
C
      return
      end
C
      subroutine faccl3(a,b,c,iface1)
C
C     Collocate B with A on the surface IFACE1 of element IE.
C
C         A is a (NX,NY,NZ) data structure
C         B is a (NX,NY,IFACE) data structure
C         IFACE1 is in the preprocessor notation 
C         IFACE  is the dssum notation.
C         5 Jan 1989 15:12:22      PFF
C
      include 'SIZE'
      include 'TOPOL'
      DIMENSION A(LX1,LY1,LZ1),B(LX1,LY1,LZ1),C(LX1,LY1)
C
C     Set up counters
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      I = 0
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         I = I+1
         A(J1,J2,1) = B(J1,J2,1)*C(I,1)
  100 CONTINUE
C
      return
      end
      subroutine faddcl3(a,b,c,iface1)
C
C     Collocate B with C and add to A on the surface IFACE1 of element IE.
C
C         A is a (NX,NY,NZ) data structure
C         B is a (NX,NY,NZ) data structure
C         C is a (NX,NY,IFACE) data structure
C         IFACE1 is in the preprocessor notation 
C         IFACE  is the dssum notation.
C         29 Jan 1990 18:00 PST   PFF
C
      include 'SIZE'
      include 'TOPOL'
      DIMENSION A(LX1,LY1,LZ1),B(LX1,LY1,LZ1),C(LX1,LY1)
C
C     Set up counters
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFACE1)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      I = 0
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         I = I+1
         A(J1,J2,1) = A(J1,J2,1) + B(J1,J2,1)*C(I,1)
  100 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine sethlm (h1,h2,intloc)
 
c     Set the variable property arrays H1 and H2
c     in the Helmholtz equation.
c     (associated with variable IFIELD)
c     INTLOC =      integration type

      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'

      real h1(1),h2(1)

      nel   = nelfld(ifield)
      ntot1 = lx1*ly1*lz1*nel

      if (iftran) then
         dtbd = bd(1)/dt
         call copy  (h1,vdiff (1,1,1,1,ifield),ntot1)
         if (intloc.eq.0) then
            call rzero (h2,ntot1)
         else
            call cmult2 (h2,vtrans(1,1,1,1,ifield),dtbd,ntot1)
         endif

c        if (ifield.eq.1 .and. ifanls) then   ! this should be replaced
c           const = 2.                        ! with a correct stress
c           call cmult (h1,const,ntot1)       ! formulation
c        endif

      ELSE
         CALL COPY  (H1,VDIFF (1,1,1,1,IFIELD),NTOT1)
         CALL RZERO (H2,NTOT1)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine nekuvp (iel)
C------------------------------------------------------------------
C
C     Generate user-specified material properties
C
C------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
      include 'PARALLEL'
      include 'NEKUSE'
      ielg = lglel(iel)
c     IF (IFSTRS .AND. IFIELD.EQ.1) CALL STNRINV ! don't call! pff, 2007
      DO 10 K=1,lz1
      DO 10 J=1,ly1
      DO 10 I=1,lx1
         if (optlevel.le.2) CALL NEKASGN (I,J,K,IEL)
         CALL USERVP  (I,J,K,IELG)
         VDIFF (I,J,K,IEL,IFIELD) = UDIFF
         VTRANS(I,J,K,IEL,IFIELD) = UTRANS
 10   CONTINUE
      return
      end
C
      subroutine diagnos
      return
      end

c-----------------------------------------------------------------------
      subroutine setsolv
      include 'SIZE'

      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv

      ifsolv = .false.

      return
      end
c-----------------------------------------------------------------------
      subroutine hmhzsf (name,u1,u2,u3,r1,r2,r3,h1,h2,
     $                   rmask1,rmask2,rmask3,rmult,
     $                   tol,maxit,matmod)

c     Solve coupled Helmholtz equations (stress formulation)


      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'   ! For outpost diagnostic call
      include 'TSTEP'
      include 'ORTHOSTRS'
      include 'CTIMER'

      real u1(1),u2(1),u3(1),r1(1),r2(1),r3(1),h1(1),h2(1)
      real rmask1(1),rmask2(1),rmask3(1),rmult(1)
      character name*4

#ifdef TIMER
      nhmhz = nhmhz + 1
      etime1 = dnekclock()
#endif

      nel = nelfld(ifield)
      vol = volfld(ifield)
      n   = lx1*ly1*lz1*nel

      napproxstrs(1) = 0
      iproj = 0
      if (ifprojfld(ifield)) iproj = param(94)
      if (iproj.gt.0.and.istep.ge.iproj) napproxstrs(1)=param(93)
      napproxstrs(1)=min(napproxstrs(1),mxprev)

      call rmask   (r1,r2,r3,nel)
      call opdssum (r1,r2,r3)
      call rzero3  (u1,u2,u3,n)

      if (imesh.eq.1) then
         call chktcgs (r1,r2,r3,rmask1,rmask2,rmask3,rmult,binvm1
     $                ,vol,tol,nel)

         call strs_project_a(r1,r2,r3,h1,h2,rmult,ifield,ierr,matmod)

         call cggosf  (u1,u2,u3,r1,r2,r3,h1,h2,rmult,binvm1
     $                ,vol,tol,maxit,matmod)

         call strs_project_b(u1,u2,u3,h1,h2,rmult,ifield,ierr)

      else

         call chktcgs (r1,r2,r3,rmask1,rmask2,rmask3,rmult,bintm1
     $                ,vol,tol,nel)
         call cggosf  (u1,u2,u3,r1,r2,r3,h1,h2,rmult,bintm1
     $                ,vol,tol,maxit,matmod)

      endif

#ifdef TIMER
      thmhz=thmhz+(dnekclock()-etime1)
#endif

      return
      end

      subroutine chktcgs (r1,r2,r3,rmask1,rmask2,rmask3,rmult,binv,
     $                    vol,tol,nel)
C-------------------------------------------------------------------
C
C     Check that the tolerances are not too small for the CG-solver.
C     Important when calling the CG-solver (Gauss-Lobatto mesh) with
C     zero Neumann b.c.
C
C-------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'EIGEN'
      common /cprint/ ifprint
      logical         ifprint
      common /ctmp0/ wa (lx1,ly1,lz1,lelt)
C
      dimension r1    (lx1,ly1,lz1,1)
     $        , r2    (lx1,ly1,lz1,1)
     $        , r3    (lx1,ly1,lz1,1)
     $        , rmask1(lx1,ly1,lz1,1)
     $        , rmask2(lx1,ly1,lz1,1)
     $        , rmask3(lx1,ly1,lz1,1)
     $        , rmult (lx1,ly1,lz1,1)
     $        , binv  (lx1,ly1,lz1,1)
C
      NTOT1 = lx1*ly1*lz1*NEL
C
      IF (EIGAA .NE. 0.0) THEN
         ACONDNO = EIGGA/EIGAA
      ELSE
         ACONDNO = 10.0
      endif
C
C     Check Single or double precision
C
      DELTA = 1.0E-9
      X     = 1.0 + DELTA
      Y     = 1.0
      DIFF  = ABS(X - Y)
      IF (DIFF .EQ. 0.0) EPS = 1.0E-6
      IF (DIFF .GT. 0.0) EPS = 1.0E-13
C
      CALL OPDOT (WA,R1,R2,R3,R1,R2,R3,NTOT1)
      RINIT = GLSC3(WA,BINV,RMULT,NTOT1)
      RINIT = SQRT (RINIT/VOL)
      RMIN  = EPS*RINIT
C
      IF (TOL.LT.RMIN) THEN
       TOLOLD = TOL
       TOL = RMIN
c       IF (NIO.EQ.0 .AND. IFPRINT)
c     $ WRITE(6,*)'New CG1(stress)-tolerance (RINIT*epsm) = ',TOL,TOLOLD
      endif
C
      IF (ldim.EQ.2) THEN
         CALL ADD3 (WA,RMASK1,RMASK2,NTOT1)
      ELSE
         CALL ADD4 (WA,RMASK1,RMASK2,RMASK3,NTOT1)
      endif
      BCNEU1 = GLSC2 (WA,RMULT,NTOT1)
      BCNEU2 = (ldim) * GLSUM(RMULT,NTOT1)
      BCTEST = ABS(BCNEU1 - BCNEU2)
      IF (BCTEST .LT. 0.1) THEN
         IF (ldim.EQ.2) THEN
            CALL ADD3 (WA,R1,R2,NTOT1)
         ELSE
            CALL ADD4 (WA,R1,R2,R3,NTOT1)
         endif
         OTR    = GLSC2(WA,RMULT,NTOT1) / ( ldim )
         TOLMIN = ABS(OTR) * ACONDNO
         IF (TOL .LT. TOLMIN) THEN
            TOLOLD = TOL
            TOL = TOLMIN
c            IF (NIO.EQ.0)
c     $      WRITE (6,*) 'New CG1(stress)-tolerance (OTR) = ',TOL,TOLOLD
         endif
      endif
C
      return
      end
c-----------------------------------------------------------------------
      subroutine axhmsf (au1,au2,au3,u1,u2,u3,h1,h2,matmod)

C     Compute the coupled Helmholtz matrix-vector products

C     Fluid (MATMOD .GE. 0) :  Hij Uj = Aij*Uj + H2*B*Ui 
C     Solid (MATMOD .LT. 0) :  Hij Uj = Kij*Uj
C
C-----------------------------------------------------------------------
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'MASS'
      include 'TSTEP'
      include 'CTIMER'

      common /fastmd/ ifdfrm(lelt), iffast(lelt), ifh2, ifsolv
      logical ifdfrm, iffast, ifh2, ifsolv
C
      dimension au1(lx1,ly1,lz1,1)
     $        , au2(lx1,ly1,lz1,1)
     $        , au3(lx1,ly1,lz1,1)
     $        , u1 (lx1*ly1*lz1*1)
     $        , u2 (lx1*ly1*lz1*1)
     $        , u3 (lx1*ly1*lz1*1)
     $        , h1 (lx1,ly1,lz1,1)
     $        , h2 (lx1,ly1,lz1,1)

      naxhm = naxhm + 1
      etime1 = dnekclock()

      nel   = nelfld(ifield)
      ntot1 = lx1*ly1*lz1*nel

c      if (ifaxis.and.ifsplit) call exitti(
c     $'Axisymmetric stress w/PnPn not yet supported.$',istep)

c     icase = 1 --- axsf_fast (no axisymmetry)
c     icase = 2 --- stress formulation and supports axisymmetry
c     icase = 3 --- 3 separate axhelm calls

      icase = 1                ! Fast mode for stress
      if (ifaxis)      icase=2 ! Slow for stress, but supports axisymmetry
      if (matmod.lt.0) icase=2 ! Elasticity case
c     if (matmod.lt.0) icase=3 ! Block-diagonal Axhelm
      if (matmod.lt.0) icase=1 ! Elasticity case (faster, 7/28/17,pff)
      if (.not.ifstrs) icase=3 ! Block-diagonal Axhelm

      if (icase.eq.1) then

        call axsf_fast(au1,au2,au3,u1,u2,u3,h1,h2,ifield)

      elseif (icase.eq.3) then

        call axhelm(au1,u1,h1,h2,1,1)
        call axhelm(au2,u2,h1,h2,1,2)
        if (if3d) call axhelm(au3,u3,h1,h2,1,3)

      else  !  calculate coupled  Aij Uj  products

        if ( .not.ifsolv ) call setfast (h1,h2,imesh)

        call stnrate (u1,u2,u3,nel,matmod)
        call stress  (h1,h2,nel,matmod,ifaxis)
        call aijuj   (au1,au2,au3,nel,ifaxis)

        if (ifh2 .and. matmod.ge.0) then ! add Helmholtz contributions
           call addcol4 (au1,bm1,h2,u1,ntot1)
           call addcol4 (au2,bm1,h2,u2,ntot1)
           if (ldim.eq.3) call addcol4 (au3,bm1,h2,u3,ntot1)
        endif

      endif

      taxhm=taxhm+(dnekclock()-etime1)

      return
      end
c-----------------------------------------------------------------------
      subroutine stnrate (u1,u2,u3,nel,matmod)
C
C     Compute strainrates
C
C     CAUTION : Stresses and strainrates share the same scratch commons
C
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'TSTEP'

      common /ctmp0/ exz(lx1*ly1*lz1*lelt)
     $             , eyz(lx1*ly1*lz1*lelt)
      common /ctmp1/ exx(lx1*ly1*lz1*lelt)
     $             , exy(lx1*ly1*lz1*lelt)
     $             , eyy(lx1*ly1*lz1*lelt)
     $             , ezz(lx1*ly1*lz1*lelt)
c
      dimension u1(lx1,ly1,lz1,1)
     $        , u2(lx1,ly1,lz1,1)
     $        , u3(lx1,ly1,lz1,1)
C
      NTOT1 = lx1*ly1*lz1*NEL

      CALL RZERO3 (EXX,EYY,EZZ,NTOT1)
      CALL RZERO3 (EXY,EXZ,EYZ,NTOT1)

      CALL UXYZ  (U1,EXX,EXY,EXZ,NEL)
      CALL UXYZ  (U2,EXY,EYY,EYZ,NEL)
      IF (ldim.EQ.3) CALL UXYZ   (U3,EXZ,EYZ,EZZ,NEL)

      CALL INVCOL2 (EXX,JACM1,NTOT1)
      CALL INVCOL2 (EXY,JACM1,NTOT1)
      CALL INVCOL2 (EYY,JACM1,NTOT1)
 
      IF (IFAXIS) CALL AXIEZZ (U2,EYY,EZZ,NEL)
C
      IF (ldim.EQ.3) THEN
         CALL INVCOL2 (EXZ,JACM1,NTOT1)
         CALL INVCOL2 (EYZ,JACM1,NTOT1)
         CALL INVCOL2 (EZZ,JACM1,NTOT1)
      endif
C
      return
      end
c-----------------------------------------------------------------------
      subroutine stress (h1,h2,nel,matmod,ifaxis)
C
C     MATMOD.GE.0        Fluid material models
C     MATMOD.LT.0        Solid material models
C
C     CAUTION : Stresses and strainrates share the same scratch commons
C
      include 'SIZE'
      common /ctmp1/ txx(lx1,ly1,lz1,lelt)
     $             , txy(lx1,ly1,lz1,lelt)
     $             , tyy(lx1,ly1,lz1,lelt)
     $             , tzz(lx1,ly1,lz1,lelt)
      common /ctmp0/ txz(lx1,ly1,lz1,lelt)
     $             , tyz(lx1,ly1,lz1,lelt)
      common /scrsf/ t11(lx1,ly1,lz1,lelt)
     $             , t22(lx1,ly1,lz1,lelt)
     $             , t33(lx1,ly1,lz1,lelt)
     $             , hii(lx1,ly1,lz1,lelt)
C
      DIMENSION H1(LX1,LY1,LZ1,1),H2(LX1,LY1,LZ1,1)
      LOGICAL IFAXIS

      NTOT1 = lx1*ly1*lz1*NEL

      IF (MATMOD.EQ.0) THEN

C        Newtonian fluids

         CONST = 2.0
         CALL CMULT2 (HII,H1,CONST,NTOT1)
         CALL COL2   (TXX,HII,NTOT1)
         CALL COL2   (TXY,H1 ,NTOT1)
         CALL COL2   (TYY,HII,NTOT1)
         IF (IFAXIS .OR. ldim.EQ.3) CALL COL2 (TZZ,HII,NTOT1)
         IF (ldim.EQ.3) THEN
            CALL COL2 (TXZ,H1 ,NTOT1)
            CALL COL2 (TYZ,H1 ,NTOT1)
         endif
C
      ELSEIF (MATMOD.EQ.-1) THEN
C
C        Elastic solids
C
         CONST = 2.0
         CALL ADD3S   (HII,H1,H2,CONST,NTOT1)
         CALL COPY    (T11,TXX,NTOT1)
         CALL COPY    (T22,TYY,NTOT1)
         CALL COL3    (TXX,HII,T11,NTOT1)
         CALL ADDCOL3 (TXX,H1 ,T22,NTOT1)
         CALL COL3    (TYY,H1 ,T11,NTOT1)
         CALL ADDCOL3 (TYY,HII,T22,NTOT1)
         CALL COL2    (TXY,H2     ,NTOT1)
         IF (IFAXIS .OR. ldim.EQ.3) THEN
            CALL COPY (T33,TZZ,NTOT1)
            CALL COL3    (TZZ,H1 ,T11,NTOT1)
            CALL ADDCOL3 (TZZ,H1 ,T22,NTOT1)
            CALL ADDCOL3 (TZZ,HII,T33,NTOT1)
            CALL ADDCOL3 (TXX,H1 ,T33,NTOT1)
            CALL ADDCOL3 (TYY,H1 ,T33,NTOT1)
         endif
         IF (ldim.EQ.3) THEN
            CALL COL2 (TXZ,H2     ,NTOT1)
            CALL COL2 (TYZ,H2     ,NTOT1)
         endif
C
      endif
C
      return
      end
c-----------------------------------------------------------------------
      subroutine aijuj (au1,au2,au3,nel,ifaxis)
C
      include 'SIZE'
      common /ctmp1/ txx(lx1,ly1,lz1,lelt)
     $             , txy(lx1,ly1,lz1,lelt)
     $             , tyy(lx1,ly1,lz1,lelt)
     $             , tzz(lx1,ly1,lz1,lelt)
      common /ctmp0/ txz(lx1,ly1,lz1,lelt)
     $             , tyz(lx1,ly1,lz1,lelt)
C
      DIMENSION AU1(LX1,LY1,LZ1,1)
     $        , AU2(LX1,LY1,LZ1,1)
     $        , AU3(LX1,LY1,LZ1,1)
      LOGICAL IFAXIS
C
      CALL TTXYZ (AU1,TXX,TXY,TXZ,NEL)
      CALL TTXYZ (AU2,TXY,TYY,TYZ,NEL)
      IF (IFAXIS)    CALL AXITZZ (AU2,TZZ,NEL)
      IF (ldim.EQ.3) CALL TTXYZ  (AU3,TXZ,TYZ,TZZ,NEL)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine uxyz (u,ex,ey,ez,nel)
C
      include 'SIZE'
      include 'GEOM'
      common /scrsf/ ur(lx1,ly1,lz1,lelt)
     $             , us(lx1,ly1,lz1,lelt)
     $             , ut(lx1,ly1,lz1,lelt)
c
      dimension u (lx1,ly1,lz1,1)
     $        , ex(lx1,ly1,lz1,1)
     $        , ey(lx1,ly1,lz1,1)
     $        , ez(lx1,ly1,lz1,1)
C
      NTOT1 = lx1*ly1*lz1*NEL
C
      CALL URST (U,UR,US,UT,NEL)
C
      CALL ADDCOL3 (EX,RXM1,UR,NTOT1)
      CALL ADDCOL3 (EX,SXM1,US,NTOT1)
      CALL ADDCOL3 (EY,RYM1,UR,NTOT1)
      CALL ADDCOL3 (EY,SYM1,US,NTOT1)
C
      IF (ldim.EQ.3) THEN
         CALL ADDCOL3 (EZ,RZM1,UR,NTOT1)
         CALL ADDCOL3 (EZ,SZM1,US,NTOT1)
         CALL ADDCOL3 (EZ,TZM1,UT,NTOT1)
         CALL ADDCOL3 (EX,TXM1,UT,NTOT1)
         CALL ADDCOL3 (EY,TYM1,UT,NTOT1)
      endif
C
      return
      end
      subroutine urst (u,ur,us,ut,nel)
C
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
C
      DIMENSION U (LX1,LY1,LZ1,1)
     $        , UR(LX1,LY1,LZ1,1)
     $        , US(LX1,LY1,LZ1,1)
     $        , UT(LX1,LY1,LZ1,1)
C
      DO 100 IEL=1,NEL
         IF (IFAXIS) CALL SETAXDY ( IFRZER(IEL) )
         CALL DDRST (U (1,1,1,IEL),UR(1,1,1,IEL),
     $               US(1,1,1,IEL),UT(1,1,1,IEL))
  100 CONTINUE
C
      return
      end
      subroutine ddrst (u,ur,us,ut)
C
      include 'SIZE'
      include 'DXYZ'
C
      DIMENSION U (LX1,LY1,LZ1)
     $        , UR(LX1,LY1,LZ1)
     $        , US(LX1,LY1,LZ1)
     $        , UT(LX1,LY1,LZ1)
C
      NXY1 = lx1*ly1
      NYZ1 = ly1*lz1
C
      CALL MXM (DXM1,lx1,U,lx1,UR,NYZ1)
      IF (ldim.EQ.2) THEN
         CALL MXM (U,lx1,DYTM1,ly1,US,ly1)
      ELSE
         DO 10 IZ=1,lz1
         CALL MXM (U(1,1,IZ),lx1,DYTM1,ly1,US(1,1,IZ),ly1)
   10    CONTINUE
         CALL MXM (U,NXY1,DZTM1,lz1,UT,lz1)
      endif
C
      return
      end
      subroutine axiezz (u2,eyy,ezz,nel)
C
      include 'SIZE'
      include 'GEOM'
C
      DIMENSION U2 (LX1,LY1,LZ1,1)
     $        , EYY(LX1,LY1,LZ1,1)
     $        , EZZ(LX1,LY1,LZ1,1)
C
      NXYZ1  = lx1*ly1*lz1
C
      DO 100 IEL=1,NEL
         IF ( IFRZER(IEL) ) THEN
            DO 200 IX=1,lx1
               EZZ(IX, 1,1,IEL) = EYY(IX,1,1,IEL)
            DO 200 IY=2,ly1
               EZZ(IX,IY,1,IEL) = U2(IX,IY,1,IEL) / YM1(IX,IY,1,IEL)
  200       CONTINUE
         ELSE
            CALL INVCOL3 (EZZ(1,1,1,IEL),U2(1,1,1,IEL),YM1(1,1,1,IEL),
     $                    NXYZ1)
         endif
  100 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine flush_io
      return
      end
c-----------------------------------------------------------------------
      subroutine fcsum2(xsum,asum,x,e,f)
c
c     Compute the weighted sum of X over face f of element e
c
c     x is an (NX,NY,NZ) data structure
c     f  is in the preprocessor notation 
c
c     xsum is sum (X*area)
c     asum is sum (area)


      include 'SIZE'
      include 'GEOM'
      include 'TOPOL'
      real x(lx1,ly1,lz1,1)
      integer e,f,fd

      asum = 0.
      xsum = 0.

c     Set up counters ;  fd is the dssum notation.
      call dsset(lx1,ly1,lz1)
      fd     = eface1(f)
      js1    = skpdat(1,fd)
      jf1    = skpdat(2,fd)
      jskip1 = skpdat(3,fd)
      js2    = skpdat(4,fd)
      jf2    = skpdat(5,fd)
      jskip2 = skpdat(6,fd)

      i = 0
      do j2=js2,jf2,jskip2
      do j1=js1,jf1,jskip1
         i = i+1
         xsum = xsum+area(i,1,f,e)*x(j1,j2,1,e)
         asum = asum+area(i,1,f,e)
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      function surf_mean(u,ifld,bc_in,ierr)

      include 'SIZE'
      include 'TOTAL'

      real u(1)

      integer e,f
      character*3 bc_in

      usum = 0
      asum = 0

      nface = 2*ldim
      do e=1,nelfld(ifld)
      do f=1,nface
         if (cbc(f,e,ifld).eq.bc_in) then
            call fcsum2(usum_f,asum_f,u,e,f)
            usum = usum + usum_f
            asum = asum + asum_f
         endif
      enddo
      enddo

      usum = glsum(usum,1)  ! sum across processors
      asum = glsum(asum,1)

      surf_mean = usum
      ierr      = 1

      if (asum.gt.0) surf_mean = usum/asum
      if (asum.gt.0) ierr      = 0

      return
      end
c-----------------------------------------------------------------------
      subroutine fdm_h1a(z,r,d,nel,kt,rr)
      include 'SIZE'
      include 'TOTAL'
c
      common /ctmp0/ w(lx1,ly1,lz1)
c
      include 'FDMH1'
c
c     Overlapping Schwarz, FDM based
c
      real z(lx1,ly1,lz1,1)
      real r(lx1,ly1,lz1,1)
      real d(lx1,ly1,lz1,1)
      real rr(lx1,ly1,lz1,1)

      integer kt(lelt,3)

      integer icalld
      save    icalld
      data    icalld /0/

      n1 = lx1
      n2 = lx1*lx1
      n3 = lx1*lx1*lx1
      n  = lx1*ly1*lz1*nel

      if (ifbhalf) then
         call col3(rr,r,bhalf,n)
      else
         call copy(rr,r,n)
      endif
      icalld = icalld+1
c
c
      do ie=1,nel
         if (if3d) then
c           Transfer to wave space:  
            call mxm(fdst(1,kt(ie,1)),n1,rr(1,1,1,ie),n1,w,n2)
            do iz=1,n1
              call mxm(w(1,1,iz),n1,fds (1,kt(ie,2)),n1,z(1,1,iz,ie),n1)
            enddo
            call mxm(z(1,1,1,ie),n2,fds (1,kt(ie,3)),n1,w,n1)
c
c           fdsolve:
c
            call col2(w,d(1,1,1,ie),n3)
c
c           Transfer to physical space:  
c
            call mxm(w,n2,fdst(1,kt(ie,3)),n1,z(1,1,1,ie),n1)
            do iz=1,n1
              call mxm(z(1,1,iz,ie),n1,fdst(1,kt(ie,2)),n1,w(1,1,iz),n1)
            enddo
            call mxm(fds (1,kt(ie,1)),n1,w,n1,z(1,1,1,ie),n2)
c
         else
c           Transfer to wave space:  
            call mxm(fdst(1,kt(ie,1)),n1,rr(1,1,1,ie),n1,w,n1)
            call mxm(w,n1,fds (1,kt(ie,2)),n1,z(1,1,1,ie),n1)
c
c           fdsolve:
c
            call col2(z(1,1,1,ie),d(1,1,1,ie),n2)
c
c           Transfer to physical space:  
c
            call mxm(z(1,1,1,ie),n1,fdst(1,kt(ie,2)),n1,w,n1)
            call mxm(fds (1,kt(ie,1)),n1,w,n1,z(1,1,1,ie),n1)
c
         endif
      enddo

      if (ifbhalf) call col2(z,bhalf,n)

      call dssum(z,lx1,ly1,lz1)

      return
      end
c-----------------------------------------------------------------------
      subroutine set_vert_strs(glo_num,ngv,nx,nel,vertex,ifcenter)

c     Given global array, vertex, pointing to hex vertices, set up
c     a new array of global pointers for an nx^ldim set of elements.

      include 'SIZE'
      include 'INPUT'

      integer*8 glo_num(1),ngv
      integer vertex(1),nx
      logical ifcenter

      common /ctmp0/ gnum(lx1*ly1*lz1*lelt)
      integer*8 gnum

      call set_vert(gnum,ngv,nx,nel,vertex,ifcenter)

      n=nel*nx*nx
      if (if3d) n=n*nx

c     Pack vertex ids component-wise (u,v,w_1; u,v,w_2; etc.)

      k=0
      do i=1,n

         do j=1,ldim
            glo_num(k+j) = ldim*(gnum(i)-1) + j
         enddo
         k=k+ldim

      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine get_strs_mask(mask,nxc,nzc,nel)
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'

      real mask(ldim,nxc,nxc,nzc,nel)
      integer e


      if (if3d) then
         do e=1,nel
         do kc=1,nxc
         do jc=1,nxc
         do ic=1,nxc
            k = 1 + ((lx1-1)*(kc-1))/(nxc-1)
            j = 1 + ((lx1-1)*(jc-1))/(nxc-1)
            i = 1 + ((lx1-1)*(ic-1))/(nxc-1)
            mask(1,ic,jc,kc,e) = v1mask(i,j,k,e)
            mask(2,ic,jc,kc,e) = v2mask(i,j,k,e)
            mask(3,ic,jc,kc,e) = v3mask(i,j,k,e)
         enddo
         enddo
         enddo
         enddo
      else
         do e=1,nel
         do jc=1,nxc
         do ic=1,nxc
            j = 1 + ((lx1-1)*(jc-1))/(nxc-1)
            i = 1 + ((lx1-1)*(ic-1))/(nxc-1)
            mask(1,ic,jc,1,e) = v1mask(i,j,1,e)
            mask(2,ic,jc,1,e) = v2mask(i,j,1,e)
         enddo
         enddo
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine axstrs(a1,a2,a3,p1,p2,p3,h1,h2,matmod,nel)
      real a1(1),a2(1),a3(1),p1(1),p2(1),p3(1)

      call axhmsf  (a1,a2,a3,p1,p2,p3,h1,h2,matmod)
      call rmask   (a1,a2,a3,nel)
      call opdssum (a1,a2,a3)

      return
      end
c-----------------------------------------------------------------------
      subroutine axstrs_nds(a1,a2,a3,p1,p2,p3,h1,h2,matmod,nel)
      real a1(1),a2(1),a3(1),p1(1),p2(1),p3(1)

      call rmask   (p1,p2,p3,nel)
      call axhmsf  (a1,a2,a3,p1,p2,p3,h1,h2,matmod)
      call rmask   (a1,a2,a3,nel)
c     call opdssum (a1,a2,a3)

      return
      end
c-----------------------------------------------------------------------
      subroutine get_local_crs_galerkin_strs(a,ncl,nxc,h1,h2,matmod)

c     This routine generates Nelv submatrices of order ncl using
c     Galerkin projection

      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'


      real    a(ldim,ncl,ldim,ncl,1),h1(1),h2(1)
c     real    a(ncl,ldim,ncl,ldim,1),h1(1),h2(1)

      common /scrcr2/ a1(lx1*ly1*lz1,lelt),w1(lx1*ly1*lz1,lelt)
     $              , a2(lx1*ly1*lz1,lelt),w2(lx1*ly1*lz1,lelt)
      common /scrcr3/ a3(lx1*ly1*lz1,lelt),w3(lx1*ly1*lz1,lelt)
     $              , b (lx1*ly1*lz1,8)

      integer e

      nel = nelfld(ifield)

      do j=1,ncl ! bi- or tri-linear interpolant, ONLY
         call gen_crs_basis(b(1,j),j)
      enddo

      nxyz = lx1*ly1*lz1
      do k = 1,ldim
       call opzero(w1,w2,w3)
       call opzero(a1,a2,a3)

       do j = 1,ncl

         do e = 1,nel
            if (k.eq.1) call copy(w1(1,e),b(1,j),nxyz)
            if (k.eq.2) call copy(w2(1,e),b(1,j),nxyz)
            if (k.eq.3) call copy(w3(1,e),b(1,j),nxyz)
         enddo

         call axstrs_nds(a1,a2,a3,w1,w2,w3,h1,h2,matmod,nel)

         do e = 1,nel
         do i = 1,ncl

            a(1,i,k,j,e)=vlsc2(b(1,i),a1(1,e),nxyz)  ! bi^T * A^e * bj
            a(2,i,k,j,e)=vlsc2(b(1,i),a2(1,e),nxyz)  ! bi^T * A^e * bj
            if (if3d)
     $      a(3,i,k,j,e)=vlsc2(b(1,i),a3(1,e),nxyz)  ! bi^T * A^e * bj

         enddo
         enddo

       enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine crs_strs(u1,u2,u3,v1,v2,v3)
c     Given an input vector v, this generates the H1 coarse-grid solution
      include 'SIZE'
      include 'DOMAIN'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'PARALLEL'
      include 'CTIMER'
      include 'TSTEP'

      real u1(1),u2(1),u3(1),v1(1),v2(1),v3(1)

      common /scrpr3/ uc1(lcr*lelt),uc2(lcr*lelt),uc3(lcr*lelt)
      common /scrpr2/ vc1(lcr*lelt),vc2(lcr*lelt),vc3(lcr*lelt)

      integer icalld1
      save    icalld1
      data    icalld1 /0/

      
      if (icalld1.eq.0) then ! timer info
         ncrsl=0
         tcrsl=0.0
         icalld1=1
      endif
      ncrsl  = ncrsl  + 1

      n = nelv*lx1*ly1*lz1
      m = nelv*lcr

      call map_f_to_c_h1_bilin(uc1,v1)   ! additive Schwarz
      call map_f_to_c_h1_bilin(uc2,v2)   ! additive Schwarz
      if (if3d) call map_f_to_c_h1_bilin(uc3,v3)   ! additive Schwarz

      k=0
      if (if3d) then
         do i=1,m
            vc1(k+1)=uc1(i)
            vc1(k+2)=uc2(i)
            vc1(k+3)=uc3(i)
            k=k+3
         enddo
      else
         do i=1,m
            vc1(k+1)=uc1(i)
            vc1(k+2)=uc2(i)
            k=k+2
         enddo
      endif

      etime1=dnekclock()
      call fgslib_crs_solve(xxth_strs,uc1,vc1)
      tcrsl=tcrsl+dnekclock()-etime1

      k=0
      if (if3d) then
         do i=1,m
            vc1(i)=uc1(k+1)
            vc2(i)=uc1(k+2)
            vc3(i)=uc1(k+3)
            k=k+3
         enddo
      else
         do i=1,m
            vc1(i)=uc1(k+1)
            vc2(i)=uc1(k+2)
            k=k+2
         enddo
      endif
      call map_c_to_f_h1_bilin(u1,vc1)
      call map_c_to_f_h1_bilin(u2,vc2)
      if (if3d) call map_c_to_f_h1_bilin(u3,vc3)

      return
      end
c-----------------------------------------------------------------------
      subroutine set_up_h1_crs_strs(h1,h2,ifld,matmod)

      include 'SIZE'
      include 'GEOM'
      include 'DOMAIN'
      include 'INPUT'
      include 'PARALLEL'
      include 'TSTEP'
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      common /ivrtx/ vertex ((2**ldim)*lelt)
      integer vertex

      integer null_space,e

      character*3 cb
      common /scrxxti/ ia(ldim*ldim*lcr*lcr*lelv)
     $               , ja(ldim*ldim*lcr*lcr*lelv)

      parameter (lcc=2**ldim)
      common /scrcr1/ a(ldim*ldim*lcc*lcc*lelt)
      real mask(ldim,lcr,lelv)
      equivalence (mask,a)

      integer*8 ngv

      t0 = dnekclock()

      nel = nelfld(ifld)

      nxc = 2
      nzc = 1
      if (if3d) nzc=nxc

      ncr = nxc**ldim
      mcr = ldim*ncr  ! Dimension of unassembled sub-block
      n   = mcr*nel

c     Set SEM_to_GLOB index
      call get_vertex
      call set_vert_strs(se_to_gcrs,ngv,nxc,nel,vertex,.true.)


c     Set mask for full array
      call get_strs_mask   (mask,nxc,nzc,nel) ! Set mask
      call set_jl_crs_mask (n,mask,se_to_gcrs)


c     Setup local SEM-based Neumann operators (for now, just full...)
      call get_local_crs_galerkin_strs(a,ncr,nxc,h1,h2,matmod)
      call set_mat_ij(ia,ja,mcr,nel)
      nnz=mcr*mcr*nel

      null_space=0

      t1 = dnekclock()-t0
      if (nio.eq.0) 
     $  write(6,*) 'start:: setup h1 coarse grid ',t1, ' sec'
     $             ,nnz,mcr,ncr,nel

      do i=1,nnz
         write(44,44) ia(i),ja(i),a(i)
      enddo
   44 format(2i9,1pe22.13)
c     stop

      imode = param(40)
      call fgslib_crs_setup(xxth_strs,imode,nekcomm,mp,n,se_to_gcrs,
     $                      nnz,ia,ja,a,null_space)

      t0 = dnekclock()-t0
      if (nio.eq.0) then
         write(6,*) 'done :: setup h1 coarse grid ',t0, ' sec',xxth_strs
         write(6,*) ' '
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine axsf_e_3d(au,av,aw,u,v,w,h1,h2,ur,e)
c
c                                         du_i
c     Compute the gradient tensor G_ij := ----  ,  for element e
c                                         du_j
c
      include 'SIZE'
      include 'TOTAL'

      real au(1),av(1),aw(1),u(1),v(1),w(1),h1(1),h2(1)

      parameter (l=lx1*ly1*lz1)
      real ur(l,ldim,ldim)

      integer e,p

      p = lx1-1      ! Polynomial degree
      n = lx1*ly1*lz1


      call local_grad3(ur(1,1,1),ur(1,2,1),ur(1,3,1),u,p,1,dxm1,dxtm1)
      call local_grad3(ur(1,1,2),ur(1,2,2),ur(1,3,2),v,p,1,dxm1,dxtm1)
      call local_grad3(ur(1,1,3),ur(1,2,3),ur(1,3,3),w,p,1,dxm1,dxtm1)

      do i=1,n

         u1 = ur(i,1,1)*rxm1(i,1,1,e) + ur(i,2,1)*sxm1(i,1,1,e)
     $                                + ur(i,3,1)*txm1(i,1,1,e)
         u2 = ur(i,1,1)*rym1(i,1,1,e) + ur(i,2,1)*sym1(i,1,1,e)
     $                                + ur(i,3,1)*tym1(i,1,1,e)
         u3 = ur(i,1,1)*rzm1(i,1,1,e) + ur(i,2,1)*szm1(i,1,1,e)
     $                                + ur(i,3,1)*tzm1(i,1,1,e)

         v1 = ur(i,1,2)*rxm1(i,1,1,e) + ur(i,2,2)*sxm1(i,1,1,e)
     $                                + ur(i,3,2)*txm1(i,1,1,e)
         v2 = ur(i,1,2)*rym1(i,1,1,e) + ur(i,2,2)*sym1(i,1,1,e)
     $                                + ur(i,3,2)*tym1(i,1,1,e)
         v3 = ur(i,1,2)*rzm1(i,1,1,e) + ur(i,2,2)*szm1(i,1,1,e)
     $                                + ur(i,3,2)*tzm1(i,1,1,e)

         w1 = ur(i,1,3)*rxm1(i,1,1,e) + ur(i,2,3)*sxm1(i,1,1,e)
     $                                + ur(i,3,3)*txm1(i,1,1,e)
         w2 = ur(i,1,3)*rym1(i,1,1,e) + ur(i,2,3)*sym1(i,1,1,e)
     $                                + ur(i,3,3)*tym1(i,1,1,e)
         w3 = ur(i,1,3)*rzm1(i,1,1,e) + ur(i,2,3)*szm1(i,1,1,e)
     $                                + ur(i,3,3)*tzm1(i,1,1,e)

         dj  = h1(i)*w3m1(i,1,1)*jacmi(i,e)
         s11 = dj*(u1 + u1)! S_ij
         s12 = dj*(u2 + v1)
         s13 = dj*(u3 + w1)
         s21 = dj*(v1 + u2)
         s22 = dj*(v2 + v2)
         s23 = dj*(v3 + w2)
         s31 = dj*(w1 + u3)
         s32 = dj*(w2 + v3)
         s33 = dj*(w3 + w3)

c        Sum_j : (r_p/x_j) h1 J S_ij

         ur(i,1,1)=rxm1(i,1,1,e)*s11+rym1(i,1,1,e)*s12+rzm1(i,1,1,e)*s13
         ur(i,2,1)=sxm1(i,1,1,e)*s11+sym1(i,1,1,e)*s12+szm1(i,1,1,e)*s13
         ur(i,3,1)=txm1(i,1,1,e)*s11+tym1(i,1,1,e)*s12+tzm1(i,1,1,e)*s13

         ur(i,1,2)=rxm1(i,1,1,e)*s21+rym1(i,1,1,e)*s22+rzm1(i,1,1,e)*s23
         ur(i,2,2)=sxm1(i,1,1,e)*s21+sym1(i,1,1,e)*s22+szm1(i,1,1,e)*s23
         ur(i,3,2)=txm1(i,1,1,e)*s21+tym1(i,1,1,e)*s22+tzm1(i,1,1,e)*s23

         ur(i,1,3)=rxm1(i,1,1,e)*s31+rym1(i,1,1,e)*s32+rzm1(i,1,1,e)*s33
         ur(i,2,3)=sxm1(i,1,1,e)*s31+sym1(i,1,1,e)*s32+szm1(i,1,1,e)*s33
         ur(i,3,3)=txm1(i,1,1,e)*s31+tym1(i,1,1,e)*s32+tzm1(i,1,1,e)*s33

      enddo
      call local_grad3_t
     $    (au,ur(1,1,1),ur(1,2,1),ur(1,3,1),p,1,dxm1,dxtm1,av)
      call local_grad3_t
     $    (av,ur(1,1,2),ur(1,2,2),ur(1,3,2),p,1,dxm1,dxtm1,ur)
      call local_grad3_t
     $    (aw,ur(1,1,3),ur(1,2,3),ur(1,3,3),p,1,dxm1,dxtm1,ur)

      do i=1,n
         au(i)=au(i) + h2(i)*bm1(i,1,1,e)*u(i)
         av(i)=av(i) + h2(i)*bm1(i,1,1,e)*v(i)
         aw(i)=aw(i) + h2(i)*bm1(i,1,1,e)*w(i)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine axsf_e_2d(au,av,u,v,h1,h2,ur,e)
c
c                                         du_i
c     Compute the gradient tensor G_ij := ----  ,  for element e
c                                         du_j
c
      include 'SIZE'
      include 'TOTAL'

      real au(1),av(1),u(1),v(1),h1(1),h2(1)

      parameter (l=lx1*ly1*lz1)
      real ur(l,ldim,ldim)

      integer e,p

      p = lx1-1      ! Polynomial degree
      n = lx1*ly1*lz1


      call local_grad2(ur(1,1,1),ur(1,2,1),u,p,1,dxm1,dxtm1)
      call local_grad2(ur(1,1,2),ur(1,2,2),v,p,1,dxm1,dxtm1)

      do i=1,n
         dj = h1(i)*w3m1(i,1,1)*jacmi(i,e)

         u1 = ur(i,1,1)*rxm1(i,1,1,e) + ur(i,2,1)*sxm1(i,1,1,e) !ux
         u2 = ur(i,1,1)*rym1(i,1,1,e) + ur(i,2,1)*sym1(i,1,1,e) !uy
         v1 = ur(i,1,2)*rxm1(i,1,1,e) + ur(i,2,2)*sxm1(i,1,1,e) !vx
         v2 = ur(i,1,2)*rym1(i,1,1,e) + ur(i,2,2)*sym1(i,1,1,e) !vy

         s11 = dj*( u1 + u1 ) ! h1*rho*S_ij
         s12 = dj*( u2 + v1 )
         s21 = dj*( v1 + u2 )
         s22 = dj*( v2 + v2 )

c        Sum_j : (r_k/x_j) h1 J S_ij

         ur(i,1,1)=rxm1(i,1,1,e)*s11+rym1(i,1,1,e)*s12 ! i=1,k=1
         ur(i,2,1)=sxm1(i,1,1,e)*s11+sym1(i,1,1,e)*s12 ! i=1,k=2

         ur(i,1,2)=rxm1(i,1,1,e)*s21+rym1(i,1,1,e)*s22 ! i=2,k=1
         ur(i,2,2)=sxm1(i,1,1,e)*s21+sym1(i,1,1,e)*s22 ! i=2,k=2

      enddo

      call local_grad2_t(au,ur(1,1,1),ur(1,2,1),p,1,dxm1,dxtm1,av)
      call local_grad2_t(av,ur(1,1,2),ur(1,2,2),p,1,dxm1,dxtm1,ur)

      do i=1,n
         au(i)=au(i) + h2(i)*bm1(i,1,1,e)*u(i)
         av(i)=av(i) + h2(i)*bm1(i,1,1,e)*v(i)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine axsf_fast(au,av,aw,u,v,w,h1,h2,ifld)
      include 'SIZE'
      include 'TOTAL'

      parameter (l=lx1*ly1*lz1)
      real au(l,1),av(l,1),aw(l,1),u(l,1),v(l,1),w(l,1),h1(l,1),h2(l,1)

      common /btmp0/ ur(l,ldim,ldim)

      integer e

      nel = nelfld(ifld)

      if (if3d) then
        do e=1,nel
          call axsf_e_3d(au(1,e),av(1,e),aw(1,e),u(1,e),v(1,e),w(1,e)
     $                                         ,h1(1,e),h2(1,e),ur,e)
        enddo
      else
        do e=1,nel
          call axsf_e_2d(au(1,e),av(1,e),u(1,e),v(1,e)
     $                          ,h1(1,e),h2(1,e),ur,e)
        enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine ttxyz (ff,tx,ty,tz,nel)
C
      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
      include 'WZ'

      DIMENSION TX(LX1,LY1,LZ1,1)
     $        , TY(LX1,LY1,LZ1,1)
     $        , TZ(LX1,LY1,LZ1,1)
     $        , FF(LX1*LY1*LZ1,1)

      common /scrsf/ fr(lx1*ly1*lz1,lelt)
     $             , fs(lx1*ly1*lz1,lelt)
     $             , ft(lx1*ly1*lz1,lelt)
      real           wa(lx1,ly1,lz1,lelt)
      equivalence   (wa,ft)
      real ys(lx1)

      NXYZ1 = lx1*ly1*lz1
      NTOT1 = NXYZ1*NEL

      CALL COL3    (FR,RXM1,TX,NTOT1)
      CALL ADDCOL3 (FR,RYM1,TY,NTOT1)
      CALL COL3    (FS,SXM1,TX,NTOT1)
      CALL ADDCOL3 (FS,SYM1,TY,NTOT1)

      IF (ldim.EQ.3) THEN
         CALL ADDCOL3 (FR,RZM1,TZ,NTOT1)
         CALL ADDCOL3 (FS,SZM1,TZ,NTOT1)
         CALL COL3    (FT,TXM1,TX,NTOT1)
         CALL ADDCOL3 (FT,TYM1,TY,NTOT1)
         CALL ADDCOL3 (FT,TZM1,TZ,NTOT1)
      endif
C
      IF (IFAXIS) THEN
         DO 100 IEL=1,NEL
         IF ( IFRZER(IEL) ) THEN
            CALL MXM (YM1(1,1,1,IEL),lx1,DATM1,ly1,YS,1)
            DO 120 IX=1,lx1
               IY = 1
               WA(IX,IY,1,IEL)=YS(IX)*W2AM1(IX,IY)
            DO 120 IY=2,ly1
               DNR = 1.0 + ZAM1(IY)
               WA(IX,IY,1,IEL)=YM1(IX,IY,1,IEL)*W2AM1(IX,IY)/DNR
  120       CONTINUE
         ELSE
            CALL COL3 (WA(1,1,1,IEL),YM1(1,1,1,IEL),W2CM1,NXYZ1)
         endif
  100    CONTINUE
         CALL COL2 (FR,WA,NTOT1)      
         CALL COL2 (FS,WA,NTOT1)      
      else
         do 180 iel=1,nel
            call col2(fr(1,iel),w3m1,nxyz1)
            call col2(fs(1,iel),w3m1,nxyz1)
            call col2(ft(1,iel),w3m1,nxyz1)
  180    continue
      endif


      DO 200 IEL=1,NEL
         IF (IFAXIS) CALL SETAXDY ( IFRZER(IEL) )
         CALL TTRST (FF(1,IEL),FR(1,IEL),FS(1,IEL),
     $               FT(1,IEL),FR(1,IEL)) ! FR work array
  200 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine ttrst (ff,fr,fs,ft,ta)

      include 'SIZE'
      include 'DXYZ'
      include 'TSTEP'

      DIMENSION FF(LX1,LY1,LZ1)
     $        , FR(LX1,LY1,LZ1)
     $        , FS(LX1,LY1,LZ1)
     $        , FT(LX1,LY1,LZ1)
     $        , TA(LX1,LY1,LZ1)

      NXY1  = lx1*ly1
      NYZ1  = ly1*lz1
      NXYZ1 = NXY1*lz1

      CALL MXM (DXTM1,lx1,FR,lx1,FF,NYZ1)
      IF (ldim.EQ.2) THEN
         CALL MXM  (FS,lx1,DYM1,ly1,TA,ly1)
         CALL ADD2 (FF,TA,NXYZ1)
      ELSE
         DO 10 IZ=1,lz1
         CALL MXM  (FS(1,1,IZ),lx1,DYM1,ly1,TA(1,1,IZ),ly1)
   10    CONTINUE
         CALL ADD2 (FF,TA,NXYZ1)
         CALL MXM  (FT,NXY1,DZM1,lz1,TA,lz1)
         CALL ADD2 (FF,TA,NXYZ1)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine axitzz (vfy,tzz,nel)
C
      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'WZ'
      common /ctmp0/ phi(lx1,ly1)
C
      DIMENSION VFY(LX1,LY1,LZ1,1)
     $        , TZZ(LX1,LY1,LZ1,1)
C
      NXYZ1 = lx1*ly1*lz1
C
      DO 100 IEL=1,NEL
         CALL SETAXW1 ( IFRZER(IEL) )
         CALL COL4 (PHI,TZZ(1,1,1,IEL),JACM1(1,1,1,IEL),W3M1,NXYZ1)
         IF ( IFRZER(IEL) ) THEN
            DO 120 IX=1,lx1
            DO 120 IY=2,ly1
               DNR = PHI(IX,IY)/( 1.0 + ZAM1(IY) )
               DDS = WXM1(IX) * WAM1(1) * DATM1(IY,1) *
     $               JACM1(IX,1,1,IEL) * TZZ(IX,1,1,IEL)
               VFY(IX,IY,1,IEL)=VFY(IX,IY,1,IEL) + DNR + DDS
  120       CONTINUE
         ELSE
            CALL ADD2 (VFY(1,1,1,IEL),PHI,NXYZ1)
         endif
  100 CONTINUE
C
      return
      end
c-----------------------------------------------------------------------
      subroutine setaxdy (ifaxdy)
C
      include 'SIZE'
      include 'DXYZ'
C
      LOGICAL IFAXDY
C
      IF (IFAXDY) THEN
         CALL COPY (DYM1 ,DAM1 ,ly1*ly1)
         CALL COPY (DYTM1,DATM1,ly1*ly1)
      ELSE
         CALL COPY (DYM1 ,DCM1 ,ly1*ly1)
         CALL COPY (DYTM1,DCTM1,ly1*ly1)
      endif
C
      return
      end
c-----------------------------------------------------------------------
      function opnorm2w(v1,v2,v3,w)
      include 'SIZE'
      include 'TOTAL'
c
      real v1(1) , v2(1), v3(1), w(1)

      n=lx1*ly1*lz1*nelv
      s=vlsc3(v1,w,v1,n)+vlsc3(v2,w,v2,n)
      if(if3d) s=s+vlsc3(v3,w,v3,n)
      s=glsum(s,1)
      
      if (s.gt.0) s=sqrt(s/volvm1)
      opnorm2w = s

      return
      end
c-----------------------------------------------------------------------
      subroutine strs_project_a(b1,b2,b3,h1,h2,wt,ifld,ierr,matmod)

c     Assumes if uservp is true and thus reorthogonalizes every step

      include 'SIZE'
      include 'TOTAL'
      include 'ORTHOSTRS'  ! Storage of approximation space
      include 'CTIMER'

      real b1(1),b2(1),b3(1),h1(1),h2(1),wt(1)
      common /ctmp1/ w(lx1*ly1*lz1*lelt,ldim)
      real l2a,l2b

      kmax = napproxstrs(1)
      k    = napproxstrs(2)
      n    = lx1*ly1*lz1*nelv
      m    = n*ldim

      if (k.eq.0.or.kmax.eq.0) return

      etime0 = dnekclock()

      l2b=opnorm2w(b1,b2,b3,binvm1)

c     Reorthogonalize basis

      dh1max=difmax(bstrs(1  ),h1,n)
      call col3(bstrs,h2,bm1,n)
      dh2max=difmax(bstrs(1+n),bstrs,n)

      if (dh1max.gt.0.or.dh2max.gt.0) then
        call strs_ortho_all(xstrs(1+m),bstrs(1+m),n,k,h1,h2,wt,ifld,w
     $                   ,ierr,matmod)
      else
        call strs_ortho_one(xstrs(1+m),bstrs(1+m),n,k,h1,h2,wt,ifld,w
     $                   ,ierr,matmod)
      endif

      napproxstrs(2) = k

      call opcopy(bstrs(1),bstrs(1+n),bstrs(1+2*n),b1,b2,b3)
      call opzero(xstrs(1),xstrs(1+n),xstrs(1+2*n))

      do i=1,k
         i1 = 1 + 0*n + (i-1)*m + m
         i2 = 1 + 1*n + (i-1)*m + m
         i3 = 1 + 2*n + (i-1)*m + m
         alpha=op_glsc2_wt(bstrs(1),bstrs(1+n),bstrs(1+2*n)
     $                    ,xstrs(i1),xstrs(i2),xstrs(i3),wt)

         alphm=-alpha
         call opadds(bstrs(1),bstrs(1+n),bstrs(1+2*n)
     $              ,bstrs(i1),bstrs(i2),bstrs(i3),alphm,n,2)

         call opadds(xstrs(1),xstrs(1+n),xstrs(1+2*n)
     $              ,xstrs(i1),xstrs(i2),xstrs(i3),alpha,n,2)


      enddo

      call opcopy(b1,b2,b3,bstrs(1),bstrs(1+n),bstrs(1+2*n))
      l2a=opnorm2w(b1,b2,b3,binvm1)

      call copy(bstrs(1  ),h1,n)  ! Save h1 and h2 for comparison
      call col3(bstrs(1+n),bm1,h2,n)

      ratio=l2b/l2a
      if (nio.eq.0) write(6,1) istep,'  Project ' // 'HELM3 ',
     $              l2a,l2b,ratio,k,kmax
    1 format(i11,a,6x,1p3e13.4,i4,i4)

c     if (ierr.ne.0) call exitti(' h3proj quit$',ierr)

      tproj = tproj + dnekclock() - etime0

      return
      end
c-----------------------------------------------------------------------
      subroutine strs_project_b(x1,x2,x3,h1,h2,wt,ifld,ierr)

c     Reconstruct solution; don't bother to orthonomalize bases

      include 'SIZE'
      include 'TOTAL'
      include 'ORTHOSTRS'  ! Storage of approximation space
      include 'CTIMER'

      real x1(1),x2(1),x3(1),h1(1),h2(1),wt(1)
      common /cptst/ xs(lx1*ly1*lz1*lelt*ldim)

      kmax = napproxstrs(1)
      k    = napproxstrs(2)
      n    = lx1*ly1*lz1*nelv
      m    = n*ldim

      if (kmax.eq.0) return

      etime0 = dnekclock()

      if (k.eq.0) then                                          !      _
         call opadd2(x1,x2,x3,xstrs(1),xstrs(1+n),xstrs(1+2*n)) ! x=dx+x
         k=1
         k1 = 1 + 0*n + (k-1)*m + m
         k2 = 1 + 1*n + (k-1)*m + m
         k3 = 1 + 2*n + (k-1)*m + m
         call opcopy(xstrs(k1),xstrs(k2),xstrs(k3),x1,x2,x3)    ! x1=x^n
      elseif (k.eq.kmax) then                                   !      _
         call opadd2(x1,x2,x3,xstrs(1),xstrs(1+n),xstrs(1+2*n)) ! x=dx+x
         k=1
         k1 = 1 + 0*n + (k-1)*m + m
         k2 = 1 + 1*n + (k-1)*m + m
         k3 = 1 + 2*n + (k-1)*m + m
         call opcopy(xstrs(k1),xstrs(k2),xstrs(k3),x1,x2,x3)    ! x1=x^n
c        k=2
c        k1 = 1 + 0*n + (k-1)*m + m
c        k2 = 1 + 1*n + (k-1)*m + m
c        k3 = 1 + 2*n + (k-1)*m + m
c        call opcopy(xstrs(k1),xstrs(k2),xstrs(k3),xs(1),xs(1+n),xs(1+2*n))
      else
         k=k+1
         k1 = 1 + 0*n + (k-1)*m + m
         k2 = 1 + 1*n + (k-1)*m + m
         k3 = 1 + 2*n + (k-1)*m + m
         call opcopy(xstrs(k1),xstrs(k2),xstrs(k3),x1,x2,x3)    ! xk=dx  _
         call opadd2(x1,x2,x3,xstrs(1),xstrs(1+n),xstrs(1+2*n)) ! x=dx + x
      endif

c     if (k.eq.kmax) call opcopy(xs(1),xs(1+n),xs(1+2*n),x1,x2,x3) ! presave

      napproxstrs(2)=k

      tproj = tproj + dnekclock() - etime0

      return
      end
c-----------------------------------------------------------------------
      subroutine strs_orthok(x,b,n,k,h1,h2,wt,ifld,w,ierr,matmod)

c     Orthonormalize the kth element of X against x_j, j < k.

      include 'SIZE'
      include 'TOTAL'

      real x(n,ldim,k),b(n,ldim,k),h1(n),h2(n),wt(n),w(n,ldim)
      real al(mxprev),bt(mxprev)

      m   = n*ldim ! vector length
      nel = nelfld(ifld)

      call axhmsf   (b(1,1,k),b(1,2,k),b(1,3,k)
     $              ,x(1,1,k),x(1,2,k),x(1,3,k),h1,h2,matmod)
      call rmask    (b(1,1,k),b(1,2,k),b(1,3,k),nel)
      call opdssum  (b(1,1,k),b(1,2,k),b(1,3,k))

      xax0 = op_glsc2_wt(b(1,1,k),b(1,2,k),b(1,3,k)
     $                  ,x(1,1,k),x(1,2,k),x(1,3,k),wt)
      ierr = 3

      if (xax0.le.0.and.nio.eq.0)write(6,*)istep,ierr,k,xax0,'Proj3 ERR'
      if (xax0.le.0) return

      s = 0.
      do j=1,k-1! Modifed Gram-Schmidt

        betaj = ( op_vlsc2_wt(b(1,1,j),b(1,2,j),b(1,3,j)
     $                       ,x(1,1,k),x(1,2,k),x(1,3,k),wt)
     $          + op_vlsc2_wt(b(1,1,k),b(1,2,k),b(1,3,k)
     $                       ,x(1,1,j),x(1,2,j),x(1,3,j),wt))/2.
        betam = -glsum(betaj,1)
        call add2s2 (x(1,1,k),x(1,1,j),betam,m) ! Full-vector-subtract
        call add2s2 (b(1,1,k),b(1,1,j),betam,m) !

        s = s + betam**2

      enddo

      xax1 = xax0-s
      xax2 = op_glsc2_wt(b(1,1,k),b(1,2,k),b(1,3,k)
     $                  ,x(1,1,k),x(1,2,k),x(1,3,k),wt)
      scale = xax2

      eps  = 1.e-8
      ierr = 0
      if (scale/xax0.lt.eps) ierr=1

c      if(nio.eq.0) write(6,*) istep,ierr,k,scale,xax0,' SCALE'
c      if(nio.eq.0.and.(istep.lt.10.or.mod(istep,100).eq.0.or.ierr.gt.0))
c     $write(6,3) istep,k,ierr,xax1/xax0,xax2/xax0
c    3 format(i9,2i3,1p2e12.4,' scale ortho')

      if (scale.gt.0) then
         scale = 1./sqrt(scale)     
         call cmult(x(1,1,k),scale,m)
         call cmult(b(1,1,k),scale,m)
      else
         ierr=2
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine strs_ortho_one(x,b,n,k,h1,h2,wt,ifld,w,ierr,matmod)

      include 'SIZE'
      include 'TOTAL'

      real x(n,ldim,k),b(n,ldim,k),h1(n),h2(n),wt(n),w(n,ldim)

      m = n*ldim

      js=k
      do j=k,k
         if (js.lt.j) call copy(x(1,1,js),x(1,1,j),m)
         call strs_orthok(x,b,n,js,h1,h2,wt,ifld,w,ierr,matmod)
         if (ierr.eq.0) js=js+1
      enddo
      k = js-1

      return
      end
c-----------------------------------------------------------------------
      subroutine strs_ortho_all(x,b,n,k,h1,h2,wt,ifld,w,ierr,matmod)

      include 'SIZE'
      include 'TOTAL'

      real x(n,ldim,k),b(n,ldim,k),h1(n),h2(n),wt(n),w(n,ldim)

      m = n*ldim

      js=1
      do j=1,k
         if (js.lt.j) call copy(x(1,1,js),x(1,1,j),m)
         call strs_orthok(x,b,n,js,h1,h2,wt,ifld,w,ierr,matmod)
         if (ierr.eq.0) js=js+1
      enddo
      k = js-1

      return
      end
c-----------------------------------------------------------------------
      subroutine setprop
C------------------------------------------------------------------------
C
C     Set variable property arrays
C
C------------------------------------------------------------------------
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
C
C     Caution: 2nd and 3rd strainrate invariants residing in scratch
C              common /SCREV/ are used in STNRINV and NEKASGN
C
      common /screv/ sii (lx1,ly1,lz1,lelt),siii(lx1,ly1,lz1,lelt)

      if (nio.eq.0.and.loglevel.gt.2)
     $   write(6,*) 'setprop'

#ifdef TIMER
      if (icalld.eq.0) tspro=0.0
      icalld=icalld+1
      nspro=icalld
      etime1=dnekclock()
#endif

      NXYZ1 = lx1*ly1*lz1
      MFIELD=2
      IF (IFFLOW) MFIELD=1
      nfldt = nfield
      if (ifmhd) nfldt = nfield+1

      ifld = ifield

      do ifield=mfield,nfldt
         if (idpss(ifield-1).eq.-1) goto 100
         call vprops
 100     continue
      enddo

      ifield = ifld

#ifdef TIMER
      tspro=tspro+(dnekclock()-etime1)
#endif

      return
      end
c-----------------------------------------------------------------------

C> @file drive2_cmt.f mid-level initialization drivers. Not long for this world.
c-----------------------------------------------------------------------
      subroutine nek_cmt_init
      include 'SIZE'
      include 'TOTAL'
      include 'DG'
      include 'CMTDATA'
      if (nio.eq.0) write(6,*)'Set up CMT-Nek'    
      if (toteq.ne.5) then
         if (nio.eq.0) write(6,*)'toteq is low ! toteq = ',toteq
         if (nio.eq.0) write(6,*) 'Reset toteq in SIZE to 5'
         call exitt
      endif
      if (ifrestart) then
         ifheat = .true. ! almost certainly incorrect
      endif
      call setup_cmt_commo

      iostep2=iostep
      iostep=9999999
      
c     call setup_cmt_param
      return
      end

!-----------------------------------------------------------------------

      subroutine izero8(a,n)
      integer*8 a(1)
      do i=1,n
         a(i)=0
      enddo
      return
      end
!-----------------------------------------------------------------------
      subroutine setup_cmt_param
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'CMTDATA'
      INCLUDE 'CMTBCDATA'

      real  MixtPerf_R_CpG, MixtPerf_T_DPR, MixtPerf_C_GRT
     >                 ,MixtPerf_Ho_CpTUVW,MixtPerf_Cp_CvR,MixtPerf_R_M
     >                 ,MixtPerf_G_CpR      
      external MixtPerf_R_CpG, MixtPerf_T_DPR, MixtPerf_C_GRT
     >                 ,MixtPerf_Ho_CpTUVW,MixtPerf_Cp_CvR,MixtPerf_R_M
     >                 ,MixtPerf_G_CpR      

      cip_adhoc=10.0
      cvgref     = param(104)
c     gmaref     = param(105)
      molmass    = param(106)
      muref      = param(107)
      coeflambda = param(108)
      suthcoef   = param(109)
      reftemp    = param(110)
      prlam      = param(111)
      pinfty     = param(112)
      rgasref    = MixtPerf_R_M(molmass,dum)
      cpgref     = MixtPerf_Cp_CvR(cvgref,rgasref)
      gmaref     = MixtPerf_G_CpR(cpgref,rgasref) 
! put these in rea file someday
      return
      end
c------------------------------------------------------------------------

      subroutine limiter
! EBDG Stuff. WHERE'S PHI????
      include 'SIZE'
      include 'TOTAL'
      include 'CMTDATA'
      include 'NEKUSE'
      parameter (lxyz=lx1*ly1*lz1)
      common /scrns/ scr(lxyz),avstate(toteq)
      real scr,avstate
      integer e,eg
      real kemax

      nxyz=lx1*ly1*lz1
      ntot=nxyz*nelt

      epslon=1.0e-9


!     rgam=rgasref/(gmaref-1.0)
!      do i=1,ntot
!         rho=max(vtrans(i,1,1,1,irho),1.0e-10)
!!        scr(i,1)=rgam*log(pr(i,1,1,1)/(rho**gmaref))
!         scr(i,1)=log(pr(i,1,1,1)/(rho**gmaref))
!      enddo
!!     call dsop(scr,'MIN',lx1,ly1,lz1)
!      call copy(t(1,1,1,1,4),scr,ntot)
!! elemental entropy minimum
!!     do e=1,nelt
!!        se0(e)=vlmin(scr(1,e),nxyz)
!!     enddo

      do e=1,nelt

!        rhomin=vlmin(vtrans(1,1,1,e,irho),nxyz)
         rhomin=vlmin(u(1,1,1,1,e),nxyz)

! positivity-preserving limiter of Zhang and Shu: density
         rho=vlsc2(bm1(1,1,1,e),u(1,1,1,1,e),nxyz)/volel(e)
!        if (abs(rho-rhomin) .gt. epslon) then
         theta=min((rho-epslon)/(rho-rhomin+epslon),1.0)
         if (rho .lt. epslon) then
            write(6,'(a33,2i5,1p3e15.7)')
     >        'rho<epslon,nid,e,rho,rhomin,theta',nid,e,rho,rhomin,theta
            do i=1,nxyz
               uold=u(i,1,1,1,e)
               u(i,1,1,1,e)=rho+theta*(uold-rho)
            enddo
         else
            do i=1,nxyz
               uold=u(i,1,1,1,e)
               u(i,1,1,1,e)=rho+abs(theta)*(uold-rho)
            enddo
         endif
         call cfill(t(1,1,1,e,4),theta,nxyz)
!        rho=vlsc2(bm1(1,1,1,e),u(1,1,1,1,e),nxyz)/volel(e)

! positivity-preserving limiter of Lv & Ihme: internal energy
! first compute kinetic energy density
         if (if3d) then
            call vdot3(scr,
     >             u(1,1,1,irpu,e),u(1,1,1,irpv,e),u(1,1,1,irpw,e),
     >             u(1,1,1,irpu,e),u(1,1,1,irpv,e),u(1,1,1,irpw,e),nxyz)
         else
            call vdot2(scr,u(1,1,1,irpu,e),u(1,1,1,irpv,e),
     >                     u(1,1,1,irpu,e),u(1,1,1,irpv,e),nxyz)
         endif
         call invcol2(scr,u(1,1,1,irg,e),nxyz)
         call cmult(scr,0.5,nxyz)
!-----------------------------------------------------------------------
! JH091818 thinking about limiter pegged to max KE. explore this alternate
!          diagnostically
!         kemax=vlmax(scr,nxyz)
!-----------------------------------------------------------------------
! then subtract it off to get internal energy density in scr
         call sub2(scr,u(1,1,1,iret,e),nxyz)
         call chsign(scr,nxyz)
! violation if negative energy density
         tau=vlmin(scr,nxyz)
         tau=min(tau,0.0)
!-----------------------------------------------------------------------
! JH091818
! overwrite scr to explore alternate limiter below
!-----------------------------------------------------------------------
!         kemax=-kemax
!         call cadd2(scr,u(1,1,1,5,e),kemax,nxyz)
!-----------------------------------------------------------------------

! now for rhoe(avstate)
         do m=1,toteq
            avstate(m)=vlsc2(bm1(1,1,1,e),u(1,1,1,m,e),nxyz)/volel(e)
         enddo
         rhoeavg=avstate(5)-
     >              0.5*(avstate(2)**2+avstate(3)**2+avstate(4)**2)/
     >                   avstate(1)

         if (rhoeavg .lt. 0.0) then
            write(6,*) 'duh sir , can''t get positive e(avg)',e,rhoeavg,
     >                 tau,nid
            epsebdg(e)=1.0
         else
            epsebdg(e)=tau/(tau-rhoeavg)
         endif
!        epsebdg(e)=1.0 ! Godunov test
         do m=1,toteq
            do i=1,nxyz
               uold=u(i,1,1,m,e)
               u(i,1,1,m,e)=uold+epsebdg(e)*(avstate(m)-uold)
            enddo
         enddo

!-----------------------------------------------------------------------
! diagnostics
!-----------------------------------------------------------------------
         call cfill(t(1,1,1,e,5),epsebdg(e),nxyz)
! JH091818
! alternate limiter trying to keep U5 > kemax (at best ultraconservative)
!         tau=vlmin(scr,nxyz)
!         tau=min(tau,0.0)
!         epsalot=tau/(tau-(avstate(5)+kemax))
!         call cfill(t(1,1,1,e,5),epsalot,nxyz)
!-----------------------------------------------------------------------

!         rho=avstate(1)
!! Entropy-bounded limiter of Lv and Ihme
!-----------------------------------------------------------------------
! JH091118 This isn't ready for non-ideal state equations or volume fraction
!-----------------------------------------------------------------------
!         e_internal=avstate(5)-
!     >              0.5*(avstate(2)**2+avstate(3)**2+avstate(4)**2)/
!     >                   rho
!         e_internal=e_internal/rho
!         eg=gllel(e)
!         call cmt_userEOS(1,1,1,eg) ! assigns elm avg to  pres and temp
!         do i=1,nxyz
!            scr(i)=pr(i,1,1,e)-exp(se0const)*
!     >                         (u(i,1,1,1,e)**gmaref)
!         enddo
!         tau=vlmin(scr,nxyz)
!         tau=min(tau,0.0)
!         epsebdg(e)=tau/
!     >          (tau-(pres-exp(se0const)*rho**gmaref))
!         epsebdg(e)=min(epsebdg(e),1.0)
!         epsebdg(e)=max(epsebdg(e),0.0)
!! diagnostic
!         call cfill(t(1,1,1,e,5),epsebdg(e),nxyz)
!
!         do m=1,toteq
!            do i=1,nxyz
!               uold=u(i,1,1,m,e)
!               u(i,1,1,m,e)=uold+epsebdg(e)*(avstate(m)-uold)
!            enddo
!         enddo
!-----------------------------------------------------------------------

      enddo
      
      return
      end

!-----------------------------------------------------------------------
! JH082118 shock detectors. Test shock detectors in usr file extensively.
!          port them here after they have earned our trust.
!-----------------------------------------------------------------------

      subroutine AVeverywhere(shkdet)
      include 'SIZE'
      include 'TOTAL'
      real shkdet(nelt)
      call rone(shkdet,nelt)
      return
      end

      subroutine limiter_only(shkdet)
! worst ad hoc shock detector ever. read a limiter function from CMTDATA
! epsebdg is the only one we have so far. If it's bigger than some threshold,
! apply AV there too.
      include 'SIZE'
      include 'CMTDATA'
      real shkdet(nelt)
      integer e

      call rzero(shkdet,nelt)
      tol=1.0e-5

      if (.not.time4av) then
         do e=1,nelt
            if (abs(epsebdg(e)) .gt. tol) shkdet(e)=1.0
         enddo
      endif

      emax=glamax(shkdet,nelt)
      if (nio.eq.0) write(6,*) 'max shock detector =',emax

      return
      end

!-----------------------------------------------------------------------
      subroutine lpm_init(rparam,yp,nyp,pp,npp,npart,time_)
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
#     include "LPM"

      real     yp(*)
      real     pp(*)
      real     rparam(*)

      lpm_d2chk(2) = 0.0
      lpm_npart = npart
      lpm_timef = time_

      if (nyp.gt.LPM_LRS)
     $   call exitti('nyp > LPM_LRS$',nyp)

      if (npp.gt.LPM_LRP)
     $   call exitti('npp > LPM_LRP$',npp)

      if (lpm_npart.gt.LPM_LPART)
     $   call exitti('lpm_npart > LPM_LPART$',lpm_npart)

      call copy(lpm_y    ,yp,lpm_npart*nyp)
      call copy(lpm_rprop,pp,lpm_npart*npp)

      if (nio.eq.0) then
         write(6,*) ' '
         write(6,*) 'initialize LPM'
         if (int(rparam(1)) .ne. 0) 
     $   write(6,*) 'overwrite default settings'
      endif

      call lpm_rparam_set(rparam)
      call lpm_tag_init
      call lpm_tag_set

      ! get domain bounds
      call domain_size( lpm_xdrange(1,1),lpm_xdrange(2,1)
     >                 ,lpm_xdrange(1,2),lpm_xdrange(2,2)
     >                 ,lpm_xdrange(1,3),lpm_xdrange(2,3))

      ! send particles to correct rank
      call lpm_init_filter

      call lpm_comm_setup
      call lpm_interpolate_setup

      ! two-way coupling init
      if (int(lpm_rparam(4)) .ne. 1) then
         call lpm_project
      endif

      call nekgsync()
      if (nio.eq.0) then
        write(6,*) 'done :: initialize LPM' 
        write(6,*) ' '
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_rparam_set(rparam)
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      real rparam(*)

      if (rparam(1) .eq. 0) then ! set defaults
         lpm_rparam(2)  = 1      ! time integration method
         lpm_rparam(3)  = lx1-1  ! polynomial order of mesh
         lpm_rparam(4)  = 0      ! use 1 for tracers only
         lpm_rparam(5)  = 0      ! index of filter non-dim in rprop
         lpm_rparam(6)  = 0      ! non-dimensional Gaussian filter width
         lpm_rparam(7)  = 0      ! percent decay of Gaussian filter
         lpm_rparam(8)  = 0      ! periodic in x
         lpm_rparam(9)  = 0      ! periodic in y
         lpm_rparam(10) = 0      ! periodic in z
      else ! custom values
         do i=2,lpm_nparam
            lpm_rparam(i) = rparam(i)
         enddo
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_init_filter
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      rsig  = 0.0
      jdp   = int(lpm_rparam(5))
      filt  = lpm_rparam(6)
      alph  = lpm_rparam(7)

      rdx_max = 0.0

      lx1m1 = max(1,lx1-1)
      ly1m1 = max(1,ly1-1)
      lz1m1 = max(1,lz1-1)

      ! first, compute what is the smallest filter size for the grid
      do ie=1,nelt
      do k=1,lz1m1
      do j=1,ly1m1
      do i=1,lx1m1
         ip1 = i+1
         jp1 = j+1
         kp1 = k+1

         rdx_test = xm1(ip1,j,k,ie) - xm1(i,j,k,ie)
         rdy_test = ym1(i,jp1,k,ie) - ym1(i,j,k,ie)
         if (if3d) 
     >   rdz_test = zm1(i,j,kp1,ie) - zm1(i,j,k,ie)

         rdist = max(rdx_test,rdy_test)
         if (if3d)
     >   rdist = max(rdz_test,rdist)

         rdx_dy_test = sqrt(rdx_test**2 + rdy_test**2)
         rdist = max(rdx_dy_test,rdist)
         if (if3d) then
            rdy_dz_test = sqrt(rdy_test**2 + rdz_test**2)
            rdist = max(rdy_dz_test,rdist)
            rdx_dz_test = sqrt(rdx_test**2 + rdz_test**2)
            rdist = max(rdx_dz_test,rdist)
         endif

         if (rdist .gt. rdx_max) rdx_max = rdist
      enddo
      enddo
      enddo
      enddo
      rdx_max = glmax(rdx_max,1)

      lpm_rdx_max = rdx_max

      rsig_dx_min_set  = 0.25
      rfilt_dp_min_set = 1.0
      rsig_dx_min      = 1E12

      tol = 1.e-12
      if (wdsize.eq.4) tol = 1.e-6

      rfilt = lpm_rparam(6)
      lpm_d2chk(2) = -1
      if (abs(alph) .lt. tol) then
         alph = 1E-3
         lpm_rparam(7) = alph
      endif

      do i=1,lpm_npart

         if (filt .lt. tol) then
            rsig_test_grid = rsig_dx_min_set*rdx_max + tol
            rsig_test_diam = rfilt_dp_min_set*lpm_rprop(jdp,i)
     >                       /(2.*sqrt(2.*log(2.)))
            rsig_test = max(rsig_test_grid,rsig_test_diam)
            filt      = rsig_test/lpm_rprop(jdp,i)*2.*sqrt(2.*log(2.))
            rfilt = filt
         else
            rsig_test = filt*lpm_rprop(jdp,i)/(2.*sqrt(2.*log(2.)))
         endif

         rsig_dx = rsig_test/rdx_max
         if (rsig_dx .lt. rsig_dx_min) rsig_dx_min = rsig_dx

         if (rsig_test .gt. rsig) rsig = rsig_test
      enddo
      rsig = glmax(rsig,1)
      rsig_dx_min = glmin(rsig_dx_min,1)
         
      lpm_d2chk(2) = rsig*sqrt(-2*log(alph))

      if (rsig_dx_min .lt. rsig_dx_min_set) then
         if (nid .eq. 0) then
            filt_new = filt/(rsig_dx_min/rsig_dx_min_set)
            write(6,100) filt, filt_new
 100        format('Reset Gaussian filter width from', E14.7
     >             ' to', E14.7, ' or larger')
         endif
         call exitt
      endif

      lpm_rparam(6) = glmax(rfilt,1)
      lpm_d2chk(2)  = glmax(lpm_d2chk(2),1)
      if (int(lpm_rparam(4)) .eq. 1) lpm_d2chk(2) = 0

      return
      end
c----------------------------------------------------------------------
      subroutine lpm_tag_set
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      do i=1,lpm_npart
         if (lpm_iprop(5,i) .eq. -1) lpm_iprop(5,i) = nid
         if (lpm_iprop(6,i) .eq. -1) lpm_iprop(6,i) = istep
         if (lpm_iprop(7,i) .eq. -1) lpm_iprop(7,i) = i
      enddo

      return
      end
c----------------------------------------------------------------------
      subroutine lpm_tag_init
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      if (.not. LPM_RESTART) then
         do i=1,LPM_LPART
            lpm_iprop(5,i) = -1
            lpm_iprop(6,i) = -1
            lpm_iprop(7,i) = -1
         enddo
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine lpm_solve(time_)
      include 'SIZE'
      include 'TSTEP'
#     include "LPM"

      real time_

      ts   = dnekclock()

      isol = lpm_rparam(2)
      dt_  = time_ - lpm_timef 
      n    = LPM_NPART*LPM_LRS

      ! save previous solution
      call copy(lpm_y1,lpm_y,n)

      if (isol .eq. 1) then
         call lpm_rk3_driver(time_,dt_,lpm_y1,lpm_y,lpm_ydot,n)
      else
         call exitti('unknown LPM integrator$',isol)
      endif

      lpm_timef = time_

      if(nio.eq.0)
     &   write(*,'(4x,i7,a,1p3e12.4)')
     &   istep,'  LPM-solver done',time,dnekclock()-ts, lpm_timef

      return
      end
c----------------------------------------------------------------------
      subroutine lpm_rk3_driver(time_,dt_,y0,y,ydot,n)
      include 'SIZE'
#     include "LPM"

      real time_
      real y0(*)
      real y(*)
      real ydot(*)

      parameter(nstage = 3)
      real tcoef(3,3)

      call lpm_rk3_coeff(tcoef,dt_)

      do istage=1,nstage
         call lpm_fun(time_,y,ydot)
         do i=1,n
            y(i) = tcoef(1,istage)*y0  (i)
     >           + tcoef(2,istage)*y   (i)
     >           + tcoef(3,istage)*ydot(i)
         enddo
      enddo

      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_interpolate_setup
      include 'SIZE'
#     include "LPM"

      call lpm_move_outlier
      call lpm_comm_bin_setup
      call lpm_comm_findpts

      call lpm_comm_crystal

      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_interpolate_fld(jp,fld)
      include 'SIZE'
#     include "LPM"

      common /intp_h/ ih_intp(2,1)

      real fld(*)

      ih_intp1 = ih_intp(1,i_fp_hndl)

c     call fgslib_findpts_eval_local( ih_intp1
c    >                               ,lpm_rprop (jp,1)
c    >                               ,LPM_LRP
c    >                               ,lpm_iprop (2,1)
c    >                               ,LPM_LIP
c    >                               ,lpm_rprop2(1,1)
c    >                               ,LPM_LRP2
c    >                               ,LPM_NPART
c    >                               ,fld)

         call fgslib_findpts_eval( ih_intp1
     >                           ,lpm_rprop (jp,1)
     >                           ,LPM_LRP
     >                           ,lpm_iprop (1,1)
     >                           ,LPM_LIP
     >                           ,lpm_iprop (3,1)
     >                           ,LPM_LIP
     >                           ,lpm_iprop (2,1)
     >                           ,LPM_LIP
     >                           ,lpm_rprop2(1,1)
     >                           ,LPM_LRP2
     >                           ,LPM_NPART
     >                           ,fld)

      return
      end
c----------------------------------------------------------------------
      subroutine lpm_project
      include 'SIZE'
#     include "LPM"

      if (int(lpm_rparam(4)) .ne. 1) then
         call lpm_comm_ghost_create
         call lpm_comm_ghost_send
         call lpm_solve_project
      endif

      return
      end
c----------------------------------------------------------------------
      subroutine lpm_solve_project
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      real               phig(lx1,ly1,lz1,lelt)
      common /otherpvar/ phig

      real    multfci
      integer e

      common /lpm_fix/ phigdum,phigvdum
      real phigdum(lx1,ly1,lz1,lelt,3),phigvdum(lx1,ly1,lz1,lelt)

      real xrun(lx1),yrun(ly1),zrun(lz1)

      integer xrune(lx1),yrune(ly1),zrune(lz1)

      real    rproj(1+LPM_LRP_GP,LPM_LPART+LPM_LPART_GP)
      integer iproj(4,LPM_LPART+LPM_LPART_GP)

      logical partl

      nxyz = lx1*ly1*lz1

      nxyzdum = nxyz*LPM_LRP_PRO*lpm_neltb
      call rzero(lpm_pro_fldb,nxyzdum)

      d2chk2_sq = lpm_d2chk(2)**2

      ! real particles
      lpm_jxgp  = 1
      lpm_jygp  = 2
      lpm_jzgp  = 3
      lpm_jdp   = 4
      filt      = lpm_rparam(6)
      alph      = lpm_rparam(7)

      nxyze = lx1*ly1*lz1*nelt
      nxyz = lx1*ly1*lz1

c     lpm_npart_gp = 0

      ! real particles
      do ip=1,lpm_npart
         rsig    = filt*lpm_cp_map(lpm_jdp,ip)/(2.*sqrt(2.*log(2.)))
         multfci = 1./(sqrt(2.*pi)**2 * rsig**2) 
         if (if3d) multfci = multfci**(1.5d+0)
         ralph   = filt/2.*sqrt(-log(alph)/log(2.))*
     >             lpm_cp_map(lpm_jdp,ip)
         ralph2   = ralph**2
         rbexpi   = 1./(-2.*rsig**2)

c        if (.not. if3d) 
c    >          multfci = multfci/lpm_cp_map(lpm_jdp,ip)

         rproj(1 ,ip) = rbexpi
         rproj(2 ,ip) = lpm_cp_map(lpm_jxgp,ip)
         rproj(3 ,ip) = lpm_cp_map(lpm_jygp,ip)
         rproj(4 ,ip) = lpm_cp_map(lpm_jzgp,ip)


         do j=5,LPM_LRP_GP
            rproj(j,ip) = lpm_cp_map(j,ip)*multfci
         enddo
                    
         iproj(1,ip)  = lpm_iprop(8,ip)
         iproj(2,ip)  = lpm_iprop(9,ip)
         iproj(3,ip)  = lpm_iprop(10,ip)
         iproj(4,ip)  = lpm_iprop(11,ip)
      enddo

      ! ghost particles
      do ip=1,lpm_npart_gp
         rsig    = filt*lpm_rprop_gp(lpm_jdp,ip)/(2.*sqrt(2.*log(2.)))
         multfci = 1./(sqrt(2.*pi)**2 * rsig**2) 
         if (if3d) multfci = multfci**(1.5d+0)
         ralph   = filt/2.*sqrt(-log(alph)/log(2.))*
     >             lpm_rprop_gp(lpm_jdp,ip)
         ralph2   = ralph**2
         rbexpi   = 1./(-2.*rsig**2)

c        if (.not. if3d) 
c    >          multfci = multfci/lpm_rprop_gp(lpm_jdp,ip)

         rproj(1 ,ip+lpm_npart) = rbexpi
         rproj(2 ,ip+lpm_npart) = lpm_rprop_gp(lpm_jxgp,ip)
         rproj(3 ,ip+lpm_npart) = lpm_rprop_gp(lpm_jygp,ip)
         rproj(4 ,ip+lpm_npart) = lpm_rprop_gp(lpm_jzgp,ip)

         do j=5,LPM_LRP_GP
            rproj(j,ip+lpm_npart) = lpm_rprop_gp(j,ip)*multfci
         enddo
                    
         iproj(1,ip+lpm_npart)  = lpm_iprop_gp(2,ip)
         iproj(2,ip+lpm_npart)  = lpm_iprop_gp(3,ip)
         iproj(3,ip+lpm_npart)  = lpm_iprop_gp(4,ip)
         iproj(4,ip+lpm_npart)  = lpm_iprop_gp(5,ip)
      enddo

      ndum = lpm_npart+lpm_npart_gp
c     ndum = lpm_npart_gp

      if (int(lpm_rparam(3)) .eq. 1) then
         do ip=1,ndum
            ii    = iproj(1,ip)
            jj    = iproj(2,ip)
            kk    = iproj(3,ip)
            ndum  = iproj(4,ip)
          
            ilow  = ii-1
            ihigh = ii+1
            jlow  = jj-1
            jhigh = jj+1
            klow  = kk-1
            khigh = kk+1
         
            do ie=1,lpm_neltb
         
               if (lpm_el_map(1,ie) .gt. ndum) exit
               if (lpm_el_map(2,ie) .lt. ndum) cycle 
         
               if (lpm_el_map(3,ie) .gt. ihigh) cycle
               if (lpm_el_map(4,ie) .lt. ilow)  cycle
               if (lpm_el_map(5,ie) .gt. jhigh) cycle
               if (lpm_el_map(6,ie) .lt. jlow)  cycle
               if (lpm_el_map(7,ie) .gt. khigh) cycle
               if (lpm_el_map(8,ie) .lt. klow)  cycle

               do i=1,lx1
                  xrun(i) = (lpm_xm1b(i,1,1,1,ie) - rproj(2,ip))**2
                  xrune(i) = 1
                  if (xrun(i) .gt. d2chk2_sq) xrune(i) = -1
               enddo
               do j=1,ly1
                  yrun(j) = (lpm_xm1b(1,j,1,2,ie) - rproj(3,ip))**2
                  yrune(j) = 1
                  if (yrun(j) .gt. d2chk2_sq) yrune(j) = -1
               enddo
               do k=1,lz1
                  zrun(k) = (lpm_xm1b(1,1,k,3,ie) - rproj(4,ip))**2
                  if (.not. if3d) zrun(k) = 0.0
                  zrune(k) = 1
                  if (zrun(k) .gt. d2chk2_sq) zrune(k) = -1
               enddo
         
               do k=1,lz1
                  if (zrune(k) .lt. 0) cycle
               do j=1,ly1
                  if (yrune(j) .lt. 0) cycle
                  rdum1 = yrun(j) + zrun(k)
               do i=1,lx1
                  if (lpm_modgp(i,j,k,ie,4).ne.iproj(4,ip)) cycle
                  rdist2 = rdum1 + xrun(i)
                  if (rdist2 .gt. d2chk2_sq) cycle

                  rexp = exp(rdist2*rproj(1,ip))
                  
                  do jj=1,LPM_LRP_PRO
                     j1 = jj+4
                     LPM_PRO_FLDB(i,j,k,jj,ie) = 
     >                                   LPM_PRO_FLDB(i,j,k,jj,ie) 
     >                                 + rproj(j1,ip)*rexp
                  enddo
               enddo
               enddo
               enddo
            enddo
         enddo
      else
         do ip=1,ndum
            ii    = iproj(1,ip)
            jj    = iproj(2,ip)
            kk    = iproj(3,ip)
            ndum  = iproj(4,ip)
          
            ilow  = ii-1
            ihigh = ii+1
            jlow  = jj-1
            jhigh = jj+1
            klow  = kk-1
            khigh = kk+1
         
            do ie=1,lpm_neltb
         
               if (lpm_el_map(1,ie) .gt. ndum) exit
               if (lpm_el_map(2,ie) .lt. ndum) cycle 
         
               if (lpm_el_map(3,ie) .gt. ihigh) cycle
               if (lpm_el_map(4,ie) .lt. ilow)  cycle
               if (lpm_el_map(5,ie) .gt. jhigh) cycle
               if (lpm_el_map(6,ie) .lt. jlow)  cycle
               if (lpm_el_map(7,ie) .gt. khigh) cycle
               if (lpm_el_map(8,ie) .lt. klow)  cycle
         
               do i=1,nxyz
                  if (lpm_modgp(i,1,1,ie,4).ne.iproj(4,ip)) cycle
                  rdist2  = (lpm_xm1b(i,1,1,1,ie) - rproj(2,ip))**2 +
     >                      (lpm_xm1b(i,1,1,2,ie) - rproj(3,ip))**2
                  if(if3d) rdist2 = rdist2                      +
     >                      (lpm_xm1b(i,1,1,3,ie) - rproj(4,ip))**2
                  if (rdist2 .gt. d2chk2_sq) cycle
               
                  rexp = exp(rdist2*rproj(1,ip))
                  
                  do j=1,LPM_LRP_PRO
                     j1 = j+4
                     LPM_PRO_FLDB(i,1,1,j,ie) = 
     >                               LPM_PRO_FLDB(i,1,1,j,ie) 
     >                             + rproj(j1,ip)*rexp
                  enddo
                enddo
             enddo
          enddo
      endif

      ! now send xm1b to the processors in nek that hold xm1

      neltbc = lpm_neltb
      ndum = LPM_LRMAX*neltbc
      call icopy(lpm_er_mapc,lpm_er_map,ndum)
      do ie=1,neltbc
         lpm_er_mapc(5,ie) = lpm_er_mapc(2,ie)
         lpm_er_mapc(6,ie) = lpm_er_mapc(2,ie)
      enddo
      nl = 0
      nii = LPM_LRMAX
      njj = 6
      nrr = nxyz*LPM_LRP_PRO
      call fgslib_crystal_tuple_transfer(i_cr_hndl,neltbc,lpm_lbmax
     >                  , lpm_er_mapc,nii,partl,nl,lpm_pro_fldb,nrr,njj)

      ! add the fields from the bins to ptw array
      nlxyze = lx1*ly1*lz1*lelt
      call rzero(LPM_PRO_FLD,nlxyze*LPM_LRP_PRO)
      do ie=1,neltbc
         iee = lpm_er_mapc(1,ie)
         do ip=1,LPM_LRP_PRO
         do k=1,nz1
         do j=1,ny1
         do i=1,nx1
            LPM_PRO_FLD(i,j,k,iee,ip) = LPM_PRO_FLD(i,j,k,iee,ip) +
     >                                  LPM_PRO_FLDB(i,j,k,ip,ie)
         enddo
         enddo
         enddo
         enddo
      enddo

      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_rk3_coeff(tcoef,rdt)
      include 'SIZE'
      include 'TOTAL'

      real tcoef(*)
      real rdt

      tcoef(1) = 0.0
      tcoef(2) = 1.0 
      tcoef(3) = rdt
      tcoef(4) = 3.0/4.0
      tcoef(5) = 1.0/4.0 
      tcoef(6) = rdt/4.0 
      tcoef(7) = 1.0/3.0
      tcoef(8) = 2.0/3.0 
      tcoef(9) = rdt*2.0/3.0 

      return
      end
!-----------------------------------------------------------------------
      subroutine lpm_qtl_pvol(divin,phipin)
c
c     Computes modified divergence constraint for multiphase dense
c     incompressible flow
c
      include 'SIZE'
      include 'TOTAL'
#     include "LPM"

      common /phig_qtl_blk/ phig_last
      real phig_last(lx1,ly1,lz1,lelt)

      real divin(lx2,ly2,lz2,lelv), phipin(lx1,ly1,lz1,lelt)

      COMMON /SCRNS/ ur(lx1,ly1,lz1,lelt)
     >              ,us(lx1,ly1,lz1,lelt)
     >              ,ut(lx1,ly1,lz1,lelt)
     >              ,phigin(lx1,ly1,lz1,lelt)
     >              ,phig_qtl(lx1,ly1,lz1,lelt)
     >              ,grad_dot(lx1,ly1,lz1,lelt)

      integer icalld
      save    icalld
      data    icalld  /-1/

      icalld = icalld + 1
      nxyze = lx1*ly1*lz1*lelt

      rdt_in = 1./dt

      call rzero(phig_qtl,nxyze)

      if (icalld .eq. 0) then
         call rone(phig_last,nxyze)
         call sub2(phig_last,phipin,nxyze)
      endif

      call rone(phigin,nxyze)
      call sub2(phigin,phipin,nxyze)
      
c     if (icalld .lt. 5) goto 123

      call opgrad(ur,us,ut,phigin)
      call sub3(phig_qtl,phigin,phig_last,nxyze)
      call cmult(phig_qtl,rdt_in,nxyze)
      call vdot3(grad_dot,vx,vy,vz,ur,us,ut,nxyze)
      call add2(phig_qtl,grad_dot,nxyze)
      call invcol2(phig_qtl,phigin,nxyze)
      call chsign(phig_qtl,nxyze)

      call copy(phig_last,phigin,nxyze)

      do ie=1,nelt
         call map12(divin(1,1,1,ie),phig_qtl(1,1,1,ie),ie)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine lpm_move_outlier
      include 'SIZE'
#     include "LPM"

      integer in_part(LPM_LPART)
      integer jj(3)

      iperiodicx = int(lpm_rparam(8))
      iperiodicy = int(lpm_rparam(9))
      iperiodicz = int(lpm_rparam(10))

      jj(1) = 1
      jj(2) = 2
      jj(3) = 3

      do i=1,lpm_npart
         isl = (i -1) * LPM_LRS + 1
         in_part(i) = 0
         do j=0,ndim-1
            jchk = jj(j+1)
            if (lpm_y(jchk,i).lt.lpm_xdrange(1,j+1))then
               if (((iperiodicx.eq.1) .and. (j.eq.0)) .or.   ! periodic
     >             ((iperiodicy.eq.1) .and. (j.eq.1)) .or.     
     >             ((iperiodicz.eq.1) .and. (j.eq.2)) ) then
                   lpm_y(jchk,i) = lpm_xdrange(2,j+1) - 
     &                         abs(lpm_xdrange(1,j+1) - lpm_y(jchk,i))
                   lpm_y1(isl+j)   = lpm_xdrange(2,j+1) +
     &                         abs(lpm_xdrange(1,j+1) - lpm_y1(isl+j))
                  goto 1512
                endif
            endif
            if (lpm_y(jchk,i).gt.lpm_xdrange(2,j+1))then
               if (((iperiodicx.eq.1) .and. (j.eq.0)) .or.   ! periodic
     >             ((iperiodicy.eq.1) .and. (j.eq.1)) .or.     
     >             ((iperiodicz.eq.1) .and. (j.eq.2)) ) then
                   lpm_y(jchk,i) = lpm_xdrange(1,j+1) +
     &                         abs(lpm_y(jchk,i) - lpm_xdrange(2,j+1))
                   lpm_y1(isl+j)   = lpm_xdrange(1,j+1) +
     &                         abs(lpm_y1(isl+j) - lpm_xdrange(2,j+1))
                  goto 1512
                endif
            endif
            if (lpm_iprop(1,i) .eq. 2) then
               in_part(i) = -1 ! only if periodic check fails it will get here
            endif
 1512 continue
         enddo
      enddo

      ic = 0
      do i=1,lpm_npart
         if (in_part(i).eq.0) then
            ic = ic + 1 
            if (i .ne. ic) then
               isl = (i -1) * LPM_LRS + 1
               isr = (ic-1) * LPM_LRS + 1
               call copy(lpm_y     (1,ic),lpm_y(1,i)     ,LPM_LRS)
               call copy(lpm_y1    (isr) ,lpm_y1(isl)    ,LPM_LRS)
               call copy(lpm_ydot  (1,ic),lpm_ydot(1,i)  ,LPM_LRS)
               call copy(lpm_ydotc (1,ic),lpm_ydotc(1,i) ,LPM_LRS)
               call copy(lpm_rprop (1,ic),lpm_rprop(1,i) ,LPM_LRP)
               call copy(lpm_rprop2(1,ic),lpm_rprop2(1,i),LPM_LRP2)
               call icopy(lpm_iprop(1,ic),lpm_iprop(1,i) ,LPM_LIP)
            endif
         endif
      enddo
      lpm_npart = ic

      return
      end
!-----------------------------------------------------------------------

C> @file ausm.f Riemann solvers and other rocflu miscellany
! ******************************************************************************
!
! Purpose: Compute convective fluxes using AUSM+ scheme.
!
! Description: None.
!
! Input: 
!   nx          x-component of face normal
!   ny          y-component of face normal
!   nz          z-component of face normal
!   nm          Magnitude of face normal
!   fs          Face speed
!   rl          Density of left state
!   ul          x-component of velocity of left state
!   vl          y-component of velocity of left state
!   wl          z-component of velocity of left state   
!   Hl		Total enthalpy of left state
!   al		Speed of sound of left state
!   pl          Pressure of left state
!   rr          Density of right state
!   ur          x-component of velocity of right state
!   vr          y-component of velocity of right state
!   wr          z-component of velocity of right state  
!   pr          Pressure of right state
!   Hr		Total enthalpy of right state
!   ar		Speed of sound of right state
!
! Output: 
!   flx         Fluxes
!   vf          Face velocities ! NOT USED IN CMT-NEK YET
!
! Notes: 
!   1. Liou M.-S., Progress towards an improved CFD method: AUSM+, AIAA Paper
!      95-1701, 1995
!   2. Do not use computation of face speed of sound which leads to exact 
!      capturing of isolated normal shock waves because of robustness problems
!      for unsteady flows and because that formulation is not applicable to 
!      anything but calorically and thermally perfect gases.
!
! ******************************************************************************

C> \ingroup isurf
C> @{
C> Computes inviscid numerical surface flux from AUSM+ Riemann solver
      SUBROUTINE AUSM_FluxFunction(ntot,nx,ny,nz,nm,fs,rl,ul,vl,wl,pl,
     >                         al,tl,rr,ur,vr,wr,pr,ar,tr,flx,el,er)

!     IMPLICIT NONE ! HAHAHHAHHAHA
! ******************************************************************************
! Definitions and declarations
! ******************************************************************************
      real     MixtJWL_Enthalpy
      external MixtJWL_Enthalpy

! ==============================================================================
! Arguments
! ==============================================================================
      integer ntot
      REAL al(ntot),ar(ntot),fs(ntot),nm(ntot),nx(ntot),ny(ntot),
     >     nz(ntot),pl(ntot),pr(ntot),rl(ntot),rr(ntot),ul(ntot),
     >     ur(ntot),vl(ntot),vr(ntot),wl(ntot),wr(ntot),el(ntot),
     >     er(ntot),tl(ntot),tr(ntot)! INTENT(IN) ::
      REAL flx(ntot,5)!,vf(3) ! INTENT(OUT) ::

! ==============================================================================
! Locals
! ==============================================================================

      REAL af,mf,mfa,mfm,mfp,ml,mla,mlp,mr,mra,mrm,pf,ql,qr,vml,vmr,
     >        wtl,wtr,Hl,Hr

! ******************************************************************************
! Start, compute face state
! ******************************************************************************

      do i=1,ntot
!        Change the Enthalpy 
         Hl = MixtJWL_Enthalpy(rl(i),pl(i),ul(i),vl(i),wl(i),el(i))
         Hr = MixtJWL_Enthalpy(rr(i),pr(i),ur(i),vr(i),wr(i),er(i))

         ql = ul(i)*nx(i) + vl(i)*ny(i) + wl(i)*nz(i) - fs(i)
         qr = ur(i)*nx(i) + vr(i)*ny(i) + wr(i)*nz(i) - fs(i)

         af = 0.5*(al(i)+ar(i)) ! NOTE not using original formulation, see note
         ml  = ql/af
         mla = ABS(ml)

         mr  = qr/af
         mra = ABS(mr)    

         IF ( mla .le. 1.0 ) THEN 
            mlp = 0.25*(ml+1.0)*(ml+1.0) + 0.125*(ml*ml-1.0)*(ml*ml-1.0)
            wtl = 0.25*(ml+1.0)*(ml+1.0)*(2.0-ml) +
     >            0.1875*ml*(ml*ml-1.0)*(ml*ml-1.0)
         ELSE
            mlp = 0.5*(ml+mla)
            wtl = 0.5*(1.0+ml/mla)
         END IF ! mla

         IF ( mra .le. 1.0 ) THEN 
            mrm = -0.25*(mr-1.0)*(mr-1.0)-0.125*(mr*mr-1.0)*(mr*mr-1.0)
            wtr = 0.25*(mr-1.0)*(mr-1.0)*(2.0+mr) -
     >            0.1875*mr*(mr*mr-1.0)*(mr*mr-1.0)
         ELSE
            mrm = 0.5*(mr-mra)
            wtr = 0.5*(1.0-mr/mra)
         END IF ! mla

         mf  = mlp + mrm
         mfa = ABS(mf)
         mfp = 0.5*(mf+mfa)
         mfm = 0.5*(mf-mfa)

         pf = wtl*pl(i) + wtr*pr(i)

! ******************************************************************************
! Compute fluxes
! ******************************************************************************

!        vf(1) = mfp*ul + mfm*ur ! I'm sure we'll need this someday
!        vf(2) = mfp*vl + mfm*vr
!        vf(3) = mfp*wl + mfm*wr

         flx(i,1)=(af*(mfp*rl(i)      +mfm*rr(i)   )        )*nm(i)
         flx(i,2)=(af*(mfp*rl(i)*ul(i)+mfm*rr(i)*ur(i))+pf*nx(i))*
     >            nm(i)
         flx(i,3)=(af*(mfp*rl(i)*vl(i)+mfm*rr(i)*vr(i))+pf*ny(i))*
     >            nm(i)
         flx(i,4)=(af*(mfp*rl(i)*wl(i)+mfm*rr(i)*wr(i))+pf*nz(i))*
     >            nm(i)
         flx(i,5)=(af*(mfp*rl(i)*Hl   +mfm*rr(i)*Hr) + pf*fs(i))*
     >            nm(i)
      enddo
C> @}
      return
      END

!-----------------------------------------------------------------------
! NOT LONG FOR THIS WORLD

      SUBROUTINE CentralInviscid_FluxFunction(ntot,nx,ny,nz,fs,ul,pl,
     >                                     ur,pr,flx)
! JH081915 More general, more obvious
! JH111815 HEY GENIUS THIS MAY BE SECOND ORDER AND THUS KILLING YOUR
!          CONVERGENCE. REPLACE WITH AUSM AND SHITCAN IT
! JH112015 This isn't why walls aren't converging. There's something
!          inherently second-order about your wall pressure. Think!
      real nx(ntot),ny(ntot),nz(ntot),fs(ntot),ul(ntot,5),pl(ntot),
     >     ur(ntot,5),pr(ntot) ! intent(in)
      real flx(ntot,5)! intent(out),dimension(5) ::

      do i=1,ntot
         rl =ul(i,1)
         rul=ul(i,2)
         rvl=ul(i,3)
         rwl=ul(i,4)
         rel=ul(i,5)

         rr =ur(i,1)
         rur=ur(i,2)
         rvr=ur(i,3)
         rwr=ur(i,4)
         rer=ur(i,5)

         ql = (rul*nx(i) + rvl*ny(i) + rwl*nz(i))/rl - fs(i)
         qr = (rur*nx(i) + rvr*ny(i) + rwr*nz(i))/rr - fs(i)

         flx(i,1) = 0.5*(ql* rl+ qr*rr               )
         flx(i,2) = 0.5*(ql* rul+pl(i)*nx(i) + qr* rur     +pr(i)*nx(i))
         flx(i,3) = 0.5*(ql* rvl+pl(i)*ny(i) + qr* rvr     +pr(i)*ny(i))
         flx(i,4) = 0.5*(ql* rwl+pl(i)*nz(i) + qr* rwr     +pr(i)*nz(i))
         flx(i,5) = 0.5*(ql*(rel+pl(i))+pl(i)*fs(i)+qr*(rer+pr(i))+
     >               pr(i)*fs(i))
      enddo

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!!The scheduling constraints prohibit a thread in the team from executing
!!a new task that modifies tp while another such task region tied to
!!the same thread is suspended. Therefore, the value written will
!!persist across the task scheduling point.
!!No Data Race

module DRB128
    integer :: tp, var
    !$omp threadprivate(tp)
contains
    subroutine foo
        !$omp task
            !$omp task
            tp = 1
                !$omp task
                !$omp end task
            var = tp
            !$omp end task
        !$omp end task
    end subroutine
end module

program DRB128_tasking_threadprivate2_orig_no
    use omp_lib
    use DRB128
    implicit none

    call foo()
    print*,var
end program

      SUBROUTINE MXM(A,N1,B,N2,C,N3)
      REAL A(N1,N2), B(N2,N3), C(N1,N3)

      DO J=1,N3
         DO I=1,N1
            C(I,J) = 0.0
            DO K=1, N2
               C(I,J) = C(I,J) + A(I,K)*B(K,J)
            ENDDO
         ENDDO
      ENDDO
      END

C**********************************************************************
C
C     ROUTINES FOR ESITMATING AND CALCULATING EIGENVALUES
C     USED IN NEKTON
C
C**********************************************************************
C
      SUBROUTINE ESTEIG
C--------------------------------------------------------------
C
C     Estimate eigenvalues
C
C-------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'EIGEN'
      INCLUDE 'TSTEP'
C
      NTOT1=lx1*ly1*lz1*NELFLD(IFIELD)
      XMIN = GLMIN(XM1,NTOT1)
      XMAX = GLMAX(XM1,NTOT1)
      YMIN = GLMIN(YM1,NTOT1)
      YMAX = GLMAX(YM1,NTOT1)
      IF (IF3D) THEN
         ZMIN = GLMIN(ZM1,NTOT1)
         ZMAX = GLMAX(ZM1,NTOT1)
      ELSE
         ZMIN = 0.0
         ZMAX = 0.0
      ENDIF
C
      XX = XMAX - XMIN
      YY = YMAX - YMIN
      ZZ = ZMAX - ZMIN
      RXY = XX/YY
      RYX = YY/XX
      RMIN = RXY
      IF (RYX .LT. RMIN) RMIN = RYX
      IF (ldim .EQ. 3) THEN
         RXZ = XX/ZZ
         RZX = ZZ/XX
         RYZ = YY/ZZ
         RZY = ZZ/YY
         IF (RXZ .LT. RMIN) RMIN = RXZ
         IF (RZX .LT. RMIN) RMIN = RZX
         IF (RYZ .LT. RMIN) RMIN = RYZ
         IF (RZY .LT. RMIN) RMIN = RZY
      ENDIF
C
      XX2    = 1./XX**2
      YY2    = 1./YY**2
      XYZMIN = XX2
      XYZMAX = XX2+YY2
      IF (YY2 .LT. XYZMIN) XYZMIN = YY2
      IF (ldim .EQ. 3) THEN
         ZZ2 = 1./ZZ**2
         XYZMAX = XYZMAX+ZZ2
         IF (ZZ2 .LT. XYZMIN) XYZMIN = ZZ2
      ENDIF
C
      one    = 1.
      PI     = 4.*ATAN(one)
      RATIO  = XYZMIN/XYZMAX
      EIGAE  = PI*PI*XYZMIN
      EIGGE  = EIGGA
      IF (ldim .EQ. 2) EIGAA = PI*PI*(XX2+YY2)/2.
      IF (ldim .EQ. 3) EIGAA = PI*PI*(XX2+YY2+ZZ2)/3.
      IF (IFAXIS)      EIGAA = .25*PI*PI*YY2
      EIGAS  = 0.25*RATIO
      EIGGS  = 2.0
C
      IF (NIO.EQ.0 .AND. ISTEP.LE.0) THEN
         WRITE (6,*) ' '
         WRITE (6,*) 'Estimated eigenvalues'
         WRITE (6,*) 'EIGAA = ',EIGAA
         WRITE (6,*) 'EIGGA = ',EIGGA
         IF (IFFLOW) THEN
            WRITE (6,*) 'EIGAE = ',EIGAE
            WRITE (6,*) 'EIGAS = ',EIGAS
            WRITE (6,*) 'EIGGE = ',EIGGE
            WRITE (6,*) 'EIGGS = ',EIGGS
         ENDIF
         WRITE (6,*) ' '
      ENDIF
C
      RETURN
      END
C
      SUBROUTINE EIGENV
C-------------------------------------------------------------------------
C
C     Compute the following eigenvalues:
C     EIGAA  = minimum eigenvalue of the matrix A  (=Laplacian)
C     EIGAE  = minimum eigenvalue of the matrix E  (=DB-1DT)
C     EIGAS  = minimum eigenvalue of the matrix S  (=DA-1DT)
C     EIGAST = minimum eigenvalue of the matrix St (=D(A+B/dt)-1DT
C     EIGGA  = maximum eigenvalue of the matrix A
C     EIGGS  = maximum eigenvalue of the matrix S
C     EIGGE  = maximum eigenvalue of the matrix E
C     EIGGST = maximum eigenvalue of the matrix St
C
C     Method : Power method/Inverse iteration & Rayleigh quotient wo shift
C
C-------------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'EIGEN'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
C
      COMMON /SCRVH/ H1 (LX1,LY1,LZ1,LELT)
     $ ,             H2 (LX1,LY1,LZ1,LELT)
      COMMON /SCRHI/ H2INV (LX1,LY1,LZ1,LELV)
C
      NTOT1  = lx1*ly1*lz1*NELV
C
      IF (IFAA) THEN
         NTOT1  = lx1*ly1*lz1*NELV
         CALL RONE    (H1,NTOT1)
         CALL RZERO   (H2,NTOT1)
         CALL ALPHAM1 (EIGAA1,V1MASK,VMULT,H1,H2,1)
         CALL ALPHAM1 (EIGAA2,V2MASK,VMULT,H1,H2,2)
         EIGAA = MIN  (EIGAA1,EIGAA2)
         IF (ldim.EQ.3) THEN
            CALL ALPHAM1 (EIGAA3,V3MASK,VMULT,H1,H2,3)
            EIGAA = MIN  (EIGAA,EIGAA3)
         ENDIF
         IF (NIO.EQ.0 .AND. ISTEP.LE.0) WRITE (6,*) 'EIGAA = ',EIGAA
      ENDIF
C
      IF (IFAS) THEN
         INLOC = 0
         CALL RONE    (H1,NTOT1)
         CALL RZERO   (H2,NTOT1)
         CALL RZERO   (H2INV,NTOT1)
         CALL ALPHAM2  (EIGAS,H1,H2,H2INV,INLOC)
         IF (NIO.EQ.0 .AND. ISTEP.LE.0) WRITE (6,*) 'EIGAS = ',EIGAS
      ENDIF
C
      IF (IFAE) THEN
         INLOC = 1
         CALL RZERO   (H1,NTOT1)
         CALL RONE    (H2,NTOT1)
         CALL RONE    (H2INV,NTOT1)
         CALL ALPHAM2  (EIGAE,H1,H2,H2INV,INLOC)
         IF (NIO.EQ.0 .AND. ISTEP.LE.0) WRITE (6,*) 'EIGAE = ',EIGAE
      ENDIF
C
      IF (IFAST) THEN
         INLOC = -1
         CALL SETHLM  (H1,H2,INLOC)
         CALL INVERS2 (H2INV,H2,NTOT1)
         CALL ALPHAM2  (EIGAST,H1,H2,H2INV,INLOC)
         IF (NIO.EQ.0 .AND. ISTEP.LE.0) WRITE (6,*) 'EIGAST = ',EIGAST
      ENDIF
C
      IF (IFGS) THEN
         INLOC = 0
         CALL RONE    (H1,NTOT1)
         CALL RZERO   (H2,NTOT1)
         CALL RZERO   (H2INV,NTOT1)
         CALL GAMMAM2 (EIGGS,H1,H2,H2INV,INLOC)
         IF (NIO.EQ.0 .AND. ISTEP.LE.0) WRITE (6,*) 'EIGGS = ',EIGGS
      ENDIF
C
      IF (IFGE) THEN
         INLOC = 1
         CALL RZERO   (H1,NTOT1)
         CALL RONE    (H2,NTOT1)
         CALL RONE    (H2INV,NTOT1)
         CALL GAMMAM2 (EIGGE,H1,H2,H2INV,INLOC)
         IF (NIO.EQ.0 .AND. ISTEP.LE.0) WRITE (6,*) 'EIGGE = ',EIGGE
      ENDIF
C
      IF (IFGST) THEN
         INLOC = -1
         CALL SETHLM  (H1,H2,INLOC)
         CALL INVERS2 (H2INV,H2,NTOT1)
         CALL GAMMAM2 (EIGGST,H1,H2,H2INV,INLOC)
         IF (NIO.EQ.0 .AND. ISTEP.LE.0) WRITE (6,*) 'EIGGST = ',EIGGST
      ENDIF
C
      IF (IFGA) THEN
         NTOT1  = lx1*ly1*lz1*NELV
         CALL RONE    (H1,NTOT1)
         CALL RZERO   (H2,NTOT1)
         IF (.NOT.IFSTRS) THEN
            CALL GAMMAM1 (EIGGA1,V1MASK,VMULT,H1,H2,1)
            CALL GAMMAM1 (EIGGA2,V2MASK,VMULT,H1,H2,2)
            EIGGA3 = 0.
            IF (ldim.EQ.3)
     $      CALL GAMMAM1 (EIGGA3,V3MASK,VMULT,H1,H2,3)
            EIGGA = MAX  (EIGGA1,EIGGA2,EIGGA3)
         ELSE
            CALL GAMMASF (H1,H2)
         ENDIF
      ENDIF
C
      RETURN
      END
C
      SUBROUTINE ALPHAM1 (ALPHA,MASK,MULT,H1,H2,ISD)
C---------------------------------------------------------------------------
C
C     Compute minimum eigenvalue, ALPHA, of the discrete Helmholtz operator
C
C---------------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
C
      REAL            MASK (LX1,LY1,LZ1,1)
      REAL            MULT (LX1,LY1,LZ1,1)
      REAL            H1   (LX1,LY1,LZ1,1)
      REAL            H2   (LX1,LY1,LZ1,1)
      COMMON /SCREV/  X1   (LX1,LY1,LZ1,LELT)
     $ ,              Y1   (LX1,LY1,LZ1,LELT)
      CHARACTER NAME*4
C
      IF (IMESH.EQ.1) NEL  = NELV
      IF (IMESH.EQ.2) NEL  = NELT
      IF (ISD  .EQ.1) NAME = 'EVVX'
      IF (ISD  .EQ.2) NAME = 'EVVX'
      IF (ISD  .EQ.3) NAME = 'EVVX'
C
      NXYZ1  = lx1*ly1*lz1
      NTOT1  = NXYZ1*NEL
      EVNEW  = 0.
      CALL STARTX1 (X1,Y1,MASK,MULT,NEL)
C
      DO 1000 ITER=1,NMXE
         CALL AXHELM (Y1,X1,H1,H2,IMESH,ISD)
         CALL COL2   (Y1,MASK,NTOT1)
         CALL DSSUM  (Y1,lx1,ly1,lz1)
         RQ     = GLSC3 (X1,Y1,MULT,NTOT1)
         EVOLD  = EVNEW
         EVNEW  = RQ
         write (6,*) 'alphaa = ',rq
         CRIT   = ABS((EVNEW-EVOLD)/EVNEW)
         IF (CRIT.LT.TOLEV)                  GOTO 2000
         CALL COL2    (X1,BM1,NTOT1)
         CALL HMHOLTZ ('NOMG',Y1,X1,H1,H2,MASK,MULT,
     $                              IMESH,TOLHE,NMXE,ISD)
         CALL COL3    (X1,BM1,Y1,NTOT1)
         CALL DSSUM   (X1,lx1,ly1,lz1)
         YY = GLSC3  (X1,Y1,MULT,NTOT1)
         YNORM = 1./SQRT(YY)
         CALL CMULT   (Y1,YNORM,NTOT1)
         CALL COPY    (X1,Y1,NTOT1)
 1000 CONTINUE
 2000 CONTINUE
C
      ALPHA = RQ
      RETURN
      END
C
      SUBROUTINE GAMMAM1 (GAMMA,MASK,MULT,H1,H2,ISD)
C---------------------------------------------------------------------------
C
C     Compute maximum eigenvalue of the discrete Helmholtz operator
C
C---------------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
C
      REAL            MASK (LX1,LY1,LZ1,1)
      REAL            MULT (LX1,LY1,LZ1,1)
      REAL            H1   (LX1,LY1,LZ1,1)
      REAL            H2   (LX1,LY1,LZ1,1)
      COMMON /SCREV/  X1   (LX1,LY1,LZ1,LELT)
     $ ,              Y1   (LX1,LY1,LZ1,LELT)
C
      IF (IMESH.EQ.1) NEL = NELV
      IF (IMESH.EQ.2) NEL = NELT
      NXYZ1  = lx1*ly1*lz1
      NTOT1  = NXYZ1*NEL
      EVNEW  = 0.
c     pff (2/15/96)
      if (isd.eq.1) CALL STARTX1 (X1,Y1,MASK,MULT,NEL)
C
      DO 1000 ITER=1,NMXE
         CALL AXHELM (Y1,X1,H1,H2,IMESH,ISD)
         CALL COL2   (Y1,MASK,NTOT1)
         CALL DSSUM  (Y1,lx1,ly1,lz1)
         RQ     = GLSC3 (X1,Y1,MULT,NTOT1)
         EVOLD  = EVNEW
         EVNEW  = RQ
         CRIT   = ABS((EVNEW-EVOLD)/EVNEW)
C
C HMT removed
C
C         if (nio.eq.0) then
C            write(6,*) iter,' eig_max A:',evnew,crit,tolev
C         endif
         IF (CRIT.LT.TOLEV)                  GOTO 2000
         CALL COL3 (X1,BINVM1,Y1,NTOT1)
         XX     = GLSC3 (X1,Y1,MULT,NTOT1)
         XNORM  = 1./SQRT(XX)
         CALL CMULT (X1,XNORM,NTOT1)
 1000 CONTINUE
 2000 CONTINUE
C
      GAMMA = RQ
      RETURN
      END
C
      SUBROUTINE ALPHAM2 (ALPHA,H1,H2,H2INV,INLOC)
C----------------------------------------------------------------------
C
C     Compute minimum eigenvalue, ALPHA, of one of the matrices
C     defined on the pressure mesh:
C     INLOC =  0  : DA-1DT
C     INLOC =  1  : DB-1DT
C     INLOC = -1  : D(A+B/DT)-1DT
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
C
      REAL           H1   (LX1,LY1,LZ1,1)
      REAL           H2   (LX1,LY1,LZ1,1)
      REAL           H2INV(LX1,LY1,LZ1,1)
      COMMON /SCREV/ X2   (LX2,LY2,LZ2,LELV)
     $ ,             Y2   (LX2,LY2,LZ2,LELV)
C
      NTOT2  = lx2*ly2*lz2*NELV
      EVNEW  = 0.
      CALL STARTX2 (X2,Y2)
C
      DO 1000 ITER=1,NMXE
         CALL CDABDTP (Y2,X2,H1,H2,H2INV,INLOC)
         RQ = GLSC2  (X2,Y2,NTOT2)
         EVOLD  = EVNEW
         EVNEW  = RQ
c        write (6,*) 'new eigenvalue ************* eigas = ',evnew
         CRIT   = ABS((EVNEW-EVOLD)/EVNEW)
         IF (CRIT.LT.TOLEV)                GOTO 2000
         CALL COL2   (X2,BM2,NTOT2)
         CALL UZAWA  (X2,H1,H2,H2INV,INLOC,ICG)
         CALL COL3   (Y2,BM2,X2,NTOT2)
         XX = GLSC2 (X2,Y2,NTOT2)
         XNORM = 1./SQRT(XX)
         CALL CMULT  (X2,XNORM,NTOT2)
 1000 CONTINUE
 2000 CONTINUE
C
      ALPHA = RQ
      RETURN
      END
C
      SUBROUTINE GAMMAM2 (GAMMA,H1,H2,H2INV,INLOC)
C-------------------------------------------------------------------
C
C     Compute maximum eigenvalue, GAMMA, of one of the matrices
C     defined on the pressure mesh:
C     INLOC =  0  : DA-1DT
C     INLOC =  1  : DB-1DT
C     INLOC = -1  : D(A+B/DT)-1DT
C
C-------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
C
      REAL           H1    (LX1,LY1,LZ1,1)
      REAL           H2    (LX1,LY1,LZ1,1)
      REAL           H2INV (LX1,LY1,LZ1,1)
      COMMON /SCREV/ X2 (LX2,LY2,LZ2,LELV)
     $ ,             Y2 (LX2,LY2,LZ2,LELV)
C
      NTOT2  = lx2*ly2*lz2*NELV
      EVNEW  = 0.
      CALL STARTX2 (X2,Y2)
C
      DO 1000 ITER=1,NMXE
         CALL CDABDTP (Y2,X2,H1,H2,H2INV,INLOC)
         RQ = GLSC2  (X2,Y2,NTOT2)
         EVOLD  = EVNEW
         EVNEW  = RQ
         CRIT   = ABS((EVNEW-EVOLD)/EVNEW)
         IF (CRIT.LT.TOLEV)                GOTO 2000
         CALL INVCOL3 (X2,Y2,BM2,NTOT2)
         XX     = GLSC2  (Y2,X2,NTOT2)
         XNORM  = 1./SQRT(XX)
         CALL CMULT   (X2,XNORM,NTOT2)
 1000 CONTINUE
 2000 CONTINUE
C
      GAMMA = RQ
      RETURN
      END
C
c-----------------------------------------------------------------------
      SUBROUTINE STARTX1 (X1,Y1,MASK,MULT,NEL)

c     Compute startvector for finding an eigenvalue on mesh 1.
c     Normalization: XT*B*X = 1

      INCLUDE 'SIZE'
      INCLUDE 'MASS'

      REAL X1   (LX1,LY1,LZ1,1)
      REAL Y1   (LX1,LY1,LZ1,1)
      REAL MASK (LX1,LY1,LZ1,1)
      REAL MULT (LX1,LY1,LZ1,1)

      NTOT1 = lx1*ly1*lz1*NEL
      CALL COPY       (X1,BM1,NTOT1)


      call rand_fld_h1(y1)            ! pff 3/21/12
      small = 0.001*glamax(x1,ntot1)
      call add2s2(x1,y1,small,ntot1)


      CALL COL2       (X1,MASK,NTOT1)
      CALL COL3       (Y1,BM1,X1,NTOT1)
      CALL DSSUM      (Y1,lx1,ly1,lz1)
      XX     = GLSC3 (X1,Y1,MULT,NTOT1)
      XNORM  = 1./SQRT(XX)
      CALL CMULT      (X1,XNORM,NTOT1)

      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE STARTX2 (X2,Y2)
C------------------------------------------------------------------
C
C     Compute startvector for finding an eigenvalue on mesh 2.
C
C------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
C
      REAL X2 (LX2,LY2,LZ2,LELV)
      REAL Y2 (LX2,LY2,LZ2,LELV)
C
      NXYZ2  = lx2*ly2*lz2
      NTOT2  = NXYZ2*NELV
      ICONST = 0
      IF ((ldim .EQ. 2).AND.(NXYZ2 .EQ. 4)) ICONST = 1
      IF ((ldim .EQ. 3).AND.(NXYZ2 .EQ. 8)) ICONST = 1
C
      IF (ICONST .EQ. 1) THEN
         DO 1000 IEL=1,NELV
         DO 1000 K=1,lz2
         DO 1000 J=1,ly2
         DO 1000 I=1,lx2
            X2(I,J,K,IEL) = I*J*K
 1000    CONTINUE
      ELSE
         CALL COPY (X2,BM2,NTOT2)
      ENDIF
C
      call ortho (x2)
      CALL COL3 (Y2,BM2,X2,NTOT2)
      XX     = GLSC2 (X2,Y2,NTOT2)
      XNORM  = 1./SQRT(XX)
      CALL CMULT (X2,XNORM,NTOT2)
C
      RETURN
      END

c-----------------------------------------------------------------------
c
c     To do:
c
c        Differing BC's imposed for ophinv, incomprn, etc.
c
c        1-shot Fast solver for Helmholtz and pressure
c
c
c-----------------------------------------------------------------------
      subroutine induct (igeom)
c
c     Solve the convection-diffusion equation for the B-field, with
c     projection onto a div-free space.
c
c
      include 'SIZE'
      include 'INPUT'
      include 'EIGEN'
      include 'SOLN'
      include 'TSTEP'
      include 'MASS'

      common /scrns/  resv1 (lx1,ly1,lz1,lelv)
     $ ,              resv2 (lx1,ly1,lz1,lelv)
     $ ,              resv3 (lx1,ly1,lz1,lelv)
     $ ,              dv1   (lx1,ly1,lz1,lelv)
     $ ,              dv2   (lx1,ly1,lz1,lelv)
     $ ,              dv3   (lx1,ly1,lz1,lelv)
      common /scrvh/  h1    (lx1,ly1,lz1,lelv)
     $ ,              h2    (lx1,ly1,lz1,lelv)

      ifield = ifldmhd

      if (igeom.eq.1) then  ! old geometry, old velocity

         call makebsource_mhd

      else

         call lagbfield
         call lagvel

         call elsasserh(igeom)

         call vol_flow        ! check for fixed flow rate


      endif
c
      return
      end
c--------------------------------------------------------------------
      subroutine lagbfield
c
c     Keep old B-field(s)
c
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
c
      do ilag=nbdinp-1,2,-1
         call opcopy
     $    ( bxlag(1,ilag  ),bylag(1,ilag  ),bzlag(1,ilag  )
     $    , bxlag(1,ilag-1),bylag(1,ilag-1),bzlag(1,ilag-1) )
      enddo
      call opcopy (bxlag,bylag,bzlag,bx,by,bz)
c
      return
      end
c--------------------------------------------------------------------
      subroutine makebsource_mhd
c
c     Make rhs for induction equation
c
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'INPUT'
      include 'TSTEP'
      include 'CTIMER'

      if (icalld.eq.0) tbmhd=0.0
      icalld = icalld+1
      nbmhd  = icalld
      etime1 = dnekclock()
c
      ifield = 1
                                      call makeuf
c
      ifield = ifldmhd
                                      call makeufb
      if (ifaxis) then
c        do ifield = 2,3
         do ifield = 2,npscal+1
                                      call makeuq  ! nonlinear terms
         enddo
         ifield = ifldmhd
      endif

      if (ifnav.and.(.not.ifchar)) then
         call advab_elsasser_fast
      endif
      if (ifchar) then
         write(6,*) 'No IFCHAR for MHD, yet.'
         call exitt
      endif

      ifield = 1
      if (iftran)                     call makeabf
                                      call makebdf
c
      ifield = ifldmhd
      if (iftran)                     call makextb
                                      call makebdfb
c
      tbmhd=tbmhd+(dnekclock()-etime1)
      return
      end
c--------------------------------------------------------------------
      subroutine makeufb
c
c     Compute and add: (1) user specified forcing function (FX,FY,FZ)
c
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
C
      time = time-dt
      call nekuf   (bmx,bmy,bmz)
      call opcolv2 (bmx,bmy,bmz,vtrans(1,1,1,1,ifield),bm1)
      time = time+dt
c
      return
      end
c--------------------------------------------------------------------
      subroutine makextb
c
c     Add extrapolation terms to magnetic source terms
c
c     (nek5 equivalent for velocity is "makeabf")
c
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
C
      common /scrns/ ta1 (lx1,ly1,lz1,lelv)
     $ ,             ta2 (lx1,ly1,lz1,lelv)
     $ ,             ta3 (lx1,ly1,lz1,lelv)
c
      ntot1 = lx1*ly1*lz1*nelv
c
      ab0 = ab(1)
      ab1 = ab(2)
      ab2 = ab(3)
      call add3s2 (ta1,bbx1,bbx2,ab1,ab2,ntot1)
      call add3s2 (ta2,bby1,bby2,ab1,ab2,ntot1)
      call copy   (bbx2,bbx1,ntot1)
      call copy   (bby2,bby1,ntot1)
      call copy   (bbx1,bmx,ntot1)
      call copy   (bby1,bmy,ntot1)
      call add2s1 (bmx,ta1,ab0,ntot1)
      call add2s1 (bmy,ta2,ab0,ntot1)
      if (ldim.eq.3) then
         call add3s2 (ta3,bbz1,bbz2,ab1,ab2,ntot1)
         call copy   (bbz2,bbz1,ntot1)
         call copy   (bbz1,bmz,ntot1)
         call add2s1 (bmz,ta3,ab0,ntot1)
      endif
c
      return
      end
c--------------------------------------------------------------------
      subroutine makebdfb
C
C     Add contributions to magnetic source from lagged BD terms.
C
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
C
      COMMON /SCRNS/ TA1(LX1,LY1,LZ1,LELV)
     $ ,             TA2(LX1,LY1,LZ1,LELV)
     $ ,             TA3(LX1,LY1,LZ1,LELV)
     $ ,             TB1(LX1,LY1,LZ1,LELV)
     $ ,             TB2(LX1,LY1,LZ1,LELV)
     $ ,             TB3(LX1,LY1,LZ1,LELV)
     $ ,             H2 (LX1,LY1,LZ1,LELV)
C
      NTOT1 = lx1*ly1*lz1*NELV
      CONST = 1./DT
      CALL CMULT2(H2,vtrans(1,1,1,1,ifield),CONST,NTOT1)
      CALL OPCOLV3c (TB1,TB2,TB3,BX,BY,BZ,BM1,bd(2))
C
      DO 100 ILAG=2,NBD
         IF (IFGEOM) THEN
            CALL OPCOLV3c(TA1,TA2,TA3,BXLAG (1,ILAG-1),
     $                                BYLAG (1,ILAG-1),
     $                                BZLAG (1,ILAG-1),
     $                                BM1LAG(1,1,1,1,ILAG-1),bd(ilag+1))
         ELSE
            CALL OPCOLV3c(TA1,TA2,TA3,BXLAG (1,ILAG-1),
     $                                BYLAG (1,ILAG-1),
     $                                BZLAG (1,ILAG-1),
     $                                BM1                   ,bd(ilag+1))
         ENDIF
         CALL OPADD2  (TB1,TB2,TB3,TA1,TA2,TA3)
 100  CONTINUE
      CALL OPADD2col (BMX,BMY,BMZ,TB1,TB2,TB3,h2)
c
      return
      end
c--------------------------------------------------------------------
      subroutine cresvib(resv1,resv2,resv3,h1,h2)
c
c     Account for inhomogeneous Dirichlet boundary contributions 
c     in rhs of induction eqn.
c                                               n
c     Also, subtract off best estimate of grad p
c
      include 'SIZE'
      include 'TOTAL'
      real           resv1 (lx1,ly1,lz1,1)
      real           resv2 (lx1,ly1,lz1,1)
      real           resv3 (lx1,ly1,lz1,1)
      real           h1    (lx1,ly1,lz1,1)
      real           h2    (lx1,ly1,lz1,1)
      common /scruz/ w1    (lx1,ly1,lz1,lelv)
     $ ,             w2    (lx1,ly1,lz1,lelv)
     $ ,             w3    (lx1,ly1,lz1,lelv)
c
c
      call bcdirvc (bx,by,bz,b1mask,b2mask,b3mask)
      call extrapp (pm,pmlag)
      call opgradt (resv1,resv2,resv3,pm)
      call opadd2  (resv1,resv2,resv3,bmx,bmy,bmz)
c     call opcopy  (resv1,resv2,resv3,bmx,bmy,bmz)
      call ophx    (w1,w2,w3,bx,by,bz,h1,h2)
      call opsub2  (resv1,resv2,resv3,w1,w2,w3)
c
      return
      end
c--------------------------------------------------------------------
      subroutine cresvibp(resv1,resv2,resv3,h1,h2)
c
c     Account for inhomogeneous Dirichlet boundary contributions 
c     in rhs of momentum eqn.
c                                               n
c     Also, subtract off best estimate of grad p
c
      include 'SIZE'
      include 'TOTAL'
      real           resv1 (lx1,ly1,lz1,1)
      real           resv2 (lx1,ly1,lz1,1)
      real           resv3 (lx1,ly1,lz1,1)
      real           h1    (lx1,ly1,lz1,1)
      real           h2    (lx1,ly1,lz1,1)
      common /scruz/ w1    (lx1,ly1,lz1,lelv)
     $ ,             w2    (lx1,ly1,lz1,lelv)
     $ ,             w3    (lx1,ly1,lz1,lelv)
c
      call bcdirvc (vx,vy,vz,v1mask,v2mask,v3mask)
      if (ifstrs)  call bcneutr
      call extrapp (pr,prlag)
      call opgradt (resv1,resv2,resv3,pr)
      call opadd2  (resv1,resv2,resv3,bfx,bfy,bfz)
c     call opcopy  (resv1,resv2,resv3,bfx,bfy,bfz)
      call ophx    (w1,w2,w3,vx,vy,vz,h1,h2)
      call opsub2  (resv1,resv2,resv3,w1,w2,w3)
c
      return
      end
c--------------------------------------------------------------------
      subroutine incomprn (ux,uy,uz,up)
c
c     Project U onto the closest incompressible field
c
c     Input:  U     := (ux,uy,uz)
c
c     Output: updated values of U, iproj, proj; and
c             up    := pressure currection req'd to impose div U = 0
c
c
c     Dependencies: ifield ==> which "density" (vtrans) is used.
c
c     Notes  1.  up is _not_ scaled by bd(1)/dt.  This should be done
c                external to incompr().
c
c            2.  up accounts _only_ for the perturbation pressure,
c                not the current pressure derived from extrapolation.
c
c
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
c
      common /scrns/ w1    (lx1,ly1,lz1,lelv)
     $ ,             w2    (lx1,ly1,lz1,lelv)
     $ ,             w3    (lx1,ly1,lz1,lelv)
     $ ,             dv1   (lx1,ly1,lz1,lelv)
     $ ,             dv2   (lx1,ly1,lz1,lelv)
     $ ,             dv3   (lx1,ly1,lz1,lelv)
     $ ,             dp    (lx2,ly2,lz2,lelv)
      common /scrvh/ h1    (lx1,ly1,lz1,lelv)
     $ ,             h2    (lx1,ly1,lz1,lelv)
      common /scrhi/ h2inv (lx1,ly1,lz1,lelv)

      parameter(nset = 1 + lbelv/lelv)
      common /orthov/ pset(lx2*ly2*lz2*lelv*mxprev,nset)
      common /orthbi/ nprv(2)
      logical ifprjp

      ifprjp=.false.    ! Project out previous pressure solutions?
      istart=param(95)  
      if (istep.ge.istart.and.istart.ne.0) ifprjp=.true.

      if (icalld.eq.0) tpres=0.0
      icalld = icalld+1
      npres  = icalld
      etime1 = dnekclock()

      ntot1  = lx1*ly1*lz1*nelv
      ntot2  = lx2*ly2*lz2*nelv
      intype = 1

      call rzero   (h1,ntot1)
      call copy    (h2,vtrans(1,1,1,1,ifield),ntot1)
      call invers2 (h2inv,h2,ntot1)

      call opdiv   (dp,ux,uy,uz)

      bdti = -bd(1)/dt
      call cmult   (dp,bdti,ntot2)

      call add2col2(dp,bm2,usrdiv,ntot2) ! User-defined divergence.

      call ortho   (dp)

      i = 1 + ifield/ifldmhd
      if (ifprjp)   call setrhsp  (dp,h1,h2,h2inv,pset(1,i),nprv(i))
                    scaledt = dt/bd(1)
                    scaledi = 1./scaledt
                    call cmult(dp,scaledt,ntot2)        ! scale for tol
                    call esolver  (dp,h1,h2,h2inv,intype)
                    call cmult(dp,scaledi,ntot2)
      if (ifprjp)   call gensolnp (dp,h1,h2,h2inv,pset(1,i),nprv(i))

      call add2(up,dp,ntot2)

      call opgradt  (w1 ,w2 ,w3 ,dp)
      call opbinv   (dv1,dv2,dv3,w1 ,w2 ,w3 ,h2inv)
      dtb  = dt/bd(1)
      call opadd2cm (ux ,uy ,uz ,dv1,dv2,dv3, dtb )

      if (ifmhd)  call chkptol	! to avoid repetition

      tpres=tpres+(dnekclock()-etime1)

      return
      end
c-----------------------------------------------------------------------
      subroutine extrapp(p,plag)
C
C     Pressure extrapolation
C
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'

      real  p    (lx2,ly2,lz2,1)
     $     ,plag (lx2,ly2,lz2,1)

      common /cgeom/ igeom

      ntot2 = lx2*ly2*lz2*nelv

      if (nbd.eq.2.and.nbdinp.gt.2.and.igeom.le.2) then
         call copy(plag,p,ntot2)
      elseif (nbd.eq.3.and.igeom.le.2) then

         const = dtlag(1)/dtlag(2)

         do i=1,ntot2
            pnm1          = p   (i,1,1,1)
            pnm2          = plag(i,1,1,1)
            p   (i,1,1,1) = pnm1 + const*(pnm1-pnm2)
            plag(i,1,1,1) = pnm1
         enddo

      elseif (nbd.gt.3) then
         WRITE (6,*) 'Pressure extrapolation cannot be completed'
         WRITE (6,*) 'Try a lower-order temporal scheme'
         call exitt
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine opzero(ux,uy,uz)
      include 'SIZE'
      include 'TOTAL'
      real ux(1),uy(1),uz(1)
c
      n = lx1*ly1*lz1*nelfld(ifield)
      call rzero(ux,n)
      call rzero(uy,n)
      if (if3d) call rzero(uz,n)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine opnorm(unorm,ux,uy,uz,type3)
      include 'SIZE'
      include 'TOTAL'
      character*3 type3
      real ux(1),uy(1),uz(1)
      real un(3),wn(3)
c
      n = lx1*ly1*lz1*nelfld(ifield)
      if (type3.eq.'L2 ') then
         if (if3d) then
            un(1) = vlsc3(ux,ux,bm1,n)
            un(2) = vlsc3(uy,uy,bm1,n)
            un(3) = vlsc3(uz,uz,bm1,n)
            un(1) = un(1) + un(2) + un(3)
            unorm = glsum(un(1),1)
            if (unorm.gt.0) unorm = sqrt(unorm/volvm1)
         else
            un(1) = vlsc3(ux,ux,bm1,n)
            un(2) = vlsc3(uy,uy,bm1,n)
            un(1) = un(1) + un(2)
            unorm = glsum(un(1),1)
            if (unorm.gt.0) unorm = sqrt(unorm/volvm1)
         endif
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine lorentz_force (lf,b1,b2,b3,w1,w2)
c
c     Compute Lorentz force
c
c     Input:  B     := (b1,b2,b3)
c
c     Output: lf(1,ldim)
c
c     Work arrays: w1(ltot) and w2(ltot)
c
c     The output will not be continuous.  However, it will be in
c     the form appropriate for incorporation as a body force term 
c     in the variational formulation of the Navier-Stokes equations.
c
c     (i.e.,   rhs(NS) = rhs(NS) + B*lf,  where B is the mass matrix)
c
      include 'SIZE'
c
      real lf(lx1*ly1*lz1*lelv,ldim)
      real b1(lx1*ly1*lz1*lelv)
      real b2(lx1*ly1*lz1*lelv)
      real b3(lx1*ly1*lz1*lelv)
c
      call curl(lf,b1,b2,b3,.false.,w1,w2)
c
      ntot = lx1*ly1*lz1*nelv
c
      do i=1,ntot
         c1 = lf(i,2)*b3(i) - lf(i,3)*b2(i)
         c2 = lf(i,3)*b1(i) - lf(i,1)*b3(i)
         c3 = lf(i,1)*b2(i) - lf(i,2)*b1(i)
         lf(i,1) = c1
         lf(i,2) = c2
         lf(i,3) = c3
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine curl(vort,u,v,w,ifavg,work1,work2)
c
      include 'SIZE'
      include 'TOTAL'
c
      logical ifavg
c
      parameter(lt=lx1*ly1*lz1*lelv)
      real vort(lt,3),work1(1),work2(1),u(1),v(1),w(1)
c
      ntot  = lx1*ly1*lz1*nelv
      if (if3d) then
c        work1=dw/dy ; work2=dv/dz
           call dudxyz(work1,w,rym1,sym1,tym1,jacm1,1,2)
           call dudxyz(work2,v,rzm1,szm1,tzm1,jacm1,1,3)
           call sub3(vort(1,1),work1,work2,ntot)
c        work1=du/dz ; work2=dw/dx
           call dudxyz(work1,u,rzm1,szm1,tzm1,jacm1,1,3)
           call dudxyz(work2,w,rxm1,sxm1,txm1,jacm1,1,1)
           call sub3(vort(1,2),work1,work2,ntot)
c        work1=dv/dx ; work2=du/dy
           call dudxyz(work1,v,rxm1,sxm1,txm1,jacm1,1,1)
           call dudxyz(work2,u,rym1,sym1,tym1,jacm1,1,2)
           call sub3(vort(1,3),work1,work2,ntot)
      else
c        work1=dv/dx ; work2=du/dy
           call dudxyz(work1,v,rxm1,sxm1,txm1,jacm1,1,1)
           call dudxyz(work2,u,rym1,sym1,tym1,jacm1,1,2)
           call sub3(vort(1,3),work1,work2,ntot)
      endif
c
c    Avg at bndry
c
      if (ifavg) then
         ifielt = ifield
         ifield = 1
         if (if3d) then
            do idim=1,ldim
               call col2  (vort(1,idim),bm1,ntot)
               call dssum (vort(1,idim),lx1,ly1,lz1)
               call col2  (vort(1,idim),binvm1,ntot)
            enddo
         else
            call col2  (vort(1,3),bm1,ntot)    ! NOTE:  This differs from
            call dssum (vort(1,3),lx1,ly1,lz1) ! "comp_vort", which returns
            call col2  (vort(1,3),binvm1,ntot) ! vorticity as 1st entry in vort
         endif
         ifield = ifielt
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine lorentz_force2(lf,b1,b2,b3)
c
c     Compute Lorentz force
c
c     Input:  B     := (b1,b2,b3)
c
c     Output: lf(1,ldim)
c
c     Work arrays: w1(ltot) and w2(ltot)
c
c     The output will not be continuous.  However, it will be in
c     the form appropriate for incorporation as a body force term 
c     in the variational formulation of the Navier-Stokes equations.
c
c     (i.e.,   rhs(NS) = rhs(NS) + B*lf,  where B is the mass matrix)
c
      include 'SIZE'
c
      real lf(lx1*ly1*lz1*ldim,lelt)
      real b1(lx1*ly1*lz1,lelt)
      real b2(lx1*ly1*lz1,lelt)
      real b3(lx1*ly1*lz1,lelt)
c
      integer e
c
      do e = 1,nelt   ! NOTE:  the order is different from v. 1
         call lorentz_force_e(lf(1,e),b1(1,e),b2(1,e),b3(1,e),e)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine lorentz_force_e(lf,b1,b2,b3,e)
c
c     Compute Lorentz force field for a single element
c
c     Input:  B     := (b1,b2,b3)
c
c     Output: lf(1,ldim)
c
c     Work arrays: cb(lxyzd) and w2(lxyzd)
c
c     The output will not be continuous.  However, it will be in
c     the form appropriate for incorporation as a body force term 
c     in the variational formulation of the Navier-Stokes equations.
c     (i.e.,   rhs(NS) = rhs(NS) + B*lf,  where B is the mass matrix)
c
c     Dealiasing strategy:
c
c       e      e  -1   ~ T  ~e   ~ ~      
c     lf  = ( B  )     I    B  ( I j x I b )
c       i              ~                    i
c
c            ~
c     Here,  I is the interpolant from N to M, where M = 3/2 N.
c
c            ~                                  -1
c            j is a special curl  (sans Jacobian   )
c
c            b is the B-field on the N-points
c
c            ~e
c            B  is the local mass matrix on the M-points (sans Jacabian)
c
c             e
c            B  is the local mass matrix on the N-points (with Jacabian)
c
c     The last B is req'd to compensate for the subsequent multiplication 
c     by B that takes place once the rhs is formed.
c
c
c
      include 'SIZE'
      include 'DEALIAS'
      include 'GEOM'
      include 'WZ'
c
      real lf(lx1*ly1*lz1,3)
      real b1(lx1*ly1*lz1)
      real b2(lx1*ly1*lz1)
      real b3(lx1*ly1*lz1)
      integer d,e
c
      integer icalld
      save    icalld
      data    icalld /0/
c
      common /ctmp1x/ lfd(lxd*lyd*lzd,3)
     $             ,  bd (lxd*lyd*lzd,3)
     $             ,  cb (lx1*ly1*lz1,3)
     $             ,  cbd(lxd*lyd*lzd,3)
      real lfd

      if (icalld .eq. 0) then
          write(6,*) 'CALL SET PROJ',lx1,lxd
          call setmap (lx1,lxd)   ! Set up interpolation operators
          call setproj(lx1,lxd)   ! Set up interpolation operators
          icalld = icalld + 1
      endif
c
      call spec_curl_e (cb,b1,b2,b3                  !local curl, w/o Jacobian
     $                 , rxm1(1,1,1,e),rym1(1,1,1,e),rzm1(1,1,1,e)
     $                 , sxm1(1,1,1,e),sym1(1,1,1,e),szm1(1,1,1,e)
     $                 , txm1(1,1,1,e),tym1(1,1,1,e),tzm1(1,1,1,e) )
c
      do d=1,ldim                                   ! interpolate to M points
         call specmp(cbd(1,d),lxd,cb(1,d),lx1,im1d,im1dt,bd)
      enddo
      call specmp(bd(1,1),lxd,b1,lx1,im1d,im1dt,lfd)
      call specmp(bd(1,2),lxd,b2,lx1,im1d,im1dt,lfd)
      call specmp(bd(1,3),lxd,b3,lx1,im1d,im1dt,lfd)
c
      nxyzd = lxd*lyd*lzd
      do i=1,nxyzd
         lfd(i,1) = cbd(i,2)*bd(i,3) - cbd(i,3)*bd(i,2) ! Curl B x B
         lfd(i,2) = cbd(i,3)*bd(i,1) - cbd(i,1)*bd(i,3)
         lfd(i,3) = cbd(i,1)*bd(i,2) - cbd(i,2)*bd(i,1)
      enddo
c
c     Project back and simultaneous collocate with local quadrature weights
c
c                                 ~        ~        ~
c        P := Pz x Py x Px  =  Iz*B  x  Iy*B  x  Ix*B
c
c
c           ~            M
c     where B = diag (rho  )
c                        i
c
      call specmp(lf(1,1),lx1,lfd(1,1),lxd,pmd1,pmd1t,cbd)
      call specmp(lf(1,2),lx1,lfd(1,2),lxd,pmd1,pmd1t,cbd)
      call specmp(lf(1,3),lx1,lfd(1,3),lxd,pmd1,pmd1t,cbd)
c
c     Finally, divide by local mass matrix in anticipation of subsequent
c     multiply by BM1.
c
      nxyz = lx1*ly1*lz1
      do i=1,nxyz
c        scale = 1./(w3m1(i,1,1)*jacm1(i,1,1,e))
         scale = 1./jacm1(i,1,1,e)
         lf(i,1) = scale*lf(i,1)
         lf(i,2) = scale*lf(i,2)
         lf(i,3) = scale*lf(i,3)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine spec_curl_e (cb,b1,b2,b3,rx,ry,rz,sx,sy,sz,tx,ty,tz) 
c
c     local curl, multiplied by Jacobian
c
      include 'SIZE'
      include 'DXYZ'
c
      real cb(lx1*ly1*lz1,3)  ! Output J*curl B  (J:=Jacobian)
      real b1(1),b2(1),b3(1)  ! Input B-field
c
      real rx(1),ry(1),rz(1)  ! Metrics
      real sx(1),sy(1),sz(1)
      real tx(1),ty(1),tz(1)
c
      common /ctmp0x/ br(lx1*ly1*lz1),bs(lx1*ly1*lz1),bt(lx1*ly1*lz1)
c
c              / db3     db2 \
c     cb1 = J  | ---  -  --- |    ! Keep J ( J:=Jacobian)
c              \ dy      dz  /
c
c
c              / db1     db3 \
c     cb2 = J  | ---  -  --- |    ! Keep J ( J:=Jacobian)
c              \ dz      dx  /
c
c
c              / db2     db1 \
c     cb3 = J  | ---  -  --- |    ! Keep J ( J:=Jacobian)
c              \ dx      dy  /
c
c
c     Note:
c
c      db2      db2   dr     db2   ds     db2   dt       
c    J --- =    --- J --  +  --- J --  +  --- J --     
c      dz       dr    dz     ds    dz     dt    dz      
c
c              etc.
c
c
c
      nxyz = lx1*ly1*lz1 
c
      N=lx1-1
      call local_grad3(br,bs,bt,b1,N,1,dxm1,dxtm1)
      do i=1,nxyz
         cb(i,2) =  (br(i)*rz(i)+bs(i)*sz(i)+bt(i)*tz(i))
         cb(i,3) = -(br(i)*ry(i)+bs(i)*sy(i)+bt(i)*ty(i))
      enddo
c
      call local_grad3(br,bs,bt,b2,N,1,dxm1,dxtm1)
      do i=1,nxyz
         cb(i,1) = -(br(i)*rz(i)+bs(i)*sz(i)+bt(i)*tz(i))
         cb(i,3) =  (br(i)*rx(i)+bs(i)*sx(i)+bt(i)*tx(i))
     $           +  cb(i,3)
      enddo
c
      call local_grad3(br,bs,bt,b3,N,1,dxm1,dxtm1)
      do i=1,nxyz
         cb(i,1) =  (br(i)*ry(i)+bs(i)*sy(i)+bt(i)*ty(i))
     $           +  cb(i,1)
         cb(i,2) = -(br(i)*rx(i)+bs(i)*sx(i)+bt(i)*tx(i))
     $           +  cb(i,2)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine specx(b,nb,a,na,ba,ab,w)
c
      include 'SIZE'
      include 'INPUT'
      real b(1),a(1)
      real w(1)
c
      n=na*na*na
      do i=1,n
         b(i) = a(i)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine phys_to_elsasser(u1,u2,u3,b1,b2,b3,n)
c
      real u1(1),u2(1),u3(1),b1(1),b2(1),b3(1)
c
      do i=1,n
c
         zpx = u1(i) + b1(i)
         zpy = u2(i) + b2(i)
         zpz = u3(i) + b3(i)
c
         zmx = u1(i) - b1(i)
         zmy = u2(i) - b2(i)
         zmz = u3(i) - b3(i)
c
         u1(i) = zpx
         u2(i) = zpy
         u3(i) = zpz
c
         b1(i) = zmx
         b2(i) = zmy
         b3(i) = zmz
c
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine elsasser_to_phys(u1,u2,u3,b1,b2,b3,n)
c
      real u1(1),u2(1),u3(1),b1(1),b2(1),b3(1)
c
      do i=1,n
c
         zpx = 0.5*( u1(i) + b1(i) )
         zpy = 0.5*( u2(i) + b2(i) )
         zpz = 0.5*( u3(i) + b3(i) )
c
         zmx = 0.5*( u1(i) - b1(i) )
         zmy = 0.5*( u2(i) - b2(i) )
         zmz = 0.5*( u3(i) - b3(i) )
c
         u1(i) = zpx
         u2(i) = zpy
         u3(i) = zpz
c
         b1(i) = zmx
         b2(i) = zmy
         b3(i) = zmz
c
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine phys_to_elsasser2(u1,b1,n)
c
      real u1(1),b1(1)
c
      do i=1,n
         zpx = u1(i) + b1(i)
         zmx = u1(i) - b1(i)
         u1(i) = zpx
         b1(i) = zmx
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine elsasser_to_phys2(u1,b1,n)
c
      real u1(1),b1(1)
c
      do i=1,n
         zpx = 0.5*( u1(i) + b1(i) )
         zmx = 0.5*( u1(i) - b1(i) )
         u1(i) = zpx
         b1(i) = zmx
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine elsasserh(igeom)
c
c
c     Solve MHD in Elsasser variables
c
c
      include 'SIZE'
      include 'INPUT'
      include 'EIGEN'
      include 'SOLN'
      include 'TSTEP'
      include 'MASS'
      include 'GEOM'
C
      common /scrnt/  besv1 (lbx1,lby1,lbz1,lbelv)
     $ ,              besv2 (lbx1,lby1,lbz1,lbelv)
     $ ,              besv3 (lbx1,lby1,lbz1,lbelv)
      COMMON /SCRNS/  RESV1 (LX1,LY1,LZ1,LELV)
     $ ,              RESV2 (LX1,LY1,LZ1,LELV)
     $ ,              RESV3 (LX1,LY1,LZ1,LELV)
     $ ,              DV1   (LX1,LY1,LZ1,LELV)
     $ ,              DV2   (LX1,LY1,LZ1,LELV)
     $ ,              DV3   (LX1,LY1,LZ1,LELV)
      COMMON /SCRVH/  H1    (LX1,LY1,LZ1,LELV)
     $ ,              H2    (LX1,LY1,LZ1,LELV)
c
      n  = lx1*ly1*lz1*nelv
c
c     New geometry, new velocity
c
      intype = -1
c
      ifield = 1
      call sethlm   (h1,h2,intype)
      call cresvibp (resv1,resv2,resv3,h1,h2)
c
      ifield = ifldmhd
      call sethlm   (h1,h2,intype)
      call cresvib  (besv1,besv2,besv3,h1,h2)
c
c
      ifield = 1
      call sethlm   (h1,h2,intype)

      call ophinv   (dv1,dv2,dv3,resv1,resv2,resv3,h1,h2,tolhv,nmxv)

      call opadd2   (vx,vy,vz,dv1,dv2,dv3)

      if (filterType.eq.1) then
         alpha_filt=param(103)                        ! Optional Filtering
         call q_filter(alpha_filt)
      endif

      call incomprn (vx,vy,vz,pr) ! project U onto div-free space

      ifield = ifldmhd
      call sethlm   (h1,h2,intype)

      call ophinv   (dv1,dv2,dv3,besv1,besv2,besv3,h1,h2,tolhv,nmxv)
      call opadd2   (bx,by,bz,dv1,dv2,dv3)

      call incomprn (bx,by,bz,pm) ! project B onto div-free space

      return
      end
c--------------------------------------------------------------------
      subroutine compute_cfl(cfl,u,v,w,dt)
c
c     Given velocity field (u,v,w) and dt, compute current CFL number.
c
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'WZ'
      include 'SOLN'
c
      real u(lx1,ly1,lz1,nelv),v(lx1,ly1,lz1,nelv),w(lx1,ly1,lz1,nelv)
c
c     Store the inverse jacobian to speed up this operation
c
      common /cfldx/ dri(lx1),dsi(ly1),dti(lz1)
c
      integer e
c
      integer icalld
      save    icalld
      data    icalld /0/
c
      if (icalld.eq.0) then
         icalld=1
         call getdr(dri,zgm1(1,1),lx1)
         call getdr(dsi,zgm1(1,2),ly1)
         if (if3d) call getdr(dti,zgm1(1,3),lz1)
      endif

      cfl = 0.
      l   = 0

      if (if3d) then
         nxyz = lx1*ly1*lz1
         do e=1,nelv
            do k=1,lz1
            do j=1,ly1
            do i=1,lx1
               l = l+1
               ur = ( u(i,j,k,e)*rxm1(i,j,k,e)
     $            +   v(i,j,k,e)*rym1(i,j,k,e)
     $            +   w(i,j,k,e)*rzm1(i,j,k,e) ) * jacmi(l,1)
               us = ( u(i,j,k,e)*sxm1(i,j,k,e)
     $            +   v(i,j,k,e)*sym1(i,j,k,e)
     $            +   w(i,j,k,e)*szm1(i,j,k,e) ) * jacmi(l,1)
               ut = ( u(i,j,k,e)*txm1(i,j,k,e)
     $            +   v(i,j,k,e)*tym1(i,j,k,e)
     $            +   w(i,j,k,e)*tzm1(i,j,k,e) ) * jacmi(l,1)
 
               cflr = abs(dt*ur*dri(i))
               cfls = abs(dt*us*dsi(j))
               cflt = abs(dt*ut*dti(k))
 
               cflm = cflr + cfls + cflt
               cfl  = max(cfl,cflm)

               cflf(i,j,k,e) = cflm
 
            enddo
            enddo
            enddo
         enddo
      else
         nxyz = lx1*ly1
         do e=1,nelv
            do j=1,ly1
            do i=1,lx1
               l = l+1
               ur = ( u(i,j,1,e)*rxm1(i,j,1,e)
     $            +   v(i,j,1,e)*rym1(i,j,1,e) ) * jacmi(l,1)
               us = ( u(i,j,1,e)*sxm1(i,j,1,e)
     $            +   v(i,j,1,e)*sym1(i,j,1,e) ) * jacmi(l,1)

               cflr = abs(dt*ur*dri(i))
               cfls = abs(dt*us*dsi(j))

               cflm = cflr + cfls
               cfl  = max(cfl,cflm)

               cflf(i,j,1,e) = cflm

            enddo
            enddo
         enddo
      endif
c
      cfl = glmax(cfl,1)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine getdr(dri,zgm1,lx1)
      real dri(lx1),zgm1(lx1)
c
      dri(1) = zgm1(2) - zgm1(1)   !  Compute 1/Dx
      do i=2,lx1-1
         dri(i) = 0.5*( zgm1(i+1) - zgm1(i-1) )
      enddo
      dri(lx1) = zgm1(lx1) - zgm1(lx1-1)
c
      call invcol1(dri,lx1)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine ophinv(o1,o2,o3,i1,i2,i3,h1,h2,tolh,nmxhi)
C
C     Ok = (H1*A+H2*B)-1 * Ik  (implicit)
C
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'VPROJ'
      include 'TSTEP'
c      logical ifproj
 
      real o1 (lx1,ly1,lz1,1) , o2 (lx1,ly1,lz1,1) , o3 (lx1,ly1,lz1,1)
      real i1 (lx1,ly1,lz1,1) , i2 (lx1,ly1,lz1,1) , i3 (lx1,ly1,lz1,1)
      real h1 (lx1,ly1,lz1,1) , h2 (lx1,ly1,lz1,1)
 
c      ifproj = .false.
c      if (param(94).gt.0)    ifproj = .true.
c      if (ifprojfld(ifield)) ifproj = .true.
c 
c      if (.not.ifproj) then
c         if (ifield.eq.1) call ophinv
c     $      (o1,o2,o3,i1,i2,i3,h1,h2,tolh,nmxhi)
c         if (ifield.eq.ifldmhd) call ophinv
c     $      (o1,o2,o3,i1,i2,i3,h1,h2,tolh,nmxhi)
c         return
c      endif
 
      mtmp = param(93)
      do i=1,2*ldim
         ivproj(1,i) = min(mxprev,mtmp) - 1
      enddo
 
      imesh = 1
 
      if (ifstrs) then
         matmod = 0
         call hmhzsf  ('NOMG',o1,o2,o3,i1,i2,i3,h1,h2,
     $                  v1mask,v2mask,v3mask,vmult,
     $                  tolh,nmxhi,matmod)
      else
         if (ifield.eq.1) then
            call hsolve ('VELX',o1,i1,h1,h2,v1mask,vmult
     $                         ,imesh,tolh,nmxhi,1
     $                         ,vproj(1,1),ivproj(1,1),binvm1)
            call hsolve ('VELY',o2,i2,h1,h2,v2mask,vmult
     $                         ,imesh,tolh,nmxhi,2
     $                         ,vproj(1,2),ivproj(1,2),binvm1)
            if (if3d)
     $      call hsolve ('VELZ',o3,i3,h1,h2,v3mask,vmult
     $                         ,imesh,tolh,nmxhi,3
     $                         ,vproj(1,3),ivproj(1,3),binvm1)
         elseif (ifield.eq.ifldmhd) then  ! B-field
            call hsolve (' BX ',o1,i1,h1,h2,b1mask,vmult
     $                         ,imesh,tolh,nmxhi,1
     $                         ,vproj(1,4),ivproj(1,4),binvm1)
            call hsolve (' BY ',o2,i2,h1,h2,b2mask,vmult
     $                         ,imesh,tolh,nmxhi,2
     $                         ,vproj(1,5),ivproj(1,5),binvm1)
            if (if3d)
     $      call hsolve (' BZ ',o3,i3,h1,h2,b3mask,vmult
     $                         ,imesh,tolh,nmxhi,3
     $                         ,vproj(1,6),ivproj(1,6),binvm1)
         endif
      endif
C
      return
      end
c--------------------------------------------------------------------
      subroutine set_ifbcor
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
c     include 'TSTEP'   ! ifield?

      common  /nekcb/ cb
      character cb*3

      ifbcor = .true.
      ifield = ifldmhd

      nface  = 2*ldim
      do iel=1,nelv
      do ifc=1,nface
         cb = cbc(ifc,iel,ifield)
         if  (cb.eq.'ndd' .or. cb.eq.'dnd' .or. cb.eq.'ddn')
     $           ifbcor = .false.
      enddo
      enddo

      call gllog(ifbcor , .false.)

      if (nio.eq.0)  write (6,*) 'IFBCOR   =',ifbcor

      return
      end
c--------------------------------------------------------------------
c      subroutine set_ifbcor_old(ifbcor)
cc
cc     This is a quick hack for the rings problem - it is not general,
cc     but will also work fine for the periodic in Z problem
cc
c      include 'SIZE'
c      include 'TOTAL'
c
c      logical ifbcor
c
c      integer e,f
c      character*1 cb1(3)
c
c      itest = 0
c
c      do e=1,nelv
c      do f=1,2*ldim
c         call chcopy(cb1,cbc(f,e,ifldmhd),3)
c         if (cb1(3).eq.'n'.or.cb1(3).eq.'N') itest = 1
c      enddo
c      enddo
c
c      itest = iglmax(itest,1)
c
c      ifbcor = .true.  ! adjust mean pressure to rmv hydrostatic mode
c
c
c      if (itest.eq.1) ifbcor = .false.  ! do not adjust mean pressure
c
c      return
c      end
c--------------------------------------------------------------------
      subroutine setrhsp(p,h1,h2,h2inv,pset,niprev)
C
C     Project soln onto best fit in the "E" norm.
C
      include 'SIZE'
      include 'INPUT'
      include 'MASS'
      include 'SOLN'
      include 'TSTEP'

      real p    (lx2,ly2,lz2,lelv)
      real h1   (lx1,ly1,lz1,lelv)
      real h2   (lx1,ly1,lz1,lelv)
      real h2inv(lx1,ly1,lz1,lelv)
      real pset (lx2*ly2*lz2*lelv,mxprev)

      parameter (ltot2=lx2*ly2*lz2*lelv)
      common /orthox/ pbar(ltot2),pnew(ltot2)
      common /orthos/ alpha(mxprev),work(mxprev)
      common /orthoi/ nprev,mprev

      nprev = niprev
      if (nprev.eq.0) return

c     Diag to see how much reduction in the residual is attained.
      ntot2  = lx2*ly2*lz2*nelv
      alpha1 = glsc3(p,p,bm2inv,ntot2)
      if (alpha1.gt.0) then
         alpha1 = sqrt(alpha1/volvm2)
      else
         return
      endif

      call updrhse(p,h1,h2,h2inv,ierr) ! Update rhs's if E-matrix has changed
c     if (ierr.eq.1) Nprev=0           ! Doesn't happen w/ new formulation

      do i=1,nprev  ! Perform Gram-Schmidt for previous soln's.
         alpha(i) = vlsc2(p,pset(1,i),ntot2)
      enddo
      call gop(alpha,work,'+  ',nprev)

      call rzero(pbar,ntot2)
      do i=1,nprev
         call add2s2(pbar,pset(1,i),alpha(i),ntot2)
      enddo
C
      intetype = 1
      call cdabdtp(pnew,pbar,h1,h2,h2inv,intetype)
      call sub2   (p,pnew,ntot2)

c    ................................................................
      alpha2 = glsc3(p,p,bm2inv,ntot2) ! Diagnostics
      if (alpha2.gt.0) then
         alpha2 = sqrt(alpha2/volvm2)
         ratio  = alpha1/alpha2
         n10=min(10,nprev)
c         if (nio.eq.0) write(6,11) istep,nprev,(alpha(i),i=1,n10)
c         if (nio.eq.0) write(6,12) istep,nprev,alpha1,alpha2,ratio
   11    format(2i5,' alpha:',1p10e12.4)
   12    format(i6,i4,1p3e12.4,' alph12')

         if (nio.eq.0) write(6,13) istep,'  Project PRES  ',
     &                         alpha2,alpha1,ratio,nprev,mxprev
   13    format(i11,a,6x,1p3e13.4,i4,i4)
      endif
c    ................................................................

      return
      end
c-----------------------------------------------------------------------
      subroutine gensolnp(p,h1,h2,h2inv,pset,nprev)
C
C     Reconstruct the solution to the original problem by adding back
C     the previous solutions
C
      include 'SIZE'
      include 'INPUT'

      real p    (lx2,ly2,lz2,lelv)
      real h1   (lx1,ly1,lz1,lelv)
      real h2   (lx1,ly1,lz1,lelv)
      real h2inv(lx1,ly1,lz1,lelv)
      real pset (lx2*ly2*lz2*lelv,mxprev)

      parameter (ltot2=lx2*ly2*lz2*lelv)
      common /orthox/ pbar(ltot2),pnew(ltot2)
      common /orthos/ alpha(mxprev),work(mxprev)

      mprev=param(93)
      mprev=min(mprev,mxprev)

      ntot2=lx2*ly2*lz2*nelv

      if (nprev.lt.mprev) then
         nprev = nprev+1
         call copy  (pset(1,nprev),p,ntot2)        ! Save current solution
         call add2  (p,pbar,ntot2)                 ! Reconstruct solution.
         call econjp(pset,nprev,h1,h2,h2inv,ierr)  ! Orthonormalize set

         if (ierr.eq.1) then
          nprev = 1
          call copy  (pset(1,nprev),p,ntot2)       ! Save current solution
          call econjp(pset,nprev,h1,h2,h2inv,ierr) !   and orthonormalize.
        endif

      else                                         !          (uses pnew).
         nprev = 1
         call add2  (p,pbar,ntot2)                 ! Reconstruct solution.
         call copy  (pset(1,nprev),p,ntot2)        ! Save current solution
         call econjp(pset,nprev,h1,h2,h2inv,ierr)  !   and orthonormalize.
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine econjp(pset,nprev,h1,h2,h2inv,ierr)

c     Orthogonalize the soln wrt previous soln's for which we already
c     know the soln.

      include 'SIZE'
      include 'INPUT'

      real p    (lx2,ly2,lz2,lelv)
      real h1   (lx1,ly1,lz1,lelv)
      real h2   (lx1,ly1,lz1,lelv)
      real h2inv(lx1,ly1,lz1,lelv)
      real pset (lx2*ly2*lz2*lelv,mxprev)

      parameter (ltot2=lx2*ly2*lz2*lelv)
      common /orthox/ pbar(ltot2),pnew(ltot2)
      common /orthos/ alpha(mxprev),work(mxprev)

      ierr  = 0

      ntot2=lx2*ly2*lz2*nelv

C
C     Gram Schmidt, w re-orthogonalization
C
      npass=1
c     if (abs(param(105)).eq.2) npass=2
      do ipass=1,npass

         intetype=1
         call cdabdtp(pnew,pset(1,nprev),h1,h2,h2inv,intetype)
         alphad = glsc2(pnew,pset(1,nprev),ntot2) ! compute part of the norm

         nprev1 = nprev-1
         do i=1,nprev1   !   Gram-Schmidt
            alpha(i) = vlsc2(pnew,pset(1,i),ntot2)
         enddo
         if (nprev1.gt.0) call gop(alpha,work,'+  ',nprev1)

         do i=1,nprev1
            alpham = -alpha(i)
            call add2s2(pset(1,nprev),pset(1,i),alpham,ntot2)
            alphad = alphad - alpha(i)**2
         enddo
      enddo
C
C    .Normalize new element in P~
C
      if (alphad.le.0) then
         write(6,*) 'ERROR:  alphad .le. 0 in econjp',alphad,nprev
         ierr = 1
         return
      endif
      alphad = 1./sqrt(alphad)
      call cmult(pset(1,nprev),alphad,ntot2)

      return
      end
c-----------------------------------------------------------------------
      subroutine advab_elsasser_fast
C
C     Eulerian scheme, add convection term to forcing function
C     at current time step.
C
      include 'SIZE'
      include 'INPUT'
      include 'GEOM'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
c
      parameter (lxy=lx1*ly1*lz1,ltd=lxd*lyd*lzd)
      common /scrns/ wk(2*ltd)
     $             , fx(lxy),fy(lxy),fz(lxy)
     $             , gx(lxy),gy(lxy),gz(lxy)
     $             , zr(ltd),zs(ltd),zt(ltd)
     $             , tr(ltd,3),zp(ltd,3),zm(ltd,3)

      integer e
      integer icalld
      save    icalld
      data    icalld /0/

      if (icalld.eq.0) call set_dealias_rx
      icalld = icalld + 1

      nxyz1 = lx1*ly1*lz1
      nxyzd = lxd*lyd*lzd


      if (if3d) then
c
         do e=1,nelv

c           Interpolate z+ and z- into fine mesh, translate to r-s-t coords

c           write(6,*) nid,' inside fast',e,nxyz1

            call add3(wk,vx(1,1,1,e),bx(1,1,1,e),nxyz1)
            call intp_rstd(zp(1,1),wk,lx1,lxd,if3d,0) ! 0 --> forward

            call add3(wk,vy(1,1,1,e),by(1,1,1,e),nxyz1)
            call intp_rstd(zp(1,2),wk,lx1,lxd,if3d,0)

            call add3(wk,vz(1,1,1,e),bz(1,1,1,e),nxyz1)
            call intp_rstd(zp(1,3),wk,lx1,lxd,if3d,0)

            call sub3(wk,vx(1,1,1,e),bx(1,1,1,e),nxyz1)
            call intp_rstd(zm(1,1),wk,lx1,lxd,if3d,0)

            call sub3(wk,vy(1,1,1,e),by(1,1,1,e),nxyz1)
            call intp_rstd(zm(1,2),wk,lx1,lxd,if3d,0)

            call sub3(wk,vz(1,1,1,e),bz(1,1,1,e),nxyz1)
            call intp_rstd(zm(1,3),wk,lx1,lxd,if3d,0)

            do i=1,nxyzd  ! Convert convector (zm) to r-s-t coordinates
               tr(i,1)=
     $            rx(i,1,e)*zm(i,1)+rx(i,2,e)*zm(i,2)+rx(i,3,e)*zm(i,3)
               tr(i,2)=
     $            rx(i,4,e)*zm(i,1)+rx(i,5,e)*zm(i,2)+rx(i,6,e)*zm(i,3)
               tr(i,3)=
     $            rx(i,7,e)*zm(i,1)+rx(i,8,e)*zm(i,2)+rx(i,9,e)*zm(i,3)
            enddo


            call grad_rst(zr,zs,zt,zp(1,1),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)+tr(i,3)*zt(i)
            enddo
            call intp_rstd(fx,wk,lx1,lxd,if3d,1) ! Project back to coarse

            call grad_rst(zr,zs,zt,zp(1,2),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)+tr(i,3)*zt(i)
            enddo
            call intp_rstd(fy,wk,lx1,lxd,if3d,1) ! Project back to coarse

            call grad_rst(zr,zs,zt,zp(1,3),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)+tr(i,3)*zt(i)
            enddo
            call intp_rstd(fz,wk,lx1,lxd,if3d,1) ! Project back to coarse


            do i=1,nxyzd  ! Convert convector (zp) to r-s-t coordinates
               tr(i,1)=
     $            rx(i,1,e)*zp(i,1)+rx(i,2,e)*zp(i,2)+rx(i,3,e)*zp(i,3)
               tr(i,2)=
     $            rx(i,4,e)*zp(i,1)+rx(i,5,e)*zp(i,2)+rx(i,6,e)*zp(i,3)
               tr(i,3)=
     $            rx(i,7,e)*zp(i,1)+rx(i,8,e)*zp(i,2)+rx(i,9,e)*zp(i,3)
            enddo


            call grad_rst(zr,zs,zt,zm(1,1),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)+tr(i,3)*zt(i)
            enddo
            call intp_rstd(gx,wk,lx1,lxd,if3d,1) ! Project back to coarse

            call grad_rst(zr,zs,zt,zm(1,2),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)+tr(i,3)*zt(i)
            enddo
            call intp_rstd(gy,wk,lx1,lxd,if3d,1) ! Project back to coarse

            call grad_rst(zr,zs,zt,zm(1,3),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)+tr(i,3)*zt(i)
            enddo
            call intp_rstd(gz,wk,lx1,lxd,if3d,1) ! Project back to coarse

            tmp = -0.5 ! vtrans() assumed to be 1.0 !
            do i=1,nxyz1
               bfx(i,1,1,e) = bfx(i,1,1,e) + tmp*( fx(i) + gx(i) )
               bmx(i,1,1,e) = bmx(i,1,1,e) + tmp*( fx(i) - gx(i) )

               bfy(i,1,1,e) = bfy(i,1,1,e) + tmp*( fy(i) + gy(i) )
               bmy(i,1,1,e) = bmy(i,1,1,e) + tmp*( fy(i) - gy(i) )

               bfz(i,1,1,e) = bfz(i,1,1,e) + tmp*( fz(i) + gz(i) )
               bmz(i,1,1,e) = bmz(i,1,1,e) + tmp*( fz(i) - gz(i) )
            enddo

         enddo

      else ! 2D
c
         do e=1,nelv

c           Interpolate z+ and z- into fine mesh, translate to r-s-t coords

            call add3(wk,vx(1,1,1,e),bx(1,1,1,e),nxyz1)
            call intp_rstd(zp(1,1),wk,lx1,lxd,if3d,0) ! 0 --> forward

            call add3(wk,vy(1,1,1,e),by(1,1,1,e),nxyz1)
            call intp_rstd(zp(1,2),wk,lx1,lxd,if3d,0)

            call sub3(wk,vx(1,1,1,e),bx(1,1,1,e),nxyz1)
            call intp_rstd(zm(1,1),wk,lx1,lxd,if3d,0)

            call sub3(wk,vy(1,1,1,e),by(1,1,1,e),nxyz1)
            call intp_rstd(zm(1,2),wk,lx1,lxd,if3d,0)

            do i=1,nxyzd  ! Convert convector (zm) to r-s-t coordinates
               tr(i,1)=
     $            rx(i,1,e)*zm(i,1)+rx(i,2,e)*zm(i,2)
               tr(i,2)=
     $            rx(i,3,e)*zm(i,1)+rx(i,4,e)*zm(i,2)
            enddo

            call grad_rst(zr,zs,zt,zp(1,1),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)
            enddo
            call intp_rstd(fx,wk,lx1,lxd,if3d,1) ! Project back to coarse

            call grad_rst(zr,zs,zt,zp(1,2),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)
            enddo
            call intp_rstd(fy,wk,lx1,lxd,if3d,1) ! Project back to coarse

            do i=1,nxyzd  ! Convert convector (zp) to r-s-t coordinates
               tr(i,1)=
     $            rx(i,1,e)*zp(i,1)+rx(i,2,e)*zp(i,2)
               tr(i,2)=
     $            rx(i,3,e)*zp(i,1)+rx(i,4,e)*zp(i,2)
            enddo

            call grad_rst(zr,zs,zt,zm(1,1),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)
            enddo
            call intp_rstd(gx,wk,lx1,lxd,if3d,1) ! Project back to coarse

            call grad_rst(zr,zs,zt,zm(1,2),lxd,if3d)
            do i=1,nxyzd ! mass matrix included, per DFM (4.8.5)
               wk(i) = tr(i,1)*zr(i)+tr(i,2)*zs(i)
            enddo
            call intp_rstd(gy,wk,lx1,lxd,if3d,1) ! Project back to coarse

            tmp = -0.5 ! vtrans() assumed to be 1.0 !
            do i=1,nxyz1
               bfx(i,1,1,e) = bfx(i,1,1,e) + tmp*( fx(i) + gx(i) )
               bmx(i,1,1,e) = bmx(i,1,1,e) + tmp*( fx(i) - gx(i) )

               bfy(i,1,1,e) = bfy(i,1,1,e) + tmp*( fy(i) + gy(i) )
               bmy(i,1,1,e) = bmy(i,1,1,e) + tmp*( fy(i) - gy(i) )
            enddo
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine cfl_check
c
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
c
      common /scrns/ ta1 (lx1,ly1,lz1,lelv)
     $ ,             ta2 (lx1,ly1,lz1,lelv)
     $ ,             ta3 (lx1,ly1,lz1,lelv)
     $ ,             tb1 (lx1,ly1,lz1,lelv)
     $ ,             tb2 (lx1,ly1,lz1,lelv)
     $ ,             tb3 (lx1,ly1,lz1,lelv)


      call opcopy(ta1,ta2,ta3,vx,vy,vz)
      call opcopy(tb1,tb2,tb3,bx,by,bz)

      ntot1 = lx1*ly1*lz1*nelv
      call phys_to_elsasser(ta1,ta2,ta3,tb1,tb2,tb3,ntot1) ! crude, but effective

      call compute_cfl(cflp,ta1,ta2,ta3,dt)   !  vx = U+B
      call compute_cfl(cflm,tb1,tb2,tb3,dt)   !  bx = U-B

      courno = max(cflp,cflm)

      if (nio.eq.0) write(6,1) istep,time,dt,cflp,cflm
    1 format(i9,1p4e15.7,' CFL')

      return
      end
c--------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!For the case of a variable which is not referenced within a construct:
!static data member should be shared, unless it is within a threadprivate directive.
!
!Dependence pair: counter@27:9 vs. counter@27:19

module DRB086
    implicit none
    public :: A, foo

    integer, save :: counter
    integer, save :: pcounter

    type A
        integer :: counter
        integer :: pcounter
    end type
    !$omp threadprivate(pcounter)
contains
    subroutine foo()
        counter = counter + 1
        pcounter = pcounter + 1
    end subroutine
end module

program DRB086_static_data_member_orig_yes
    use omp_lib
    use DRB086
    implicit none

    type(A) :: c
    c = A(0,0)

    !$omp parallel
    call foo()
    !$omp end parallel

    print *,counter,pcounter
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The below program will fail to order the write to x on thread 0 before the read from x on thread 1.
!The implicit release flush on exit from the critical region will not synchronize with the acquire
!flush that occurs on the atomic read operation performed by thread 1. This is because implicit
!release flushes that occur on a given construct may only synchronize with implicit acquire flushes
!on a compatible construct (and vice-versa) that internally makes use of the same synchronization
!variable.
!
!Implicit flush must be used after critical construct to avoid data race.
!No Data Race pair

program DRB142_acquirerelease_orig_yes
    use omp_lib
    implicit none

    integer :: x, y, thrd
    integer :: tmp
    x = 0

    !$omp parallel num_threads(2) private(thrd) private(tmp)
        thrd = omp_get_thread_num()
        if (thrd == 0) then
            !$omp critical
            x = 10
            !$omp end critical

            !$omp flush(x)

            !$omp atomic write
            y = 1
            !$omp end atomic
        else
            tmp = 0
            do while(tmp == 0)
            !$omp atomic read acquire ! or seq_cst
            tmp = x
            !$omp end atomic
            end do
            !$omp critical
            print *, "x = ", x
            !$omp end critical
        end if
    !$omp end parallel
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This is a program based on a test contributed by Yizi Gu@Rice Univ.
!Proper user of ordered directive and clause, no data races


program DRB110_ordered_orig_no
    use omp_lib
    implicit none

    integer x, i
    x=0
    
    !$omp parallel do ordered
    do i = 1, 100
        !$omp ordered
        x = x+1
        !$omp end ordered
    end do
    !$omp end parallel do    

    print*,'x =',x
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

! * Cover an implicitly determined rule: In a task generating construct,
! * a variable without applicable rules is firstprivate. No data race pairs.


module DRB101
    implicit none
    integer, dimension(:), allocatable :: a
contains
    subroutine gen_task(i)
        use omp_lib
        implicit none
        integer, value :: i
        !$omp task
        a(i) = i+1
        !$omp end task
    end subroutine
end module

program DRB101_task_value_orig_no
    use omp_lib
    use DRB101
    implicit none

    integer :: i
    allocate (a(100))

    !$omp parallel
        !$omp single
        do i = 1, 100
            call gen_task(i)
        end do
        !$omp end single
    !$omp end parallel

    do i = 1, 100
        if (a(i) /= i+1) then
            print*,'warning: a(',i,') =',a(i),' not expected',i+1
        end if
!        print*,a(i),i+1
    end do
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Two tasks with depend clause to ensure execution order:
!i is shared for two tasks based on implicit data-sharing attribute rules. No data race pairs.

program DRB072_taskdep1_orig_no
    use omp_lib
    implicit none

    integer :: i
    i = 0

    !$omp parallel
        !$omp single
            !$omp task depend (out:i)
            i = 1
            !$omp end task
            !$omp task depend (in:i)
            i = 2
            !$omp end task
        !$omp end single
    !$omp end parallel

    if (i/=2) then
        print*,'i is not equal to 2'
    end if
end program

c-----------------------------------------------------------------------
      subroutine fluidp (igeom)
c
c     Driver for perturbation velocity
c
      include 'SIZE'
      include 'INPUT'
      include 'TSTEP'
      include 'SOLN'

      do jp=1,npert

         if (nio.eq.0.and.igeom.eq.2) write(6,1) istep,time,jp
   1     format(i9,1pe14.7,' Perturbation Solve:',i5)

         call perturbv (igeom)

      enddo

      jp=0   ! set jp to zero, for baseline flow

      return
      end
c-----------------------------------------------------------------------
      subroutine perturbv (igeom)
c
c
c     Solve the convection-diffusion equation for the perturbation field, 
c     with projection onto a div-free space.
c
c
      include 'SIZE'
      include 'INPUT'
      include 'EIGEN'
      include 'SOLN'
      include 'TSTEP'
      include 'MASS'
C
      COMMON /SCRNS/  RESV1 (LX1,LY1,LZ1,LELV)
     $ ,              RESV2 (LX1,LY1,LZ1,LELV)
     $ ,              RESV3 (LX1,LY1,LZ1,LELV)
     $ ,              DV1   (LX1,LY1,LZ1,LELV)
     $ ,              DV2   (LX1,LY1,LZ1,LELV)
     $ ,              DV3   (LX1,LY1,LZ1,LELV)
      COMMON /SCRVH/  H1    (LX1,LY1,LZ1,LELV)
     $ ,              H2    (LX1,LY1,LZ1,LELV)
c
      ifield = 1
c
      if (igeom.eq.1) then
c
c        Old geometry, old velocity
c
         call makefp
         call lagfieldp
c
      else
c
c        New geometry, new velocity
c
         intype = -1
         call sethlm   (h1,h2,intype)
         call cresvipp (resv1,resv2,resv3,h1,h2)
         call ophinv   (dv1,dv2,dv3,resv1,resv2,resv3,h1,h2,tolhv,nmxv)
         call opadd2   (vxp(1,jp),vyp(1,jp),vzp(1,jp),dv1,dv2,dv3)
         call incomprp (vxp(1,jp),vyp(1,jp),vzp(1,jp),prp(1,jp))
c
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine lagfieldp
c
c     Keep old Vp-field(s)
c
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'TSTEP'
c
      do ilag=nbdinp-1,2,-1
         call opcopy
     $     (vxlagp(1,ilag  ,jp),vylagp(1,ilag  ,jp),vzlagp(1,ilag  ,jp)
     $     ,vxlagp(1,ilag-1,jp),vylagp(1,ilag-1,jp),vzlagp(1,ilag-1,jp))
      enddo
      call opcopy(vxlagp(1,1,jp),vylagp(1,1,jp),vzlagp(1,1,jp)
     $           ,vxp   (1,jp)  ,vyp   (1,jp)  ,vzp   (1,jp) )
c
      return
      end
c-----------------------------------------------------------------------
      subroutine makefp
c
c     Make rhs for velocity perturbation equation
c
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'INPUT'
      include 'TSTEP'
      include 'ADJOINT'
 
                                              call makeufp
      if (filterType.eq.2)                    call make_hpf
      if (ifnav.and.(.not.ifchar).and.(.not.ifadj))call advabp
      if (ifnav.and.(.not.ifchar).and.(     ifadj))call advabp_adjoint
      if (iftran)                              call makextp
                                               call makebdfp
c
      return
      end
c--------------------------------------------------------------------
      subroutine makeufp
c
c     Compute and add: (1) user specified forcing function (FX,FY,FZ)
c
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
C
      time = time-dt
      call nekuf   (bfxp(1,jp),bfyp(1,jp),bfzp(1,jp))
      call opcolv2 (bfxp(1,jp),bfyp(1,jp),bfzp(1,jp)
     $                              ,vtrans(1,1,1,1,ifield),bm1)
      time = time+dt
c
      return
      end
c--------------------------------------------------------------------
      subroutine advabp
C
C     Eulerian scheme, add convection term to forcing function
C     at current time step.
C
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
C
      COMMON /SCRNS/ TA1 (LX1*LY1*LZ1*LELV)
     $ ,             TA2 (LX1*LY1*LZ1*LELV)
     $ ,             TA3 (LX1*LY1*LZ1*LELV)
     $ ,             TB1 (LX1*LY1*LZ1*LELV)
     $ ,             TB2 (LX1*LY1*LZ1*LELV)
     $ ,             TB3 (LX1*LY1*LZ1*LELV)
C
      ntot1 = lx1*ly1*lz1*nelv
      ntot2 = lx2*ly2*lz2*nelv
c
      if (if3d) then
         call opcopy  (tb1,tb2,tb3,vx,vy,vz)                   ! Save velocity
         call opcopy  (vx,vy,vz,vxp(1,jp),vyp(1,jp),vzp(1,jp)) ! U <-- dU
         call convop  (ta1,tb1)                                ! du.grad U
         call convop  (ta2,tb2)
         call convop  (ta3,tb3)
         call opcopy  (vx,vy,vz,tb1,tb2,tb3)  ! Restore velocity
c
         do i=1,ntot1
            tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,ifield)
            bfxp(i,jp) = bfxp(i,jp)-tmp*ta1(i)
            bfyp(i,jp) = bfyp(i,jp)-tmp*ta2(i)
            bfzp(i,jp) = bfzp(i,jp)-tmp*ta3(i)
         enddo
c
         call convop  (ta1,vxp(1,jp))       !  U.grad dU
         call convop  (ta2,vyp(1,jp))
         call convop  (ta3,vzp(1,jp))
c
         do i=1,ntot1
            tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,ifield)
            bfxp(i,jp) = bfxp(i,jp)-tmp*ta1(i)
            bfyp(i,jp) = bfyp(i,jp)-tmp*ta2(i)
            bfzp(i,jp) = bfzp(i,jp)-tmp*ta3(i)
         enddo
c
      else  ! 2D
c
         call opcopy  (tb1,tb2,tb3,vx,vy,vz)                   ! Save velocity
         call opcopy  (vx,vy,vz,vxp(1,jp),vyp(1,jp),vzp(1,jp)) ! U <-- dU
         call convop  (ta1,tb1)                                ! du.grad U
         call convop  (ta2,tb2)
         call opcopy  (vx,vy,vz,tb1,tb2,tb3)  ! Restore velocity
c
         do i=1,ntot1
            tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,ifield)
            bfxp(i,jp) = bfxp(i,jp)-tmp*ta1(i)
            bfyp(i,jp) = bfyp(i,jp)-tmp*ta2(i)
         enddo
c
         call convop  (ta1,vxp(1,jp))       !  U.grad dU
         call convop  (ta2,vyp(1,jp))
c
         do i=1,ntot1
            tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,ifield)
            bfxp(i,jp) = bfxp(i,jp)-tmp*ta1(i)
            bfyp(i,jp) = bfyp(i,jp)-tmp*ta2(i)
         enddo
c
      endif
c
      return
      end
c--------------------------------------------------------------------
      subroutine advabp_adjoint
C
C     Eulerian scheme, add convection term to forcing function
C     at current time step for backward part of adjoint: 
C     Convective term is now (U.Grad)u - (Grad U)^T .u
C     instead of (u.Grad)U + (U.Grad)u in above subroutine advabp
C
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
      include 'GEOM'
      include 'ADJOINT'
C
      COMMON /SCRNS/ TA1 (LX1*LY1*LZ1*LELV)
     $ ,             TA2 (LX1*LY1*LZ1*LELV)
     $ ,             TA3 (LX1*LY1*LZ1*LELV)
     $ ,             TB1 (LX1*LY1*LZ1*LELV)
     $ ,             TB2 (LX1*LY1*LZ1*LELV)
     $ ,             TB3 (LX1*LY1*LZ1*LELV)


      real fact,factx,facty
C
      ntot1 = lx1*ly1*lz1*nelv
      ntot2 = lx2*ly2*lz2*nelv   !dimensionn arrays 
      NTOT      = lx1*ly1*lz1*NELT

c
      if (if3d) then
         call opcopy  (tb1,tb2,tb3,vx,vy,vz)                   ! Save velocity
         call opcopy  (vx,vy,vz,vxp(1,jp),vyp(1,jp),vzp(1,jp)) ! U <-- u
c     
         call convop_adj  (ta1,ta2,ta3,tb1,tb2,tb3,vx,vy,vz) ! u.grad U^T

         call opcopy  (vx,vy,vz,tb1,tb2,tb3)  ! Restore velocity
c
         do i=1,ntot1
            tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,ifield)
            bfxp(i,jp) = bfxp(i,jp)-tmp*ta1(i)
            bfyp(i,jp) = bfyp(i,jp)-tmp*ta2(i)
            bfzp(i,jp) = bfzp(i,jp)-tmp*ta3(i)
         enddo
c
c               
c
         call convop  (ta1,vxp(1,jp))       !  U.grad u
         call convop  (ta2,vyp(1,jp))
         call convop  (ta3,vzp(1,jp))
c
         do i=1,ntot1
            tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,ifield)
            bfxp(i,jp) = bfxp(i,jp)+tmp*ta1(i)
            bfyp(i,jp) = bfyp(i,jp)+tmp*ta2(i)
            bfzp(i,jp) = bfzp(i,jp)+tmp*ta3(i)
         enddo
c
         if (ifheat) then       ! dt.(grad T)
c                               ! term coming from the temperature convection
            call opcolv3 (ta1,ta2,ta3,dTdx,dTdy,dTdz,tp)
c
            do i=1,ntot1
               tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,2)
               bfxp(i,jp) = bfxp(i,jp)-tmp*ta1(i)
               bfyp(i,jp) = bfyp(i,jp)-tmp*ta2(i)
               bfzp(i,jp) = bfzp(i,jp)-tmp*ta3(i)
            enddo
         endif
c
      else  ! 2D

         call opcopy  (tb1,tb2,tb3,vx,vy,vz)                   ! Save velocity
         call opcopy  (vx,vy,vz,vxp(1,jp),vyp(1,jp),vzp(1,jp)) 

         call convop_adj  (ta1,ta2,ta3,tb1,tb2,tb3,vx,vy,vz) ! u.((grad U)^T)

         call opcopy  (vx,vy,vz,tb1,tb2,tb3) ! Restore velocity

         do i=1,ntot1
            tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,ifield)
            bfxp(i,jp) = bfxp(i,jp)-tmp*ta1(i)
            bfyp(i,jp) = bfyp(i,jp)-tmp*ta2(i)
         enddo

         call convop  (ta1,vxp(1,jp))       !  U.grad u
         call convop  (ta2,vyp(1,jp))
c
         do i=1,ntot1
            tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,ifield)
            bfxp(i,jp) = bfxp(i,jp)+tmp*ta1(i)
            bfyp(i,jp) = bfyp(i,jp)+tmp*ta2(i)
         enddo

         if (ifheat) then       ! dt.(grad T)^T
                                ! term coming from the temperature convection
            call opcolv3 (ta1,ta2,ta3,dTdx,dTdy,dTdz,tp)
c
            do i=1,ntot1
               tmp = bm1(i,1,1,1)*vtrans(i,1,1,1,2)
               bfxp(i,jp) = bfxp(i,jp)-tmp*ta1(i)
               bfyp(i,jp) = bfyp(i,jp)-tmp*ta2(i)
            enddo
         endif
         
      endif
c
      return
      end
c--------------------------------------------------------------------
      subroutine convop_adj  (bdux,bduy,bduz,udx,udy,udz,cx,cy,cz)

      include 'SIZE'
      include 'TOTAL'

      parameter (lxy=lx1*ly1*lz1,ltd=lxd*lyd*lzd)
      common /scrcv/ fx(ltd),fy(ltd),fz(ltd)
     $     , uf1(ltd),uf2(ltd),uf3(ltd),uf4(ltd),uf5(ltd),uf6(ltd)
      real urx(ltd),usx(ltd),utx(ltd)
      real ury(ltd),usy(ltd),uty(ltd)
      real urz(ltd),usz(ltd),utz(ltd)
      real bdux(1),bduy(1),bduz(1),u(1),cx(1),cy(1),cz(1)
      real udx(1),udy(1),udz(1)
      logical ifuf,ifcf            ! u and/or c already on fine mesh?
      integer e
      real bdrx(1), bdry(1),bdrz (1)

      call set_dealias_rx
      nxyz1 = lx1*ly1*lz1
c     AM DING DING 
      nxyzd = lxd*lyd*lzd
      nxyzu = nxyz1
      nxyzc = nxyz1
      ntot1=lx1*ly1*lz1*nelv
      ic = 1                    ! pointer to vector field C
      iu = 1                    ! pointer to scalar field u
      ib = 1                    ! pointer to scalar field Bdu
      if(if3d)then
         do e=1,nelv
                                ! map coarse velocity to fine mesh (C-->F)
            call intp_rstd(fx,cx(ic),lx1,lxd,if3d,0) ! 0 --> forward
            call intp_rstd(fy,cy(ic),lx1,lxd,if3d,0) 
            call intp_rstd(fz,cz(ic),lx1,lxd,if3d,0) 
               
            call intp_rstd(uf1,udx(iu),lx1,lxd,if3d,0) ! 0 --> forward
            call grad_rst(urx,usx,utx,uf1,lxd,if3d)
            
            call intp_rstd(uf2,udy(iu),lx1,lxd,if3d,0) 
            call grad_rst(ury,usy,uty,uf2,lxd,if3d)
            
            call intp_rstd(uf3,udz(iu),lx1,lxd,if3d,0) 
            call grad_rst(urz,usz,utz,uf3,lxd,if3d)
            
            do i=1,nxyzd        ! mass matrix included, per DFM (4.8.5)
               uf4(i)=fx(i)*(rx(i,1,e)*urx(i)+rx(i,4,e)*usx(i)
     $              +rx(i,7,e)*utx(i))+
     $              fy(i)*(rx(i,1,e)*ury(i)+rx(i,4,e)*usy(i)
     $              +rx(i,7,e)*uty(i))+
     $              fz(i)*(rx(i,1,e)*urz(i)+rx(i,4,e)*usz(i)
     $              +rx(i,7,e)*utz(i))
               uf5(i)=fx(i)*(rx(i,2,e)*urx(i)+rx(i,5,e)*usx(i)
     $              +rx(i,8,e)*utx(i))+
     $              fy(i)*(rx(i,2,e)*ury(i)+rx(i,5,e)*usy(i)
     $              +rx(i,8,e)*uty(i))+
     $              fz(i)*(rx(i,2,e)*urz(i)+rx(i,5,e)*usz(i)
     $              +rx(i,8,e)*utz(i))
               uf6(i)=fx(i)*(rx(i,3,e)*urx(i)+rx(i,6,e)*usx(i)
     $              +rx(i,9,e)*utx(i))+
     $              fy(i)*(rx(i,3,e)*ury(i)+rx(i,6,e)*usy(i)
     $              +rx(i,9,e)*uty(i))+
     $              fz(i)*(rx(i,3,e)*urz(i)+rx(i,6,e)*usz(i)
     $              +rx(i,9,e)*utz(i))
            enddo

            call intp_rstd(bdux(ib),uf4,lx1,lxd,if3d,1) ! Project back to coarse
            call intp_rstd(bduy(ib),uf5,lx1,lxd,if3d,1)
            call intp_rstd(bduz(ib),uf6,lx1,lxd,if3d,1)

            ic = ic + nxyzc
            iu = iu + nxyzu
            ib = ib + nxyz1
         enddo
         call invcol2     (bdux,bm1,ntot1) ! local mass inverse
         call invcol2     (bduy,bm1,ntot1) ! local mass inverse
         call invcol2     (bduz,bm1,ntot1) ! local mass inverse
      else
         do e=1,nelv

                               ! map coarse velocity to fine mesh (C-->F)
            call intp_rstd(fx,cx(ic),lx1,lxd,if3d,0) ! 0 --> forward
            call intp_rstd(fy,cy(ic),lx1,lxd,if3d,0) 

            call intp_rstd(uf1,udx(iu),lx1,lxd,if3d,0) 
            call grad_rst(urx,usx,utx,uf1,lxd,if3d)

            call intp_rstd(uf2,udy(iu),lx1,lxd,if3d,0) 
            call grad_rst(ury,usy,uty,uf2,lxd,if3d)

            do i=1,nxyzd       
               uf4(i) = fx(i)*(rx(i,1,e)*urx(i)+rx(i,3,e)*usx(i))+
     $              fy(i)*(rx(i,1,e)*ury(i)+rx(i,3,e)*usy(i))
               uf5(i) = fx(i)*(rx(i,2,e)*urx(i)+rx(i,4,e)*usx(i))+
     $              fy(i)*(rx(i,2,e)*ury(i)+rx(i,4,e)*usy(i))
            enddo

            call intp_rstd(bdux(ib),uf4,lx1,lxd,if3d,1)
            call intp_rstd(bduy(ib),uf5,lx1,lxd,if3d,1)

            ic = ic + nxyzc
            iu = iu + nxyzu
            ib = ib + nxyz1
         end do
         call invcol2     (bdux,bm1,ntot1) ! local mass inverse
         call invcol2     (bduy,bm1,ntot1) ! local mass inverse
      end if


      return
      end
c--------------------------------------------------------------------
      subroutine makextp
c
c     Add extrapolation terms to perturbation source terms
c
c     (nek5 equivalent for velocity is "makeabf")
c
      include 'SIZE'
      include 'INPUT'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
C
      common /scrns/ ta1 (lx1,ly1,lz1,lelv)
     $ ,             ta2 (lx1,ly1,lz1,lelv)
     $ ,             ta3 (lx1,ly1,lz1,lelv)
c
      ntot1 = lx1*ly1*lz1*nelv
c
      ab0 = ab(1)
      ab1 = ab(2)
      ab2 = ab(3)
      call add3s2 (ta1,exx1p(1,jp),exx2p(1,jp),ab1,ab2,ntot1)
      call add3s2 (ta2,exy1p(1,jp),exy2p(1,jp),ab1,ab2,ntot1)
      call copy   (exx2p(1,jp),exx1p(1,jp),ntot1)
      call copy   (exy2p(1,jp),exy1p(1,jp),ntot1)
      call copy   (exx1p(1,jp),bfxp (1,jp),ntot1)
      call copy   (exy1p(1,jp),bfyp (1,jp),ntot1)
      call add2s1 (bfxp(1,jp),ta1,ab0,ntot1)
      call add2s1 (bfyp(1,jp),ta2,ab0,ntot1)
      if (if3d) then
         call add3s2 (ta3,exz1p(1,jp),exz2p(1,jp),ab1,ab2,ntot1)
         call copy   (exz2p(1,jp),exz1p(1,jp),ntot1)
         call copy   (exz1p(1,jp),bfzp (1,jp),ntot1)
         call add2s1 (bfzp(1,jp),ta3,ab0,ntot1)
      endif
c
      return
      end
c--------------------------------------------------------------------
      subroutine makebdfp
C
C     Add contributions to perturbation source from lagged BD terms.
C
      include 'SIZE'
      include 'SOLN'
      include 'MASS'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
C
      COMMON /SCRNS/ TA1(LX1,LY1,LZ1,LELV)
     $ ,             TA2(LX1,LY1,LZ1,LELV)
     $ ,             TA3(LX1,LY1,LZ1,LELV)
     $ ,             TB1(LX1,LY1,LZ1,LELV)
     $ ,             TB2(LX1,LY1,LZ1,LELV)
     $ ,             TB3(LX1,LY1,LZ1,LELV)
     $ ,             H2 (LX1,LY1,LZ1,LELV)
C
      ntot1 = lx1*ly1*lz1*nelv
      const = 1./dt
      call cmult2(h2,vtrans(1,1,1,1,ifield),const,ntot1)
      call opcolv3c (tb1,tb2,tb3
     $              ,vxp(1,jp),vyp(1,jp),vzp(1,jp),bm1,bd(2))
C
      do ilag=2,nbd
         if (ifgeom) then
            call opcolv3c(ta1,ta2,ta3,vxlagp(1,ilag-1,jp),
     $                                vylagp(1,ilag-1,jp),
     $                                vzlagp(1,ilag-1,jp),
     $                                bm1lag(1,1,1,1,ilag-1),bd(ilag+1))
         else
            call opcolv3c(ta1,ta2,ta3,vxlagp(1,ilag-1,jp),
     $                                vylagp(1,ilag-1,jp),
     $                                vzlagp(1,ilag-1,jp),
     $                                bm1                   ,bd(ilag+1))
         endif
         call opadd2  (tb1,tb2,tb3,ta1,ta2,ta3)
      enddo
      call opadd2col (bfxp(1,jp),bfyp(1,jp),bfzp(1,jp),tb1,tb2,tb3,h2)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine cresvipp(resv1,resv2,resv3,h1,h2)
c
c     Account for inhomogeneous Dirichlet boundary contributions 
c     in rhs of perturbation eqn.
c                                               n
c     Also, subtract off best estimate of grad p
c
      include 'SIZE'
      include 'TOTAL'
      real           resv1 (lx1,ly1,lz1,1)
      real           resv2 (lx1,ly1,lz1,1)
      real           resv3 (lx1,ly1,lz1,1)
      real           h1    (lx1,ly1,lz1,1)
      real           h2    (lx1,ly1,lz1,1)
      common /scruz/ w1    (lx1,ly1,lz1,lelv)
     $ ,             w2    (lx1,ly1,lz1,lelv)
     $ ,             w3    (lx1,ly1,lz1,lelv)
     $ ,             prextr(lx2,ly2,lz2,lelv)
c
      ntot1 = lx1*ly1*lz1*nelv
      ntot2 = lx2*ly2*lz2*nelv
c
      call bcdirvc (vxp(1,jp),vyp(1,jp),vzp(1,jp)
     $             ,v1mask,v2mask,v3mask)
      call extrapprp(prextr)
      call opgradt(resv1,resv2,resv3,prextr)
      call opadd2(resv1,resv2,resv3,bfxp(1,jp),bfyp(1,jp),bfzp(1,jp))
      call ophx  (w1,w2,w3,vxp(1,jp),vyp(1,jp),vzp(1,jp),h1,h2)
      call opsub2(resv1,resv2,resv3,w1,w2,w3)
c
      return
      end
c--------------------------------------------------------------------
      subroutine heatp (igeom)
C
C     Driver for temperature or passive scalar.
C
C     Current version:
C     (1) Varaiable properties.
C     (2) Implicit time stepping.
C     (3) User specified tolerance for the Helmholtz solver
C         (not based on eigenvalues).
C     (4) A passive scalar can be defined on either the 
C         temperatur or the velocity mesh.
C     (5) A passive scalar has its own multiplicity (B.C.).  
C
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      INCLUDE 'SOLN'
C
      do jp=1,npert
         do ifield=2,nfield
            INTYPE        = -1
            IF (.NOT.IFTMSH(IFIELD)) IMESH = 1
            IF (     IFTMSH(IFIELD)) IMESH = 2
            CALL UNORM
            CALL SETTOLT
            CALL CDSCALP (IGEOM)
         enddo
      enddo
c
      jp=0   ! set jp to zero, for baseline flow
c
      return
      end
C
C-----------------------------------------------------------------------
      subroutine cdscalp (igeom)
C-----------------------------------------------------------------------
C
C     Solve the convection-diffusion equation for passive scalar IPSCAL
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'GEOM'
      INCLUDE 'MVGEOM'
      INCLUDE 'SOLN'
      INCLUDE 'MASS'
      INCLUDE 'TSTEP'
      COMMON  /CPRINT/ IFPRINT
      LOGICAL          IFPRINT
      LOGICAL          IFCONV
C
      COMMON /SCRNS/ TA(LX1,LY1,LZ1,LELT)
     $              ,TB(LX1,LY1,LZ1,LELT)
      COMMON /SCRVH/ H1(LX1,LY1,LZ1,LELT)
     $              ,H2(LX1,LY1,LZ1,LELT)
c
      include 'ORTHOT'
      ifld1 = ifield-1
      napproxt(1,ifld1) = laxtt
C
      IF (IGEOM.EQ.1) THEN
C
C        Old geometry
C
         CALL MAKEQP
         CALL LAGSCALP
C
      ELSE
C
         IF (IFPRINT) THEN
            IF (IFIELD.EQ.2.AND.NIO.EQ.0) THEN
               WRITE (6,*) ' Temperature/Passive scalar solution'
            ENDIF
         ENDIF
         if1=ifield-1
         write(name4t,1) if1
    1    format('TEM',i1)
C
C        New geometry
C
         NEL    = NELFLD(IFIELD)
         NTOT   = lx1*ly1*lz1*NEL
C
         INTYPE = 0
         IF (IFTRAN) INTYPE = -1
         CALL SETHLM  (H1,H2,INTYPE)
         CALL BCNEUSC (TA,-1)
         CALL ADD2    (H2,TA,NTOT)
         CALL BCDIRSC (TP(1,IFIELD-1,jp))
         CALL AXHELM  (TA,TP (1,IFIELD-1,jp),H1,H2,IMESH,1)
         CALL SUB3    (TB,BQP(1,IFIELD-1,jp),TA,NTOT)
         CALL BCNEUSC (TA,1)
         CALL ADD2    (TB,TA,NTOT)
c
         CALL HMHOLTZ (name4t,TA,TB,H1,H2
     $                 ,TMASK(1,1,1,1,IFIELD-1)
     $                 ,TMULT(1,1,1,1,IFIELD-1)
     $                 ,IMESH,TOLHT(IFIELD),NMXT(ifield-1),1)
c
         CALL ADD2    (TP(1,IFIELD-1,jp),TA,NTOT)
C
         CALL BCNEUSC (TA,1)
         CALL ADD2 (BQP(1,IFIELD-1,jp),TA,NTOT)
C
      ENDIF
C
      return
      end
C
      subroutine makeqp
C----------------------------------------------------------------------
C
C     Generate forcing function for the solution of a passive scalar.
C     !! NOTE: Do not change the content of the array BQ until the current
C              time step is completed 
C
C----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
      include 'SOLN'
                                                       CALL MAKEUQP
      IF (FILTERTYPE.EQ.2)                             CALL MAKE_HPF
      IF (IFADVC(IFIELD).AND.(.NOT.IFCHAR))            CALL CONVABP
      IF (IFTRAN)                                      CALL MAKEABQP
      IF ((IFTRAN.AND..NOT.IFCHAR).OR.
     $    (IFTRAN.AND..NOT.IFADVC(IFIELD).AND.IFCHAR)) CALL MAKEBDQP
c     IF (IFADVC(IFIELD).AND.IFCHAR)                   CALL CONVCHP
      IF (IFADVC(IFIELD).AND.IFCHAR) write(6,*) 'no convchp'
      IF (IFADVC(IFIELD).AND.IFCHAR) call exitt
c
      return
      end
C
      subroutine makeuqp
C---------------------------------------------------------------------
C
C     Fill up user defined forcing function and collocate will the
C     mass matrix on the Gauss-Lobatto mesh.
C
C---------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'MASS'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
C
      NTOT = lx1*ly1*lz1*NELFLD(IFIELD)
C
      time = time-dt                           ! time is tn
c
      call rzero   ( bqp(1,ifield-1,jp) ,    ntot)
      call setqvol ( bqp(1,ifield-1,jp)          )
      call col2    ( bqp(1,ifield-1,jp) ,bm1,ntot)
c
      time = time+dt                           ! restore time
C
      return
      end
C
      subroutine convabp
C---------------------------------------------------------------
C
C     Eulerian scheme, add convection term to forcing function 
C     at current time step.
C
C---------------------------------------------------------------
      include 'SIZE'
      include 'ADJOINT'
      include 'SOLN'
      include 'MASS'
      include 'TSTEP'
c
      common /scruz/ ta (lx1,ly1,lz1,lelt)
     $             , ua (lx1,ly1,lz1,lelt)
     $             , ub (lx1,ly1,lz1,lelt)
     $             , uc (lx1,ly1,lz1,lelt)
      real coeff
c
      nel = nelfld(ifield)
      ntot1 = lx1*ly1*lz1*nel
c
      if (.not.ifadj) then
         call opcopy(ua,ub,uc,vx,vy,vz)
         call opcopy(vx,vy,vz,vxp(1,jp),vyp(1,jp),vzp(1,jp))
         call convop(ta,t(1,1,1,1,ifield-1)) ! dU.grad T
         call opcopy(vx,vy,vz,ua,ub,uc)
      endif
c
      call convop  (ua,tp(1,ifield-1,jp)) ! U.grad dT
c
      if (.not.ifadj) then
         call add2 (ta,ua,ntot1)          ! U.grad dT + dU.grad T
      else
         call copy (ta,ua,ntot1)
         coeff=-1.0
         call cmult(ta,coeff,ntot1)       ! -U.grad dT
                                          ! the second term depends on the buoyancy
      endif
c
      call col2    (ta,vtrans(1,1,1,1,ifield),ntot1) !vtrans (U.grad dT + dU.grad T)
      call subcol3 (bqp(1,ifield-1,jp),bm1,ta,ntot1)
c
      return
      end
C
      subroutine makeabqp
C-----------------------------------------------------------------------
C
C     Sum up contributions to 3rd order Adams-Bashforth scheme.
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
C
      COMMON /SCRUZ/ TA (LX1,LY1,LZ1,LELT)
C
      AB0   = AB(1)
      AB1   = AB(2)
      AB2   = AB(3)
      NEL   = NELFLD(IFIELD)
      NTOT1 = lx1*ly1*lz1*NEL
C
      CALL ADD3S2 (TA,VGRADT1P(1,IFIELD-1,jp),
     $                VGRADT2P(1,IFIELD-1,jp),AB1,AB2,NTOT1)
      CALL COPY   (   VGRADT2P(1,IFIELD-1,jp),
     $                VGRADT1P(1,IFIELD-1,jp),NTOT1)
      CALL COPY   (   VGRADT1P(1,IFIELD-1,jp),
     $                     BQP(1,IFIELD-1,jp),NTOT1)
      CALL ADD2S1 (BQP(1,IFIELD-1,jp),TA,AB0,NTOT1)
C
      return
      end
C
      subroutine makebdqp
C-----------------------------------------------------------------------
C
C     Add contributions to Q from lagged BD terms.
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'MASS'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'TSTEP'
C
      COMMON /SCRNS/ TA (LX1,LY1,LZ1,LELT)
     $ ,             TB (LX1,LY1,LZ1,LELT)
     $ ,             H2 (LX1,LY1,LZ1,LELT)
C
      NEL   = NELFLD(IFIELD)
      NTOT1 = lx1*ly1*lz1*NEL
      CONST = 1./DT
      CALL COPY  (H2,VTRANS(1,1,1,1,IFIELD),NTOT1)
      CALL CMULT (H2,CONST,NTOT1)
C
      CALL COL3  (TB,BM1,TP(1,IFIELD-1,jp),NTOT1)
      CALL CMULT (TB,BD(2),NTOT1)
C
      DO 100 ILAG=2,NBD
         IF (IFGEOM) THEN
            CALL COL3 (TA,BM1LAG(1,1,1,1,ILAG-1),
     $                    TLAGP (1,ILAG-1,IFIELD-1,jp),NTOT1)
         ELSE
            CALL COL3 (TA,BM1,
     $                    TLAGP (1,ILAG-1,IFIELD-1,jp),NTOT1)
         ENDIF
         CALL ADD2S2(TB,TA,BD(ilag+1),NTOT1)
 100  CONTINUE
C
      CALL COL2 (TB,H2,NTOT1)
      CALL ADD2 (BQP(1,IFIELD-1,jp),TB,NTOT1)
C
      return
      end
C
      subroutine lagscalp
C-----------------------------------------------------------------------
C
C     Keep old passive scalar field(s) 
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
C
      NTOT1 = lx1*ly1*lz1*NELFLD(IFIELD)
C
      DO 100 ILAG=NBDINP-1,2,-1
         CALL COPY (TLAGP(1,ILAG  ,IFIELD-1,jp),
     $              TLAGP(1,ILAG-1,IFIELD-1,jp),NTOT1)
 100  CONTINUE
C
      CALL COPY (TLAGP(1,1,IFIELD-1,jp),TP(1,IFIELD-1,jp),NTOT1)
C
      return
      end
c-----------------------------------------------------------------------
      subroutine incomprp (ux,uy,uz,up)
c
c     Project U onto the closest incompressible field
c
c     Input:  U     := (ux,uy,uz)
c
c     Output: updated values of U, iproj, proj; and
c             up    := pressure correction req'd to impose div U = 0
c
c
c     Dependencies: ifield ==> which "density" (vtrans) is used.
c
c
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
c
      common /scrns/ w1    (lx1,ly1,lz1,lelv)
     $ ,             w2    (lx1,ly1,lz1,lelv)
     $ ,             w3    (lx1,ly1,lz1,lelv)
     $ ,             dv1   (lx1,ly1,lz1,lelv)
     $ ,             dv2   (lx1,ly1,lz1,lelv)
     $ ,             dv3   (lx1,ly1,lz1,lelv)
     $ ,             dp    (lx2,ly2,lz2,lelv)
      common /scrvh/ h1    (lx1,ly1,lz1,lelv)
     $ ,             h2    (lx1,ly1,lz1,lelv)
      common /scrhi/ h2inv (lx1,ly1,lz1,lelv)
      COMMON /SCRCH/ PREXTR(LX2,LY2,LZ2,LELV)
      logical ifprjp

c
      if (icalld.eq.0) tpres=0.0
      icalld=icalld+1
      npres=icalld
c
      ntot1  = lx1*ly1*lz1*nelv
      ntot2  = lx2*ly2*lz2*nelv
      intype = 1
      dtbd   = bd(1)/dt

      call rzero   (h1,ntot1)
c     call copy    (h2,vtrans(1,1,1,1,ifield),ntot1)
      call cmult2  (h2,vtrans(1,1,1,1,ifield),dtbd,ntot1)
      call invers2 (h2inv,h2,ntot1)

      call opdiv   (dp,ux,uy,uz)
      call chsign  (dp,ntot2)
      call ortho   (dp)


C******************************************************************


      ifprjp=.false.    ! project out previous pressure solutions?
      istart=param(95)  
      if (istep.ge.istart.and.istart.ne.0) ifprjp=.true.

      ! Most likely, the following can be commented out. (pff, 1/6/2010)
c     if (npert.gt.1.or.ifbase)            ifprjp=.false.
cpff  if (ifprjp)   call setrhs  (dp,h1,h2,h2inv)

                    call esolver (dp,h1,h2,h2inv,intype)

cpff  if (ifprjp)   call gensoln (dp,h1,h2,h2inv)

cNOTE:  The "cpff" comments added 11/24/17 to avoid old-style projection,
cNOTE:  which should be replaced with something more updated.

C******************************************************************

      call opgradt (w1 ,w2 ,w3 ,dp)
      call opbinv  (dv1,dv2,dv3,w1 ,w2 ,w3 ,h2inv)
      call opadd2  (ux ,uy ,uz ,dv1,dv2,dv3)

      call extrapprp(prextr)
      call lagpresp
      call add3(up,prextr,dp,ntot2)

      return
      end
c------------------------------------------------------------------------
      subroutine extrapprp (prextr)
C
C     Pressure extrapolation
C
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
      COMMON /CTMP0/ DPR (LX2,LY2,LZ2,LELV)
      REAL        PREXTR (LX2,LY2,LZ2,LELV)
C
      ntot2 = lx2*ly2*lz2*nelv
      if (nbd.eq.1.or.nbd.eq.2) then
         call copy (prextr,prp(1,JP),ntot2)
      elseif (nbd.eq.3) then
         const = dtlag(1)/dtlag(2)
         call sub3 (dpr,prp(1,JP),prlagp(1,1,JP),ntot2)
         call cmult(dpr,const,ntot2)
         call add3 (prextr,prp(1,JP),dpr,ntot2)
      elseif (nbd.gt.3) then
         write (6,*) 'Pressure extrapolation cannot be completed'
         write (6,*) 'Try a lower-order temporal scheme'
         call exitt
      endif
      return
      end
C-------------------------------------------------------------------
      subroutine lagpresp
C
C     save old pressure values
C
      INCLUDE 'SIZE'
      INCLUDE 'SOLN'
      INCLUDE 'TSTEP'
C
      if (nbdinp.eq.3) then
         ntot2 = lx2*ly2*lz2*nelv
         call copy (prlagp(1,1,JP),prp(1,JP),ntot2)
      endif
      return
      end
C-------------------------------------------------------------------
      subroutine lyap_scale ! Rescale / orthogonalize perturbation fields
c
c
      include 'SIZE'
      include 'TOTAL'
c
      real sigma(0:lpert)
c
      ntotv = lx1*ly1*lz1*nelv
      ntotp = lx2*ly2*lz2*nelv
      ntott = lx1*ly1*lz1*nelt
c
      do j=1,npert
         call normvc(h1,semi,pl2,plinf,vxp(1,j),vyp(1,j),vzp(1,j))
         sigma(j) = pl2
         if (pl2.gt.0) then
            write(6,*) 'this is pl2:',pl2
            scale = 1./pl2
            call opcmult(vxp(1,j),vyp(1,j),vzp(1,j),scale)
            call   cmult(tp(1,1,j),scale,ntott)
            call   cmult(prp(1,j) ,scale,ntotp)
         endif
c
c        Have to do lag terms as well, etc
c        
c        Also, must orthogonalize
      enddo
c
      if (nio.eq.0) then
         if (npert.eq.1) write(6,1) istep,time,(sigma(j),j=1,npert)
         if (npert.eq.2) write(6,2) istep,time,(sigma(j),j=1,npert)
         if (npert.eq.3) write(6,3) istep,time,(sigma(j),j=1,npert)
         if (npert.eq.4) write(6,4) istep,time,(sigma(j),j=1,npert)
         if (npert.eq.5) write(6,5) istep,time,(sigma(j),j=1,npert)
         if (npert.eq.6) write(6,6) istep,time,(sigma(j),j=1,npert)
         if (npert.eq.7) write(6,7) istep,time,(sigma(j),j=1,npert)
         if (npert.eq.8) write(6,8) istep,time,(sigma(j),j=1,npert)
         if (npert.eq.9) write(6,9) istep,time,(sigma(j),j=1,npert)
      endif
    1 format(i8,1p2e12.4,' pgrow')
    2 format(i8,1p3e12.4,' pgrow')
    3 format(i8,1p4e12.4,' pgrow')
    4 format(i8,1p5e12.4,' pgrow')
    5 format(i8,1p6e12.4,' pgrow')
    6 format(i8,1p7e12.4,' pgrow')
    7 format(i8,1p8e12.4,' pgrow')
    8 format(i8,1p9e12.4,' pgrow')
    9 format(i8,1p10e12.4,' pgrow')
c
      return
      end
c-----------------------------------------------------------------------
      subroutine out_pert  ! dump perturbation .fld files
c
      include 'SIZE'
      include 'TOTAL'
      include 'NEKUSE'
c
      character*3 s3
c
      do jpp=1,npert
         write(s3,3) jpp
 3       format('p',i2.2)
         call outpost2
     $   (vxp(1,jpp),vyp(1,jpp),vzp(1,jpp),prp(1,jpp),tp(1,1,jpp),1,s3)
c        call writehist
c    $     (vxp(1,jpp),vyp(1,jpp),vzp(1,jpp),tp(1,1,jpp),jpp)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine pert_add2s2(i,j,scale)   ! xi = xi + scale * xj
      include 'SIZE'
      include 'TOTAL'

      ntotp = lx2*ly2*lz2*nelv
      ntotv = lx1*ly1*lz1*nelv
      ntott = lx1*ly1*lz1*nelt

      call add2s2(vxp(1,i),vxp(1,j),scale,ntotv)
      call add2s2(vyp(1,i),vyp(1,j),scale,ntotv)
      if (if3d) call add2s2(vzp(1,i),vzp(1,j),scale,ntotv)
      call add2s2(prp(1,i),prp(1,j),scale,ntotp)

      do l=1,lorder-1
         call add2s2(vxlagp(1,l,i),vxlagp(1,l,j),scale,ntotv)
         call add2s2(vylagp(1,l,i),vylagp(1,l,j),scale,ntotv)
         if (if3d) call add2s2(vzlagp(1,l,i),vzlagp(1,l,j),scale,ntotv)
         if (l.le.lorder-2) 
     $      call add2s2(prlagp(1,l,i),prlagp(1,l,j),scale,ntotp)
      enddo

      call add2s2(exx1p(1,i),exx1p(1,j),scale,ntotv)
      call add2s2(exy1p(1,i),exy1p(1,j),scale,ntotv)
      if (if3d) call add2s2(exz1p(1,i),exz1p(1,j),scale,ntotv)

      call add2s2(exx2p(1,i),exx2p(1,j),scale,ntotv)
      call add2s2(exy2p(1,i),exy2p(1,j),scale,ntotv)
      if (if3d) call add2s2(exz2p(1,i),exz2p(1,j),scale,ntotv)

      if (ifheat) then
        do k=0,npscal
          k1=k+1
          ntotk = lx1*ly1*lz1*nelfld(k+2)
          call add2s2(tp(1,k1,i),tp(1,k1,j),scale,ntotk)
          do l=1,lorder-1
            call add2s2(tlagp(1,l,k1,i),tlagp(1,l,k1,j),scale,ntotk)
          enddo
          call add2s2(vgradt1p(1,k1,i),vgradt1p(1,k1,j),scale,ntotk)
          call add2s2(vgradt2p(1,k1,i),vgradt2p(1,k1,j),scale,ntotk)
        enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      function pert_inner_prod(i,j) ! weighted inner product vi^T vj
      include 'SIZE'
      include 'TOTAL'

      common/normset/pran, ray, rayc

      ntotv=lx1*ly1*lz1*nelv
      ntott=lx1*ly1*lz1*nelt

      s1 = rayc*glsc3(vxp(1,i),bm1,vxp(1,j),ntotv)
      s2 = rayc*glsc3(vyp(1,i),bm1,vyp(1,j),ntotv)
      s3 = 0
      if (if3d) s3 = rayc*glsc3(vzp(1,i),bm1,vzp(1,j),ntotv)

      t1 = 0
      if (ifheat) t1=pran*ray*ray*glsc3(tp(1,1,i),bm1,tp(1,1,j),ntott)

      pert_inner_prod = (s1+s2+s3+t1)/volvm1

      return
      end
c-----------------------------------------------------------------------
      subroutine pert_ortho_norm ! orthogonalize and rescale pert. arrays
      include 'SIZE'
      include 'TOTAL'

      do k=1,npert
         call pert_ortho_norm1(k)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine pert_ortho_norm1 (k) ! orthogonalize k against 1...k-1
      include 'SIZE'
      include 'TOTAL'

      do j=1,k-1
         scale = -pert_inner_prod(j,k)
         call pert_add2s2(k,j,scale)   ! xi = xi + scale * xj
      enddo
      scale = pert_inner_prod(k,k)
      if (scale.gt.0) scale = 1./scale
      call rescalepert(pertnorm,scale,k)

      return
      end
c-----------------------------------------------------------------------
      function opnorm2(v1,v2,v3)
      include 'SIZE'
      include 'TOTAL'
c
      real v1(1) , v2(1), v3(1)
      real normsq1,normsq2,normsq3,opnorm
c
      ntotv=lx1*ly1*lz1*nelv
      normsq1=glsc3(v1,bm1,v1,ntotv)
      normsq2=glsc3(v2,bm1,v2,ntotv)
      if(if3d) then
         normsq3=glsc3(v3,bm1,v3,ntotv)
      else
         normsq3=0
      endif

      opnorm2=normsq1+normsq2+normsq3
      if (opnorm2.gt.0) opnorm2=sqrt(opnorm2/volvm1)
      return
      end
c-----------------------------------------------------------------------

      function Tnorm(temp)
      include 'SIZE'
      include 'TOTAL'

      real temp(*)
c
      ntotv = lx1*ly1*lz1*nelv
      Tnorm = sqrt( glsc3(temp,BM1,temp,ntotv) /voltm1)
c
      return
      end
c--------------------------------------------
      function dmnorm1(v1,v2,v3,temp)
c     Norm weighted by mass matrix
      include 'SIZE'
      include 'TOTAL'

      real v1(1),v2(1),v3(1),temp(1)
      real normsq1,normsq2,normsq3,normsqT,dMnorm
      common/normset/pran, ray, rayc

      ntotv=lx1*ly1*lz1*nelv
      normsq1=(rayc)*glsc3(v1,BM1,v1,ntotv)
      normsq2=(rayc)*glsc3(v2,BM1,v2,ntotv)
      if(if3d) then
         normsq3=(rayc)*glsc3(v3,BM1,v3,ntotv)
      else
         normsq3=0
      endif

      if(ifheat) then
         normsqT = (pran*ray*ray)*glsc3(temp,BM1,temp,ntotv)
      else
         normsqT = 0
      endif

      dmnorm1=sqrt((normsq1+normsq2+normsq3+normsqT)/volvm1)

      return
      end

c---------------------------------------------------------------
      subroutine opscale(v1,v2,v3,temp,alpha)
c     v =  alpha*v
      include 'SIZE'
      include 'INPUT'

      real alpha
      real v1(1),v2(1),v3(1),temp(1)

      ltotv=lx1*ly1*lz1*lelv
      ltott=lx1*ly1*lz1*lelt

      call cmult(v1,alpha,ltotv)
      call cmult(v2,alpha,ltotv)
      if (if3d)   call cmult(v3,alpha,ltotv)
      if (ifheat) call cmult(temp,alpha,ltott*ldimt)

      return
      end

c---------------------------------------------------------------
      subroutine opscaleV(v1,v2,v3,alpha)
c     v =  alpha*v
      include 'SIZE'
      include 'INPUT'
      real alpha
      real v1(*),v2(*),v3(*)

      ntotv=lx1*ly1*lz1*nelv

      call cmult(v1,alpha,ntotv)
      call cmult(v2,alpha,ntotv)

      if (if3d)   call cmult(v3,alpha,ntotv)
c
      return
      end

c-----------------------------------------------------------------------
      subroutine computelyap
      include 'SIZE'
      include 'TOTAL'

      do jpp=1,npert         ! Loop through each Lyapunov eigenvalue
         call computelyap1
     $     (vxp(1,jpp),vyp(1,jpp),vzp(1,jpp),tp(1,1,jpp),jpp)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine computelyap1(vxq,vyq,vzq,tq,jpp)
      include 'SIZE'
      include 'TOTAL'

      real vxq(1),vyq(1),vzq(1),tq(1)
      real lyapsum,twt
      common /pertsave/ timestart,tinitial

      integer icount
      save    icount
      data    icount /0/

      logical       if_restart,if_ortho_lyap
      common/restar/if_restart,if_ortho_lyap

      character*132 lyprestart
      common/restflename/lyprestart  !file for restart data

      twt = param(126) !time to wait to start computing exponents

      if (nio.eq.0) 
     $  write(6,8) istep,icount,time,twt,(lyap(k,jpp),k=1,3),jpp
    8 format(i9,i4,2f8.4,1p3e12.4,i3,'clyap')

      if(time.lt.twt) then
c
c        For a  fresh simulation, then we wait 5 vertical diffusion 
c        times before we start measuring, so in this case just rescale
c
         pertnorm = dmnorm1(vxq,vyq,vzq,tq)
         pertinvnorm = 1.0/pertnorm
         call rescalepert(pertnorm,pertinvnorm,jpp)
         lyap(3,jpp) = pertnorm !store latest norm
         timestart   = time
         tinitial    = time
         icount      = 0
         return
      else
         if (jpp.eq.1) icount = icount + 1
      endif

      irescale = param(128)
      if (icount.eq.irescale) then

         lyapsum     = lyap(2,jpp)
         oldpertnorm = lyap(3,jpp)
         pertnorm=dmnorm1(vxq,vyq,vzq,tq)
c
         lyap(1,jpp) = log(pertnorm/oldpertnorm)/(time-timestart)
         lyapsum     = lyapSum + log(pertnorm/oldpertnorm)
         lyap(2,jpp) = lyapSum

         if(nid.eq.0) then        ! write out results to the .lyp file
 
           write(6 ,1) istep,time,lyap(1,jpp),lyapsum,pertnorm,jpp
           write(79,2) time,lyap(1,jpp),lyapsum,pertnorm,oldpertnorm,jpp
 1          format(i9,1p4e17.8,i4,'lyap')
 2          format(1p5e17.8,i4,'lyap')
c           call flushbuffer(79)
 
            if (jpp.eq.1) open(unit=96,file=lyprestart)
            write(96,9) lyapsum,timestart,jpp
 9          format(1p2e19.11,i9)
            if (jpp.eq.npert) close(96)
         endif

         pertinvnorm = 1.0/pertnorm
         call rescalepert(pertnorm,pertinvnorm,jpp)
         lyap(3,jpp) = pertnorm  !save current pertnorm as old pertnorm

         if (jpp.eq.npert) then
            icount    = 0
            timestart = time
         endif

         if_ortho_lyap = .false.
         if (param(125).gt.0) if_ortho_lyap = .true.
         if (jpp.eq.npert .and. if_ortho_lyap) call pert_ortho_norm

      endif

      return
      end
c-----------------------------------------------------------------------

      subroutine rescalepert(pertnorm,pertinvnorm,jpp)
      include 'SIZE'
      include 'TOTAL'

      ntotp = lx2*ly2*lz2*nelv

      call opscale                     !normalize vectors to unit norm
     $      (vxp(1,jpp),vyp(1,jpp),vzp(1,jpp),tp(1,1,jpp),pertinvnorm)
      call cmult(prp(1,jpp),pertinvnorm,ntotp)

      call opscale(exx1p(1,jpp),exy1p(1,jpp),exz1p(1,jpp)
     $                           ,vgradt1p(1,1,jpp),pertinvnorm)
      call opscale(exx2p(1,jpp),exy2p(1,jpp),exz2p(1,jpp)
     $                           ,vgradt2p(1,1,jpp),pertinvnorm)

      ltotv = lx1*ly1*lz1*lelv
      ltotp = lx2*ly2*lz2*lelv

      call cmult( tlagp(1,1,1,jpp),pertinvnorm,ltotv*(lorder-1)*ldimt)
      call cmult(vxlagp(1,1,jpp),pertinvnorm,ltotv*(lorder-1))
      call cmult(vylagp(1,1,jpp),pertinvnorm,ltotv*(lorder-1))
      call cmult(vzlagp(1,1,jpp),pertinvnorm,ltotv*(lorder-1))
      call cmult(prlagp(1,1,jpp),pertinvnorm,ltotp*(Lorder-2))

      if (nio.eq.0) write(6,1) istep,pertnorm,pertinvnorm,jpp,'PNORM'
  1   format(i4,1p2e12.4,i4,a5)
      pertnorm = pertnorm*pertinvnorm

      return
      end
c-----------------------------------------------------------------------

c-----------------------------------------------------------------------
      subroutine q_filter(wght)
c
c     filter vx,vy,vz, and p by simple interpolation
c
      include 'SIZE'
      include 'TOTAL'
c
c
c     These are the dimensions that we interpolate onto for v and p:
      parameter(lxv=lx1-1)
      parameter(lxp=lx2-1)
c
      real intdv(lx1,lx1)
      real intuv(lx1,lx1)
      real intdp(lx1,lx1)
      real intup(lx1,lx1)
      real intv(lx1,lx1)
      real intp(lx1,lx1)
c
      save intdv
      save intuv
      save intdp
      save intup
      save intv
      save intp

      common /ctmp0/ intw,intt
     $             , wk1,wk2
     $             , zgmv,wgtv,zgmp,wgtp,tmax(100),omax(103)

      real intw(lx1,lx1)
      real intt(lx1,lx1)
      real wk1  (lx1,lx1,lx1,lelt)
      real wk2  (lx1,lx1,lx1)
      real zgmv(lx1),wgtv(lx1),zgmp(lx1),wgtp(lx1)
c
c     outpost arrays
      parameter (lt=lx1*ly1*lz1*lelv)
      common /scruz/ w1(lt),w2(lt),w3(lt),wt(lt)

      character*18 sfmt

      integer icalld
      save    icalld
      data    icalld /0/

      logical if_fltv

      ncut = param(101)+1

      if(wght.le.0) return
      if(ifaxis) call exitti('Filtering not supported w/ IFAXIS!$',1)
      if(nid.eq.0 .and. loglevel.gt.2) write(6,*) 'apply q_filter ',
     $                                            ncut, wght

      imax = nid
      imax = iglmax(imax,1)
      jmax = iglmax(imax,1)
      if (icalld.eq.0) then
         icalld = 1
         call build_new_filter(intv,zgm1,lx1,ncut,wght,nio)
      elseif (icalld.lt.0) then   ! old (std.) filter
         icalld = 1
         call zwgll(zgmv,wgtv,lxv)
         call igllm(intuv,intw,zgmv,zgm1,lxv,lx1,lxv,lx1)
         call igllm(intdv,intw,zgm1,zgmv,lx1,lxv,lx1,lxv)
c
         call zwgl (zgmp,wgtp,lxp)
         call iglm (intup,intw,zgmp,zgm2,lxp,lx2,lxp,lx2)
         call iglm (intdp,intw,zgm2,zgmp,lx2,lxp,lx2,lxp)
c
c        Multiply up and down interpolation into single operator
c
         call mxm(intup,lx2,intdp,lxp,intp,lx2)
         call mxm(intuv,lx1,intdv,lxv,intv,lx1)
c
c        Weight the filter to make it a smooth (as opposed to truncated)
c        decay in wave space

         w0 = 1.-wght
         call ident(intup,lx2)
         call add2sxy(intp,wght,intup,w0,lx2*lx2)

         call ident   (intuv,lx1)
         call add2sxy (intv ,wght,intuv,w0,lx1*lx1)

      endif

      ifldt  = ifield
      ifield = 1

      if_fltv = .false.
      if ( ifflow .and. .not. ifmhd ) if_fltv = .true.
      if ( ifmhd                    ) if_fltv = .true.
      if ( .not.ifbase              ) if_fltv = .false. ! base-flow frozen
      if ( .not. iffilter(1)        ) if_fltv = .false. 

      if ( if_fltv ) then
         call filterq(vx,intv,lx1,lz1,wk1,wk2,intt,if3d,umax)
         call filterq(vy,intv,lx1,lz1,wk1,wk2,intt,if3d,vmax)
         if (if3d)
     $   call filterq(vz,intv,lx1,lz1,wk1,wk2,intt,if3d,wmax)

         if (ifsplit.and..not.iflomach) 
     $      call filterq(pr,intv,lx1,lz1,wk1,wk2,intt,if3d,pmax)

         if (ifpert) then
           do j=1,npert
              call filterq(vxp(1,j),intv,lx1,lz1,wk1,wk2,intt,if3d,umax)
              call filterq(vyp(1,j),intv,lx1,lz1,wk1,wk2,intt,if3d,vmax)
              if (if3d)
     $        call filterq(vzp(1,j),intv,lx1,lz1,wk1,wk2,intt,if3d,wmax)
           enddo
         endif
      endif

      if (ifmhd.and.ifield.eq.ifldmhd) then
         call filterq(bx,intv,lx1,lz1,wk1,wk2,intt,if3d,umax)
         call filterq(by,intv,lx1,lz1,wk1,wk2,intt,if3d,vmax)
         if (if3d)
     $   call filterq(bz,intv,lx1,lz1,wk1,wk2,intt,if3d,wmax)
      endif

      mmax = 0
      if (ifflow) then
c        pmax    = glmax(pmax,1)
c         omax(1) = glmax(umax,1)
c         omax(2) = glmax(vmax,1)
c         omax(3) = glmax(wmax,1)
         mmax = ldim
      endif
         
      nfldt = 1+npscal
      do ifld=1,nfldt
         ifield = ifld + 1
         if (.not. iffilter(ifield)) goto 10
         call filterq(t(1,1,1,1,ifld),intv,
     $                lx1,lz1,wk1,wk2,intt,if3d,tmax(ifld))
         if (ifpert) then
            do j=1,npert
               call filterq(tp(1,j,1),intv,lx1,lz1,wk1,wk2,intt,if3d,
     $                      wmax)
            enddo
         endif
  10     mmax = mmax+1
c         omax(mmax) = glmax(tmax(ifld),1)
      enddo

c      if (nio.eq.0) then
c            if (if3d) then
c               write(6,1) istep,ifield,umax,vmax,wmax
c            else
c               write(6,1) istep,ifield,umax,vmax
c            endif
c    1       format(4x,i7,i3,' qfilt:',1p3e12.4)
c            if(ifheat) 
c     &            write(6,'(1p50e12.4)') (tmax(k),k=1,nfldt)
c      endif

      ifield = ifldt   ! RESTORE ifield

      return
      end
c-----------------------------------------------------------------------
      subroutine filterq(v,f,nx,nz,w1,w2,ft,if3d,dmax)
c
      include 'SIZE'
      include 'TSTEP'

      real v(nx*nx*nz,nelt),w1(1),w2(1)
      logical if3d
c
      real f(nx,nx),ft(nx,nx)
c
      integer e
c
      call transpose(ft,nx,f,nx)
c
      nxyz=nx*nx*nz
      dmax = 0.

      if (nio.eq.0 .and. loglevel.gt.2) write(6,*) 'call filterq',ifield
      nel = nelfld(ifield)

      if (if3d) then
         do e=1,nel
c           Filter
            call copy(w2,v(1,e),nxyz)
            call mxm(f,nx,w2,nx,w1,nx*nx)
            i=1
            j=1
            do k=1,nx
               call mxm(w1(i),nx,ft,nx,w2(j),nx)
               i = i+nx*nx
               j = j+nx*nx
            enddo
            call mxm (w2,nx*nx,ft,nx,w1,nx)
            call sub3(w2,v(1,e),w1,nxyz)
            call copy(v(1,e),w1,nxyz)
            smax = vlamax(w2,nxyz)
            dmax = max(dmax,abs(smax))
         enddo
c
      else
         do e=1,nel
c           Filter
            call copy(w1,v(1,e),nxyz)
            call mxm(f ,nx,w1,nx,w2,nx)
            call mxm(w2,nx,ft,nx,w1,nx)
c
            call sub3(w2,v(1,e),w1,nxyz)
            call copy(v(1,e),w1,nxyz)
            smax = vlamax(w2,nxyz)
            dmax = max(dmax,abs(smax))
         enddo
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine outmatx(a,m,n,io,name)
      real a(m*n)
      character*4 name
c
      open(unit=io,file=name)
      do i=1,m*n
         write(io,1) a(i)
      enddo
    1 format(1p1e22.13)
      close(unit=io)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine mappr(pm1,pm2,pa,pb)
c
      INCLUDE 'SIZE'
      INCLUDE 'TOTAL'
      real pm1(lx1,ly1,lz1,lelv),pm2(lx2,ly2,lz2,lelv)
     $    ,pa (lx1,ly2,lz2)     ,pb (lx1,ly1,lz2)
c
C     Map the pressure onto the velocity mesh
C
      NGLOB1 = lx1*ly1*lz1*NELV
      NYZ2   = ly2*lz2
      NXY1   = lx1*ly1
      NXYZ   = lx1*ly1*lz1
C
      IF (IFSPLIT) THEN
         CALL COPY(PM1,PM2,NGLOB1)
      ELSE
         DO 1000 IEL=1,NELV
            CALL MXM (IXM21,lx1,PM2(1,1,1,IEL),lx2,pa (1,1,1),NYZ2)
            DO 100 IZ=1,lz2
               CALL MXM (PA(1,1,IZ),lx1,IYTM21,ly2,PB(1,1,IZ),ly1)
 100        CONTINUE
            CALL MXM (PB(1,1,1),NXY1,IZTM21,lz2,PM1(1,1,1,IEL),lz1)
 1000    CONTINUE

C     Average the pressure on elemental boundaries
       IFIELD=1
       CALL DSSUM (PM1,lx1,ly1,lz1)
       CALL COL2  (PM1,VMULT,NGLOB1)

      ENDIF
C
C
      return
      end
c
c-----------------------------------------------------------------------
      function facint_a(a,area,f,e)
c     Integrate areal array a() on face f of element e.  27 June, 2012 pff

c     f  is in the preprocessor notation

      include 'SIZE'
      include 'TOPOL'
      real a(lx1,lz1,6,lelt),area(lx1,lz1,6,lelt)

      integer e,f

      sum=0.0
      do i=1,lx1*lz1
         sum = sum + a(i,1,f,e)*area(i,1,f,e)
      enddo

      facint_a = sum

      return
      end
c-----------------------------------------------------------------------
      function facint_v(a,area,f,e)
c     Integrate volumetric array a() on face f of element e

c        f  is in the preprocessor notation
c        fd  is the dssum notation.
c        27 June, 2012            PFF

      include 'SIZE'
      include 'TOPOL'
      real a(lx1,ly1,lz1,lelt),area(lx1,lz1,6,lelt)

      integer e,f,fd

      call dsset(lx1,ly1,lz1) ! set counters
      fd     = eface1(f)
      js1    = skpdat(1,fd)
      jf1    = skpdat(2,fd)
      jskip1 = skpdat(3,fd)
      js2    = skpdat(4,fd)
      jf2    = skpdat(5,fd)
      jskip2 = skpdat(6,fd)

      sum=0.0
      i = 0
      do 100 j2=js2,jf2,jskip2
      do 100 j1=js1,jf1,jskip1
         i = i+1
         sum = sum + a(j1,j2,1,e)*area(i,1,f,e)
  100 continue

      facint_v = sum

      return
      end
c-----------------------------------------------------------------------
      function facint(a,b,area,ifc,ie)
c
C
C     Take the dot product of A and B on the surface IFACE1 of element IE.
C
C         IFACE1 is in the preprocessor notation
C         IFACE  is the dssum notation.
C         5 Jan 1989 15:12:22      PFF
C
      INCLUDE 'SIZE'
      INCLUDE 'TOPOL'
      DIMENSION A    (LX1,LY1,LZ1,lelv)
     $         ,B    (lx1,lz1,6,lelv)
     $         ,area (lx1,lz1,6,lelv)
C
C     Set up counters
C
      CALL DSSET(lx1,ly1,lz1)
      IFACE  = EFACE1(IFC)
      JS1    = SKPDAT(1,IFACE)
      JF1    = SKPDAT(2,IFACE)
      JSKIP1 = SKPDAT(3,IFACE)
      JS2    = SKPDAT(4,IFACE)
      JF2    = SKPDAT(5,IFACE)
      JSKIP2 = SKPDAT(6,IFACE)
C
      SUM=0.0
      I = 0
      DO 100 J2=JS2,JF2,JSKIP2
      DO 100 J1=JS1,JF1,JSKIP1
         I = I+1
         SUM = SUM + A(J1,J2,1,ie)*B(I,1,ifc,ie)*area(I,1,ifc,ie)
c        SUM = SUM + A(J1,J2,1,ie)*B(J1,J2,1,ie)*area(I,1,ifc,ie)
  100 CONTINUE
C
      facint = SUM
c
      return
      end
c-----------------------------------------------------------------------
      function facint2(a,b,c,area,ifc,ie)
      include 'SIZE'
      include 'TOPOL'
      dimension a    (lx1,ly1,lz1,lelv)
     $        , b    (lx1,lz1,6,lelv)
     $        , c    (lx1,lz1,6,lelv)
     $        , area (lx1,lz1,6,lelv) 
      call dsset(lx1,ly1,lz1)
      iface  = eface1(ifc)
      js1    = skpdat(1,iface)
      jf1    = skpdat(2,iface)
      jskip1 = skpdat(3,iface)
      js2    = skpdat(4,iface)
      jf2    = skpdat(5,iface)
      jskip2 = skpdat(6,iface)
      sum=0.0
      i=0
      do j2=js2,jf2,jskip2
      do j1=js1,jf1,jskip1
         i=i+1
         sum=sum+a(j1,j2,1,ie)*b(i,1,ifc,ie)*c(i,1,ifc,ie)
     $          *area(i,1,ifc,ie)
      end do
      end do 
      facint2=sum
      return
      end 
c-----------------------------------------------------------------------
      subroutine out_csrmats(acsr,ia,ja,n,name9)
      real    acsr(1)
      integer ia(1),ja(1)
c
      character*9 name9
      character*9 s(16)
c
      nnz = ia(n+1)-ia(1)
c
      write(6,1) name9,n,nnz
    1 format(/,'CSR Mat:',a9,3x,'n =',i5,3x,'nnz =',i5,/)
c
      n16 = min(n,16)
      n29 = min(n,29)
      do i=1,n29
         call blank(s,9*16)
         n1 = ia(i)
         n2 = ia(i+1)-1
         do jj=n1,n2
            j = ja  (jj)
            a = acsr(jj)
            if (a.ne.0..and.j.le.n16) write(s(j),9) a
         enddo
         write(6,16) (s(k),k=1,n16)
      enddo
    9 format(f9.4)
   16 format(16a9)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine local_grad3(ur,us,ut,u,N,e,D,Dt)
c     Output: ur,us,ut         Input:u,N,e,D,Dt
      real ur(0:N,0:N,0:N),us(0:N,0:N,0:N),ut(0:N,0:N,0:N)
      real u (0:N,0:N,0:N,1)
      real D (0:N,0:N),Dt(0:N,0:N)
      integer e
c
      m1 = N+1
      m2 = m1*m1
c
      call mxm(D ,m1,u(0,0,0,e),m1,ur,m2)
      do k=0,N
         call mxm(u(0,0,k,e),m1,Dt,m1,us(0,0,k),m1)
      enddo
      call mxm(u(0,0,0,e),m2,Dt,m1,ut,m1)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine local_grad2(ur,us,u,N,e,D,Dt)
c     Output: ur,us         Input:u,N,e,D,Dt
      real ur(0:N,0:N),us(0:N,0:N)
      real u (0:N,0:N,1)
      real D (0:N,0:N),Dt(0:N,0:N)
      integer e
c
      m1 = N+1
c
      call mxm(D ,m1,u(0,0,e),m1,ur,m1)
      call mxm(u(0,0,e),m1,Dt,m1,us,m1)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine gradm1(ux,uy,uz,u)
c
c     Compute gradient of T -- mesh 1 to mesh 1 (vel. to vel.)
c
      include 'SIZE'
      include 'DXYZ'
      include 'GEOM'
      include 'INPUT'
      include 'TSTEP'
c
      parameter (lxyz=lx1*ly1*lz1)
      real ux(lxyz,1),uy(lxyz,1),uz(lxyz,1),u(lxyz,1)

      common /ctmp1/ ur(lxyz),us(lxyz),ut(lxyz)

      integer e

      nxyz = lx1*ly1*lz1
      ntot = nxyz*nelt

      N = lx1-1
      do e=1,nelt
         if (if3d) then
            call local_grad3(ur,us,ut,u,N,e,dxm1,dxtm1)
            do i=1,lxyz
               ux(i,e) = jacmi(i,e)*(ur(i)*rxm1(i,1,1,e)
     $                             + us(i)*sxm1(i,1,1,e)
     $                             + ut(i)*txm1(i,1,1,e) )
               uy(i,e) = jacmi(i,e)*(ur(i)*rym1(i,1,1,e)
     $                             + us(i)*sym1(i,1,1,e)
     $                             + ut(i)*tym1(i,1,1,e) )
               uz(i,e) = jacmi(i,e)*(ur(i)*rzm1(i,1,1,e)
     $                             + us(i)*szm1(i,1,1,e)
     $                             + ut(i)*tzm1(i,1,1,e) )
            enddo
         else
            if (ifaxis) call setaxdy (ifrzer(e))
            call local_grad2(ur,us,u,N,e,dxm1,dytm1)
            do i=1,lxyz
               ux(i,e) =jacmi(i,e)*(ur(i)*rxm1(i,1,1,e)
     $                            + us(i)*sxm1(i,1,1,e) )
               uy(i,e) =jacmi(i,e)*(ur(i)*rym1(i,1,1,e)
     $                            + us(i)*sym1(i,1,1,e) )
            enddo
         endif
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine comp_vort3(vort,work1,work2,u,v,w)

      include 'SIZE'
      include 'TOTAL'

      parameter(lt=lx1*ly1*lz1*lelv)
      real vort(lt,3),work1(1),work2(1),u(1),v(1),w(1)

      parameter(lx=lx1*ly1*lz1)
      real ur(lx),us(lx),ut(lx)
     $    ,vr(lx),vs(lx),vt(lx)
     $    ,wr(lx),ws(lx),wt(lx)
      common /ctmp0/ ur,us,ut,vr,vs,vt,wr,ws,wt

      integer e
      real jacmil
 
      ntot  = lx1*ly1*lz1*nelt
      nxyz  = lx1*ly1*lz1
      nx    = lx1 - 1      ! Polynomial degree

      if (ldim.eq.3) then
       k=0
       do e=1,nelt
        call local_grad3(ur,us,ut,u,nx,e,dxm1,dxtm1)
        call local_grad3(vr,vs,vt,v,nx,e,dxm1,dxtm1)
        call local_grad3(wr,ws,wt,w,nx,e,dxm1,dxtm1)
        do i=1,lx
         jacmil = jacmi(i,e)
c        vux=ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e)+ut(i)*txm1(i,1,1,e)
         vuy=ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)+ut(i)*tym1(i,1,1,e)
         vuz=ur(i)*rzm1(i,1,1,e)+us(i)*szm1(i,1,1,e)+ut(i)*tzm1(i,1,1,e)
         vvx=vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e)+vt(i)*txm1(i,1,1,e)
c        vvy=vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e)+vt(i)*tym1(i,1,1,e)
         vvz=vr(i)*rzm1(i,1,1,e)+vs(i)*szm1(i,1,1,e)+vt(i)*tzm1(i,1,1,e)
         vwx=wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e)+wt(i)*txm1(i,1,1,e)
         vwy=wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e)+wt(i)*tym1(i,1,1,e)
c        vwz=wr(i)*rzm1(i,1,1,e)+ws(i)*szm1(i,1,1,e)+wt(i)*tzm1(i,1,1,e)

         k = k+1
         vort(k,1) = (vwy-vvz)*jacmil
         vort(k,2) = (vuz-vwx)*jacmil
         vort(k,3) = (vvx-vuy)*jacmil
c        write(6,*) i,jacmil,vuy,vvx,k,e,' vort'
        enddo
       enddo

      else      ! 2D

       k=0
       do e=1,nelt
        call local_grad2(ur,us,u,nx,e,dxm1,dxtm1)
        call local_grad2(vr,vs,v,nx,e,dxm1,dxtm1)
        do i=1,lx
c        vux=ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e)+ut(i)*txm1(i,1,1,e)
         vuy=ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)+ut(i)*tym1(i,1,1,e)
         vvx=vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e)+vt(i)*txm1(i,1,1,e)
c        vvy=vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e)+vt(i)*tym1(i,1,1,e)

         k = k+1
         vort(k,1) = (vvx-vuy)*jacmi(i,e)
        enddo
       enddo
      endif
c
c    Avg at bndry
c
      ifielt = ifield
      ifield = 1
      if (if3d) then
         do idim=1,ldim
            call col2  (vort(1,idim),bm1,ntot)
            call dssum (vort(1,idim),lx1,ly1,lz1)
            call col2  (vort(1,idim),binvm1,ntot)
         enddo
      else
         call col2  (vort,bm1,ntot)
         call dssum (vort,lx1,ly1,lz1)
         call col2  (vort,binvm1,ntot)
      endif
      ifield = ifielt
c
      return
      end
c-----------------------------------------------------------------------
      subroutine surface_int(sint,sarea,a,e,f)
C
      include 'SIZE'
      include 'GEOM'
      include 'PARALLEL'
      include 'TOPOL'
      real a(lx1,ly1,lz1,1)

      integer e,f

      call dsset(lx1,ly1,lz1)

      iface  = eface1(f)
      js1    = skpdat(1,iface)
      jf1    = skpdat(2,iface)
      jskip1 = skpdat(3,iface)
      js2    = skpdat(4,iface)
      jf2    = skpdat(5,iface)
      jskip2 = skpdat(6,iface)

      sarea = 0.
      sint  = 0.
      i     = 0

      do 100 j2=js2,jf2,jskip2
      do 100 j1=js1,jf1,jskip1
         i = i+1
         sarea = sarea+area(i,1,f,e)
         sint  = sint +area(i,1,f,e)*a(j1,j2,1,e)
  100 continue

      return
      end
c-----------------------------------------------------------------------
      subroutine surface_flux(dq,qx,qy,qz,e,f,w)

      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'PARALLEL'
      include 'TOPOL'
      parameter (l=lx1*ly1*lz1)

      real qx(l,1),qy(l,1),qz(l,1),w(lx1,ly1,lz1)
      integer e,f

      call           faccl3  (w,qx(1,e),unx(1,1,f,e),f)
      call           faddcl3 (w,qy(1,e),uny(1,1,f,e),f)
      if (if3d) call faddcl3 (w,qz(1,e),unz(1,1,f,e),f)

      call dsset(lx1,ly1,lz1)
      iface  = eface1(f)
      js1    = skpdat(1,iface)
      jf1    = skpdat(2,iface)
      jskip1 = skpdat(3,iface)
      js2    = skpdat(4,iface)
      jf2    = skpdat(5,iface)
      jskip2 = skpdat(6,iface)

      dq = 0
      i  = 0
      do 100 j2=js2,jf2,jskip2
      do 100 j1=js1,jf1,jskip1
         i = i+1
         dq    = dq + area(i,1,f,e)*w(j1,j2,1)
  100 continue

      return
      end
c-----------------------------------------------------------------------
      subroutine gaujordf(a,m,n,indr,indc,ipiv,ierr,rmult)
C
C     Gauss-Jordan matrix inversion with full pivoting
c
c     Num. Rec. p. 30, 2nd Ed., Fortran
c
C
C     a     is an m x n matrix
C     rmult is a  work array of dimension m
C
c
      real a(m,n),rmult(m)
      integer indr(m),indc(n),ipiv(n)

c     call outmat(a,m,n,'ab4',n)
c     do i=1,m
c        write(6,1) (a(i,j),j=1,n)
c     enddo
c 1   format('mat: ',1p6e12.4)

      ierr = 0
      eps = 1.e-9
      call izero(ipiv,m)

      do k=1,m
         amx=0.
         do i=1,m                    ! Pivot search
            if (ipiv(i).ne.1) then
               do j=1,m
                  if (ipiv(j).eq.0) then
                    if (abs(a(i,j)).ge.amx) then
                       amx = abs(a(i,j))
                       ir  = i
                       jc  = j
                    endif
                 elseif (ipiv(j).gt.1) then
                    ierr = -ipiv(j)
                    return
                 endif
              enddo
           endif
        enddo
        ipiv(jc) = ipiv(jc) + 1
c
c       Swap rows
        if (ir.ne.jc) then
           do j=1,n
              tmp     = a(ir,j)
              a(ir,j) = a(jc,j)
              a(jc,j) = tmp
           enddo
        endif
        indr(k)=ir
        indc(k)=jc
c       write(6 ,*) k,' Piv:',jc,a(jc,jc)
c       write(28,*) k,' Piv:',jc,a(jc,jc)
        if (abs(a(jc,jc)).lt.eps) then
           write(6 ,*) 'small Gauss Jordan Piv:',jc,a(jc,jc)
           write(28,*) 'small Gauss Jordan Piv:',jc,a(jc,jc)
           ierr = jc
           call exitt
           return
        endif
        piv = 1./a(jc,jc)
        a(jc,jc)=1.
        do j=1,n
           a(jc,j) = a(jc,j)*piv
        enddo
c
        do j=1,n
           work    = a(jc,j)
           a(jc,j) = a(1 ,j)
           a(1 ,j) = work
        enddo
        do i=2,m
           rmult(i) = a(i,jc)
           a(i,jc)  = 0.
        enddo
c
        do j=1,n
        do i=2,m
           a(i,j) = a(i,j) - rmult(i)*a(1,j)
        enddo
        enddo
c
        do j=1,n
           work    = a(jc,j)
           a(jc,j) = a(1 ,j)
           a(1 ,j) = work
        enddo
c
c       do i=1,m
c          if (i.ne.jc) then
c             rmult   = a(i,jc)
c             a(i,jc) = 0.
c             do j=1,n
c                a(i,j) = a(i,j) - rmult*a(jc,j)
c             enddo
c          endif
c       enddo
c
      enddo
c
c     Unscramble matrix
      do j=m,1,-1
         if (indr(j).ne.indc(j)) then
            do i=1,m
               tmp=a(i,indr(j))
               a(i,indr(j))=a(i,indc(j))
               a(i,indc(j))=tmp
            enddo
         endif
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine legendre_poly(L,x,N)
c
c     Evaluate Legendre polynomials of degrees 0-N at point x
c
      real L(0:N)
c
      L(0) = 1.
      L(1) = x
c
      do j=2,N
         L(j) = ( (2*j-1) * x * L(j-1) - (j-1) * L(j-2) ) / j 
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine build_new_filter(intv,zpts,nx,kut,wght,nio)
c
c     This routing builds a 1D filter with a transfer function that
c     looks like:
c
c
c        ^
c    d_k |
c        |                 |
c     1  |__________      _v_
c        |          -_     
c        |            \  wght
c        |             \  ___
c        |             |   ^
c     0  |-------------|---|>
c
c        0         c   N   k-->
c
c        Where c := N-kut is the point below which d_k = 1.
c
c
c
c      Here, nx = number of points
c
      real intv(nx,nx),zpts(nx)
c
      parameter (lm=40)
      parameter (lm2=lm*lm)
      real      phi(lm2),pht(lm2),diag(lm2),rmult(lm),Lj(lm)
      integer   indr(lm),indc(lm),ipiv(lm)
c
      if (nx.gt.lm) then
         write(6,*) 'ABORT in build_new_filter:',nx,lm
         call exitt
      endif
c
      kj = 0
      n  = nx-1
      do j=1,nx
         z = zpts(j)
         call legendre_poly(Lj,z,n)
         kj = kj+1
         pht(kj) = Lj(1)
         kj = kj+1
         pht(kj) = Lj(2)
         do k=3,nx
            kj = kj+1
            pht(kj) = Lj(k)-Lj(k-2)
         enddo
      enddo
      call transpose (phi,nx,pht,nx)
      call copy      (pht,phi,nx*nx)
      call gaujordf  (pht,nx,nx,indr,indc,ipiv,ierr,rmult)
c
c     Set up transfer function
c
      call ident   (diag,nx)
c
      k0 = nx-kut
      do k=k0+1,nx
         kk = k+nx*(k-1)
         amp = wght*(k-k0)*(k-k0)/(kut*kut)   ! quadratic growth
         diag(kk) = 1.-amp
      enddo
c
      call mxm  (diag,nx,pht,nx,intv,nx)      !          -1
      call mxm  (phi ,nx,intv,nx,pht,nx)      !     V D V
      call copy (intv,pht,nx*nx)
c
      do k=1,nx*nx
         pht(k) = 1.-diag(k)
      enddo
      np1 = nx+1
      if (nio.eq.0) then
         write(6,6) 'filt amp',(pht (k),k=1,nx*nx,np1)
         write(6,6) 'filt trn',(diag(k),k=1,nx*nx,np1)
   6     format(a8,16f7.4,6(/,8x,16f7.4))
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine avg_all
c
c     This routine computes running averages E(X),E(X^2),E(X*Y)
c     and outputs to avg*.fld*, rms*.fld*, and rm2*.fld* for all
c     fields.
c
c     E denotes the expected value operator and X,Y two
c     real valued random variables.
c
c     variances and covariances can be computed in a post-processing step:
c
c        var(X)   := E(X^X) - E(X)*E(X) 
c        cov(X,Y) := E(X*Y) - E(X)*E(Y)  
c
c     Note: The E-operator is linear, in the sense that the expected
c           value is given by E(X) = 1/N * sum[ E(X)_i ], where E(X)_i
c           is the expected value of the sub-ensemble i (i=1...N).
c
      include 'SIZE'  
      include 'TOTAL' 
      include 'AVG'

      logical ifverbose
      integer icalld
      save    icalld
      data    icalld  /0/

      if (ax1.ne.lx1 .or. ay1.ne.ly1 .or. az1.ne.lz1) then
         if(nid.eq.0) write(6,*)
     $     'ABORT: wrong size of ax1,ay1,az1 in avg_all(), check SIZE!'
         call exitt
      endif
      if (ax2.ne.lx2 .or. ay2.ne.ay2 .or. az2.ne.lz2) then
         if(nid.eq.0) write(6,*)
     $     'ABORT: wrong size of ax2,ay2,az2 in avg_all(), check SIZE!'
         call exitt
      endif

      ntot  = lx1*ly1*lz1*nelv
      ntott = lx1*ly1*lz1*nelt
      nto2  = lx2*ly2*lz2*nelv

      ! initialization
      if (icalld.eq.0) then
         icalld = icalld + 1
         atime  = 0.
         timel  = time

         call rzero(uavg,ntot)
         call rzero(vavg,ntot)
         call rzero(wavg,ntot)
         call rzero(pavg,nto2)
         do i = 1,ldimt
            call rzero(tavg(1,1,1,1,i),ntott)
         enddo

         call rzero(urms,ntot)
         call rzero(vrms,ntot)
         call rzero(wrms,ntot)
         call rzero(prms,nto2)
         do i = 1,ldimt
            call rzero(trms(1,1,1,1,i),ntott)
         enddo

         call rzero(vwms,ntot)
         call rzero(wums,ntot)
         call rzero(uvms,ntot)
      endif

      dtime = time  - timel
      atime = atime + dtime

      ! dump freq
      iastep = param(68)
      if  (iastep.eq.0) iastep=param(15)   ! same as iostep
      if  (iastep.eq.0) iastep=500

      ifverbose=.false.
      if (istep.le.10) ifverbose=.true.
      if  (mod(istep,iastep).eq.0) ifverbose=.true.

      if (atime.ne.0..and.dtime.ne.0.) then
         if(nio.eq.0) write(6,*) 'Compute statistics ...'
         beta  = dtime/atime
         alpha = 1.-beta
         ! compute averages E(X)
         call avg1    (uavg,vx,alpha,beta,ntot ,'um  ',ifverbose)
         call avg1    (vavg,vy,alpha,beta,ntot ,'vm  ',ifverbose)
         call avg1    (wavg,vz,alpha,beta,ntot ,'wm  ',ifverbose)
         call avg1    (pavg,pr,alpha,beta,nto2 ,'prm ',ifverbose)
         call avg1    (tavg,t ,alpha,beta,ntott,'tm  ',ifverbose)
         do i = 2,ldimt
            call avg1 (tavg(1,1,1,1,i),t(1,1,1,1,i),alpha,beta,
     &                 ntott,'psav',ifverbose)
         enddo

         ! compute averages E(X^2) 
         call avg2    (urms,vx,alpha,beta,ntot ,'ums ',ifverbose)
         call avg2    (vrms,vy,alpha,beta,ntot ,'vms ',ifverbose)
         call avg2    (wrms,vz,alpha,beta,ntot ,'wms ',ifverbose)
         call avg2    (prms,pr,alpha,beta,nto2 ,'prms',ifverbose)
         call avg2    (trms,t ,alpha,beta,ntott,'tms ',ifverbose)
         do i = 2,ldimt
            call avg2 (trms(1,1,1,1,i),t(1,1,1,1,i),alpha,beta,
     &                 ntott,'psms',ifverbose)
         enddo

         ! compute averages E(X*Y) (for now just for the velocities)
         call avg3    (uvms,vx,vy,alpha,beta,ntot,'uvm ',ifverbose)
         call avg3    (vwms,vy,vz,alpha,beta,ntot,'vwm ',ifverbose)
         call avg3    (wums,vz,vx,alpha,beta,ntot,'wum ',ifverbose)
      endif
c
c-----------------------------------------------------------------------
      if ( (mod(istep,iastep).eq.0.and.istep.gt.1) .or.lastep.eq.1) then

         time_temp = time
         time      = atime   ! Output the duration of this avg
         dtmp      = param(63)
         param(63) = 1       ! Enforce 64-bit output

         call outpost2(uavg,vavg,wavg,pavg,tavg,ldimt,'avg')
         call outpost2(urms,vrms,wrms,prms,trms,ldimt,'rms')
         call outpost (uvms,vwms,wums,prms,trms,      'rm2')

         param(63) = dtmp
         atime = 0.
         time  = time_temp  ! Restore clock

      endif
c
      timel = time
c
      return
      end
c-----------------------------------------------------------------------
      subroutine avg1(avg,f,alpha,beta,n,name,ifverbose)
      include 'SIZE'
      include 'TSTEP'
c
      real avg(n),f(n)
      character*4 name
      logical ifverbose
c
      do k=1,n
         avg(k) = alpha*avg(k) + beta*f(k)
      enddo
c
      if (ifverbose) then
         avgmax = glmax(avg,n)
         avgmin = glmin(avg,n)
         if (nio.eq.0) write(6,1) istep,time,avgmin,avgmax
     $                           ,alpha,beta,name
    1    format(i9,1p5e13.5,1x,a4,' av1mnx')
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine avg2(avg,f,alpha,beta,n,name,ifverbose)
      include 'SIZE'
      include 'TSTEP'
c
      real avg(n),f(n)
      character*4 name
      logical ifverbose
c
      do k=1,n
         avg(k) = alpha*avg(k) + beta*f(k)*f(k)
      enddo
c
      if (ifverbose) then
         avgmax = glmax(avg,n)
         avgmin = glmin(avg,n)
         if (nio.eq.0) write(6,1) istep,time,avgmin,avgmax
     $                           ,alpha,beta,name
    1    format(i9,1p5e13.5,1x,a4,' av2mnx')
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine avg3(avg,f,g,alpha,beta,n,name,ifverbose)
      include 'SIZE'
      include 'TSTEP'
c
      real avg(n),f(n),g(n)
      character*4 name
      logical ifverbose
c
      do k=1,n
         avg(k) = alpha*avg(k) + beta*f(k)*g(k)
      enddo
c
      if (ifverbose) then
         avgmax = glmax(avg,n)
         avgmin = glmin(avg,n)
         if (nio.eq.0) write(6,1) istep,time,avgmin,avgmax
     $                           ,alpha,beta,name
    1    format(i9,1p5e13.5,1x,a4,' av3mnx')
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine build_legend_transform(Lj,Ljt,zpts,nx)
c
      real Lj(nx*nx),Ljt(nx*nx),zpts(nx)
c
      parameter (lm=90)
      integer   indr(lm),indc(lm),ipiv(lm)
      real rmult(lm)
c
      if (nx.gt.lm) then
         write(6,*) 'ABORT in build_legend_transform:',nx,lm
         call exitt
      endif
c
      j = 1
      n = nx-1
      do i=1,nx
         z = zpts(i)
         call legendre_poly(Lj(j),z,n)  ! Return Lk(z), k=0,...,n
         j = j+nx
      enddo
      call transpose1(Lj,nx)
c     call outmat(Lj,nx,nx,'Lj ',n)
c     call exitt
      call gaujordf  (Lj,nx,nx,indr,indc,ipiv,ierr,rmult)
      call transpose (Ljt,nx,Lj,nx)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine local_err_est(err,u,nx,Lj,Ljt,uh,w,if3d)
c
c     Local error estimates for u_e
c
      include 'SIZE'
      real err(5,2),u(1),uh(nx,nx,nx),w(1),Lj(1),Ljt(1)
      logical if3d
c
      call rzero(err,10)
c
      nxyz = nx**ldim
      utot = vlsc2(u,u,nxyz)
      if (utot.eq.0) return
c
      call tensr3(uh,nx,u,nx,Lj,Ljt,Ljt,w)    !  Go to Legendre space
c
c
c     Get energy in low modes
c
      m = nx-2
c
      if (if3d) then
         amp2_l = 0.
         do k=1,m
         do j=1,m
         do i=1,m
            amp2_l = amp2_l + uh(i,j,k)**2
         enddo
         enddo
         enddo
c
c        Energy in each spatial direction
c        
         amp2_t = 0
         do k=m+1,nx
         do j=1,m
         do i=1,m
            amp2_t = amp2_t + uh(i,j,k)**2
         enddo
         enddo
         enddo
c        
         amp2_s = 0
         do k=1,m
         do j=m+1,nx
         do i=1,m
            amp2_s = amp2_s + uh(i,j,k)**2
         enddo
         enddo
         enddo
c        
         amp2_r = 0
         do k=1,m
         do j=1,m
         do i=m+1,nx
            amp2_r = amp2_r + uh(i,j,k)**2
         enddo
         enddo
         enddo
c
         amp2_h = 0
         do k=m+1,nx
         do j=m+1,nx
         do i=m+1,nx
            amp2_h = amp2_h + uh(i,j,k)**2
         enddo
         enddo
         enddo
c
         etot = amp2_l + amp2_r + amp2_s + amp2_t + amp2_h
c
         relr = amp2_r / (amp2_r + amp2_l)
         rels = amp2_s / (amp2_s + amp2_l)
         relt = amp2_t / (amp2_t + amp2_l)
         relh = (amp2_r + amp2_s + amp2_t + amp2_h) / etot
c
      else
         k = 1
         amp2_l = 0.
         do j=1,m
         do i=1,m
            amp2_l = amp2_l + uh(i,j,k)**2
         enddo
         enddo
         if (amp2_l.eq.0) return
c
c        Energy in each spatial direction
c        
         amp2_t = 0
c        
         amp2_s = 0
         do j=m+1,nx
         do i=1,m
            amp2_s = amp2_s + uh(i,j,k)**2
         enddo
         enddo
c        
         amp2_r = 0
         do j=1,m
         do i=m+1,nx
            amp2_r = amp2_r + uh(i,j,k)**2
         enddo
         enddo
c
         amp2_h = 0
         do j=m+1,nx
         do i=m+1,nx
            amp2_h = amp2_h + uh(i,j,k)**2
         enddo
         enddo
c
         etot = amp2_l + amp2_r + amp2_s + amp2_h
c
         relr = amp2_r / (amp2_r + amp2_l)
         rels = amp2_s / (amp2_s + amp2_l)
         relt = 0
         relh = (amp2_r + amp2_s + amp2_h) / etot
c
      endif
c
      err (1,1) = sqrt(relr)
      err (2,1) = sqrt(rels)
      if (if3d) err (3,1) = sqrt(relt)
      err (4,1) = sqrt(relh)
      err (5,1) = sqrt(etot)
c
      err (1,2) = sqrt(amp2_r)
      err (2,2) = sqrt(amp2_s)
      if (if3d) err (3,2) = sqrt(amp2_t)
      err (4,2) = sqrt(amp2_h)
      err (5,2) = sqrt(utot)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine get_exyz(ex,ey,ez,eg,nelx,nely,nelz)
      integer ex,ey,ez,eg
c
      nelxy = nelx*nely
c
      ez = 1 +  (eg-1)/nelxy
      ey = mod1 (eg,nelxy)
      ey = 1 +  (ey-1)/nelx
      ex = mod1 (eg,nelx)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine dump_header2d(excode,nx,ny,nlx,nly,ierr)

      include 'SIZE'
      include 'TOTAL'

      character*2 excode(15)

      real*4         test_pattern

      character*1 fhdfle1(132)
      character*132 fhdfle
      equivalence (fhdfle,fhdfle1)

      jstep = istep
      if (jstep.gt.10000) jstep = jstep / 10
      if (jstep.gt.10000) jstep = jstep / 10
      if (jstep.gt.10000) jstep = jstep / 10
      if (jstep.gt.10000) jstep = jstep / 10
      if (jstep.gt.10000) jstep = jstep / 10

      nlxy = nlx*nly
      nzz  = 1

c     write(6,'(4i4,1PE14.7,i5,1x,15a2,1x,a12)')
c    $  nlxy,nx,ny,nzz,TIME,jstep,(excode(i),i=1,15),
c    $  'NELT,NX,NY,N'
c
      p66 = 0.
      ierr= 0
      IF (p66.EQ.1.0) THEN
C       unformatted i/o
        WRITE(24)
     $  nlxy,nx,ny,nzz,TIME,jstep,(excode(i),i=1,15)
      ELSEIF (p66.EQ.3.0) THEN
C       formatted i/o to header file
        WRITE(27,'(4I4,1pe14.7,I5,1X,15A2,1X,A12)')
     $  nlxy,nx,ny,nzz,TIME,jstep,(excode(i),i=1,15),
     $  'NELT,NX,NY,N'
      ELSEIF (p66.eq.4.0) THEN
C       formatted i/o to header file
        WRITE(fhdfle,'(4I4,1pe14.7,I5,1X,15A2,1X,A12)')
     $  nlxy,nx,ny,nzz,TIME,jstep,(excode(i),i=1,15),
     $  ' 4 NELT,NX,NY,N'
        call byte_write(fhdfle,20,ierr)
      ELSEIF (p66.eq.5.0) THEN
C       formatted i/o to header file
        WRITE(fhdfle,'(4I4,1pe14.7,I5,1X,15A2,1X,A12)')
     $  nlxy,nx,ny,nzz,TIME,jstep,(excode(i),i=1,15),
     $  ' 8 NELT,NX,NY,N'
        call byte_write(fhdfle,20,ierr)
      ELSE
C       formatted i/o
        WRITE(24,'(4I4,1pe14.7,I5,1X,15A2,1X,A12)')
     $  nlxy,nx,ny,nzz,TIME,jstep,(excode(i),i=1,15),
     $  'NELT,NX,NY,N'
      ENDIF
C     cdrror is a dummy cerror value for now.
      CDRROR=0.0
      IF (p66.EQ.1.0) THEN
C       unformatted i/o
        WRITE(24)(CDRROR,I=1,nlxy)
      ELSEIF (p66.eq.3. .or. p66.eq.4.0) then
C       write byte-ordering test pattern to byte file...
        test_pattern = 6.54321
        call byte_write(test_pattern,1,ierr)
      ELSEIF (p66.eq.5.) then
        test_pattern8 = 6.54321
        call byte_write(test_pattern8,2,ierr)
      ELSE
C       formatted i/o
        WRITE(24,'(6G11.4)')(CDRROR,I=1,nlxy)
      ENDIF
 
      return
      end
c-----------------------------------------------------------------------
      subroutine outfld2d_p(u,v,w,nx,ny,nlx,nly,name,ifld,jid,npido,ir)

      include 'SIZE'
      include 'TOTAL'

      integer icalld
      save    icalld
      data    icalld /0/

      real u(nx*ny*nlx*nly)
      real v(nx*ny*nlx*nly)
      real w(nx*ny*nlx*nly)
      character*4 name

      character*2  excode(15)
      character*12 fm
      character*20 outfile

      character*1 slash,dot
      save        slash,dot
      data        slash,dot  / '/' , '.' /

      icalld = icalld+1

      call blank(excode,30)
      excode(4) = 'U '
      excode(5) = '  '
      excode(6) = 'T '
      nthings   =  3
      ir = 0 !error code for dump_header2d

      call blank(outfile,20)
      if (npido.lt.100) then
         if (ifld.lt.100) then
            write(outfile,22) jid,slash,name,ifld
   22       format('B',i2.2,a1,a4,'.fld',i2.2)
         elseif (ifld.lt.1000) then
            write(outfile,23) jid,slash,name,ifld
   23       format('B',i2.2,a1,a4,'.fld',i3)
         elseif (ifld.lt.10000) then
            write(outfile,24) jid,slash,name,ifld
   24       format('B',i2.2,a1,a4,'.fld',i4)
         elseif (ifld.lt.100000) then
            write(outfile,25) jid,slash,name,ifld
   25       format('B',i2.2,a1,a4,'.fld',i5)
         elseif (ifld.lt.1000000) then
            write(outfile,26) jid,slash,name,ifld
   26       format('B',i2.2,a1,a4,'.fld',i6)
         endif
      else
         if (ifld.lt.100) then
            write(outfile,32) jid,slash,name,ifld
   32       format('B',i3.3,a1,a4,'.fld',i2.2)
         elseif (ifld.lt.1000) then
            write(outfile,33) jid,slash,name,ifld
   33       format('B',i3.3,a1,a4,'.fld',i3)
         elseif (ifld.lt.10000) then
            write(outfile,34) jid,slash,name,ifld
   34       format('B',i3.3,a1,a4,'.fld',i4)
         elseif (ifld.lt.100000) then
            write(outfile,35) jid,slash,name,ifld
   35       format('B',i3.3,a1,a4,'.fld',i5)
         elseif (ifld.lt.1000000) then
            write(outfile,36) jid,slash,name,ifld
   36       format('B',i3.3,a1,a4,'.fld',i6)
         endif
      endif

      if (icalld.le.4) write(6,*) nid,outfile,' OPEN',nlx,nly
      open(unit=24,file=outfile,status='unknown')
      call dump_header2d(excode,nx,ny,nlx,nly,ir)

      n = nx*ny*nlx*nly
      write(fm,10) nthings
      write(24,fm) (u(i),v(i),w(i),i=1,n)
   10 format('(1p',i1,'e14.6)')
      close(24)

      return
      end
c-----------------------------------------------------------------------
      subroutine outfld2d(u,v,w,nx,ny,nlx,nly,name,ifld)

      include 'SIZE'
      include 'TOTAL'

      real u(nx*ny*nlx*nly)
      real v(nx*ny*nlx*nly)
      real w(nx*ny*nlx*nly)
      character*3 name

      character*2  excode(15)
      character*12 fm
      character*20 outfile

c     if (istep.le.10) write(6,*) nid,' in out2d:',iz

      call blank(excode,30)
c
c     excode(1) = 'X '
c     excode(2) = 'Y '
c     excode(3) = 'U '
c     excode(4) = 'V '
c     excode(5) = 'P '
c     excode(6) = 'T '
c
      excode(4) = 'U '
      excode(5) = '  '
      excode(6) = 'T '
      nthings   =  3

      ierr = 0 
      if (nid.eq.0) then
         call blank(outfile,20)
         if (ifld.lt.100) then
            write(outfile,2) name,ifld
    2       format(a3,'2d.fld',i2.2)
         elseif (ifld.lt.1000) then
            write(outfile,3) name,ifld
    3       format(a3,'2d.fld',i3)
         elseif (ifld.lt.10000) then
            write(outfile,4) name,ifld
    4       format(a3,'2d.fld',i4)
         elseif (ifld.lt.100000) then
            write(outfile,5) name,ifld
    5       format(a3,'2d.fld',i5)
         elseif (ifld.lt.1000000) then
            write(outfile,6) name,ifld
    6       format(a3,'2d.fld',i6)
         endif
         open(unit=24,file=outfile,status='unknown')
         call dump_header2d(excode,nx,ny,nlx,nly,ierr)

         n = nx*ny*nlx*nly
         write(fm,10) nthings
c        write(6,*) fm
c        call exitt
         write(24,fm) (u(i),v(i),w(i),i=1,n)
   10    format('(1p',i1,'e14.6)')
c  10    format('''(1p',i1,'e15.7)''')
c  10    format(1p7e15.7)
c
         close(24)
      endif
      call err_chk(ierr,'Error using byte_write,outfld2d. Abort.$')

      return
      end
c-----------------------------------------------------------------------
      subroutine drgtrq(dgtq,xm0,ym0,zm0,sij,pm1,visc,f,e)
c
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'TOPOL'
      INCLUDE 'TSTEP'
c
      real dgtq(3,4)
      real xm0 (lx1,ly1,lz1,lelt)
      real ym0 (lx1,ly1,lz1,lelt)
      real zm0 (lx1,ly1,lz1,lelt)
      real sij (lx1,ly1,lz1,3*ldim-3,lelv)
      real pm1 (lx1,ly1,lz1,lelv)
      real visc(lx1,ly1,lz1,lelv)
c
      real dg(3,2)
c
      integer f,e,pf
      real    n1,n2,n3
c
      call dsset(lx1,ly1,lz1)    ! set up counters
      pf     = eface1(f)         ! convert from preproc. notation
      js1    = skpdat(1,pf)
      jf1    = skpdat(2,pf)
      jskip1 = skpdat(3,pf)
      js2    = skpdat(4,pf)
      jf2    = skpdat(5,pf)
      jskip2 = skpdat(6,pf)
C
      call rzero(dgtq,12)
c
      if (if3d.or.ifaxis) then
       i = 0
       a = 0
       do j2=js2,jf2,jskip2
       do j1=js1,jf1,jskip1
         i = i+1
         n1 = unx(i,1,f,e)*area(i,1,f,e)
         n2 = uny(i,1,f,e)*area(i,1,f,e)
         n3 = unz(i,1,f,e)*area(i,1,f,e)
         a  = a +          area(i,1,f,e)
c
         v  = visc(j1,j2,1,e)
c
         s11 = sij(j1,j2,1,1,e)
         s21 = sij(j1,j2,1,4,e)
         s31 = sij(j1,j2,1,6,e)
c
         s12 = sij(j1,j2,1,4,e)
         s22 = sij(j1,j2,1,2,e)
         s32 = sij(j1,j2,1,5,e)
c
         s13 = sij(j1,j2,1,6,e)
         s23 = sij(j1,j2,1,5,e)
         s33 = sij(j1,j2,1,3,e)
c
         dg(1,1) = pm1(j1,j2,1,e)*n1     ! pressure drag
         dg(2,1) = pm1(j1,j2,1,e)*n2
         dg(3,1) = pm1(j1,j2,1,e)*n3
c
         dg(1,2) = -v*(s11*n1 + s12*n2 + s13*n3) ! viscous drag
         dg(2,2) = -v*(s21*n1 + s22*n2 + s23*n3)
         dg(3,2) = -v*(s31*n1 + s32*n2 + s33*n3)
c
         r1 = xm0(j1,j2,1,e)
         r2 = ym0(j1,j2,1,e)
         r3 = zm0(j1,j2,1,e)
c
         do l=1,2
         do k=1,3
            dgtq(k,l) = dgtq(k,l) + dg(k,l)
         enddo
         enddo
c
         dgtq(1,3) = dgtq(1,3) + (r2*dg(3,1)-r3*dg(2,1)) ! pressure
         dgtq(2,3) = dgtq(2,3) + (r3*dg(1,1)-r1*dg(3,1)) ! torque
         dgtq(3,3) = dgtq(3,3) + (r1*dg(2,1)-r2*dg(1,1))
c
         dgtq(1,4) = dgtq(1,4) + (r2*dg(3,2)-r3*dg(2,2)) ! viscous
         dgtq(2,4) = dgtq(2,4) + (r3*dg(1,2)-r1*dg(3,2)) ! torque
         dgtq(3,4) = dgtq(3,4) + (r1*dg(2,2)-r2*dg(1,2))
       enddo
       enddo

      else ! 2D

       i = 0
       a = 0
       do j2=js2,jf2,jskip2
       do j1=js1,jf1,jskip1
         i = i+1
         n1 = unx(i,1,f,e)*area(i,1,f,e)
         n2 = uny(i,1,f,e)*area(i,1,f,e)
         a  = a +          area(i,1,f,e)
         v  = visc(j1,j2,1,e)

         s11 = sij(j1,j2,1,1,e)
         s12 = sij(j1,j2,1,3,e)
         s21 = sij(j1,j2,1,3,e)
         s22 = sij(j1,j2,1,2,e)

         dg(1,1) = pm1(j1,j2,1,e)*n1     ! pressure drag
         dg(2,1) = pm1(j1,j2,1,e)*n2
         dg(3,1) = 0

         dg(1,2) = -v*(s11*n1 + s12*n2) ! viscous drag
         dg(2,2) = -v*(s21*n1 + s22*n2)
         dg(3,2) = 0.

         r1 = xm0(j1,j2,1,e)
         r2 = ym0(j1,j2,1,e)
         r3 = 0.

         do l=1,2
         do k=1,3
            dgtq(k,l) = dgtq(k,l) + dg(k,l)
         enddo
         enddo

         dgtq(1,3) = 0! dgtq(1,3) + (r2*dg(3,1)-r3*dg(2,1)) ! pressure
         dgtq(2,3) = 0! dgtq(2,3) + (r3*dg(1,1)-r1*dg(3,1)) ! torque
         dgtq(3,3) = dgtq(3,3) + (r1*dg(2,1)-r2*dg(1,1))

         dgtq(1,4) = 0! dgtq(1,4) + (r2*dg(3,2)-r3*dg(2,2)) ! viscous
         dgtq(2,4) = 0! dgtq(2,4) + (r3*dg(1,2)-r1*dg(3,2)) ! torque
         dgtq(3,4) = dgtq(3,4) + (r1*dg(2,2)-r2*dg(1,2))
       enddo
       enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine torque_calc(scale,x0,ifdout,iftout)
c
c     Compute torque about point x0
c
c     Scale is a user-supplied multiplier so that results may be
c     scaled to any convenient non-dimensionalization.
c
c
      INCLUDE 'SIZE'  
      INCLUDE 'TOTAL' 

      common /cvflow_r/ flow_rate,base_flow,domain_length,xsec
     $                , scale_vf(3)

c
      real x0(3),w1(0:maxobj)
      logical ifdout,iftout
c
      common /scrns/         sij (lx1*ly1*lz1*6*lelv)
      common /scrcg/         pm1 (lx1,ly1,lz1,lelv)
      common /scrsf/         xm0(lx1,ly1,lz1,lelt)
     $,                      ym0(lx1,ly1,lz1,lelt)
     $,                      zm0(lx1,ly1,lz1,lelt)
c
      parameter (lr=lx1*ly1*lz1)
      common /scruz/         ur(lr),us(lr),ut(lr)
     $                     , vr(lr),vs(lr),vt(lr)
     $                     , wr(lr),ws(lr),wt(lr)
c
      n = lx1*ly1*lz1*nelv
c
      call mappr(pm1,pr,xm0,ym0) ! map pressure onto Mesh 1
c
c    Add mean_pressure_gradient.X to p:

      if (param(55).ne.0) then
         dpdx_mean = -scale_vf(1)
         dpdy_mean = -scale_vf(2)
         dpdz_mean = -scale_vf(3)
      endif

      call add2s2(pm1,xm1,dpdx_mean,n)  ! Doesn't work if object is cut by 
      call add2s2(pm1,ym1,dpdy_mean,n)  ! periodicboundary.  In this case,
      call add2s2(pm1,zm1,dpdz_mean,n)  ! set ._mean=0 and compensate in
c
c    Compute sij
c
      nij = 3
      if (if3d.or.ifaxis) nij=6
      call comp_sij(sij,nij,vx,vy,vz,ur,us,ut,vr,vs,vt,wr,ws,wt)
c
c
c     Fill up viscous array w/ default
c
      if (istep.lt.1) call cfill(vdiff,param(2),n)
c
      call cadd2(xm0,xm1,-x0(1),n)
      call cadd2(ym0,ym1,-x0(2),n)
      call cadd2(zm0,zm1,-x0(3),n)
c
      x1min=glmin(xm0(1,1,1,1),n)
      x2min=glmin(ym0(1,1,1,1),n)
      x3min=glmin(zm0(1,1,1,1),n)
c
      x1max=glmax(xm0(1,1,1,1),n)
      x2max=glmax(ym0(1,1,1,1),n)
      x3max=glmax(zm0(1,1,1,1),n)
c
      do i=0,maxobj
         dragpx(i) = 0   ! BIG CODE  :}
         dragvx(i) = 0
         dragx (i) = 0
         dragpy(i) = 0
         dragvy(i) = 0
         dragy (i) = 0
         dragpz(i) = 0
         dragvz(i) = 0
         dragz (i) = 0
         torqpx(i) = 0
         torqvx(i) = 0
         torqx (i) = 0
         torqpy(i) = 0
         torqvy(i) = 0
         torqy (i) = 0
         torqpz(i) = 0
         torqvz(i) = 0
         torqz (i) = 0
      enddo
c
c
      ifield = 1
      do iobj = 1,nobj
         memtot = nmember(iobj)
      do mem  = 1,memtot
         ieg   = object(iobj,mem,1)
         ifc   = object(iobj,mem,2)
         if (gllnid(ieg).eq.nid) then ! this processor has a contribution
            ie = gllel(ieg)
            call drgtrq(dgtq,xm0,ym0,zm0,sij,pm1,vdiff,ifc,ie)

            call cmult(dgtq,scale,12)

            dragpx(iobj) = dragpx(iobj) + dgtq(1,1)  ! pressure 
            dragpy(iobj) = dragpy(iobj) + dgtq(2,1)
            dragpz(iobj) = dragpz(iobj) + dgtq(3,1)

            dragvx(iobj) = dragvx(iobj) + dgtq(1,2)  ! viscous
            dragvy(iobj) = dragvy(iobj) + dgtq(2,2)
            dragvz(iobj) = dragvz(iobj) + dgtq(3,2)

            torqpx(iobj) = torqpx(iobj) + dgtq(1,3)  ! pressure 
            torqpy(iobj) = torqpy(iobj) + dgtq(2,3)
            torqpz(iobj) = torqpz(iobj) + dgtq(3,3)

            torqvx(iobj) = torqvx(iobj) + dgtq(1,4)  ! viscous
            torqvy(iobj) = torqvy(iobj) + dgtq(2,4)
            torqvz(iobj) = torqvz(iobj) + dgtq(3,4)
         endif
      enddo
      enddo
c
c     Sum contributions from all processors
c
      call gop(dragpx,w1,'+  ',maxobj+1)
      call gop(dragpy,w1,'+  ',maxobj+1)
      call gop(dragpz,w1,'+  ',maxobj+1)
      call gop(dragvx,w1,'+  ',maxobj+1)
      call gop(dragvy,w1,'+  ',maxobj+1)
      call gop(dragvz,w1,'+  ',maxobj+1)
c
      call gop(torqpx,w1,'+  ',maxobj+1)
      call gop(torqpy,w1,'+  ',maxobj+1)
      call gop(torqpz,w1,'+  ',maxobj+1)
      call gop(torqvx,w1,'+  ',maxobj+1)
      call gop(torqvy,w1,'+  ',maxobj+1)
      call gop(torqvz,w1,'+  ',maxobj+1)

      do i=1,nobj
         dragx(i) = dragpx(i) + dragvx(i)
         dragy(i) = dragpy(i) + dragvy(i)
         dragz(i) = dragpz(i) + dragvz(i)

         torqx(i) = torqpx(i) + torqvx(i)
         torqy(i) = torqpy(i) + torqvy(i)
         torqz(i) = torqpz(i) + torqvz(i)

         dragpx(0) = dragpx (0) + dragpx (i)
         dragvx(0) = dragvx (0) + dragvx (i)
         dragx (0) = dragx  (0) + dragx  (i)

         dragpy(0) = dragpy (0) + dragpy (i)
         dragvy(0) = dragvy (0) + dragvy (i)
         dragy (0) = dragy  (0) + dragy  (i)

         dragpz(0) = dragpz (0) + dragpz (i)
         dragvz(0) = dragvz (0) + dragvz (i)
         dragz (0) = dragz  (0) + dragz  (i)

         torqpx(0) = torqpx (0) + torqpx (i)
         torqvx(0) = torqvx (0) + torqvx (i)
         torqx (0) = torqx  (0) + torqx  (i)

         torqpy(0) = torqpy (0) + torqpy (i)
         torqvy(0) = torqvy (0) + torqvy (i)
         torqy (0) = torqy  (0) + torqy  (i)

         torqpz(0) = torqpz (0) + torqpz (i)
         torqvz(0) = torqvz (0) + torqvz (i)
         torqz (0) = torqz  (0) + torqz  (i)
      enddo

      do i=1,nobj
        if (nio.eq.0) then
          if (if3d.or.ifaxis) then
           if (ifdout) then
            write(6,6) istep,time,dragx(i),dragpx(i),dragvx(i),i,'dragx'
            write(6,6) istep,time,dragy(i),dragpy(i),dragvy(i),i,'dragy'
            write(6,6) istep,time,dragz(i),dragpz(i),dragvz(i),i,'dragz'
           endif
           if (iftout) then
            write(6,6) istep,time,torqx(i),torqpx(i),torqvx(i),i,'torqx'
            write(6,6) istep,time,torqy(i),torqpy(i),torqvy(i),i,'torqy'
            write(6,6) istep,time,torqz(i),torqpz(i),torqvz(i),i,'torqz'
           endif
          else
           if (ifdout) then
            write(6,6) istep,time,dragx(i),dragpx(i),dragvx(i),i,'dragx'
            write(6,6) istep,time,dragy(i),dragpy(i),dragvy(i),i,'dragy'
           endif
           if (iftout) then
            write(6,6) istep,time,torqz(i),torqpz(i),torqvz(i),i,'torqz'
           endif
          endif
        endif
    6   format(i8,1p4e19.11,2x,i5,a5)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine comp_sij(sij,nij,u,v,w,ur,us,ut,vr,vs,vt,wr,ws,wt)
c                                       du_i       du_j
c     Compute the stress tensor S_ij := ----   +   ----
c                                       du_j       du_i
c
      include 'SIZE'
      include 'TOTAL'
c
      integer e
c
      real sij(lx1*ly1*lz1,nij,lelv)
      real u  (lx1*ly1*lz1,lelv)
      real v  (lx1*ly1*lz1,lelv)
      real w  (lx1*ly1*lz1,lelv)
      real ur (1) , us (1) , ut (1)
     $   , vr (1) , vs (1) , vt (1)
     $   , wr (1) , ws (1) , wt (1)

      real j ! Inverse Jacobian

      n    = lx1-1      ! Polynomial degree
      nxyz = lx1*ly1*lz1

      if (if3d) then     ! 3D CASE
       do e=1,nelv
        call local_grad3(ur,us,ut,u,N,e,dxm1,dxtm1)
        call local_grad3(vr,vs,vt,v,N,e,dxm1,dxtm1)
        call local_grad3(wr,ws,wt,w,N,e,dxm1,dxtm1)

        do i=1,nxyz

         j = jacmi(i,e)

         sij(i,1,e) = j*  ! du/dx + du/dx
     $   2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e)+ut(i)*txm1(i,1,1,e))

         sij(i,2,e) = j*  ! dv/dy + dv/dy
     $   2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e)+vt(i)*tym1(i,1,1,e))

         sij(i,3,e) = j*  ! dw/dz + dw/dz
     $   2*(wr(i)*rzm1(i,1,1,e)+ws(i)*szm1(i,1,1,e)+wt(i)*tzm1(i,1,1,e))

         sij(i,4,e) = j*  ! du/dy + dv/dx
     $   (ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e)+ut(i)*tym1(i,1,1,e) +
     $    vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e)+vt(i)*txm1(i,1,1,e) )

         sij(i,5,e) = j*  ! dv/dz + dw/dy
     $   (wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e)+wt(i)*tym1(i,1,1,e) +
     $    vr(i)*rzm1(i,1,1,e)+vs(i)*szm1(i,1,1,e)+vt(i)*tzm1(i,1,1,e) )

         sij(i,6,e) = j*  ! du/dz + dw/dx
     $   (ur(i)*rzm1(i,1,1,e)+us(i)*szm1(i,1,1,e)+ut(i)*tzm1(i,1,1,e) +
     $    wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e)+wt(i)*txm1(i,1,1,e) )

        enddo
       enddo

      elseif (ifaxis) then  ! AXISYMMETRIC CASE  

c
c        Notation:                       ( 2  x  Acheson, p. 353)
c                     Cylindrical
c            Nek5k    Coordinates
c
c              x          z
c              y          r
c              z          theta
c

         do e=1,nelv
            call setaxdy ( ifrzer(e) )  ! change dytm1 if on-axis
            call local_grad2(ur,us,u,N,e,dxm1,dytm1)
            call local_grad2(vr,vs,v,N,e,dxm1,dytm1)
            call local_grad2(wr,ws,w,N,e,dxm1,dytm1)

            do i=1,nxyz
               j = jacmi(i,e)
               r = ym1(i,1,1,e)                              ! Cyl. Coord:

               sij(i,1,e) = j*  ! du/dx + du/dx              ! e_zz
     $           2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e))

               sij(i,2,e) = j*  ! dv/dy + dv/dy              ! e_rr
     $           2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))

               if (r.gt.0) then                              ! e_@@
                  sij(i,3,e) = v(i,e)/r  ! v / r 
               else
                  sij(i,3,e) = j*  ! L'Hopital's rule: e_@@ = dv/dr
     $            2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))
               endif

               sij(i,4,e) = j*  ! du/dy + dv/dx             ! e_zr
     $            ( ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e) +
     $              vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e) )

               if (r.gt.0) then                             ! e_r@
                  sij(i,5,e) = j*  ! dw/dy 
     $              ( wr(i)*rym1(i,1,1,e)+ws(i)*sym1(i,1,1,e) )
     $              - w(i,e) / r
               else
                  sij(i,5,e) = 0
               endif

               sij(i,6,e) = j*  ! dw/dx                     ! e_@z
     $            ( wr(i)*rxm1(i,1,1,e)+ws(i)*sxm1(i,1,1,e) )

            enddo
         enddo

      else              ! 2D CASE

         do e=1,nelv
            call local_grad2(ur,us,u,N,e,dxm1,dxtm1)
            call local_grad2(vr,vs,v,N,e,dxm1,dxtm1)

            do i=1,nxyz
               j = jacmi(i,e)

               sij(i,1,e) = j*  ! du/dx + du/dx
     $           2*(ur(i)*rxm1(i,1,1,e)+us(i)*sxm1(i,1,1,e))

               sij(i,2,e) = j*  ! dv/dy + dv/dy
     $           2*(vr(i)*rym1(i,1,1,e)+vs(i)*sym1(i,1,1,e))

               sij(i,3,e) = j*  ! du/dy + dv/dx
     $           (ur(i)*rym1(i,1,1,e)+us(i)*sym1(i,1,1,e) +
     $            vr(i)*rxm1(i,1,1,e)+vs(i)*sxm1(i,1,1,e) )

            enddo
         enddo
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine auto_averager(fname127) ! simple average of files

c     This routine reads files specificed of file.list and averages
c     them with uniform weight
c
c     Note that it relies on scravg and scruz common blocks. pff 12/7/14
c

      include 'SIZE'
      include 'TOTAL'

      character*127 fname127
      character*1   f1(127)

      parameter (lt=lx1*ly1*lz1*lelt)
      common /scravg/ ua(lt),va(lt),wa(lt),pa(lt)
      common /scrsf/  ta(lt,ldimt)

      character*1 s1(127)
      equivalence (s1,initc) ! equivalence to initial condition

      if (nid.eq.0) then
         ib=indx1(fname127,' ',1)-1
         call chcopy(f1,fname127,ib)
         write(6,2) (f1(k),k=1,ib)
    2    format('Open file: ',127a1)
      endif

      ierr = 0
      if (nid.eq.0) open(77,file=fname127,status='old',err=199)
      ierr = iglmax(ierr,1)
      if (ierr.gt.0) goto 199
      n = lx1*ly1*lz1*nelt
      n2= lx2*ly2*lz2*nelt

      call rzero (ua,n)
      call rzero (va,n)
      call rzero (wa,n)
      call rzero (pa,n2)
      do k=1,npscal+1
         call rzero (ta(1,k),n)
      enddo

      icount = 0
      do ipass=1,9999999

         call blank(initc,127)
         initc(1) = 'done '
         if (nid.eq.0) read(77,127,end=998) initc(1)
  998    call bcast(initc,127)
  127    format(a127)

         iblank = indx1(initc,' ',1)-1
         if (nio.eq.0) write(6,1) ipass,(s1(k),k=1,iblank)
    1    format(i8,'Reading: ',127a1)

         if (indx1(initc,'done ',5).eq.0) then ! We're not done

            nfiles = 1
            call restart(nfiles)  ! Note -- time is reset.

            call opadd2 (ua,va,wa,vx,vy,vz)
            call add2   (pa,pr,n2)
            do k=1,npscal+1
               call add2(ta(1,k),t(1,1,1,1,k),n)
            enddo
            icount = icount+1

         else
            goto 999
         endif

      enddo

  999 continue  ! clean up averages
      if (nid.eq.0) close(77)

      scale = 1./icount
      call cmult2(vx,ua,scale,n)
      call cmult2(vy,va,scale,n)
      call cmult2(vz,wa,scale,n)
      call cmult2(pr,pa,scale,n2)
      do k=1,npscal+1
         call cmult2(t(1,1,1,1,k),ta(1,k),scale,n)
      enddo
      return

  199 continue ! exception handle for file not found
      ierr = 1
      if (nid.eq.0) ierr = iglmax(ierr,1)
      call exitti('Auto averager did not find list file.$',ierr)

      return
      end
c-----------------------------------------------------------------------
      subroutine outmesh
      include 'SIZE'
      include 'TOTAL'
      integer e,eg

      common /cmesh/ xt(2**ldim,ldim)

      len = wdsize*ldim*(2**ldim)

      if (nid.eq.0) open(unit=29,file='rea.new')

      do eg=1,nelgt
         call nekgsync()          !  belt
         jnid = gllnid(eg)
         e    = gllel (eg)
         mtype = e
         if (jnid.eq.0 .and. nid.eq.0) then
            call get_el(xt,xm1(1,1,1,e),ym1(1,1,1,e),zm1(1,1,1,e))
            call out_el(xt,eg)
         elseif (nid.eq.0) then
            call crecv2(mtype,xt,len,jnid)
            call out_el(xt,eg)
         elseif (jnid.eq.nid) then
            call get_el(xt,xm1(1,1,1,e),ym1(1,1,1,e),zm1(1,1,1,e))
            call csend(mtype,xt,len,0,0)
         endif
         call nekgsync()          !  suspenders
      enddo

      if (nid.eq.0) close(29)
      call nekgsync()
      call exitt

      return
      end
c-----------------------------------------------------------------------
      subroutine out_el(xt,e)
      include 'SIZE'
      include 'TOTAL'

      real xt(2**ldim,ldim)
      integer e

      integer ed(8)
      save    ed
      data    ed  / 1,2,4,3 , 5,6,8,7 /

      write(29,1) e
      write(29,2) ((xt(ed(k),j),k=1,4),j=1,ldim)
      write(29,2) ((xt(ed(k),j),k=5,8),j=1,ldim)

    1 format(12x,'ELEMENT',i6,' [    1 ]    GROUP     0')
    2 format(1p4e18.10)

      return
      end
c-----------------------------------------------------------------------
      subroutine get_el(xt,x,y,z)
      include 'SIZE'
      include 'TOTAL'

      real xt(2**ldim,ldim)
      real x(lx1,ly1,lz1),y(lx1,ly1,lz1),z(lx1,ly1,lz1)

      l = 0
      do k=1,lz1,max(lz1-1,1)
      do j=1,ly1,ly1-1
      do i=1,lx1,lx1-1
         l = l+1
         xt(l,1) = x(i,j,k)
         xt(l,2) = y(i,j,k)
         xt(l,3) = z(i,j,k)
      enddo
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine shear_calc_max(strsmx,scale,x0,ifdout,iftout)
c
c     Compute maximum shear stress on objects
c
c     Scale is a user-supplied multiplier so that results may be
c     scaled to any convenient non-dimensionalization.
c
c
      INCLUDE 'SIZE'  
      INCLUDE 'TOTAL' 

      real    strsmx(maxobj),x0(3),w1(0:maxobj)
      logical ifdout,iftout

      common /cvflow_r/ flow_rate,base_flow,domain_length,xsec
     $                , scale_vf(3)


      common /scrns/         sij (lx1*ly1*lz1*6*lelv)
      common /scrcg/         pm1 (lx1,ly1,lz1,lelv)
      common /scrsf/         xm0(lx1,ly1,lz1,lelt)
     $,                      ym0(lx1,ly1,lz1,lelt)
     $,                      zm0(lx1,ly1,lz1,lelt)

      parameter (lr=lx1*ly1*lz1)
      common /scruz/         ur(lr),us(lr),ut(lr)
     $                     , vr(lr),vs(lr),vt(lr)
     $                     , wr(lr),ws(lr),wt(lr)


      n = lx1*ly1*lz1*nelv

      call mappr(pm1,pr,xm0,ym0) ! map pressure onto Mesh 1

c    Add mean_pressure_gradient.X to p:

      if (param(55).ne.0) then
         dpdx_mean = -scale_vf(1)
         dpdy_mean = -scale_vf(2)
         dpdz_mean = -scale_vf(3)
      endif

      call add2s2(pm1,xm1,dpdx_mean,n)  ! Doesn't work if object is cut by 
      call add2s2(pm1,ym1,dpdy_mean,n)  ! periodicboundary.  In this case,
      call add2s2(pm1,zm1,dpdz_mean,n)  ! set ._mean=0 and compensate in
c
c    Compute sij
c
      nij = 3
      if (if3d.or.ifaxis) nij=6
      call comp_sij(sij,nij,vx,vy,vz,ur,us,ut,vr,vs,vt,wr,ws,wt)
c
c
c     Fill up viscous array w/ default
c
      if (istep.lt.1) call cfill(vdiff,param(2),n)
c
      call cadd2(xm0,xm1,-x0(1),n)
      call cadd2(ym0,ym1,-x0(2),n)
      call cadd2(zm0,zm1,-x0(3),n)
c
      x1min=glmin(xm0(1,1,1,1),n)
      x2min=glmin(ym0(1,1,1,1),n)
      x3min=glmin(zm0(1,1,1,1),n)
c
      x1max=glmax(xm0(1,1,1,1),n)
      x2max=glmax(ym0(1,1,1,1),n)
      x3max=glmax(zm0(1,1,1,1),n)
c
      call rzero(strsmx,maxobj)

      ifield = 1

      strsmx(ii) = 0.
      do iobj = 1,nobj
         memtot = nmember(iobj)
      do mem  = 1,memtot
         ieg   = object(iobj,mem,1)
         ifc   = object(iobj,mem,2)
         if (gllnid(ieg).eq.nid) then ! this processor has a contribution
            ie = gllel(ieg)
            call get_strsmax(strsmxl,xm0,ym0,zm0,sij,pm1,vdiff,ifc,ie)
            call cmult(strsmxl,scale,1)
            strsmx(ii)=max(strsmx(ii),strsmxl)
         endif
      enddo
      enddo
c
c     Max contributions over all processors
c
      call gop(strsmx,w1,'M  ',maxobj)

      return
      end
c-----------------------------------------------------------------------
      subroutine get_strsmax(strsmax,xm0,ym0,zm0,sij,pm1,visc,f,e)
c
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'TOPOL'
      INCLUDE 'TSTEP'
c
      real dgtq(3,4)
      real xm0 (lx1,ly1,lz1,lelt)
      real ym0 (lx1,ly1,lz1,lelt)
      real zm0 (lx1,ly1,lz1,lelt)
      real sij (lx1,ly1,lz1,3*ldim-3,lelv)
      real pm1 (lx1,ly1,lz1,lelv)
      real visc(lx1,ly1,lz1,lelv)

      integer f,e,pf
      real    n1,n2,n3

      call dsset(lx1,ly1,lz1)    ! set up counters
      pf     = eface1(f)         ! convert from preproc. notation
      js1    = skpdat(1,pf)
      jf1    = skpdat(2,pf)
      jskip1 = skpdat(3,pf)
      js2    = skpdat(4,pf)
      jf2    = skpdat(5,pf)
      jskip2 = skpdat(6,pf)

      if (if3d.or.ifaxis) then
         i       = 0
         strsmax = 0
         do j2=js2,jf2,jskip2
         do j1=js1,jf1,jskip1
            i = i+1
            n1 = unx(i,1,f,e)
            n2 = uny(i,1,f,e)
            n3 = unz(i,1,f,e)
c
            v  = visc(j1,j2,1,e)
c
            s11 = sij(j1,j2,1,1,e)
            s21 = sij(j1,j2,1,4,e)
            s31 = sij(j1,j2,1,6,e)
c
            s12 = sij(j1,j2,1,4,e)
            s22 = sij(j1,j2,1,2,e)
            s32 = sij(j1,j2,1,5,e)

            s13 = sij(j1,j2,1,6,e)
            s23 = sij(j1,j2,1,5,e)
            s33 = sij(j1,j2,1,3,e)

            stress1 = -v*(s11*n1 + s12*n2 + s13*n3) ! viscous drag
            stress2 = -v*(s21*n1 + s22*n2 + s23*n3)
            stress3 = -v*(s31*n1 + s32*n2 + s33*n3)

            strsnrm = stress1*stress1+stress2*stress2+stress3*stress3
            strsmax = max(strsmax,strsnrm)

         enddo
         enddo

      else ! 2D

         i       = 0
         strsmax = 0
         do j2=js2,jf2,jskip2
         do j1=js1,jf1,jskip1
            i = i+1
            n1 = unx(i,1,f,e)*area(i,1,f,e)
            n2 = uny(i,1,f,e)*area(i,1,f,e)
            v  = visc(j1,j2,1,e)

            s11 = sij(j1,j2,1,1,e)
            s12 = sij(j1,j2,1,3,e)
            s21 = sij(j1,j2,1,3,e)
            s22 = sij(j1,j2,1,2,e)

            stress1 = -v*(s11*n1 + s12*n2) ! viscous drag
            stress2 = -v*(s21*n1 + s22*n2)

            strsnrm = stress1*stress1+stress2*stress2
            strsmax = max(strsmax,strsnrm)

       enddo
       enddo

      endif

      if (strsmax.gt.0) strsmax = sqrt(strsmax)

      return
      end
c-----------------------------------------------------------------------
      subroutine fix_geom ! fix up geometry irregularities

      include 'SIZE'
      include 'TOTAL'

      parameter (lt = lx1*ly1*lz1)
      common /scrns/ xb(lt,lelt),yb(lt,lelt),zb(lt,lelt)
      common /scruz/ tmsk(lt,lelt),tmlt(lt,lelt),w1(lt),w2(lt)

      integer e,f
      character*3 cb

      n      = lx1*ly1*lz1*nelt
      nxyz   = lx1*ly1*lz1
      nfaces = 2*ldim
      ifield = 1 ! velocity field
      if (nelgv.ne.nelgt .or. .not.ifflow) ifield = 2 ! temperature field

      call rone  (tmlt,n)
      call dssum (tmlt,lx1,ly1,lz1)  ! denominator

      call rone  (tmsk,n)
      do e=1,nelt                ! fill mask where bc is periodic
      do f=1,nfaces              ! so we don't translate periodic bcs (z only)
         cb =cbc(f,e,ifield)
         if (cb.eq.'P  ') call facev (tmsk,e,f,0.0,lx1,ly1,lz1)
      enddo
      enddo
      call dsop(tmsk,'*  ',lx1,ly1,lz1)
      call dsop(tmsk,'*  ',lx1,ly1,lz1)
      call dsop(tmsk,'*  ',lx1,ly1,lz1)

      do kpass = 1,ldim+1   ! This doesn't work for 2D, yet.
                            ! Extra pass is just to test convergence

c        call opcopy (xb,yb,zb,xm1,ym1,zm1) ! Must use WHOLE field,
c        call opdssum(xb,yb,zb)             ! not just fluid domain.
         call copy   (xb,xm1,n)
         call copy   (yb,ym1,n)
         call copy   (zb,zm1,n)
         call dssum  (xb,lx1,ly1,lz1)
         call dssum  (yb,lx1,ly1,lz1)
         call dssum  (zb,lx1,ly1,lz1)

         xm = 0.
         ym = 0.
         zm = 0.

         do e=1,nelt
            do i=1,nxyz                       ! compute averages of geometry
               s     = 1./tmlt(i,e)
               xb(i,e) = s*xb(i,e)
               yb(i,e) = s*yb(i,e)
               zb(i,e) = s*zb(i,e)

               xb(i,e) = xb(i,e) - xm1(i,1,1,e)   ! local displacements
               yb(i,e) = yb(i,e) - ym1(i,1,1,e)
               zb(i,e) = zb(i,e) - zm1(i,1,1,e)
               xb(i,e) = xb(i,e)*tmsk(i,e)
               yb(i,e) = yb(i,e)*tmsk(i,e)
               zb(i,e) = zb(i,e)*tmsk(i,e)

               xm = max(xm,abs(xb(i,e)))
               ym = max(ym,abs(yb(i,e)))
               zm = max(zm,abs(zb(i,e)))
            enddo

            if (kpass.le.ldim) then
               call gh_face_extend(xb(1,e),zgm1,lx1,kpass,w1,w2)
               call gh_face_extend(yb(1,e),zgm1,lx1,kpass,w1,w2)
               call gh_face_extend(zb(1,e),zgm1,lx1,kpass,w1,w2)
            endif

         enddo

         if (kpass.le.ldim) then
            call add2(xm1,xb,n)
            call add2(ym1,yb,n)
            call add2(zm1,zb,n)
         endif
         
         xx = glamax(xb,n)
         yx = glamax(yb,n)
         zx = glamax(zb,n)

         xm = glmax(xm,1)
         ym = glmax(ym,1)
         zm = glmax(zm,1)

         if (nio.eq.0) write(6,1) xm,ym,zm,xx,yx,zx,kpass
    1    format(1p6e12.4,' xyz repair',i2)

      enddo

      param(59) = 1.       ! ifdef = .true.
      call geom_reset(1)   ! reset metrics, etc.
      
      return
      end
c-----------------------------------------------------------------------
      subroutine gh_face_extend(x,zg,n,gh_type,e,v)
      include 'SIZE'

      real x(1),zg(1),e(1),v(1)
      integer gh_type

      if (ldim.eq.2) then
         call gh_face_extend_2d(x,zg,n,gh_type,e,v)
      else
         call gh_face_extend_3d(x,zg,n,gh_type,e,v)
      endif
      
      return
      end
c-----------------------------------------------------------------------
      subroutine gh_face_extend_2d(x,zg,n,gh_type,e,v)
c
c     Extend 2D faces into interior via gordon hall
c
c     gh_type:  1 - vertex only
c               2 - vertex and faces
c
c
      real x(n,n)
      real zg(n)
      real e(n,n)
      real v(n,n)
      integer gh_type
c
c     Build vertex interpolant
c
      ntot=n*n
      call rzero(v,ntot)
      do jj=1,n,n-1
      do ii=1,n,n-1
         do j=1,n
         do i=1,n
            si     = 0.5*((n-ii)*(1-zg(i))+(ii-1)*(1+zg(i)))/(n-1)
            sj     = 0.5*((n-jj)*(1-zg(j))+(jj-1)*(1+zg(j)))/(n-1)
            v(i,j) = v(i,j) + si*sj*x(ii,jj)
         enddo
         enddo
      enddo
      enddo
      if (gh_type.eq.1) then
         call copy(x,v,ntot)
         return
      endif


c     Extend 4 edges
      call rzero(e,ntot)
c
c     x-edges
c
      do jj=1,n,n-1
         do j=1,n
         do i=1,n
            hj     = 0.5*((n-jj)*(1-zg(j))+(jj-1)*(1+zg(j)))/(n-1)
            e(i,j) = e(i,j) + hj*(x(i,jj)-v(i,jj))
         enddo
         enddo
      enddo
c
c     y-edges
c
      do ii=1,n,n-1
         do j=1,n
         do i=1,n
            hi     = 0.5*((n-ii)*(1-zg(i))+(ii-1)*(1+zg(i)))/(n-1)
            e(i,j) = e(i,j) + hi*(x(ii,j)-v(ii,j))
         enddo
         enddo
      enddo

      call add3(x,e,v,ntot)

      return
      end
c-----------------------------------------------------------------------
      subroutine gh_face_extend_3d(x,zg,n,gh_type,e,v)
c
c     Extend faces into interior via gordon hall
c
c     gh_type:  1 - vertex only
c               2 - vertex and edges
c               3 - vertex, edges, and faces
c
c
      real x(n,n,n)
      real zg(n)
      real e(n,n,n)
      real v(n,n,n)
      integer gh_type
c
c     Build vertex interpolant
c
      ntot=n*n*n
      call rzero(v,ntot)
      do kk=1,n,n-1
      do jj=1,n,n-1
      do ii=1,n,n-1
         do k=1,n
         do j=1,n
         do i=1,n
            si       = 0.5*((n-ii)*(1-zg(i))+(ii-1)*(1+zg(i)))/(n-1)
            sj       = 0.5*((n-jj)*(1-zg(j))+(jj-1)*(1+zg(j)))/(n-1)
            sk       = 0.5*((n-kk)*(1-zg(k))+(kk-1)*(1+zg(k)))/(n-1)
            v(i,j,k) = v(i,j,k) + si*sj*sk*x(ii,jj,kk)
         enddo
         enddo
         enddo
      enddo
      enddo
      enddo
      if (gh_type.eq.1) then
         call copy(x,v,ntot)
         return
      endif
c
c
c     Extend 12 edges
      call rzero(e,ntot)
c
c     x-edges
c
      do kk=1,n,n-1
      do jj=1,n,n-1
         do k=1,n
         do j=1,n
         do i=1,n
            hj       = 0.5*((n-jj)*(1-zg(j))+(jj-1)*(1+zg(j)))/(n-1)
            hk       = 0.5*((n-kk)*(1-zg(k))+(kk-1)*(1+zg(k)))/(n-1)
            e(i,j,k) = e(i,j,k) + hj*hk*(x(i,jj,kk)-v(i,jj,kk))
         enddo
         enddo
         enddo
      enddo
      enddo
c
c     y-edges
c
      do kk=1,n,n-1
      do ii=1,n,n-1
         do k=1,n
         do j=1,n
         do i=1,n
            hi       = 0.5*((n-ii)*(1-zg(i))+(ii-1)*(1+zg(i)))/(n-1)
            hk       = 0.5*((n-kk)*(1-zg(k))+(kk-1)*(1+zg(k)))/(n-1)
            e(i,j,k) = e(i,j,k) + hi*hk*(x(ii,j,kk)-v(ii,j,kk))
         enddo
         enddo
         enddo
      enddo
      enddo
c
c     z-edges
c
      do jj=1,n,n-1
      do ii=1,n,n-1
         do k=1,n
         do j=1,n
         do i=1,n
            hi       = 0.5*((n-ii)*(1-zg(i))+(ii-1)*(1+zg(i)))/(n-1)
            hj       = 0.5*((n-jj)*(1-zg(j))+(jj-1)*(1+zg(j)))/(n-1)
            e(i,j,k) = e(i,j,k) + hi*hj*(x(ii,jj,k)-v(ii,jj,k))
         enddo
         enddo
         enddo
      enddo
      enddo
c
      call add2(e,v,ntot)
c
      if (gh_type.eq.2) then
         call copy(x,e,ntot)
         return
      endif
c
c     Extend faces
c
      call rzero(v,ntot)
c
c     x-edges
c
      do ii=1,n,n-1
         do k=1,n
         do j=1,n
         do i=1,n
            hi       = 0.5*((n-ii)*(1-zg(i))+(ii-1)*(1+zg(i)))/(n-1)
            v(i,j,k) = v(i,j,k) + hi*(x(ii,j,k)-e(ii,j,k))
         enddo
         enddo
         enddo
      enddo
c
c     y-edges
c
      do jj=1,n,n-1
         do k=1,n
         do j=1,n
         do i=1,n
            hj       = 0.5*((n-jj)*(1-zg(j))+(jj-1)*(1+zg(j)))/(n-1)
            v(i,j,k) = v(i,j,k) + hj*(x(i,jj,k)-e(i,jj,k))
         enddo
         enddo
         enddo
      enddo
c
c     z-edges
c
      do kk=1,n,n-1
         do k=1,n
         do j=1,n
         do i=1,n
            hk       = 0.5*((n-kk)*(1-zg(k))+(kk-1)*(1+zg(k)))/(n-1)
            v(i,j,k) = v(i,j,k) + hk*(x(i,j,kk)-e(i,j,kk))
         enddo
         enddo
         enddo
      enddo
c
      call add2(v,e,ntot)
      call copy(x,v,ntot)

      return
      end
c-----------------------------------------------------------------------
      function ran1(idum)
c
      integer idum,ia,im,iq,ir,ntab,ndiv
      real    ran1,am,eps,rnmx
c
      parameter (ia=16807,im=2147483647,am=1./im,iq=127773,ir=2836)
      parameter (ntab=32,ndiv=1+(im-1)/ntab,eps=1.2e-7,rnmx=1.-eps)
c
c     Numerical Rec. in Fortran, 2nd eD.  P. 271
c
      integer j,k
      integer iv(ntab),iy
      save    iv,iy
      data    iv,iy /ntab*0,0/
c
      if (idum.le.0.or.iy.eq.0) then
         idum=max(-idum,1)
         do j=ntab+8,1,-1
            k    = idum/iq
            idum = ia*(idum-k*iq)-ir*k
            if(idum.lt.0) idum = idum+im
            if (j.le.ntab) iv(j) = idum
         enddo
         iy = iv(1)
      endif
      k    = idum/iq
      idum = ia*(idum-k*iq)-ir*k
      if(idum.lt.0) idum = idum+im
      j     = 1+iy/ndiv
      iy    = iv(j)
      iv(j) = idum
      ran1  = min(am*iy,rnmx)
c     ran1  = cos(ran1*1.e8)

      return
      end
c-----------------------------------------------------------------------
      subroutine rand_fld_h1(x)

      include 'SIZE'
      real x(1)

      n=lx1*ly1*lz1*nelt
      id = n
      do i=1,n
         x(i) = ran1(id)
      enddo
      call dsavg(x)

      return
      end
c-----------------------------------------------------------------------
      subroutine rescale_x (x,x0,x1)
      include 'SIZE'
      real x(1)

      n = lx1*ly1*lz1*nelt
      xmin = glmin(x,n)
      xmax = glmax(x,n)

      if (xmax.le.xmin) return

      scale = (x1-x0)/(xmax-xmin)
      do i=1,n
         x(i) = x0 + scale*(x(i)-xmin)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine build_filter(f,diag,nx)
      include 'SIZE'

      real f(nx,nx),diag(nx),zpts(nx)

      parameter (lm=4*lx1) ! Totally arbitrary
      parameter (lm2=lm*lm)

      common /cfilt1/ phi,pht,ft,rmult,Lj,gpts,indr,indc,ipiv
      real      phi(lm2),pht(lm2),ft(lm2),rmult(lm),Lj(lm),gpts(lm)
      integer   indr(lm),indc(lm),ipiv(lm)

      integer nxl
      save    nxl
      data    nxl / -9 /

      if (nx.gt.lm) call exitti('ABORT in build_filter:$',nx)

      if (nx.ne.nxl) then

        nxl = nx

        call zwgll (gpts,f,nx)  ! Get nx GLL points

        kj = 0
        n  = nx-1
        do j=1,nx
         z = gpts(j)
         call legendre_poly(Lj,z,n)
         kj = kj+1
         pht(kj) = Lj(1)
         kj = kj+1
         pht(kj) = Lj(2)
         do k=3,nx
            kj = kj+1
            pht(kj) = Lj(k)-Lj(k-2)
         enddo
        enddo

        call transpose (phi,nx,pht,nx)
        call copy      (pht,phi,nx*nx)
        call gaujordf  (pht,nx,nx,indr,indc,ipiv,ierr,rmult)

      endif ! End of save section

      ij=0
      do j=1,nx
      do i=1,nx
         ij = ij+1
         ft(ij) = diag(i)*pht(ij)
      enddo
      enddo
                                          !          -1
      call mxm  (phi,nx,ft,nx,f,nx)       !     V D V

      return
      end
c-----------------------------------------------------------------------
      subroutine g_filter(u,diag,ifld)
c
c     Generalized filter: F(u) with F = J^T D J, where D=diag(diag)
c
      include 'SIZE'
      include 'TOTAL'

      real u(1),diag(1)

      parameter (lxx=lx1*lx1,lxyz=lx1*ly1*lz1)
      common /ctmp0/ f(lxx),wk1(lxyz),wk2(lxyz),wk3(lxyz)

      ifldt = ifield
      ifield = ifld

      call build_filter(f,diag,lx1)
      call filterq(u,f,lx1,lz1,wk1,wk2,wk3,if3d,umax)

      ifield = ifldt

      return
      end
c-----------------------------------------------------------------------
      subroutine cut_off_filter(u,mx,ifld) ! mx=max saved mode
c
c     Generalized filter: F(u) with F = J^T D J, where D=diag(diag)
c
      include 'SIZE'
      include 'TOTAL'

      real u(1)

      parameter (lxx=lx1*lx1,lxyz=lx1*ly1*lz1)
      common /ctmp0/ f(lxx),wk1(lxyz),wk2(lxyz),wk3(lxyz),diag(lx1)

      ifldt = ifield
      ifield = ifld

      call rone(diag,lx1)
      do i=mx+1,lx1
         diag(i)=0.
      enddo

      call build_filter(f,diag,lx1)
      call filterq(u,f,lx1,lz1,wk1,wk2,wk3,if3d,umax)

      ifield = ifldt

      return
      end
c-----------------------------------------------------------------------
      subroutine filter_d2(v,nx,nz,wgt,ifd4)

      include 'SIZE'
      include 'TOTAL'

      parameter (lt=lx1*ly1*lz1)
      real v(lt,nelt)
      logical ifd4

      common /ctmp1/ w(lt,lelt),ur(lt),us(lt),ut(lt),w1(2*lt)

      integer e

      n   = lx1*ly1*lz1*nelt
      nn  = nx-1
      nel = nelfld(ifield)

      bmax = glamax(v,n)

      if (if3d) then
        do e=1,nel
          call local_grad3(ur,us,ut,v(1,e),nn,1,dxm1,dxtm1)
          do i=1,lt
            ur(i) = ur(i)*w3m1(i,1,1)
            us(i) = us(i)*w3m1(i,1,1)
            ut(i) = ut(i)*w3m1(i,1,1)
          enddo
          call local_grad3_t(w(1,e),ur,us,ut,nn,1,dxm1,dxtm1,w1)
        enddo
        call dsavg(w)  !NOTE STILL NEED BC TREATMENT !

        if (ifd4) then
           wght = 20./(lx1**4)
           do e=1,nel
             do i=1,lt
               w(i,e)  = wght*w(i,e)/w3m1(i,1,1)
             enddo
             call local_grad3(ur,us,ut,w(1,e),nn,1,dxm1,dxtm1)
             do i=1,lt
               ur(i) = ur(i)*w3m1(i,1,1)
               us(i) = us(i)*w3m1(i,1,1)
               ut(i) = ut(i)*w3m1(i,1,1)
             enddo
             call local_grad3_t(w(1,e),ur,us,ut,nn,1,dxm1,dxtm1,w1)
           enddo
           call dsavg(w)  !NOTE STILL NEED BC TREATMENT !
        endif

        wght = wgt/(lx1**4)
        do e=1,nel
          do i=1,lt
            v(i,e)  = v(i,e) - wght*w(i,e)/w3m1(i,1,1)
          enddo
        enddo

      else  ! 2D

        do e=1,nel
          call local_grad2(ur,us,v(1,e),nn,1,dxm1,dxtm1)
          do i=1,lt
            ur(i) = ur(i)*w3m1(i,1,1)
            us(i) = us(i)*w3m1(i,1,1)
          enddo
          call local_grad2_t(w(1,e),ur,us,nn,1,dxm1,dxtm1,w1)
        enddo
        call dsavg(w)  !NOTE STILL NEED BC TREATMENT !

        if (ifd4) then
           wght = 200./(lx1**4)
           do e=1,nel
             do i=1,lt
               w(i,e)  = wght*w(i,e)/w3m1(i,1,1)
             enddo
             call local_grad2(ur,us,w(1,e),nn,1,dxm1,dxtm1)
             do i=1,lt
               ur(i) = ur(i)*w3m1(i,1,1)
               us(i) = us(i)*w3m1(i,1,1)
             enddo
             call local_grad2_t(w(1,e),ur,us,nn,1,dxm1,dxtm1,w1)
           enddo
           call dsavg(w)  !NOTE STILL NEED BC TREATMENT !
        endif

        wght = wgt/(lx1**4)
        do e=1,nel
          do i=1,lt
            v(i,e)  = v(i,e) - wght*w(i,e)/w3m1(i,1,1)
          enddo
        enddo

      endif

      vmax = glamax(v,n)
      if (nio.eq.0) write(6,1) istep,time,vmax,bmax,' filter max'
    1 format(i9,1p3e12.4,a11)

      return
      end
c-------------------------------------------------------------------------
      function dist3d(a,b,c,x,y,z)

      d = (a-x)**2 + (b-y)**2 + (c-z)**2

      dist3d = 0.
      if (d.gt.0) dist3d = sqrt(d)

      return
      end
c-----------------------------------------------------------------------
      function dist2d(a,b,x,y)

      d = (a-x)**2 + (b-y)**2

      dist2d = 0.
      if (d.gt.0) dist2d = sqrt(d)

      return
      end
c-----------------------------------------------------------------------
      subroutine domain_size(xmin,xmax,ymin,ymax,zmin,zmax)

      include 'SIZE'
      include 'TOTAL'

      n = lx1*ly1*lz1*nelt

      xmin = glmin(xm1,n)
      xmax = glmax(xm1,n)
      ymin = glmin(ym1,n)
      ymax = glmax(ym1,n)
      if (if3d) then
         zmin = glmin(zm1,n)
         zmax = glmax(zm1,n)
      else
         zmin = 0.
         zmax = 0.
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine cheap_dist(d,ifld,b)

c     Finds a pseudo-distance function.

c     INPUT:  ifld - field type for which distance function is to be found.
c             ifld = 1 for velocity
c             ifld = 2 for temperature, etc.

c     OUTPUT: d = "path" distance to nearest wall

c     This approach has a significant advantage that it works for
c     periodict boundary conditions, whereas most other approaches
c     will not.

      include 'SIZE'
      include 'GEOM'       ! Coordinates
      include 'INPUT'      ! cbc()
      include 'TSTEP'      ! nelfld
      include 'PARALLEL'   ! gather-scatter handle for field "ifld"

      real d(lx1,ly1,lz1,lelt)

      character*3 b  ! Boundary condition of interest

      integer e,eg,f

      nel = nelfld(ifld)
      n = lx1*ly1*lz1*nel

      call domain_size(xmin,xmax,ymin,ymax,zmin,zmax)

      xmn = min(xmin,ymin)
      xmx = max(xmax,ymax)
      if (if3d) xmn = min(xmn ,zmin)
      if (if3d) xmx = max(xmx ,zmax)

      big = 10*(xmx-xmn)
      call cfill(d,big,n)


      nface = 2*ldim
      do e=1,nel     ! Set d=0 on walls
      do f=1,nface
         if (cbc(f,e,ifld).eq.b) call facev(d,e,f,0.,lx1,ly1,lz1)
      enddo
      enddo

      do ipass=1,10000
         dmax    = 0
         nchange = 0
         do e=1,nel
           do k=1,lz1
           do j=1,ly1
           do i=1,lx1
             i0=max(  1,i-1)
             j0=max(  1,j-1)
             k0=max(  1,k-1)
             i1=min(lx1,i+1)
             j1=min(ly1,j+1)
             k1=min(lz1,k+1)
             do kk=k0,k1
             do jj=j0,j1
             do ii=i0,i1

              if (if3d) then
               dtmp = d(ii,jj,kk,e) + dist3d(
     $           xm1(ii,jj,kk,e),ym1(ii,jj,kk,e),zm1(ii,jj,kk,e)
     $          ,xm1(i ,j ,k ,e),ym1(i ,j ,k ,e),zm1(i ,j ,k ,e))
              else
               dtmp = d(ii,jj,kk,e) + dist2d(
     $           xm1(ii,jj,kk,e),ym1(ii,jj,kk,e)
     $          ,xm1(i ,j ,k ,e),ym1(i ,j ,k ,e))
              endif

              if (dtmp.lt.d(i,j,k,e)) then
                d(i,j,k,e) = dtmp
                nchange = nchange+1
                dmax = max(dmax,d(i,j,k,e))
              endif
             enddo
             enddo
             enddo

           enddo
           enddo
           enddo
         enddo
         call fgslib_gs_op(gsh_fld(ifld),d,1,3,0) ! min over all elements
         nchange = iglsum(nchange,1)
         dmax = glmax(dmax,1)
         if (nio.eq.0.and.loglevel.gt.2) write(6,1) ipass,nchange,dmax,b
    1    format(i9,i12,1pe12.4,' max distance b: ',a3)
         if (nchange.eq.0) goto 1000
      enddo
 1000 return
      end
c-----------------------------------------------------------------------
      subroutine distf(d,ifld,b,dmin,emin,xn,yn,zn)

c     Generate a distance function to boundary with bc "b".
c     This approach does not yet work with periodic boundary conditions.

c     INPUT:  ifld - field type for which distance function is to be found.
c             ifld = 1 for velocity
c             ifld = 2 for temperature, etc.

c     OUTPUT: d = distance to nearest boundary with boundary condition "b"

c     Work arrays:  dmin,emin,xn,yn,zn

      include 'SIZE'
      include 'GEOM'       ! Coordinates
      include 'INPUT'      ! cbc()
      include 'TSTEP'      ! nelfld
      include 'PARALLEL'   ! gather-scatter handle for field "ifld"

      real d(lx1,ly1,lz1,lelt)
      character*3 b

      real dmin(lx1,ly1,lz1,lelt),emin(lx1,ly1,lz1,lelt)
      real xn(lx1,ly1,lz1,lelt),yn(lx1,ly1,lz1,lelt)
      real zn(lx1,ly1,lz1,lelt)


      integer e,eg,f

      nel = nelfld(ifld)
      n = lx1*ly1*lz1*nel

      call domain_size(xmin,xmax,ymin,ymax,zmin,zmax)

      xmn = min(xmin,ymin)
      xmx = max(xmax,ymax)
      if (if3d) xmn = min(xmn ,zmin)
      if (if3d) xmx = max(xmx ,zmax)

      big = 10*(xmx-xmn)
      call cfill (d,big,n)

      call opcopy(xn,yn,zn,xm1,ym1,zm1)

      nface = 2*ldim
      do e=1,nel     ! Set d=0 on walls
      do f=1,nface
         if (cbc(f,e,1).eq.b) call facev(d,e,f,0.,lx1,ly1,lz1)
      enddo
      enddo

      nxyz = lx1*ly1*lz1

      do ipass=1,10000
         dmax    = 0
         nchange = 0
         do e=1,nel
            do k=1,lz1
            do j=1,ly1
            do i=1,lx1
              i0=max(  1,i-1)
              j0=max(  1,j-1)
              k0=max(  1,k-1)
              i1=min(lx1,i+1)
              j1=min(ly1,j+1)
              k1=min(lz1,k+1)
              do kk=k0,k1
              do jj=j0,j1
              do ii=i0,i1

               dself  = d(i,j,k,e)
               dneigh = d(ii,jj,kk,e)
               if (dneigh.lt.dself) then  ! check neighbor's nearest point
                  d2 = (xm1(i,j,k,e)-xn(ii,jj,kk,e))**2
     $               + (ym1(i,j,k,e)-yn(ii,jj,kk,e))**2
                  if (if3d) d2 = d2 + (zm1(i,j,k,e)-zn(ii,jj,kk,e))**2
                  if (d2.gt.0) d2 = sqrt(d2)
                  if (d2.lt.dself) then
                    nchange = nchange+1
                    d (i,j,k,e) = d2
                    xn(i,j,k,e) = xn(ii,jj,kk,e)
                    yn(i,j,k,e) = yn(ii,jj,kk,e)
                    zn(i,j,k,e) = zn(ii,jj,kk,e)
                    dmax = max(dmax,d(i,j,k,e))
                  endif
               endif
              enddo
              enddo
              enddo

            enddo
            enddo
            enddo

            re = lglel(e)
            call cfill(emin(1,1,1,e),re,nxyz)
            call copy (dmin(1,1,1,e),d(1,1,1,e),nxyz)

         enddo
         nchange = iglsum(nchange,1)

         call fgslib_gs_op(gsh_fld(ifld),dmin,1,3,0) ! min over all elements


         nchange2=0
         do e=1,nel
         do i=1,nxyz
          if (dmin(i,1,1,e).ne.d(i,1,1,e)) then
             nchange2 = nchange2+1
             emin(i,1,1,e) = 0  ! Flag
          endif
         enddo
         enddo
         call copy(d,dmin,n)                !   Ensure updated distance
         nchange2 = iglsum(nchange2,1)
         nchange  = nchange + nchange2
         call fgslib_gs_op(gsh_fld(ifld),emin,1,4,0) ! max over all elements

         do e=1,nel    ! Propagate nearest wall points
         do i=1,nxyz
          eg = emin(i,1,1,e)
          if (eg.ne.lglel(e)) then
             xn(i,1,1,e) = 0
             yn(i,1,1,e) = 0
             zn(i,1,1,e) = 0
          endif
         enddo
         enddo
         call fgslib_gs_op(gsh_fld(ifld),xn,1,1,0) !   Sum over all elements to
         call fgslib_gs_op(gsh_fld(ifld),yn,1,1,0) !   convey nearest point
         call fgslib_gs_op(gsh_fld(ifld),zn,1,1,0) !   to shared neighbor.

         dmax = glmax(dmax,1)
         if (nio.eq.0) write(6,1) ipass,nchange,dmax
    1    format(i9,i12,1pe12.4,' max wall distance 2')
         if (nchange.eq.0) goto 1000
      enddo
 1000 continue

c     wgt = 0.3
c     call filter_d2(d,lx1,lz1,wgt,.true.)

      return
      end
c-----------------------------------------------------------------------
      subroutine turb_outflow(d,m1,rq,uin)

c     . Set div U > 0 in elements with 'O  ' bc.
c
c     . rq is nominally the ratio of Qout/Qin and is typically 1.5
c
c     . uin is normally zero, unless your flow is zero everywhere 
c
c     . d and m1 are work arrays of size (lx1,ly1,lz1,lelt), assumed persistant
c
c     This routine may or may not work with multiple outlets --- it has
c     not been tested for this case.
c
c
c     TYPICAL USAGE -- ADD THESE LINES TO userchk() in your .usr file:
c                      (uncommented)
c
c     common /myoutflow/ d(lx1,ly1,lz1,lelt),m1(lx1*ly1*lz1,lelt)
c     real m1
c     rq  = 2.
c     uin = 0.
c     call turb_outflow(d,m1,rq,uin)
c

      include 'SIZE'
      include 'TOTAL'

      real d(lx2,ly2,lz2,lelt),m1(lx1*ly1*lz1,lelt)

      parameter (lw = 3*lx1*ly1*lz1)
      common /ctmp1/ w(lw)

      integer icalld,noutf,e,f
      save    icalld,noutf
      data    icalld,noutf /0,0/

      real ddmax,cso
      save ddmax,cso
      logical ifout

      character*3 b

      n     = lx1*ly1*lz1*nelv
      n2    = lx2*ly2*lz2*nelv
      nxyz  = lx1*ly1*lz1
      nxyz2 = lx2*ly2*lz2

      if (icalld.eq.0) then
         icalld = 1

         b = 'O  '
         call cheap_dist(m1,1,b)

         call rzero (d,n2)

         ddmax = 0.
         noutf = 0

         do e=1,nelv
           ifout = .false.
           do f=1,2*ldim
             if (cbc(f,e,1).eq.b) ifout = .true. ! outflow
             if (cbc(f,e,1).eq.b) noutf = noutf+1
           enddo
           if (ifout) then
            if (lx2.lt.lx1) then ! Map distance function to Gauss
             call maph1_to_l2(d(1,1,1,e),lx2,m1(1,e),lx1,if3d,w,lw)
            else
             call copy(d(1,1,1,e),m1(1,e),nxyz)
            endif
            dmax  = vlmax(m1(1,e),nxyz)
            ddmax = max(ddmax,dmax)
            call rzero(m1(1,e),nxyz) ! mask points at outflow
           else
             call rone (m1(1,e),nxyz)
           endif
         enddo

         ddmax = glamax(ddmax,1)

         do e=1,nelv
           ifout = .false.
           do f=1,2*ldim
             if (cbc(f,e,1).eq.b) ifout = .true. ! outflow
           enddo
           if (ifout) then
              do i=1,nxyz2
                d(i,1,1,e) = (ddmax - d(i,1,1,e))/ddmax
              enddo
           endif
         enddo
         noutf = iglsum(noutf,1)
      endif

      if (noutf.eq.0) return

      if (uin.ne.0) then ! Use user-supplied characteristic velocity
         ubar = uin
      else
         ubar = glsc3(vx,bm1,m1,n)   ! Masked average
         vbar = glsc3(vy,bm1,m1,n)
         wbar = glsc3(vz,bm1,m1,n)
         volu = glsc2(bm1,m1,n)
         ubar = abs(ubar)+abs(vbar)
         if (if3d) ubar = abs(ubar)+abs(wbar)
         ubar = ubar/volu
      endif

      cs = 3*(rq-1.)*(ubar/ddmax)
      if (.not.ifsplit) cs = cs*bd(1)/dt

      do i=1,n2
         usrdiv(i,1,1,1) = cs*(d(i,1,1,1)**2)
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine add_temp(f2tbc,nbc,npass)

c     add multiple passive scalar fields (npass new ones)

      include 'SIZE'
      include 'TOTAL'

      character*3 f2tbc(2,nbc)

      do i=1,npass
         call add_temp_1(f2tbc,nbc)
      enddo

      igeom = 2
      call setup_topo  ! Set gs handles and multiplicity

      return
      end
c-----------------------------------------------------------------------
      subroutine add_temp_1(f2tbc,nbc)

c
c     TYPICAL USAGE:  Add the below to usrdat().
c
c     parameter (lbc=10) ! Maximum number of bc types
c     character*3 f2tbc(2,lbc)
c
c     f2tbc(1,1) = 'W  '   ! Any 'W  ' bc is swapped to ft2bc(2,1)
c     f2tbc(2,1) = 'I  '
c
c     f2tbc(1,2) = 'v  '   ! Any 'v  ' bc is swapped to ft2bc(2,2)
c     f2tbc(2,2) = 't  '
c
c     nbc = 2      ! Number of boundary condition pairings (e.g., W-->t)
c     do i=1,ldimt-1
c        call add_temp(f2tbc,nbc)
c     enddo

      include 'SIZE'
      include 'TOTAL'
      character*3 f2tbc(2,nbc)

      integer e,f

      nfld=nfield+1

      if (nio.eq.0) write(6,*) 'add temp: ',nfld,nfield,istep

      nelfld(nfld) = nelfld(nfield)
      nel = nelfld(nfield)
      call copy  (bc(1,1,1,nfld),bc(1,1,1,nfield),30*nel)
      call chcopy(cbc(1,1,nfld),cbc(1,1,nfield),3*6*nel)

      do k=1,3
         cpfld(nfld,k)=cpfld(nfield,k)
         call copy (cpgrp(-5,nfld,k),cpgrp(-5,nfield,k),16)
      enddo
      call icopy(matype(-5,nfld),matype(-5,nfield),16)

      param(7) = param(1)  ! rhoCP   = rho
      param(8) = param(2)  ! conduct = dyn. visc

      ifheat          = .true.
      ifadvc(nfld)    = .true.
      iftmsh(nfld)    = .true.
      ifvarp(nfld)    = ifvarp(nfield)
      ifdeal(nfld)    = ifdeal(nfield)
      ifprojfld(nfld) = ldimt_proj.ge.(nfld-1).and.ifprojfld(nfield)

      if (nfld.eq.2) ifto = .true.
      if (nfld.gt.2) ifpsco(nfld-2) = .true.
      if (nfld.gt.2) npscal = npscal+1

      ifldmhd = npscal + 3

      nfield = nfld

      nface = 2*ldim
      do k=1,nbc               ! BC conversion
        do e=1,nelfld(nfld)
        do f=1,nface
          if (cbc(f,e,nfld).eq.f2tbc(1,k)) cbc(f,e,nfld)=f2tbc(2,k)
        enddo
        enddo
      enddo


      return
      end
c-----------------------------------------------------------------------
      subroutine planar_avg(ua,u,hndl)
c
c     Examples:
c
c     ! average field in z and then in x 
c     idir = 3 ! z
c     call gtpp_gs_setup(igs_z,nelx*nely,1,nelz,idir)
c     call planar_avg(uavg_z,u,igs_z)
c     idir = 1 ! x
c     call gtpp_gs_setup(igs_x,nelx,nely,nelz,idir)
c     call planar_avg(uavg_xz,uavg,igs_z)
c    
c     Note, mesh has to be extruded in idir (tensor product)
c 
      include 'SIZE'
      include 'TOTAL'

      real ua(*)
      real u (*)

      common /scrcg/ wrk(lx1*ly1*lz1*lelv)

      n = nx1*ny1*nz1*nelv

      call copy(wrk,bm1,n)              ! Set the averaging weights
      call fgslib_gs_op(hndl,wrk,1,1,0) ! Sum weights
      call invcol1(wrk,n)

      do i=1,n
         ua(i) = bm1(i,1,1,1)*u(i)*wrk(i)
      enddo

      call fgslib_gs_op(hndl,ua,1,1,0) ! Sum weighted values

      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This benchmark is extracted from flush_nolist.1c of OpenMP Application
!Programming Interface Examples Version 4.5.0 .
!We added one critical section to make it a test with only one pair of data races.
!The data race will not generate wrong result though. So the assertion always passes.
!Data race pair:  i@37:13 vs. i@38:15

module DRB074
    use omp_lib
    implicit none
contains
    subroutine f1(q)
        integer :: q
        !$omp critical
        q = 1
        !$omp end critical
        !$omp flush
    end subroutine
end module

program DRB074_flush_orig_yes
    use omp_lib
    use DRB074
    implicit none

    integer :: i, sum
    i = 0
    sum =  0

    !$omp parallel reduction(+:sum) num_threads(10)
    call f1(i)
    sum = sum+i
    !$omp end parallel

    if (sum /= 10) then
        print*,'sum =',sum
    end if
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Race condition due to anti-dependence within a loop offloaded to accelerators.
!Data race pair: a[i]@29 vs. a[i+1]@29

program DRB026_targetparallelfor_orig_yes
    use omp_lib
    implicit none

    integer :: i, len
    integer, dimension(:), allocatable :: a

    len = 1000

    allocate (a(len))

    do i = 1, len
        a(i) = i
    end do

    !$omp target map(a)
        !$omp parallel do
        do i = 1, len-1
            a(i) = a(i+1) + 1
        end do
        !$omp end parallel do
    !$omp end target

    do i = 1, len
        write(6,*) 'Values for i and a(i) are:', i, a(i)
    end do

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The workshare construct is only available in Fortran. The workshare spreads work across the threads 
!executing the parallel. There is an implicit barrier. The nowait nullifies this barrier and hence
!there is a race at line:29 due to nowait at line:26. Data Race Pairs, AA@25:9 and AA@29:!5.


program DRB169_workshare_orig_yes 
    use omp_lib
    implicit none
 
    integer :: AA, BB, CC, res
  
    BB = 1
    CC = 2

    !$omp parallel
        !$omp workshare
        AA = BB
        AA = AA+CC
        !$omp end workshare nowait
    
        !$omp workshare
        res = AA*2
        !$omp end workshare
    !$omp end parallel

    if (res /= 6) then 
        print*,res
    end if
end program

      PROGRAM MAIN
      INTEGER NUMERATOR, DENOMINATOR, RESULT
      NUMERATOR = 1
      DENOMINATOR = 0
      RESULT = NUMERATOR / DENOMINATOR !It is obviously a divide-by-zero.
      END
      

      

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!This program has data races due to true dependence within the loop at 63.
!Data race pair: a[i+1]@27 vs. a[i]@27

program DRB029_truedep1_orig_yes
    use omp_lib
    implicit none

    integer :: i, len
    integer, dimension(:), allocatable :: a

    len = 100
    allocate (a(len))

    do i = 1, len
        a(i) = i
    end do

    !$omp parallel do
    do i = 1, len-1
        a(i+1) = a(i)+1
    end do
    !$omp end parallel do

    print 100, a(50)
    100 format ('a(50)=',i3)

    deallocate(a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Concurrent access of var@30:13 without acquiring locks causes atomicity violation. Data race present.
!Data Race Pairs, var@30:13 and var@30:22.

module DRB163
    integer :: var(16)
    integer :: i, j
end module

program DRB163_simdmissinglock1_orig_gpu_no
    use omp_lib
    use DRB163
    implicit none

    do i = 1, 16
        var(i) = 0
    end do

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do
    do i = 1, 20
        !$omp simd
        do j = 1, 16
            var(j) = var(j)+1
        end do
        !$omp end simd
    end do
    !$omp end teams distribute parallel do
    !$omp end target

    print*,var(16)

end program

      subroutine makeq_aux

      include 'SIZE'
      include 'TOTAL'

      logical  if_conv_std

      if_conv_std = .true.
      if (ifmhd.and.ifaxis) if_conv_std = .false. ! conv. treated in induct.f

      if (if_conv_std) call makeuq ! this will zero bq first

      if (ifdp0dt .and.  ifield.eq.2 .and. .not.ifcvfld(ifield)) then
            dd = dp0thdt * (gamma0 - 1.)/gamma0
            ntot = nx1*ny1*nz1*nelv
            call add2s2 (bq(1,1,1,1,ifield-1),bm1,dd,ntot) 
      endif

      if(filterType.eq.2) call make_hpf
    
      return
      end

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Only the outmost loop can be parallelized in this program.
!Data race pair: b[i][j]@51:13 vs. b[i][j-1]@51:22

program DRB038_truedepseconddimension_var_yes
    use omp_lib
    implicit none

    integer i, j, n, m, len, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    real, dimension(:,:), allocatable :: b

    len = 1000

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    n = len
    m = len

    allocate (b(len,len))

    do i = 1, n
        !$omp parallel do
        do j = 2, m
            b(i,j) = b(i,j-1)
        end do
        !$omp end parallel do
    end do
!    print 100, b(5,5)
!    100 format ('b(5,5) =', F20.6)

    deallocate(args,b)
end program

! @expect error

pure function cap(x)
  implicit none
  integer, intent(in) :: x
  integer :: y
  integer :: cap
  y = x
  if (10 < y) then
      y = 10
  end if
  cap = y
end function


program main
  implicit none
  integer :: cap
  integer :: x
!$CVL $input
  integer :: n
  !$CVL $assert(cap(2) == 2)
  !$CVL $assert(cap(15) /= 10)
  x = n
  !$CVL $assert(cap(x) <= 10)
end program main

!
!  Copyright (c) 2010-2015 Centre National de la Recherche Scientifique.
!  written by Nathanael Schaeffer (CNRS, ISTerre, Grenoble, France).
!  
!  nathanael.schaeffer@ujf-grenoble.fr
!  
!  This software is governed by the CeCILL license under French law and
!  abiding by the rules of distribution of free software. You can use,
!  modify and/or redistribute the software under the terms of the CeCILL
!  license as circulated by CEA, CNRS and INRIA at the following URL
!  "http://www.cecill.info".
!  
!  The fact that you are presently reading this means that you have had
!  knowledge of the CeCILL license and that you accept its terms.
!  


!! A Fortran example program that performs backward and forward Spherical Harmonic Transforms using SHTns
      PROGRAM SHT_example

      IMPLICIT NONE
! import useful parameters for shtns initialization
      include 'shtns.f'

      integer*4 lmax, mmax, mres
      integer*4 nlat, nphi
      integer*4 nlm
      integer*4 layout
      integer*4 norm
      real*8 eps_polar
      complex*16, allocatable :: Slm(:), Tlm(:)
      real*8, allocatable :: Sh(:,:), Th(:,:)

      integer i,lm, m

! set size of transform
      lmax = 5
      mmax = 2
      mres = 2
      nphi = 6
      nlat = 8

! compute sizes required for arrays.
      call shtns_calc_nlm(nlm, lmax, mmax, mres)
      print*,'NLM=',nlm

! displays information during initialization
      call shtns_verbose(1)

! enable multi-threaded transform (OpenMP) if supported.
      call shtns_use_threads(0)

! init SHT. SHT_PHI_CONTIGUOUS is defined in 'shtns.f'
      layout = SHT_PHI_CONTIGUOUS
      call shtns_init_sh_gauss(layout, lmax, mmax, mres, nlat, nphi)

! alternatively, you can use the two following calls, giving more control on the initialization process,
! namely you can choose a normalization with 'norm' and control the polar optimization
! with 'eps_polar' : from 0 (no optimization) to 1e-6 (agressive optimization).
!      norm = SHT_ORTHONORMAL + SHT_REAL_NORM
!      call shtns_set_size(lmax, mmax, mres, norm)
!      eps_polar = 1.e-10
!      call shtns_precompute(SHT_GAUSS, layout, eps_polar, nlat, nphi)

! display information:
       call shtns_print_cfg()

! allocate memory for spectral and spatial representation
      allocate ( Slm(1:nlm), Tlm(1:nlm) )
      allocate ( Sh(1:nphi,1:nlat), Th(1:nphi,1:nlat) )
      Slm(:) = 0.0

! get index for given l and m
      call shtns_lmidx(lm, 1, 0)
      Slm(lm) = 1.0
      print*
      print*,Slm(:)

      call shtns_sh_to_spat(Slm, Sh)

! print all spatial data
      print*
      do i=1,nphi
        print*,'phi index=',i
        print*,Sh(i,:)
      enddo

      call shtns_spat_to_sh(Sh, Slm)

      print*
      print*,Slm(:)

! print SH data, grouping by m  (shows how to access SH coefficients)
      print*
      do m=0, mres*mmax, mres
        print*,'m=', m
        call shtns_lmidx(lm,m,m)
        print*,Slm(lm : lm+(lmax-m))
      enddo

! Legendre transform (fixed m, no fft):
      m = 1*mres
      call shtns_lmidx(lm, m, m)
      Slm(lm+1) = 1.0
      call shtns_sh_to_spat_ml(m/mres, Slm(lm), Tlm, lmax)
      print*
      print*,'spectral m=', m
      print*,Slm(lm : lm+lmax-m+1)
      print*,'spatial m=', m
      print*,Tlm(1 : nlat)

      stop
      END

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Due to distribute parallel for simd directive at line 23, there is a data race at line 25.
!Data Rae Pairs, var@25:9 and var@25:15

program DRB157_missingorderedsimd_orig_gpu_yes
    use omp_lib
    implicit none

    integer :: var(100)
    integer :: i

    do i = 1, 100
        var(i) = 1
    end do

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do simd safelen(16)
    do i = 17, 100
        var(i) = var(i-16)+1
    end do
    !$omp end teams distribute parallel do simd
    !$omp end target

    print*,var(98)
end program

      real function avm_vdiff(ix,iy,iz,e,c1,ncut)
c
c c1 and ncut a user tuneable control parameters. 
c Set c1 = 1.0 and reduce/increase as much possible/required,
c depending on your application.
c Typically ncut 1 or 2 works well. 
c Note, avoid using lx1 < 6! 
c
      include 'SIZE'
      include 'TOTAL'

      integer ix, iy, iz, e
      real c1, c2
      integer ncut
 
      logical ifcont
      parameter (ifcont=.false.)

      real visc(lx1,ly1,lz1,lelt)
      save visc

      common /SCRMG/ r (lx1*ly1*lz1,lelt),
     $               tx(lx1*ly1*lz1,lelt),
     $               ty(lx1*ly1*lz1,lelt),
     $               tz(lx1*ly1*lz1,lelt)

      parameter (lm=40)
      parameter (lm2=lm*lm)
      real hpf_filter(lm2)
      real hpf_op(lx1*lx1,ldimt1)
      save hpf_op

      integer ibuild(ldimt1)
      save    ibuild

      save    icalld
      data    icalld / 0 /

      real h0,h0max
      real viscc(8,lelt)

      if (ix*iy*iz*e .ne. 1) then ! use cache
         avm_vdiff = visc(ix,iy,iz,e)
         return
      endif

      if (icalld.eq.0) then
         iffilter(ifield) = .false.
         do i = 1,ldimt1
            ibuild(i) = 0
         enddo
         icalld = 1
      endif

      nxyz = lx1*ly1*lz1
      n    = nxyz*nelv
      c2   = 0.5

      ! compute residual
      if (ifield.eq.1) then
         if (nid.eq.0) write(6,*) 'avm not supported for ifield=1 !'
         call exitt
      else
         if (ibuild(ifield).eq.0) then
           call hpf_trns_fcn(hpf_filter,ncut)
           call build_hpf_mat(hpf_op(1,ifield),hpf_filter,.false.)
           ibuild(ifield) = ibuild(ifield) + 1
         endif
         call build_hpf_fld(r,t(1,1,1,1,ifield-1),hpf_op(1,ifield),
     $                      lx1,lz1)

         psave = param(99)
         param(99) = 0
         call copy(tx,r,n)
         call convop(r,tx)
         param(99) = psave

         ! normalize
         uavg = gl2norm(t(1,1,1,1,ifield-1),n)
         call cfill(tx,uavg,n)
         call sub2(tx,t(1,1,1,1,ifield-1),n)
         uinf = 1.
         if(uavg.gt.0) uinf = glamax(tx, n)
      endif

      ! evaluate arificial viscosity
      uinf = 1./uinf
      do ie = 1,nelv
         h0max = vlmax(deltaf(1,1,1,ie),nxyz) 
      do i = 1,nxyz
         h0 = deltaf(i,1,1,ie)
         vmax = sqrt(vx(i,1,1,ie)**2 + vy(i,1,1,ie)**2 
     $               + vz(i,1,1,ie)**2)
         vismax = c2 * h0max * vmax
         visc(i,1,1,ie) = min(vismax, c1*h0**2 * abs(r(i,ie))*uinf)
      enddo
      enddo

      ! make it piecewise constant
      do ie = 1,nelv
         vmax = vlmax(visc(1,1,1,ie),nxyz)
         call cfill(visc(1,1,1,ie),vmax,nxyz)
      enddo

      ! make it P1 continuous
      if (ifcont) then
         call dsop (visc,'max',lx1,ly1,lz1)
         do ie = 1,nelv 
           viscc(1,ie) = visc(1  ,1  ,1  ,ie)
           viscc(2,ie) = visc(lx1,1  ,1  ,ie)
           viscc(3,ie) = visc(1  ,ly1,1  ,ie)
           viscc(4,ie) = visc(lx1,ly1,1  ,ie)

           viscc(5,ie) = visc(1  ,1  ,lz1,ie)
           viscc(6,ie) = visc(lx1,1  ,lz1,ie)
           viscc(7,ie) = visc(1  ,ly1,lz1,ie)
           viscc(8,ie) = visc(lx1,ly1,lz1,ie)
         enddo 
         call map_c_to_f_h1_bilin(visc,viscc)
      endif

      if (mod(istep,10).eq.0) then
        vismx = glamax(visc,n)
        vismn = glamin(visc,n)
        visav = glsc2(visc,bm1,n)/volvm1
        if (nio.eq.0) write(6,10) time,vismx,vismn,visav,ifield
 10     format(1p4e12.4,' AVM',i6)
      endif

      avm_vdiff = visc(ix,iy,iz,e)

      return
      end
c---------------------------------------------------------------
      real function deltaf(ix,iy,iz,iel)
c
c     compute characteristic sgs length scale
c     defined as min of GLL nodes within an elements but many
c     others possible.
c
      include 'SIZE'
      include 'TOTAL'

      real dx(lx1,ly1,lz1,lelt)
      save dx 

      data icalld /0/
      save icalld

      nxyz = nx1*ny1*nz1
      n    = nxyz*nelv

      if (icalld.eq.0 .or. ifmvbd) then
         dinv = 1./ldim
         do ie = 1,nelv
c            volavg = 0
c            do i  = 1,nxyz
c               volavg = volavg + bm1(i,1,1,ie)
c            enddo
c            dd = (volavg**dinv)/(lx1-1)

            dd = dxmin_e(ie)

            call cfill(dx(1,1,1,ie),dd,nxyz) 
         enddo
         icalld = 1
      endif

      deltaf = dx(ix,iy,iz,iel)

      end 

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!The increment operation at line@22:17 is team specific as each team work on their individual var.
!No Data Race Pair

program DRB145_atomiccritical_orig_gpu_no
    use omp_lib
    implicit none

    integer :: var, i
    var = 0

    !$omp target map(tofrom:var) device(0)
    !$omp teams distribute parallel do reduction(+:var)
        do i = 1, 200
            if (var<101) then
                var = var+1
            end if
        end do
    !$omp end teams distribute parallel do
    !$omp end target

end program

       program abs
         implicit none
!$CVL $input
  		 integer :: arg
         integer :: x
!$CVL $assume(-10 .LE. arg .AND. arg .LE. 10);
         x = ABS(arg)
!$CVL $assert(0 .LE. x);
       end program abs

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Loop carried true dep between tmp =..  and ..= tmp.
!Data race pair: tmp@48:16 vs. tmp@49:9

program DRB036_truedepscalar_var_yes
    use omp_lib
    implicit none

    integer i, tmp, len, argCount, allocStatus, rdErr, ix
    character(len=80), dimension(:), allocatable :: args
    integer, dimension(:), allocatable :: a

    len = 100
    tmp = 10

    argCount = command_argument_count()
    if (argCount == 0) then
        write (*,'(a)') "No command line arguments provided."
    end if

    allocate(args(argCount), stat=allocStatus)
    if (allocStatus > 0) then
        write (*,'(a)') "Allocation error, program terminated."
        stop
    end if

    do ix = 1, argCount
        call get_command_argument(ix,args(ix))
    end do

    if (argCount >= 1) then
        read (args(1), '(i10)', iostat=rdErr) len
        if (rdErr /= 0 ) then
            write (*,'(a)') "Error, invalid integer value."
        end if
    end if

    allocate (a(len))

    !$omp parallel do
    do i = 1, len
        a(i) = tmp
        tmp = a(i) + i
    end do
    !$omp end parallel do

    deallocate(args,a)
end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Simplest one dimension array computation. No data race pairs.

program DRB045_doall1_orig_no
    use omp_lib
    implicit none

    integer :: i
    integer :: a(100)

    !$omp parallel do
    do i = 1, 100
        a(i) = a(i)+1
    end do
    !$omp end parallel do

end program

c-----------------------------------------------------------------------
c     Routines for multidomain (neknek) simulations.
c
c     References:
c
c     "A spectrally accurate method for overlapping grid solution of
c     incompressible Navier–Stokes equations" Brandon E. Merrill,
c     Yulia T. Peet, Paul F. Fischer, and James W. Lottes, J. Comp. Phys.
c     307 (2016) 60-93.
c
c     "Stability analysis of interface temporal discretization in grid
c      overlapping methods," Y. Peet, P.F. Fischer, SIAM J. Numer. Anal.
c      50 (6) (2012) 3375–3401.
c-----------------------------------------------------------------------
      subroutine setup_neknek_wts

      include 'SIZE'
      include 'TOTAL'

      ntot1 = lx1*ly1*lz1*nelt
c     Initialize unity partition function to 1
      call rone(upf,ntot1)
      call col3(bm1ms,bm1,upf,ntot1)

      return
      end
c-------------------------------------------------------------
      subroutine neknek_setup

      include 'SIZE'
      include 'TOTAL'
      real dxf,dyf,dzf

      integer icalld
      save    icalld
      data    icalld  /0/

      integer nfld_neknek
      common /inbc/ nfld_neknek

      if (icalld.eq.0.and.nid.eq.0) write(6,*) 'setup neknek'

      if (nsessmax.eq.1) 
     $  call exitti('set nsessmax > 1 in SIZE!$',nsessmax)

      call setup_neknek_wts

      if (icalld.eq.0) then
         ! just in case we call setup from usrdat2 
         call fix_geom
         call geom_reset(1)

         call set_intflag
         call neknekmv
         if (nid.eq.0) write(6,*) 'session id:', idsess
         if (nid.eq.0) write(6,*) 'extrapolation order:', ninter
         if (nid.eq.0) write(6,*) 'nfld_neknek:', nfld_neknek

         nfld_min = iglmin_ms(nfld_neknek,1)
         nfld_max = iglmax_ms(nfld_neknek,1)
         if (nfld_min .ne. nfld_max) then
            nfld_neknek = nfld_min 
            if (nid.eq.0) write(6,*)
     $         'WARNING: reset nfld_neknek to ', nfld_neknek
         endif
      endif

c     Figure out the displacement for the first mesh 
      call setup_int_neknek(dxf,dyf,dzf)  !sets up interpolation for 2 meshes

c     exchange_points finds the processor and element number at
c     comm_world level and displaces the 1st mesh back
      call exchange_points(dxf,dyf,dzf)

      if (icalld.eq.0) then
        if(nio.eq.0) write(6,'(A,/)') ' done :: setup neknek'
        icalld = 1
      endif

      return
      end
c-------------------------------------------------------------
      subroutine set_intflag 
      include 'SIZE'
      include 'TOTAL'
      include 'NEKNEK'
      character*3 cb
      character*2 cb2
      equivalence (cb2,cb)
      integer j,e,f

c     Set interpolation flag: points with boundary condition = 'int' 
c     get intflag=1. 
c
c     Boundary conditions are changed back to 'v' or 't'.

      nfaces = 2*ldim
      
      nflag=nelt*nfaces
      call izero(intflag,nflag)

      do j=1,nfield
         nel = nelfld(j)
      do e=1,nel
      do f=1,nfaces
         cb=cbc(f,e,j)
         if (cb2.eq.'in') then
            intflag(f,e)=1
            if (j.ge.2) cbc(f,e,j)='t  '
            if (j.eq.1) cbc(f,e,j)='v  '
c            if (cb.eq.'inp') cbc(f,e,ifield)='on ' ! Pressure
c            if (cb.eq.'inp') cbc(f,e,ifield)='o  ' ! Pressure
            if (cb.eq.'inp') cbc(f,e,j)='o  ' ! Pressure
         endif
      enddo
      enddo
      enddo

c      zero out valint
       do i=1,nfld_neknek
         call rzero(valint(1,1,1,1,i),lx1*ly1*lz1*nelt)
       enddo

      return
      end
c------------------------------------------------------------------------
      subroutine bcopy
      include 'SIZE'
      include 'TOTAL'
      include 'NEKNEK'
      integer k,i,n

      if (.not.ifneknekc) return

      n    = lx1*ly1*lz1*nelt

      do k=1,nfld_neknek
         call copy(bdrylg(1,k,2),bdrylg(1,k,1),n)
         call copy(bdrylg(1,k,1),bdrylg(1,k,0),n)
         call copy(bdrylg(1,k,0),valint(1,1,1,1,k),n)
      enddo

c     Order of extrpolation is contolled by the parameter NINTER contained 
c     in NEKNEK. First order interface extrapolation, NINTER=1 (time lagging) 
c     is activated. It is unconditionally stable.  If you want to use 
c     higher-order interface extrapolation schemes, you need to increase 
c     ngeom to ngeom=3-5 for scheme to be stable.


      if (NINTER.eq.1.or.istep.eq.1) then
       c0=1.
       c1=0.
       c2=0.
       else if (NINTER.eq.2.or.istep.eq.2) then
         c0=2.
         c1=-1.
         c2=0.
       else 
         c0=3.
         c1=-3.
         c2=1.
      endif

      do k=1,nfld_neknek
      do i=1,n
         valint(i,1,1,1,k) = 
     $      c0*bdrylg(i,k,0)+c1*bdrylg(i,k,1)+c2*bdrylg(i,k,2)
      enddo
      enddo

      return
      end
c---------------------------------------------------------------------
      subroutine chk_outflow ! Assign neighbor velocity to outflow if
                             ! characteristics are going the wrong way.

      include 'SIZE'
      include 'TOTAL'
      include 'NEKUSE'
      include 'NEKNEK'
      integer e,eg,f

      nface = 2*ldim
      do e=1,nelv
      do f=1,nface
         if (cbc(f,e,1).eq.'o  ') then
           eg = lglel(e)
           call facind (i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)
           l=0
           do k=k0,k1
           do j=j0,j1
           do i=i0,i1
              l=l+1
              vo=vx(i,j,k,e)*unx(l,1,f,e)
     $          +vy(i,j,k,e)*uny(l,1,f,e)
     $          +vz(i,j,k,e)*unz(l,1,f,e)
              if (vo.lt.0) then            ! We have inflow
                 cbu = cbc(f,e,1)
                 call userbc(i,j,k,f,eg)
                 vx(i,j,k,e) = ux
                 vy(i,j,k,e) = uy
                 vz(i,j,k,e) = uz
              endif
           enddo
           enddo
           enddo
         endif
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine neknekmv()
      include 'SIZE'
      include 'TOTAL'

      integer imove

      imove=1
      if (ifmvbd) imove=0

      iglmove = iglmin_ms(imove,1)

      if (iglmove.eq.0) then
         ifneknekm=.true.
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine setup_int_neknek(dxf,dyf,dzf)
      include 'SIZE'
      include 'TOTAL'
      include 'NEKUSE'
      include 'NEKNEK'
      include 'mpif.h'

      real dx1,dy1,dz1,dxf,dyf,dzf,mx_glob,mn_glob
      integer i,j,k,n,ntot2,npall
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
c     THIS ROUTINE DISPLACES THE FIRST MESH AND SETUPS THE FINDPTS
c     THE MESH IS DISPLACED BACK TO ORIGINAL POSITION IN EXCH_POINTS

c     Get total number of processors and number of p
      npall = 0
      do i=1,nsessions
       npall = npall+npsess(i-1)
      enddo

c     Get diamter of the domain
      mx_glob = glmax_ms(xm1,lx1*ly1*lz1*nelt)
      mn_glob = glmin_ms(xm1,lx1*ly1*lz1*nelt)
      dx1 = mx_glob-mn_glob

      dxf = 10.+dx1
      dyf = 0.
      dzf = 0.

c     Displace MESH 1
      ntot = lx1*ly1*lz1*nelt
      if (idsess.eq.0) then
         call cadd(xm1,-dxf,ntot)
      endif

c     Setup findpts    
      tol     = 5e-13
      npt_max = 128
      nxf     = 2*lx1 ! fine mesh for bb-test
      nyf     = 2*ly1
      nzf     = 2*lz1
      bb_t    = 0.01 ! relative size to expand bounding boxes by

      if (istep.gt.1) call fgslib_findpts_free(inth_multi2)
      call fgslib_findpts_setup(inth_multi2,mpi_comm_world,npall,ldim,
     &                          xm1,ym1,zm1,lx1,ly1,lz1,
     &                          nelt,nxf,nyf,nzf,bb_t,ntot,ntot,
     &                          npt_max,tol)

      return
      end
c-----------------------------------------------------------------------
      subroutine exchange_points(dxf,dyf,dzf)
      include 'SIZE'
      include 'TOTAL'
      include 'NEKUSE'
      include 'NEKNEK'
      integer i,j,k,n
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
      integer jsend(nmaxl_nn)
      common /exchr/ rsend(ldim*nmaxl_nn)
      integer rcode_all(nmaxl_nn),elid_all(nmaxl_nn)
      integer proc_all(nmaxl_nn)
      real    dist_all(nmaxl_nn)
      real    rst_all(nmaxl_nn*ldim)
      integer e,ip,iface,nel,nfaces,ix,iy,iz
      integer kx1,kx2,ky1,ky2,kz1,kz2,idx,nxyz,nxy
      integer icalld
      save    icalld
      data    icalld /0/

c     Look for boundary points with Diriclet b.c. (candidates for
c     interpolation)

      ifield = 1
      if (ifheat)  ifield   = 2

      nfaces = 2*ldim
      nel    = nelfld(ifield)

      nxyz  = lx1*ly1*lz1
      ntot  = nxyz*nel
      nxy = lx1*ly1
      call izero(imask,ntot)

c     Setup arrays of x,y,zs to send to findpts and indices of boundary 
c     points in jsend
      ip = 0
      if (idsess.eq.0) then
        dxf = -dxf
      endif
      do e=1,nel
      do iface=1,nfaces
         if (intflag(iface,e).eq.1) then
            call facind (kx1,kx2,ky1,ky2,kz1,kz2,lx1,ly1,lz1,iface)
            do iz=kz1,kz2
            do iy=ky1,ky2
            do ix=kx1,kx2
               call nekasgn (ix,iy,iz,e)
               ip=ip+1
               idx = (e-1)*nxyz+(iz-1)*nxy+(iy-1)*lx1+ix
               jsend(ip) = idx 
               if (if3d) then
                 rsend(ldim*(ip-1)+1)=x-dxf
                 rsend(ldim*(ip-1)+2)=y
                 rsend(ldim*(ip-1)+3)=z
               else
                 rsend(ldim*(ip-1)+1)=x-dxf
                 rsend(ldim*(ip-1)+2)=y
               endif

               if (ip.gt.nmaxl_nn) then
                  write(6,*) nid,
     &            ' ABORT: nbp (current ip) too large',ip,nmaxl_nn
                  call exitt
               endif

               imask(idx,1,1,1)=1

            enddo
            enddo
            enddo
         endif
      enddo
      enddo
      nbp = ip

      call neknekgsync()

c     JL's routine to find which points these procs are on
      call fgslib_findpts(inth_multi2,rcode_all,1,
     &                    proc_all,1,
     &                    elid_all,1,
     &                    rst_all,ldim,
     &                    dist_all,1,
     &                    rsend(1),ldim,
     &                    rsend(2),ldim,
     &                    rsend(3),ldim,nbp)

      call neknekgsync()

c     Move mesh 1 back to its original position
      if (idsess.eq.0) then
        call cadd(xm1,-dxf,lx1*ly1*lz1*nelt)
      endif

      ip=0
      icount=0
      ierror=0

c     Make sure rcode_all is fine
      do 200 i=1,nbp

      if (rcode_all(i).lt.2) then

        if (rcode_all(i).eq.1.and.dist_all(i).gt.1e-02) then
           if (ldim.eq.2) write(6,*)
     &     'WARNING: point on boundary or outside the mesh xy[z]d^2: '
           if (ldim.eq.3) write(6,*)
     &     'WARNING: point on boundary or outside the mesh xy[z]d^2: '
           goto 200
         endif
         ip=ip+1
         rcode(ip) = rcode_all(i)
         elid(ip)  = elid_all(i)
         proc(ip)  = proc_all(i)
         do j=1,ldim
           rst(ldim*(ip-1)+j)   = rst_all(ldim*(i-1)+j)
         enddo
         iList(1,ip) = jsend(i)

      endif  !  rcode_all

 200  continue

      ipg = iglsum(ip,1)
      nbpg = iglsum(nbp,1)
      if (nid.eq.0) write(6,*) ipg,nbpg,'interface points' 
      npoints_nn = ip

      ierror = iglmax_ms(ierror,1)
      if (ierror.eq.1) call exitt
 
      return
      end
c-----------------------------------------------------------------------
      subroutine neknek_exchange
      include 'SIZE'
      include 'TOTAL'
      include 'NEKNEK'
      include 'CTIMER'

      parameter (lt=lx1*ly1*lz1*lelt,lxyz=lx1*ly1*lz1)
      common /scrcg/ pm1(lt),wk1(lxyz),wk2(lxyz)

      real fieldout(nmaxl_nn,nfldmax_nn)
      real field(lx1*ly1*lz1*lelt)
      integer nv,nt,i,j,k,n,ie,ix,iy,iz,idx,ifld

      if (nio.eq.0) write(6,98) 
     $   ' Multidomain data exchange ... ', nfld_neknek
 98   format(12x,a,i3)

      etime0 = dnekclock_sync()
      call neknekgsync()
      etime1 = dnekclock()

      call mappr(pm1,pr,wk1,wk2)  ! Map pressure to pm1 
      nv = lx1*ly1*lz1*nelv
      nt = lx1*ly1*lz1*nelt

c     Interpolate using findpts_eval
      call field_eval(fieldout(1,1),1,vx)
      call field_eval(fieldout(1,2),1,vy)
      if (ldim.eq.3) call field_eval(fieldout(1,ldim),1,vz)
      call field_eval(fieldout(1,ldim+1),1,pm1)
      if (nfld_neknek.gt.ldim+1) then 
        do i=ldim+2,nfld_neknek
          call field_eval(fieldout(1,i),1,t(1,1,1,1,i-ldim-1))
        enddo
      endif
         
c     Now we can transfer this information to valint array from which
c     the information will go to the boundary points
       do i=1,npoints_nn
        idx = iList(1,i)
        do ifld=1,nfld_neknek
          valint(idx,1,1,1,ifld)=fieldout(i,ifld)
        enddo
       enddo

      call nekgsync()
      etime = dnekclock() - etime1
      tsync = etime1 - etime0

      if (nio.eq.0) write(6,99) istep,
     $              '  done :: Multidomain data exchange',
     $              etime, etime+tsync
 99   format(i11,a,1p2e13.4)

      return
      end
c--------------------------------------------------------------------------
      subroutine field_eval(fieldout,fieldstride,fieldin)
      include 'SIZE'
      include 'TOTAL'
      include 'NEKNEK'
      real fieldout(1)
      real fieldin(1)
      integer fieldstride

c     Used for findpts_eval of various fields
      call fgslib_findpts_eval(inth_multi2,fieldout,fieldstride,
     &                         rcode,1,
     &                         proc,1,
     &                         elid,1,
     &                         rst,ldim,npoints_nn,
     &                         fieldin)

      return
      end
c--------------------------------------------------------------------------
      subroutine nekneksanchk
      include 'SIZE'
      include 'TOTAL'
      include 'NEKNEK'

      if (nfld_neknek.gt.nfldmax_nn) then
        call exitti('Error: nfld_neknek > nfldmax:$',idsess)
      endif

      if (nfld_neknek.eq.0)
     $ call exitti('Error: set nfld_neknek in usrdat. Session:$',idsess)

      return
      end
C--------------------------------------------------------------------------
      subroutine neknek_xfer_fld(u,ui)
      include 'SIZE'
      include 'TOTAL'
      include 'NEKNEK'
      real fieldout(nmaxl_nn,nfldmax_nn)
      real u(1),ui(1)
      integer nv,nt

      call field_eval(fieldout(1,1),1,u)

c     Now we can transfer this information to valint array from which
c     the information will go to the boundary points
       do i=1,npoints_nn
        idx = iList(1,i)
        ui(idx)=fieldout(i,1)
       enddo
      call neknekgsync()

      return
      end
C--------------------------------------------------------------------------
      subroutine fix_surface_flux
      include 'SIZE'
      include 'TOTAL'
      include 'NEKNEK'
      integer e,f
      common /ctmp1/ work(lx1*ly1*lz1*lelt)
      integer itchk
      common /idumochk/ itchk
      integer icalld
      save    icalld
      data    icalld /0/
c     assume that this routine is called at the end of bcdirvc
c     where all the boundary condition data has been read in for 
c     velocity.
      if (icalld.eq.0) then
       itchk = 0
       do e=1,nelv
       do f=1,2*ldim
         if (cbc(f,e,1).eq.'o  '.or.cbc(f,e,1).eq.'O  ') then
         if (intflag(f,e).eq.0) then
           itchk = 1
         endif
         endif
       enddo
       enddo
       itchk = iglmax(itchk,1)
       icalld = 1
      endif
      if (itchk.eq.1) return
      dqg=0
      aqg=0
      do e=1,nelv
      do f=1,2*ldim
         if (cbc(f,e,1).eq.'v  '.or.cbc(f,e,1).eq.'V  ') then
            call surface_flux_area(dq,aq
     $          ,vx,vy,vz,e,f,work)
            dqg = dqg+dq
            if (intflag(f,e).eq.1) aqg = aqg+aq
         endif
      enddo
      enddo
      dqg=glsum(dqg,1) ! sum over all processors for this session
      aqg=glsum(aqg,1) ! sum over all processors for this session
      gamma = 0.
      if (aqg.gt.0) gamma = -dqg/aqg
c      if (nid.eq.0) write(6,104) idsess,istep,time,dqg,aqg,gamma
c 104  format(i4,i10,1p4e13.4,' NekNek_bdry_flux')
      do e=1,nelv
      do f=1,2*ldim
        if (intflag(f,e).eq.1) then
          call facind (i0,i1,j0,j1,k0,k1,lx1,ly1,lz1,f)
          l=0
          do k=k0,k1
          do j=j0,j1
          do i=i0,i1
            l=l+1
            vx(i,j,k,e) = vx(i,j,k,e) + gamma*unx(l,1,f,e)
            vy(i,j,k,e) = vy(i,j,k,e) + gamma*uny(l,1,f,e)
            if (ldim.eq.3) 
     $      vz(i,j,k,e) = vz(i,j,k,e) + gamma*unz(l,1,f,e)
          enddo
          enddo
          enddo
        endif
      enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine surface_flux_area(dq,aq,qx,qy,qz,e,f,w)
      include 'SIZE'
      include 'GEOM'
      include 'INPUT'
      include 'PARALLEL'
      include 'TOPOL'
      parameter (l=lx1*ly1*lz1)
      real qx(l,1),qy(l,1),qz(l,1),w(lx1,ly1,lz1)
      integer e,f
      call           faccl3  (w,qx(1,e),unx(1,1,f,e),f)
      call           faddcl3 (w,qy(1,e),uny(1,1,f,e),f)
      if (if3d) call faddcl3 (w,qz(1,e),unz(1,1,f,e),f)
      call dsset(lx1,ly1,lz1)
      iface  = eface1(f)
      js1    = skpdat(1,iface)
      jf1    = skpdat(2,iface)
      jskip1 = skpdat(3,iface)
      js2    = skpdat(4,iface)
      jf2    = skpdat(5,iface)
      jskip2 = skpdat(6,iface)
      dq = 0
      aq = 0
      i  = 0
      do 100 j2=js2,jf2,jskip2
      do 100 j1=js1,jf1,jskip1
         i = i+1
         dq    = dq + area(i,1,f,e)*w(j1,j2,1)
         aq    = aq + area(i,1,f,e)
  100 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine rescale_x_ms (x,x0,x1)
      include 'SIZE'
      real x(1)

      n = lx1*ly1*lz1*nelt
      xmin = glmin(x,n)
      xmax = glmax(x,n)
      xming = glmin_ms(x,n)
      xmaxg = glmax_ms(x,n)

      if (xmax.le.xmin) return

      scale = (x1-x0)/(xmaxg-xming)
      x0n = x0 + scale*(xmin-xming)


      do i=1,n
         x(i) = x0n + scale*(x(i)-xmin)
      enddo

      return
      end
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine vol_flow_ms
c
c
c     Adust flow volume at end of time step to keep flow rate fixed by
c     adding an appropriate multiple of the linear solution to the Stokes
c     problem arising from a unit forcing in the X-direction.  This assumes
c     that the flow rate in the X-direction is to be fixed (as opposed to Y-
c     or Z-) *and* that the periodic boundary conditions in the X-direction
c     occur at the extreme left and right ends of the mesh.
c
c     pff 6/28/98
c
      include 'SIZE'
      include 'TOTAL'
c
c     Swap the comments on these two lines if you don't want to fix the
c     flow rate for periodic-in-X (or Z) flow problems.
c
      parameter (kx1=lx1,ky1=ly1,kz1=lz1,kx2=lx2,ky2=ly2,kz2=lz2)
c
      common /cvflow_a/ vxc(kx1,ky1,kz1,lelv)
     $                , vyc(kx1,ky1,kz1,lelv)
     $                , vzc(kx1,ky1,kz1,lelv)
     $                , prc(kx2,ky2,kz2,lelv)
     $                , vdc(kx1*ky1*kz1*lelv,2)
      common /cvflow_r/ flow_rate,base_flow,domain_length,xsec
     $                , scale_vf(3)
      common /cvflow_i/ icvflow,iavflow
      common /cvflow_c/ chv(3)
      character*1 chv
c
      real bd_vflow,dt_vflow
      save bd_vflow,dt_vflow
      data bd_vflow,dt_vflow /-99.,-99./

      logical ifcomp

c     Check list:

c     param (55) -- volume flow rate, if nonzero
c     forcing in X? or in Z?

      ntot1 = lx1*ly1*lz1*nelv
      ntot2 = lx2*ly2*lz2*nelv

      if (param(55).eq.0.) return
      if (kx1.eq.1) then
         write(6,*) 'ABORT. Recompile vol_flow with kx1=lx1, etc.'
         call exitt
      endif

      icvflow   = 1                                  ! Default flow dir. = X
      if (param(54).ne.0) icvflow = abs(param(54))
      iavflow   = 0                                  ! Determine flow rate
      if (param(54).lt.0) iavflow = 1                ! from mean velocity
      flow_rate = param(55)

      chv(1) = 'X'
      chv(2) = 'Y'
      chv(3) = 'Z'

c     If either dt or the backwards difference coefficient change,
c     then recompute base flow solution corresponding to unit forcing:

      ifcomp = .false.
      if (dt.ne.dt_vflow.or.bd(1).ne.bd_vflow.or.ifmvbd) ifcomp=.true.
      if (.not.ifcomp) then
         ifcomp=.true.
         do i=1,ntot1
            if (vdiff (i,1,1,1,1).ne.vdc(i,1)) goto 20
            if (vtrans(i,1,1,1,1).ne.vdc(i,2)) goto 20
         enddo
         ifcomp=.false.  ! If here, then vdiff/vtrans unchanged.
   20    continue
      endif

      call copy(vdc(1,1),vdiff (1,1,1,1,1),ntot1)
      call copy(vdc(1,2),vtrans(1,1,1,1,1),ntot1)
      dt_vflow = dt
      bd_vflow = bd(1)

      if (ifcomp) call compute_vol_soln_ms(vxc,vyc,vzc,prc)

      if (icvflow.eq.1)
     $       current_flow=glsc2_ms(vx,bm1ms,ntot1)/domain_length  ! for X
      if (icvflow.eq.2)
     $       current_flow=glsc2_ms(vy,bm1ms,ntot1)/domain_length  ! for Y
      if (icvflow.eq.3)
     $       current_flow=glsc2_ms(vz,bm1ms,ntot1)/domain_length  ! for Z
      volvm1ms = glsum_ms(bm1ms,ntot1)

      if (iavflow.eq.1) then
         xsec = volvm1ms / domain_length
         flow_rate = param(55)*xsec
      endif

      delta_flow = flow_rate-current_flow

c     Note, this scale factor corresponds to FFX, provided FFX has
c     not also been specified in userf.   If ffx is also specified
c     in userf then the true FFX is given by ffx_userf + scale.

      scale = delta_flow/base_flow
      scale_vf(icvflow) = scale
      if (nio.eq.0) write(6,1) istep,chv(icvflow)
     $   ,time,scale,delta_flow,current_flow,flow_rate
    1    format(i10,'  volflow ',a1,11x,1p5e12.4)

      call add2s2(vx,vxc,scale,ntot1)
      call add2s2(vy,vyc,scale,ntot1)
      call add2s2(vz,vzc,scale,ntot1)
      call add2s2(pr,prc,scale,ntot2)

      return
      end
c-----------------------------------------------------------------------
      subroutine compute_vol_soln_ms(vxc,vyc,vzc,prc)
c
c     Compute the solution to the time-dependent Stokes problem
c     with unit forcing, and find associated flow rate.
c
c     pff 2/28/98
c
      include 'SIZE'
      include 'TOTAL'
c
      real vxc(lx1,ly1,lz1,lelv)
     $   , vyc(lx1,ly1,lz1,lelv)
     $   , vzc(lx1,ly1,lz1,lelv)
     $   , prc(lx2,ly2,lz2,lelv)
c
      common /cvflow_r/ flow_rate,base_flow,domain_length,xsec
     $                , scale_vf(3)
      common /cvflow_i/ icvflow,iavflow
      common /cvflow_c/ chv(3)
      character*1 chv
c
      integer icalld
      save    icalld
      data    icalld/0/

c
c
      ntot1 = lx1*ly1*lz1*nelv
      if (icalld.eq.0) then
         icalld=icalld+1
         xlmin = glmin_ms(xm1,ntot1)
         xlmax = glmax_ms(xm1,ntot1)
         ylmin = glmin_ms(ym1,ntot1)          !  for Y!
         ylmax = glmax_ms(ym1,ntot1)
         zlmin = glmin_ms(zm1,ntot1)          !  for Z!
         zlmax = glmax_ms(zm1,ntot1)
c
         if (icvflow.eq.1) domain_length = xlmax - xlmin
         if (icvflow.eq.2) domain_length = ylmax - ylmin
         if (icvflow.eq.3) domain_length = zlmax - zlmin
      endif
c
      if (ifsplit) then
c        call plan2_vol(vxc,vyc,vzc,prc)
         call plan4_vol_ms(vxc,vyc,vzc,prc)
      else
         call plan3_vol_ms(vxc,vyc,vzc,prc)
      endif
c
c     Compute base flow rate
c 
      if (icvflow.eq.1)
     $       base_flow = glsc2_ms(vxc,bm1ms,ntot1)/domain_length
      if (icvflow.eq.2)
     $       base_flow = glsc2_ms(vyc,bm1ms,ntot1)/domain_length
      if (icvflow.eq.3)
     $       base_flow = glsc2_ms(vzc,bm1ms,ntot1)/domain_length
c
      if (nio.eq.0 .and. loglevel.gt.0) write(6,1) 
     $   istep,chv(icvflow),base_flow,domain_length,flow_rate
    1    format(i11,'  basflow ',a1,11x,1p3e13.4)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine plan3_vol_ms(vxc,vyc,vzc,prc)
c
c     Compute pressure and velocity using fractional step method.
c     (PLAN3).
c
c
      include 'SIZE'
      include 'TOTAL'
c
      real vxc(lx1,ly1,lz1,lelv)
     $   , vyc(lx1,ly1,lz1,lelv)
     $   , vzc(lx1,ly1,lz1,lelv)
     $   , prc(lx2,ly2,lz2,lelv)
C
      COMMON /SCRNS/ rw1   (LX1,LY1,LZ1,LELV)
     $ ,             rw2   (LX1,LY1,LZ1,LELV)
     $ ,             rw3   (LX1,LY1,LZ1,LELV)
     $ ,             dv1   (LX1,LY1,LZ1,LELV)
     $ ,             dv2   (LX1,LY1,LZ1,LELV)
     $ ,             dv3   (LX1,LY1,LZ1,LELV)
     $ ,             RESPR (LX2,LY2,LZ2,LELV)
      COMMON /SCRVH/ H1    (LX1,LY1,LZ1,LELV)
     $ ,             H2    (LX1,LY1,LZ1,LELV)
      COMMON /SCRHI/ H2INV (LX1,LY1,LZ1,LELV)
      common /cvflow_i/ icvflow,iavflow

      real vxcbc(lx1,ly1,lz1,lelv)
      real vycbc(lx1,ly1,lz1,lelv)
      real vzcbc(lx1,ly1,lz1,lelv)
      REAL           vxcp   (LX1,LY1,LZ1,LELV)
      REAL           dvxc   (LX1,LY1,LZ1,LELV)
      REAL           vycp   (LX1,LY1,LZ1,LELV)
      REAL           dvyc   (LX1,LY1,LZ1,LELV)
      REAL           vzcp   (LX1,LY1,LZ1,LELV)
      REAL           dvzc   (LX1,LY1,LZ1,LELV)
      common /cvflow_nn/ vxcbc,vycbc,vzcbc
      real resbc(lx1*ly1*lz1*lelv,ldim+1)
c
c
c     Compute velocity, 1st part 
c
      n  = lx1*ly1*lz1*nelv
      ntot1  = lx1*ly1*lz1*nelv
      ntot2  = lx2*ly2*lz2*nelv
      ifield = 1
c
      call opzero(vxcbc,vycbc,vzcbc)
      call opzero(vxc,vyc,vzc)

      ngeompv = 10
      do ictr = 1,ngeompv
        if (icvflow.eq.1) then
         call copy     (rw1,bm1,ntot1)
         call rzero    (rw2,ntot1)
         call rzero    (rw3,ntot1)
        elseif (icvflow.eq.2) then
         call rzero    (rw1,ntot1)
         call copy     (rw2,bm1,ntot1)
         call rzero    (rw3,ntot1)
        else
         call rzero    (rw1,ntot1)        ! Z-flow!
         call rzero    (rw2,ntot1)        ! Z-flow!
         call copy     (rw3,bm1,ntot1)    ! Z-flow!
        endif

        if (ictr.eq.1) then
          intype = -1
          call sethlm   (h1,h2,intype)
          call ophinv   (vxc,vyc,vzc,rw1,rw2,rw3,h1,h2,tolhv,nmxh)
          call ssnormd  (vxc,vyc,vzc)
        else
          intype = -1
          call sethlm   (h1,h2,intype)

          call copy(vxcp,vxc,lx1*ly1*lz1*nelv)
          call copy(vycp,vyc,lx1*ly1*lz1*nelv)
          if (ldim.eq.3) call copy(vzcp,vzc,lx1*ly1*lz1*nelv)

          call neknek_xfer_fld(vxc,vxcbc)
          call neknek_xfer_fld(vyc,vycbc)
          if (ldim.eq.3) call neknek_xfer_fld(vzc,vzcbc)
  
          call ophx(resbc(1,1),resbc(1,2),resbc(1,3),
     $             vxcbc,vycbc,vzcbc,h1,h2)
          call sub2(rw1,resbc(1,1),ntot1)
          call sub2(rw2,resbc(1,2),ntot1)
          if (ldim.eq.3) call sub2(rw3,resbc(1,3),ntot1)
          call ophinv   (vxc,vyc,vzc,rw1,rw2,rw3,h1,h2,tolhv,nmxh)
          call opadd2(vxc,vyc,vzc,vxcbc,vycbc,vzcbc)
          call ssnormd  (vxc,vyc,vzc)
        endif
c
c
c     Compute pressure  (from "incompr")
c
        intype = 1
        dtinv  = 1./dt
c
        call rzero   (h1,ntot1)
        call copy    (h2,vtrans(1,1,1,1,ifield),ntot1)
        call cmult   (h2,dtinv,ntot1)
        call invers2 (h2inv,h2,ntot1)
        call opdiv   (respr,vxc,vyc,vzc)
        call chsign  (respr,ntot2)
        call ortho   (respr)
c
c
c     Set istep=0 so that h1/h2 will be re-initialized in eprec
        i_tmp = istep
        istep = 0
        call esolver (respr,h1,h2,h2inv,intype)
        istep = i_tmp
c
        call opgradt (rw1,rw2,rw3,respr)
        call opbinv  (dv1,dv2,dv3,rw1,rw2,rw3,h2inv)
        call opadd2  (vxc,vyc,vzc,dv1,dv2,dv3)
c
        call cmult2  (prc,respr,bd(1),ntot2)

        call sub3(dvxc,vxcp,vxc,ntot1)
        call sub3(dvyc,vycp,vyc,ntot1)
        call sub3(dvzc,vzcp,vzc,ntot1)
        dvxmax = glamax_ms(dvxc,ntot1)
        dvymax = glamax_ms(dvyc,ntot1)
        dvzmax = glamax_ms(dvzc,ntot1)
         if (nio.eq.0)
     $      write(6,'(i2,i8,i4,1p4e13.4,a11)') idsess,istep,ictr,time,
     $      dvxmax,dvymax,dvzmax,' del-vol-vxy'
        call neknekgsync()
      enddo

        call neknekgsync()
c
      
      if (istep.eq.3) ifxyo = .true.
      if (istep.eq.3) call outpost(vxc,vyc,vzc,prc,t,'cor')
      if (istep.eq.3) ifxyo = .false.
      return
      end
c-----------------------------------------------------------------------
      subroutine plan4_vol_ms(vxc,vyc,vzc,prc)

c     Compute pressure and velocity using fractional step method.
c     (Tombo splitting scheme).
      include 'SIZE'
      include 'TOTAL'
      include 'NEKNEK'

      real vxc(lx1,ly1,lz1,lelv)
     $   , vyc(lx1,ly1,lz1,lelv)
     $   , vzc(lx1,ly1,lz1,lelv)
     $   , prc(lx2,ly2,lz2,lelv)

      common /scrns/ resv1 (lx1,ly1,lz1,lelv)
     $ ,             resv2 (lx1,ly1,lz1,lelv)
     $ ,             resv3 (lx1,ly1,lz1,lelv)
     $ ,             respr (lx2*ly2*lz2,lelv)
     $ ,             TA1 (lx1*ly1*lz1*lelv)
     $ ,             TA2 (lx1*ly1*lz1*lelv)
     $ ,             TA3 (lx1*ly1*lz1*lelv)
     $ ,             WA1 (lx1*ly1*lz1*lelv)
     $ ,             WA2 (lx1*ly1*lz1*lelv)
     $ ,             WA3 (lx1*ly1*lz1*lelv)
      common /scrvh/ h1    (lx1,ly1,lz1,lelv)
     $ ,             h2    (lx1,ly1,lz1,lelv)
      COMMON /SCRMG/ W1    (LX1*LY1*LZ1,LELV)
     $ ,             W2    (LX1*LY1*LZ1,LELV)
     $ ,             W3    (LX1*LY1*LZ1,LELV)

      common /cvflow_i/ icvflow,iavflow

      real vxcbc(lx1,ly1,lz1,lelv)
      real vycbc(lx1,ly1,lz1,lelv)
      real vzcbc(lx1,ly1,lz1,lelv)
      REAL           vxcp   (LX1,LY1,LZ1,LELV)
      REAL           dvxc   (LX1,LY1,LZ1,LELV)
      REAL           vycp   (LX1,LY1,LZ1,LELV)
      REAL           dvyc   (LX1,LY1,LZ1,LELV)
      REAL           vzcp   (LX1,LY1,LZ1,LELV)
      REAL           dvzc   (LX1,LY1,LZ1,LELV)
      common /cvflow_nn/ vxcbc,vycbc,vzcbc
      real resbc(lx1*ly1*lz1*lelv,ldim+1)

      CHARACTER CB*3


      n = lx1*ly1*lz1*nelv
      NXYZ1  = lx1*ly1*lz1
      NTOT1  = NXYZ1*NELV

      ngeompv = 10
      do ictr = 1,ngeompv
        call invers2  (h1,vtrans,n)
        call rzero    (h2,       n)
        if (ictr.eq.1) then
          call opzero(vxc,vyc,vzc)
        else 
          call neknek_xfer_fld(vxc,vxcbc)
          call neknek_xfer_fld(vyc,vycbc)
          if (ldim.eq.3) call neknek_xfer_fld(vzc,vzcbc)
        endif

c       Compute pressure 
        if (icvflow.eq.1) call cdtp(respr,h1,rxm2,sxm2,txm2,1)
        if (icvflow.eq.2) call cdtp(respr,h1,rym2,sym2,tym2,1)
        if (icvflow.eq.3) call cdtp(respr,h1,rzm2,szm2,tzm2,1)

        dtbd = BD(1)/DT

C     surface terms
        DO 100 IEL=1,NELV
          DO 300 IFC=1,2*ldim
            CALL RZERO  (W1(1,IEL),NXYZ1)
            CALL RZERO  (W2(1,IEL),NXYZ1)
            IF (ldim.EQ.3)
     $      CALL RZERO  (W3(1,IEL),NXYZ1)
            CB = CBC(IFC,IEL,IFIELD)
            IF (CB(1:1).EQ.'v'.and.intflag(ifc,iel).eq.1) then
               CALL FACCL3
     $         (W1(1,IEL),vxcbc(1,1,1,IEL),UNX(1,1,IFC,IEL),IFC)
               CALL FACCL3
     $         (W2(1,IEL),vycbc(1,1,1,IEL),UNY(1,1,IFC,IEL),IFC)
               IF (ldim.EQ.3)
     $          CALL FACCL3
     $         (W3(1,IEL),vzcbc(1,1,1,IEL),UNZ(1,1,IFC,IEL),IFC)
            ENDIF
            CALL ADD2   (W1(1,IEL),W2(1,IEL),NXYZ1)
            IF (ldim.EQ.3)
     $      CALL ADD2   (W1(1,IEL),W3(1,IEL),NXYZ1)
            CALL FACCL2 (W1(1,IEL),AREA(1,1,IFC,IEL),IFC)
            IF (CB(1:1).EQ.'v'.and.intflag(ifc,iel).eq.1) then
              CALL CMULT(W1(1,IEL),dtbd,NXYZ1)
            endif
            CALL SUB2 (RESPR(1,IEL),W1(1,IEL),NXYZ1)
  300     CONTINUE
  100   CONTINUE


        call ortho    (respr)
        call ctolspl  (tolspl,respr)

        call hmholtz  ('PRES',prc,respr,h1,h2,pmask,vmult,
     $                             imesh,tolspl,nmxh,1)
        call ortho    (prc)

C     Compute velocity
ccccc
        call opgrad   (resv1,resv2,resv3,prc)
        if (ifaxis) call col2 (resv2,omask,n)
        call opchsgn  (resv1,resv2,resv3)

        if (icvflow.eq.1) call add2col2(resv1,v1mask,bm1,n) ! add forcing
        if (icvflow.eq.2) call add2col2(resv2,v2mask,bm1,n)
        if (icvflow.eq.3) call add2col2(resv3,v3mask,bm1,n)
        if (ifexplvis) call split_vis ! split viscosity into exp/imp part

        call copy(vxcp,vxc,lx1*ly1*lz1*nelv)
        call copy(vycp,vyc,lx1*ly1*lz1*nelv)
        call copy(vzcp,vzc,lx1*ly1*lz1*nelv)

        intype = -1
        call sethlm   (h1,h2,intype)
        call ophx(resbc(1,1),resbc(1,2),resbc(1,3),
     $             vxcbc,vycbc,vzcbc,h1,h2)
        call sub2(resv1,resbc(1,1),n)
        call sub2(resv2,resbc(1,2),n)
        if (ldim.eq.3) call sub2(resv3,resbc(1,3),n)
        call ophinv   (vxc,vyc,vzc,resv1,resv2,resv3,h1,h2,tolhv,nmxh)
        call opadd2(vxc,vyc,vzc,vxcbc,vycbc,vzcbc)

        call sub3(dvxc,vxcp,vxc,n)
        call sub3(dvyc,vycp,vyc,n)
        call sub3(dvzc,vzcp,vzc,n)
        dvxmax = glamax_ms(dvxc,n)
        dvymax = glamax_ms(dvyc,n)
        dvzmax = glamax_ms(dvzc,n)
        if (ifexplvis) call redo_split_vis ! restore vdiff
        if (nid.eq.0)
     $    write(6,'(i2,i8,i4,1p4e13.4,a11)') idsess,istep,ictr,time,
     $    dvxmax,dvymax,dvzmax,' del-vol-vxy'

      enddo

      return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!A master directive is used to protect memory accesses. No data race pairs.

program DRB103_master_orig_no
    use omp_lib
    implicit none

    integer k

    !$omp parallel
    !$omp master
    k = omp_get_num_threads()
    print 100, k
    100 format ('Number of threads requested =',3i8)
    !$omp end master
    !$omp end parallel

end program

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!Matrix-vector multiplication: inner level parallelization. No data race pairs.

program DRB062_matrixvector2_orig_no
    use omp_lib
    implicit none

    call foo
contains
    subroutine foo()
        integer :: i, j, N
        real :: sum
        real, dimension(:,:), allocatable :: a
        real, dimension(:), allocatable :: v, v_out

        N = 1000
        allocate (a(N,N))
        allocate (v(N))
        allocate (v_out(N))

        do i = 1, N
            sum = 0.0
            !$omp parallel do reduction(+:sum)
            do j = 1, N
                sum = sum + a(i,j)*v(j)
                print*,sum
            end do
            !$omp end parallel do
            v_out(i) = sum
        end do

    end subroutine foo
end program

      subroutine meshsmoother
      include 'SIZE'
      include 'TOTAL'

      parameter(ndfsbc=1)         !number of boundary conditions
      character*3 dfsbc(ndfsbc)
      save        dfsbc
      data        dfsbc /'W  '/  !BCs listed here

      idftyp = 0      !distance function - 0 -> exponential, 1-> tanh
      alpha = 15.     !Input for wall distance function 
      beta  = 0.1     !

      nouter = 50      !total loops around laplacian and optimizer smoothing
      nlap = 20        !number of laplacian iterations in each loop
      nopt = 20        !number of optimization iterations in each loop

      mtyp = 1         !metric type

      call smoothmesh(mtyp,nouter,nlap,nopt,ndfsbc,dfsbc,idftyp,alpha,
     $                 beta)
     
      return
      end
c-----------------------------------------------------------------------
      subroutine smoothmesh(mtyp,nouter,nlap,nopt,nbc,dcbc,
     $                      idftyp,alpha,beta)
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      parameter (nxyzc=lxc*lyc*lzc,nxyz=lx1*ly1*lz1)

      real xmc(lxc,lyc,lzc,lelv),
     $     ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv),
     $     mltc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc

      real x8(2**ldim,lelv*(2**ldim)),
     $     y8(2**ldim,lelv*(2**ldim)),
     $     z8(2**ldim,lelv*(2**ldim)),
     $     nodmask(2**ldim,lelv*(2**ldim)),
     $     dis((2**ldim)*lelv*(2**ldim)),
     $     mlt((2**ldim)*lelv*(2**ldim))
      common /coarsemesh8/ x8,y8,z8

      real  dx(nxyzc,lelv),dy(nxyzc,lelv),dz(nxyzc,lelv),
     $      xbp(nxyzc,lelv),ybp(nxyzc,lelv),zbp(nxyzc,lelv)
      common / msmbackup / dx,dy,dz,xbp,ybp,zbp

      real dxm(nxyz,lelv),dym(nxyz,lelv),dzm(nxyz,lelv),
     $     dxn(nxyz,lelv),dyn(nxyz,lelv),dzn(nxyz,lelv)

      integer opt,gshl,gshlc,lapinv,optinv
      real alpha,beta,etstart, etend,f1sav,f1,f1pre
      character*3 dcbc(nbc)
c     -------------------
c     -------------------
ccc   INITIALIZE VARIABLES
      lapinv = 0
      optinv = 0

      if (nid.eq.0.and.loglevel.ge.5) 
     $            write(6,*) 'SMOOTHER-check original mesh'
      call fix_geom
c     Copy original mesh from xm1 to dxm
      call copy(dxm,xm1,lx1*ly1*lz1*nelv)
      call copy(dym,ym1,lx1*ly1*lz1*nelv)
      if (ldim.eq.3) call copy(dzm,zm1,lx1*ly1*lz1*nelv)

ccc   Generate interpolators for going to lx1 = 3
      call gen_int_lx1_to_3

ccc   COPY THE ORIGINAL MESH TO dx,dy,dz vectors
      call copy(dx,xmc,lxc*lyc*lzc*nelv)
      call copy(dy,ymc,lxc*lyc*lzc*nelv)
      if (ldim.eq.3) call copy(dz,zmc,lxc*lyc*lzc*nelv)
ccc   COPY THE ORIGINAL MESH FOR BACKUP IF MESH BECOMES INVERTED
      call copy(xbp,xmc,lxc*lyc*lzc*nelt)
      call copy(ybp,ymc,lxc*lyc*lzc*nelt)
      if (ldim.eq.3) call copy(zbp,zmc,lxc*lyc*lzc*nelt)

      call xmtox8(xmc,x8)
      call xmtox8(ymc,y8)
      if (ldim.eq.3) call xmtox8(zmc,z8)

ccc   CREATE MASK
      call genmask(nodmask,mlt,gshl,mltc,gshlc)

ccc   CONSTRUCT WEIGHT FUNCTION
      call disfun(dis,idftyp,alpha,beta,dcbc,nbc)

      etstart=dnekclock()
ccc   GET INITIAL ENERGY
      call getglobsum(x8,y8,z8,mlt,gshl,2**ldim,1,f1sav)
      if (nid.eq.0) 
     $   write(6,'(A,1p1e13.6)') 'SMOOTHER-initial energy',f1sav
      f1 = f1sav

ccc   START SMOOTHING HERE
      do j=1,nouter
         f1pre = f1
         if (nid.eq.0.and.loglevel.ge.2) 
     $     write(6,'(A,I5)') 'SMOOTHER-iteration',j
         mtyp = 1 !if mtyp = 1, jacobian, 2 = l^2, 3 - scale jacobian
         if (nlap.gt.0) then 
           call fastlap(nlap,nodmask,mlt,gshl,dis,lapinv,mltc,gshlc)
           if (lapinv.eq.1) nlap = 0
           if (lapinv.eq.1) call restbackmesh
         endif
         if (nopt.gt.0) then
           call optCG(nopt,nodmask,mlt,gshl,dis,mtyp,optinv,mltc,gshlc)
           if (optinv.eq.1) call restbackmesh !xbp->xm1 and xbp->x8
           if (optinv.eq.1) nopt = 0
         endif
        
         call getglobsum(x8,y8,z8,mlt,gshl,2**ldim,mtyp,f1)
  
         call xmtox8(xmc,x8)
         call xmtox8(ymc,y8)
         if (ldim.eq.3) call xmtox8(zmc,z8)

         call xmctoxm1
  
         if (nid.eq.0) write(6,'(A,I7,1p1e13.5)') 'SMOOTHER-energy',j,f1
         if (nid.eq.0.and.loglevel.ge.2) write(6,*) 'loop complete',j
         if (f1.ge.f1pre) goto 5001  !mesh didn't improve since last iteration
         if (nopt.eq.0.and.nlap.eq.0) goto 5001 !no iterations left to do
      enddo
 5001 continue
    
      etend=dnekclock()
ccc   RESTORE BOUNDARY LAYER
      call restbndrlayer(dx,dy,dz,dis,mltc,gshlc)  !dx,dy,dz is now actually smooth-coarse
      call fix_geom

ccc   Solve the Laplace's equation to morph the interior mesh to match
ccc   the actual surface mesh
      call opsub3(dxn,dyn,dzn,dxm,dym,dzm,xm1,ym1,zm1)
      call my_mv_mesh(dxn,dyn,dzn)
      call opadd2(xm1,ym1,zm1,dxn,dyn,dzn)

      call getglobsum(x8,y8,z8,mlt,gshl,2**ldim,mtyp,f1)
      if (nid.eq.0) then
        write(6,'(A,1p1e13.6)') 'SMOOTHER-initial energy ',f1sav
        write(6,'(A,1p1e13.6)') 'SMOOTHER-final energy ',f1
        write(6,'(A,f5.2)') 'SMOOTHER-improve % ',100.*(f1sav-f1)/f1sav
        write(6,'(A,1p1e13.6)') 'SMOOTHER-time taken ',etend-etstart
      endif

      call geom_reset(1)    ! recompute Jacobians, etc.
       
ccc   OUTPUT THE MESH
c      call gen_rea_full(1)                   !output the rea for smooth mesh

      return
      end
c-----------------------------------------------------------------------
      subroutine gen_int_lx1_to_3 !interpolate mesh from lx1 to lx1=3
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real      dxmc(3,3),dymc(3,3),dzmc(3,3)
      real      dxtmc(3,3),dytmc(3,3),dztmc(3,3)
      common /coarseders/ dxmc,dymc,dzmc,dxtmc,dytmc,dztmc
      real      ixtmc3(lx1,3),ixmc3(3,lx1)
      real      ixtmf3(3,lx1),ixmf3(lx1,3)
      common /coarseints/ ixmc3,ixtmc3,ixmf3,ixtmf3
      real      zgmc(3),wxmc(3)     !points and weights
      real      zgmf(lx1),wxmf(lx1) !points and weights
      real      w(lx1,lx1)

c     Generate GLL points and weight
      call zwgll(zgmc,wxmc,3)
      call zwgll(zgmf,wxmf,lx1)
c     Generate derivative matrices with transpose operators
      call dgll(dxmc,dxtmc,zgmc,3,3)
      call dgll(dymc,dytmc,zgmc,3,3)
      call rzero(dzmc,3*3)
      call rzero(dztmc,3*3)
      if (ldim.eq.3) call dgll(dzmc,dztmc,zgmc,3,3)
c     Generate interpolation matrices
      call igllm (ixmc3,ixtmc3,zgmf,zgmc,nx1,3,nx1,3)
      call igllm (ixmf3,ixtmf3,zgmc,zgmf,3,nx1,3,nx1)

c     Interpolate mesh to lx1=3
      call xm1toxmc

      return
      end
c-----------------------------------------------------------------------
      subroutine int_fine_to_coarse_2d(u1,u2,n1,n2)
      include 'SIZE'
c     Interpolate u1 to u2 using interpolation matrices in12 and in12^T
c     u1 is size n1xn1 and u2 is size n2xn2
      real ixtmc3(lx1,3),ixmc3(3,lx1)
      real ixtmf3(3,lx1),ixmf3(lx1,3)
      common /coarseints/ ixmc3,ixtmc3,ixmf3,ixtmf3
      real u1(n1,n1),u2(n2,n2)
      real w(20,20)
 
      if (lx1.gt.20) write(6,*) 'SMOOTHER-increase size of work array 
     $                   in int_fine_to_coarse and related routines '
      if (lx1.gt.20) call exitt

      call mxm(ixmc3,n2,u1,n1,w,n1)
      call mxm(w,n2,ixtmc3,n1,u2,n2)
   
      return
      end
c-----------------------------------------------------------------------
      subroutine int_fine_to_coarse_3d(u1,u2,n1,n2)
      include 'SIZE'
c     Interpolate u1 to u2 using interpolation matrices in12 and in12^T
c     u1 is size n1xn1 and u2 is size n2xn2
      real ixtmc3(lx1,3),ixmc3(3,lx1)
      real ixtmf3(3,lx1),ixmf3(lx1,3)
      common /coarseints/ ixmc3,ixtmc3,ixmf3,ixtmf3
      real u1(n1,n1,n1),u2(n2,n2,n2)
      real w(20*20*20)
      real v(20*20*20)
 
      if (lx1.gt.20) write(6,*) 'SMOOTHER-increase size of work array 
     $                   in int_fine_to_coarse and related routines '
      if (lx1.gt.20) call exitt
      
      mm = n1*n1
      mn = n1*n2
      nn = n2*n2

      call mxm(ixmc3,n2,u1,n1,v ,mm)
      iv=1
      iw=1
      do k=1,n1
         call mxm(v(iv),n2,ixtmc3,n1,w(iw),n2)
         iv = iv+mn
         iw = iw+nn
      enddo
      call mxm(w,nn,ixtmc3,n1,u2,n2)
  
      return
      end
c-----------------------------------------------------------------------
      subroutine int_coarse_to_fine_2d(u1,u2,n1,n2)
      include 'SIZE'
c     Interpolate u1 to u2 using interpolation matrices in12 and in12^T
c     u1 is size n1xn1 and u2 is size n2xn2
c     u1 is fine, u2 is coarse
      real ixtmc3(lx1,3),ixmc3(3,lx1)
      real ixtmf3(3,lx1),ixmf3(lx1,3)
      common /coarseints/ ixmc3,ixtmc3,ixmf3,ixtmf3
      real zgmc(3),wxmc(3) !points and weights
      real zgmf(lx1),wxmf(lx1) !points and weights
      common /coarswz/ zgmc,wxmc,zgmf,wxmf
      real u1(n1,n1),u2(n2,n2)
      real w(20,20)

      if (lx1.gt.20) write(6,*) 'SMOOTHER-increase size of work array 
     $                   in int_coarse_to_fine and related routines '
      if (lx1.gt.20) call exitt

      call mxm(ixmf3,n1,u2,n2,w,n2)
      call mxm(w,n1,ixtmf3,n2,u1,n1)

      return
      end
c-----------------------------------------------------------------------
      subroutine int_coarse_to_fine_3d(u1,u2,n1,n2)
      include 'SIZE'
c     Interpolate u1 to u2 using interpolation matrices in12 and in12^T
c     u1 is size n1xn1 and u2 is size n2xn2
      real ixtmc3(lx1,3),ixmc3(3,lx1)
      real ixtmf3(3,lx1),ixmf3(lx1,3)
      common /coarseints/ ixmc3,ixtmc3,ixmf3,ixtmf3
      real u1(n1,n1,n1),u2(n2,n2,n2)
      real w(20*20*20)
      real v(20*20*20)

      if (lx1.gt.20) write(6,*) 'SMOOTHER-increase size of work array 
     $                   in int_coarse_to_fine and related routines '
      if (lx1.gt.20) call exitt

      mm = n2*n2
      mn = n2*n1
      nn = n1*n1

      call mxm(ixmf3,n1,u2,n2,v ,mm)
      iv=1
      iw=1
      do k=1,n2
         call mxm(v(iv),n1,ixtmf3,n2,w(iw),n1)
         iv = iv+mn
         iw = iw+nn
      enddo
      call mxm(w,nn,ixtmf3,n2,u1,n1)

      return
      end
c-----------------------------------------------------------------------
      subroutine genbackupmesh   !xm1->xbp   backup the mesh
      include 'SIZE'
      include 'TOTAL'
! backsup the mesh
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real xmc(lxc,lyc,lzc,lelv),ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc

      parameter(lt = lxc*lyc*lzc*lelv)
      real dx(lt),dy(lt),dz(lt),xbp(lt),ybp(lt),zbp(lt)
      common / msmbackup / dx,dy,dz,xbp,ybp,zbp

      call copy(xbp,xmc,lxc*lyc*lzc*nelt)
      call copy(ybp,ymc,lxc*lyc*lzc*nelt)
      if (ldim.eq.3) call copy(zbp,zmc,lxc*lyc*lzc*nelt)

      return
      end
c-----------------------------------------------------------------------
      subroutine restbackmesh  !xbp->xm1 and xbp->x8
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real xmc(lxc,lyc,lzc,lelv),ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc

      real x8(2,2,ldim-1,lelv*(2**ldim)),y8(2,2,ldim-1,lelv*(2**ldim))
      real z8(2,2,ldim-1,lelv*(2**ldim))
      common /coarsemesh8/ x8,y8,z8

      parameter(lt = lxc*lyc*lzc*lelv)
      real dx(lt),dy(lt),dz(lt),xbp(lt),ybp(lt),zbp(lt)
      common / msmbackup / dx,dy,dz,xbp,ybp,zbp
     
      call copy(xmc,xbp,lxc*lyc*lzc*nelt)
      call copy(ymc,ybp,lxc*lyc*lzc*nelt)
      if (ldim.eq.3) call copy(zmc,zbp,lxc*lyc*lzc*nelt)
      call xmtox8(xmc,x8)
      call xmtox8(ymc,y8)
      if (ldim.eq.3) call xmtox8(zmc,z8)

      return
      end
c-----------------------------------------------------------------------
      subroutine optCG(itmax,nodmask,mlt,gshl,dis,opt,optinv,mltc,gshlc)
      include 'SIZE'
      include 'TOTAL'

      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      parameter (nxyzc=lxc*lyc*lzc,nxyz=lx1*ly1*lz1)

      real xmc(lxc,lyc,lzc,lelv),
     $     ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv),
     $     mltc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc

      real x8(2**ldim,lelv*(2**ldim)),
     $     y8(2**ldim,lelv*(2**ldim)),
     $     z8(2**ldim,lelv*(2**ldim)),
     $     nodmask(2**ldim,lelv*(2**ldim)),
     $     dis(2**ldim,lelv*(2**ldim)),
     $     mlt(2**ldim,lelv*(2**ldim)),
     $     dx(2**ldim,lelv*(2**ldim)),
     $     dy(2**ldim,lelv*(2**ldim)),
     $     dz(2**ldim,lelv*(2**ldim)),
     $     dfdx(2**ldim,lelv*(2**ldim),ldim),
     $     dfdxn(2**ldim,lelv*(2**ldim),ldim),
     $     sk(2**ldim,lelv*(2**ldim),ldim)
      common /coarsemesh8/ x8,y8,z8

      integer iter,gshl,siz,eg,opt,optinv,kerr,gshlc
      real f2,lambda,num,den,scale2
      real alpha,bk,num1,den1,wrk1
      real hval(2**ldim,lelv*(2**ldim))

      optinv = 0 !initialize to 0

      if (nid.eq.0.and.loglevel.ge.2) 
     $         write(6,*) 'Optimization loop started'

      if (opt.eq.1) siz = 2**ldim !for jacobian
      if (opt.eq.2) siz = 4+8*(ldim-2) !for len
      n1 = 2**ldim
      n2 = nelv*(2**ldim)*n1

      call get_nodscale(hval,x8,y8,z8,gshl)
c      if (nid.eq.0.and.loglevel.ge.4) 
c     $   write(6,'(A,1p1e13.5)') 'perturbation amount is ',hval

      call gradf(f2,dfdx,x8,y8,z8,mlt,gshl,siz,opt,hval)
      do i=1,ldim
        call copy(sk(1,1,i),dfdx(1,1,i),n2)
        call cmult(sk(1,1,i),-1.,n2)
      enddo

      do iter=1,itmax
c  do line search at this point
         call
     $  dolsalpha(x8,y8,z8,sk,alpha,siz,opt,mlt,gshl,nodmask,iter)

         if (alpha.eq.0) goto 5002

         call col4(dx,sk(1,1,1),nodmask,dis,n2)
         call col4(dy,sk(1,1,2),nodmask,dis,n2)
         if (ldim.eq.3) call col4(dz,sk(1,1,ldim),nodmask,dis,n2)

         call add2s2(x8,dx,alpha,n2)
         call add2s2(y8,dy,alpha,n2)
         if (ldim.eq.3) call add2s2(z8,dz,alpha,n2)

c Gradf at new positions
         call gradf(f2,dfdxn,x8,y8,z8,mlt,gshl,siz,opt,hval)

c  get Bk = dfdxn'*dfdxn / (dfdx'*dfdx)
         num1 = 0.
         den1 = 0.
         do k=1,ldim
         do j=1,nelv*(2**ldim)
         do i=1,2**ldim
          num1 = dfdxn(i,j,k)*mlt(i,j)*dfdxn(i,j,k) + num1
          den1 = dfdx(i,j,k)*mlt(i,j)*dfdx(i,j,k) + den1
         enddo
         enddo
         enddo
         call gop(num1,wrk1,'+  ',1)
         call gop(den1,wrk1,'+  ',1)
         bk = num1/den1
  
         do k=1,ldim
         do j=1,nelv*(2**ldim)
         do i=1,2**ldim
          sk(i,j,k) = -dfdxn(i,j,k) + bk*sk(i,j,k)
          dfdx(i,j,k) = dfdxn(i,j,k)
         enddo
         enddo
         enddo
        
         if (mod(iter,5).eq.0.or.iter.eq.itmax) then
          call x8toxm(xmc,x8)
          call x8toxm(ymc,y8)
          if (ldim.eq.3) call x8toxm(zmc,z8)
          call fixcurs(mltc,gshlc)
          call xmtox8(xmc,x8)
          call xmtox8(ymc,y8)
          if (ldim.eq.3) call xmtox8(zmc,z8)
         endif
      enddo

 5002 continue
      if (alpha.eq.0) then
       optinv = 2
       call x8toxm(xmc,x8)
       call x8toxm(ymc,y8)
       if (ldim.eq.3) call x8toxm(zmc,z8)
       call fixcurs(mltc,gshlc)
       call xmtox8(xmc,x8)
       call xmtox8(ymc,y8)
       if (ldim.eq.3) call xmtox8(zmc,z8)
      endif

      call glmapm1chkinv(kerr)
      if (kerr.gt.0) then
        optinv = 1  !Terminate smoother
        if (nid.eq.0) write(6,*) 'Terminating optimizer'
      else
        call genbackupmesh
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine 
     $   dolsalpha(xe,ye,ze,sk,alpha,siz,opt,mlt,gshl,nodmask,iter)
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real     xmc(lxc,lyc,lzc,lelv),
     $         ymc(lxc,lyc,lzc,lelv),
     $         zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc
      real     xe(2**ldim,lelv*(2**ldim)),
     $         ye(2**ldim,lelv*(2**ldim)),
     $         ze(2**ldim,lelv*(2**ldim)),
     $         dx(2**ldim,lelv*(2**ldim)),
     $         dy(2**ldim,lelv*(2**ldim)),
     $         dz(2**ldim,lelv*(2**ldim)),
     $         xs(2**ldim,lelv*(2**ldim)),
     $         ys(2**ldim,lelv*(2**ldim)),
     $         zs(2**ldim,lelv*(2**ldim)),
     $         nodmask(2**ldim,lelv*(2**ldim)),
     $         mlt(2**ldim,lelv*(2**ldim)),
     $         sk((2**ldim),lelv*(2**ldim),ldim),
     $         jac(2**ldim,lelv*(2**ldim))
      real alpha,wrk1,f1,f2
      integer siz,opt,z,gshl,invflag
      integer n1,n2,chk1,chk2,tstop,maxcount,iter

      common /lsinfo / lssteps
      real lssteps(5)
      integer icalld
      save    icalld
      data    icalld /0/
      integer idx
      save    idx   
      data    idx    /0/

      if (icalld.eq.0) then
        call rzero(lssteps,5)
        icalld = 1
        idx = 0
      endif

      if (idx.lt.6) then
        alpha = 1.0
      else
        dumsum = vlsum(lssteps,5)
        alpha = 2.*dumsum
      endif
      alphasav = alpha
      maxcount = 20
      chk1 = 0
      chk2 = 0
      tstop = 0
      n1 = 2**ldim
      n2 = nelv*(2**ldim)*n1

      call copy(xs(1,1),xe(1,1),n2)
      call copy(ys(1,1),ye(1,1),n2)
      if (ldim.eq.3) call copy(zs(1,1),ze(1,1),n2)

      call getglobsum(xs,ys,zs,mlt,gshl,siz,opt,f1)
      z = 0
      do while (tstop.eq.0.and.z.le.maxcount)
        z = z+1
        call col3c(dx,sk(1,1,1),nodmask,alpha,n2)
        call col3c(dy,sk(1,1,2),nodmask,alpha,n2)
        if (ldim.eq.3) call col3c(dz,sk(1,1,ldim),nodmask,alpha,n2)

        call add3(xs,xe,dx,n2)
        call add3(ys,ye,dy,n2)
        if (ldim.eq.3) call add3(zs,ze,dz,n2)

        call getglobsum(xs,ys,zs,mlt,gshl,siz,opt,f2)

        if (f2.lt.f1) then
          chk1 = 1
        endif
        call gop(chk1,wrk1,'m  ',1)

        chk2 = 0
        if (chk1.eq.1) then
          call x8toxm(xmc,xs)
          call x8toxm(ymc,ys)
          if (ldim.eq.3) call x8toxm(zmc,zs)
          call glmapm1chkinv(invflag)
          if (invflag.eq.0) chk2 = 1
        endif
        call gop(chk2,wrk1,'m  ',1)

        if (chk1.eq.1.and.chk2.eq.1.) then
           alphasav = alpha
           tstop = 1.
        else
           chk1 = 0.
           chk2 = 0.
           alpha = alpha/(10.)
        endif
      enddo

      if (idx.lt.6) then
        idx = idx+1
        lssteps(idx) = alphasav
      else
        lssteps(1) = lssteps(2)
        lssteps(2) = lssteps(3)
        lssteps(3) = lssteps(4)
        lssteps(4) = lssteps(5)
        lssteps(5) = alphasav
      endif

      if (tstop.eq.1) then 
        alpha = alphasav
        if (nid.eq.0.and.loglevel.ge.3) write(6,101) iter,f2
  101   format(i5,' glob_phi ',1p1e13.6)
c        write(6,*) z,'number of ls steps'
      else
        alpha = 0.
        if (nid.eq.0.and.loglevel.ge.4) 
     $       write(6,*) 'SMOOTHER-line-search alpha set to 0'
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine getglobsum(xe,ye,ze,mlt,gshl,siz,opt,fl)
      include 'SIZE'
      include 'TOTAL'
      real xe(2**ldim,lelv*(2**ldim))
      real ye(2**ldim,lelv*(2**ldim))
      real ze(2**ldim,lelv*(2**ldim))
      real mlt(2**ldim,lelv*(2**ldim))
      integer gshl,siz,e,opt
      real f1,fl,wrk1

      fl = 0.
      do e=1,nelv*(2**ldim)
        if (opt.eq.1) 
     $     call get_jac(f1,xe(1,e),ye(1,e),ze(1,e),siz,e,1)
        if (opt.eq.2) call get_len(f1,xe(1,e),ye(1,e),ze(1,e),siz)
        fl = fl+f1
      enddo
      call gop(fl,wrk1,'+  ',1)

      return
      end
c-----------------------------------------------------------------------
      subroutine disfun(dis,funtype,alpha,beta,dcbc,nbc)
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real dd1(lx1*ly1*lz1*lelv),
     $     dd2(lx1*ly1*lz1*lelv),
     $     ddd(lx1*ly1*lz1*lelv),
     $     ddc(lxc*lyc*lzc,lelv),
     $     dis((2**ldim)*lelv*(2**ldim))
      integer i,nbc,j,funtype
      character*3 dcbc(nbc)
      real dscale,dmax,alpha,beta,dum2

      if (nid.eq.0.and.loglevel.ge.5) 
     $            write(6,*) 'calculate distance function'

      call rone (dd1,lx1*ly1*lz1*nelv)
      call sm_cheap_dist(dd1,1,dcbc(1))  ! Distance function scaling

      if (nbc.ge.2) then
      do i=2,nbc
         call rone (dd2,lx1*ly1*lz1*nelv)
         call sm_cheap_dist(dd2,1,dcbc(i))  ! Distance function scaling
         do j=1,lx1*ly1*lz1*nelv
           dd1(j) = min(dd1(j),dd2(j))
         enddo
      enddo
      endif

      dmax   = glamax(dd1,lx1*ly1*lz1*nelv)
      dscale = 1./dmax
      call cmult(dd1,dscale,lx1*ly1*lz1*nelv) !normalized 0 to 1
c      call outpost(dd1,vy,vz,pr,t,'   ')

      nxyz = lx1*ly1*lz1
      if (ldim.eq.2) then
       do i=1,nelv
         call int_fine_to_coarse_2d(dd1((i-1)*nxyz+1),ddc(1,i),lx1,lxc) 
       enddo
      else
       do i=1,nelv
         call int_fine_to_coarse_3d(dd1((i-1)*nxyz+1),ddc(1,i),lx1,lxc)
       enddo
      endif
      call xmtox8(ddc,dis)
c
      if (funtype.eq.0) then
        do i=1,(2**ldim)*nelv*(2**ldim)
          dis(i) = (1-EXP(-dis(i)/beta))
       enddo
      elseif (funtype.eq.1) then
        do i=1,(2**ldim)*nelv*(2**ldim)
          dis(i) = 0.5*(tanh(alpha*(dis(i)-beta))+1)
        enddo
      else
          call exitti('Please set the funtype to 0 or 1$',funtype)
      endif
        
      if (nid.eq.0.and.loglevel.ge.5) 
     $            write(6,'(1p1e13.4,A)') dmax,'max disfun'

      return
      end
c-----------------------------------------------------------------------
      subroutine restbndrlayer(dx,dy,dz,dis,mltc,gshlc)
      include 'SIZE'
      include 'TOTAL'
c     dis*smoothmesh + (1-dis)*original mesh
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real xmc(lxc,lyc,lzc,lelv),
     $     ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc

      real dx(lxc*lyc*lzc,lelv),
     $     dy(lxc*lyc*lzc,lelv),
     $     dz(lxc*lyc*lzc,lelv),
     $     dis((2**ldim)*lelv*(2**ldim)),
     $     dis2(lxc,lyc,lzc,lelv),
     $     mltc(lxc,lyc,lzc,lelv)

      integer gshlc

      call x8toxm(dis2,dis)
      dum2 = glamax(dis2,lxc*lyc*lzc*nelv)
      dum2 = 1./dum2
      call cmult(dis2,dum2,lxc*lyc*lzc*nelv)

      call col2(xmc,dis2,lxc*lyc*lzc*nelv)   !w*xs
      call col2(ymc,dis2,lxc*lyc*lzc*nelv)
      if (ndim.eq.3) call col2(zmc,dis2,lxc*lyc*lzc*nelv)

      call add2(xmc,dx,lxc*lyc*lzc*nelv)     !w*xs+xo
      call add2(ymc,dy,lxc*lyc*lzc*nelv)
      if (ndim.eq.3) call add2(zmc,dz,lxc*lyc*lzc*nelv)

      call col2(dx,dis2,lxc*lyc*lzc*nelv)    !w*xo
      call col2(dy,dis2,lxc*lyc*lzc*nelv)
      if (ndim.eq.3) call col2(dz,dis2,lxc*lyc*lzc*nelv)

      call sub2(xmc,dx,lxc*lyc*lzc*nelv)     !w*xs+xo-w*xo=w*xs+xo(1-w)
      call sub2(ymc,dy,lxc*lyc*lzc*nelv)     !this is now store in xmc..zmc
      if (ndim.eq.3) call sub2(zmc,dz,lxc*lyc*lzc*nelv)

      call sub2(dx,xmc,lxc*lyc*lzc*nelv)     !dx=xo-xmc
      call sub2(dy,ymc,lxc*lyc*lzc*nelv)
      if (ndim.eq.3) call sub2(dz,zmc,lxc*lyc*lzc*nelv)

      call fixcurs(mltc,gshlc)
      call xmctoxm1

      return
      end
c-----------------------------------------------------------------------
      subroutine masklayers(nodmask,nlayers)
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real nodmask(2**ldim,lelv*(2**ldim))
      real d(lx1*ly1*lz1,lelv)
      real vcmask(lxc,lyc,lzc,lelv)
      integer e,f,i,j,nlayers,valm,c

      character*3 tcbc(5)
      save        tcbc
      data        tcbc /'W  ','v  ','V  ','mv ','MV ' /

      call x8toxm(v1mask,nodmask)

      call rone(d,nx1*ny1*nz1*nelv)
      do e=1,nelv
      do f=1,2*ldim
      do c=1,5
         if(cbc(f,e,1).eq.tcbc(c)) call facev(d,e,f,zero,nx1,ny1,nz1)
      enddo
      enddo
      enddo
      call dsop(d,'mul',nx1,ny1,nz1)

      do i=1,nlayers
        call dsop(d,'mul',nx1,ny1,nz1)
         do e=1,nelv
          val = glamin(d(1,e),lx1**ldim)
          call cmult(d(1,e),val,lx1**ldim)
         enddo
      enddo

      call dsop(d,'mul',nx1,ny1,nz1)
      call col2(v1mask,d,lx1*ly1*lz1*nelv)
      do i=1,nelv
       call int_fine_to_coarse_2d(v1mask(1,1,1,e),vcmask(1,1,1,e),lx1,3)
      enddo
      call xmtox8(vcmask,nodmask)

      return
      end
c-----------------------------------------------------------------------
      subroutine fixcurs(mltc,gshlc)
      include 'SIZE'
      include 'TOTAL'
c     This routine fixes the curved edges post smoothing
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real xmc(lxc,lyc,lzc,lelv),
     $     ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc

      common /ctmp0/ zg(3)
      real w1(lxc*lyc*lzc*lelv),w2(lxc*lyc*lzc*lelv)
      real vcmask(lxc,lyc,lzc,lelv)
      integer f,e,nedge,n,nfaces,gshlc
      integer ke(3,12)
      real    xyz(3,3)
      real    xd(lxc*lyc*lzc),
     $        yd(lxc*lyc*lzc),
     $        zd(lxc*lyc*lzc),
     $        mltc(lxc*lyc*lzc*lelv)
      real nxv,nyv,nzv

      save    ke
      data    ke /  1, 2, 3,    3, 6, 9,    9, 8, 7,    7, 4, 1
     $           , 19,20,21,   21,24,27,   27,26,25,   25,22,19
     $           ,  1,10,19,    3,12,21,    9,18,27,    7,16,25 /
       integer kin(7)

c     START BY LOOPING OVER EACH ELEMENT AND THEN OVER EACH EDGE
      nedge = 4 + 8*(ldim-2)
      nfaces = 2*ldim

      n      = lxc*lyc*lzc*nelv
      call rone  (vcmask,n)
      do e=1,nelv                
      do f=1,nfaces              
       if (cbc(f,e,1).ne.'E  '.and.cbc(f,e,1).ne.'   ') 
     $ call facev (vcmask,e,f,0.0,lxc,lyc,lzc)
      enddo
      enddo
      call fgslib_gs_op(gshlc,vcmask,1,2,0)

      do e=1,nelv
       do j=1,nedge
        call rzero(xyz,9)
        do i=1,3
         xyz(1,i) = xmc(ke(i,j),1,1,e)
         xyz(2,i) = ymc(ke(i,j),1,1,e)
         if (ldim.eq.3) xyz(3,i) = zmc(ke(i,j),1,1,e)
        enddo

        if (vcmask(ke(2,j),1,1,e).gt.0.5) then
         call fixedgs(xyz,nxv,nyv,nzv)
         xmc(ke(2,j),1,1,e) = nxv
         ymc(ke(2,j),1,1,e) = nyv
         if (ldim.eq.3) zmc(ke(2,j),1,1,e) = nzv
        endif
       enddo

c      fix face center and body center
        zg(1) = -1.
        zg(2) = 0.
        zg(3) = 1.
        call copy(xd,xmc(1,1,1,e),lxc*lyc*lzc)
        call copy(yd,ymc(1,1,1,e),lxc*lyc*lzc)
        if (ldim.eq.3) call copy(zd,zmc(1,1,1,e),lxc*lyc*lzc)
        call gh_face_extend(xd,zg,3,2,w1,w2)
        call gh_face_extend(yd,zg,3,2,w1,w2)
        if (ldim.eq.3) call gh_face_extend(zd,zg,3,2,w1,w2)
        kin(1) = 5
        kin(2) = 11
        kin(3) = 13
        kin(4) = 15
        kin(5) = 17
        kin(6) = 23
        kin(7) = 14
        do i=1,(ldim-2)*6+1
         xmc(kin(i),1,1,e) = xd(kin(i))
         ymc(kin(i),1,1,e) = yd(kin(i))
         if (ldim.eq.3) zmc(kin(i),1,1,e) = zd(kin(i))
        enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine fixedgs(xyz,nx,ny,nz)
      real xyz(3,0:2) ! Coordinates
      real x0(3),x1(3),x2(3),v2(3),v1(3),l02,l01,n1i,u1(3),u2(3)
      real nx,ny,nz
      real h,tol,h2

      call copy(x0,xyz(1,0),3)
      call copy(x1,xyz(1,1),3)
      call copy(x2,xyz(1,2),3)
                             !                  ^ x2
      call sub3(v1,x1,x0,3)  ! v1=x1-x0        /  \ v2     p1 = x0+v2*dot
      call sub3(v2,x2,x0,3)  ! v2=x2-x0    x1 .<-- x0
                             !                  v1
      l02 = vlsc2(v2,v2,3)   ! || x2-x0 ||
      if (l02.gt.0) then
         l02 = sqrt(l02)
         scl = 1./l02
         call cmult2(u2,v2,scl,3)  ! Unit tangent
      endif

      l01 = vlsc2(v1,v1,3)   ! || x1-x0 ||
      if (l01.gt.0) then
         l01 = sqrt(l01)
         scl = 1./l01
         call cmult2(u1,v1,scl,3)  ! Unit tangent
      endif

      dot = vlsc2(v1,u2,3)

      if (dot.le.0) then
         write(6,*) 'SMOOTHER-ERROR 1 IN SHIFT - YOU SHOULD ABORT'
         return
      elseif (dot.gt.l02) then
         write(6,*) 'SMOOTHER-ERROR 2 IN SHIFT - YOU SHOULD ABORT'
         return
      endif
         h = 0.
         h2 = 0.
         tol = 1.e-8
      do i=1,3
         p1i = x0(i) + u2(i)*dot   ! Projection of x1 onto [x0,x2]
         n1i = x1(i) - p1i         ! Normal vector
         h = h + n1i**2
         h2 = h2+ (x2(i)-x0(i))**2
         xmi = 0.5*(x0(i)+x2(i))
         x1(i) = xmi + n1i         ! X1 point shifted to be centered at midpoint
      enddo
         if (h.le.h2*tol) then
            x1(1) = 0.5*(x0(1)+x2(1))
            x1(2) = 0.5*(x0(2)+x2(2))
            x1(3) = 0.5*(x0(3)+x2(3))
         endif
         

      nx = x1(1)
      ny = x1(2)
      nz = x1(3)

      return
      end
c-----------------------------------------------------------------------
      subroutine gradf(f2,dfdx,x8,y8,z8,mlt,gshl,siz,opt,h)
      include 'SIZE'
      include 'TOTAL'
      real x8(2**ldim,lelv*(2**ldim)),
     $     y8(2**ldim,lelv*(2**ldim)),
     $     z8(2**ldim,lelv*(2**ldim)),
     $    mlt(2**ldim,lelv*(2**ldim)),
     $   dfdx(2**ldim,lelv*(2**ldim),ldim)
      real xt(2**ldim),
     $     yt(2**ldim),
     $     zt(2**ldim)
      integer siz,opt,vertex,gshl,e,eg,e0,f
      real par(siz)
      real f1,fl,gl,f2,h(2**ldim,lelv*(2**ldim))
 
      f1 = 0
      do e=1,nelv*(2**ldim)
      if (opt.eq.1) 
     $    call get_jac(fl,x8(1,e),y8(1,e),z8(1,e),siz,e,0)
      if (opt.eq.2) call get_len(fl,x8(1,e),y8(1,e),z8(1,e),siz)  
         f1 = f1+fl
         call copy(xt,x8(1,e),2**ldim)
         call copy(yt,y8(1,e),2**ldim)
         call copy(zt,z8(1,e),2**ldim)
         do j=1,2**ldim
            xt(j) = x8(j,e)+h(j,e) 
      if (opt.eq.1) call get_jac(gl,xt,yt,zt,siz,e,1)
      if (opt.eq.2) call get_len(gl,xt,yt,zt,siz)
            xt(j) = x8(j,e)-h(j,e) 
      if (opt.eq.1) call get_jac(fl,xt,yt,zt,siz,e,1)
      if (opt.eq.2) call get_len(fl,xt,yt,zt,siz)
            xt(j) = x8(j,e) 
           dfdx(j,e,1) = (gl-fl)/(2.*h(j,e))

            yt(j) = y8(j,e)+h(j,e) 
      if (opt.eq.1) call get_jac(gl,xt,yt,zt,siz,e,2)
      if (opt.eq.2) call get_len(gl,xt,yt,zt,siz)
            yt(j) = y8(j,e)-h(j,e) 
      if (opt.eq.1) call get_jac(fl,xt,yt,zt,siz,e,2)
      if (opt.eq.2) call get_len(fl,xt,yt,zt,siz)
            yt(j) = y8(j,e) 
           dfdx(j,e,2) = (gl-fl)/(2.*h(j,e))

            if (ldim.eq.3) then
             zt(j) = z8(j,e)+h(j,e) 
      if (opt.eq.1) call get_jac(gl,xt,yt,zt,siz,e,3)
      if (opt.eq.2) call get_len(gl,xt,yt,zt,siz)
             zt(j) = z8(j,e)-h(j,e) 
      if (opt.eq.1) call get_jac(fl,xt,yt,zt,siz,e,3)
      if (opt.eq.2) call get_len(fl,xt,yt,zt,siz)
             zt(j) = z8(j,e) 
           dfdx(j,e,ldim) = (gl-fl)/(2.*h(j,e))
            endif
          enddo 
      enddo 

      call fgslib_gs_op(gshl,dfdx(1,1,1),1,1,0)
      call fgslib_gs_op(gshl,dfdx(1,1,2),1,1,0)
      if (ldim.eq.3) call fgslib_gs_op(gshl,dfdx(1,1,ldim),1,1,0)

      f2 = glsum(f1,1)

      return
      end
c-----------------------------------------------------------------------
      subroutine get_jac(val,x,y,z,siz,el,dire)
      include 'SIZE'
      include 'TOTAL'
c     This routine compiles the jacobian matrix and then does the 
c     frobenius norm of the matrix times that of the inverse
      integer i,j,k,siz,el,dire

      real par(siz),det(siz)
      real jm(ldim,ldim),jin(ldim,ldim),frn(ldim**2)
      real x(2**ldim),y(2**ldim),z(2**ldim),jac(2**ldim)
      real fr1,fr2,sum1,dumc,val

      integer bzindx(24),czindx(24)
      integer penalty
      SAVE bzindx
      DATA bzindx / 2,3,5, 1,4,6, 4,1,7, 3,2,8, 
     $             6,7,1, 5,8,2, 8,5,3, 7,6,4 /
c     bzindx tells which node is node connected to in r,s,t direction
c     example: node 1 is connected to 2,3,5; 2 to 1,4,6 and so on  
      SAVE czindx
      DATA czindx / 1,1,1,  -1,1,1, 1,-1,1, -1,-1,1,
     $              1,1,-1, -1,1,-1, 1,-1,-1, -1,-1,-1 / 
c     this tells which node is to be subtracted.

      if (siz.ne.2**ldim) then
         write(6,*) 'siz value wrong input into get_jac'
         write(6,*) siz,'sizval',2**ldim,'should be this'
         call exitt
      endif

      do i=1,2**ldim
        ind1 = (i-1)*3 !tells where to look in b/czindx
        do j=1,ldim
         ind2 = ind1+j
            jm(1,j) = 0.5*czindx(ind2)*(x(bzindx(ind2))-x(i))
            jm(2,j) = 0.5*czindx(ind2)*(y(bzindx(ind2))-y(i))
            if (ldim.eq.3) 
     $      jm(ldim,j) = 0.5*czindx(ind2)*(z(bzindx(ind2))-z(i))
        enddo
c     jacobian matrix has been calculated at this point. 
c     now calculate determinant
       if (ldim.eq.3) then
         jac(i)=jm(1,1)*(jm(2,2)*jm(ldim,ldim)-jm(2,ldim)*jm(ldim,2))+ 
     $          jm(1,ldim)*(jm(2,1)*jm(ldim,2)-jm(2,2)*jm(ldim,1))   +
     $          jm(1,2)*(jm(2,ldim)*jm(ldim,1)-jm(2,1)*jm(ldim,ldim))
        else
           jac(i)=jm(1,1)*jm(2,2)-jm(2,1)*jm(1,2) 
        endif
c      calculate inverse matrix
       if (ldim.eq.3) then
         jin(1,1) = jm(2,2)*jm(ldim,ldim)-jm(ldim,2)*jm(2,ldim)
         jin(2,1) = jm(2,ldim)*jm(ldim,1)-jm(ldim,ldim)*jm(2,1)
         jin(ldim,1) = jm(2,1)*jm(ldim,2)-jm(ldim,1)*jm(2,2)

         jin(1,2) = jm(1,ldim)*jm(ldim,2)-jm(ldim,ldim)*jm(1,2)
         jin(2,2) = jm(1,1)*jm(ldim,ldim)-jm(ldim,1)*jm(1,ldim)
         jin(ldim,2) = jm(1,2)*jm(ldim,1)-jm(ldim,2)*jm(1,1)
       
         jin(1,ldim) = jm(1,2)*jm(2,ldim)-jm(2,2)*jm(1,ldim)
         jin(2,ldim) = jm(1,ldim)*jm(2,1)-jm(2,ldim)*jm(1,1)
         jin(ldim,ldim) = jm(1,1)*jm(2,2)-jm(2,1)*jm(1,2)
       else
         jin(1,1) = jm(2,2)
         jin(2,1) = -jm(2,1)

         jin(1,2) = -jm(1,2)
         jin(2,2) = jm(1,1)
       endif
       
       dumc = 1/jac(i)
       call cmult(jin,dumc,ldim**2) !scale inverse by inv det
  
       call rzero(frn,ldim**2)
       call col3(frn,jm,jm,ldim**2) !square the entries
       sum1 = vlsum(frn,ldim**2)
       fr1 = SQRT(sum1)           !squareroot
             
       call rzero(frn,ldim**2)
       call col3(frn,jin,jin,ldim**2)
       sum1 = vlsum(frn,ldim**2)
       fr2 = SQRT(sum1)

       par(i) = fr1*fr2
       par(i) = (par(i)/ldim)**2

      enddo

      val = vlsum(par,siz)
      val = val/siz  !normalize to 1 for each element
      val=abs(val)

      return
      end
c-----------------------------------------------------------------------
      subroutine get_len(val,x,y,z,siz)
      include 'SIZE'
      include 'TOTAL'
      integer siz
      real x(2**ldim),y(2**ldim),z(2**ldim)
      real par(siz),xm,ym,zm,val

      integer azindx(24)
      SAVE    azindx
      DATA    azindx  / 1,2 ,2,4, 3,4, 1,3, 2,6, 6,8,
     $                  4,8, 5,6, 7,8, 5,7, 1,5, 3,7 /
c     azindx tells what nodes make up each edge

      do i=1,siz
        ind = (i-1)*2
        xm = x(azindx(ind+1))-x(azindx(ind+2))
        ym = y(azindx(ind+1))-y(azindx(ind+2))
        zm = z(azindx(ind+1))-z(azindx(ind+2))
        par(i) = sqrt(xm*xm+ym*ym+zm*zm)
        par(i) = par(i)**2
      enddo

      val = vlsum(par,siz)

      return
      end
c-----------------------------------------------------------------------
      subroutine get_nodscale(scalek,x8,y8,z8,gshl)
      include 'SIZE'
      include 'TOTAL'
      real x8(2**ldim,lelv*(2**ldim)),
     $     y8(2**ldim,lelv*(2**ldim)),
     $     z8(2**ldim,lelv*(2**ldim))
      real curval,xm,ym,zm,work1(1),dum,wrk1
c      real scalek
      real scalek(2**ldim,lelv*(2**ldim))
      integer bzindx(24),e,gshl
      DATA bzindx / 2,3,5, 1,4,6, 4,1,7, 3,2,8,
     $             6,7,1, 5,8,2, 8,5,3, 7,6,4 /
c     bzindx tells what node is connected to what node

      n1 = nelv*(2**ldim)
      n2 = n1*(2**ldim)
      curval = 1e+10
      call rone(scalek,n2)
      call cmult(scalek,curval,n2)

      do e=1,nelv*(2**ldim)
      do i=1,2**ldim
        curval = 1e+10
        ind = (i-1)*3
      do j=1,ldim
        xm = x8(i,e)-x8(bzindx(ind+j),e)
        ym = y8(i,e)-y8(bzindx(ind+j),e)
        zm = 0.
      if (ldim.eq.3) zm = z8(i,e)-z8(bzindx(ind+j),e)
        dum = sqrt(xm*xm+ym*ym+zm*zm)
        curval = min(dum,curval)
      enddo
        scalek(i,e) = curval
      enddo
      enddo
c
      fac = 1.e-2
      call cmult(scalek,fac,n2)
      call fgslib_gs_op(gshl,scalek,1,3,0)

      return
      end
c-----------------------------------------------------------------------
      subroutine genmask(nodmask,mlt,gshl,mltc,gshlc)
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      integer gs_handle
      integer vertex(1)
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal
      common /ivrtx/ vertex
      integer*8 glo_num(lxc*lyc*lzc,lelv),ngv
      integer*8 glo_numk2(2**ldim,lelv*(2**ldim))

      real     mlt(2**ldim,lelv*(2**ldim)),
     $     nodmask(2**ldim,lelv*(2**ldim))
      real    mltc(lxc*lyc*lzc*lelv),
     $     wrkmask(lxc*lyc*lzc*lelv)
      integer gshlc,gshl,e,eg,e0,f

      integer zindx(64)
      SAVE zindx
      DATA zindx /  1,  2,  4,  5,  10, 11, 13, 14,
     $              2,  3,  5,  6,  11, 12, 14, 15,
     $              4,  5,  7,  8,  13, 14, 16, 17,
     $              5,  6,  8,  9,  14, 15, 17, 18,
     $              10, 11, 13, 14, 19, 20, 22, 23,
     $              11, 12, 14, 15, 20, 21, 23, 24,
     $              13, 14, 16, 17, 22, 23, 25, 26,
     $              14, 15, 17, 18, 23, 24, 26, 27 /


      call setupds_center(gs_handle,lxc,lyc,lzc,nelv,
     $  nelgv,vertex,glo_num)

c     setup the mask first so that it can be distribute as well
      zero = 0.
      call rone(wrkmask,lxc*lyc*lzc*nelv)
      do e=1,nelv
      do f=1,2*ldim
         if(cbc(f,e,1).ne.'E  '.and.cbc(f,e,1).ne.'   ')then
           call facev(wrkmask,e,f,zero,lxc,lyc,lzc)
         endif
      enddo
      enddo

      n = (lxc*lyc*lzc)*nelv
      call rone(mltc,n)
      call fgslib_gs_setup(gshlc,glo_num,n,nekcomm,np)
      call fgslib_gs_op(gshlc,mltc,1,1,0)

      call fgslib_gs_op(gshlc,wrkmask,1,2,0)
      call xmtox8(wrkmask,nodmask)

      n = 0
      do e=1,nelv     !each element
      do j=1,2**ldim  !broken down into 4 quads/8hexes
        n = n+1
        ind1 = (j-1)*8
        do k=1,2**ldim
          glo_numk2(k,n) = glo_num(zindx(ind1+k),e)
        enddo
      enddo
      enddo

      n = (2**ldim)*(nelv*(2**ldim))
      call fgslib_gs_setup(gshl,glo_numk2,n,nekcomm,np)
      call rone(mlt,n)
      call fgslib_gs_op(gshl,mlt,1,1,0)   ! '+'
      xmlt = glmax(mlt,n)
      call invcol1(mlt,n)

      call fgslib_gs_op(gshl,nodmask,1,2,0)

      return
      end
c-----------------------------------------------------------------------
      subroutine setupds_center(gs_handle,nx,ny,nz,nel,melg,
     $                        vertex,glo_num)
      include 'SIZE'
      include 'INPUT'
      include 'PARALLEL'
      include 'NONCON'
      integer gs_handle
      integer vertex(1)
      integer*8 glo_num(1),ngv
      common /nekmpi/ mid,mp,nekcomm,nekgroup,nekreal

      n = nx*ny*nz*nel
      call set_vert(glo_num,ngv,nx,nel,vertex,.true.)
      call fgslib_gs_setup(gs_handle,glo_num,n,nekcomm,mp)
      return
      end
c-----------------------------------------------------------------------
      subroutine fastlap(iter,nodmask,mlt,gshl,dis,lapinv,mltc,gshlc)
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real xmc(lxc,lyc,lzc,lelv),
     $     ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc

      real x8(2,2,ldim-1,lelv*(2**ldim)),
     $     y8(2,2,ldim-1,lelv*(2**ldim)),
     $     z8(2,2,ldim-1,lelv*(2**ldim))
      common /coarsemesh8/ x8,y8,z8

      real dxx(2**ldim,lelv*(2**ldim)),
     $     dyy(2**ldim,lelv*(2**ldim)),
     $     dzz(2**ldim,lelv*(2**ldim)),
     $     dis(2**ldim,lelv*(2**ldim)),
     $     mlt(2**ldim,lelv*(2**ldim)),
     $     nodmask(2**ldim,lelv*(2**ldim)),
     $     mltc(lxc*lyc*lzc,lelv)
      integer z,e,f,gshl,lapinv,kerr,gshlc
      real xbar,ybar,zbar,sfac

      if (nid.eq.0.and.loglevel.ge.2) 
     $    write(6,*) 'laplacian smoothing started'

      n    = 2**ldim
      sfac = 0.01
      do k=1,iter
         do e=1,nelv*(2**ldim)
            xbar = vlsum(x8(1,1,1,e),n)/(n)
            ybar = vlsum(y8(1,1,1,e),n)/(n)
            if (ldim.eq.3) zbar = vlsum(z8(1,1,1,e),n)/(n)
            do i=1,n
               dxx(i,e) = sfac*(xbar-x8(i,1,1,e))
               dyy(i,e) = sfac*(ybar-y8(i,1,1,e))
        if (ldim.eq.3) dzz(i,e) = sfac*(zbar-z8(i,1,1,e))
            enddo
         enddo

         n2 = nelv*(2**ldim)*(n)

         call col2(dxx,nodmask,n2)
         call col2(dxx,dis,n2)
         call dsavg_general(dxx,mlt,gshl)
         call add2(x8,dxx,n2)

         call col2(dyy,nodmask,n2)
         call col2(dyy,dis,n2)
         call dsavg_general(dyy,mlt,gshl)
         call add2(y8,dyy,n2)
        
         if (ldim.eq.3) then
          call col2(dzz,nodmask,n2)
          call col2(dzz,dis,n2)
          call dsavg_general(dzz,mlt,gshl)
          call add2(z8,dzz,n2)
         endif

         dxm =glamax(dxx,n2)
         dym =glamax(dyy,n2)
         if (ldim.eq.3) then
            dzm =glamax(dzz,n2)
         else
            dzm = 0.
         endif
         if (nio.eq.0.and.loglevel.ge.3) write(6,1) k,dxm,dym,dzm
   1     format(i5,1p3e12.3,' dxm')

      enddo

      call x8toxm(xmc,x8)
      call x8toxm(ymc,y8)
      if (ldim.eq.3) call x8toxm(zmc,z8)
      call fixcurs(mltc,gshlc)
      call xmtox8(xmc,x8)
      call xmtox8(ymc,y8)
      if (ldim.eq.3) call xmtox8(zmc,z8)

      call glmapm1chkinv(kerr)
      if (kerr.gt.0.) then
        lapinv = 1  !Terminate Laplacian smoothing
      if (nid.eq.0.and.loglevel.ge.2) write(6,*) 'terminating Laplacian'
      else
       call genbackupmesh
      endif
       
      return
      end
c-----------------------------------------------------------------------
      subroutine dsavg_general(u,mlt,gshl)
      include 'SIZE'
      include 'TOTAL'
      integer gshl
      real u(2**ldim,lelv*(2**ldim))
      real mlt(2**ldim,lelv*(2**ldim))

      call fgslib_gs_op(gshl,u,1,1,0) ! '+'
      call col2(u,mlt,(2**ldim)*nelv*(2**ldim))
      
      return
      end
c-----------------------------------------------------------------------
      subroutine xmtox8(xd,x8)
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real x8(2**ldim,lelv*(2**ldim))
      real xd(lxc*lyc*lzc,lelv)
      integer e,k,n,j,ind1
      integer zindx(64)
      SAVE zindx
      DATA zindx /  1,  2,  4,  5,  10, 11, 13, 14,
     $              2,  3,  5,  6,  11, 12, 14, 15,
     $              4,  5,  7,  8,  13, 14, 16, 17,
     $              5,  6,  8,  9,  14, 15, 17, 18,
     $              10, 11, 13, 14, 19, 20, 22, 23,
     $              11, 12, 14, 15, 20, 21, 23, 24,
     $              13, 14, 16, 17, 22, 23, 25, 26,
     $              14, 15, 17, 18, 23, 24, 26, 27 /

      n = 0
      do e=1,nelv     !each element
      do j=1,2**ldim  !broken down into 4 quads/8hexes
        n = n+1
        ind1 = (j-1)*8
        do k=1,2**ldim
          x8(k,n) = xd(zindx(ind1+k),e)
        enddo
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine x8toxm(xd,x8)
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real x8(2**ldim,lelv*(2**ldim))
      real xd(lxc*lyc*lzc,lelv)
      integer zindx((2**3)**2)
      integer e,k,n,j,ind1
      DATA zindx /  1,  2,  4,  5,  10, 11, 13, 14,
     $              2,  3,  5,  6,  11, 12, 14, 15,
     $              4,  5,  7,  8,  13, 14, 16, 17,
     $              5,  6,  8,  9,  14, 15, 17, 18,
     $              10, 11, 13, 14, 19, 20, 22, 23,
     $              11, 12, 14, 15, 20, 21, 23, 24,
     $              13, 14, 16, 17, 22, 23, 25, 26,
     $              14, 15, 17, 18, 23, 24, 26, 27 /


      n = 0
      do e=1,nelv     !each element
      do j=1,2**ldim  !broken down into 4 quads/8hexes
        n = n+1
        ind1 = (j-1)*8
        do k=1,2**ldim
          xd(zindx(ind1+k),e) = x8(k,n)
        enddo
      enddo
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine col3c(a,b,c,d,n)
      real a(1),b(1),c(1),d

      do i=1,n
         a(i)=b(i)*c(i)*d
      enddo

      return
      end
c-----------------------------------------------------------------------
      subroutine glmapm1chkinv(kerr)
      INCLUDE 'SIZE'
      INCLUDE 'GEOM'
      INCLUDE 'INPUT'
      INCLUDE 'SOLN'
C
C     Note: Subroutines GLMAPM1, GEODAT1, AREA2, SETWGTR and AREA3 
C           share the same array structure in Scratch Common /SCRNS/.
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      parameter (nxc=3,nyc=3,nzc=1+(ldim-2)*(nxc-1))
      real xmc(lxc,lyc,lzc,lelv),ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc
C
      real           XRMc(LXc,LYc,LZc,LELv)
     $ ,             YRMc(LXc,LYc,LZc,LELv)
     $ ,             XSMc(LXc,LYc,LZc,LELv)
     $ ,             YSMc(LXc,LYc,LZc,LELv)
     $ ,             XTMc(LXc,LYc,LZc,LELv)
     $ ,             YTMc(LXc,LYc,LZc,LELv)
     $ ,             ZRMc(LXc,LYc,LZc,LELv)
      real           ZSMc(LXc,LYc,LZc,LELv)
     $ ,             ZTMc(LXc,LYc,LZc,LELv)
     $ ,            jacmc(lxc,lyc,lzc,lelv)
      real           rxmc(lxc,lyc,lzc,lelv)
     $ ,             rymc(lxc,lyc,lzc,lelv)
     $ ,             rzmc(lxc,lyc,lzc,lelv)
     $ ,             sxmc(lxc,lyc,lzc,lelv)
     $ ,             symc(lxc,lyc,lzc,lelv)
     $ ,             szmc(lxc,lyc,lzc,lelv)
     $ ,             txmc(lxc,lyc,lzc,lelv)
     $ ,             tymc(lxc,lyc,lzc,lelv)
     $ ,             tzmc(lxc,lyc,lzc,lelv)
      integer kerr,ierr
C
      NXYc  = NXc*NYc
      NYZc  = NYc*NZc
      NXYZc = NXc*NYc*NZc
      NTOTc = NXYZc*NELv
C
      CALL XYZRSTc (XRMc,YRMc,ZRMc,XSMc,YSMc,ZSMc,XTMc,YTMc,ZTMc,
     $             IFAXIS)


C
      IF (NDIM.EQ.2) THEN
         CALL RZERO   (JACMc,NTOTc)
         CALL ADDCOL3 (JACMc,XRMc,YSMc,NTOTc)
         CALL SUBCOL3 (JACMc,XSMc,YRMc,NTOTc)
         CALL COPY    (RXMc,YSMc,NTOTc)
         CALL COPY    (RYMc,XSMc,NTOTc)
         CALL CHSIGN  (RYMc,NTOTc)
         CALL COPY    (SXMc,YRMc,NTOTc)
         CALL CHSIGN  (SXMc,NTOTc)
         CALL COPY    (SYMc,XRMc,NTOTc)
         CALL RZERO   (RZMc,NTOTc)
         CALL RZERO   (SZMc,NTOTc)
         CALL RONE    (TZMc,NTOTc)
      ELSE
         CALL RZERO   (JACMc,NTOTc)
         CALL ADDCOL4 (JACMc,XRMc,YSMc,ZTMc,NTOTc)
         CALL ADDCOL4 (JACMc,XTMc,YRMc,ZSMc,NTOTc)
         CALL ADDCOL4 (JACMc,XSMc,YTMc,ZRMc,NTOTc)
         CALL SUBCOL4 (JACMc,XRMc,YTMc,ZSMc,NTOTc)
         CALL SUBCOL4 (JACMc,XSMc,YRMc,ZTMc,NTOTc)
         CALL SUBCOL4 (JACMc,XTMc,YSMc,ZRMc,NTOTc)
         CALL ASCOL5  (RXMc,YSMc,ZTMc,YTMc,ZSMc,NTOTc)
         CALL ASCOL5  (RYMc,XTMc,ZSMc,XSMc,ZTMc,NTOTc)
         CALL ASCOL5  (RZMc,XSMc,YTMc,XTMc,YSMc,NTOTc)
         CALL ASCOL5  (SXMc,YTMc,ZRMc,YRMc,ZTMc,NTOTc)
         CALL ASCOL5  (SYMc,XRMc,ZTMc,XTMc,ZRMc,NTOTc)
         CALL ASCOL5  (SZMc,XTMc,YRMc,XRMc,YTMc,NTOTc)
         CALL ASCOL5  (TXMc,YRMc,ZSMc,YSMc,ZRMc,NTOTc)
         CALL ASCOL5  (TYMc,XSMc,ZRMc,XRMc,ZSMc,NTOTc)
         CALL ASCOL5  (TZMc,XRMc,YSMc,XSMc,YRMc,NTOTc)
      ENDIF
C
      kerr = 0
      DO 500 ie=1,NELv
         CALL CHKJACINV(JACMc(1,1,1,ie),NXYZc,ie,xmc(1,1,1,ie),
     $ ymc(1,1,1,ie),zmc(1,1,1,ie),ndim,ierr)
         if (ierr.ne.0) kerr = kerr+1
  500 CONTINUE
      kerr = iglsum(kerr,1)
      
      RETURN
      END
C-----------------------------------------------------------------------
      subroutine chkjacinv(jac,n,iel,X,Y,Z,ND,IERR)
c
      include 'SIZE'
      include 'PARALLEL'
C
C     Check the array JAC for a change in sign.
C
      REAL JAC(N),x(1),y(1),z(1)
      integer ierr
c
      ierr = 0
      SIGN = JAC(1)
      DO 100 I=2,N
         IF (SIGN*JAC(I).LE.0.0) THEN
            ierr = 1
         ENDIF
  100 CONTINUE

      RETURN
      END
C-----------------------------------------------------------------------
      subroutine xyzrstc(xrmc,yrmc,zrmc,xsmc,ysmc,zsmc,
     $                   XTMc,YTMc,ZTMc,IFAXIS)
C-----------------------------------------------------------------------
C
C     Compute global-to-local derivatives on mesh 1.
C
C-----------------------------------------------------------------------
      INCLUDE 'SIZE'
C
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      DIMENSION XRMc(LXc,LYc,LZc,1),YRMc(LXc,LYc,LZc,1)
     $        , ZRMc(LXc,LYc,LZc,1),XSMc(LXc,LYc,LZc,1)
     $        , YSMc(LXc,LYc,LZc,1),ZSMc(LXc,LYc,LZc,1)
     $        , XTMc(LXc,LYc,LZc,1),YTMc(LXc,LYc,LZc,1)
     $        , ZTMc(LXc,LYc,LZc,1)
      LOGICAL IFAXIS
      real dxmc(3,3),dymc(3,3),dzmc(3,3)
      real dxtmc(3,3),dytmc(3,3),dztmc(3,3)
      common /coarseders/ dxmc,dymc,dzmc,dxtmc,dytmc,dztmc
      real xmc(lxc,lyc,lzc,lelv),ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc
C
      NXYc=lxc*lyc
      NYZc=lyc*lzc
C
      DO 100 IEL=1,NELv
C
      CALL MXM (DXMc,lxc,XMc(1,1,1,IEL),lxc,XRMc(1,1,1,IEL),NYZc)
      CALL MXM (DXMc,lxc,YMc(1,1,1,IEL),lxc,YRMc(1,1,1,IEL),NYZc)
      CALL MXM (DXMc,lxc,ZMc(1,1,1,IEL),lxc,ZRMc(1,1,1,IEL),NYZc)
C
      DO 10 IZ=1,lzc
      CALL MXM (XMc(1,1,IZ,IEL),lxc,DYTMc,lyc,XSMc(1,1,IZ,IEL),lyc)
      CALL MXM (YMc(1,1,IZ,IEL),lxc,DYTMc,lyc,YSMc(1,1,IZ,IEL),lyc)
      CALL MXM (ZMc(1,1,IZ,IEL),lxc,DYTMc,lyc,ZSMc(1,1,IZ,IEL),lyc)
   10 CONTINUE
C
      IF (ldim.EQ.3) THEN
         CALL MXM (XMc(1,1,1,IEL),NXYc,DZTMc,lzc,XTMc(1,1,1,IEL),lzc)
         CALL MXM (YMc(1,1,1,IEL),NXYc,DZTMc,lzc,YTMc(1,1,1,IEL),lzc)
         CALL MXM (ZMc(1,1,1,IEL),NXYc,DZTMc,lzc,ZTMc(1,1,1,IEL),lzc)
      ELSE
         CALL RZERO (XTMc(1,1,1,IEL),NXYc)
         CALL RZERO (YTMc(1,1,1,IEL),NXYc)
         CALL RONE  (ZTMc(1,1,1,IEL),NXYc)
      ENDIF
C
  100 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      subroutine xm1toxmc
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real xmc(lxc,lyc,lzc,lelv),ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc
      integer e

      if (ldim.eq.2) then
        do e=1,nelv
         call int_fine_to_coarse_2d(xm1(1,1,1,e),xmc(1,1,1,e),lx1,3)
         call int_fine_to_coarse_2d(ym1(1,1,1,e),ymc(1,1,1,e),lx1,3)
        enddo
      else
        do e=1,nelv
         call int_fine_to_coarse_3d(xm1(1,1,1,e),xmc(1,1,1,e),lx1,3)
         call int_fine_to_coarse_3d(ym1(1,1,1,e),ymc(1,1,1,e),lx1,3)
         call int_fine_to_coarse_3d(zm1(1,1,1,e),zmc(1,1,1,e),lx1,3)
        enddo
      endif

      RETURN
      END
C-----------------------------------------------------------------------
      subroutine xmctoxm1
      include 'SIZE'
      include 'TOTAL'
      parameter (lxc=3,lyc=3,lzc=1+(ldim-2)*(lxc-1))
      real xmc(lxc,lyc,lzc,lelv),ymc(lxc,lyc,lzc,lelv),
     $     zmc(lxc,lyc,lzc,lelv)
      common /coarsemesh/ xmc,ymc,zmc
      integer e

      if (ldim.eq.2) then
        do e=1,nelv
         call int_coarse_to_fine_2d(xm1(1,1,1,e),xmc(1,1,1,e),lx1,3)
         call int_coarse_to_fine_2d(ym1(1,1,1,e),ymc(1,1,1,e),lx1,3)
        enddo
      else
        do e=1,nelv
         call int_coarse_to_fine_3d(xm1(1,1,1,e),xmc(1,1,1,e),lx1,3)
         call int_coarse_to_fine_3d(ym1(1,1,1,e),ymc(1,1,1,e),lx1,3)
         call int_coarse_to_fine_3d(zm1(1,1,1,e),zmc(1,1,1,e),lx1,3)
        enddo
      endif

      RETURN
      END
C-----------------------------------------------------------------------
      subroutine my_mv_mesh(dx,dy,dz)
      include 'SIZE'
      include 'TOTAL'

      parameter (lt = lx1*ly1*lz1*lelv)
      common /mrthoi/ napprx(2),nappry(2),napprz(2)
      common /mrthov/ apprx(lt,0:mxprev)
     $              , appry(lt,0:mxprev)
     $              , apprz(lt,0:mxprev)
      common /mstuff/ d(lt),h1(lt),h2(lt),mask(lt)
      real mask
      real mask2(lx1,ly1,lz1,lelv)
      real dx(1),dy(1),dz(1)

      integer e,f

      integer icalld
      save    icalld
      data    icalld /0/

      n = nx1*ny1*nz1*nelv
      nface = 2*ndim

      napprx(1)=0
      nappry(1)=0
      napprz(1)=0

      nxz   = nx1*nz1
      nxyz  = nx1*ny1*nz1

      volbl = 0.   ! Volume of elements in boundary layer
      do e=1,nelv
      do f=1,nface
         if (cbc(f,e,1).eq.'W  ') then
            srfbl = srfbl + vlsum(area(1,1,f,e),nxz )
            volbl = volbl + vlsum(bm1 (1,1,1,e),nxyz)
         endif
      enddo
      enddo
      srfbl = glsum(srfbl,1)  ! Sum over all processors
      volbl = glsum(volbl,1)

      delta = volbl / srfbl   ! Avg thickness of b.l. elements

      call rone (h1,n)
      call rzero(h2,n)
      call sm_cheap_dist(d,1,'W  ')

      deltap = 5*delta  ! Protected b.l. thickness
      do i=1,n
         arg   = -(d(i)/deltap)**2
         h1(i) = h1(i) + 9*exp(arg)
      enddo

      call rone(mask,n)
      do e=1,nelv
      do f=1,nface
        if (cbc(f,e,1).ne.'E  '.and.cbc(f,e,1).ne.'   ') 
     $     call facev(mask,e,f,0.,nx1,ny1,nz1)
      enddo
      enddo
      call dsop(mask,'mul',nx1,ny1,nz1)
      call copy(mask2,mask,n)
      call chsign(mask2,n)
      call cadd(mask2,1.,n)
      call col2(dx,mask2,n)
      call col2(dy,mask2,n)
      call col2(dz,mask2,n)
      tol = -1.e-6
      call laplaceh('mshx',dx,h1,h2,mask,vmult,1,tol,500,apprx,napprx)
      call laplaceh('mshy',dy,h1,h2,mask,vmult,1,tol,500,appry,nappry)
      if (if3d)
     $ call laplaceh('mshz',dz,h1,h2,mask,vmult,1,tol,500,apprz,napprz)

      return
      end
c-----------------------------------------------------------------------
      subroutine laplaceh
     $     (name,u,h1,h2,mask,mult,ifld,tli,maxi,approx,napprox)
      include 'SIZE'
      include 'TOTAL'
      include 'CTIMER'
c
      character*4 name
      real u(1),h1(1),h2(1),mask(1),mult(1),approx (1)
      integer   napprox(1)

      parameter (lt=lx1*ly1*lz1*lelv)
      common /scruz/ r (lt),ub(lt)

      logical ifstdh
      character*4  cname
      character*6  name6

      logical ifwt,ifvec

      call chcopy(cname,name,4)
      call capit (cname,4)

      call blank (name6,6)
      call chcopy(name6,name,4)
      ifwt  = .true.
      ifvec = .false.
      isd   = 1
      imsh  = 1
      nel   = nelfld(ifld)

      n = nx1*ny1*nz1*nel

      call copy (ub,u,n)             ! ub = u on boundary
      call dsavg(ub)                 ! Make certain ub is in H1
                                     !     _
      call axhelm (r,ub,h1,h2,1,1)   ! r = A*ub

      do i=1,n                       !        _
         r(i)=-r(i)*mask(i)          ! r = -M*A*ub
      enddo

      call dssum  (r,nx1,ny1,nz1)    ! dssum rhs

      call project1
     $    (r,n,approx,napprox,h1,h2,mask,mult,ifwt,ifvec,name6)

      tol = -abs(tli)
      if (nel.eq.nelv) then
        call hmhzpf (name,u,r,h1,h2,mask,mult,imsh,tol,maxi,isd,binvm1)
      else
        call hmhzpf (name,u,r,h1,h2,mask,mult,imsh,tol,maxi,isd,bintm1)
      endif

      call project2
     $     (u,n,approx,napprox,h1,h2,mask,mult,ifwt,ifvec,name6)

      call add2(u,ub,n)

      return
      end
c-----------------------------------------------------------------------
      subroutine sm_cheap_dist(d,ifld,b)
c     this is a copy of the routine in navier5.f, modified to be less
c     verbose


      include 'SIZE'
      include 'GEOM'       ! Coordinates
      include 'INPUT'      ! cbc()
      include 'TSTEP'      ! nelfld
      include 'PARALLEL'   ! gather-scatter handle for field "ifld"

      real d(lx1,ly1,lz1,lelt)

      character*3 b  ! Boundary condition of interest

      integer e,eg,f

      nel = nelfld(ifld)
      n = lx1*ly1*lz1*nel

      call domain_size(xmin,xmax,ymin,ymax,zmin,zmax)

      xmn = min(xmin,ymin)
      xmx = max(xmax,ymax)
      if (if3d) xmn = min(xmn ,zmin)
      if (if3d) xmx = max(xmx ,zmax)

      big = 10*(xmx-xmn)
      call cfill(d,big,n)

      nface = 2*ldim
      do e=1,nel     ! Set d=0 on walls
      do f=1,nface
         if (cbc(f,e,ifld).eq.b) call facev(d,e,f,0.,lx1,ly1,lz1)
      enddo
      enddo

      do ipass=1,10000
         dmax    = 0
         nchange = 0
         do e=1,nel
           do k=1,lz1
           do j=1,ly1
           do i=1,lx1
             i0=max(  1,i-1)
             j0=max(  1,j-1)
             k0=max(  1,k-1)
             i1=min(lx1,i+1)
             j1=min(ly1,j+1)
             k1=min(lz1,k+1)
             do kk=k0,k1
             do jj=j0,j1
             do ii=i0,i1

              if (if3d) then
               dtmp = d(ii,jj,kk,e) + dist3d(
     $           xm1(ii,jj,kk,e),ym1(ii,jj,kk,e),zm1(ii,jj,kk,e)
     $          ,xm1(i ,j ,k ,e),ym1(i ,j ,k ,e),zm1(i ,j ,k ,e))
              else
               dtmp = d(ii,jj,kk,e) + dist2d(
     $           xm1(ii,jj,kk,e),ym1(ii,jj,kk,e)
     $          ,xm1(i ,j ,k ,e),ym1(i ,j ,k ,e))
              endif

              if (dtmp.lt.d(i,j,k,e)) then
                d(i,j,k,e) = dtmp
                nchange = nchange+1
                dmax = max(dmax,d(i,j,k,e))
              endif
             enddo
             enddo
             enddo

           enddo
           enddo
           enddo
         enddo
         call fgslib_gs_op(gsh_fld(ifld),d,1,3,0) ! min over all elements
         nchange = iglsum(nchange,1)
         dmax = glmax(dmax,1)
         if (nio.eq.0.and.loglevel.ge.3) write(6,1) ipass,nchange,dmax,b
    1    format(i9,i12,1pe12.4,' max distance b: ',a3)
         if (nchange.eq.0) goto 1000
      enddo
 1000 return
      end
c-----------------------------------------------------------------------

!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!
!!! Copyright (c) 2017-20, Lawrence Livermore National Security, LLC
!!! and DataRaceBench project contributors. See the DataRaceBench/COPYRIGHT file for details.
!!!
!!! SPDX-License-Identifier: (BSD-3-Clause)
!!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!!!

!* This is a program based on a test contributed by Yizi Gu@Rice Univ.
!* Use taskgroup to synchronize two tasks. No data race pairs.

program DRB107_taskgroup_orig_no
    use omp_lib
    implicit none

    integer result
    result = 0

    !$omp parallel
    !$omp single
        !$omp taskgroup
            !$omp task
            call sleep(3)
            result = 1
            !$omp end task
        !$omp end taskgroup
        !$omp task
        result = 2
        !$omp end task
    !$omp end single
    !$omp end parallel

    print 100, result
    100 format ('result =',3i8)

end program

#!/bin/bash
# Copyright (c) 2017, Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory
# Written by Chunhua Liao, Pei-Hung Lin, Joshua Asplund,
# Markus Schordan, and Ian Karlin
# (email: liao6@llnl.gov, lin32@llnl.gov, asplund1@llnl.gov,
# schordan1@llnl.gov, karlin1@llnl.gov)
# LLNL-CODE-732144
# All rights reserved.
#
# This file is part of DataRaceBench. For details, see
# https://github.com/LLNL/dataracebench. Please also see the LICENSE file
# for our additional BSD notice
#
# Redistribution of Backstroke and use in source and binary forms, with
# or without modification, are permitted provided that the following
# conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the disclaimer below.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the disclaimer (as noted below)
#   in the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the LLNS/LLNL nor the names of its contributors
#   may be used to endorse or promote products derived from this
#   software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL LAWRENCE LIVERMORE NATIONAL
# SECURITY, LLC, THE U.S. DEPARTMENT OF ENERGY OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
# OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.

#----------------------------------------------------------------
# copy& paste the two tables in https://github.com/LLNL/dataracebench/blob/master/README.md
# save to a benchmark_list.txt file
# then run thisScript benchmark_list.txt to count Y and N labels.
#example output:
# ./count_drb_labels.sh benchmark_list.txt
# ----1: Y1, N1-----
# 26
# 14
# ----2: Y2, N2-----
# 17
# 19
# ----3: Y3, N3-----
# 8
# 9
# ----4: Y4, N4-----
# 3
# 4
# ----5: Y5, N5-----
# 1
# 2
# ----6: Y6, N6-----
# 4
# 7
# ----7: Y7, N7-----
# 4
# 9
# Total Y label count=63
# Total N label count=64
##----------------------------------------------------------------
set -u

# expect an argument for the text file storing benchmarks and labels
# $# means the number of arguments passed to a function, or to the script itself
if [ $# -eq 1 ]; then
  INPUT_FILE=$1
else
  echo This script needs one argument while there is $# arguments.
  echo Usage:$0 inputfile
  echo Exampe:$0 benchmark_list.txt
  exit 1
fi

if [ ! -f "$INPUT_FILE" ]; then
  echo "Error: cannot find $INPUT_FILE. Please make sure it exists!"
  exit 1
fi

ysum=0
nsum=0

for var in 1 2 3 4 5 6 7; do
  YLABEL="Y$var"
  NLABEL="N$var"

echo "----$var: $YLABEL, $NLABEL-----"
  ycount=`grep $YLABEL $INPUT_FILE | wc | awk '{print $1}'`
  echo $ycount
  let "ysum+=$ycount"
  ncount=`grep $NLABEL $INPUT_FILE | wc | awk '{print $1}'`
  echo $ncount
  let "nsum+=$ncount"
done

echo "Total Y label count=$ysum"
echo "Total N label count=$nsum"

#!/usr/bin/env bash

# Copyright (c) 2017, Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory
# Written by Chunhua Liao, Pei-Hung Lin, Joshua Asplund,
# Markus Schordan, and Ian Karlin
# (email: liao6@llnl.gov, lin32@llnl.gov, asplund1@llnl.gov,
# schordan1@llnl.gov, karlin1@llnl.gov)
# LLNL-CODE-732144
# All rights reserved.
#
# This file is part of DataRaceBench. For details, see
# https://github.com/LLNL/dataracebench. Please also see the LICENSE file
# for our additional BSD notice
# 
# Redistribution of Backstroke and use in source and binary forms, with
# or without modification, are permitted provided that the following
# conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the disclaimer below.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the disclaimer (as noted below)
#   in the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the LLNS/LLNL nor the names of its contributors
#   may be used to endorse or promote products derived from this
#   software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL LAWRENCE LIVERMORE NATIONAL
# SECURITY, LLC, THE U.S. DEPARTMENT OF ENERGY OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
# OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.

OPTION=$1
DEF_LAN=$2
TESTS=$(grep -l main micro-benchmarks/*.c)
CPPTESTS=$(grep -l main micro-benchmarks/*.cpp)
FORTRANTESTS=$(find micro-benchmarks-fortran -iregex ".*\.F[0-9]*" -o -iregex ".*\.for")
POLYFLAG="micro-benchmarks/utilities/polybench.c -I micro-benchmarks -I micro-benchmarks/utilities -DPOLYBENCH_NO_FLUSH_CACHE -DPOLYBENCH_TIME -D_POSIX_C_SOURCE=200112L"
FPOLYFLAG="-Imicro-benchmarks-fortran micro-benchmarks-fortran/utilities/fpolybench.o"
LANGUAGE="default"

help () {
    echo
    echo "Usage: $0 [--run] [--help] language"
    echo
    echo "--help      : this option"
    echo "--small     : compile and test all benchmarks using small parameters with Helgrind, ThreadSanitizer, Archer, Intel inspector."
    echo "--run       : compile and run all benchmarks with gcc (no evaluation)"
    echo "--run-intel : compile and run all benchmarks with Intel compilers (no evaluation)"
    echo "--helgrind  : compile and test all benchmarks with Helgrind"
    echo "--tsan-clang: compile and test all benchmarks with clang ThreadSanitizer"
    echo "--tsan-gcc  : compile and test all benchmarks with gcc ThreadSanitizer"
    echo "--archer    : compile and test all benchmarks with Archer"
    echo "--coderrect : compile and test all benchmarks with Coderrect Scanner"
    echo "--inspector : compile and test all benchmarks with Intel Inspector"
    echo "--romp      : compile and test all benchmarks with Romp"
    echo "--customize : compile and test customized test list and tools"
    echo
}

valid_language_name () {
  case "$1" in
    c/c++) return 0 ;;
    C/C++) return 0 ;;
    c) return 0 ;;
    C) return 0 ;;
    c++) return 0 ;;
    C++) return 0 ;;
    fortran) return 0 ;;
    Fortran) return 0 ;;
    FORTRAN) return 0 ;;
    *) return 1 ;;
  esac
}

if [ -z "$DEF_LAN" ]; then
	echo "use default test"
fi

if valid_language_name "$DEF_LAN"; then LANGUAGE="$DEF_LAN"
        else 
		echo "Invalid language name $DEF_LAN" && help && exit 1
fi
 

if [[ -z "$OPTION" || "$OPTION" == "--help" ]]; then

    echo
    echo "Usage: $0 [--run] [--help]"
    echo
    echo "--help      : this option"
    echo "--small     : compile and test all benchmarks using small parameters with Helgrind, ThreadSanitizer, Archer, Intel inspector."
    echo "--run       : compile and run all benchmarks with gcc (no evaluation)"
    echo "--run-intel : compile and run all benchmarks with Intel compilers (no evaluation)"
    echo "--helgrind  : compile and test all benchmarks with Helgrind"
    echo "--tsan-clang: compile and test all benchmarks with clang ThreadSanitizer"
    echo "--tsan-gcc  : compile and test all benchmarks with gcc ThreadSanitizer"
    echo "--archer    : compile and test all benchmarks with Archer"
    echo "--coderrect : compile and test all benchmarks with Coderrect Scanner"
    echo "--inspector : compile and test all benchmarks with Intel Inspector"
    echo "--romp      : compile and test all benchmarks with Romp"
    echo "--customize : compile and test customized test list and tools"
    echo
    exit
fi

if [[ "$OPTION" == "--small" ]]; then
  scripts/test-harness.sh -t 3 -n 2 -d 32 -l $LANGUAGE -x helgrind
  scripts/test-harness.sh -t 3 -n 2 -d 32 -l $LANGUAGE -x archer
  scripts/test-harness.sh -t 3 -n 1 -d 32 -l $LANGUAGE -x coderrect
  scripts/test-harness.sh -t 3 -n 2 -d 32 -l $LANGUAGE -x tsan-clang
  scripts/test-harness.sh -t 3 -n 2 -d 32 -l $LANGUAGE -x inspector-max-resources
  scripts/test-harness.sh -t 3 -n 2 -d 32 -l $LANGUAGE -x romp
fi

if [[ "$OPTION" == "--run" ]]; then
    if [[ "$LANGUAGE" == "c" || "$LANGUAGE" == "C" ]]; then
    	for test in $TESTS; do
            echo "------------------------------------------"
            echo "RUNNING: $test"
            CFLAGS="-g -Wall -std=c99 -fopenmp"
            if grep -q 'PolyBench' "$test"; then CFLAGS+=" $POLYFLAG"; fi
            gcc $CFLAGS "$test" -lm
            ./a.out  > /dev/null
        done
        rm -f ./a.out
# test for cpp files
    elif [[ "$LANGUAGE" == "c++" || "$LANGUAGE" == "C++" ]]; then
   	for test in $CPPTESTS; do
            echo "------------------------------------------"
            echo "RUNNING: $test"
            CFLAGS="-g -Wall -fopenmp"
            if grep -q 'PolyBench' "$test"; then CFLAGS+=" $POLYFLAG"; fi
            g++ $CFLAGS "$test" -lm
            ./a.out  > /dev/null
        done
        rm -f ./a.out
# test for fortran files
    elif [[ "$LANGUAGE" == "fortran" || "$LANGUAGE" == "FORTRAN" ]]; then
    	for test in $FORTRANTESTS; do
	    echo "------------------------------------------"
            echo "RUNNING: $test"
            FFLAGS="-fopenmp -ffree-line-length-none"
	    if grep -q 'PolyBench' "$test"; then FFLAGS+=" $FPOLYFLAG"; fi
            gfortran $FFLAGS "$test" -lm
            ./a.out  > /dev/null
         done
         rm -f ./a.out
         rm drb*
    else 
        for test in $TESTS; do
            echo "------------------------------------------"
            echo "RUNNING: $test"
            CFLAGS="-g -Wall -std=c99 -fopenmp"
            if grep -q 'PolyBench' "$test"; then CFLAGS+=" $POLYFLAG"; fi
            gcc $CFLAGS "$test" -lm
            ./a.out  > /dev/null
        done
        rm -f ./a.out
        for test in $CPPTESTS; do
            echo "------------------------------------------"
            echo "RUNNING: $test"
            CFLAGS="-g -Wall -fopenmp"
            if grep -q 'PolyBench' "$test"; then CFLAGS+=" $POLYFLAG"; fi
            g++ $CFLAGS "$test" -lm
            ./a.out  > /dev/null
        done
        rm -f ./a.out
        for test in $FORTRANTESTS; do
            echo "------------------------------------------"
            echo "RUNNING: $test"
            FFLAGS="-fopenmp  -ffree-line-length-none"
            if grep -q 'PolyBench' "$test"; then FFLAGS+=" $FPOLYFLAG"; fi
            gfortran $FFLAGS "$test" -lm
            ./a.out  > /dev/null
         done
         rm -f ./a.out
         rm drb*
    fi
    exit
fi

if [[ "$OPTION" == "--run-intel" ]]; then
    for test in $TESTS; do
        echo "------------------------------------------"
        echo "RUNNING: $test"
        CFLAGS="-g -Wall -std=c99 -fopenmp"
        if grep -q 'PolyBench' "$test"; then CFLAGS+=" $POLYFLAG"; fi
        icc $CFLAGS "$test" -lm
        ./a.out  > /dev/null
    done
    rm -f ./a.out
# test for cpp files
    for test in $CPPTESTS; do
        echo "------------------------------------------"
        echo "RUNNING: $test"
        CFLAGS="-g -Wall -fopenmp"
        if grep -q 'PolyBench' "$test"; then CFLAGS+=" $POLYFLAG"; fi
        icpc $CFLAGS "$test" -lm
        ./a.out  > /dev/null
    done
    rm -f ./a.out
# test for fortran files
    for test in $FORTRANTESTS; do
        echo "------------------------------------------"
        echo "RUNNING: $test"
        FFLAGS="-fopenmp"
        if grep -q 'PolyBench' "$test"; then FLAGS+=" $POLYFLAG"; fi
        ifort $FFLAGS "$test" -lm
        ./a.out  > /dev/null
    done
    rm -f ./a.out
    rm drb*
    exit
fi

if [[ "$OPTION" == "--run-rose" ]]; then
    for test in $TESTS; do
        echo "------------------------------------------"
        echo "TESTING using rose: $test"
        CFLAGS="-g -Wall -std=c99 -rose:openmp:ast_only"
        if grep -q 'PolyBench' "$test"; then CFLAGS+=" $POLYFLAG"; fi
        $ROSE_INSTALL/bin/identityTranslator -c $CFLAGS "$test" -lm
    done
# test for cpp files
    for test in $CPPTESTS; do
        echo "------------------------------------------"
        echo "TESTING using rose: $test"
        CFLAGS="-g -Wall -rose:openmp:ast_only"
        if grep -q 'PolyBench' "$test"; then CFLAGS+=" $POLYFLAG"; fi
        $ROSE_INSTALL/bin/identityTranslator -c $CFLAGS "$test" -lm
    done
    exit
fi



if [[ "$OPTION" == "--helgrind" ]]; then
    scripts/test-harness.sh -l $LANGUAGE -x helgrind
fi

if [[ "$OPTION" == "--archer" ]]; then
    scripts/test-harness.sh -t 8 -n 5 -d 32 -l $LANGUAGE -x archer
fi

if [[ "$OPTION" == "--coderrect" ]]; then
    scripts/test-harness.sh -t 8 -n 1 -d 32 -l $LANGUAGE -x coderrect
fi

if [[ "$OPTION" == "--tsan-clang" ]]; then
    scripts/test-harness.sh -t 8 -n 5 -d 32 -l $LANGUAGE -x tsan-clang
fi

if [[ "$OPTION" == "--tsan-gcc" ]]; then
    scripts/test-harness.sh -t 8 -n 5 -d 32 -l $LANGUAGE -x tsan-gcc
fi

if [[ "$OPTION" == "--inspector" ]]; then
    scripts/test-harness.sh -t 8 -n 5 -d 32 -l $LANGUAGE -x inspector-max-resources
fi

if [[ "$OPTION" == "--romp" ]]; then
   scripts/test-harness.sh -t 8 -n 5 -d 32 -l $LANGUAGE -x romp
fi

if [[ "$OPTION" == "--customize" ]]; then
        TO=($(cat tool.def))
        for rtool in "${TO[@]}"; do
                scripts/test-harness.sh -t 8 -n 5 -d 32 -l $LANGUAGE -c 1 -x $rtool;
        done
fi
